/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(oe){for(var t=[],y=0,S=oe.length;y<S;y++)t[y]=me[oe[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Qt,getPrototypeOf:Yt,getOwnPropertyDescriptor:Xt}=Object;let{freeze:tt,seal:ht,create:Zt}=Object,{apply:St,construct:Ft}=typeof Reflect<"u"&&Reflect;St||(St=function(t,y,S){return t.apply(y,S)}),tt||(tt=function(t){return t}),ht||(ht=function(t){return t}),Ft||(Ft=function(t,y){return new t(...y)});const Jt=rt(Array.prototype.forEach),zt=rt(Array.prototype.pop),mt=rt(Array.prototype.push),wt=rt(String.prototype.toLowerCase),Ot=rt(String.prototype.toString),ei=rt(String.prototype.match),ut=rt(String.prototype.replace),ti=rt(String.prototype.indexOf),ii=rt(String.prototype.trim),st=rt(RegExp.prototype.test),bt=ni(TypeError);function rt(oe){return function(t){for(var y=arguments.length,S=new Array(y>1?y-1:0),i=1;i<y;i++)S[i-1]=arguments[i];return St(oe,t,S)}}function ni(oe){return function(){for(var t=arguments.length,y=new Array(t),S=0;S<t;S++)y[S]=arguments[S];return Ft(oe,y)}}function Be(oe,t,y){var S;y=(S=y)!==null&&S!==void 0?S:wt,jt&&jt(oe,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const D=y(U);D!==U&&(Qt(t)||(t[i]=D),U=D)}oe[U]=!0}return oe}function gt(oe){const t=Zt(null);for(const[y,S]of Bt(oe))t[y]=S;return t}function vt(oe,t){for(;oe!==null;){const S=Xt(oe,t);if(S){if(S.get)return rt(S.get);if(typeof S.value=="function")return rt(S.value)}oe=Yt(oe)}function y(S){return console.warn("fallback value for",S),null}return y}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),si=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Lt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ri=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),_t=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Wt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),oi=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),li=ht(/<%[\w\W]*|[\w\W]*%>/gm),ai=ht(/\${[\w\W]*}/gm),hi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),ui=ht(/^aria-[\-\w]+$/),qt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ci=ht(/^(?:\w+script|data):/i),fi=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ht(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:oi,ERB_EXPR:li,TMPLIT_EXPR:ai,DATA_ATTR:hi,ARIA_ATTR:ui,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:ci,ATTR_WHITESPACE:fi,DOCTYPE_NAME:Vt});const di=()=>typeof window>"u"?null:window,gi=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let S=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(S=y.getAttribute(i));const U="dompurify"+(S?"#"+S:"");try{return t.createPolicy(U,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Kt(){let oe=arguments.length>0&&arguments[0]!==void 0?arguments[0]:di();const t=Pe=>Kt(Pe);if(t.version="3.0.5",t.removed=[],!oe||!oe.document||oe.document.nodeType!==9)return t.isSupported=!1,t;const y=oe.document,S=y.currentScript;let{document:i}=oe;const{DocumentFragment:U,HTMLTemplateElement:D,Node:v,Element:l,NodeFilter:u,NamedNodeMap:f=oe.NamedNodeMap||oe.MozNamedAttrMap,HTMLFormElement:P,DOMParser:r,trustedTypes:h}=oe,e=l.prototype,a=vt(e,"cloneNode"),o=vt(e,"nextSibling"),s=vt(e,"childNodes"),n=vt(e,"parentNode");if(typeof D=="function"){const Pe=i.createElement("template");Pe.content&&Pe.content.ownerDocument&&(i=Pe.content.ownerDocument)}let g,b="";const{implementation:$,createNodeIterator:c,createDocumentFragment:O,getElementsByTagName:R}=i,{importNode:L}=y;let m={};t.isSupported=typeof Bt=="function"&&typeof n=="function"&&$&&$.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:p,ERB_EXPR:N,TMPLIT_EXPR:M,DATA_ATTR:H,ARIA_ATTR:j,IS_SCRIPT_OR_DATA:W,ATTR_WHITESPACE:ee}=xt;let{IS_ALLOWED_URI:ne}=xt,re=null;const ce=Be({},[...Ht,...Pt,...Tt,...Lt,...Ut]);let he=null;const ae=Be({},[..._t,...It,...Wt,...Dt]);let we=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Oe=null,Ie=null,Me=!0,fe=!0,ie=!1,G=!0,x=!1,J=!1,X=!1,k=!1,V=!1,d=!1,w=!1,E=!0,I=!1;const F="user-content-";let B=!0,q=!1,T={},z=null;const C=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let A=null;const _=Be({},["audio","video","img","source","image","track"]);let K=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",pe="http://www.w3.org/1999/xhtml";let Ce=pe,Ee=!1,ve=null;const Te=Be({},[se,ge,pe],Ot);let Fe;const qe=["application/xhtml+xml","text/html"],je="text/html";let Le,Ge=null;const Q=i.createElement("form"),le=function(ue){return ue instanceof RegExp||ue instanceof Function},be=function(ue){if(!(Ge&&Ge===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=gt(ue),Fe=qe.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Fe=je:Fe=ue.PARSER_MEDIA_TYPE,Le=Fe==="application/xhtml+xml"?Ot:wt,re="ALLOWED_TAGS"in ue?Be({},ue.ALLOWED_TAGS,Le):ce,he="ALLOWED_ATTR"in ue?Be({},ue.ALLOWED_ATTR,Le):ae,ve="ALLOWED_NAMESPACES"in ue?Be({},ue.ALLOWED_NAMESPACES,Ot):Te,K="ADD_URI_SAFE_ATTR"in ue?Be(gt(te),ue.ADD_URI_SAFE_ATTR,Le):te,A="ADD_DATA_URI_TAGS"in ue?Be(gt(_),ue.ADD_DATA_URI_TAGS,Le):_,z="FORBID_CONTENTS"in ue?Be({},ue.FORBID_CONTENTS,Le):C,Oe="FORBID_TAGS"in ue?Be({},ue.FORBID_TAGS,Le):{},Ie="FORBID_ATTR"in ue?Be({},ue.FORBID_ATTR,Le):{},T="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Me=ue.ALLOW_ARIA_ATTR!==!1,fe=ue.ALLOW_DATA_ATTR!==!1,ie=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,G=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,x=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,V=ue.RETURN_DOM||!1,d=ue.RETURN_DOM_FRAGMENT||!1,w=ue.RETURN_TRUSTED_TYPE||!1,k=ue.FORCE_BODY||!1,E=ue.SANITIZE_DOM!==!1,I=ue.SANITIZE_NAMED_PROPS||!1,B=ue.KEEP_CONTENT!==!1,q=ue.IN_PLACE||!1,ne=ue.ALLOWED_URI_REGEXP||qt,Ce=ue.NAMESPACE||pe,we=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&le(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(we.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&le(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(we.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(we.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),x&&(fe=!1),d&&(V=!0),T&&(re=Be({},[...Ut]),he=[],T.html===!0&&(Be(re,Ht),Be(he,_t)),T.svg===!0&&(Be(re,Pt),Be(he,It),Be(he,Dt)),T.svgFilters===!0&&(Be(re,Tt),Be(he,It),Be(he,Dt)),T.mathMl===!0&&(Be(re,Lt),Be(he,Wt),Be(he,Dt))),ue.ADD_TAGS&&(re===ce&&(re=gt(re)),Be(re,ue.ADD_TAGS,Le)),ue.ADD_ATTR&&(he===ae&&(he=gt(he)),Be(he,ue.ADD_ATTR,Le)),ue.ADD_URI_SAFE_ATTR&&Be(K,ue.ADD_URI_SAFE_ATTR,Le),ue.FORBID_CONTENTS&&(z===C&&(z=gt(z)),Be(z,ue.FORBID_CONTENTS,Le)),B&&(re["#text"]=!0),J&&Be(re,["html","head","body"]),re.table&&(Be(re,["tbody"]),delete Oe.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');g=ue.TRUSTED_TYPES_POLICY,b=g.createHTML("")}else g===void 0&&(g=gi(h,S)),g!==null&&typeof b=="string"&&(b=g.createHTML(""));tt&&tt(ue),Ge=ue}},De=Be({},["mi","mo","mn","ms","mtext"]),Ne=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),ze=Be({},Pt);Be(ze,Tt),Be(ze,si);const Qe=Be({},Lt);Be(Qe,ri);const Ye=function(ue){let ye=n(ue);(!ye||!ye.tagName)&&(ye={namespaceURI:Ce,tagName:"template"});const ke=wt(ue.tagName),Ue=wt(ye.tagName);return ve[ue.namespaceURI]?ue.namespaceURI===ge?ye.namespaceURI===pe?ke==="svg":ye.namespaceURI===se?ke==="svg"&&(Ue==="annotation-xml"||De[Ue]):!!ze[ke]:ue.namespaceURI===se?ye.namespaceURI===pe?ke==="math":ye.namespaceURI===ge?ke==="math"&&Ne[Ue]:!!Qe[ke]:ue.namespaceURI===pe?ye.namespaceURI===ge&&!Ne[Ue]||ye.namespaceURI===se&&!De[Ue]?!1:!Qe[ke]&&(Re[ke]||!ze[ke]):!!(Fe==="application/xhtml+xml"&&ve[ue.namespaceURI]):!1},Ve=function(ue){mt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},_e=function(ue,ye){try{mt(t.removed,{attribute:ye.getAttributeNode(ue),from:ye})}catch{mt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ue),ue==="is"&&!he[ue])if(V||d)try{Ve(ye)}catch{}else try{ye.setAttribute(ue,"")}catch{}},et=function(ue){let ye,ke;if(k)ue="<remove></remove>"+ue;else{const nt=ei(ue,/^[\r\n\t ]+/);ke=nt&&nt[0]}Fe==="application/xhtml+xml"&&Ce===pe&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Ue=g?g.createHTML(ue):ue;if(Ce===pe)try{ye=new r().parseFromString(Ue,Fe)}catch{}if(!ye||!ye.documentElement){ye=$.createDocument(Ce,"template",null);try{ye.documentElement.innerHTML=Ee?b:Ue}catch{}}const Xe=ye.body||ye.documentElement;return ue&&ke&&Xe.insertBefore(i.createTextNode(ke),Xe.childNodes[0]||null),Ce===pe?R.call(ye,J?"html":"body")[0]:J?ye.documentElement:Xe},it=function(ue){return c.call(ue.ownerDocument||ue,ue,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},ft=function(ue){return ue instanceof P&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof f)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ct=function(ue){return typeof v=="object"?ue instanceof v:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ot=function(ue,ye,ke){m[ue]&&Jt(m[ue],Ue=>{Ue.call(t,ye,ke,Ge)})},yt=function(ue){let ye;if(ot("beforeSanitizeElements",ue,null),ft(ue))return Ve(ue),!0;const ke=Le(ue.nodeName);if(ot("uponSanitizeElement",ue,{tagName:ke,allowedTags:re}),ue.hasChildNodes()&&!ct(ue.firstElementChild)&&(!ct(ue.content)||!ct(ue.content.firstElementChild))&&st(/<[/\w]/g,ue.innerHTML)&&st(/<[/\w]/g,ue.textContent))return Ve(ue),!0;if(!re[ke]||Oe[ke]){if(!Oe[ke]&&At(ke)&&(we.tagNameCheck instanceof RegExp&&st(we.tagNameCheck,ke)||we.tagNameCheck instanceof Function&&we.tagNameCheck(ke)))return!1;if(B&&!z[ke]){const Ue=n(ue)||ue.parentNode,Xe=s(ue)||ue.childNodes;if(Xe&&Ue){const nt=Xe.length;for(let xe=nt-1;xe>=0;--xe)Ue.insertBefore(a(Xe[xe],!0),o(ue))}}return Ve(ue),!0}return ue instanceof l&&!Ye(ue)||(ke==="noscript"||ke==="noembed"||ke==="noframes")&&st(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ve(ue),!0):(x&&ue.nodeType===3&&(ye=ue.textContent,ye=ut(ye,p," "),ye=ut(ye,N," "),ye=ut(ye,M," "),ue.textContent!==ye&&(mt(t.removed,{element:ue.cloneNode()}),ue.textContent=ye)),ot("afterSanitizeElements",ue,null),!1)},Et=function(ue,ye,ke){if(E&&(ye==="id"||ye==="name")&&(ke in i||ke in Q))return!1;if(!(fe&&!Ie[ye]&&st(H,ye))){if(!(Me&&st(j,ye))){if(!he[ye]||Ie[ye]){if(!(At(ue)&&(we.tagNameCheck instanceof RegExp&&st(we.tagNameCheck,ue)||we.tagNameCheck instanceof Function&&we.tagNameCheck(ue))&&(we.attributeNameCheck instanceof RegExp&&st(we.attributeNameCheck,ye)||we.attributeNameCheck instanceof Function&&we.attributeNameCheck(ye))||ye==="is"&&we.allowCustomizedBuiltInElements&&(we.tagNameCheck instanceof RegExp&&st(we.tagNameCheck,ke)||we.tagNameCheck instanceof Function&&we.tagNameCheck(ke))))return!1}else if(!K[ye]){if(!st(ne,ut(ke,ee,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ue!=="script"&&ti(ke,"data:")===0&&A[ue])){if(!(ie&&!st(W,ut(ke,ee,"")))){if(ke)return!1}}}}}}return!0},At=function(ue){return ue.indexOf("-")>0},kt=function(ue){let ye,ke,Ue,Xe;ot("beforeSanitizeAttributes",ue,null);const{attributes:nt}=ue;if(!nt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(Xe=nt.length;Xe--;){ye=nt[Xe];const{name:lt,namespaceURI:$t}=ye;if(ke=lt==="value"?ye.value:ii(ye.value),Ue=Le(lt),xe.attrName=Ue,xe.attrValue=ke,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ot("uponSanitizeAttribute",ue,xe),ke=xe.attrValue,xe.forceKeepAttr||(_e(lt,ue),!xe.keepAttr))continue;if(!G&&st(/\/>/i,ke)){_e(lt,ue);continue}x&&(ke=ut(ke,p," "),ke=ut(ke,N," "),ke=ut(ke,M," "));const Nt=Le(ue.nodeName);if(Et(Nt,Ue,ke)){if(I&&(Ue==="id"||Ue==="name")&&(_e(lt,ue),ke=F+ke),g&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(Nt,Ue)){case"TrustedHTML":{ke=g.createHTML(ke);break}case"TrustedScriptURL":{ke=g.createScriptURL(ke);break}}try{$t?ue.setAttributeNS($t,lt,ke):ue.setAttribute(lt,ke),zt(t.removed)}catch{}}}ot("afterSanitizeAttributes",ue,null)},Rt=function Pe(ue){let ye;const ke=it(ue);for(ot("beforeSanitizeShadowDOM",ue,null);ye=ke.nextNode();)ot("uponSanitizeShadowNode",ye,null),!yt(ye)&&(ye.content instanceof U&&Pe(ye.content),kt(ye));ot("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Pe){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,ke,Ue,Xe;if(Ee=!Pe,Ee&&(Pe="<!-->"),typeof Pe!="string"&&!ct(Pe))if(typeof Pe.toString=="function"){if(Pe=Pe.toString(),typeof Pe!="string")throw bt("dirty is not a string, aborting")}else throw bt("toString is not a function");if(!t.isSupported)return Pe;if(X||be(ue),t.removed=[],typeof Pe=="string"&&(q=!1),q){if(Pe.nodeName){const lt=Le(Pe.nodeName);if(!re[lt]||Oe[lt])throw bt("root node is forbidden and cannot be sanitized in-place")}}else if(Pe instanceof v)ye=et("<!---->"),ke=ye.ownerDocument.importNode(Pe,!0),ke.nodeType===1&&ke.nodeName==="BODY"||ke.nodeName==="HTML"?ye=ke:ye.appendChild(ke);else{if(!V&&!x&&!J&&Pe.indexOf("<")===-1)return g&&w?g.createHTML(Pe):Pe;if(ye=et(Pe),!ye)return V?null:w?b:""}ye&&k&&Ve(ye.firstChild);const nt=it(q?Pe:ye);for(;Ue=nt.nextNode();)yt(Ue)||(Ue.content instanceof U&&Rt(Ue.content),kt(Ue));if(q)return Pe;if(V){if(d)for(Xe=O.call(ye.ownerDocument);ye.firstChild;)Xe.appendChild(ye.firstChild);else Xe=ye;return(he.shadowroot||he.shadowrootmode)&&(Xe=L.call(y,Xe,!0)),Xe}let xe=J?ye.outerHTML:ye.innerHTML;return J&&re["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+xe),x&&(xe=ut(xe,p," "),xe=ut(xe,N," "),xe=ut(xe,M," ")),g&&w?g.createHTML(xe):xe},t.setConfig=function(Pe){be(Pe),X=!0},t.clearConfig=function(){Ge=null,X=!1},t.isValidAttribute=function(Pe,ue,ye){Ge||be({});const ke=Le(Pe),Ue=Le(ue);return Et(ke,Ue,ye)},t.addHook=function(Pe,ue){typeof ue=="function"&&(m[Pe]=m[Pe]||[],mt(m[Pe],ue))},t.removeHook=function(Pe){if(m[Pe])return zt(m[Pe])},t.removeHooks=function(Pe){m[Pe]&&(m[Pe]=[])},t.removeAllHooks=function(){m={}},t}var mi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return mi}),define(me[39],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xP=t.$wP=void 0;class y{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const v=S(D);this.a!==v&&(this.a=v,this.domNode.style.maxWidth=this.a)}setWidth(D){const v=S(D);this.b!==v&&(this.b=v,this.domNode.style.width=this.b)}setHeight(D){const v=S(D);this.c!==v&&(this.c=v,this.domNode.style.height=this.c)}setTop(D){const v=S(D);this.d!==v&&(this.d=v,this.domNode.style.top=this.d)}setLeft(D){const v=S(D);this.e!==v&&(this.e=v,this.domNode.style.left=this.e)}setBottom(D){const v=S(D);this.f!==v&&(this.f=v,this.domNode.style.bottom=this.f)}setRight(D){const v=S(D);this.g!==v&&(this.g=v,this.domNode.style.right=this.g)}setPaddingTop(D){const v=S(D);this.h!==v&&(this.h=v,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const v=S(D);this.i!==v&&(this.i=v,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const v=S(D);this.j!==v&&(this.j=v,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const v=S(D);this.k!==v&&(this.k=v,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const v=S(D);this.n!==v&&(this.n=v,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const v=S(D);this.s!==v&&(this.s=v,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const v=S(D);this.t!==v&&(this.t=v,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,v){this.domNode.classList.toggle(D,v),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,v){this.domNode.setAttribute(D,v)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.$wP=y;function S(U){return typeof U=="number"?`${U}px`:U}function i(U){return new y(U)}t.$xP=i}),define(me[66],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9N=t.$8N=void 0;let y=!1,S=null;function i(l){if(!l.parent||l.parent===l)return null;try{const u=l.location,f=l.parent.location;if(u.origin!=="null"&&f.origin!=="null"&&u.origin!==f.origin)return y=!0,null}catch{return y=!0,null}return l.parent}class U{static getSameOriginWindowChain(){if(!S){S=[];let u=window,f;do f=i(u),f?S.push({window:u,iframeElement:u.frameElement||null}):S.push({window:u,iframeElement:null}),u=f;while(u)}return S.slice(0)}static hasDifferentOriginAncestor(){return S||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(u,f){if(!f||u===f)return{top:0,left:0};let P=0,r=0;const h=this.getSameOriginWindowChain();for(const e of h){if(P+=e.window.scrollY,r+=e.window.scrollX,e.window===f||!e.iframeElement)break;const a=e.iframeElement.getBoundingClientRect();P+=a.top,r+=a.left}return{top:P,left:r}}}t.$8N=U;async function D(l,u){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:l,salt:u}),r=new TextEncoder().encode(f),h=await crypto.subtle.digest("sha-256",r);return v(h)}t.$9N=D;function v(l){const f=Array.from(new Uint8Array(l)).map(P=>P.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(me[67],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7P=t.$6P=t.$5P=t.ListDragOverEffect=void 0;var y;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$5P={reject(){return{accept:!1}},accept(){return{accept:!0}}};class S extends Error{constructor(D,v){super(`ListError [${D}] ${v}`)}}t.$6P=S;class i{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,v){v>0&&this.c.set(D,v)}}t.$7P=i}),define(me[68],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4P=void 0;class y{constructor(i){this.a=i}splice(i,U,D){this.a.forEach(v=>v.splice(i,U,D))}}t.$4P=y}),define(me[40],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CP=void 0;const y=20;class S{constructor(U,D,v,l,u,f){this.a=Math.round(D),this.b=Math.round(v),this.c=Math.round(U),this.d=l,this.e=u,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new S(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const D=Math.round(U);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(U){const D=Math.round(U);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(U){const D=Math.round(U);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,D,v,l,u){const f=Math.max(0,v-U),P=Math.max(0,f-2*D),r=l>0&&l>v;if(!r)return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(y,Math.floor(v*P/l))),e=(P-h)/(l-v),a=u*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:r,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const U=S.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const D=U-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const D=U-this.c;let v=this.f;return D<this.k?v-=this.d:v+=this.d,v}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const D=this.k+U;return Math.round(D/this.j)}}t.$CP=S}),define(me[24],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZR=t.$YR=t.$XR=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(l){l[l.Hidden=0]="Hidden",l[l.Visible=1]="Visible",l[l.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var S;(function(l){l[l.Expanded=0]="Expanded",l[l.Collapsed=1]="Collapsed",l[l.PreserveOrExpanded=2]="PreserveOrExpanded",l[l.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(S||(t.ObjectTreeElementCollapseState=S={}));var i;(function(l){l[l.Unknown=0]="Unknown",l[l.Twistie=1]="Twistie",l[l.Element=2]="Element",l[l.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$XR={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(l=!1){return{accept:!0,bubble:0,autoExpand:l}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(l=!1){return{accept:!0,bubble:0,effect:0,autoExpand:l}}};class D extends Error{constructor(u,f){super(`TreeError [${u}] ${f}`)}}t.$YR=D;class v{constructor(u){this.a=u,this.b=new WeakMap}map(u){let f=this.b.get(u);return f||(f=this.a(u),this.b.set(u,f)),f}}t.$ZR=v}),define(me[69],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=void 0;function y(a,o,s){const n=S(a,o);if(n!==-1)return a[n]}t.$_e=y;function S(a,o,s=a.length-1){for(let n=s;n>=0;n--){const g=a[n];if(o(g))return n}return-1}t.$af=S;function i(a,o){const s=U(a,o);return s===-1?void 0:a[s]}t.$bf=i;function U(a,o,s=0,n=a.length){let g=s,b=n;for(;g<b;){const $=Math.floor((g+b)/2);o(a[$])?g=$+1:b=$}return g-1}t.$cf=U;function D(a,o){const s=v(a,o);return s===a.length?void 0:a[s]}t.$df=D;function v(a,o,s=0,n=a.length){let g=s,b=n;for(;g<b;){const $=Math.floor((g+b)/2);o(a[$])?b=$:g=$+1}return g}t.$ef=v;function l(a,o,s=0,n=a.length){const g=v(a,o,s,n);return g===a.length?-1:g}t.$ff=l;class u{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(u.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!o(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const s=U(this.e,o,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}t.$gf=u;function f(a,o){if(a.length===0)return;let s=a[0];for(let n=1;n<a.length;n++){const g=a[n];o(g,s)>0&&(s=g)}return s}t.$hf=f;function P(a,o){if(a.length===0)return;let s=a[0];for(let n=1;n<a.length;n++){const g=a[n];o(g,s)>=0&&(s=g)}return s}t.$if=P;function r(a,o){return f(a,(s,n)=>-o(s,n))}t.$jf=r;function h(a,o){if(a.length===0)return-1;let s=0;for(let n=1;n<a.length;n++){const g=a[n];o(g,a[s])>0&&(s=n)}return s}t.$kf=h;function e(a,o){for(const s of a){const n=o(s);if(n!==void 0)return n}}t.$lf=e}),define(me[70],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function y(D,v){const l=Object.create(null);for(const u of D){const f=v(u);let P=l[f];P||(P=l[f]=[]),P.push(u)}return l}t.$I=y;function S(D,v){const l=[],u=[];for(const f of D)v.has(f)||l.push(f);for(const f of v)D.has(f)||u.push(f);return{removed:l,added:u}}t.$J=S;function i(D,v){const l=[],u=[];for(const[f,P]of D)v.has(f)||l.push(P);for(const[f,P]of v)D.has(f)||u.push(P);return{removed:l,added:u}}t.$K=i;class U{constructor(){this.a=new Map}add(v,l){let u=this.a.get(v);u||(u=new Set,this.a.set(v,u)),u.add(l)}delete(v,l){const u=this.a.get(v);u&&(u.delete(l),u.size===0&&this.a.delete(v))}forEach(v,l){const u=this.a.get(v);u&&u.forEach(l)}get(v){const l=this.a.get(v);return l||new Set}}t.$L=U}),define(me[71],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=t.$Ks=t.$Js=t.$Is=void 0;function y(v,l){const u=Math.pow(10,l);return Math.round(v*u)/u}class S{constructor(l,u,f,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$Is=S;class i{constructor(l,u,f,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.l=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,f=l.g/255,P=l.b/255,r=l.a,h=Math.max(u,f,P),e=Math.min(u,f,P);let a=0,o=0;const s=(e+h)/2,n=h-e;if(n>0){switch(o=Math.min(s<=.5?n/(2*s):n/(2-2*s),1),h){case u:a=(f-P)/n+(f<P?6:0);break;case f:a=(P-u)/n+2;break;case P:a=(u-f)/n+4;break}a*=60,a=Math.round(a)}return new i(a,o,s,r)}static i(l,u,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?l+(u-l)*6*f:f<1/2?u:f<2/3?l+(u-l)*(2/3-f)*6:l}static toRGBA(l){const u=l.h/360,{s:f,l:P,a:r}=l;let h,e,a;if(f===0)h=e=a=P;else{const o=P<.5?P*(1+f):P+f-P*f,s=2*P-o;h=i.i(s,o,u+1/3),e=i.i(s,o,u),a=i.i(s,o,u-1/3)}return new S(Math.round(h*255),Math.round(e*255),Math.round(a*255),r)}}t.$Js=i;class U{constructor(l,u,f,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=y(Math.max(Math.min(1,u),0),3),this.v=y(Math.max(Math.min(1,f),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,f=l.g/255,P=l.b/255,r=Math.max(u,f,P),h=Math.min(u,f,P),e=r-h,a=r===0?0:e/r;let o;return e===0?o=0:r===u?o=((f-P)/e%6+6)%6:r===f?o=(P-u)/e+2:o=(u-f)/e+4,new U(Math.round(o*60),a,r,l.a)}static toRGBA(l){const{h:u,s:f,v:P,a:r}=l,h=P*f,e=h*(1-Math.abs(u/60%2-1)),a=P-h;let[o,s,n]=[0,0,0];return u<60?(o=h,s=e):u<120?(o=e,s=h):u<180?(s=h,n=e):u<240?(s=e,n=h):u<300?(o=e,n=h):u<=360&&(o=h,n=e),o=Math.round((o+a)*255),s=Math.round((s+a)*255),n=Math.round((n+a)*255),new S(o,s,n,r)}}t.$Ks=U;class D{static fromHex(l){return D.Format.CSS.parseHex(l)||D.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof S)this.rgba=l;else if(l instanceof i)this.i=l,this.rgba=i.toRGBA(l);else if(l instanceof U)this.j=l,this.rgba=U.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&S.equals(this.rgba,l.rgba)&&i.equals(this.hsla,l.hsla)&&U.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=D.k(this.rgba.r),u=D.k(this.rgba.g),f=D.k(this.rgba.b),P=.2126*l+.7152*u+.0722*f;return y(P,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u>f?(u+.05)/(f+.05):(f+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u>f}isDarkerThan(l){const u=this.getRelativeLuminance(),f=l.getRelativeLuminance();return u<f}lighten(l){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new D(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:f,b:P,a:r}=this.rgba;return new D(new S(u,f,P,r*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new S(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,f=this.rgba.a,P=u.a,r=f+P*(1-f);if(r<1e-6)return D.transparent;const h=this.rgba.r*f/r+u.r*P*(1-f)/r,e=this.rgba.g*f/r+u.g*P*(1-f)/r,a=this.rgba.b*f/r+u.b*P*(1-f)/r;return new D(new S(h,e,a,r))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:f,b:P,a:r}=this.rgba;return new D(new S(l.rgba.r-r*(l.rgba.r-u),l.rgba.g-r*(l.rgba.g-f),l.rgba.b-r*(l.rgba.b-P),1))}flatten(...l){const u=l.reduceRight((f,P)=>D.o(P,f));return D.o(this,u)}static o(l,u){const f=1-l.rgba.a;return new D(new S(f*u.rgba.r+l.rgba.a*l.rgba.r,f*u.rgba.g+l.rgba.a*l.rgba.g,f*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(l,u,f){if(l.isLighterThan(u))return l;f=f||.5;const P=l.getRelativeLuminance(),r=u.getRelativeLuminance();return f=f*(r-P)/r,l.lighten(f)}static getDarkerColor(l,u,f){if(l.isDarkerThan(u))return l;f=f||.5;const P=l.getRelativeLuminance(),r=u.getRelativeLuminance();return f=f*(P-r)/P,l.darken(f)}static{this.white=new D(new S(255,255,255,1))}static{this.black=new D(new S(0,0,0,1))}static{this.red=new D(new S(255,0,0,1))}static{this.blue=new D(new S(0,0,255,1))}static{this.green=new D(new S(0,255,0,1))}static{this.cyan=new D(new S(0,255,255,1))}static{this.lightgrey=new D(new S(211,211,211,1))}static{this.transparent=new D(new S(0,0,0,0))}}t.$Ls=D,function(v){let l;(function(u){let f;(function(P){function r(c){return c.rgba.a===1?`rgb(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b})`:v.Format.CSS.formatRGBA(c)}P.formatRGB=r;function h(c){return`rgba(${c.rgba.r}, ${c.rgba.g}, ${c.rgba.b}, ${+c.rgba.a.toFixed(2)})`}P.formatRGBA=h;function e(c){return c.hsla.a===1?`hsl(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(c)}P.formatHSL=e;function a(c){return`hsla(${c.hsla.h}, ${(c.hsla.s*100).toFixed(2)}%, ${(c.hsla.l*100).toFixed(2)}%, ${c.hsla.a.toFixed(2)})`}P.formatHSLA=a;function o(c){const O=c.toString(16);return O.length!==2?"0"+O:O}function s(c){return`#${o(c.rgba.r)}${o(c.rgba.g)}${o(c.rgba.b)}`}P.formatHex=s;function n(c,O=!1){return O&&c.rgba.a===1?v.Format.CSS.formatHex(c):`#${o(c.rgba.r)}${o(c.rgba.g)}${o(c.rgba.b)}${o(Math.round(c.rgba.a*255))}`}P.formatHexA=n;function g(c){return c.isOpaque()?v.Format.CSS.formatHex(c):v.Format.CSS.formatRGBA(c)}P.format=g;function b(c){const O=c.length;if(O===0||c.charCodeAt(0)!==35)return null;if(O===7){const R=16*$(c.charCodeAt(1))+$(c.charCodeAt(2)),L=16*$(c.charCodeAt(3))+$(c.charCodeAt(4)),m=16*$(c.charCodeAt(5))+$(c.charCodeAt(6));return new v(new S(R,L,m,1))}if(O===9){const R=16*$(c.charCodeAt(1))+$(c.charCodeAt(2)),L=16*$(c.charCodeAt(3))+$(c.charCodeAt(4)),m=16*$(c.charCodeAt(5))+$(c.charCodeAt(6)),p=16*$(c.charCodeAt(7))+$(c.charCodeAt(8));return new v(new S(R,L,m,p/255))}if(O===4){const R=$(c.charCodeAt(1)),L=$(c.charCodeAt(2)),m=$(c.charCodeAt(3));return new v(new S(16*R+R,16*L+L,16*m+m))}if(O===5){const R=$(c.charCodeAt(1)),L=$(c.charCodeAt(2)),m=$(c.charCodeAt(3)),p=$(c.charCodeAt(4));return new v(new S(16*R+R,16*L+L,16*m+m,(16*p+p)/255))}return null}P.parseHex=b;function $(c){switch(c){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=u.CSS||(u.CSS={}))})(l=v.Format||(v.Format={}))}(D||(t.$Ls=D={}))}),define(me[25],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6g=t.$5g=t.$4g=void 0;function y(D){return(v,l,u)=>{let f=null,P=null;if(typeof u.value=="function"?(f="value",P=u.value):typeof u.get=="function"&&(f="get",P=u.get),!P)throw new Error("not supported");u[f]=D(P,l)}}function S(D,v,l){let u=null,f=null;if(typeof l.value=="function"?(u="value",f=l.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(u="get",f=l.get),!f)throw new Error("not supported");const P=`$memoize$${v}`;l[u]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,r)}),this[P]}}t.$4g=S;function i(D,v,l){return y((u,f)=>{const P=`$debounce$${f}`,r=`$debounce$result$${f}`;return function(...h){this[r]||(this[r]=l?l():void 0),clearTimeout(this[P]),v&&(this[r]=v(this[r],...h),h=[this[r]]),this[P]=setTimeout(()=>{u.apply(this,h),this[r]=l?l():void 0},D)}})}t.$5g=i;function U(D,v,l){return y((u,f)=>{const P=`$throttle$timer$${f}`,r=`$throttle$result$${f}`,h=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...a){if(this[r]||(this[r]=l?l():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),v&&(this[r]=v(this[r],...a)),this[e])return;const o=this[h]+D;o<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[r]]),this[r]=l?l():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),u.apply(this,[this[r]]),this[r]=l?l():void 0},o-Date.now()))}})}t.$6g=U}),define(me[72],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ks=void 0;class y{constructor(i,U,D,v){this.originalStart=i,this.originalLength=U,this.modifiedStart=D,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ks=y}),define(me[6],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class y{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?g.isErrorNoTelemetry(c)?new g(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(O=>{O(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}t.$U=y,t.$V=new y;function S($){t.$V.setUnexpectedErrorHandler($)}t.setUnexpectedErrorHandler=S;function i($){if(!$||typeof $!="object")return!1;const c=$;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}t.$X=i;function U($){u($)||t.$V.onUnexpectedError($)}t.$Y=U;function D($){u($)||t.$V.onUnexpectedExternalError($)}t.$Z=D;function v($){if($ instanceof Error){const{name:c,message:O}=$,R=$.stacktrace||$.stack;return{$isError:!0,name:c,message:O,stack:R,noTelemetry:g.isErrorNoTelemetry($)}}return $}t.$1=v;const l="Canceled";function u($){return $ instanceof f?!0:$ instanceof Error&&$.name===l&&$.message===l}t.$2=u;class f extends Error{constructor(){super(l),this.name=this.message}}t.$3=f;function P(){const $=new Error(l);return $.name=$.message,$}t.$4=P;function r($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}t.$5=r;function h($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}t.$6=h;class e extends TypeError{constructor(c){super(c?`${c} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$7=e;function a($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}t.$8=a;class o extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}t.$9=o;class s extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}t.$0=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$$=n;class g extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof g)return c;const O=new g;return O.message=c.message,O.stack=c.stack,O}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}t.$_=g;class b extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$ab=b}),define(me[13],$e([1,0,6,69]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.CompareResult=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.top=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=void 0;function i(E,I=0){return E[E.length-(1+I)]}t.$mf=i;function U(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}t.$nf=U;function D(E,I,F=(B,q)=>B===q){if(E===I)return!0;if(!E||!I||E.length!==I.length)return!1;for(let B=0,q=E.length;B<q;B++)if(!F(E[B],I[B]))return!1;return!0}t.$of=D;function v(E,I){const F=E.length-1;I<F&&(E[I]=E[F]),E.pop()}t.$pf=v;function l(E,I,F){return u(E.length,B=>F(E[B],I))}t.$qf=l;function u(E,I){let F=0,B=E-1;for(;F<=B;){const q=(F+B)/2|0,T=I(q);if(T<0)F=q+1;else if(T>0)B=q-1;else return q}return-(F+1)}t.$rf=u;function f(E,I,F){if(E=E|0,E>=I.length)throw new TypeError("invalid index");const B=I[Math.floor(I.length*Math.random())],q=[],T=[],z=[];for(const C of I){const A=F(C,B);A<0?q.push(C):A>0?T.push(C):z.push(C)}return E<q.length?f(E,q,F):E<q.length+z.length?z[0]:f(E-(q.length+z.length),T,F)}t.$sf=f;function P(E,I){const F=[];let B;for(const q of E.slice(0).sort(I))!B||I(B[0],q)!==0?(B=[q],F.push(B)):B.push(q);return F}t.$tf=P;function*r(E,I){let F,B;for(const q of E)B!==void 0&&I(B,q)?F.push(q):(F&&(yield F),F=[q]),B=q;F&&(yield F)}t.$uf=r;function h(E,I){for(let F=0;F<=E.length;F++)I(F===0?void 0:E[F-1],F===E.length?void 0:E[F])}t.$vf=h;function e(E,I,F){const B=[];function q(C,A,_){if(A===0&&_.length===0)return;const K=B[B.length-1];K&&K.start+K.deleteCount===C?(K.deleteCount+=A,K.toInsert.push(..._)):B.push({start:C,deleteCount:A,toInsert:_})}let T=0,z=0;for(;;){if(T===E.length){q(T,0,I.slice(z));break}if(z===I.length){q(T,E.length-T,[]);break}const C=E[T],A=I[z],_=F(C,A);_===0?(T+=1,z+=1):_<0?(q(T,1,[]),T+=1):_>0&&(q(T,0,[A]),z+=1)}return B}t.$wf=e;function a(E,I,F){const B=e(E,I,F),q=[],T=[];for(const z of B)q.push(...E.slice(z.start,z.start+z.deleteCount)),T.push(...z.toInsert);return{removed:q,added:T}}t.$xf=a;function o(E,I,F){if(F===0)return[];const B=E.slice(0,F).sort(I);return n(E,I,B,F,E.length),B}t.top=o;function s(E,I,F,B,q){return F===0?Promise.resolve([]):new Promise((T,z)=>{(async()=>{const C=E.length,A=E.slice(0,F).sort(I);for(let _=F,K=Math.min(F+B,C);_<C;_=K,K=Math.min(K+B,C)){if(_>F&&await new Promise(te=>setTimeout(te)),q&&q.isCancellationRequested)throw new y.$3;n(E,I,A,_,K)}return A})().then(T,z)})}t.$zf=s;function n(E,I,F,B,q){for(const T=F.length;B<q;B++){const z=E[B];if(I(z,F[T-1])<0){F.pop();const C=(0,S.$ef)(F,A=>I(z,A)<0);F.splice(C,0,z)}}}function g(E){return E.filter(I=>!!I)}t.$Af=g;function b(E){let I=0;for(let F=0;F<E.length;F++)E[F]&&(E[I]=E[F],I+=1);E.length=I}t.$Bf=b;function $(E,I,F){E.splice(F,0,E.splice(I,1)[0])}t.$Cf=$;function c(E){return!Array.isArray(E)||E.length===0}t.$Df=c;function O(E){return Array.isArray(E)&&E.length>0}t.$Ef=O;function R(E,I=F=>F){const F=new Set;return E.filter(B=>{const q=I(B);return F.has(q)?!1:(F.add(q),!0)})}t.$Ff=R;function L(E){const I=new Set;return F=>{const B=E(F);return I.has(B)?!1:(I.add(B),!0)}}t.$Gf=L;function m(E,I){return E.length>0?E[0]:I}t.$Hf=m;function p(E,I){return E.length>0?E[E.length-1]:I}t.$If=p;function N(E,I,F=(B,q)=>B===q){let B=0;for(let q=0,T=Math.min(E.length,I.length);q<T&&F(E[q],I[q]);q++)B++;return B}t.$Jf=N;function M(E){return[].concat(...E)}t.$Kf=M;function H(E,I){let F=typeof I=="number"?E:0;typeof I=="number"?F=E:(F=0,I=E);const B=[];if(F<=I)for(let q=F;q<I;q++)B.push(q);else for(let q=F;q>I;q--)B.push(q);return B}t.$Lf=H;function j(E,I,F){return E.reduce((B,q)=>(B[I(q)]=F?F(q):q,B),Object.create(null))}t.$Mf=j;function W(E,I){return E.push(I),()=>ee(E,I)}t.$Nf=W;function ee(E,I){const F=E.indexOf(I);if(F>-1)return E.splice(F,1),I}t.$Of=ee;function ne(E,I,F){const B=E.slice(0,I),q=E.slice(I);return B.concat(F,q)}t.$Pf=ne;function re(E,I){let F;if(typeof I=="number"){let B=I;F=()=>{const q=Math.sin(B++)*179426549;return q-Math.floor(q)}}else F=Math.random;for(let B=E.length-1;B>0;B-=1){const q=Math.floor(F()*(B+1)),T=E[B];E[B]=E[q],E[q]=T}}t.$Qf=re;function ce(E,I){const F=E.indexOf(I);F>-1&&(E.splice(F,1),E.unshift(I))}t.$Rf=ce;function he(E,I){const F=E.indexOf(I);F>-1&&(E.splice(F,1),E.push(I))}t.$Sf=he;function ae(E,I){for(const F of I)E.push(F)}t.$Tf=ae;function we(E,I){return Array.isArray(E)?E.map(I):I(E)}t.$Uf=we;function Oe(E){return Array.isArray(E)?E:[E]}t.$Vf=Oe;function Ie(E){return E[Math.floor(Math.random()*E.length)]}t.$Wf=Ie;function Me(E,I,F){const B=ie(E,I),q=E.length,T=F.length;E.length=q+T;for(let z=q-1;z>=B;z--)E[z+T]=E[z];for(let z=0;z<T;z++)E[z+B]=F[z]}t.$Xf=Me;function fe(E,I,F,B){const q=ie(E,I);let T=E.splice(q,F);return T===void 0&&(T=[]),Me(E,q,B),T}t.$Yf=fe;function ie(E,I){return I<0?Math.max(I+E.length,0):Math.min(I,E.length)}var G;(function(E){function I(T){return T<0}E.isLessThan=I;function F(T){return T<=0}E.isLessThanOrEqual=F;function B(T){return T>0}E.isGreaterThan=B;function q(T){return T===0}E.isNeitherLessOrGreaterThan=q,E.greaterThan=1,E.lessThan=-1,E.neitherLessOrGreaterThan=0})(G||(t.CompareResult=G={}));function x(E,I){return(F,B)=>I(E(F),E(B))}t.$Zf=x;function J(...E){return(I,F)=>{for(const B of E){const q=B(I,F);if(!G.isNeitherLessOrGreaterThan(q))return q}return G.neitherLessOrGreaterThan}}t.$1f=J;const X=(E,I)=>E-I;t.$2f=X;const k=(E,I)=>(0,t.$2f)(E?1:0,I?1:0);t.$3f=k;function V(E){return(I,F)=>-E(I,F)}t.$4f=V;class d{constructor(I){this.g=I,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(I){let F=this.c;for(;F<this.g.length&&I(this.g[F]);)F++;const B=F===this.c?null:this.g.slice(this.c,F);return this.c=F,B}takeFromEndWhile(I){let F=this.d;for(;F>=0&&I(this.g[F]);)F--;const B=F===this.d?null:this.g.slice(F+1,this.d+1);return this.d=F,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const I=this.g[this.c];return this.c++,I}removeLast(){const I=this.g[this.d];return this.d--,I}takeCount(I){const F=this.g.slice(this.c,this.c+I);return this.c+=I,F}}t.$5f=d;class w{static{this.empty=new w(I=>{})}constructor(I){this.iterate=I}forEach(I){this.iterate(F=>(I(F),!0))}toArray(){const I=[];return this.iterate(F=>(I.push(F),!0)),I}filter(I){return new w(F=>this.iterate(B=>I(B)?F(B):!0))}map(I){return new w(F=>this.iterate(B=>F(I(B))))}some(I){let F=!1;return this.iterate(B=>(F=I(B),!F)),F}findFirst(I){let F;return this.iterate(B=>I(B)?(F=B,!1):!0),F}findLast(I){let F;return this.iterate(B=>(I(B)&&(F=B),!0)),F}findLastMaxBy(I){let F,B=!0;return this.iterate(q=>((B||G.isGreaterThan(I(q,F)))&&(B=!1,F=q),!0)),F}}t.$6f=w}),define(me[73],$e([1,0,6]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ab=t.$zb=t.$yb=t.$xb=t.ok=void 0;function S(l,u){if(!l)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=S;function i(l,u="Unreachable"){throw new Error(u)}t.$xb=i;function U(l){if(!l)throw new y.$ab("Assertion Failed")}t.$yb=U;function D(l){if(!l()){debugger;l(),(0,y.$Y)(new y.$ab("Assertion Failed"))}}t.$zb=D;function v(l,u){let f=0;for(;f<l.length-1;){const P=l[f],r=l[f+1];if(!u(P,r))return!1;f++}return!0}t.$Ab=v}),define(me[41],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=void 0;function y(S){const i=this;let U=!1,D;return function(){return U||(U=!0,D=S.apply(i,arguments)),D}}t.$bb=y}),define(me[74],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1L=t.$ZL=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$ZL=y,t.$1L=new y("id#")}),define(me[26],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(S){function i(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}S.is=i;const U=Object.freeze([]);function D(){return U}S.empty=D;function*v(b){yield b}S.single=v;function l(b){return i(b)?b:v(b)}S.wrap=l;function u(b){return b||U}S.from=u;function f(b){return!b||b[Symbol.iterator]().next().done===!0}S.isEmpty=f;function P(b){return b[Symbol.iterator]().next().value}S.first=P;function r(b,$){for(const c of b)if($(c))return!0;return!1}S.some=r;function h(b,$){for(const c of b)if($(c))return c}S.find=h;function*e(b,$){for(const c of b)$(c)&&(yield c)}S.filter=e;function*a(b,$){let c=0;for(const O of b)yield $(O,c++)}S.map=a;function*o(...b){for(const $ of b)for(const c of $)yield c}S.concat=o;function s(b,$,c){let O=c;for(const R of b)O=$(O,R);return O}S.reduce=s;function*n(b,$,c=b.length){for($<0&&($+=b.length),c<0?c+=b.length:c>b.length&&(c=b.length);$<c;$++)yield b[$]}S.slice=n;function g(b,$=Number.POSITIVE_INFINITY){const c=[];if($===0)return[c,b];const O=b[Symbol.iterator]();for(let R=0;R<$;R++){const L=O.next();if(L.done)return[c,S.empty()];c.push(L.value)}return[c,{[Symbol.iterator](){return O}}]}S.consume=g})(y||(t.Iterable=y={}))}),define(me[42],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sq=t.KeyMod=t.KeyCodeUtils=t.$rq=t.$qq=t.$pq=t.$oq=t.$nq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var S;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(S||(t.ScanCode=S={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,o){this._keyCodeToStr[a]=o,this._strToKeyCode[o.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const U=new i,D=new i,v=new i;t.$nq=new Array(230),t.$oq={};const l=[],u=Object.create(null),f=Object.create(null);t.$pq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$qq=[],t.$rq=[];for(let e=0;e<=193;e++)t.$qq[e]=-1;for(let e=0;e<=132;e++)t.$rq[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],s=[];for(const n of a){const[g,b,$,c,O,R,L,m,p]=n;if(s[b]||(s[b]=!0,l[b]=$,u[$]=b,f[$.toLowerCase()]=b,g&&(t.$qq[b]=c,c!==0&&c!==3&&c!==5&&c!==4&&c!==6&&c!==57&&(t.$rq[c]=b))),!o[c]){if(o[c]=!0,!O)throw new Error(`String representation missing for key code ${c} around scan code ${$}`);U.define(c,O),D.define(c,m||O),v.define(c,p||m||O)}R&&(t.$nq[R]=c),L&&(t.$oq[L]=c)}t.$rq[3]=46})();var P;(function(e){function a($){return U.keyCodeToStr($)}e.toString=a;function o($){return U.strToKeyCode($)}e.fromString=o;function s($){return D.keyCodeToStr($)}e.toUserSettingsUS=s;function n($){return v.keyCodeToStr($)}e.toUserSettingsGeneral=n;function g($){return D.strToKeyCode($)||v.strToKeyCode($)}e.fromUserSettings=g;function b($){if($>=98&&$<=113)return null;switch($){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr($)}e.toElectronAccelerator=b})(P||(t.KeyCodeUtils=P={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function h(e,a){const o=(a&65535)<<16>>>0;return(e|o)>>>0}t.$sq=h}),define(me[75],$e([1,0,6]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zq=t.$yq=t.$xq=t.$wq=t.$vq=t.$uq=t.$tq=void 0;var S;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(S||(S={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const h=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new l([U(h,r),U(e,r)]):new l([U(h,r)])}else{const h=[];for(let e=0;e<P.length;e++)h.push(U(P[e],r));return new l(h)}}t.$tq=i;function U(P,r){const h=!!(P&2048),e=!!(P&256),a=r===2?e:h,o=!!(P&1024),s=!!(P&512),n=r===2?h:e,g=P&255;return new D(a,o,s,n,g)}t.$uq=U;class D{constructor(r,h,e,a,o){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.keyCode=o}equals(r){return r instanceof D&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${h}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new l([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$vq=D;class v{constructor(r,h,e,a,o){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.scanCode=o}equals(r){return r instanceof v&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${h}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$wq=v;class l{constructor(r){if(r.length===0)throw(0,y.$5)("chords");this.chords=r}getHashCode(){let r="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(r+=";"),r+=this.chords[h].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(r.chords[h]))return!1;return!0}}t.$xq=l;class u{constructor(r,h,e,a,o,s){this.ctrlKey=r,this.shiftKey=h,this.altKey=e,this.metaKey=a,this.keyLabel=o,this.keyAriaLabel=s}}t.$yq=u;class f{}t.$zq=f}),define(me[30],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=y}),define(me[2],$e([1,0,41,26]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ub=t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=t.$cb=void 0;const i=!1;let U=null;function D(p){U=p}if(t.$cb=D,i){const p="__is_disposable_tracked__";D(new class{trackDisposable(N){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{N[p]||console.log(M)},3e3)}setParent(N,M){if(N&&N!==n.None)try{N[p]=!0}catch{}}markAsDisposed(N){if(N&&N!==n.None)try{N[p]=!0}catch{}}markAsSingleton(N){}})}function v(p){return U?.trackDisposable(p),p}t.$db=v;function l(p){U?.markAsDisposed(p)}t.$eb=l;function u(p,N){U?.setParent(p,N)}function f(p,N){if(U)for(const M of p)U.setParent(M,N)}function P(p){return U?.markAsSingleton(p),p}t.$fb=P;function r(p){return typeof p.dispose=="function"&&p.dispose.length===0}t.$gb=r;function h(p){if(S.Iterable.is(p)){const N=[];for(const M of p)if(M)try{M.dispose()}catch(H){N.push(H)}if(N.length===1)throw N[0];if(N.length>1)throw new AggregateError(N,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}t.$hb=h;function e(p){for(const N of p)r(N)&&N.dispose();return[]}t.$ib=e;function a(...p){const N=o(()=>h(p));return f(p,N),N}t.$jb=a;function o(p){const N=v({dispose:(0,y.$bb)(()=>{l(N),p()})});return N}t.$kb=o;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(N){if(!N)return N;if(N===this)throw new Error("Cannot register a disposable on itself!");return u(N,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(N),N}}t.$lb=s;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,v(this),u(this.q,this)}dispose(){l(this),this.q.dispose()}B(N){if(N===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(N)}}t.$mb=n;class g{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(N){this.b||N===this.a||(this.a?.dispose(),N&&u(N,this),this.a=N)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const N=this.a;return this.a=void 0,N&&u(N,null),N}}t.$nb=g;class b{constructor(N){this.b=N,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$ob=b;class ${constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(N){let M=N;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,l(this))},this}}t.$pb=$;class c{constructor(){this.a=new Map}acquire(N,...M){let H=this.a.get(N);H||(H={counter:0,object:this.b(N,...M)},this.a.set(N,H));const{object:j}=H,W=(0,y.$bb)(()=>{--H.counter===0&&(this.c(N,H.object),this.a.delete(N))});return H.counter++,{object:j,dispose:W}}}t.$qb=c;class O{constructor(N){this.a=N}async acquire(N,...M){const H=this.a.acquire(N,...M);try{return{object:await H.object,dispose:()=>H.dispose()}}catch(j){throw H.dispose(),j}}}t.$rb=O;class R{constructor(N){this.object=N}dispose(){}}t.$sb=R;function L(p){const N=new s;try{p(N)}finally{N.dispose()}}t.$tb=L;class m{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(N){return this.a.has(N)}get size(){return this.a.size}get(N){return this.a.get(N)}set(N,M,H=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),H||this.a.get(N)?.dispose(),this.a.set(N,M)}deleteAndDispose(N){this.a.get(N)?.dispose(),this.a.delete(N)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$ub=m}),define(me[43],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vb=void 0;class y{static{this.Undefined=new y(void 0)}constructor(U){this.element=U,this.next=y.Undefined,this.prev=y.Undefined}}class S{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let U=this.a;for(;U!==y.Undefined;){const D=U.next;U.prev=y.Undefined,U.next=y.Undefined,U=D}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,D){const v=new y(U);if(this.a===y.Undefined)this.a=v,this.b=v;else if(D){const u=this.b;this.b=v,v.prev=u,u.next=v}else{const u=this.a;this.a=v,v.next=u,u.prev=v}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(v))}}shift(){if(this.a!==y.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==y.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==y.Undefined&&U.next!==y.Undefined){const D=U.prev;D.next=U.next,U.next.prev=D}else U.prev===y.Undefined&&U.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):U.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):U.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==y.Undefined;)yield U.element,U=U.next}}t.$vb=S}),define(me[76],$e([1,0]),function(oe,t){"use strict";var y,S,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ci=t.$Bi=t.$Ai=t.$zi=t.Touch=t.$yi=t.$xi=t.$wi=t.$vi=t.$ui=void 0;function U(o,s,n){let g=o.get(s);return g===void 0&&(g=n,o.set(s,g)),g}t.$ui=U;function D(o){const s=[];return o.forEach((n,g)=>{s.push(`${g} => ${n}`)}),`Map(${o.size}) {${s.join(", ")}}`}t.$vi=D;function v(o){const s=[];return o.forEach(n=>{s.push(n)}),`Set(${o.size}) {${s.join(", ")}}`}t.$wi=v;class l{constructor(s,n){this.uri=s,this.value=n}}class u{static{this.a=s=>s.toString()}constructor(s,n){this[y]="ResourceMap",s instanceof u?(this.b=new Map(s.b),this.c=n??u.a):(this.b=new Map,this.c=s??u.a)}set(s,n){return this.b.set(this.c(s),new l(s,n)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,n){typeof n<"u"&&(s=s.bind(n));for(const[g,b]of this.b)s(b.value,b.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.$xi=u;class f{constructor(s,n){this[S]="ResourceSet",!s||typeof s=="function"?this.a=new u(s):(this.a=new u(n),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,n){this.a.forEach((g,b)=>s.call(n,b,b,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$yi=f;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P||(t.Touch=P={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,n=0){const g=this.a.get(s);if(g)return n!==0&&this.j(g,n),g.value}set(s,n,g=0){let b=this.a.get(s);if(b)b.value=n,g!==0&&this.j(b,g);else{switch(b={key:s,value:n,next:void 0,previous:void 0},g){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(s,b),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const n=this.a.get(s);if(n)return this.a.delete(s),this.i(n),this.d--,n.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,n){const g=this.e;let b=this.b;for(;b;){if(n?s.bind(n)(b.value,b.key,this):s(b.value,b.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.key,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}values(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.value,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}entries(){const s=this,n=this.e;let g=this.b;const b={[Symbol.iterator](){return b},next(){if(s.e!==n)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:[g.key,g.value],done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return b}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let n=this.b,g=this.size;for(;n&&g>s;)this.a.delete(n.key),n=n.next,g--;this.b=n,this.d=g,n&&(n.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const n=s.next,g=s.previous;if(!n||!g)throw new Error("Invalid list");n.previous=g,g.next=n}s.next=void 0,s.previous=void 0,this.e++}j(s,n){if(!this.b||!this.c)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(s===this.b)return;const g=s.next,b=s.previous;s===this.c?(b.next=void 0,this.c=b):(g.previous=b,b.next=g),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(n===2){if(s===this.c)return;const g=s.next,b=s.previous;s===this.b?(g.previous=void 0,this.b=g):(g.previous=b,b.next=g),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((n,g)=>{s.push([g,n])}),s}fromJSON(s){this.clear();for(const[n,g]of s)this.set(n,g)}}t.$zi=r;class h extends r{constructor(s,n=1){super(),this.k=s,this.l=Math.min(Math.max(0,n),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,n=2){return super.get(s,n)}peek(s){return super.get(s,0)}set(s,n){return super.set(s,n,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Ai=h;class e{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let n=this.a.get(s)||0;return n===0?!1:(n--,n===0?this.a.delete(s):this.a.set(s,n),!0)}has(s){return this.a.has(s)}}t.$Bi=e;class a{constructor(s){if(this.a=new Map,this.b=new Map,s)for(const[n,g]of s)this.set(n,g)}clear(){this.a.clear(),this.b.clear()}set(s,n){this.a.set(s,n),this.b.set(n,s)}get(s){return this.a.get(s)}getKey(s){return this.b.get(s)}delete(s){const n=this.a.get(s);return n===void 0?!1:(this.a.delete(s),this.b.delete(n),!0)}forEach(s,n){this.a.forEach((g,b)=>{s.call(n,g,b,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ci=a}),function(oe,t){typeof define=="function"&&define.amd?define(me[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,t(oe.marked={}))}(this,function(oe){"use strict";function t(F,B){for(var q=0;q<B.length;q++){var T=B[q];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(F,T.key,T)}}function y(F,B,q){return B&&t(F.prototype,B),q&&t(F,q),Object.defineProperty(F,"prototype",{writable:!1}),F}function S(F,B){if(F){if(typeof F=="string")return i(F,B);var q=Object.prototype.toString.call(F).slice(8,-1);if(q==="Object"&&F.constructor&&(q=F.constructor.name),q==="Map"||q==="Set")return Array.from(F);if(q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(q))return i(F,B)}}function i(F,B){(B==null||B>F.length)&&(B=F.length);for(var q=0,T=new Array(B);q<B;q++)T[q]=F[q];return T}function U(F,B){var q=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(q)return(q=q.call(F)).next.bind(q);if(Array.isArray(F)||(q=S(F))||B&&F&&typeof F.length=="number"){q&&(F=q);var T=0;return function(){return T>=F.length?{done:!0}:{done:!1,value:F[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=D();function v(F){oe.defaults=F}var l=/[&<>"']/,u=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(B){return r[B]};function e(F,B){if(B){if(l.test(F))return F.replace(u,h)}else if(f.test(F))return F.replace(P,h);return F}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(F){return F.replace(a,function(B,q){return q=q.toLowerCase(),q==="colon"?":":q.charAt(0)==="#"?q.charAt(1)==="x"?String.fromCharCode(parseInt(q.substring(2),16)):String.fromCharCode(+q.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(F,B){F=typeof F=="string"?F:F.source,B=B||"";var q={replace:function(z,C){return C=C.source||C,C=C.replace(s,"$1"),F=F.replace(z,C),q},getRegex:function(){return new RegExp(F,B)}};return q}var g=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function $(F,B,q){if(F){var T;try{T=decodeURIComponent(o(q)).replace(g,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}B&&!b.test(q)&&(q=m(B,q));try{q=encodeURI(q).replace(/%25/g,"%")}catch{return null}return q}var c={},O=/^[^:]+:\/*[^/]*$/,R=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(F,B){c[" "+F]||(O.test(F)?c[" "+F]=F+"/":c[" "+F]=H(F,"/",!0)),F=c[" "+F];var q=F.indexOf(":")===-1;return B.substring(0,2)==="//"?q?B:F.replace(R,"$1")+B:B.charAt(0)==="/"?q?B:F.replace(L,"$1")+B:F+B}var p={exec:function(){}};function N(F){for(var B=1,q,T;B<arguments.length;B++){q=arguments[B];for(T in q)Object.prototype.hasOwnProperty.call(q,T)&&(F[T]=q[T])}return F}function M(F,B){var q=F.replace(/\|/g,function(C,A,_){for(var K=!1,te=A;--te>=0&&_[te]==="\\";)K=!K;return K?"|":" |"}),T=q.split(/ \|/),z=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>B)T.splice(B);else for(;T.length<B;)T.push("");for(;z<T.length;z++)T[z]=T[z].trim().replace(/\\\|/g,"|");return T}function H(F,B,q){var T=F.length;if(T===0)return"";for(var z=0;z<T;){var C=F.charAt(T-z-1);if(C===B&&!q)z++;else if(C!==B&&q)z++;else break}return F.slice(0,T-z)}function j(F,B){if(F.indexOf(B[1])===-1)return-1;for(var q=F.length,T=0,z=0;z<q;z++)if(F[z]==="\\")z++;else if(F[z]===B[0])T++;else if(F[z]===B[1]&&(T--,T<0))return z;return-1}function W(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ee(F,B){if(B<1)return"";for(var q="";B>1;)B&1&&(q+=F),B>>=1,F+=F;return q+F}function ne(F,B,q,T){var z=B.href,C=B.title?e(B.title):null,A=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){T.state.inLink=!0;var _={type:"link",raw:q,href:z,title:C,text:A,tokens:T.inlineTokens(A)};return T.state.inLink=!1,_}return{type:"image",raw:q,href:z,title:C,text:e(A)}}function re(F,B){var q=F.match(/^(\s+)(?:```)/);if(q===null)return B;var T=q[1];return B.split(`
`).map(function(z){var C=z.match(/^\s+/);if(C===null)return z;var A=C[0];return A.length>=T.length?z.slice(T.length):z}).join(`
`)}var ce=function(){function F(q){this.options=q||oe.defaults}var B=F.prototype;return B.space=function(T){var z=this.rules.block.newline.exec(T);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},B.code=function(T){var z=this.rules.block.code.exec(T);if(z){var C=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?C:H(C,`
`)}}},B.fences=function(T){var z=this.rules.block.fences.exec(T);if(z){var C=z[0],A=re(C,z[3]||"");return{type:"code",raw:C,lang:z[2]?z[2].trim():z[2],text:A}}},B.heading=function(T){var z=this.rules.block.heading.exec(T);if(z){var C=z[2].trim();if(/#$/.test(C)){var A=H(C,"#");(this.options.pedantic||!A||/ $/.test(A))&&(C=A.trim())}return{type:"heading",raw:z[0],depth:z[1].length,text:C,tokens:this.lexer.inline(C)}}},B.hr=function(T){var z=this.rules.block.hr.exec(T);if(z)return{type:"hr",raw:z[0]}},B.blockquote=function(T){var z=this.rules.block.blockquote.exec(T);if(z){var C=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(C,[]),text:C}}},B.list=function(T){var z=this.rules.block.list.exec(T);if(z){var C,A,_,K,te,se,ge,pe,Ce,Ee,ve,Te,Fe=z[1].trim(),qe=Fe.length>1,je={type:"list",raw:"",ordered:qe,start:qe?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=qe?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=qe?Fe:"[*+-]");for(var Le=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Te=!1,!(!(z=Le.exec(T))||this.rules.block.hr.test(T)));){if(C=z[0],T=T.substring(C.length),pe=z[2].split(`
`,1)[0],Ce=T.split(`
`,1)[0],this.options.pedantic?(K=2,ve=pe.trimLeft()):(K=z[2].search(/[^ ]/),K=K>4?1:K,ve=pe.slice(K),K+=z[1].length),se=!1,!pe&&/^ *$/.test(Ce)&&(C+=Ce+`
`,T=T.substring(Ce.length+1),Te=!0),!Te)for(var Ge=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Q=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),le=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),be=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");T&&(Ee=T.split(`
`,1)[0],pe=Ee,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(le.test(pe)||be.test(pe)||Ge.test(pe)||Q.test(T)));){if(pe.search(/[^ ]/)>=K||!pe.trim())ve+=`
`+pe.slice(K);else if(!se)ve+=`
`+pe;else break;!se&&!pe.trim()&&(se=!0),C+=Ee+`
`,T=T.substring(Ee.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(C)&&(ge=!0)),this.options.gfm&&(A=/^\[[ xX]\] /.exec(ve),A&&(_=A[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:C,task:!!A,checked:_,loose:!1,text:ve}),je.raw+=C}je.items[je.items.length-1].raw=C.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,je.items[te].tokens=this.lexer.blockTokens(je.items[te].text,[]);var Ne=je.items[te].tokens.filter(function(ze){return ze.type==="space"}),Re=Ne.every(function(ze){for(var Qe=ze.raw.split(""),Ye=0,Ve=U(Qe),_e;!(_e=Ve()).done;){var et=_e.value;if(et===`
`&&(Ye+=1),Ye>1)return!0}return!1});!je.loose&&Ne.length&&Re&&(je.loose=!0,je.items[te].loose=!0)}return je}},B.html=function(T){var z=this.rules.block.html.exec(T);if(z){var C={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};if(this.options.sanitize){var A=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]);C.type="paragraph",C.text=A,C.tokens=this.lexer.inline(A)}return C}},B.def=function(T){var z=this.rules.block.def.exec(T);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var C=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:C,raw:z[0],href:z[2],title:z[3]}}},B.table=function(T){var z=this.rules.block.table.exec(T);if(z){var C={type:"table",header:M(z[1]).map(function(ge){return{text:ge}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(C.header.length===C.align.length){C.raw=z[0];var A=C.align.length,_,K,te,se;for(_=0;_<A;_++)/^ *-+: *$/.test(C.align[_])?C.align[_]="right":/^ *:-+: *$/.test(C.align[_])?C.align[_]="center":/^ *:-+ *$/.test(C.align[_])?C.align[_]="left":C.align[_]=null;for(A=C.rows.length,_=0;_<A;_++)C.rows[_]=M(C.rows[_],C.header.length).map(function(ge){return{text:ge}});for(A=C.header.length,K=0;K<A;K++)C.header[K].tokens=this.lexer.inline(C.header[K].text);for(A=C.rows.length,K=0;K<A;K++)for(se=C.rows[K],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return C}}},B.lheading=function(T){var z=this.rules.block.lheading.exec(T);if(z)return{type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:this.lexer.inline(z[1])}},B.paragraph=function(T){var z=this.rules.block.paragraph.exec(T);if(z){var C=z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1];return{type:"paragraph",raw:z[0],text:C,tokens:this.lexer.inline(C)}}},B.text=function(T){var z=this.rules.block.text.exec(T);if(z)return{type:"text",raw:z[0],text:z[0],tokens:this.lexer.inline(z[0])}},B.escape=function(T){var z=this.rules.inline.escape.exec(T);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},B.tag=function(T){var z=this.rules.inline.tag.exec(T);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},B.link=function(T){var z=this.rules.inline.link.exec(T);if(z){var C=z[2].trim();if(!this.options.pedantic&&/^</.test(C)){if(!/>$/.test(C))return;var A=H(C.slice(0,-1),"\\");if((C.length-A.length)%2===0)return}else{var _=j(z[2],"()");if(_>-1){var K=z[0].indexOf("!")===0?5:4,te=K+z[1].length+_;z[2]=z[2].substring(0,_),z[0]=z[0].substring(0,te).trim(),z[3]=""}}var se=z[2],ge="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);pe&&(se=pe[1],ge=pe[3])}else ge=z[3]?z[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(C)?se=se.slice(1):se=se.slice(1,-1)),ne(z,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},B.reflink=function(T,z){var C;if((C=this.rules.inline.reflink.exec(T))||(C=this.rules.inline.nolink.exec(T))){var A=(C[2]||C[1]).replace(/\s+/g," ");if(A=z[A.toLowerCase()],!A||!A.href){var _=C[0].charAt(0);return{type:"text",raw:_,text:_}}return ne(C,A,C[0],this.lexer)}},B.emStrong=function(T,z,C){C===void 0&&(C="");var A=this.rules.inline.emStrong.lDelim.exec(T);if(A&&!(A[3]&&C.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var _=A[1]||A[2]||"";if(!_||_&&(C===""||this.rules.inline.punctuation.exec(C))){var K=A[0].length-1,te,se,ge=K,pe=0,Ce=A[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ce.lastIndex=0,z=z.slice(-1*T.length+K);(A=Ce.exec(z))!=null;)if(te=A[1]||A[2]||A[3]||A[4]||A[5]||A[6],!!te){if(se=te.length,A[3]||A[4]){ge+=se;continue}else if((A[5]||A[6])&&K%3&&!((K+se)%3)){pe+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+pe),Math.min(K,se)%2){var Ee=T.slice(1,K+A.index+se);return{type:"em",raw:T.slice(0,K+A.index+se+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=T.slice(2,K+A.index+se-1);return{type:"strong",raw:T.slice(0,K+A.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},B.codespan=function(T){var z=this.rules.inline.code.exec(T);if(z){var C=z[2].replace(/\n/g," "),A=/[^ ]/.test(C),_=/^ /.test(C)&&/ $/.test(C);return A&&_&&(C=C.substring(1,C.length-1)),C=e(C,!0),{type:"codespan",raw:z[0],text:C}}},B.br=function(T){var z=this.rules.inline.br.exec(T);if(z)return{type:"br",raw:z[0]}},B.del=function(T){var z=this.rules.inline.del.exec(T);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2])}},B.autolink=function(T,z){var C=this.rules.inline.autolink.exec(T);if(C){var A,_;return C[2]==="@"?(A=e(this.options.mangle?z(C[1]):C[1]),_="mailto:"+A):(A=e(C[1]),_=A),{type:"link",raw:C[0],text:A,href:_,tokens:[{type:"text",raw:A,text:A}]}}},B.url=function(T,z){var C;if(C=this.rules.inline.url.exec(T)){var A,_;if(C[2]==="@")A=e(this.options.mangle?z(C[0]):C[0]),_="mailto:"+A;else{var K;do K=C[0],C[0]=this.rules.inline._backpedal.exec(C[0])[0];while(K!==C[0]);A=e(C[0]),C[1]==="www."?_="http://"+A:_=A}return{type:"link",raw:C[0],text:A,href:_,tokens:[{type:"text",raw:A,text:A}]}}},B.inlineText=function(T,z){var C=this.rules.inline.text.exec(T);if(C){var A;return this.lexer.state.inRawBlock?A=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(C[0]):e(C[0]):C[0]:A=e(this.options.smartypants?z(C[0]):C[0]),{type:"text",raw:C[0],text:A}}},F}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=n(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=n(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=n(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=n(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=n(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=n(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=N({},he),he.gfm=N({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=n(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=n(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=N({},he.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=n(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=n(he._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=n(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=n(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=n(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=n(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=n(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=n(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=n(ae.reflink).replace("label",ae._label).replace("ref",he._label).getRegex(),ae.nolink=n(ae.nolink).replace("ref",he._label).getRegex(),ae.reflinkSearch=n(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=N({},ae),ae.pedantic=N({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=N({},ae.normal,{escape:n(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=n(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=N({},ae.gfm,{br:n(ae.br).replace("{2,}","*").getRegex(),text:n(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function we(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Oe(F){var B="",q,T,z=F.length;for(q=0;q<z;q++)T=F.charCodeAt(q),Math.random()>.5&&(T="x"+T.toString(16)),B+="&#"+T+";";return B}var Ie=function(){function F(q){this.tokens=[],this.tokens.links=Object.create(null),this.options=q||oe.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:he.normal,inline:ae.normal};this.options.pedantic?(T.block=he.pedantic,T.inline=ae.pedantic):this.options.gfm&&(T.block=he.gfm,this.options.breaks?T.inline=ae.breaks:T.inline=ae.gfm),this.tokenizer.rules=T}F.lex=function(T,z){var C=new F(z);return C.lex(T)},F.lexInline=function(T,z){var C=new F(z);return C.inlineTokens(T)};var B=F.prototype;return B.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},B.blockTokens=function(T,z){var C=this;z===void 0&&(z=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(ge,pe,Ce){return pe+"    ".repeat(Ce.length)});for(var A,_,K,te;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(A=ge.call({lexer:C},T,z))?(T=T.substring(A.raw.length),z.push(A),!0):!1}))){if(A=this.tokenizer.space(T)){T=T.substring(A.raw.length),A.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(A);continue}if(A=this.tokenizer.code(T)){T=T.substring(A.raw.length),_=z[z.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+A.raw,_.text+=`
`+A.text,this.inlineQueue[this.inlineQueue.length-1].src=_.text):z.push(A);continue}if(A=this.tokenizer.fences(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.heading(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.hr(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.blockquote(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.list(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.html(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.def(T)){T=T.substring(A.raw.length),_=z[z.length-1],_&&(_.type==="paragraph"||_.type==="text")?(_.raw+=`
`+A.raw,_.text+=`
`+A.raw,this.inlineQueue[this.inlineQueue.length-1].src=_.text):this.tokens.links[A.tag]||(this.tokens.links[A.tag]={href:A.href,title:A.title});continue}if(A=this.tokenizer.table(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.lheading(T)){T=T.substring(A.raw.length),z.push(A);continue}if(K=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,pe=T.slice(1),Ce=void 0;C.options.extensions.startBlock.forEach(function(Ee){Ce=Ee.call({lexer:this},pe),typeof Ce=="number"&&Ce>=0&&(ge=Math.min(ge,Ce))}),ge<1/0&&ge>=0&&(K=T.substring(0,ge+1))}(),this.state.top&&(A=this.tokenizer.paragraph(K))){_=z[z.length-1],te&&_.type==="paragraph"?(_.raw+=`
`+A.raw,_.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):z.push(A),te=K.length!==T.length,T=T.substring(A.raw.length);continue}if(A=this.tokenizer.text(T)){T=T.substring(A.raw.length),_=z[z.length-1],_&&_.type==="text"?(_.raw+=`
`+A.raw,_.text+=`
`+A.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=_.text):z.push(A);continue}if(T){var se="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,z},B.inline=function(T,z){return z===void 0&&(z=[]),this.inlineQueue.push({src:T,tokens:z}),z},B.inlineTokens=function(T,z){var C=this;z===void 0&&(z=[]);var A,_,K,te=T,se,ge,pe;if(this.tokens.links){var Ce=Object.keys(this.tokens.links);if(Ce.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ce.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+ee("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+ee("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(ge||(pe=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(A=ve.call({lexer:C},T,z))?(T=T.substring(A.raw.length),z.push(A),!0):!1}))){if(A=this.tokenizer.escape(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.tag(T)){T=T.substring(A.raw.length),_=z[z.length-1],_&&A.type==="text"&&_.type==="text"?(_.raw+=A.raw,_.text+=A.text):z.push(A);continue}if(A=this.tokenizer.link(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(A.raw.length),_=z[z.length-1],_&&A.type==="text"&&_.type==="text"?(_.raw+=A.raw,_.text+=A.text):z.push(A);continue}if(A=this.tokenizer.emStrong(T,te,pe)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.codespan(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.br(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.del(T)){T=T.substring(A.raw.length),z.push(A);continue}if(A=this.tokenizer.autolink(T,Oe)){T=T.substring(A.raw.length),z.push(A);continue}if(!this.state.inLink&&(A=this.tokenizer.url(T,Oe))){T=T.substring(A.raw.length),z.push(A);continue}if(K=T,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Te=T.slice(1),Fe=void 0;C.options.extensions.startInline.forEach(function(qe){Fe=qe.call({lexer:this},Te),typeof Fe=="number"&&Fe>=0&&(ve=Math.min(ve,Fe))}),ve<1/0&&ve>=0&&(K=T.substring(0,ve+1))}(),A=this.tokenizer.inlineText(K,we)){T=T.substring(A.raw.length),A.raw.slice(-1)!=="_"&&(pe=A.raw.slice(-1)),ge=!0,_=z[z.length-1],_&&_.type==="text"?(_.raw+=A.raw,_.text+=A.text):z.push(A);continue}if(T){var Ee="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return z},y(F,null,[{key:"rules",get:function(){return{block:he,inline:ae}}}]),F}(),Me=function(){function F(q){this.options=q||oe.defaults}var B=F.prototype;return B.code=function(T,z,C){var A=(z||"").match(/\S*/)[0];if(this.options.highlight){var _=this.options.highlight(T,A);_!=null&&_!==T&&(C=!0,T=_)}return T=T.replace(/\n$/,"")+`
`,A?'<pre><code class="'+this.options.langPrefix+e(A,!0)+'">'+(C?T:e(T,!0))+`</code></pre>
`:"<pre><code>"+(C?T:e(T,!0))+`</code></pre>
`},B.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},B.html=function(T){return T},B.heading=function(T,z,C,A){if(this.options.headerIds){var _=this.options.headerPrefix+A.slug(C);return"<h"+z+' id="'+_+'">'+T+"</h"+z+`>
`}return"<h"+z+">"+T+"</h"+z+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(T,z,C){var A=z?"ol":"ul",_=z&&C!==1?' start="'+C+'"':"";return"<"+A+_+`>
`+T+"</"+A+`>
`},B.listitem=function(T){return"<li>"+T+`</li>
`},B.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(T){return"<p>"+T+`</p>
`},B.table=function(T,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+z+`</table>
`},B.tablerow=function(T){return`<tr>
`+T+`</tr>
`},B.tablecell=function(T,z){var C=z.header?"th":"td",A=z.align?"<"+C+' align="'+z.align+'">':"<"+C+">";return A+T+("</"+C+`>
`)},B.strong=function(T){return"<strong>"+T+"</strong>"},B.em=function(T){return"<em>"+T+"</em>"},B.codespan=function(T){return"<code>"+T+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(T){return"<del>"+T+"</del>"},B.link=function(T,z,C){if(T=$(this.options.sanitize,this.options.baseUrl,T),T===null)return C;var A='<a href="'+e(T)+'"';return z&&(A+=' title="'+z+'"'),A+=">"+C+"</a>",A},B.image=function(T,z,C){if(T=$(this.options.sanitize,this.options.baseUrl,T),T===null)return C;var A='<img src="'+T+'" alt="'+C+'"';return z&&(A+=' title="'+z+'"'),A+=this.options.xhtml?"/>":">",A},B.text=function(T){return T},F}(),fe=function(){function F(){}var B=F.prototype;return B.strong=function(T){return T},B.em=function(T){return T},B.codespan=function(T){return T},B.del=function(T){return T},B.html=function(T){return T},B.text=function(T){return T},B.link=function(T,z,C){return""+C},B.image=function(T,z,C){return""+C},B.br=function(){return""},F}(),ie=function(){function F(){this.seen={}}var B=F.prototype;return B.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(T,z){var C=T,A=0;if(this.seen.hasOwnProperty(C)){A=this.seen[T];do A++,C=T+"-"+A;while(this.seen.hasOwnProperty(C))}return z||(this.seen[T]=A,this.seen[C]=0),C},B.slug=function(T,z){z===void 0&&(z={});var C=this.serialize(T);return this.getNextSafeSlug(C,z.dryrun)},F}(),G=function(){function F(q){this.options=q||oe.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new ie}F.parse=function(T,z){var C=new F(z);return C.parse(T)},F.parseInline=function(T,z){var C=new F(z);return C.parseInline(T)};var B=F.prototype;return B.parse=function(T,z){z===void 0&&(z=!0);var C="",A,_,K,te,se,ge,pe,Ce,Ee,ve,Te,Fe,qe,je,Le,Ge,Q,le,be,De=T.length;for(A=0;A<De;A++){if(ve=T[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(be=this.options.extensions.renderers[ve.type].call({parser:this},ve),be!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){C+=be||"";continue}switch(ve.type){case"space":continue;case"hr":{C+=this.renderer.hr();continue}case"heading":{C+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,o(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{C+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ce="",pe="",te=ve.header.length,_=0;_<te;_++)pe+=this.renderer.tablecell(this.parseInline(ve.header[_].tokens),{header:!0,align:ve.align[_]});for(Ce+=this.renderer.tablerow(pe),Ee="",te=ve.rows.length,_=0;_<te;_++){for(ge=ve.rows[_],pe="",se=ge.length,K=0;K<se;K++)pe+=this.renderer.tablecell(this.parseInline(ge[K].tokens),{header:!1,align:ve.align[K]});Ee+=this.renderer.tablerow(pe)}C+=this.renderer.table(Ce,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),C+=this.renderer.blockquote(Ee);continue}case"list":{for(Te=ve.ordered,Fe=ve.start,qe=ve.loose,te=ve.items.length,Ee="",_=0;_<te;_++)Le=ve.items[_],Ge=Le.checked,Q=Le.task,je="",Le.task&&(le=this.renderer.checkbox(Ge),qe?Le.tokens.length>0&&Le.tokens[0].type==="paragraph"?(Le.tokens[0].text=le+" "+Le.tokens[0].text,Le.tokens[0].tokens&&Le.tokens[0].tokens.length>0&&Le.tokens[0].tokens[0].type==="text"&&(Le.tokens[0].tokens[0].text=le+" "+Le.tokens[0].tokens[0].text)):Le.tokens.unshift({type:"text",text:le}):je+=le),je+=this.parse(Le.tokens,qe),Ee+=this.renderer.listitem(je,Q,Ge);C+=this.renderer.list(Ee,Te,Fe);continue}case"html":{C+=this.renderer.html(ve.text);continue}case"paragraph":{C+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;A+1<De&&T[A+1].type==="text";)ve=T[++A],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);C+=z?this.renderer.paragraph(Ee):Ee;continue}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return C},B.parseInline=function(T,z){z=z||this.renderer;var C="",A,_,K,te=T.length;for(A=0;A<te;A++){if(_=T[A],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(K=this.options.extensions.renderers[_.type].call({parser:this},_),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(_.type))){C+=K||"";continue}switch(_.type){case"escape":{C+=z.text(_.text);break}case"html":{C+=z.html(_.text);break}case"link":{C+=z.link(_.href,_.title,this.parseInline(_.tokens,z));break}case"image":{C+=z.image(_.href,_.title,_.text);break}case"strong":{C+=z.strong(this.parseInline(_.tokens,z));break}case"em":{C+=z.em(this.parseInline(_.tokens,z));break}case"codespan":{C+=z.codespan(_.text);break}case"br":{C+=z.br();break}case"del":{C+=z.del(this.parseInline(_.tokens,z));break}case"text":{C+=z.text(_.text);break}default:{var se='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return C},F}();function x(F,B,q){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof B=="function"&&(q=B,B=null),B=N({},x.defaults,B||{}),W(B),q){var T=B.highlight,z;try{z=Ie.lex(F,B)}catch(te){return q(te)}var C=function(se){var ge;if(!se)try{B.walkTokens&&x.walkTokens(z,B.walkTokens),ge=G.parse(z,B)}catch(pe){se=pe}return B.highlight=T,se?q(se):q(null,ge)};if(!T||T.length<3||(delete B.highlight,!z.length))return C();var A=0;x.walkTokens(z,function(te){te.type==="code"&&(A++,setTimeout(function(){T(te.text,te.lang,function(se,ge){if(se)return C(se);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),A--,A===0&&C()})},0))}),A===0&&C();return}function _(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var K=Ie.lex(F,B);if(B.walkTokens){if(B.async)return Promise.all(x.walkTokens(K,B.walkTokens)).then(function(){return G.parse(K,B)}).catch(_);x.walkTokens(K,B.walkTokens)}return G.parse(K,B)}catch(te){_(te)}}x.options=x.setOptions=function(F){return N(x.defaults,F),v(x.defaults),x},x.getDefaults=D,x.defaults=oe.defaults,x.use=function(){for(var F=arguments.length,B=new Array(F),q=0;q<F;q++)B[q]=arguments[q];var T=N.apply(void 0,[{}].concat(B)),z=x.defaults.extensions||{renderers:{},childTokens:{}},C;B.forEach(function(A){if(A.extensions&&(C=!0,A.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var te=z.renderers?z.renderers[K.name]:null;te?z.renderers[K.name]=function(){for(var se=arguments.length,ge=new Array(se),pe=0;pe<se;pe++)ge[pe]=arguments[pe];var Ce=K.renderer.apply(this,ge);return Ce===!1&&(Ce=te.apply(this,ge)),Ce}:z.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[K.level]?z[K.level].unshift(K.tokenizer):z[K.level]=[K.tokenizer],K.start&&(K.level==="block"?z.startBlock?z.startBlock.push(K.start):z.startBlock=[K.start]:K.level==="inline"&&(z.startInline?z.startInline.push(K.start):z.startInline=[K.start]))}K.childTokens&&(z.childTokens[K.name]=K.childTokens)})),A.renderer&&function(){var K=x.defaults.renderer||new Me,te=function(pe){var Ce=K[pe];K[pe]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Fe=A.renderer[pe].apply(K,ve);return Fe===!1&&(Fe=Ce.apply(K,ve)),Fe}};for(var se in A.renderer)te(se);T.renderer=K}(),A.tokenizer&&function(){var K=x.defaults.tokenizer||new ce,te=function(pe){var Ce=K[pe];K[pe]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Te=0;Te<Ee;Te++)ve[Te]=arguments[Te];var Fe=A.tokenizer[pe].apply(K,ve);return Fe===!1&&(Fe=Ce.apply(K,ve)),Fe}};for(var se in A.tokenizer)te(se);T.tokenizer=K}(),A.walkTokens){var _=x.defaults.walkTokens;T.walkTokens=function(K){var te=[];return te.push(A.walkTokens.call(this,K)),_&&(te=te.concat(_.call(this,K))),te}}C&&(T.extensions=z),x.setOptions(T)})},x.walkTokens=function(F,B){for(var q=[],T=function(){var _=C.value;switch(q=q.concat(B.call(x,_)),_.type){case"table":{for(var K=U(_.header),te;!(te=K()).done;){var se=te.value;q=q.concat(x.walkTokens(se.tokens,B))}for(var ge=U(_.rows),pe;!(pe=ge()).done;)for(var Ce=pe.value,Ee=U(Ce),ve;!(ve=Ee()).done;){var Te=ve.value;q=q.concat(x.walkTokens(Te.tokens,B))}break}case"list":{q=q.concat(x.walkTokens(_.items,B));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[_.type]?x.defaults.extensions.childTokens[_.type].forEach(function(Fe){q=q.concat(x.walkTokens(_[Fe],B))}):_.tokens&&(q=q.concat(x.walkTokens(_.tokens,B)))}},z=U(F),C;!(C=z()).done;)T();return q},x.parseInline=function(F,B){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");B=N({},x.defaults,B||{}),W(B);try{var q=Ie.lexInline(F,B);return B.walkTokens&&x.walkTokens(q,B.walkTokens),G.parseInline(q,B)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}},x.Parser=G,x.parser=G.parse,x.Renderer=Me,x.TextRenderer=fe,x.Lexer=Ie,x.lexer=Ie.lex,x.Tokenizer=ce,x.Slugger=ie,x.parse=x;var J=x.options,X=x.setOptions,k=x.use,V=x.walkTokens,d=x.parseInline,w=x,E=G.parse,I=Ie.lex;oe.Lexer=Ie,oe.Parser=G,oe.Renderer=Me,oe.Slugger=ie,oe.TextRenderer=fe,oe.Tokenizer=ce,oe.getDefaults=D,oe.lexer=I,oe.marked=x,oe.options=J,oe.parse=w,oe.parseInline=d,oe.parser=E,oe.setOptions=X,oe.use=k,oe.walkTokens=V,Object.defineProperty(oe,"__esModule",{value:!0})}),define(me[78],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=void 0;class y{constructor(i,U=0,D=i.length,v=U-1){this.a=i,this.b=U,this.c=D,this.d=v}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$fR=y}),define(me[79],$e([1,0,78]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=void 0;class S{constructor(D=[],v=10){this.h(D),this.b=v,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new y.$fR(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const v of D)this.a.add(v)}get j(){const D=[];return this.a.forEach(v=>D.push(v)),D}}t.$gR=S;class i{constructor(D,v=10){if(this.g=v,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let l=1;l<D.length;l++)this.add(D[l])}add(D){const v={value:D,previous:this.c,next:void 0};for(this.c.next=v,this.c=v,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const v=this.c.value;return this.a.delete(v),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),v}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let v=this.b;for(;v!==this.c;)v.value===D&&(v===this.b?(this.b=this.b.next,this.b.previous=void 0):(v.previous.next=v.next,v.next.previous=v.previous),this.f--),v=v.next}}t.$hR=i}),define(me[44],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jl=t.$Il=t.$Hl=t.rot=t.$Fl=void 0;function y(v,l,u){return Math.min(Math.max(v,l),u)}t.$Fl=y;function S(v,l){return(l+v%l)%l}t.rot=S;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Hl=i;class U{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Il=U;class D{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const u=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Jl=D}),define(me[45],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(S){function i(l,u){if(l.start>=u.end||u.start>=l.end)return{start:0,end:0};const f=Math.max(l.start,u.start),P=Math.min(l.end,u.end);return P-f<=0?{start:0,end:0}:{start:f,end:P}}S.intersect=i;function U(l){return l.end-l.start<=0}S.isEmpty=U;function D(l,u){return!U(i(l,u))}S.intersects=D;function v(l,u){const f=[],P={start:l.start,end:Math.min(u.start,l.end)},r={start:Math.max(u.end,l.start),end:l.end};return U(P)||f.push(P),U(r)||f.push(r),f}S.relativeComplement=v})(y||(t.Range=y={}))}),define(me[80],$e([1,0,45]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$P=t.$0P=t.$9P=t.$8P=void 0;function S(l,u){const f=[];for(const P of u){if(l.start>=P.range.end)continue;if(l.end<P.range.start)break;const r=y.Range.intersect(l,P.range);y.Range.isEmpty(r)||f.push({range:r,size:P.size})}return f}t.$8P=S;function i({start:l,end:u},f){return{start:l+f,end:u+f}}t.$9P=i;function U(l){const u=[];let f=null;for(const P of l){const r=P.range.start,h=P.range.end,e=P.size;if(f&&e===f.size){f.range.end=h;continue}f={range:{start:r,end:h},size:e},u.push(f)}return u}t.$0P=U;function D(...l){return U(l.reduce((u,f)=>u.concat(f),[]))}class v{get paddingTop(){return this.c}set paddingTop(u){this.b=this.b+u-this.c,this.c=u}constructor(u){this.a=[],this.b=0,this.c=0,this.c=u??0,this.b=this.c}splice(u,f,P=[]){const r=P.length-f,h=S({start:0,end:u},this.a),e=S({start:u+f,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:i(o.range,r),size:o.size})),a=P.map((o,s)=>({range:{start:u+s,end:u+s+1},size:o.size}));this.a=D(h,a,e),this.b=this.c+this.a.reduce((o,s)=>o+s.size*(s.range.end-s.range.start),0)}get count(){const u=this.a.length;return u?this.a[u-1].range.end:0}get size(){return this.b}indexAt(u){if(u<0)return-1;if(u<this.c)return 0;let f=0,P=this.c;for(const r of this.a){const h=r.range.end-r.range.start,e=P+h*r.size;if(u<e)return f+Math.floor((u-P)/r.size);f+=h,P=e}return f}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let f=0,P=0;for(const r of this.a){const h=r.range.end-r.range.start,e=P+h;if(u<e)return this.c+f+(u-P)*r.size;f+=h*r.size,P=e}return-1}}t.$$P=v}),define(me[81],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class S{static create(U){return new S(U)}constructor(U){this.c=y&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$dc=S}),define(me[3],$e([1,0,6,41,2,43,81]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.Event=void 0;const v=!1,l=!1;var u;(function(H){H.None=()=>i.$mb.None;function j(z){if(l){const{onDidAddListener:C}=z,A=e.create();let _=0;z.onDidAddListener=()=>{++_===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),A.print()),C?.()}}}function W(z,C){return Me(z,()=>{},0,void 0,!0,void 0,C)}H.defer=W;function ee(z){return(C,A=null,_)=>{let K=!1,te;return te=z(se=>{if(!K)return te?te.dispose():K=!0,C.call(A,se)},null,_),K&&te.dispose(),te}}H.once=ee;function ne(z,C,A){return Oe((_,K=null,te)=>z(se=>_.call(K,C(se)),null,te),A)}H.map=ne;function re(z,C,A){return Oe((_,K=null,te)=>z(se=>{C(se),_.call(K,se)},null,te),A)}H.forEach=re;function ce(z,C,A){return Oe((_,K=null,te)=>z(se=>C(se)&&_.call(K,se),null,te),A)}H.filter=ce;function he(z){return z}H.signal=he;function ae(...z){return(C,A=null,_)=>{const K=(0,i.$jb)(...z.map(te=>te(se=>C.call(A,se))));return Ie(K,_)}}H.any=ae;function we(z,C,A,_){let K=A;return ne(z,te=>(K=C(K,te),K),_)}H.reduce=we;function Oe(z,C){let A;const _={onWillAddFirstListener(){A=z(K.fire,K)},onDidRemoveLastListener(){A?.dispose()}};C||j(_);const K=new g(_);return C?.add(K),K.event}function Ie(z,C){return C instanceof Array?C.push(z):C&&C.add(z),z}function Me(z,C,A=100,_=!1,K=!1,te,se){let ge,pe,Ce,Ee=0,ve;const Te={leakWarningThreshold:te,onWillAddFirstListener(){ge=z(qe=>{Ee++,pe=C(pe,qe),_&&!Ce&&(Fe.fire(pe),pe=void 0),ve=()=>{const je=pe;pe=void 0,Ce=void 0,(!_||Ee>1)&&Fe.fire(je),Ee=0},typeof A=="number"?(clearTimeout(Ce),Ce=setTimeout(ve,A)):Ce===void 0&&(Ce=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&Ee>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ge.dispose()}};se||j(Te);const Fe=new g(Te);return se?.add(Fe),Fe.event}H.debounce=Me;function fe(z,C=0,A){return H.debounce(z,(_,K)=>_?(_.push(K),_):[K],C,void 0,!0,void 0,A)}H.accumulate=fe;function ie(z,C=(_,K)=>_===K,A){let _=!0,K;return ce(z,te=>{const se=_||!C(te,K);return _=!1,K=te,se},A)}H.latch=ie;function G(z,C,A){return[H.filter(z,C,A),H.filter(z,_=>!C(_),A)]}H.split=G;function x(z,C=!1,A=[],_){let K=A.slice(),te=z(pe=>{K?K.push(pe):ge.fire(pe)});_&&_.add(te);const se=()=>{K?.forEach(pe=>ge.fire(pe)),K=null},ge=new g({onWillAddFirstListener(){te||(te=z(pe=>ge.fire(pe)),_&&_.add(te))},onDidAddFirstListener(){K&&(C?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return _&&_.add(ge),ge.event}H.buffer=x;function J(z,C){return(_,K,te)=>{const se=C(new k);return z(function(ge){const pe=se.evaluate(ge);pe!==X&&_.call(K,pe)},void 0,te)}}H.chain=J;const X=Symbol("HaltChainable");class k{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(A=>(C(A),A)),this}filter(C){return this.f.push(A=>C(A)?A:X),this}reduce(C,A){let _=A;return this.f.push(K=>(_=C(_,K),_)),this}latch(C=(A,_)=>A===_){let A=!0,_;return this.f.push(K=>{const te=A||!C(K,_);return A=!1,_=K,te?K:X}),this}evaluate(C){for(const A of this.f)if(C=A(C),C===X)break;return C}}function V(z,C,A=_=>_){const _=(...ge)=>se.fire(A(...ge)),K=()=>z.on(C,_),te=()=>z.removeListener(C,_),se=new g({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}H.fromNodeEventEmitter=V;function d(z,C,A=_=>_){const _=(...ge)=>se.fire(A(...ge)),K=()=>z.addEventListener(C,_),te=()=>z.removeEventListener(C,_),se=new g({onWillAddFirstListener:K,onDidRemoveLastListener:te});return se.event}H.fromDOMEventEmitter=d;function w(z){return new Promise(C=>ee(z)(C))}H.toPromise=w;function E(z){const C=new g;return z.then(A=>{C.fire(A)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}H.fromPromise=E;function I(z,C){return C(void 0),z(A=>C(A))}H.runAndSubscribe=I;function F(z,C){let A=null;function _(te){A?.dispose(),A=new i.$lb,C(te,A)}_(void 0);const K=z(te=>_(te));return(0,i.$kb)(()=>{K.dispose(),A?.dispose()})}H.runAndSubscribeWithStore=F;class B{constructor(C,A){this._observable=C,this.f=0,this.g=!1;const _={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};A||j(_),this.emitter=new g(_),A&&A.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,A){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(z,C){return new B(z,C).emitter.event}H.fromObservable=q;function T(z){return C=>{let A=0,_=!1;const K={beginUpdate(){A++},endUpdate(){A--,A===0&&(z.reportChanges(),_&&(_=!1,C()))},handlePossibleChange(){},handleChange(){_=!0}};return z.addObserver(K),z.reportChanges(),{dispose(){z.removeObserver(K)}}}}H.fromObservableLight=T})(u||(t.Event=u={}));class f{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${f.f++}`,f.all.add(this)}start(j){this.g=new D.$dc,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}t.$fc=f;let P=-1;function r(H){const j=P;return P=H,{dispose(){P=j}}}t.$gc=r;class h{constructor(j,W=Math.random().toString(18).slice(2,5)){this.threshold=j,this.name=W,this.g=0}dispose(){this.f?.clear()}check(j,W){const ee=this.threshold;if(ee<=0||W<ee)return;this.f||(this.f=new Map);const ne=this.f.get(j.value)||0;if(this.f.set(j.value,ne+1),this.g-=1,this.g<=0){this.g=ee*.5;let re,ce=0;for(const[he,ae]of this.f)(!re||ce<ae)&&(re=he,ce=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${W} listeners already. MOST frequent listener (${ce}):`),console.warn(re)}return()=>{const re=this.f.get(j.value)||0;this.f.set(j.value,re-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class o{constructor(j){this.value=j,this.id=a++}}const s=2,n=(H,j)=>{if(H instanceof o)j(H);else for(let W=0;W<H.length;W++){const ee=H[W];ee&&j(ee)}};class g{constructor(j){this.w=0,this.f=j,this.g=P>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const j=this.t;queueMicrotask(()=>{n(j,W=>W.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,W,ee)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$mb.None;if(this.m)return i.$mb.None;W&&(j=j.bind(W));const ne=new o(j);let re,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ne.stack=e.create(),re=this.g.check(ne.stack,this.w+1)),v&&(ne.stack=ce??e.create()),this.t?this.t instanceof o?(this.u??=new $,this.t=[this.t,ne]):this.t.push(ne):(this.f?.onWillAddFirstListener?.(this),this.t=ne,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,i.$kb)(()=>{re?.(),this.x(ne)});return ee instanceof i.$lb?ee.add(he):Array.isArray(ee)&&ee.push(he),he},this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const W=this.t,ee=W.indexOf(j);if(ee===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,W[ee]=void 0;const ne=this.u.current===this;if(this.w*s<=W.length){let re=0;for(let ce=0;ce<W.length;ce++)W[ce]?W[re++]=W[ce]:ne&&(this.u.end--,re<this.u.i&&this.u.i--);W.length=re}}y(j,W){if(!j)return;const ee=this.f?.onListenerError||y.$Y;if(!ee){j.value(W);return}try{j.value(W)}catch(ne){ee(ne)}}z(j){const W=j.current.t;for(;j.i<j.end;)this.y(W[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,j);else{const W=this.u;W.enqueue(this,j,this.t.length),this.z(W)}this.j?.stop()}hasListeners(){return this.w>0}}t.$hc=g;const b=()=>new $;t.$ic=b;class ${constructor(){this.i=-1,this.end=0}enqueue(j,W,ee){this.i=0,this.end=ee,this.current=j,this.value=W}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class c extends g{async fireAsync(j,W,ee){if(this.t)for(this.h||(this.h=new U.$vb),n(this.t,ne=>this.h.push([ne.value,j]));this.h.size>0&&!W.isCancellationRequested;){const[ne,re]=this.h.shift(),ce=[],he={...re,token:W,waitUntil:ae=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");ee&&(ae=ee(ae,ne)),ce.push(ae)}};try{ne(he)}catch(ae){(0,y.$Y)(ae);continue}Object.freeze(ce),await Promise.allSettled(ce).then(ae=>{for(const we of ae)we.status==="rejected"&&(0,y.$Y)(we.reason)})}}}t.$jc=c;class O extends g{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new U.$vb,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}t.$kc=O;class R extends O{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}t.$lc=R;class L extends g{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(W=>super.fire(W)),this.h=[]}))}}t.$mc=L;class m{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const W={event:j,listener:null};this.h.push(W),this.g&&this.m(W);const ee=()=>{this.g&&this.o(W);const ne=this.h.indexOf(W);this.h.splice(ne,1)};return(0,i.$kb)((0,S.$bb)(ee))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(W=>this.f.fire(W))}o(j){j.listener&&j.listener.dispose(),j.listener=null}dispose(){this.f.dispose()}}t.$nc=m;class p{constructor(j,W,ee,ne){this.f=new i.$lb;const re=this.f.add(new m),ce=this.f.add(new i.$ub);function he(ae){ce.set(ae,re.add(ne(ae)))}for(const ae of j)he(ae);this.f.add(W(ae=>{he(ae)})),this.f.add(ee(ae=>{ce.deleteAndDispose(ae)})),this.event=re.event}dispose(){this.f.dispose()}}t.$oc=p;class N{constructor(){this.f=[]}wrapEvent(j){return(W,ee,ne)=>j(re=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>W.call(ee,re)):W.call(ee,re)},void 0,ne)}bufferEvents(j){const W=[];this.f.push(W);const ee=j();return this.f.pop(),W.forEach(ne=>ne()),ee}}t.$pc=N;class M{constructor(){this.f=!1,this.g=u.None,this.h=i.$mb.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$qc=M}),define(me[16],$e([1,0,3,2]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6N=t.$5N=t.$4N=t.$3N=t.$2N=t.$1N=t.$ZN=t.$YN=t.$XN=t.$WN=t.$VN=t.$UN=t.$TN=t.$SN=t.$RN=t.$QN=t.$PN=t.$ON=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$hc,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(b){this.a!==b&&(this.a=b)}getZoomFactor(){return this.b}setZoomFactor(b){this.b=b}setFullscreen(b){this.c!==b&&(this.c=b,this.d.fire())}isFullscreen(){return this.c}}class U extends S.$mb{constructor(){super(),this.a=this.B(new y.$hc),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(b){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),b&&this.a.fire()}}class D extends S.$mb{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$hc),this.onDidChange=this.a.event,this.b=this.c();const b=this.B(new U);this.B(b.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const b=document.createElement("canvas").getContext("2d"),$=window.devicePixelRatio||1,c=b.webkitBackingStorePixelRatio||b.mozBackingStorePixelRatio||b.msBackingStorePixelRatio||b.oBackingStorePixelRatio||b.backingStorePixelRatio||1;return $/c}}class v{constructor(){this.a=null}b(){return this.a||(this.a=(0,S.$fb)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function l(g,b){typeof g=="string"&&(g=window.matchMedia(g)),g.addEventListener("change",b)}t.$ON=l,t.$PN=new v;function u(g){i.INSTANCE.setZoomLevel(g)}t.$QN=u;function f(){return i.INSTANCE.getZoomLevel()}t.$RN=f;function P(){return i.INSTANCE.getZoomFactor()}t.$SN=P;function r(g){i.INSTANCE.setZoomFactor(g)}t.$TN=r;function h(g){i.INSTANCE.setFullscreen(g)}t.$UN=h;function e(){return i.INSTANCE.isFullscreen()}t.$VN=e,t.$WN=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$XN=a.indexOf("Firefox")>=0,t.$YN=a.indexOf("AppleWebKit")>=0,t.$ZN=a.indexOf("Chrome")>=0,t.$1N=!t.$ZN&&a.indexOf("Safari")>=0,t.$2N=!t.$ZN&&!t.$1N&&t.$YN,t.$3N=a.indexOf("Electron/")>=0,t.$4N=a.indexOf("Android")>=0;let o=!1;if(window.matchMedia){const g=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),b=window.matchMedia("(display-mode: fullscreen)");o=g.matches,l(g,({matches:$})=>{o&&b.matches||(o=$)})}function s(){return o}t.$5N=s;function n(){return navigator?.windowControlsOverlay?.visible}t.$6N=n}),define(me[21],$e([1,0,3]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZP=void 0;class S{get event(){return this.a.event}constructor(U,D,v){const l=u=>this.a.fire(u);this.a=new y.$hc({onWillAddFirstListener:()=>U.addEventListener(D,l,v),onDidRemoveLastListener:()=>U.removeEventListener(D,l,v)})}dispose(){this.a.dispose()}}t.$ZP=S}),define(me[27],$e([1,0,3]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rc=t.CancellationToken=void 0;const S=Object.freeze(function(v,l){const u=setTimeout(v.bind(l),0);return{dispose(){clearTimeout(u)}}});var i;(function(v){function l(u){return u===v.None||u===v.Cancelled||u instanceof U?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}v.isCancellationToken=l,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?S:(this.b||(this.b=new y.$hc),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$rc=D}),define(me[82],$e([1,0,27]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ld=t.$kd=t.$jd=void 0;class S{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new y.$rc,l=this.b(v.token);return this.a={promise:l,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}t.$jd=S;class i{constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const l=JSON.stringify(v);return this.b!==l&&(this.b=l,this.a=this.c(v)),this.a}}t.$kd=i;class U{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const l=this.b(v);return this.a.set(v,l),l}}t.$ld=U}),define(me[46],$e([1,0,3,2]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mr=t.$Lr=t.$Kr=t.$Jr=t.ScrollbarVisibility=void 0;var i;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,a,o,s,n,g,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,o=o|0,s=s|0,n=n|0,g=g|0,b=b|0),this.rawScrollLeft=s,this.rawScrollTop=b,a<0&&(a=0),s+a>o&&(s=o-a),s<0&&(s=0),n<0&&(n=0),b+n>g&&(b=g-n),b<0&&(b=0),this.width=a,this.scrollWidth=o,this.scrollLeft=s,this.height=n,this.scrollHeight=g,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const o=this.width!==e.width,s=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,g=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,$=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:s,scrollLeftChanged:n,heightChanged:g,scrollHeightChanged:b,scrollTopChanged:$}}}t.$Jr=U;class D extends S.$mb{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new y.$hc),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const o=this.g.withScrollDimensions(e,a);this.k(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let s;a?s=new f(this.h.from,o,this.h.startTime,this.h.duration):s=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=s}else{const o=this.g.withScrollPosition(e);this.h=f.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}hasPendingScrollAnimation(){return!!this.h}j(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.k(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}}k(e,a){const o=this.g;o.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(o,a)))}}t.$Kr=D;class v{constructor(e,a,o){this.scrollLeft=e,this.scrollTop=a,this.isDone=o}}t.$Lr=v;function l(h,e){const a=e-h;return function(o){return h+a*r(o)}}function u(h,e,a){return function(o){return o<a?h(o/a):e((o-a)/(1-a))}}class f{constructor(e,a,o,s){this.from=e,this.to=a,this.duration=s,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,o){if(Math.abs(e-a)>2.5*o){let n,g;return e<a?(n=e+.75*o,g=a-.75*o):(n=e-.75*o,g=a+.75*o),u(l(e,n),l(g,a),.33)}return l(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const o=this.c(a),s=this.d(a);return new v(o,s,!1)}return new v(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,o){return f.start(e,a,o)}static start(e,a,o){o=o+10;const s=Date.now()-10;return new f(e,a,s,o)}}t.$Mr=f;function P(h){return Math.pow(h,3)}function r(h){return 1-P(1-h)}}),define(me[83],$e([1,0,6,2]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=t.$vc=t.$uc=t.$tc=t.$sc=void 0;function i(b){const $=b;return $?typeof $.read=="function":!1}t.$sc=i;function U(b){const $=b;return $?[$.on,$.pause,$.resume,$.destroy].every(c=>typeof c=="function"):!1}t.$tc=U;function D(b){const $=b;return $?U($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}t.$uc=D;function v(b,$){return new l(b,$)}t.$vc=v;class l{constructor($,c){this.e=$,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(c=>c($))}h($){this.c.error.length===0?(0,y.$Y)($):this.c.error.slice(0).forEach(c=>c($))}i(){this.c.end.slice(0).forEach($=>$())}on($,c){if(!this.a.destroyed)switch($){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener($,c){if(this.a.destroyed)return;let O;switch($){case"data":O=this.c.data;break;case"end":O=this.c.end;break;case"error":O=this.c.error;break}if(O){const R=O.indexOf(c);R>=0&&O.splice(R,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(O=>O())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(b,$){const c=[];let O;for(;(O=b.read())!==null;)c.push(O);return $(c)}t.$wc=u;function f(b,$,c){const O=[];let R;for(;(R=b.read())!==null&&O.length<c;)O.push(R);return R===null&&O.length>0?$(O):{read:()=>{if(O.length>0)return O.shift();if(typeof R<"u"){const L=R;return R=void 0,L}return b.read()}}}t.$xc=f;function P(b,$){return new Promise((c,O)=>{const R=[];r(b,{onData:L=>{$&&R.push(L)},onError:L=>{$?O(L):c(void 0)},onEnd:()=>{c($?$(R):void 0)}})})}t.$yc=P;function r(b,$,c){b.on("error",O=>{c?.isCancellationRequested||$.onError(O)}),b.on("end",()=>{c?.isCancellationRequested||$.onEnd()}),b.on("data",O=>{c?.isCancellationRequested||$.onData(O)})}t.$zc=r;function h(b,$){return new Promise((c,O)=>{const R=new S.$lb,L=[],m=M=>{if(L.push(M),L.length>$)return R.dispose(),b.pause(),c({stream:b,buffer:L,ended:!1})},p=M=>(R.dispose(),O(M)),N=()=>(R.dispose(),c({stream:b,buffer:L,ended:!0}));R.add((0,S.$kb)(()=>b.removeListener("error",p))),b.on("error",p),R.add((0,S.$kb)(()=>b.removeListener("end",N))),b.on("end",N),R.add((0,S.$kb)(()=>b.removeListener("data",m))),b.on("data",m)})}t.$Ac=h;function e(b,$){const c=v($);return c.end(b),c}t.$Bc=e;function a(){const b=v(()=>{throw new Error("not supported")});return b.end(),b}t.$Cc=a;function o(b){let $=!1;return{read:()=>$?null:($=!0,b)}}t.$Dc=o;function s(b,$,c){const O=v(c);return r(b,{onData:R=>O.write($.data(R)),onError:R=>O.error($.error?$.error(R):R),onEnd:()=>O.end()}),O}t.$Ec=s;function n(b,$,c){let O=!1;return{read:()=>{const R=$.read();return O?R:(O=!0,R!==null?c([b,R]):b)}}}t.$Fc=n;function g(b,$,c){let O=!1;const R=v(c);return r($,{onData:L=>O?R.write(L):(O=!0,R.write(c([b,L]))),onError:L=>R.error(L),onEnd:()=>{O||(O=!0,R.write(b)),R.end()}}),R}t.$Gc=g}),define(me[31],$e([1,0,30,83]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const i=typeof Buffer<"u",U=new y.$T(()=>new Uint8Array(256));let D,v;class l{static alloc(W){return i?new l(Buffer.allocUnsafe(W)):new l(new Uint8Array(W))}static wrap(W){return i&&!Buffer.isBuffer(W)&&(W=Buffer.from(W.buffer,W.byteOffset,W.byteLength)),new l(W)}static fromString(W,ee){return!(ee?.dontUseNodeBuffer||!1)&&i?new l(Buffer.from(W)):(D||(D=new TextEncoder),new l(D.encode(W)))}static fromByteArray(W){const ee=l.alloc(W.length);for(let ne=0,re=W.length;ne<re;ne++)ee.buffer[ne]=W[ne];return ee}static concat(W,ee){if(typeof ee>"u"){ee=0;for(let ce=0,he=W.length;ce<he;ce++)ee+=W[ce].byteLength}const ne=l.alloc(ee);let re=0;for(let ce=0,he=W.length;ce<he;ce++){const ae=W[ce];ne.set(ae,re),re+=ae.byteLength}return ne}constructor(W){this.buffer=W,this.byteLength=this.buffer.byteLength}clone(){const W=l.alloc(this.byteLength);return W.set(this),W}toString(){return i?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(W,ee){return new l(this.buffer.subarray(W,ee))}set(W,ee){if(W instanceof l)this.buffer.set(W.buffer,ee);else if(W instanceof Uint8Array)this.buffer.set(W,ee);else if(W instanceof ArrayBuffer)this.buffer.set(new Uint8Array(W),ee);else if(ArrayBuffer.isView(W))this.buffer.set(new Uint8Array(W.buffer,W.byteOffset,W.byteLength),ee);else throw new Error("Unknown argument 'array'")}readUInt32BE(W){return r(this.buffer,W)}writeUInt32BE(W,ee){h(this.buffer,W,ee)}readUInt32LE(W){return e(this.buffer,W)}writeUInt32LE(W,ee){a(this.buffer,W,ee)}readUInt8(W){return o(this.buffer,W)}writeUInt8(W,ee){s(this.buffer,W,ee)}indexOf(W,ee=0){return u(this.buffer,W instanceof l?W.buffer:W,ee)}}t.$Hc=l;function u(j,W,ee=0){const ne=W.byteLength,re=j.byteLength;if(ne===0)return 0;if(ne===1)return j.indexOf(W[0]);if(ne>re-ee)return-1;const ce=U.value;ce.fill(W.length);for(let Oe=0;Oe<W.length;Oe++)ce[W[Oe]]=W.length-Oe-1;let he=ee+W.length-1,ae=he,we=-1;for(;he<re;)if(j[he]===W[ae]){if(ae===0){we=he;break}he--,ae--}else he+=Math.max(W.length-ae,ce[j[he]]),ae=W.length-1;return we}t.$Ic=u;function f(j,W){return j[W+0]<<0>>>0|j[W+1]<<8>>>0}t.$Jc=f;function P(j,W,ee){j[ee+0]=W&255,W=W>>>8,j[ee+1]=W&255}t.$Kc=P;function r(j,W){return j[W]*2**24+j[W+1]*2**16+j[W+2]*2**8+j[W+3]}t.$Lc=r;function h(j,W,ee){j[ee+3]=W,W=W>>>8,j[ee+2]=W,W=W>>>8,j[ee+1]=W,W=W>>>8,j[ee]=W}t.$Mc=h;function e(j,W){return j[W+0]<<0>>>0|j[W+1]<<8>>>0|j[W+2]<<16>>>0|j[W+3]<<24>>>0}t.$Nc=e;function a(j,W,ee){j[ee+0]=W&255,W=W>>>8,j[ee+1]=W&255,W=W>>>8,j[ee+2]=W&255,W=W>>>8,j[ee+3]=W&255}t.$Oc=a;function o(j,W){return j[W]}t.$Pc=o;function s(j,W,ee){j[ee]=W}t.$Qc=s;function n(j){return S.$wc(j,W=>l.concat(W))}t.$Rc=n;function g(j){return S.$Dc(j)}t.$Sc=g;function b(j){return S.$yc(j,W=>l.concat(W))}t.$Tc=b;async function $(j){return j.ended?l.concat(j.buffer):l.concat([...j.buffer,await b(j.stream)])}t.$Uc=$;function c(j){return S.$Bc(j,W=>l.concat(W))}t.$Vc=c;function O(j){return S.$Ec(j,{data:W=>typeof W=="string"?l.fromString(W):l.wrap(W)},W=>l.concat(W))}t.$Wc=O;function R(j){return S.$vc(W=>l.concat(W),j)}t.$Xc=R;function L(j,W){return S.$Fc(j,W,ee=>l.concat(ee))}t.$Yc=L;function m(j,W){return S.$Gc(j,W,ee=>l.concat(ee))}t.$Zc=m;function p(j){let W=0,ee=0,ne=0;const re=new Uint8Array(Math.floor(j.length/4*3)),ce=ae=>{switch(ee){case 3:re[ne++]=W|ae,ee=0;break;case 2:re[ne++]=W|ae>>>2,W=ae<<6,ee=3;break;case 1:re[ne++]=W|ae>>>4,W=ae<<4,ee=2;break;default:W=ae<<2,ee=1}};for(let ae=0;ae<j.length;ae++){const we=j.charCodeAt(ae);if(we>=65&&we<=90)ce(we-65);else if(we>=97&&we<=122)ce(we-97+26);else if(we>=48&&we<=57)ce(we-48+52);else if(we===43||we===45)ce(62);else if(we===47||we===95)ce(63);else{if(we===61)break;throw new SyntaxError(`Unexpected base64 character ${j[ae]}`)}}const he=ne;for(;ee>0;)ce(0);return l.wrap(re).slice(0,he)}t.$1c=p;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function H({buffer:j},W=!0,ee=!1){const ne=ee?M:N;let re="";const ce=j.byteLength%3;let he=0;for(;he<j.byteLength-ce;he+=3){const ae=j[he+0],we=j[he+1],Oe=j[he+2];re+=ne[ae>>>2],re+=ne[(ae<<4|we>>>4)&63],re+=ne[(we<<2|Oe>>>6)&63],re+=ne[Oe&63]}if(ce===1){const ae=j[he+0];re+=ne[ae>>>2],re+=ne[ae<<4&63],W&&(re+="==")}else if(ce===2){const ae=j[he+0],we=j[he+1];re+=ne[ae>>>2],re+=ne[(ae<<4|we>>>4)&63],re+=ne[we<<2&63],W&&(re+="=")}return re}t.$2c=H}),define(me[11],$e([1,0,82,30]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ke=t.$je=t.$ie=t.$he=t.GraphemeBreakType=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=void 0;function i(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}t.$od=i;const U=/{(\d+)}/g;function D(Q,...le){return le.length===0?Q:Q.replace(U,function(be,De){const Ne=parseInt(De,10);return isNaN(Ne)||Ne<0||Ne>=le.length?be:le[Ne]})}t.$pd=D;const v=/{([^}]+)}/g;function l(Q,le){return Q.replace(v,(be,De)=>le[De]??be)}t.$qd=l;function u(Q){return Q.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.$rd=u;function f(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$sd=f;function P(Q,le){let be=0;const De=le.charCodeAt(0);for(let Ne=Q.length-1;Ne>=0;Ne--)Q.charCodeAt(Ne)===De&&be++;return be}t.$td=P;function r(Q,le,be="\u2026"){return Q.length<=le?Q:`${Q.substr(0,le)}${be}`}t.$ud=r;function h(Q,le=" "){const be=e(Q,le);return a(be,le)}t.$vd=h;function e(Q,le){if(!Q||!le)return Q;const be=le.length;if(be===0||Q.length===0)return Q;let De=0;for(;Q.indexOf(le,De)===De;)De=De+be;return Q.substring(De)}t.$wd=e;function a(Q,le){if(!Q||!le)return Q;const be=le.length,De=Q.length;if(be===0||De===0)return Q;let Ne=De,Re=-1;for(;Re=Q.lastIndexOf(le,Ne-1),!(Re===-1||Re+be!==Ne);){if(Re===0)return"";Ne=Re}return Q.substring(0,Ne)}t.$xd=a;function o(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$yd=o;function s(Q){return Q.replace(/\*/g,"")}t.$zd=s;function n(Q,le,be={}){if(!Q)throw new Error("Cannot create regex from empty string");le||(Q=f(Q)),be.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let De="";return be.global&&(De+="g"),be.matchCase||(De+="i"),be.multiline&&(De+="m"),be.unicode&&(De+="u"),new RegExp(Q,De)}t.$Ad=n;function g(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}t.$Bd=g;function b(Q){return Q.split(/\r\n|\r|\n/)}t.$Cd=b;function $(Q){for(let le=0,be=Q.length;le<be;le++){const De=Q.charCodeAt(le);if(De!==32&&De!==9)return le}return-1}t.$Dd=$;function c(Q,le=0,be=Q.length){for(let De=le;De<be;De++){const Ne=Q.charCodeAt(De);if(Ne!==32&&Ne!==9)return Q.substring(le,De)}return Q.substring(le,be)}t.$Ed=c;function O(Q,le=Q.length-1){for(let be=le;be>=0;be--){const De=Q.charCodeAt(be);if(De!==32&&De!==9)return be}return-1}t.$Fd=O;function R(Q,le,be){const De=[];let Ne=0;for(const Re of Q.matchAll(le)){if(De.push(Q.slice(Ne,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ne=Re.index+Re[0].length,De.push(be(Re[0],...Re.slice(1),Re.index,Q,Re.groups))}return De.push(Q.slice(Ne)),Promise.all(De).then(Re=>Re.join(""))}t.$Gd=R;function L(Q,le){return Q<le?-1:Q>le?1:0}t.$Hd=L;function m(Q,le,be=0,De=Q.length,Ne=0,Re=le.length){for(;be<De&&Ne<Re;be++,Ne++){const Ye=Q.charCodeAt(be),Ve=le.charCodeAt(Ne);if(Ye<Ve)return-1;if(Ye>Ve)return 1}const ze=De-be,Qe=Re-Ne;return ze<Qe?-1:ze>Qe?1:0}t.$Id=m;function p(Q,le){return N(Q,le,0,Q.length,0,le.length)}t.$Jd=p;function N(Q,le,be=0,De=Q.length,Ne=0,Re=le.length){for(;be<De&&Ne<Re;be++,Ne++){let Ye=Q.charCodeAt(be),Ve=le.charCodeAt(Ne);if(Ye===Ve)continue;if(Ye>=128||Ve>=128)return m(Q.toLowerCase(),le.toLowerCase(),be,De,Ne,Re);H(Ye)&&(Ye-=32),H(Ve)&&(Ve-=32);const _e=Ye-Ve;if(_e!==0)return _e}const ze=De-be,Qe=Re-Ne;return ze<Qe?-1:ze>Qe?1:0}t.$Kd=N;function M(Q){return Q>=48&&Q<=57}t.$Ld=M;function H(Q){return Q>=97&&Q<=122}t.$Md=H;function j(Q){return Q>=65&&Q<=90}t.$Nd=j;function W(Q,le){return Q.length===le.length&&N(Q,le)===0}t.$Od=W;function ee(Q,le){const be=le.length;return le.length>Q.length?!1:N(Q,le,0,be)===0}t.$Pd=ee;function ne(Q,le){const be=Math.min(Q.length,le.length);let De;for(De=0;De<be;De++)if(Q.charCodeAt(De)!==le.charCodeAt(De))return De;return be}t.$Qd=ne;function re(Q,le){const be=Math.min(Q.length,le.length);let De;const Ne=Q.length-1,Re=le.length-1;for(De=0;De<be;De++)if(Q.charCodeAt(Ne-De)!==le.charCodeAt(Re-De))return De;return be}t.$Rd=re;function ce(Q){return 55296<=Q&&Q<=56319}t.$Sd=ce;function he(Q){return 56320<=Q&&Q<=57343}t.$Td=he;function ae(Q,le){return(Q-55296<<10)+(le-56320)+65536}t.$Ud=ae;function we(Q,le,be){const De=Q.charCodeAt(be);if(ce(De)&&be+1<le){const Ne=Q.charCodeAt(be+1);if(he(Ne))return ae(De,Ne)}return De}t.$Vd=we;function Oe(Q,le){const be=Q.charCodeAt(le-1);if(he(be)&&le>1){const De=Q.charCodeAt(le-2);if(ce(De))return ae(De,be)}return be}class Ie{get offset(){return this.e}constructor(le,be=0){this.c=le,this.d=le.length,this.e=be}setOffset(le){this.e=le}prevCodePoint(){const le=Oe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=we(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.$Wd=Ie;class Me{get offset(){return this.c.offset}constructor(le,be=0){this.c=new Ie(le,be)}nextGraphemeLength(){const le=Ee.getInstance(),be=this.c,De=be.offset;let Ne=le.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,ze=le.getGraphemeBreakType(be.nextCodePoint());if(pe(Ne,ze)){be.setOffset(Re);break}Ne=ze}return be.offset-De}prevGraphemeLength(){const le=Ee.getInstance(),be=this.c,De=be.offset;let Ne=le.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,ze=le.getGraphemeBreakType(be.prevCodePoint());if(pe(ze,Ne)){be.setOffset(Re);break}Ne=ze}return De-be.offset}eol(){return this.c.eol()}}t.$Xd=Me;function fe(Q,le){return new Me(Q,le).nextGraphemeLength()}t.$Yd=fe;function ie(Q,le){return new Me(Q,le).prevGraphemeLength()}t.$Zd=ie;function G(Q,le){le>0&&he(Q.charCodeAt(le))&&le--;const be=le+fe(Q,le);return[be-ie(Q,be),be]}t.$1d=G;function x(Q){const le=new Me(Q);let be=0;for(;!le.eol();)be++,le.nextGraphemeLength();return be}t.$2d=x;let J;function X(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function k(Q){return J||(J=X()),J.test(Q)}t.$3d=k;const V=/^[\t\n\r\x20-\x7E]*$/;function d(Q){return V.test(Q)}t.$4d=d,t.$5d=/[\u2028\u2029]/;function w(Q){return t.$5d.test(Q)}t.$6d=w;function E(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}t.$7d=E;function I(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}t.$8d=I;function F(Q,le){if(Q.length<le)return Q;const be=/\b/g;let De=0;for(;be.test(Q)&&!(Q.length-be.lastIndex<le);)De=be.lastIndex,be.lastIndex+=1;return Q.substring(De).replace(/^\s/,"")}t.$9d=F;const B=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,q=/\x1b\].*?\x07/g;function T(Q){return Q&&(Q=Q.replace(B,"").replace(q,"")),Q}t.$0d=T,t.$$d=String.fromCharCode(65279);function z(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}t.$_d=z;function C(Q){return z(Q)?Q.substr(1):Q}t.$ae=C;function A(Q,le){if(!Q||!le||Q.length<le.length)return!1;const be=le.length,De=Q.toLowerCase();let Ne=0,Re=-1;for(;Ne<be;){const ze=De.indexOf(le[Ne],Re+1);if(ze<0)return!1;Re=ze,Ne++}return!0}t.$be=A;function _(Q,le=!1){return Q?(le&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}t.$ce=_;function K(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}t.$de=K;function te(Q,le=1){if(le===0)return"";let be=-1;do be=Q.indexOf(`
`,be+1),le--;while(le>0&&be>=0);return be===-1?Q:(Q[be-1]==="\r"&&be--,Q.substr(0,be))}t.$ee=te;function se(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}t.$fe=se;function ge(Q){return Ee.getInstance().getGraphemeBreakType(Q)}t.$ge=ge;function pe(Q,le){return Q===0?le!==5&&le!==7:Q===2&&le===3?!1:Q===4||Q===2||Q===3||le===4||le===2||le===3?!0:!(Q===8&&(le===8||le===9||le===11||le===12)||(Q===11||Q===9)&&(le===9||le===10)||(Q===12||Q===10)&&le===10||le===5||le===13||le===7||Q===1||Q===13&&le===14||Q===6&&le===6)}var Ce;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(Ce||(t.GraphemeBreakType=Ce={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const be=this.d,De=be.length/3;let Ne=1;for(;Ne<=De;)if(le<be[3*Ne])Ne=2*Ne;else if(le>be[3*Ne+1])Ne=2*Ne+1;else return be[3*Ne+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Q,le){if(Q===0)return 0;const be=Fe(Q,le);if(be!==void 0)return be;const De=new Ie(le,Q);return De.prevCodePoint(),De.offset}t.$he=Te;function Fe(Q,le){const be=new Ie(le,Q);let De=be.prevCodePoint();for(;qe(De)||De===65039||De===8419;){if(be.offset===0)return;De=be.prevCodePoint()}if(!I(De))return;let Ne=be.offset;return Ne>0&&be.prevCodePoint()===8205&&(Ne=be.offset),Ne}function qe(Q){return 127995<=Q&&Q<=127999}var je;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$ie="\xA0";class Le{static{this.c=new S.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$kd(le=>{function be(_e){const et=new Map;for(let it=0;it<_e.length;it+=2)et.set(_e[it],_e[it+1]);return et}function De(_e,et){const it=new Map(_e);for(const[ft,ct]of et)it.set(ft,ct);return it}function Ne(_e,et){if(!_e)return et;const it=new Map;for(const[ft,ct]of _e)et.has(ft)&&it.set(ft,ct);return it}const Re=this.c.value;let ze=le.filter(_e=>!_e.startsWith("_")&&_e in Re);ze.length===0&&(ze=["_default"]);let Qe;for(const _e of ze){const et=be(Re[_e]);Qe=Ne(Qe,et)}const Ye=be(Re._common),Ve=De(Ye,Qe);return new Le(Ve)})}static getInstance(le){return Le.d.get(Array.from(le))}static{this.e=new S.$T(()=>Object.keys(Le.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return Le.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$je=Le;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(le){return Ge.e().has(le)}static get codePoints(){return Ge.e()}}t.$ke=Ge}),define(me[32],$e([1,0,76,11]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.FuzzyScore=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.$Aj=t.$zj=t.$yj=t.$xj=t.$wj=t.$vj=t.or=void 0;function i(...C){return function(A,_){for(let K=0,te=C.length;K<te;K++){const se=C[K](A,_);if(se)return se}return null}}t.or=i,t.$vj=U.bind(void 0,!1),t.$wj=U.bind(void 0,!0);function U(C,A,_){if(!_||_.length<A.length)return null;let K;return C?K=S.$Pd(_,A):K=_.indexOf(A)===0,K?A.length>0?[{start:0,end:A.length}]:[]:null}function D(C,A){const _=A.toLowerCase().indexOf(C.toLowerCase());return _===-1?null:[{start:_,end:_+C.length}]}t.$xj=D;function v(C,A){return l(C.toLowerCase(),A.toLowerCase(),0,0)}t.$yj=v;function l(C,A,_,K){if(_===C.length)return[];if(K===A.length)return null;if(C[_]===A[K]){let te=null;return(te=l(C,A,_+1,K+1))?s({start:K,end:K+1},te):null}return l(C,A,_,K+1)}function u(C){return 97<=C&&C<=122}function f(C){return 65<=C&&C<=90}t.$zj=f;function P(C){return 48<=C&&C<=57}function r(C){return C===32||C===9||C===10||C===13}const h=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>h.add(C.charCodeAt(0)));function e(C){return r(C)||h.has(C)}function a(C,A){return C===A||e(C)&&e(A)}function o(C){return u(C)||f(C)||P(C)}function s(C,A){return A.length===0?A=[C]:C.end===A[0].start?A[0].start=C.start:A.unshift(C),A}function n(C,A){for(let _=A;_<C.length;_++){const K=C.charCodeAt(_);if(f(K)||P(K)||_>0&&!o(C.charCodeAt(_-1)))return _}return C.length}function g(C,A,_,K){if(_===C.length)return[];if(K===A.length)return null;if(C[_]!==A[K].toLowerCase())return null;{let te=null,se=K+1;for(te=g(C,A,_+1,K+1);!te&&(se=n(A,se))<A.length;)te=g(C,A,_+1,se),se++;return te===null?null:s({start:K,end:K+1},te)}}function b(C){let A=0,_=0,K=0,te=0,se=0;for(let ve=0;ve<C.length;ve++)se=C.charCodeAt(ve),f(se)&&A++,u(se)&&_++,o(se)&&K++,P(se)&&te++;const ge=A/C.length,pe=_/C.length,Ce=K/C.length,Ee=te/C.length;return{upperPercent:ge,lowerPercent:pe,alphaPercent:Ce,numericPercent:Ee}}function $(C){const{upperPercent:A,lowerPercent:_}=C;return _===0&&A>.6}function c(C){const{upperPercent:A,lowerPercent:_,alphaPercent:K,numericPercent:te}=C;return _>.2&&A<.8&&K>.6&&te<.2}function O(C){let A=0,_=0,K=0,te=0;for(let se=0;se<C.length;se++)K=C.charCodeAt(se),f(K)&&A++,u(K)&&_++,r(K)&&te++;return(A===0||_===0)&&te===0?C.length<=30:A<=5}function R(C,A){if(!A||(A=A.trim(),A.length===0)||!O(C)||A.length>60)return null;const _=b(A);if(!c(_)){if(!$(_))return null;A=A.toLowerCase()}let K=null,te=0;for(C=C.toLowerCase();te<A.length&&(K=g(C,A,0,te))===null;)te=n(A,te+1);return K}t.$Aj=R;function L(C,A,_=!1){if(!A||A.length===0)return null;let K=null,te=0;for(C=C.toLowerCase(),A=A.toLowerCase();te<A.length&&(K=m(C,A,0,te,_))===null;)te=p(A,te+1);return K}t.$Bj=L;function m(C,A,_,K,te){if(_===C.length)return[];if(K===A.length)return null;if(a(C.charCodeAt(_),A.charCodeAt(K))){let se=null,ge=K+1;if(se=m(C,A,_+1,K+1,te),!te)for(;!se&&(ge=p(A,ge))<A.length;)se=m(C,A,_+1,ge,te),ge++;return se?C.charCodeAt(_)!==A.charCodeAt(K)?se:s({start:K,end:K+1},se):null}else return null}function p(C,A){for(let _=A;_<C.length;_++)if(e(C.charCodeAt(_))||_>0&&e(C.charCodeAt(_-1)))return _;return C.length}const N=i(t.$wj,R,D),M=i(t.$wj,R,v),H=new y.$Ai(1e4);function j(C,A,_=!1){if(typeof C!="string"||typeof A!="string")return null;let K=H.get(C);K||(K=new RegExp(S.$yd(C),"i"),H.set(C,K));const te=K.exec(A);return te?[{start:te.index,end:te.index+te[0].length}]:_?M(C,A):N(C,A)}t.$Cj=j;function W(C,A){const _=E(C,C.toLowerCase(),0,A,A.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?ne(_):null}t.$Dj=W;function ee(C,A,_,K,te,se){const ge=Math.min(13,C.length);for(;_<ge;_++){const pe=E(C,A,_,K,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,se]}t.$Ej=ee;function ne(C){if(typeof C>"u")return[];const A=[],_=C[1];for(let K=C.length-1;K>1;K--){const te=C[K]+_,se=A[A.length-1];se&&se.end===te?se.end=te+1:A.push({start:te,end:te+1})}return A}t.$Fj=ne;const re=128;function ce(){const C=[],A=[];for(let _=0;_<=re;_++)A[_]=0;for(let _=0;_<=re;_++)C.push(A.slice(0));return C}function he(C){const A=[];for(let _=0;_<=C;_++)A[_]=0;return A}const ae=he(2*re),we=he(2*re),Oe=ce(),Ie=ce(),Me=ce(),fe=!1;function ie(C,A,_,K,te){function se(pe,Ce,Ee=" "){for(;pe.length<Ce;)pe=Ee+pe;return pe}let ge=` |   |${K.split("").map(pe=>se(pe,3)).join("|")}
`;for(let pe=0;pe<=_;pe++)pe===0?ge+=" |":ge+=`${A[pe-1]}|`,ge+=C[pe].slice(0,te+1).map(Ce=>se(Ce.toString(),3)).join("|")+`
`;return ge}function G(C,A,_,K){C=C.substr(A),_=_.substr(K),console.log(ie(Ie,C,C.length,_,_.length)),console.log(ie(Me,C,C.length,_,_.length)),console.log(ie(Oe,C,C.length,_,_.length))}function x(C,A){if(A<0||A>=C.length)return!1;const _=C.codePointAt(A);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!S.$8d(_)}}function J(C,A){if(A<0||A>=C.length)return!1;switch(C.charCodeAt(A)){case 32:case 9:return!0;default:return!1}}function X(C,A,_){return A[C]!==_[C]}function k(C,A,_,K,te,se,ge=!1){for(;A<_&&te<se;)C[A]===K[te]&&(ge&&(ae[A]=te),A+=1),te+=1;return A===_}t.$Gj=k;var V;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(V||(V={}));var d;(function(C){C.Default=[-100,0];function A(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}C.isDefault=A})(d||(t.FuzzyScore=d={}));class w{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(A,_){this.firstMatchCanBeWeak=A,this.boostFullMatch=_}}t.$Hj=w;function E(C,A,_,K,te,se,ge=w.default){const pe=C.length>re?re:C.length,Ce=K.length>re?re:K.length;if(_>=pe||se>=Ce||pe-_>Ce-se||!k(A,_,pe,te,se,Ce,!0))return;I(pe,Ce,_,se,A,te);let Ee=1,ve=1,Te=_,Fe=se;const qe=[!1];for(Ee=1,Te=_;Te<pe;Ee++,Te++){const le=ae[Te],be=we[Te],De=Te+1<pe?we[Te+1]:Ce;for(ve=le-se+1,Fe=le;Fe<De;ve++,Fe++){let Ne=Number.MIN_SAFE_INTEGER,Re=!1;Fe<=be&&(Ne=F(C,A,Te,_,K,te,Fe,Ce,se,Oe[Ee-1][ve-1]===0,qe));let ze=0;Ne!==Number.MAX_SAFE_INTEGER&&(Re=!0,ze=Ne+Ie[Ee-1][ve-1]);const Qe=Fe>le,Ye=Qe?Ie[Ee][ve-1]+(Oe[Ee][ve-1]>0?-5:0):0,Ve=Fe>le+1&&Oe[Ee][ve-1]>0,_e=Ve?Ie[Ee][ve-2]+(Oe[Ee][ve-2]>0?-5:0):0;if(Ve&&(!Qe||_e>=Ye)&&(!Re||_e>=ze))Ie[Ee][ve]=_e,Me[Ee][ve]=3,Oe[Ee][ve]=0;else if(Qe&&(!Re||Ye>=ze))Ie[Ee][ve]=Ye,Me[Ee][ve]=2,Oe[Ee][ve]=0;else if(Re)Ie[Ee][ve]=ze,Me[Ee][ve]=1,Oe[Ee][ve]=Oe[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&G(C,_,K,se),!qe[0]&&!ge.firstMatchCanBeWeak)return;Ee--,ve--;const je=[Ie[Ee][ve],se];let Le=0,Ge=0;for(;Ee>=1;){let le=ve;do{const be=Me[Ee][le];if(be===3)le=le-2;else if(be===2)le=le-1;else break}while(le>=1);Le>1&&A[_+Ee-1]===te[se+ve-1]&&!X(le+se-1,K,te)&&Le+1>Oe[Ee][le]&&(le=ve),le===ve?Le++:Le=1,Ge||(Ge=le),Ee--,ve=le-1,je.push(ve)}Ce===pe&&ge.boostFullMatch&&(je[0]+=2);const Q=Ge-pe;return je[0]-=Q,je}t.$Ij=E;function I(C,A,_,K,te,se){let ge=C-1,pe=A-1;for(;ge>=_&&pe>=K;)te[ge]===se[pe]&&(we[ge]=pe,ge--),pe--}function F(C,A,_,K,te,se,ge,pe,Ce,Ee,ve){if(A[_]!==se[ge])return Number.MIN_SAFE_INTEGER;let Te=1,Fe=!1;return ge===_-K?Te=C[_]===te[ge]?7:5:X(ge,te,se)&&(ge===0||!X(ge-1,te,se))?(Te=C[_]===te[ge]?7:5,Fe=!0):x(se,ge)&&(ge===0||!x(se,ge-1))?Te=5:(x(se,ge-1)||J(se,ge-1))&&(Te=5,Fe=!0),Te>1&&_===K&&(ve[0]=!0),Fe||(Fe=X(ge,te,se)||x(se,ge-1)||J(se,ge-1)),_===K?ge>Ce&&(Te-=Fe?3:5):Ee?Te+=Fe?2:0:Te+=Fe?0:1,ge+1===pe&&(Te-=Fe?3:5),Te}function B(C,A,_,K,te,se,ge){return T(C,A,_,K,te,se,!0,ge)}t.$Jj=B;function q(C,A,_,K,te,se,ge){return T(C,A,_,K,te,se,!1,ge)}t.$Kj=q;function T(C,A,_,K,te,se,ge,pe){let Ce=E(C,A,_,K,te,se,pe);if(Ce&&!ge)return Ce;if(C.length>=3){const Ee=Math.min(7,C.length-1);for(let ve=_+1;ve<Ee;ve++){const Te=z(C,ve);if(Te){const Fe=E(Te,Te.toLowerCase(),_,K,te,se,pe);Fe&&(Fe[0]-=3,(!Ce||Fe[0]>Ce[0])&&(Ce=Fe))}}}return Ce}function z(C,A){if(A+1>=C.length)return;const _=C[A],K=C[A+1];if(_!==K)return C.slice(0,A)+K+_+C.slice(A+2)}}),define(me[84],$e([1,0,11]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ti=t.$si=t.$ri=t.$qi=t.$pi=t.$oi=t.$ni=void 0;function S(s){return i(s,0)}t.$ni=S;function i(s,n){switch(typeof s){case"object":return s===null?U(349,n):Array.isArray(s)?l(s,n):u(s,n);case"string":return v(s,n);case"boolean":return D(s,n);case"number":return U(s,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$oi=i;function U(s,n){return(n<<5)-n+s|0}t.$pi=U;function D(s,n){return U(s?433:863,n)}function v(s,n){n=U(149417,n);for(let g=0,b=s.length;g<b;g++)n=U(s.charCodeAt(g),n);return n}t.$qi=v;function l(s,n){return n=U(104579,n),s.reduce((g,b)=>i(b,g),n)}function u(s,n){return n=U(181387,n),Object.keys(s).sort().reduce((g,b)=>(g=v(b,g),i(s[b],g)),n)}class f{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$ri=f;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(s,n,g=32){const b=g-n,$=~((1<<b)-1);return(s<<n|($&s)>>>b)>>>0}function h(s,n=0,g=s.byteLength,b=0){for(let $=0;$<g;$++)s[n+$]=b}function e(s,n,g="0"){for(;s.length<n;)s=g+s;return s}function a(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(g=>g.toString(16).padStart(2,"0")).join(""):e((s>>>0).toString(16),n/4)}t.$si=a;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const g=n.length;if(g===0)return;const b=this.p;let $=this.r,c=this.u,O,R;for(c!==0?(O=c,R=-1,c=0):(O=n.charCodeAt(0),R=0);;){let L=O;if(y.$Sd(O))if(R+1<g){const m=n.charCodeAt(R+1);y.$Td(m)?(R++,L=y.$Ud(O,m)):L=65533}else{c=O;break}else y.$Td(O)&&(L=65533);if($=this.w(b,$,L),R++,R<g)O=n.charCodeAt(R);else break}this.r=$,this.u=c}w(n,g,b){return b<128?n[g++]=b:b<2048?(n[g++]=192|(b&1984)>>>6,n[g++]=128|(b&63)>>>0):b<65536?(n[g++]=224|(b&61440)>>>12,n[g++]=128|(b&4032)>>>6,n[g++]=128|(b&63)>>>0):(n[g++]=240|(b&1835008)>>>18,n[g++]=128|(b&258048)>>>12,n[g++]=128|(b&4032)>>>6,n[g++]=128|(b&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=o.g,g=this.q;for(let N=0;N<64;N+=4)n.setUint32(N,g.getUint32(N,!1),!1);for(let N=64;N<320;N+=4)n.setUint32(N,r(n.getUint32(N-12,!1)^n.getUint32(N-32,!1)^n.getUint32(N-56,!1)^n.getUint32(N-64,!1),1),!1);let b=this.h,$=this.l,c=this.m,O=this.n,R=this.o,L,m,p;for(let N=0;N<80;N++)N<20?(L=$&c|~$&O,m=1518500249):N<40?(L=$^c^O,m=1859775393):N<60?(L=$&c|$&O|c&O,m=2400959708):(L=$^c^O,m=3395469782),p=r(b,5)+L+R+m+n.getUint32(N*4,!1)&4294967295,R=O,O=c,c=r($,30),$=b,b=p;this.h=this.h+b&4294967295,this.l=this.l+$&4294967295,this.m=this.m+c&4294967295,this.n=this.n+O&4294967295,this.o=this.o+R&4294967295}}t.$ti=o}),define(me[85],$e([1,0,72,84]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=t.$ms=t.$ls=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,h=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)h[e]=r.charCodeAt(e);return h}}t.$ls=i;function U(P,r,h){return new f(new i(P),new i(r)).ComputeDiff(h).changes}t.$ms=U;class D{static Assert(r,h){if(!r)throw new Error(h)}}class v{static Copy(r,h,e,a,o){for(let s=0;s<o;s++)e[a+s]=r[h+s]}static Copy2(r,h,e,a,o){for(let s=0;s<o;s++)e[a+s]=r[h+s]}}var l;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ks(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,h){this.b=Math.min(this.b,r),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(r,h){this.b=Math.min(this.b,r),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(r,h,e=null){this.a=e,this.b=r,this.c=h;const[a,o,s]=f.o(r),[n,g,b]=f.o(h);this.d=s&&b,this.e=a,this.f=o,this.g=n,this.h=g,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const h=r.getElements();if(f.n(h)){const e=new Int32Array(h.length);for(let a=0,o=h.length;a<o;a++)e[a]=(0,S.$qi)(h[a],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(r,h){return this.f[r]!==this.h[h]?!1:this.d?this.e[r]===this.g[h]:!0}q(r,h){if(!this.p(r,h))return!1;const e=f.r(this.b,r),a=f.r(this.c,h);return e===a}static r(r,h){return typeof r.getStrictElement=="function"?r.getStrictElement(h):null}s(r,h){return this.f[r]!==this.f[h]?!1:this.d?this.e[r]===this.e[h]:!0}u(r,h){return this.h[r]!==this.h[h]?!1:this.d?this.g[r]===this.g[h]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,h,e,a,o){const s=[!1];let n=this.w(r,h,e,a,s);return o&&(n=this.z(n)),{quitEarly:s[0],changes:n}}w(r,h,e,a,o){for(o[0]=!1;r<=h&&e<=a&&this.p(r,e);)r++,e++;for(;h>=r&&a>=e&&this.p(h,a);)h--,a--;if(r>h||e>a){let c;return e<=a?(D.Assert(r===h+1,"originalStart should only be one more than originalEnd"),c=[new y.$ks(r,0,e,a-e+1)]):r<=h?(D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),c=[new y.$ks(r,h-r+1,e,0)]):(D.Assert(r===h+1,"originalStart should only be one more than originalEnd"),D.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),c=[]),c}const s=[0],n=[0],g=this.y(r,h,e,a,s,n,o),b=s[0],$=n[0];if(g!==null)return g;if(!o[0]){const c=this.w(r,b,e,$,o);let O=[];return o[0]?O=[new y.$ks(b+1,h-(b+1)+1,$+1,a-($+1)+1)]:O=this.w(b+1,h,$+1,a,o),this.H(c,O)}return[new y.$ks(r,h-r+1,e,a-e+1)]}x(r,h,e,a,o,s,n,g,b,$,c,O,R,L,m,p,N,M){let H=null,j=null,W=new u,ee=h,ne=e,re=R[0]-p[0]-a,ce=-1073741824,he=this.k.length-1;do{const ae=re+r;ae===ee||ae<ne&&b[ae-1]<b[ae+1]?(c=b[ae+1],L=c-re-a,c<ce&&W.MarkNextChange(),ce=c,W.AddModifiedElement(c+1,L),re=ae+1-r):(c=b[ae-1]+1,L=c-re-a,c<ce&&W.MarkNextChange(),ce=c-1,W.AddOriginalElement(c,L+1),re=ae-1-r),he>=0&&(b=this.k[he],r=b[0],ee=1,ne=b.length-1)}while(--he>=-1);if(H=W.getReverseChanges(),M[0]){let ae=R[0]+1,we=p[0]+1;if(H!==null&&H.length>0){const Oe=H[H.length-1];ae=Math.max(ae,Oe.getOriginalEnd()),we=Math.max(we,Oe.getModifiedEnd())}j=[new y.$ks(ae,O-ae+1,we,m-we+1)]}else{W=new u,ee=s,ne=n,re=R[0]-p[0]-g,ce=1073741824,he=N?this.m.length-1:this.m.length-2;do{const ae=re+o;ae===ee||ae<ne&&$[ae-1]>=$[ae+1]?(c=$[ae+1]-1,L=c-re-g,c>ce&&W.MarkNextChange(),ce=c+1,W.AddOriginalElement(c+1,L+1),re=ae+1-o):(c=$[ae-1],L=c-re-g,c>ce&&W.MarkNextChange(),ce=c,W.AddModifiedElement(c+1,L+1),re=ae-1-o),he>=0&&($=this.m[he],o=$[0],ee=1,ne=$.length-1)}while(--he>=-1);j=W.getChanges()}return this.H(H,j)}y(r,h,e,a,o,s,n){let g=0,b=0,$=0,c=0,O=0,R=0;r--,e--,o[0]=0,s[0]=0,this.k=[],this.m=[];const L=h-r+(a-e),m=L+1,p=new Int32Array(m),N=new Int32Array(m),M=a-e,H=h-r,j=r-e,W=h-a,ne=(H-M)%2===0;p[M]=r,N[H]=h,n[0]=!1;for(let re=1;re<=L/2+1;re++){let ce=0,he=0;$=this.J(M-re,re,M,m),c=this.J(M+re,re,M,m);for(let we=$;we<=c;we+=2){we===$||we<c&&p[we-1]<p[we+1]?g=p[we+1]:g=p[we-1]+1,b=g-(we-M)-j;const Oe=g;for(;g<h&&b<a&&this.p(g+1,b+1);)g++,b++;if(p[we]=g,g+b>ce+he&&(ce=g,he=b),!ne&&Math.abs(we-H)<=re-1&&g>=N[we])return o[0]=g,s[0]=b,Oe<=N[we]&&1447>0&&re<=1447+1?this.x(M,$,c,j,H,O,R,W,p,N,g,h,o,b,a,s,ne,n):null}const ae=(ce-r+(he-e)-re)/2;if(this.a!==null&&!this.a(ce,ae))return n[0]=!0,o[0]=ce,s[0]=he,ae>0&&1447>0&&re<=1447+1?this.x(M,$,c,j,H,O,R,W,p,N,g,h,o,b,a,s,ne,n):(r++,e++,[new y.$ks(r,h-r+1,e,a-e+1)]);O=this.J(H-re,re,H,m),R=this.J(H+re,re,H,m);for(let we=O;we<=R;we+=2){we===O||we<R&&N[we-1]>=N[we+1]?g=N[we+1]-1:g=N[we-1],b=g-(we-H)-W;const Oe=g;for(;g>r&&b>e&&this.p(g,b);)g--,b--;if(N[we]=g,ne&&Math.abs(we-M)<=re&&g<=p[we])return o[0]=g,s[0]=b,Oe>=p[we]&&1447>0&&re<=1447+1?this.x(M,$,c,j,H,O,R,W,p,N,g,h,o,b,a,s,ne,n):null}if(re<=1447){let we=new Int32Array(c-$+2);we[0]=M-$+1,v.Copy2(p,$,we,1,c-$+1),this.k.push(we),we=new Int32Array(R-O+2),we[0]=H-O+1,v.Copy2(N,O,we,1,R-O+1),this.m.push(we)}}return this.x(M,$,c,j,H,O,R,W,p,N,g,h,o,b,a,s,ne,n)}z(r){for(let h=0;h<r.length;h++){const e=r[h],a=h<r.length-1?r[h+1].originalStart:this.f.length,o=h<r.length-1?r[h+1].modifiedStart:this.h.length,s=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<o&&(!s||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const g=[null];if(h<r.length-1&&this.I(r[h],r[h+1],g)){r[h]=g[0],r.splice(h+1,1),h--;continue}}for(let h=r.length-1;h>=0;h--){const e=r[h];let a=0,o=0;if(h>0){const c=r[h-1];a=c.originalStart+c.originalLength,o=c.modifiedStart+c.modifiedLength}const s=e.originalLength>0,n=e.modifiedLength>0;let g=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let c=1;;c++){const O=e.originalStart-c,R=e.modifiedStart-c;if(O<a||R<o||s&&!this.s(O,O+e.originalLength)||n&&!this.u(R,R+e.modifiedLength))break;const m=(O===a&&R===o?5:0)+this.G(O,e.originalLength,R,e.modifiedLength);m>b&&(b=m,g=c)}e.originalStart-=g,e.modifiedStart-=g;const $=[null];if(h>0&&this.I(r[h-1],r[h],$)){r[h-1]=$[0],r.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=r.length;h<e;h++){const a=r[h-1],o=r[h],s=o.originalStart-a.originalStart-a.originalLength,n=a.originalStart,g=o.originalStart+o.originalLength,b=g-n,$=a.modifiedStart,c=o.modifiedStart+o.modifiedLength,O=c-$;if(s<5&&b<20&&O<20){const R=this.A(n,b,$,O,s);if(R){const[L,m]=R;(L!==a.originalStart+a.originalLength||m!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=L-a.originalStart,a.modifiedLength=m-a.modifiedStart,o.originalStart=L+s,o.modifiedStart=m+s,o.originalLength=g-o.originalStart,o.modifiedLength=c-o.modifiedStart)}}}return r}A(r,h,e,a,o){if(h<o||a<o)return null;const s=r+h-o+1,n=e+a-o+1;let g=0,b=0,$=0;for(let c=r;c<s;c++)for(let O=e;O<n;O++){const R=this.B(c,O,o);R>0&&R>g&&(g=R,b=c,$=O)}return g>0?[b,$]:null}B(r,h,e){let a=0;for(let o=0;o<e;o++){if(!this.p(r+o,h+o))return 0;a+=this.e[r+o].length}return a}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,h){if(this.C(r)||this.C(r-1))return!0;if(h>0){const e=r+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,h){if(this.E(r)||this.E(r-1))return!0;if(h>0){const e=r+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,h,e,a){const o=this.D(r,h)?1:0,s=this.F(e,a)?1:0;return o+s}H(r,h){const e=[];if(r.length===0||h.length===0)return h.length>0?h:r;if(this.I(r[r.length-1],h[0],e)){const a=new Array(r.length+h.length-1);return v.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],v.Copy(h,1,a,r.length,h.length-1),a}else{const a=new Array(r.length+h.length);return v.Copy(r,0,a,0,r.length),v.Copy(h,0,a,r.length,h.length),a}}I(r,h,e){if(D.Assert(r.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),D.Assert(r.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=h.originalStart||r.modifiedStart+r.modifiedLength>=h.modifiedStart){const a=r.originalStart;let o=r.originalLength;const s=r.modifiedStart;let n=r.modifiedLength;return r.originalStart+r.originalLength>=h.originalStart&&(o=h.originalStart+h.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=h.modifiedStart&&(n=h.modifiedStart+h.modifiedLength-r.modifiedStart),e[0]=new y.$ks(a,o,s,n),!0}else return e[0]=null,!1}J(r,h,e,a){if(r>=0&&r<a)return r;const o=e,s=a-e-1,n=h%2===0;if(r<0){const g=o%2===0;return n===g?0:1}else{const g=s%2===0;return n===g?a-1:a-2}}}t.$ns=f}),define(me[47],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=void 0,t.$ec=Symbol("MicrotaskDelay")}),define(me[86],$e([1,0,13,11]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=void 0;class i{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.$Bh=i;class U{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,S.$Id)(h,this.b,0,h.length,this.c,this.d):(0,S.$Kd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Ch=U;class D{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,S.$Id)(h,this.b,0,h.length,this.d,this.e):(0,S.$Kd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Dh=D;var v;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(v||(v={}));class l{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,S.$Jd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,S.$Jd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,S.$Hd)(h,this.c.query);if(this.d[this.e]===5)return(0,S.$Hd)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Eh=l;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(f||(f={}));class P{static forUris(h=()=>!1,e=()=>!1){return new P(new l(h,e))}static forPaths(h=!1){return new P(new D(void 0,!h))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new U)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const a=e.slice(0);(0,y.$Qf)(a);for(const o of a)this.set(o,h)}else{const a=h.slice(0);(0,y.$Qf)(a);for(const o of a)this.set(o[0],o[1])}}set(h,e){const a=this.b.reset(h);let o;this.c||(this.c=new u,this.c.segment=a.value());const s=[];for(o=this.c;;){const g=a.cmp(o.segment);if(g>0)o.left||(o.left=new u,o.left.segment=a.value()),s.push([-1,o]),o=o.left;else if(g<0)o.right||(o.right=new u,o.right.segment=a.value()),s.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new u,o.mid.segment=a.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=e,o.key=h;for(let g=s.length-1;g>=0;g--){const b=s[g][1];b.updateHeight();const $=b.balanceFactor();if($<-1||$>1){const c=s[g][0],O=s[g+1][0];if(c===1&&O===1)s[g][1]=b.rotateLeft();else if(c===-1&&O===-1)s[g][1]=b.rotateRight();else if(c===1&&O===-1)b.right=s[g+1][1]=s[g+1][1].rotateRight(),s[g][1]=b.rotateLeft();else if(c===-1&&O===1)b.left=s[g+1][1]=s[g+1][1].rotateLeft(),s[g][1]=b.rotateRight();else throw new Error;if(g>0)switch(s[g-1][0]){case-1:s[g-1][1].left=s[g][1];break;case 1:s[g-1][1].right=s[g][1];break;case 0:s[g-1][1].mid=s[g][1];break}else this.c=s[0][1]}}return n}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let a=this.c;for(;a;){const o=e.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const a=this.b.reset(h),o=[];let s=this.c;for(;s;){const n=a.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(a.hasNext())a.next(),o.push([0,s]),s=s.mid;else break}if(s){if(e?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:g,value:b,segment:$}=n;this.e(n.key,!1),s.key=g,s.value=b,s.segment=$}}else{const n=s.left??s.right;if(o.length>0){const[g,b]=o[o.length-1];switch(g){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const g=o[n][1];g.updateHeight();const b=g.balanceFactor();if(b>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),o[n][1]=g.rotateLeft()):b<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),o[n][1]=g.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let a=this.c,o;for(;a;){const s=e.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(e.hasNext())e.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(h){return this.g(h,!1)}g(h,e){const a=this.b.reset(h);let o=this.c;for(;o;){const s=a.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,a]of this)h(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$Fh=P}),define(me[7],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=void 0;function y($){return typeof $=="string"}t.$le=y;function S($){return Array.isArray($)&&$.every(c=>y(c))}t.$me=S;function i($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}t.$ne=i;function U($){const c=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof c}t.$oe=U;function D($){return typeof $=="number"&&!isNaN($)}t.$pe=D;function v($){return!!$&&typeof $[Symbol.iterator]=="function"}t.$qe=v;function l($){return $===!0||$===!1}t.$re=l;function u($){return typeof $>"u"}t.$se=u;function f($){return!P($)}t.$te=f;function P($){return u($)||$===null}t.$ue=P;function r($,c){if(!$)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}t.$ve=r;function h($){if(P($))throw new Error("Assertion Failed: argument is undefined or null");return $}t.$we=h;function e(...$){const c=[];for(let O=0;O<$.length;O++){const R=$[O];if(P(R))throw new Error(`Assertion Failed: argument at index ${O} is undefined or null`);c.push(R)}return c}t.$xe=e;const a=Object.prototype.hasOwnProperty;function o($){if(!i($))return!1;for(const c in $)if(a.call($,c))return!1;return!0}t.$ye=o;function s($){return typeof $=="function"}t.$ze=s;function n(...$){return $.length>0&&$.every(s)}t.$Ae=n;function g($,c){const O=Math.min($.length,c.length);for(let R=0;R<O;R++)b($[R],c[R])}t.$Be=g;function b($,c){if(y(c)){if(typeof $!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(s(c)){try{if($ instanceof c)return}catch{}if(!P($)&&$.constructor===c||c.length===1&&c.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Ce=b}),define(me[17],$e([1,0,7]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nj=t.$Mj=t.$Lj=void 0;const S=Object.create(null);function i(v,l){if((0,y.$le)(l)){const u=S[l];if(u===void 0)throw new Error(`${v} references an unknown codicon: ${l}`);l=u}return S[v]=l,{id:v}}function U(){return S}t.$Lj=U;function D(){return Object.values(t.$Nj)}t.$Mj=D,t.$Nj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(me[48],$e([1,0,7]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5m=t.$4m=t.$3m=t.$2m=t.$1m=t.$Zm=t.$Ym=t.$Xm=t.$Wm=t.$Vm=t.$Um=t.$Tm=void 0;function S(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const n=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([g,b])=>{n[g]=b&&typeof b=="object"?S(b):b}),n}t.$Tm=S;function i(s){if(!s||typeof s!="object")return s;const n=[s];for(;n.length>0;){const g=n.shift();Object.freeze(g);for(const b in g)if(U.call(g,b)){const $=g[b];typeof $=="object"&&!Object.isFrozen($)&&!(0,y.$oe)($)&&n.push($)}}return s}t.$Um=i;const U=Object.prototype.hasOwnProperty;function D(s,n){return v(s,n,new Set)}t.$Vm=D;function v(s,n,g){if((0,y.$ue)(s))return s;const b=n(s);if(typeof b<"u")return b;if(Array.isArray(s)){const $=[];for(const c of s)$.push(v(c,n,g));return $}if((0,y.$ne)(s)){if(g.has(s))throw new Error("Cannot clone recursive data-structure");g.add(s);const $={};for(const c in s)U.call(s,c)&&($[c]=v(s[c],n,g));return g.delete(s),$}return s}function l(s,n,g=!0){return(0,y.$ne)(s)?((0,y.$ne)(n)&&Object.keys(n).forEach(b=>{b in s?g&&((0,y.$ne)(s[b])&&(0,y.$ne)(n[b])?l(s[b],n[b],g):s[b]=n[b]):s[b]=n[b]}),s):n}t.$Wm=l;function u(s,n){if(s===n)return!0;if(s==null||n===null||n===void 0||typeof s!=typeof n||typeof s!="object"||Array.isArray(s)!==Array.isArray(n))return!1;let g,b;if(Array.isArray(s)){if(s.length!==n.length)return!1;for(g=0;g<s.length;g++)if(!u(s[g],n[g]))return!1}else{const $=[];for(b in s)$.push(b);$.sort();const c=[];for(b in n)c.push(b);if(c.sort(),!u($,c))return!1;for(g=0;g<$.length;g++)if(!u(s[$[g]],n[$[g]]))return!1}return!0}t.$Xm=u;function f(s){const n=new Set;return JSON.stringify(s,(g,b)=>{if((0,y.$ne)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$Ym=f;function P(s,n){const g=Object.create(null);return!s||!n||Object.keys(n).forEach($=>{const c=s[$],O=n[$];u(c,O)||(g[$]=O)}),g}t.$Zm=P;function r(s,n){const g=n.toLowerCase(),b=Object.keys(s).find($=>$.toLowerCase()===g);return b?s[b]:s[n]}t.$1m=r;function h(s,n){const g=Object.create(null);for(const[b,$]of Object.entries(s))n(b,$)&&(g[b]=$);return g}t.$2m=h;function e(s){let n=[];for(;Object.prototype!==s;)n=n.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return n}t.$3m=e;function a(s){const n=[];for(const g of e(s))typeof s[g]=="function"&&n.push(g);return n}t.$4m=a;function o(s,n){const g=$=>function(){const c=Array.prototype.slice.call(arguments,0);return n($,c)},b={};for(const $ of s)b[$]=g($);return b}t.$5m=o}),define(me[18],$e([1,0,17]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Oj=t.ThemeColor=void 0;var S;(function(D){function v(l){return l&&typeof l=="object"&&typeof l.id=="string"}D.isThemeColor=v})(S||(t.ThemeColor=S={}));function i(D){return{id:D}}t.$Oj=i;var U;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function l(n){const g=v.exec(n.id);if(!g)return l(y.$Nj.error);const[,b,$]=g,c=["codicon","codicon-"+b];return $&&c.push("codicon-modifier-"+$.substring(1)),c}D.asClassNameArray=l;function u(n){return l(n).join(" ")}D.asClassName=u;function f(n){return"."+l(n).join(".")}D.asCSSSelector=f;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||S.isThemeColor(n.color))}D.isThemeIcon=P;const r=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(n){const g=r.exec(n);if(!g)return;const[,b]=g;return{id:b}}D.fromString=h;function e(n){return{id:n}}D.fromId=e;function a(n,g){let b=n.id;const $=b.lastIndexOf("~");return $!==-1&&(b=b.substring(0,$)),g&&(b=`${b}~${g}`),{id:b}}D.modify=a;function o(n){const g=n.id.lastIndexOf("~");if(g!==-1)return n.id.substring(g+1)}D.getModifier=o;function s(n,g){return n.id===g.id&&n.color?.id===g.color?.id}D.isEqual=s})(U||(t.ThemeIcon=U={}))}),define(me[33],$e([1,0,32,11,18]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=void 0;const U="$(",D=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${D.source}`,"g");function l(s){return s.replace(v,(n,g)=>g?n:`\\${n}`)}t.$Pj=l;const u=new RegExp(`\\\\${D.source}`,"g");function f(s){return s.replace(u,n=>`\\${n}`)}t.$Qj=f;const P=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function r(s){return s.indexOf(U)===-1?s:s.replace(P,(n,g,b,$)=>b?n:g||$||"")}t.$Rj=r;function h(s){return s?s.replace(/\$\((.*?)\)/g,(n,g)=>` ${g} `).trim():""}t.$Sj=h;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(s){e.lastIndex=0;let n="";const g=[];let b=0;for(;;){const $=e.lastIndex,c=e.exec(s),O=s.substring($,c?.index);if(O.length>0){n+=O;for(let R=0;R<O.length;R++)g.push(b)}if(!c)break;b+=c[0].length}return{text:n,iconOffsets:g}}t.$Tj=a;function o(s,n,g=!1){const{text:b,iconOffsets:$}=n;if(!$||$.length===0)return(0,y.$Cj)(s,b,g);const c=(0,S.$wd)(b," "),O=b.length-c.length,R=(0,y.$Cj)(s,c,g);if(R)for(const L of R){const m=$[L.start+O]+O;L.start+=m,L.end+=m}return R}t.$Uj=o}),define(me[87],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=t.$GS=void 0,t.$GS="vscode:contextmenu",t.$HS="vscode:onCloseContextMenu"}),define(me[88],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=void 0;class y{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$OS=y}),define(me[49],$e([8]),{}),define(me[89],$e([8]),{}),define(me[90],$e([8]),{}),define(me[91],$e([8]),{}),define(me[92],$e([1,0,90,91]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[93],$e([8]),{}),define(me[94],$e([8]),{}),define(me[95],$e([8]),{}),define(me[96],$e([8]),{}),define(me[97],$e([8]),{}),define(me[98],$e([8]),{}),define(me[99],$e([8]),{}),define(me[100],$e([8]),{}),define(me[101],$e([8]),{}),define(me[102],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[103],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[104],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[105],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[106],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[107],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[108],$e([12,10]),function(oe,t){return oe.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[109],$e([12,10]),function(oe,t){return oe.create("vs/base/common/actions",t)}),define(me[34],$e([1,0,3,2,109]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=t.$ei=void 0;class U extends S.$mb{constructor(r,h="",e="",a=!0,o){super(),this.h=this.B(new y.$hc),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=h,this.u=e,this.w=a,this.C=o}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,h){this.C&&await this.C(r)}}t.$ei=U;class D extends S.$mb{constructor(){super(...arguments),this.f=this.B(new y.$hc),this.onWillRun=this.f.event,this.k=this.B(new y.$hc),this.onDidRun=this.k.event}async run(r,h){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.l(r,h)}catch(a){e=a}this.k.fire({action:r,error:e})}async l(r,h){await r.run(h)}}t.$fi=D;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let h=[];for(const e of r)e.length&&(h.length?h=[...h,new v,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$gi=v;class l{get actions(){return this.a}constructor(r,h,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=h,this.class=a,this.a=e}async run(){}}t.$hi=l;class u extends U{static{this.ID="vs.actions.empty"}constructor(){super(u.ID,i.localize(0,null),void 0,!1)}}t.$ii=u;function f(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.$ji=f}),define(me[110],$e([12,10]),function(oe,t){return oe.create("vs/base/common/platform",t)}),define(me[5],$e([1,0,110]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let S=!1,i=!1,U=!1,D=!1,v=!1,l=!1,u=!1,f=!1,P=!1,r=!1,h,e=t.$f,a=t.$f,o,s;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?n=t.$g.vscode.process:typeof process<"u"&&(n=process);const g=typeof n?.versions?.electron=="string",b=g&&n?.type==="renderer";if(typeof navigator=="object"&&!b)s=navigator.userAgent,S=s.indexOf("Windows")>=0,i=s.indexOf("Macintosh")>=0,f=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=s.indexOf("Linux")>=0,r=s?.indexOf("Mobi")>=0,l=!0,h=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$f,e=h,a=navigator.language;else if(typeof n=="object"){S=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",D=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,u=g,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$f,e=t.$f;const M=n.env.VSCODE_NLS_CONFIG;if(M)try{const H=JSON.parse(M),j=H.availableLanguages["*"];h=H.locale,a=H.osLocale,e=j||t.$f,o=H._translationsConfigFile}catch{}v=!0}else console.error("Unable to resolve platform.");var $;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})($||(t.Platform=$={}));function c(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=c;let O=0;i?O=1:S?O=3:U&&(O=2),t.$i=S,t.$j=i,t.$k=U,t.$l=D,t.$m=v,t.$n=u,t.$o=l,t.$p=l&&typeof t.$g.importScripts=="function",t.$q=f,t.$r=r,t.$s=P,t.$t=O,t.$u=s,t.$v=e;var R;(function(M){function H(){return t.$v}M.value=H;function j(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}M.isDefaultVariant=j;function W(){return t.$v==="en"}M.isDefault=W})(R||(t.Language=R={})),t.$w=h,t.$x=a,t.$y=o,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const M=[];t.$g.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let W=0,ee=M.length;W<ee;W++){const ne=M[W];if(ne.id===j.data.vscodeScheduleAsyncWork){M.splice(W,1),ne.callback();return}}});let H=0;return j=>{const W=++H;M.push({id:W,callback:j}),t.$g.postMessage({vscodeScheduleAsyncWork:W},"*")}}return M=>setTimeout(M)})();var L;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=i||f?2:S?1:3;let m=!0,p=!1;function N(){if(!p){p=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,m=new Uint16Array(M.buffer)[0]===(2<<8)+1}return m}t.$C=N,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),define(me[111],$e([1,0,16,5]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7N=t.KeyboardSupport=void 0;var i;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$7N={clipboard:{writeText:S.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:S.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>S.$m||y.$5N()?0:navigator.keyboard||y.$1N?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[14],$e([1,0,16,42,75,5]),function(oe,t,y,S,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cO=t.$bO=t.$aO=void 0;function D(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return S.KeyCodeUtils.fromString(o)}const a=e.keyCode;if(a===3)return 7;if(y.$XN)switch(a){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(y.$YN){if(U.$j&&a===93)return 57;if(!U.$j&&a===92)return 57}return S.$nq[a]||0}const v=U.$j?256:2048,l=512,u=1024,f=U.$j?2048:256;function P(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$aO=P;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${S.KeyCodeUtils.toString(e.keyCode)}')`}t.$bO=r;class h{constructor(a){this._standardKeyboardEventBrand=!0;const o=a;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState("AltGraph"),this.keyCode=D(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let o=0;return this.ctrlKey&&(o|=v),this.altKey&&(o|=l),this.shiftKey&&(o|=u),this.metaKey&&(o|=f),o|=a,o}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.$vq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.$cO=h}),define(me[19],$e([1,0,16,66,5]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_N=t.$$N=t.$0N=void 0;class U{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=u.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=S.$8N.getPositionOfChildWindowRelativeToAncestorWindow(window,u.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$0N=U;class D extends U{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.$$N=D;class v{constructor(u,f=0,P=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=P,this.deltaX=f,u){const r=u,h=u;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof h.VERTICAL_AXIS<"u"&&h.axis===h.VERTICAL_AXIS)this.deltaY=-h.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$XN&&!i.$j?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof r.wheelDeltaX<"u")y.$1N&&i.$i?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof h.HORIZONTAL_AXIS<"u"&&h.axis===h.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?y.$XN&&!i.$j?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$_N=v}),define(me[112],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.env=t.cwd=void 0;let S;if(typeof y.$g.vscode<"u"&&typeof y.$g.vscode.process<"u"){const i=y.$g.vscode.process;S={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?S={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:S={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=S.cwd,t.env=S.env,t.$5c=S.platform,t.$6c=S.arch}),define(me[22],$e([1,0,112]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=t.sep=t.$gd=t.$fd=t.$ed=t.$dd=t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=void 0;const S=65,i=97,U=90,D=122,v=46,l=47,u=92,f=58,P=63;class r extends Error{constructor(O,R,L){let m;typeof R=="string"&&R.indexOf("not ")===0?(m="must not be",R=R.replace(/^not /,"")):m="must be";const p=O.indexOf(".")!==-1?"property":"argument";let N=`The "${O}" ${p} ${m} of type ${R}`;N+=`. Received type ${typeof L}`,super(N),this.code="ERR_INVALID_ARG_TYPE"}}function h(c,O){if(c===null||typeof c!="object")throw new r(O,"Object",c)}function e(c,O){if(typeof c!="string")throw new r(O,"string",c)}const a=y.$5c==="win32";function o(c){return c===l||c===u}function s(c){return c===l}function n(c){return c>=S&&c<=U||c>=i&&c<=D}function g(c,O,R,L){let m="",p=0,N=-1,M=0,H=0;for(let j=0;j<=c.length;++j){if(j<c.length)H=c.charCodeAt(j);else{if(L(H))break;H=l}if(L(H)){if(!(N===j-1||M===1))if(M===2){if(m.length<2||p!==2||m.charCodeAt(m.length-1)!==v||m.charCodeAt(m.length-2)!==v){if(m.length>2){const W=m.lastIndexOf(R);W===-1?(m="",p=0):(m=m.slice(0,W),p=m.length-1-m.lastIndexOf(R)),N=j,M=0;continue}else if(m.length!==0){m="",p=0,N=j,M=0;continue}}O&&(m+=m.length>0?`${R}..`:"..",p=2)}else m.length>0?m+=`${R}${c.slice(N+1,j)}`:m=c.slice(N+1,j),p=j-N-1;N=j,M=0}else H===v&&M!==-1?++M:M=-1}return m}function b(c,O){h(O,"pathObject");const R=O.dir||O.root,L=O.base||`${O.name||""}${O.ext||""}`;return R?R===O.root?`${R}${L}`:`${R}${c}${L}`:L}t.$7c={resolve(...c){let O="",R="",L=!1;for(let m=c.length-1;m>=-1;m--){let p;if(m>=0){if(p=c[m],e(p,"path"),p.length===0)continue}else O.length===0?p=y.cwd():(p=y.env[`=${O}`]||y.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==O.toLowerCase()&&p.charCodeAt(2)===u)&&(p=`${O}\\`));const N=p.length;let M=0,H="",j=!1;const W=p.charCodeAt(0);if(N===1)o(W)&&(M=1,j=!0);else if(o(W))if(j=!0,o(p.charCodeAt(1))){let ee=2,ne=ee;for(;ee<N&&!o(p.charCodeAt(ee));)ee++;if(ee<N&&ee!==ne){const re=p.slice(ne,ee);for(ne=ee;ee<N&&o(p.charCodeAt(ee));)ee++;if(ee<N&&ee!==ne){for(ne=ee;ee<N&&!o(p.charCodeAt(ee));)ee++;(ee===N||ee!==ne)&&(H=`\\\\${re}\\${p.slice(ne,ee)}`,M=ee)}}}else M=1;else n(W)&&p.charCodeAt(1)===f&&(H=p.slice(0,2),M=2,N>2&&o(p.charCodeAt(2))&&(j=!0,M=3));if(H.length>0)if(O.length>0){if(H.toLowerCase()!==O.toLowerCase())continue}else O=H;if(L){if(O.length>0)break}else if(R=`${p.slice(M)}\\${R}`,L=j,j&&O.length>0)break}return R=g(R,!L,"\\",o),L?`${O}\\${R}`:`${O}${R}`||"."},normalize(c){e(c,"path");const O=c.length;if(O===0)return".";let R=0,L,m=!1;const p=c.charCodeAt(0);if(O===1)return s(p)?"\\":c;if(o(p))if(m=!0,o(c.charCodeAt(1))){let M=2,H=M;for(;M<O&&!o(c.charCodeAt(M));)M++;if(M<O&&M!==H){const j=c.slice(H,M);for(H=M;M<O&&o(c.charCodeAt(M));)M++;if(M<O&&M!==H){for(H=M;M<O&&!o(c.charCodeAt(M));)M++;if(M===O)return`\\\\${j}\\${c.slice(H)}\\`;M!==H&&(L=`\\\\${j}\\${c.slice(H,M)}`,R=M)}}}else R=1;else n(p)&&c.charCodeAt(1)===f&&(L=c.slice(0,2),R=2,O>2&&o(c.charCodeAt(2))&&(m=!0,R=3));let N=R<O?g(c.slice(R),!m,"\\",o):"";return N.length===0&&!m&&(N="."),N.length>0&&o(c.charCodeAt(O-1))&&(N+="\\"),L===void 0?m?`\\${N}`:N:m?`${L}\\${N}`:`${L}${N}`},isAbsolute(c){e(c,"path");const O=c.length;if(O===0)return!1;const R=c.charCodeAt(0);return o(R)||O>2&&n(R)&&c.charCodeAt(1)===f&&o(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let O,R;for(let p=0;p<c.length;++p){const N=c[p];e(N,"path"),N.length>0&&(O===void 0?O=R=N:O+=`\\${N}`)}if(O===void 0)return".";let L=!0,m=0;if(typeof R=="string"&&o(R.charCodeAt(0))){++m;const p=R.length;p>1&&o(R.charCodeAt(1))&&(++m,p>2&&(o(R.charCodeAt(2))?++m:L=!1))}if(L){for(;m<O.length&&o(O.charCodeAt(m));)m++;m>=2&&(O=`\\${O.slice(m)}`)}return t.$7c.normalize(O)},relative(c,O){if(e(c,"from"),e(O,"to"),c===O)return"";const R=t.$7c.resolve(c),L=t.$7c.resolve(O);if(R===L||(c=R.toLowerCase(),O=L.toLowerCase(),c===O))return"";let m=0;for(;m<c.length&&c.charCodeAt(m)===u;)m++;let p=c.length;for(;p-1>m&&c.charCodeAt(p-1)===u;)p--;const N=p-m;let M=0;for(;M<O.length&&O.charCodeAt(M)===u;)M++;let H=O.length;for(;H-1>M&&O.charCodeAt(H-1)===u;)H--;const j=H-M,W=N<j?N:j;let ee=-1,ne=0;for(;ne<W;ne++){const ce=c.charCodeAt(m+ne);if(ce!==O.charCodeAt(M+ne))break;ce===u&&(ee=ne)}if(ne!==W){if(ee===-1)return L}else{if(j>W){if(O.charCodeAt(M+ne)===u)return L.slice(M+ne+1);if(ne===2)return L.slice(M+ne)}N>W&&(c.charCodeAt(m+ne)===u?ee=ne:ne===2&&(ee=3)),ee===-1&&(ee=0)}let re="";for(ne=m+ee+1;ne<=p;++ne)(ne===p||c.charCodeAt(ne)===u)&&(re+=re.length===0?"..":"\\..");return M+=ee,re.length>0?`${re}${L.slice(M,H)}`:(L.charCodeAt(M)===u&&++M,L.slice(M,H))},toNamespacedPath(c){if(typeof c!="string"||c.length===0)return c;const O=t.$7c.resolve(c);if(O.length<=2)return c;if(O.charCodeAt(0)===u){if(O.charCodeAt(1)===u){const R=O.charCodeAt(2);if(R!==P&&R!==v)return`\\\\?\\UNC\\${O.slice(2)}`}}else if(n(O.charCodeAt(0))&&O.charCodeAt(1)===f&&O.charCodeAt(2)===u)return`\\\\?\\${O}`;return c},dirname(c){e(c,"path");const O=c.length;if(O===0)return".";let R=-1,L=0;const m=c.charCodeAt(0);if(O===1)return o(m)?c:".";if(o(m)){if(R=L=1,o(c.charCodeAt(1))){let M=2,H=M;for(;M<O&&!o(c.charCodeAt(M));)M++;if(M<O&&M!==H){for(H=M;M<O&&o(c.charCodeAt(M));)M++;if(M<O&&M!==H){for(H=M;M<O&&!o(c.charCodeAt(M));)M++;if(M===O)return c;M!==H&&(R=L=M+1)}}}}else n(m)&&c.charCodeAt(1)===f&&(R=O>2&&o(c.charCodeAt(2))?3:2,L=R);let p=-1,N=!0;for(let M=O-1;M>=L;--M)if(o(c.charCodeAt(M))){if(!N){p=M;break}}else N=!1;if(p===-1){if(R===-1)return".";p=R}return c.slice(0,p)},basename(c,O){O!==void 0&&e(O,"ext"),e(c,"path");let R=0,L=-1,m=!0,p;if(c.length>=2&&n(c.charCodeAt(0))&&c.charCodeAt(1)===f&&(R=2),O!==void 0&&O.length>0&&O.length<=c.length){if(O===c)return"";let N=O.length-1,M=-1;for(p=c.length-1;p>=R;--p){const H=c.charCodeAt(p);if(o(H)){if(!m){R=p+1;break}}else M===-1&&(m=!1,M=p+1),N>=0&&(H===O.charCodeAt(N)?--N===-1&&(L=p):(N=-1,L=M))}return R===L?L=M:L===-1&&(L=c.length),c.slice(R,L)}for(p=c.length-1;p>=R;--p)if(o(c.charCodeAt(p))){if(!m){R=p+1;break}}else L===-1&&(m=!1,L=p+1);return L===-1?"":c.slice(R,L)},extname(c){e(c,"path");let O=0,R=-1,L=0,m=-1,p=!0,N=0;c.length>=2&&c.charCodeAt(1)===f&&n(c.charCodeAt(0))&&(O=L=2);for(let M=c.length-1;M>=O;--M){const H=c.charCodeAt(M);if(o(H)){if(!p){L=M+1;break}continue}m===-1&&(p=!1,m=M+1),H===v?R===-1?R=M:N!==1&&(N=1):R!==-1&&(N=-1)}return R===-1||m===-1||N===0||N===1&&R===m-1&&R===L+1?"":c.slice(R,m)},format:b.bind(null,"\\"),parse(c){e(c,"path");const O={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return O;const R=c.length;let L=0,m=c.charCodeAt(0);if(R===1)return o(m)?(O.root=O.dir=c,O):(O.base=O.name=c,O);if(o(m)){if(L=1,o(c.charCodeAt(1))){let ee=2,ne=ee;for(;ee<R&&!o(c.charCodeAt(ee));)ee++;if(ee<R&&ee!==ne){for(ne=ee;ee<R&&o(c.charCodeAt(ee));)ee++;if(ee<R&&ee!==ne){for(ne=ee;ee<R&&!o(c.charCodeAt(ee));)ee++;ee===R?L=ee:ee!==ne&&(L=ee+1)}}}}else if(n(m)&&c.charCodeAt(1)===f){if(R<=2)return O.root=O.dir=c,O;if(L=2,o(c.charCodeAt(2))){if(R===3)return O.root=O.dir=c,O;L=3}}L>0&&(O.root=c.slice(0,L));let p=-1,N=L,M=-1,H=!0,j=c.length-1,W=0;for(;j>=L;--j){if(m=c.charCodeAt(j),o(m)){if(!H){N=j+1;break}continue}M===-1&&(H=!1,M=j+1),m===v?p===-1?p=j:W!==1&&(W=1):p!==-1&&(W=-1)}return M!==-1&&(p===-1||W===0||W===1&&p===M-1&&p===N+1?O.base=O.name=c.slice(N,M):(O.name=c.slice(N,p),O.base=c.slice(N,M),O.ext=c.slice(p,M))),N>0&&N!==L?O.dir=c.slice(0,N-1):O.dir=O.root,O},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(a){const c=/\\/g;return()=>{const O=y.cwd().replace(c,"/");return O.slice(O.indexOf("/"))}}return()=>y.cwd()})();t.$8c={resolve(...c){let O="",R=!1;for(let L=c.length-1;L>=-1&&!R;L--){const m=L>=0?c[L]:$();e(m,"path"),m.length!==0&&(O=`${m}/${O}`,R=m.charCodeAt(0)===l)}return O=g(O,!R,"/",s),R?`/${O}`:O.length>0?O:"."},normalize(c){if(e(c,"path"),c.length===0)return".";const O=c.charCodeAt(0)===l,R=c.charCodeAt(c.length-1)===l;return c=g(c,!O,"/",s),c.length===0?O?"/":R?"./":".":(R&&(c+="/"),O?`/${c}`:c)},isAbsolute(c){return e(c,"path"),c.length>0&&c.charCodeAt(0)===l},join(...c){if(c.length===0)return".";let O;for(let R=0;R<c.length;++R){const L=c[R];e(L,"path"),L.length>0&&(O===void 0?O=L:O+=`/${L}`)}return O===void 0?".":t.$8c.normalize(O)},relative(c,O){if(e(c,"from"),e(O,"to"),c===O||(c=t.$8c.resolve(c),O=t.$8c.resolve(O),c===O))return"";const R=1,L=c.length,m=L-R,p=1,N=O.length-p,M=m<N?m:N;let H=-1,j=0;for(;j<M;j++){const ee=c.charCodeAt(R+j);if(ee!==O.charCodeAt(p+j))break;ee===l&&(H=j)}if(j===M)if(N>M){if(O.charCodeAt(p+j)===l)return O.slice(p+j+1);if(j===0)return O.slice(p+j)}else m>M&&(c.charCodeAt(R+j)===l?H=j:j===0&&(H=0));let W="";for(j=R+H+1;j<=L;++j)(j===L||c.charCodeAt(j)===l)&&(W+=W.length===0?"..":"/..");return`${W}${O.slice(p+H)}`},toNamespacedPath(c){return c},dirname(c){if(e(c,"path"),c.length===0)return".";const O=c.charCodeAt(0)===l;let R=-1,L=!0;for(let m=c.length-1;m>=1;--m)if(c.charCodeAt(m)===l){if(!L){R=m;break}}else L=!1;return R===-1?O?"/":".":O&&R===1?"//":c.slice(0,R)},basename(c,O){O!==void 0&&e(O,"ext"),e(c,"path");let R=0,L=-1,m=!0,p;if(O!==void 0&&O.length>0&&O.length<=c.length){if(O===c)return"";let N=O.length-1,M=-1;for(p=c.length-1;p>=0;--p){const H=c.charCodeAt(p);if(H===l){if(!m){R=p+1;break}}else M===-1&&(m=!1,M=p+1),N>=0&&(H===O.charCodeAt(N)?--N===-1&&(L=p):(N=-1,L=M))}return R===L?L=M:L===-1&&(L=c.length),c.slice(R,L)}for(p=c.length-1;p>=0;--p)if(c.charCodeAt(p)===l){if(!m){R=p+1;break}}else L===-1&&(m=!1,L=p+1);return L===-1?"":c.slice(R,L)},extname(c){e(c,"path");let O=-1,R=0,L=-1,m=!0,p=0;for(let N=c.length-1;N>=0;--N){const M=c.charCodeAt(N);if(M===l){if(!m){R=N+1;break}continue}L===-1&&(m=!1,L=N+1),M===v?O===-1?O=N:p!==1&&(p=1):O!==-1&&(p=-1)}return O===-1||L===-1||p===0||p===1&&O===L-1&&O===R+1?"":c.slice(O,L)},format:b.bind(null,"/"),parse(c){e(c,"path");const O={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return O;const R=c.charCodeAt(0)===l;let L;R?(O.root="/",L=1):L=0;let m=-1,p=0,N=-1,M=!0,H=c.length-1,j=0;for(;H>=L;--H){const W=c.charCodeAt(H);if(W===l){if(!M){p=H+1;break}continue}N===-1&&(M=!1,N=H+1),W===v?m===-1?m=H:j!==1&&(j=1):m!==-1&&(j=-1)}if(N!==-1){const W=p===0&&R?1:p;m===-1||j===0||j===1&&m===N-1&&m===p+1?O.base=O.name=c.slice(W,N):(O.name=c.slice(W,m),O.base=c.slice(W,N),O.ext=c.slice(m,N))}return p>0?O.dir=c.slice(0,p-1):R&&(O.dir="/"),O},sep:"/",delimiter:":",win32:null,posix:null},t.$8c.win32=t.$7c.win32=t.$7c,t.$8c.posix=t.$7c.posix=t.$8c,t.$9c=a?t.$7c.normalize:t.$8c.normalize,t.$0c=a?t.$7c.isAbsolute:t.$8c.isAbsolute,t.$$c=a?t.$7c.join:t.$8c.join,t.$_c=a?t.$7c.resolve:t.$8c.resolve,t.$ad=a?t.$7c.relative:t.$8c.relative,t.$bd=a?t.$7c.dirname:t.$8c.dirname,t.$cd=a?t.$7c.basename:t.$8c.basename,t.$dd=a?t.$7c.extname:t.$8c.extname,t.$ed=a?t.$7c.format:t.$8c.format,t.$fd=a?t.$7c.parse:t.$8c.parse,t.$gd=a?t.$7c.toNamespacedPath:t.$8c.toNamespacedPath,t.sep=a?t.$7c.sep:t.$8c.sep,t.$id=a?t.$7c.delimiter:t.$8c.delimiter}),define(me[113],$e([1,0,22,5,11,7]),function(oe,t,y,S,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=void 0;function D(p){return p===47||p===92}t.$De=D;function v(p){return p.replace(/[\\/]/g,y.$8c.sep)}t.$Ee=v;function l(p){return p.indexOf("/")===-1&&(p=v(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}t.$Fe=l;function u(p,N=y.$8c.sep){if(!p)return"";const M=p.length,H=p.charCodeAt(0);if(D(H)){if(D(p.charCodeAt(1))&&!D(p.charCodeAt(2))){let W=3;const ee=W;for(;W<M&&!D(p.charCodeAt(W));W++);if(ee!==W&&!D(p.charCodeAt(W+1))){for(W+=1;W<M;W++)if(D(p.charCodeAt(W)))return p.slice(0,W+1).replace(/[\\/]/g,N)}}return N}else if(s(H)&&p.charCodeAt(1)===58)return D(p.charCodeAt(2))?p.slice(0,2)+N:p.slice(0,2);let j=p.indexOf("://");if(j!==-1){for(j+=3;j<M;j++)if(D(p.charCodeAt(j)))return p.slice(0,j+1)}return""}t.$Ge=u;function f(p){if(!S.$i||!p||p.length<5)return!1;let N=p.charCodeAt(0);if(N!==92||(N=p.charCodeAt(1),N!==92))return!1;let M=2;const H=M;for(;M<p.length&&(N=p.charCodeAt(M),N!==92);M++);return!(H===M||(N=p.charCodeAt(M+1),isNaN(N)||N===92))}t.$He=f;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(p,N=S.$i){const M=N?P:r;return!(!p||p.length===0||/^\s+$/.test(p)||(M.lastIndex=0,M.test(p))||N&&h.test(p)||p==="."||p===".."||N&&p[p.length-1]==="."||N&&p.length!==p.trim().length||p.length>255)}t.$Ie=e;function a(p,N,M){const H=p===N;return!M||H?H:!p||!N?!1:(0,i.$Od)(p,N)}t.$Je=a;function o(p,N,M,H=y.sep){if(p===N)return!0;if(!p||!N||N.length>p.length)return!1;if(M){if(!(0,i.$Pd)(p,N))return!1;if(N.length===p.length)return!0;let W=N.length;return N.charAt(N.length-1)===H&&W--,p.charAt(W)===H}return N.charAt(N.length-1)!==H&&(N+=H),p.indexOf(N)===0}t.$Ke=o;function s(p){return p>=65&&p<=90||p>=97&&p<=122}t.$Le=s;function n(p,N){return S.$i&&p.endsWith(":")&&(p+=y.sep),(0,y.$0c)(p)||(p=(0,y.$$c)(N,p)),p=(0,y.$9c)(p),S.$i?(p=(0,i.$xd)(p,y.sep),p.endsWith(":")&&(p+=y.sep)):(p=(0,i.$xd)(p,y.sep),p||(p=y.sep)),p}t.$Me=n;function g(p){const N=(0,y.$9c)(p);return S.$i?p.length>3?!1:b(N)&&(p.length===2||N.charCodeAt(2)===92):N===y.$8c.sep}t.$Ne=g;function b(p,N=S.$i){return N?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}t.$Oe=b;function $(p,N=S.$i){return b(p,N)?p[0]:void 0}t.$Pe=$;function c(p,N,M){return N.length>p.length?-1:p===N?0:(M&&(p=p.toLowerCase(),N=N.toLowerCase()),p.indexOf(N))}t.$Qe=c;function O(p){const N=p.split(":");let M,H,j;for(const W of N){const ee=Number(W);(0,U.$pe)(ee)?H===void 0?H=ee:j===void 0&&(j=ee):M=M?[M,W].join(":"):W}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:H!==void 0?H:void 0,column:j!==void 0?j:H!==void 0?1:void 0}}t.$Re=O;const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m(p,N,M=8){let H="";for(let W=0;W<M;W++){let ee;W===0&&S.$i&&!N&&(M===3||M===4)?ee=L:ee=R,H+=ee.charAt(Math.floor(Math.random()*ee.length))}let j;return N?j=`${N}-${H}`:j=H,p?(0,y.$$c)(p,j):j}t.$Se=m}),define(me[114],$e([1,0,22]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ir=t.$Hr=t.$Gr=t.$Fr=t.$Er=void 0,t.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(f){const P=(0,y.$dd)(f),r=S[P.toLowerCase()];return r!==void 0?r:D(f)}t.$Fr=U;function D(f){const P=(0,y.$dd)(f);return i[P.toLowerCase()]}t.$Gr=D;function v(f){for(const P in i)if(i[P]===f)return P}t.$Hr=v;const l=/^(.+)\/(.+?)(;.+)?$/;function u(f,P){const r=l.exec(f);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:f}t.$Ir=u}),define(me[15],$e([1,0,22,5]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ve=t.$Ue=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,D=/^\/\//;function v(L,m){if(!L.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!U.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(L,m){return!L&&!m?"file":L}function u(L,m){switch(L){case"https":case"http":case"file":m?m[0]!==P&&(m=P+m):m=P;break}return m}const f="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(m){return m instanceof h?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,p,N,M,H,j=!1){typeof m=="object"?(this.scheme=m.scheme||f,this.authority=m.authority||f,this.path=m.path||f,this.query=m.query||f,this.fragment=m.fragment||f):(this.scheme=l(m,j),this.authority=p||f,this.path=u(this.scheme,N||f),this.query=M||f,this.fragment=H||f,v(this,j))}get fsPath(){return b(this,!1)}with(m){if(!m)return this;let{scheme:p,authority:N,path:M,query:H,fragment:j}=m;return p===void 0?p=this.scheme:p===null&&(p=f),N===void 0?N=this.authority:N===null&&(N=f),M===void 0?M=this.path:M===null&&(M=f),H===void 0?H=this.query:H===null&&(H=f),j===void 0?j=this.fragment:j===null&&(j=f),p===this.scheme&&N===this.authority&&M===this.path&&H===this.query&&j===this.fragment?this:new o(p,N,M,H,j)}static parse(m,p=!1){const N=r.exec(m);return N?new o(N[2]||f,R(N[4]||f),R(N[5]||f),R(N[7]||f),R(N[9]||f),p):new o(f,f,f,f,f)}static file(m){let p=f;if(S.$i&&(m=m.replace(/\\/g,P)),m[0]===P&&m[1]===P){const N=m.indexOf(P,2);N===-1?(p=m.substring(2),m=P):(p=m.substring(2,N),m=m.substring(N)||P)}return new o("file",p,m,f,f)}static from(m,p){return new o(m.scheme,m.authority,m.path,m.query,m.fragment,p)}static joinPath(m,...p){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return S.$i&&m.scheme==="file"?N=h.file(y.$7c.join(b(m,!0),...p)).path:N=y.$8c.join(m.path,...p),m.with({path:N})}toString(m=!1){return $(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof h)return m;{const p=new o(m);return p._formatted=m.external??null,p._fsPath=m._sep===a?m.fsPath??null:null,p}}else return m}}t.URI=h;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$Ue=e;const a=S.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(m=!1){return m?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=a),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(L,m,p){let N,M=-1;for(let H=0;H<L.length;H++){const j=L.charCodeAt(H);if(j>=97&&j<=122||j>=65&&j<=90||j>=48&&j<=57||j===45||j===46||j===95||j===126||m&&j===47||p&&j===91||p&&j===93||p&&j===58)M!==-1&&(N+=encodeURIComponent(L.substring(M,H)),M=-1),N!==void 0&&(N+=L.charAt(H));else{N===void 0&&(N=L.substr(0,H));const W=s[j];W!==void 0?(M!==-1&&(N+=encodeURIComponent(L.substring(M,H)),M=-1),N+=W):M===-1&&(M=H)}}return M!==-1&&(N+=encodeURIComponent(L.substring(M))),N!==void 0?N:L}function g(L){let m;for(let p=0;p<L.length;p++){const N=L.charCodeAt(p);N===35||N===63?(m===void 0&&(m=L.substr(0,p)),m+=s[N]):m!==void 0&&(m+=L[p])}return m!==void 0?m:L}function b(L,m){let p;return L.authority&&L.path.length>1&&L.scheme==="file"?p=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?m?p=L.path.substr(1):p=L.path[1].toLowerCase()+L.path.substr(2):p=L.path,S.$i&&(p=p.replace(/\//g,"\\")),p}t.$Ve=b;function $(L,m){const p=m?g:n;let N="",{scheme:M,authority:H,path:j,query:W,fragment:ee}=L;if(M&&(N+=M,N+=":"),(H||M==="file")&&(N+=P,N+=P),H){let ne=H.indexOf("@");if(ne!==-1){const re=H.substr(0,ne);H=H.substr(ne+1),ne=re.lastIndexOf(":"),ne===-1?N+=p(re,!1,!1):(N+=p(re.substr(0,ne),!1,!1),N+=":",N+=p(re.substr(ne+1),!1,!0)),N+="@"}H=H.toLowerCase(),ne=H.lastIndexOf(":"),ne===-1?N+=p(H,!1,!0):(N+=p(H.substr(0,ne),!1,!0),N+=H.substr(ne))}if(j){if(j.length>=3&&j.charCodeAt(0)===47&&j.charCodeAt(2)===58){const ne=j.charCodeAt(1);ne>=65&&ne<=90&&(j=`/${String.fromCharCode(ne+32)}:${j.substr(3)}`)}else if(j.length>=2&&j.charCodeAt(1)===58){const ne=j.charCodeAt(0);ne>=65&&ne<=90&&(j=`${String.fromCharCode(ne+32)}:${j.substr(2)}`)}N+=p(j,!0,!1)}return W&&(N+="?",N+=p(W,!1,!1)),ee&&(N+="#",N+=m?ee:n(ee,!1,!1)),N}function c(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+c(L.substr(3)):L}}const O=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(L){return L.match(O)?L.replace(O,m=>c(m)):L}}),define(me[50],$e([1,0,31,15]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9g=t.$8g=t.$7g=void 0;function i(l){return JSON.stringify(l,D)}t.$7g=i;function U(l){let u=JSON.parse(l);return u=v(u),u}t.$8g=U;function D(l,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function v(l,u=0){if(!l||u>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return S.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof y.$Hc||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let f=0;f<l.length;++f)l[f]=v(l[f],u+1);else for(const f in l)Object.hasOwnProperty.call(l,f)&&(l[f]=v(l[f],u+1))}return l}t.$9g=v}),define(me[28],$e([1,0,6,5,15]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.Schemas=void 0;var U;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$We="vscode-tkn",t.$Xe="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${U.vscodeRemoteResource}`}set(f,P,r){this.a[f]=P,this.b[f]=r}setConnectionToken(f,P){this.c[f]=P}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(o){return y.$Y(o),f}const P=f.authority;let r=this.a[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const h=this.b[P],e=this.c[P];let a=`path=${encodeURIComponent(f.path)}`;return typeof e=="string"&&(a+=`&${t.$Xe}=${encodeURIComponent(e)}`),i.URI.from({scheme:S.$o?this.d:U.vscodeRemoteResource,authority:`${r}:${h}`,path:this.f,query:a})}}t.$Ye=new D,t.$Ze="vs/../../extensions",t.$1e="vs/../../node_modules",t.$2e="vs/../../node_modules.asar",t.$3e="vs/../../node_modules.asar.unpacked";class v{static{this.a="vscode-app"}asBrowserUri(f){const P=this.b(f,oe);return this.uriToBrowserUri(P)}uriToBrowserUri(f){return f.scheme===U.vscodeRemote?t.$Ye.rewrite(f):f.scheme===U.file&&(S.$m||S.$p&&S.$g.origin===`${U.vscodeFileResource}://${v.a}`)?f.with({scheme:U.vscodeFileResource,authority:f.authority||v.a,query:null,fragment:null}):f}asFileUri(f){const P=this.b(f,oe);return this.uriToFileUri(P)}uriToFileUri(f){return f.scheme===U.vscodeFileResource?f.with({scheme:U.file,authority:f.authority!==v.a?f.authority:null,query:null,fragment:null}):f}b(f,P){return i.URI.isUri(f)?f:i.URI.parse(P.toUrl(f))}}t.$4e=new v;var l;(function(u){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(f.get("3"));const P="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const o=a?.get(P);if(o)return f.get(o)}u.getHeadersFromQuery=r;function h(e,a,o){if(!globalThis.crossOriginIsolated)return;const s=a&&o?"3":o?"2":"1";e instanceof URLSearchParams?e.set(P,s):e[P]=s}u.addSearchParam=h})(l||(t.COI=l={}))}),define(me[35],$e([1,0,113,28,22,5,11,15]),function(oe,t,y,S,i,U,D,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qg=t.DataUri=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=void 0;function l(h){return(0,v.$Ve)(h,!0)}t.$7f=l;class u{constructor(e){this.a=e}compare(e,a,o=!1){return e===a?0:(0,D.$Hd)(this.getComparisonKey(e,o),this.getComparisonKey(a,o))}isEqual(e,a,o=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,o)===this.getComparisonKey(a,o)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,o=!1){if(e.scheme===a.scheme){if(e.scheme===S.Schemas.file)return y.$Ke(l(e),l(a),this.a(e))&&e.query===a.query&&(o||e.fragment===a.fragment);if((0,t.$lg)(e.authority,a.authority))return y.$Ke(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(o||e.fragment===a.fragment)}return!1}joinPath(e,...a){return v.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.$dg)(e)||e.authority}basename(e){return i.$8c.basename(e.path)}extname(e){return i.$8c.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===S.Schemas.file?a=v.URI.file(i.$bd(l(e))).path:(a=i.$8c.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===S.Schemas.file?a=v.URI.file(i.$9c(l(e))).path:a=i.$8c.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.$lg)(e.authority,a.authority))return;if(e.scheme===S.Schemas.file){const n=i.$ad(l(e),l(a));return U.$i?y.$Ee(n):n}let o=e.path||"/";const s=a.path||"/";if(this.a(e)){let n=0;for(const g=Math.min(o.length,s.length);n<g&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return i.$8c.relative(o,s)}resolvePath(e,a){if(e.scheme===S.Schemas.file){const o=v.URI.file(i.$_c(l(e),a));return e.with({authority:o.authority,path:o.path})}return a=y.$Fe(a),e.with({path:i.$8c.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,D.$Od)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===S.Schemas.file){const o=l(e);return o.length>y.$Ge(o).length&&o[o.length-1]===a}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.$mg)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let o=!1;if(e.scheme===S.Schemas.file){const s=l(e);o=s!==void 0&&s.length===y.$Ge(s).length&&s[s.length-1]===a}else{a="/";const s=e.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,t.$mg)(e,a)?e.with({path:e.path+"/"}):e}}t.$8f=u,t.$9f=new u(()=>!1),t.$0f=new u(h=>h.scheme===S.Schemas.file?!U.$k:!0),t.$$f=new u(h=>!0),t.$_f=t.$9f.isEqual.bind(t.$9f),t.$ag=t.$9f.isEqualOrParent.bind(t.$9f),t.$bg=t.$9f.getComparisonKey.bind(t.$9f),t.$cg=t.$9f.basenameOrAuthority.bind(t.$9f),t.$dg=t.$9f.basename.bind(t.$9f),t.$eg=t.$9f.extname.bind(t.$9f),t.$fg=t.$9f.dirname.bind(t.$9f),t.$gg=t.$9f.joinPath.bind(t.$9f),t.$hg=t.$9f.normalizePath.bind(t.$9f),t.$ig=t.$9f.relativePath.bind(t.$9f),t.$jg=t.$9f.resolvePath.bind(t.$9f),t.$kg=t.$9f.isAbsolutePath.bind(t.$9f),t.$lg=t.$9f.isEqualAuthority.bind(t.$9f),t.$mg=t.$9f.hasTrailingPathSeparator.bind(t.$9f),t.$ng=t.$9f.removeTrailingPathSeparator.bind(t.$9f),t.$og=t.$9f.addTrailingPathSeparator.bind(t.$9f);function f(h,e){const a=[];for(let o=0;o<h.length;o++){const s=e(h[o]);h.some((n,g)=>g===o?!1:(0,t.$ag)(s,e(n)))||a.push(h[o])}return a}t.$pg=f;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(a){const o=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(g=>{const[b,$]=g.split(":");b&&$&&o.set(b,$)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&o.set(h.META_DATA_MIME,n),o}h.parseMetaData=e})(P||(t.DataUri=P={}));function r(h,e,a){if(e){let o=h.path;return o&&o[0]!==i.$8c.sep&&(o=i.$8c.sep+o),h.with({scheme:a,authority:e,path:o})}return h.with({scheme:a})}t.$qg=r}),define(me[9],$e([1,0,27,6,3,2,35,5,47]),function(oe,t,y,S,i,U,D,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3g=t.$2g=t.$1g=t.Promises=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=void 0;function u(d){return!!d&&typeof d.then=="function"}t.$rg=u;function f(d){const w=new y.$rc,E=d(w.token),I=new Promise((F,B)=>{const q=w.token.onCancellationRequested(()=>{q.dispose(),w.dispose(),B(new S.$3)});Promise.resolve(E).then(T=>{q.dispose(),w.dispose(),F(T)},T=>{q.dispose(),w.dispose(),B(T)})});return new class{cancel(){w.cancel()}then(F,B){return I.then(F,B)}catch(F){return this.then(void 0,F)}finally(F){return I.finally(F)}}}t.$sg=f;function P(d,w,E){return new Promise((I,F)=>{const B=w.onCancellationRequested(()=>{B.dispose(),I(E)});d.then(I,F).finally(()=>B.dispose())})}t.$tg=P;function r(d,w){return new Promise((E,I)=>{const F=w.onCancellationRequested(()=>{F.dispose(),I(new S.$3)});d.then(E,I).finally(()=>F.dispose())})}t.$ug=r;async function h(d){let w=-1;const E=d.map((I,F)=>I.then(B=>(w=F,B)));try{return await Promise.race(E)}finally{d.forEach((I,F)=>{F!==w&&I.cancel()})}}t.$vg=h;function e(d,w,E){let I;const F=setTimeout(()=>{I?.(void 0),E?.()},w);return Promise.race([d.finally(()=>clearTimeout(F)),new Promise(B=>I=B)])}t.$wg=e;function a(d){return new Promise((w,E)=>{const I=d();u(I)?I.then(w,E):w(I)})}t.$xg=a;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(w){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=w,!this.b){const E=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(E,E).then(I)})}return new Promise((E,I)=>{this.b.then(E,I)})}return this.a=w(),new Promise((E,I)=>{this.a.then(F=>{this.a=null,E(F)},F=>{this.a=null,I(F)})})}dispose(){this.f=!0}}t.$yg=o;class s{constructor(){this.a=Promise.resolve(null)}queue(w){return this.a=this.a.then(()=>w(),()=>w())}}t.$zg=s;class n{constructor(){this.a=new Map}queue(w,E){const F=(this.a.get(w)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(w)===F&&this.a.delete(w)});return this.a.set(w,F),F}}t.$Ag=n;const g=(d,w)=>{let E=!0;const I=setTimeout(()=>{E=!1,w()},d);return{isTriggered:()=>E,dispose:()=>{clearTimeout(I),E=!1}}},b=d=>{let w=!0;return queueMicrotask(()=>{w&&(w=!1,d())}),{isTriggered:()=>w,dispose:()=>{w=!1}}};class ${constructor(w){this.defaultDelay=w,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(w,E=this.defaultDelay){this.g=w,this.h(),this.b||(this.b=new Promise((F,B)=>{this.d=F,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=E===l.$ec?b(I):g(E,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Bg=$;class c{constructor(w){this.a=new $(w),this.b=new o}trigger(w,E){return this.a.trigger(()=>this.b.queue(w),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Cg=c;class O{constructor(){this.a=!1,this.b=new Promise((w,E)=>{this.d=w})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Dg=O;class R extends O{constructor(w){super(),this.f=setTimeout(()=>this.open(),w)}open(){clearTimeout(this.f),super.open()}}t.$Eg=R;function L(d,w){return w?new Promise((E,I)=>{const F=setTimeout(()=>{B.dispose(),E()},d),B=w.onCancellationRequested(()=>{clearTimeout(F),B.dispose(),I(new S.$3)})}):f(E=>L(d,E))}t.$Fg=L;function m(d,w=0){const E=setTimeout(d,w);return(0,U.$kb)(()=>clearTimeout(E))}t.$Gg=m;function p(d){const w=[];let E=0;const I=d.length;function F(){return E<I?d[E++]():null}function B(q){q!=null&&w.push(q);const T=F();return T?T.then(B):Promise.resolve(w)}return Promise.resolve(null).then(B)}t.$Hg=p;function N(d,w=I=>!!I,E=null){let I=0;const F=d.length,B=()=>{if(I>=F)return Promise.resolve(E);const q=d[I++];return Promise.resolve(q()).then(z=>w(z)?Promise.resolve(z):B())};return B()}t.$Ig=N;function M(d,w=I=>!!I,E=null){if(d.length===0)return Promise.resolve(E);let I=d.length;const F=()=>{I=-1;for(const B of d)B.cancel?.()};return new Promise((B,q)=>{for(const T of d)T.then(z=>{--I>=0&&w(z)?(F(),B(z)):I===0&&B(E)}).catch(z=>{--I>=0&&(F(),q(z))})})}t.$Jg=M;class H{constructor(w){this.a=0,this.d=w,this.f=[],this.b=0,this.g=new i.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(w){return this.a++,new Promise((E,I)=>{this.f.push({factory:w,c:E,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const w=this.f.shift();this.b++;const E=w.factory();E.then(w.c,w.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Kg=H;class j extends H{constructor(){super(1)}}t.$Lg=j;class W{constructor(){this.a=new Me,this.b=0}queue(w){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,w())):this.a.run(this.b++,w())}}t.$Mg=W;class ee{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const w=new G;return this.b.add(w),w.p}g(){for(const[,w]of this.a)if(w.size>0)return!1;return!0}queueFor(w,E=D.$9f){const I=E.getComparisonKey(w);let F=this.a.get(I);if(!F){F=new j;const B=this.f++,q=i.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(I),this.h(),this.d?.deleteAndDispose(B),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$ub),this.d.set(B,q),this.a.set(I,F)}return F}h(){this.g()&&this.j()}j(){for(const w of this.b)w.complete();this.b.clear()}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Ng=ee;class ne{constructor(w,E){this.a=-1,typeof w=="function"&&typeof E=="number"&&this.setIfNotSet(w,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(w,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,w()},E)}setIfNotSet(w,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,w()},E))}}t.$Og=ne;class re{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(w,E){this.cancel(),this.a=setInterval(()=>{w()},E)}}t.$Pg=re;class ce{constructor(w,E){this.b=-1,this.a=w,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(w=this.d){this.cancel(),this.b=setTimeout(this.f,w)}get delay(){return this.d}set delay(w){this.d=w}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Qg=ce;class he{constructor(w,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=w,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(w=this.b){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(w/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Rg=he;class ae extends ce{constructor(w,E){super(w,E),this.j=[]}work(w){this.j.push(w),this.isScheduled()||this.schedule()}h(){const w=this.j;this.j=[],this.a?.(w)}dispose(){this.j=[],super.dispose()}}t.$Sg=ae;class we extends U.$mb{constructor(w,E){super(),this.g=w,this.h=E,this.a=[],this.b=this.B(new U.$nb),this.f=!1}get pending(){return this.a.length}work(w){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+w.length>this.g.maxBufferedWork)return!1}else if(this.pending+w.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of w)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Tg=we,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$Ug=d=>{(0,v.$A)(()=>{if(w)return;const E=Date.now()+15;d(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:t.$Ug=(d,w)=>{const E=requestIdleCallback(d,typeof w=="number"?{timeout:w}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(E))}}}}();class Oe{constructor(w){this.d=!1,this.a=()=>{try{this.f=w()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,t.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$Vg=Oe;async function Ie(d,w,E){let I;for(let F=0;F<E;F++)try{return await d()}catch(B){I=B,await L(w)}throw I}t.$Wg=Ie;class Me{isRunning(w){return typeof w=="number"?this.a?.taskId===w:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(w,E,I){return this.a={taskId:w,cancel:()=>I?.(),promise:E},E.then(()=>this.d(w),()=>this.d(w)),E}d(w){this.a&&w===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const w=this.b;this.b=void 0,w.run().then(w.promiseResolve,w.promiseReject)}}queue(w){if(this.b)this.b.run=w;else{let E,I;const F=new Promise((B,q)=>{E=B,I=q});this.b={run:w,promise:F,promiseResolve:E,promiseReject:I}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Xg=Me;class fe{constructor(w,E=()=>Date.now()){this.d=w,this.f=E,this.a=0,this.b=0}increment(){const w=this.f();return w-this.a>this.d&&(this.a=w,this.b=0),this.b++,this.b}}t.$Yg=fe;var ie;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ie||(ie={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((w,E)=>{this.a=w,this.b=E})}complete(w){return new Promise(E=>{this.a(w),this.d={outcome:0,value:w},E()})}error(w){return new Promise(E=>{this.b(w),this.d={outcome:1,value:w},E()})}cancel(){return this.error(new S.$3)}}t.$Zg=G;var x;(function(d){async function w(I){let F;const B=await Promise.all(I.map(q=>q.then(T=>T,T=>{F||(F=T)})));if(typeof F<"u")throw F;return B}d.settled=w;function E(I){return new Promise(async(F,B)=>{try{await I(F,B)}catch(q){B(q)}})}d.withAsyncBody=E})(x||(t.Promises=x={}));var J;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(J||(J={}));class X{static fromArray(w){return new X(E=>{E.emitMany(w)})}static fromPromise(w){return new X(async E=>{E.emitMany(await w)})}static fromPromises(w){return new X(async E=>{await Promise.all(w.map(async I=>E.emitOne(await I)))})}static merge(w){return new X(async E=>{await Promise.all(w.map(async I=>{for await(const F of I)E.emitOne(F)}))})}static{this.EMPTY=X.fromArray([])}constructor(w){this.a=0,this.b=[],this.d=null,this.f=new i.$hc,queueMicrotask(async()=>{const E={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(w(E)),this.j()}catch(I){this.k(I)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let w=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(w<this.b.length)return{done:!1,value:this.b[w++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(w,E){return new X(async I=>{for await(const F of w)I.emitOne(E(F))})}map(w){return X.map(this,w)}static filter(w,E){return new X(async I=>{for await(const F of w)E(F)&&I.emitOne(F)})}filter(w){return X.filter(this,w)}static coalesce(w){return X.filter(w,E=>!!E)}coalesce(){return X.coalesce(this)}static async toPromise(w){const E=[];for await(const I of w)E.push(I);return E}toPromise(){return X.toPromise(this)}g(w){this.a===0&&(this.b.push(w),this.f.fire())}h(w){this.a===0&&(this.b=this.b.concat(w),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(w){this.a===0&&(this.a=2,this.d=w,this.f.fire())}}t.$1g=X;class k extends X{constructor(w,E){super(E),this.l=w}cancel(){this.l.cancel()}}t.$2g=k;function V(d){const w=new y.$rc,E=d(w.token);return new k(w,async I=>{const F=w.token.onCancellationRequested(()=>{F.dispose(),w.dispose(),I.reject(new S.$3)});try{for await(const B of E){if(w.token.isCancellationRequested)return;I.emitOne(B)}F.dispose(),w.dispose()}catch(B){F.dispose(),w.dispose(),I.reject(B)}})}t.$3g=V}),define(me[4],$e([1,0,16,111,14,19,9,6,3,115,2,28,5,15]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.DetectedFullscreenMode=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$=t.Namespace=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=void 0;function e(Z){for(;Z.firstChild;)Z.firstChild.remove()}t.$dO=e;function a(Z){return Z?.isConnected??!1}t.$eO=a;class o{constructor(Y,de,Ae,Se){this.f=Y,this.g=de,this.d=Ae,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(Z,Y,de,Ae){return new o(Z,Y,de,Ae)}t.$fO=s;function n(Z){return function(Y){return Z(new U.$0N(Y))}}function g(Z){return function(Y){return Z(new i.$cO(Y))}}const b=function(Y,de,Ae,Se){let We=Ae;return de==="click"||de==="mousedown"?We=n(Ae):(de==="keydown"||de==="keypress"||de==="keyup")&&(We=g(Ae)),s(Y,de,We,Se)};t.$gO=b;const $=function(Y,de,Ae){const Se=n(de);return O(Y,Se,Ae)};t.$hO=$;const c=function(Y,de,Ae){const Se=n(de);return L(Y,Se,Ae)};t.$iO=c;function O(Z,Y,de){return s(Z,r.$q&&S.$7N.pointerEvents?t.$TO.POINTER_DOWN:t.$TO.MOUSE_DOWN,Y,de)}t.$jO=O;function R(Z,Y,de){return s(Z,r.$q&&S.$7N.pointerEvents?t.$TO.POINTER_MOVE:t.$TO.MOUSE_MOVE,Y,de)}t.$kO=R;function L(Z,Y,de){return s(Z,r.$q&&S.$7N.pointerEvents?t.$TO.POINTER_UP:t.$TO.MOUSE_UP,Y,de)}t.$lO=L;class m{constructor(Y,de=0){this.d=Y,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,v.$Y)(Y)}}static sort(Y,de){return de.priority-Y.priority}}(function(){let Z=[],Y=null,de=!1,Ae=!1;const Se=()=>{for(de=!1,Y=Z,Z=[],Ae=!0;Y.length>0;)Y.sort(m.sort),Y.shift().execute();Ae=!1};t.$nO=(We,He=0)=>{const Je=new m(We,He);return Z.push(Je),de||(de=!0,requestAnimationFrame(Se)),Je},t.$mO=(We,He)=>{if(Ae){const Je=new m(We,He);return Y.push(Je),Je}else return(0,t.$nO)(We,He)}})();function p(Z){return(0,t.$nO)(Z,1e4)}t.$oO=p;function N(Z){return(0,t.$nO)(Z,-1e4)}t.$pO=N;const M=8,H=function(Z,Y){return Y};class j extends f.$mb{constructor(Y,de,Ae,Se=H,We=M){super();let He=null,Je=0;const at=this.B(new D.$Og),Ze=()=>{Je=new Date().getTime(),Ae(He),He=null};this.B(s(Y,de,pt=>{He=Se(He,pt);const Ct=new Date().getTime()-Je;Ct>=We?(at.cancel(),Ze()):at.setIfNotSet(Ze,We-Ct)}))}}function W(Z,Y,de,Ae,Se){return new j(Z,Y,de,Ae,Se)}t.$qO=W;function ee(Z){return document.defaultView.getComputedStyle(Z,null)}t.$rO=ee;function ne(Z){if(Z!==document.body)return new ce(Z.clientWidth,Z.clientHeight);if(r.$q&&window.visualViewport)return new ce(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ce(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ce(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ce(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$sO=ne;class re{static d(Y,de){return parseFloat(de)||0}static f(Y,de,Ae){const Se=ee(Y),We=Se?Se.getPropertyValue(de):"0";return re.d(Y,We)}static getBorderLeftWidth(Y){return re.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return re.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return re.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return re.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return re.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return re.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return re.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return re.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return re.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return re.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return re.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return re.f(Y,"margin-bottom","marginBottom")}}class ce{static{this.None=new ce(0,0)}constructor(Y,de){this.width=Y,this.height=de}with(Y=this.width,de=this.height){return Y!==this.width||de!==this.height?new ce(Y,de):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof ce?Y:new ce(Y.width,Y.height)}static equals(Y,de){return Y===de?!0:!Y||!de?!1:Y.width===de.width&&Y.height===de.height}}t.$tO=ce;function he(Z){let Y=Z.offsetParent,de=Z.offsetTop,Ae=Z.offsetLeft;for(;(Z=Z.parentNode)!==null&&Z!==document.body&&Z!==document.documentElement;){de-=Z.scrollTop;const Se=B(Z)?null:ee(Z);Se&&(Ae-=Se.direction!=="rtl"?Z.scrollLeft:-Z.scrollLeft),Z===Y&&(Ae+=re.getBorderLeftWidth(Z),de+=re.getBorderTopWidth(Z),de+=Z.offsetTop,Ae+=Z.offsetLeft,Y=Z.offsetParent)}return{left:Ae,top:de}}t.$uO=he;function ae(Z,Y,de){typeof Y=="number"&&(Z.style.width=`${Y}px`),typeof de=="number"&&(Z.style.height=`${de}px`)}t.$vO=ae;function we(Z,Y,de,Ae,Se,We="absolute"){typeof Y=="number"&&(Z.style.top=`${Y}px`),typeof de=="number"&&(Z.style.right=`${de}px`),typeof Ae=="number"&&(Z.style.bottom=`${Ae}px`),typeof Se=="number"&&(Z.style.left=`${Se}px`),Z.style.position=We}t.$wO=we;function Oe(Z){const Y=Z.getBoundingClientRect();return{left:Y.left+window.scrollX,top:Y.top+window.scrollY,width:Y.width,height:Y.height}}t.$xO=Oe;function Ie(Z){let Y=Z,de=1;do{const Ae=ee(Y).zoom;Ae!=null&&Ae!=="1"&&(de*=Ae),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return de}t.$yO=Ie;function Me(Z){const Y=re.getMarginLeft(Z)+re.getMarginRight(Z);return Z.offsetWidth+Y}t.$zO=Me;function fe(Z){const Y=re.getBorderLeftWidth(Z)+re.getBorderRightWidth(Z),de=re.getPaddingLeft(Z)+re.getPaddingRight(Z);return Z.offsetWidth-Y-de}t.$AO=fe;function ie(Z){const Y=re.getMarginLeft(Z)+re.getMarginRight(Z);return Z.scrollWidth+Y}t.$BO=ie;function G(Z){const Y=re.getBorderTopWidth(Z)+re.getBorderBottomWidth(Z),de=re.getPaddingTop(Z)+re.getPaddingBottom(Z);return Z.offsetHeight-Y-de}t.$CO=G;function x(Z){const Y=re.getMarginTop(Z)+re.getMarginBottom(Z);return Z.offsetHeight+Y}t.$DO=x;function J(Z,Y){if(Z===null)return 0;const de=he(Z),Ae=he(Y);return de.left-Ae.left}function X(Z,Y){const de=Y.map(Se=>Math.max(ie(Se),Me(Se))+J(Se,Z)||0);return Math.max(...de)}t.$EO=X;function k(Z,Y){for(;Z;){if(Z===Y)return!0;Z=Z.parentNode}return!1}t.$FO=k;const V="parentFlowToElementId";function d(Z,Y){Z.dataset[V]=Y.id}t.$GO=d;function w(Z){const Y=Z.dataset[V];return typeof Y=="string"?document.getElementById(Y):null}function E(Z,Y){let de=Z;for(;de;){if(de===Y)return!0;if(de instanceof HTMLElement){const Ae=w(de);if(Ae){de=Ae;continue}}de=de.parentNode}return!1}t.$HO=E;function I(Z,Y,de){for(;Z&&Z.nodeType===Z.ELEMENT_NODE;){if(Z.classList.contains(Y))return Z;if(de){if(typeof de=="string"){if(Z.classList.contains(de))return null}else if(Z===de)return null}Z=Z.parentNode}return null}t.$IO=I;function F(Z,Y,de){return!!I(Z,Y,de)}t.$JO=F;function B(Z){return Z&&!!Z.host&&!!Z.mode}t.$KO=B;function q(Z){return!!T(Z)}t.$LO=q;function T(Z){for(;Z.parentNode;){if(Z===document.body)return null;Z=Z.parentNode}return B(Z)?Z:null}t.$MO=T;function z(){let Z=document.activeElement;for(;Z?.shadowRoot;)Z=Z.shadowRoot.activeElement;return Z}t.$NO=z;function C(Z=document.getElementsByTagName("head")[0],Y){const de=document.createElement("style");return de.type="text/css",de.media="screen",Y?.(de),Z.appendChild(de),de}t.$OO=C;function A(Z=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return Z.appendChild(Y),Y}t.$PO=A;let _=null;function K(){return _||(_=C()),_}function te(Z){return Z?.sheet?.rules?Z.sheet.rules:Z?.sheet?.cssRules?Z.sheet.cssRules:[]}function se(Z,Y,de=K()){!de||!Y||de.sheet.insertRule(Z+"{"+Y+"}",0)}t.$QO=se;function ge(Z,Y=K()){if(!Y)return;const de=te(Y),Ae=[];for(let Se=0;Se<de.length;Se++)de[Se].selectorText.indexOf(Z)!==-1&&Ae.push(Se);for(let Se=Ae.length-1;Se>=0;Se--)Y.sheet.deleteRule(Ae[Se])}t.$RO=ge;function pe(Z){return typeof HTMLElement=="object"?Z instanceof HTMLElement:Z&&typeof Z=="object"&&Z.nodeType===1&&typeof Z.nodeName=="string"}t.$SO=pe,t.$TO={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$YN?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$YN?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$YN?"webkitAnimationIteration":"animationiteration"};function Ce(Z){const Y=Z;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.$UO=Ce,t.$VO={stop:(Z,Y)=>(Z.preventDefault(),Y&&Z.stopPropagation(),Z)};function Ee(Z){const Y=[];for(let de=0;Z&&Z.nodeType===Z.ELEMENT_NODE;de++)Y[de]=Z.scrollTop,Z=Z.parentNode;return Y}t.$WO=Ee;function ve(Z,Y){for(let de=0;Z&&Z.nodeType===Z.ELEMENT_NODE;de++)Z.scrollTop!==Y[de]&&(Z.scrollTop=Y[de]),Z=Z.parentNode}t.$XO=ve;class Te extends f.$mb{static l(Y){const de=T(Y),Ae=de?de.activeElement:document.activeElement;return k(Ae,Y)}constructor(Y){super(),this.f=this.B(new l.$hc),this.onDidFocus=this.f.event,this.g=this.B(new l.$hc),this.onDidBlur=this.g.event;let de=Te.l(Y),Ae=!1;const Se=()=>{Ae=!1,de||(de=!0,this.f.fire())},We=()=>{de&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,de=!1,this.g.fire())},0))};this.j=()=>{Te.l(Y)!==de&&(de?We():Se())},this.B(s(Y,t.$TO.FOCUS,Se,!0)),this.B(s(Y,t.$TO.BLUR,We,!0)),Y instanceof HTMLElement&&(this.B(s(Y,t.$TO.FOCUS_IN,()=>this.j())),this.B(s(Y,t.$TO.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Fe(Z){return new Te(Z)}t.$YO=Fe;function qe(Z,Y){return Z.after(Y),Y}t.$ZO=qe;function je(Z,...Y){if(Z.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.$1O=je;function Le(Z,Y){return Z.insertBefore(Y,Z.firstChild),Y}t.$2O=Le;function Ge(Z,...Y){Z.innerText="",je(Z,...Y)}t.$3O=Ge;const Q=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var le;(function(Z){Z.HTML="http://www.w3.org/1999/xhtml",Z.SVG="http://www.w3.org/2000/svg"})(le||(t.Namespace=le={}));function be(Z,Y,de,...Ae){const Se=Q.exec(Y);if(!Se)throw new Error("Bad use of emmet");const We=Se[1]||"div";let He;return Z!==le.HTML?He=document.createElementNS(Z,We):He=document.createElement(We),Se[3]&&(He.id=Se[3]),Se[4]&&(He.className=Se[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Je,at])=>{typeof at>"u"||(/^on\w+$/.test(Je)?He[Je]=at:Je==="selected"?at&&He.setAttribute(Je,"true"):He.setAttribute(Je,at))}),He.append(...Ae),He}function De(Z,Y,...de){return be(le.HTML,Z,Y,...de)}t.$=De,De.SVG=function(Z,Y,...de){return be(le.SVG,Z,Y,...de)};function Ne(Z,Y){const de=[];return Z.forEach((Ae,Se)=>{Se>0&&(Y instanceof Node?de.push(Y.cloneNode()):de.push(document.createTextNode(Y))),de.push(Ae)}),de}t.$5O=Ne;function Re(Z,...Y){Z?ze(...Y):Qe(...Y)}t.$6O=Re;function ze(...Z){for(const Y of Z)Y.style.display="",Y.removeAttribute("aria-hidden")}t.$7O=ze;function Qe(...Z){for(const Y of Z)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.$8O=Qe;function Ye(Z,Y){for(;Z&&Z.nodeType===Z.ELEMENT_NODE;){if(Z instanceof HTMLElement&&Z.hasAttribute(Y))return Z;Z=Z.parentNode}return null}function Ve(Z){!Z||!Z.hasAttribute("tabIndex")||(document.activeElement===Z&&Ye(Z.parentElement,"tabIndex")?.focus(),Z.removeAttribute("tabindex"))}t.$9O=Ve;function _e(Z){return Y=>{Y.preventDefault(),Y.stopPropagation(),Z(Y)}}t.$0O=_e;function et(){return new Promise(Z=>{document.readyState==="complete"||document&&document.body!==null?Z(void 0):window.addEventListener("DOMContentLoaded",Z,!1)})}t.$$O=et;function it(Z){const Y=window.devicePixelRatio*Z;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.$_O=it;function ft(Z){window.open(Z,"_blank","noopener")}t.$aP=ft;const ct=780,ot=640;function yt(Z){const Y=Math.floor(window.screenLeft+window.innerWidth/2-ct/2),de=Math.floor(window.screenTop+window.innerHeight/2-ot/2);window.open(Z,"_blank",`width=${ct},height=${ot},top=${de},left=${Y}`)}t.$bP=yt;function Et(Z,Y=!0){const de=window.open();return de?(Y&&(de.opener=null),de.location.href=Z,!0):!1}t.$cP=Et;function At(Z){const Y=()=>{Z(),de=(0,t.$nO)(Y)};let de=(0,t.$nO)(Y);return(0,f.$kb)(()=>de.dispose())}t.$dP=At,P.$Ye.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function kt(Z){return Z?`url('${P.$4e.uriToBrowserUri(Z).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$eP=kt;function Rt(Z){return`'${Z.replace(/'/g,"%27")}'`}t.$fP=Rt;function Pe(Z,Y){if(Z!==void 0){const de=Z.match(/^\s*var\((.+)\)$/);if(de){const Ae=de[1].split(",",2);return Ae.length===2&&(Y=Pe(Ae[1].trim(),Y)),`var(${Ae[0]}, ${Y})`}return Z}return Y}t.$gP=Pe;function ue(Z,Y){let de;if(h.URI.isUri(Z))de=Z.toString(!0);else{const Se=new Blob([Z]);de=URL.createObjectURL(Se),setTimeout(()=>URL.revokeObjectURL(de))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=Y,Ae.href=de,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.$hP=ue;function ye(){return new Promise(Z=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,l.Event.once(l.Event.fromDOMEventEmitter(Y,"input"))(()=>{Z(Y.files??void 0)}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.$iP=ye;var ke;(function(Z){Z[Z.DOCUMENT=1]="DOCUMENT",Z[Z.BROWSER=2]="BROWSER"})(ke||(t.DetectedFullscreenMode=ke={}));function Ue(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:ke.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:ke.BROWSER,guess:!1}:(r.$j||r.$k)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:ke.BROWSER,guess:!0}:null}t.$jP=Ue;function Xe(Z,Y=!1){const de=document.createElement("a");return u.addHook("afterSanitizeAttributes",Ae=>{for(const Se of["href","src"])if(Ae.hasAttribute(Se)){const We=Ae.getAttribute(Se);if(Se==="href"&&We.startsWith("#"))continue;if(de.href=We,!Z.includes(de.protocol.replace(/:$/,""))){if(Y&&Se==="src"&&de.href.startsWith("data:"))continue;Ae.removeAttribute(Se)}}}),(0,f.$kb)(()=>{u.removeHook("afterSanitizeAttributes")})}t.$kP=Xe;const nt=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$lP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const xe=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function lt(Z,Y){const de=Xe(nt);try{const Ae=u.sanitize(Y,xe);Z.innerHTML=Ae}finally{de.dispose()}}t.$mP=lt;function $t(Z){const Y=new Uint16Array(Z.length);for(let Se=0;Se<Y.length;Se++)Y[Se]=Z.charCodeAt(Se);let de="";const Ae=new Uint8Array(Y.buffer);for(let Se=0;Se<Ae.length;Se++)de+=String.fromCharCode(Ae[Se]);return de}function Nt(Z){return btoa($t(Z))}t.$nP=Nt;class dt extends l.$hc{constructor(){super(),this.s=new f.$lb,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(s(window,"keydown",Y=>{if(Y.defaultPrevented)return;const de=new i.$cO(Y);if(!(de.keyCode===6&&Y.repeat)){if(Y.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(Y.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(Y.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(Y.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(de.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=Y.altKey,this.A.ctrlKey=Y.ctrlKey,this.A.metaKey=Y.metaKey,this.A.shiftKey=Y.shiftKey,this.A.lastKeyPressed&&(this.A.event=Y,this.fire(this.A))}},!0)),this.s.add(s(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!Y.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!Y.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!Y.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=Y.altKey,this.A.ctrlKey=Y.ctrlKey,this.A.metaKey=Y.metaKey,this.A.shiftKey=Y.shiftKey,this.A.lastKeyReleased&&(this.A.event=Y,this.fire(this.A)))},!0)),this.s.add(s(document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mousemove",Y=>{Y.buttons&&(this.A.lastKeyPressed=void 0)},!0)),this.s.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.C(),this.fire(this.A)}C(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.B||(dt.B=new dt),dt.B}dispose(){super.dispose(),this.s.dispose()}}t.$oP=dt;function $i(Z){const Y=document.cookie.match("(^|[^;]+)\\s*"+Z+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.$pP=$i;class pi extends f.$mb{constructor(Y,de){super(),this.j=Y,this.l=de,this.f=0,this.g=0,this.m()}m(){this.B(s(this.j,t.$TO.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.l.onDragEnter(Y)})),this.B(s(this.j,t.$TO.DRAG_OVER,Y=>{Y.preventDefault(),this.l.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(s(this.j,t.$TO.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(Y))})),this.B(s(this.j,t.$TO.DRAG_END,Y=>{this.f=0,this.g=0,this.l.onDragEnd(Y)})),this.B(s(this.j,t.$TO.DROP,Y=>{this.f=0,this.g=0,this.l.onDrop(Y)}))}}t.$qP=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(Z,...Y){let de,Ae;Array.isArray(Y[0])?(de={},Ae=Y[0]):(de=Y[0]||{},Ae=Y[1]);const Se=wi.exec(Z);if(!Se||!Se.groups)throw new Error("Bad use of h");const We=Se.groups.tag||"div",He=document.createElement(We);Se.groups.id&&(He.id=Se.groups.id);const Je=[];if(Se.groups.class)for(const Ze of Se.groups.class.split("."))Ze!==""&&Je.push(Ze);if(de.className!==void 0)for(const Ze of de.className.split("."))Ze!==""&&Je.push(Ze);Je.length>0&&(He.className=Je.join(" "));const at={};if(Se.groups.name&&(at[Se.groups.name]=He),Ae)for(const Ze of Ae)Ze instanceof HTMLElement?He.appendChild(Ze):typeof Ze=="string"?He.append(Ze):"root"in Ze&&(Object.assign(at,Ze),He.appendChild(Ze.root));for(const[Ze,pt]of Object.entries(de))if(Ze!=="className")if(Ze==="style")for(const[Ct,Mt]of Object.entries(pt))He.style.setProperty(Gt(Ct),typeof Mt=="number"?Mt+"px":""+Mt);else Ze==="tabIndex"?He.tabIndex=pt:He.setAttribute(Gt(Ze),pt.toString());return at.root=He,at}t.h=vi;function Gt(Z){return Z.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],$e([1,0,4,2,114]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uP=t.$tP=t.$sP=void 0;class U extends S.$mb{constructor(l,u){super(),this.B((0,y.$fO)(l,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{u(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,y.$fO)(l,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$sP=U,t.$tP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Er.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(v,l,u,f,P){const r=document.createElement("div");r.className=u,r.textContent=l,P&&(r.style.color=P),f&&(r.style.background=f),v.dataTransfer&&(document.body.appendChild(r),v.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.$uP=D}),define(me[52],$e([1,0,4]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YP=t.$XP=t.$WP=void 0;function S(r,h={}){const e=U(h);return e.textContent=r,e}t.$WP=S;function i(r,h={}){const e=U(h);return l(e,u(r,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$XP=i;function U(r){const h=r.inline?"span":"div",e=document.createElement(h);return r.className&&(e.className=r.className),e}t.$YP=U;class D{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var v;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(v||(v={}));function l(r,h,e,a){let o;if(h.type===2)o=document.createTextNode(h.content||"");else if(h.type===3)o=document.createElement("b");else if(h.type===4)o=document.createElement("i");else if(h.type===7&&a)o=document.createElement("code");else if(h.type===5&&e){const s=document.createElement("a");e.disposables.add(y.$gO(s,"click",n=>{e.callback(String(h.index),n)})),o=s}else h.type===8?o=document.createElement("br"):h.type===1&&(o=r);o&&r!==o&&r.appendChild(o),o&&Array.isArray(h.children)&&h.children.forEach(s=>{l(o,s,e,a)})}function u(r,h){const e={type:1,children:[]};let a=0,o=e;const s=[],n=new D(r);for(;!n.eos();){let g=n.next();const b=g==="\\"&&P(n.peek(),h)!==0;if(b&&(g=n.next()),!b&&f(g,h)&&g===n.peek()){n.advance(),o.type===2&&(o=s.pop());const $=P(g,h);if(o.type===$||o.type===5&&$===6)o=s.pop();else{const c={type:$,children:[]};$===5&&(c.index=a,a++),o.children.push(c),s.push(o),o=c}}else if(g===`
`)o.type===2&&(o=s.pop()),o.children.push({type:8});else if(o.type!==2){const $={type:2,content:g};o.children.push($),s.push(o),o=$}else o.content+=g}return o.type===2&&(o=s.pop()),s.length,e}function f(r,h){return P(r,h)!==0}function P(r,h){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(me[53],$e([1,0,4,2]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yP=void 0;class i{constructor(){this.a=new S.$lb,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,v){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const l=this.c;this.c=null,D&&l&&l(v)}isMonitoring(){return!!this.b}startMonitoring(D,v,l,u,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=u,this.c=f;let P=D;try{D.setPointerCapture(v),this.a.add((0,S.$kb)(()=>{try{D.releasePointerCapture(v)}catch{}}))}catch{P=window}this.a.add(y.$fO(P,y.$TO.POINTER_MOVE,r=>{if(r.buttons!==l){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(y.$fO(P,y.$TO.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$yP=i});var Ke=this&&this.__decorate||function(oe,t,y,S){var i=arguments.length,U=i<3?t:S===null?S=Object.getOwnPropertyDescriptor(t,y):S,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(oe,t,y,S);else for(var v=oe.length-1;v>=0;v--)(D=oe[v])&&(U=(i<3?D(U):i>3?D(t,y,U):D(t,y))||U);return i>3&&U&&Object.defineProperty(t,y,U),U};define(me[23],$e([1,0,4,13,25,2,43]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vP=t.EventType=void 0;var v;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(v||(t.EventType=v={}));class l extends U.$mb{static{this.a=-.005}static{this.c=700}static{this.m=400}constructor(){super(),this.f=!1,this.g=new D.$vb,this.h=new D.$vb,this.k={},this.j=null,this.l=0,this.B(y.$fO(document,"touchstart",f=>this.n(f),{passive:!1})),this.B(y.$fO(document,"touchend",f=>this.p(f))),this.B(y.$fO(document,"touchmove",f=>this.v(f),{passive:!1}))}static addTarget(f){if(!l.isTouchDevice())return U.$mb.None;l.b||(l.b=(0,U.$fb)(new l));const P=l.b.g.push(f);return(0,U.$kb)(P)}static ignoreTarget(f){if(!l.isTouchDevice())return U.$mb.None;l.b||(l.b=(0,U.$fb)(new l));const P=l.b.h.push(f);return(0,U.$kb)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(f){const P=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,h=f.targetTouches.length;r<h;r++){const e=f.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.r(v.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.s(a)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}p(f){const P=Date.now(),r=Object.keys(this.k).length;for(let h=0,e=f.changedTouches.length;h<e;h++){const a=f.changedTouches.item(h);if(!this.k.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const o=this.k[a.identifier],s=Date.now()-o.initialTimeStamp;if(s<l.c&&Math.abs(o.initialPageX-S.$mf(o.rollingPageX))<30&&Math.abs(o.initialPageY-S.$mf(o.rollingPageY))<30){const n=this.r(v.Tap,o.initialTarget);n.pageX=S.$mf(o.rollingPageX),n.pageY=S.$mf(o.rollingPageY),this.s(n)}else if(s>=l.c&&Math.abs(o.initialPageX-S.$mf(o.rollingPageX))<30&&Math.abs(o.initialPageY-S.$mf(o.rollingPageY))<30){const n=this.r(v.Contextmenu,o.initialTarget);n.pageX=S.$mf(o.rollingPageX),n.pageY=S.$mf(o.rollingPageY),this.s(n)}else if(r===1){const n=S.$mf(o.rollingPageX),g=S.$mf(o.rollingPageY),b=S.$mf(o.rollingTimestamps)-o.rollingTimestamps[0],$=n-o.rollingPageX[0],c=g-o.rollingPageY[0],O=[...this.g].filter(R=>o.initialTarget instanceof Node&&R.contains(o.initialTarget));this.u(O,P,Math.abs($)/b,$>0?1:-1,n,Math.abs(c)/b,c>0?1:-1,g)}this.s(this.r(v.End,o.initialTarget)),delete this.k[a.identifier]}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}r(f,P){const r=document.createEvent("CustomEvent");return r.initEvent(f,!1,!0),r.initialTarget=P,r.tapCount=0,r}s(f){if(f.type===v.Tap){const P=new Date().getTime();let r=0;P-this.l>l.m?r=1:r=2,this.l=P,f.tapCount=r}else(f.type===v.Change||f.type===v.Contextmenu)&&(this.l=0);if(f.initialTarget instanceof Node){for(const P of this.h)if(P.contains(f.initialTarget))return;for(const P of this.g)P.contains(f.initialTarget)&&(P.dispatchEvent(f),this.f=!0)}}u(f,P,r,h,e,a,o,s){this.j=y.$nO(()=>{const n=Date.now(),g=n-P;let b=0,$=0,c=!0;r+=l.a*g,a+=l.a*g,r>0&&(c=!1,b=h*r*g),a>0&&(c=!1,$=o*a*g);const O=this.r(v.Change);O.translationX=b,O.translationY=$,f.forEach(R=>R.dispatchEvent(O)),c||this.u(f,n,r,h,e+b,a,o,s+$)})}v(f){const P=Date.now();for(let r=0,h=f.changedTouches.length;r<h;r++){const e=f.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.k[e.identifier],o=this.r(v.Change,a.initialTarget);o.translationX=e.pageX-S.$mf(a.rollingPageX),o.translationY=e.pageY-S.$mf(a.rollingPageY),o.pageX=e.pageX,o.pageY=e.pageY,this.s(o),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(P)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}t.$vP=l,Ke([i.$4g],l,"isTouchDevice",null)}),define(me[54],$e([1,0,4,89]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3P=t.$2P=t.$1P=void 0;const S=2e4;let i,U,D,v,l;function u(h){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),i.appendChild(o),o};U=e(),D=e();const a=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),i.appendChild(o),o};v=a(),l=a(),h.appendChild(i)}t.$1P=u;function f(h){i&&(U.textContent!==h?(y.$dO(D),r(U,h)):(y.$dO(U),r(D,h)))}t.$2P=f;function P(h){i&&(v.textContent!==h?(y.$dO(l),r(v,h)):(y.$dO(v),r(l,h)))}t.$3P=P;function r(h,e){y.$dO(h),e.length>S&&(e=e.substr(0,S)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(me[116],$e([1,0,4,18]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pQ=t.$oQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(v){const l=new Array;let u,f=0,P=0;for(;(u=i.exec(v))!==null;){P=u.index||0,f<P&&l.push(v.substring(f,P)),f=(u.index||0)+u[0].length;const[,r,h]=u;l.push(r?`$(${h})`:D({id:h}))}return f<v.length&&l.push(v.substring(f)),l}t.$oQ=U;function D(v){const l=y.$("span");return l.classList.add(...S.ThemeIcon.asClassNameArray(v)),l}t.$pQ=D}),define(me[117],$e([1,0,4]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=void 0;function S(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let v=this.h(D).pop(),l=!1;if(v)l=this.b.has(v.domNode),l&&this.b.delete(v.domNode);else{const u=(0,y.$)(".monaco-list-row"),P=this.i(D).renderTemplate(u);v={domNode:u,templateId:D,templateData:P}}return{row:v,isReusingConnectedDomNode:l}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const v of this.b)this.g(v);this.b.clear(),this.c=!1}}f(D){const{domNode:v,templateId:l}=D;v&&(this.c?this.b.add(v):this.g(v)),this.h(l).push(D)}g(D){D.classList.remove("scrolling"),S(D)}h(D){let v=this.a.get(D);return v||(v=[],this.a.set(D,v)),v}dispose(){this.a.forEach((D,v)=>{for(const l of D)this.i(v).disposeTemplate(l.templateData),l.templateData=null}),this.a.clear(),this.b.clear()}i(D){const v=this.d.get(D);if(!v)throw new Error(`No renderer found for ${D}`);return v}}t.$_P=i}),define(me[118],$e([1,0,9,2]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DP=void 0;class i extends S.$mb{constructor(D,v,l){super(),this.a=D,this.b=v,this.c=l,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new y.$Og)}setVisibility(D){this.a!==D&&(this.a=D,this.m())}setShouldBeVisible(D){this.g=D,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const D=this.l();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.i!==D&&(this.i=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(D){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.$DP=i}),define(me[119],$e([1,0,4,23,13,3,2,5]),function(oe,t,y,S,i,U,D,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=void 0;class l extends D.$mb{constructor(f,P,r,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$hc),this.h=r,this.i(),this.setOptions(f,P)}i(){this.B(S.$vP.addTarget(this.a)),[S.EventType.Tap].forEach(f=>{this.B(y.$fO(this.a,f,P=>{this.a.focus()}))}),this.B(y.$gO(this.a,"click",f=>{y.$VO.stop(f,!0)})),this.B(y.$gO(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(y.$gO(this.a,"keydown",f=>{let P=!1;v.$j?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(P=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(P=!0),P&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,P){(!this.c||!i.$of(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((r,h)=>{this.a.add(this.j(r.text,h,r.isDisabled))})),P!==void 0&&this.select(P)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(f,P,r){const h=document.createElement("option");return h.value=f,h.text=f,h.disabled=!!r,h}}t.$wQ=l}),define(me[55],$e([1,0,24,13,9,47,85,3,26]),function(oe,t,y,S,i,U,D,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3R=t.$2R=t.$1R=void 0;function u(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$1R=u;function f(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$2R=f;function P(h){return typeof h.collapsible=="boolean"}class r{constructor(e,a,o,s={}){this.o=e,this.p=a,this.rootRef=[],this.d=new v.$pc,this.f=new v.$hc,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new v.$hc,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new v.$hc,this.onDidSplice=this.l.event,this.m=new i.$Bg(U.$ec),this.h=typeof s.collapseByDefault>"u"?!1:s.collapseByDefault,this.j=s.filter,this.k=typeof s.autoExpandSingleChildren>"u"?!1:s.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,o=l.Iterable.empty(),s={}){if(e.length===0)throw new y.$YR(this.o,"Invalid tree location");s.diffIdentityProvider?this.q(s.diffIdentityProvider,e,a,o,s):this.s(e,a,o,s)}q(e,a,o,s=l.Iterable.empty(),n,g=n.diffDepth??0){const{parentNode:b}=this.G(a);if(!b.lastDiffIds)return this.s(a,o,s,n);const $=[...s],c=a[a.length-1],O=new D.$ns({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,c),...$,...b.children.slice(c+o)].map(N=>e.getId(N.element).toString())}).ComputeDiff(!1);if(O.quitEarly)return b.lastDiffIds=void 0,this.s(a,o,$,n);const R=a.slice(0,-1),L=(N,M,H)=>{if(g>0)for(let j=0;j<H;j++)N--,M--,this.q(e,[...R,N,0],Number.MAX_SAFE_INTEGER,$[M].children,n,g-1)};let m=Math.min(b.children.length,c+o),p=$.length;for(const N of O.changes.sort((M,H)=>H.originalStart-M.originalStart))L(m,p,m-(N.originalStart+N.originalLength)),m=N.originalStart,p=N.modifiedStart-c,this.s([...R,m],N.originalLength,l.Iterable.slice($,p,p+N.modifiedLength),n);L(m,p,m)}s(e,a,o=l.Iterable.empty(),{onDidCreateNode:s,onDidDeleteNode:n,diffIdentityProvider:g}){const{parentNode:b,listIndex:$,revealed:c,visible:O}=this.G(e),R=[],L=l.Iterable.map(o,ce=>this.w(ce,b,b.visible?1:0,c,R,s)),m=e[e.length-1],p=b.children.length>0;let N=0;for(let ce=m;ce>=0&&ce<b.children.length;ce--){const he=b.children[ce];if(he.visible){N=he.visibleChildIndex;break}}const M=[];let H=0,j=0;for(const ce of L)M.push(ce),j+=ce.renderNodeCount,ce.visible&&(ce.visibleChildIndex=N+H++);const W=(0,S.$Yf)(b.children,m,a,M);g?b.lastDiffIds?(0,S.$Yf)(b.lastDiffIds,m,a,M.map(ce=>g.getId(ce.element).toString())):b.lastDiffIds=b.children.map(ce=>g.getId(ce.element).toString()):b.lastDiffIds=void 0;let ee=0;for(const ce of W)ce.visible&&ee++;if(ee!==0)for(let ce=m+M.length;ce<b.children.length;ce++){const he=b.children[ce];he.visible&&(he.visibleChildIndex-=ee)}if(b.visibleChildrenCount+=H-ee,c&&O){const ce=W.reduce((he,ae)=>he+(ae.visible?ae.renderNodeCount:0),0);this.B(b,j-ce),this.p.splice($,ce,R)}if(W.length>0&&n){const ce=he=>{n(he),he.children.forEach(ce)};W.forEach(ce)}this.l.fire({insertedNodes:M,deletedNodes:W});const ne=b.children.length>0;p!==ne&&this.setCollapsible(e.slice(0,-1),ne);let re=b;for(;re;){if(re.visibility===2){this.m.trigger(()=>this.refilter());break}re=re.parent}}rerender(e){if(e.length===0)throw new y.$YR(this.o,"Invalid tree location");const{node:a,listIndex:o,revealed:s}=this.F(e);a.visible&&s&&this.p.splice(o,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new y.$YR(this.o,"Invalid tree location");const{listIndex:o}=this.F(e);this.p.updateElementHeight(o,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:o,revealed:s}=this.F(e);return o&&s?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const o=this.E(e);typeof a>"u"&&(a=!o.collapsible);const s={collapsible:a};return this.d.bufferEvents(()=>this.t(e,s))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,o){const s=this.E(e);typeof a>"u"&&(a=!s.collapsed);const n={collapsed:a,recursive:o||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,a){const{node:o,listIndex:s,revealed:n}=this.F(e),g=this.u(o,s,n,a);if(o!==this.c&&this.k&&g&&!P(a)&&o.collapsible&&!o.collapsed&&!a.recursive){let b=-1;for(let $=0;$<o.children.length;$++)if(o.children[$].visible)if(b>-1){b=-1;break}else b=$;b>-1&&this.t([...e,b],a)}return g}u(e,a,o,s){const n=this.v(e,s,!1);if(!o||!e.visible||!n)return n;const g=e.renderNodeCount,b=this.x(e),$=g-(a===-1?0:1);return this.p.splice(a+1,$,b.slice(1)),n}v(e,a,o){let s;if(e===this.c?s=!1:(P(a)?(s=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(s=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):s=!1,s&&this.f.fire({node:e,deep:o})),!P(a)&&a.recursive)for(const n of e.children)s=this.v(n,a,!0)||s;return s}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,o,s,n,g){const b={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},$=this.C(b,o);b.visibility=$,s&&n.push(b);const c=e.children||l.Iterable.empty(),O=s&&$!==0&&!b.collapsed;let R=0,L=1;for(const m of c){const p=this.w(m,b,$,O,n,g);b.children.push(p),L+=p.renderNodeCount,p.visible&&(p.visibleChildIndex=R++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=R,b.visible=$===2?R>0:$===1,b.visible?b.collapsed||(b.renderNodeCount=L):(b.renderNodeCount=0,s&&n.pop()),g?.(b),b}x(e){const a=e.renderNodeCount,o=[];return this.y(e,o),this.B(e.parent,o.length-a),o}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.y(o,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,o=[];return this.A(e,e.visible?1:0,o),this.B(e.parent,o.length-a),o}A(e,a,o,s=!0){let n;if(e!==this.c){if(n=this.C(e,a),n===0)return e.visible=!1,e.renderNodeCount=0,!1;s&&o.push(e)}const g=o.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let $=0;for(const c of e.children)b=this.A(c,n,o,s&&!e.collapsed)||b,c.visible&&(c.visibleChildIndex=$++);e.visibleChildrenCount=$}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=o.length-g):(e.renderNodeCount=0,s&&o.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const o=this.j?this.j.filter(e.element,a):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):u(o)?(e.filterData=o.data,f(o.visibility)):(e.filterData=void 0,f(o))}D(e,a=this.c){if(!e||e.length===0)return!0;const[o,...s]=e;return o<0||o>a.children.length?!1:this.D(s,a.children[o])}E(e,a=this.c){if(!e||e.length===0)return a;const[o,...s]=e;if(o<0||o>a.children.length)throw new y.$YR(this.o,"Invalid tree location");return this.E(s,a.children[o])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:o,revealed:s,visible:n}=this.G(e),g=e[e.length-1];if(g<0||g>a.children.length)throw new y.$YR(this.o,"Invalid tree location");const b=a.children[g];return{node:b,listIndex:o,revealed:s,visible:n&&b.visible}}G(e,a=this.c,o=0,s=!0,n=!0){const[g,...b]=e;if(g<0||g>a.children.length)throw new y.$YR(this.o,"Invalid tree location");for(let $=0;$<g;$++)o+=a.children[$].renderNodeCount;return s=s&&!a.collapsed,n=n&&a.visible,b.length===0?{parentNode:a,listIndex:o,revealed:s,visible:n}:this.G(b,a.children[g],o+1,s,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let o=e;for(;o.parent;)a.push(o.parent.children.indexOf(o)),o=o.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,S.$nf)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$3R=r}),define(me[120],$e([1,0,55,24,26]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=void 0;class U{get size(){return this.d.size}constructor(v,l,u={}){this.k=v,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$3R(v,l,null,u),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,u.sorter&&(this.j={compare(f,P){return u.sorter.compare(f.element,P.element)}}),this.h=u.identityProvider}setChildren(v,l=i.Iterable.empty(),u={}){const f=this.o(v);this.l(f,this.m(l),u)}l(v,l=i.Iterable.empty(),u){const f=new Set,P=new Set,r=e=>{if(e.element===null)return;const a=e;if(f.add(a.element),this.d.set(a.element,a),this.h){const o=this.h.getId(a.element).toString();P.add(o),this.f.set(o,a)}u.onDidCreateNode?.(a)},h=e=>{if(e.element===null)return;const a=e;if(f.has(a.element)||this.d.delete(a.element),this.h){const o=this.h.getId(a.element).toString();P.has(o)||this.f.delete(o)}u.onDidDeleteNode?.(a)};this.c.splice([...v,0],Number.MAX_VALUE,l,{...u,onDidCreateNode:r,onDidDeleteNode:h})}m(v=i.Iterable.empty()){return this.j&&(v=[...v].sort(this.j.compare.bind(this.j))),i.Iterable.map(v,l=>{let u=this.d.get(l.element);if(!u&&this.h){const r=this.h.getId(l.element).toString();u=this.f.get(r)}if(!u){let r;return typeof l.collapsed>"u"?r=void 0:l.collapsed===S.ObjectTreeElementCollapseState.Collapsed||l.collapsed===S.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:l.collapsed===S.ObjectTreeElementCollapseState.Expanded||l.collapsed===S.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!l.collapsed,{...l,children:this.m(l.children),collapsed:r}}const f=typeof l.collapsible=="boolean"?l.collapsible:u.collapsible;let P;return typeof l.collapsed>"u"||l.collapsed===S.ObjectTreeElementCollapseState.PreserveOrCollapsed||l.collapsed===S.ObjectTreeElementCollapseState.PreserveOrExpanded?P=u.collapsed:l.collapsed===S.ObjectTreeElementCollapseState.Collapsed?P=!0:l.collapsed===S.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!l.collapsed,{...l,collapsible:f,collapsed:P,children:this.m(l.children)}})}rerender(v){const l=this.o(v);this.c.rerender(l)}updateElementHeight(v,l){const u=this.o(v);this.c.updateElementHeight(u,l)}resort(v=null,l=!0){if(!this.j)return;const u=this.o(v),f=this.c.getNode(u);this.l(u,this.n(f,l),{})}n(v,l,u=!0){let f=[...v.children];return(l||u)&&(f=f.sort(this.j.compare.bind(this.j))),i.Iterable.map(f,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,l,!1)}))}getFirstElementChild(v=null){const l=this.o(v);return this.c.getFirstElementChild(l)}getLastElementAncestor(v=null){const l=this.o(v);return this.c.getLastElementAncestor(l)}has(v){return this.d.has(v)}getListIndex(v){const l=this.o(v);return this.c.getListIndex(l)}getListRenderCount(v){const l=this.o(v);return this.c.getListRenderCount(l)}isCollapsible(v){const l=this.o(v);return this.c.isCollapsible(l)}setCollapsible(v,l){const u=this.o(v);return this.c.setCollapsible(u,l)}isCollapsed(v){const l=this.o(v);return this.c.isCollapsed(l)}setCollapsed(v,l,u){const f=this.o(v);return this.c.setCollapsed(f,l,u)}expandTo(v){const l=this.o(v);this.c.expandTo(l)}refilter(){this.c.refilter()}getNode(v=null){if(v===null)return this.c.getNode(this.c.rootRef);const l=this.d.get(v);if(!l)throw new S.$YR(this.k,`Tree element not found: ${v}`);return l}getNodeLocation(v){return v.element}getParentNodeLocation(v){if(v===null)throw new S.$YR(this.k,"Invalid getParentNodeLocation call");const l=this.d.get(v);if(!l)throw new S.$YR(this.k,`Tree element not found: ${v}`);const u=this.c.getNodeLocation(l),f=this.c.getParentNodeLocation(u);return this.c.getNode(f).element}o(v){if(v===null)return[];const l=this.d.get(v);if(!l)throw new S.$YR(this.k,`Tree element not found: ${v}`);return this.c.getNodeLocation(l)}}t.$9R=U}),define(me[20],$e([1,0,4,14,19,23,2]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zP=void 0;class v extends D.$mb{f(u,f){this.B(y.$fO(u,y.$TO.CLICK,P=>f(new i.$0N(P))))}j(u,f){this.B(y.$fO(u,y.$TO.MOUSE_DOWN,P=>f(new i.$0N(P))))}k(u,f){this.B(y.$fO(u,y.$TO.MOUSE_OVER,P=>f(new i.$0N(P))))}m(u,f){this.B(y.$fO(u,y.$TO.MOUSE_LEAVE,P=>f(new i.$0N(P))))}p(u,f){this.B(y.$fO(u,y.$TO.KEY_DOWN,P=>f(new S.$cO(P))))}u(u,f){this.B(y.$fO(u,y.$TO.KEY_UP,P=>f(new S.$cO(P))))}z(u,f){this.B(y.$fO(u,y.$TO.INPUT,f))}C(u,f){this.B(y.$fO(u,y.$TO.BLUR,f))}D(u,f){this.B(y.$fO(u,y.$TO.FOCUS,f))}F(u,f){this.B(y.$fO(u,y.$TO.CHANGE,f))}G(u){return U.$vP.ignoreTarget(u)}}t.$zP=v}),define(me[36],$e([1,0,53,20,9,18,4]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BP=t.$AP=void 0,t.$AP=11;class v extends S.$zP{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$AP+"px",this.domNode.style.height=t.$AP+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new y.$yP),this.B(D.$gO(this.bgDomNode,D.$TO.POINTER_DOWN,f=>this.h(f))),this.B(D.$gO(this.domNode,D.$TO.POINTER_DOWN,f=>this.h(f))),this.b=this.B(new i.$Pg),this.c=this.B(new i.$Og)}h(u){if(!u.target||!(u.target instanceof Element))return;const f=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(f,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.$BP=v}),define(me[56],$e([1,0,4,39,53,36,118,20,5]),function(oe,t,y,S,i,U,D,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EP=void 0;const u=140;class f extends v.$zP{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new D.$DP(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new i.$yP),this.n=!0,this.domNode=(0,S.$xP)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$fO(this.domNode.domNode,y.$TO.POINTER_DOWN,h=>this.y(h)))}r(r){const h=this.B(new U.$BP(r));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}s(r,h,e,a){this.slider=(0,S.$xP)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$fO(this.slider.domNode,y.$TO.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.I(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){this.n&&(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),a=h+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.O(r);e<=o&&o<=a?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let h,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")h=r.offsetX,e=r.offsetY;else{const o=y.$xO(this.domNode.domNode);h=r.pageX-o.left,e=r.pageY-o.top}const a=this.N(h,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const h=this.O(r),e=this.P(r),a=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,o=>{const s=this.P(o),n=Math.abs(s-e);if(l.$i&&n>u){this.J(a.getScrollPosition());return}const b=this.O(o)-h;this.J(a.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const h={};this.writeScrollPosition(h,r),this.b.setScrollPositionNow(h)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$EP=f}),define(me[121],$e([1,0,19,56,36,40,17]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FP=void 0;class v extends S.$EP{constructor(u,f,P){const r=u.getScrollDimensions(),h=u.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:P,scrollbarState:new U.$CP(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,r.width,r.scrollWidth,h.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-i.$AP)/2,a=(f.horizontalScrollbarSize-i.$AP)/2;this.r({className:"scra",icon:D.$Nj.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$_N(null,1,0))}),this.r({className:"scra",icon:D.$Nj.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$_N(null,-1,0))})}this.s(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}M(u,f){this.slider.setWidth(u),this.slider.setLeft(f)}L(u,f){this.domNode.setWidth(u),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this.n=this.v(u.scrollWidth)||this.n,this.n=this.w(u.scrollLeft)||this.n,this.n=this.t(u.width)||this.n,this.n}N(u,f){return u}O(u){return u.pageX}P(u){return u.pageY}Q(u){this.slider.setHeight(u)}writeScrollPosition(u,f){u.scrollLeft=f}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.i.setVisibility(u.horizontal),this.c=u.scrollByPage}}t.$FP=v}),define(me[122],$e([1,0,19,56,36,40,17]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GP=void 0;class v extends S.$EP{constructor(u,f,P){const r=u.getScrollDimensions(),h=u.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:P,scrollbarState:new U.$CP(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,r.height,r.scrollHeight,h.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-i.$AP)/2,a=(f.verticalScrollbarSize-i.$AP)/2;this.r({className:"scra",icon:D.$Nj.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$_N(null,0,1))}),this.r({className:"scra",icon:D.$Nj.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$_N(null,0,-1))})}this.s(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}M(u,f){this.slider.setHeight(u),this.slider.setTop(f)}L(u,f){this.domNode.setWidth(f),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this.n=this.v(u.scrollHeight)||this.n,this.n=this.w(u.scrollTop)||this.n,this.n=this.t(u.height)||this.n,this.n}N(u,f){return f}O(u){return u.pageY}P(u){return u.pageX}Q(u){this.slider.setWidth(u)}writeScrollPosition(u,f){u.scrollTop=f}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(u.vertical),this.c=u.scrollByPage}}t.$GP=v}),define(me[57],$e([1,0,16,4,39,19,121,122,20,9,3,2,5,46,96]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=void 0;const e=500,a=50,o=!0;class s{constructor(L,m,p){this.timestamp=L,this.deltaX=m,this.deltaY=p,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,m=0,p=1,N=this.d;do{const M=N===this.c?L:Math.pow(2,-p);if(L-=M,m+=this.b[N].score*M,N===this.c)break;N=(this.a+N-1)%this.a,p++}while(!0);return m<=.5}acceptStandardWheelEvent(L){const m=window.devicePixelRatio/(0,y.$SN)();r.$i||r.$k?this.accept(Date.now(),L.deltaX/m,L.deltaY/m):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,m,p){const N=new s(L,m,p);N.score=this.f(N),this.c===-1&&this.d===-1?(this.b[0]=N,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=N)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let m=.5;const p=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$HP=n;class g extends l.$zP{get options(){return this.a}constructor(L,m,p){super(),this.I=this.B(new f.$hc),this.onScroll=this.I.event,this.J=this.B(new f.$hc),this.onWillScroll=this.J.event,L.style.overflow="hidden",this.a=O(m),this.b=p,this.B(this.b.onScroll(M=>{this.J.fire(M),this.N(M),this.I.fire(M)}));const N={onMouseWheel:M=>this.M(M),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new v.$GP(this.b,this.a,N)),this.g=this.B(new D.$FP(this.b,this.a,N)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.$xP)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.$xP)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.$xP)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,M=>this.S(M)),this.m(this.r,M=>this.R(M)),this.w=this.B(new u.$Og),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,P.$hb)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(L){this.H=L}delegateScrollFromMouseWheelEvent(L){this.M(new U.$_N(L))}L(L){if(this.s.length>0!==L&&(this.s=(0,P.$hb)(this.s),L)){const p=N=>{this.M(new U.$_N(N))};this.s.push(S.$fO(this.r,S.$TO.MOUSE_WHEEL,p,{passive:!1}))}}M(L){if(L.browserEvent?.defaultPrevented)return;const m=n.INSTANCE;o&&m.acceptStandardWheelEvent(L);let p=!1;if(L.deltaY||L.deltaX){let M=L.deltaY*this.a.mouseWheelScrollSensitivity,H=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&H+M===0?H=M=0:Math.abs(M)>=Math.abs(H)?H=0:M=0),this.a.flipAxes&&([M,H]=[H,M]);const j=!r.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||j)&&!H&&(H=M,M=0),L.browserEvent&&L.browserEvent.altKey&&(H=H*this.a.fastScrollSensitivity,M=M*this.a.fastScrollSensitivity);const W=this.b.getFutureScrollPosition();let ee={};if(M){const ne=a*M,re=W.scrollTop-(ne<0?Math.floor(ne):Math.ceil(ne));this.c.writeScrollPosition(ee,re)}if(H){const ne=a*H,re=W.scrollLeft-(ne<0?Math.floor(ne):Math.ceil(ne));this.g.writeScrollPosition(ee,re)}ee=this.b.validateScrollPosition(ee),(W.scrollLeft!==ee.scrollLeft||W.scrollTop!==ee.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(ee):this.b.setScrollPositionNow(ee),p=!0)}let N=p;!N&&this.a.alwaysConsumeMouseWheel&&(N=!0),!N&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(N=!0),N&&(L.preventDefault(),L.stopPropagation())}N(L){this.y=this.g.onDidScroll(L)||this.y,this.y=this.c.onDidScroll(L)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),m=L.scrollTop>0,p=L.scrollLeft>0,N=p?" left":"",M=m?" top":"",H=p||m?" top-left-corner":"";this.i.setClassName(`shadow${N}`),this.l.setClassName(`shadow${M}`),this.n.setClassName(`shadow${H}${M}${N}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(L){this.v=!1,this.W()}S(L){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.$IP=g;class b extends g{constructor(L,m){m=m||{},m.mouseWheelSmoothScroll=!1;const p=new h.$Kr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:N=>S.$nO(N)});super(L,m,p),this.B(p)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$JP=b;class $ extends g{constructor(L,m,p){super(L,m,p)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$KP=$;class c extends g{constructor(L,m){m=m||{},m.mouseWheelSmoothScroll=!1;const p=new h.$Kr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:N=>S.$nO(N)});super(L,m,p),this.B(p),this.Y=L,this.B(this.onScroll(N=>{N.scrollTopChanged&&(this.Y.scrollTop=N.scrollTop),N.scrollLeftChanged&&(this.Y.scrollLeft=N.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.$LP=c;function O(R){const L={lazyRender:typeof R.lazyRender<"u"?R.lazyRender:!1,className:typeof R.className<"u"?R.className:"",useShadows:typeof R.useShadows<"u"?R.useShadows:!0,handleMouseWheel:typeof R.handleMouseWheel<"u"?R.handleMouseWheel:!0,flipAxes:typeof R.flipAxes<"u"?R.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof R.consumeMouseWheelIfScrollbarIsNeeded<"u"?R.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof R.alwaysConsumeMouseWheel<"u"?R.alwaysConsumeMouseWheel:!1,scrollYToX:typeof R.scrollYToX<"u"?R.scrollYToX:!1,mouseWheelScrollSensitivity:typeof R.mouseWheelScrollSensitivity<"u"?R.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof R.fastScrollSensitivity<"u"?R.fastScrollSensitivity:5,scrollPredominantAxis:typeof R.scrollPredominantAxis<"u"?R.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof R.mouseWheelSmoothScroll<"u"?R.mouseWheelSmoothScroll:!0,arrowSize:typeof R.arrowSize<"u"?R.arrowSize:11,listenOnDomNode:typeof R.listenOnDomNode<"u"?R.listenOnDomNode:null,horizontal:typeof R.horizontal<"u"?R.horizontal:1,horizontalScrollbarSize:typeof R.horizontalScrollbarSize<"u"?R.horizontalScrollbarSize:10,horizontalSliderSize:typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:0,horizontalHasArrows:typeof R.horizontalHasArrows<"u"?R.horizontalHasArrows:!1,vertical:typeof R.vertical<"u"?R.vertical:1,verticalScrollbarSize:typeof R.verticalScrollbarSize<"u"?R.verticalScrollbarSize:10,verticalHasArrows:typeof R.verticalHasArrows<"u"?R.verticalHasArrows:!1,verticalSliderSize:typeof R.verticalSliderSize<"u"?R.verticalSliderSize:0,scrollByPage:typeof R.scrollByPage<"u"?R.scrollByPage:!1};return L.horizontalSliderSize=typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof R.verticalSliderSize<"u"?R.verticalSliderSize:L.verticalScrollbarSize,r.$j&&(L.className+=" mac"),L}}),define(me[58],$e([1,0,51,4,21,23,57,13,9,25,3,2,45,46,80,117,6]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h,e,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=t.$cQ=t.$bQ=t.$aQ=void 0;const s={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class g{get context(){return this.d}set context(m){this.d=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$aQ=g;class b{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$bQ=b;class ${constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let p=0;p<m.files.length;p++){const N=m.files.item(p);N&&(N.size||N.type)&&this.files.push(N)}}}getData(){return{types:this.types,files:this.files}}}t.$cQ=$;function c(L,m){return Array.isArray(L)&&Array.isArray(m)?(0,v.$of)(L,m):L===m}class O{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=(p,N,M)=>M,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=(p,N)=>N+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=p=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=p=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(m){if(m!==this.O){if(m&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=m,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const p of this.d)this.Y(p);this.V(),this.q.setScrollDimensions({width:(0,S.$AO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(m,p,N,M=n){if(this.Q=p,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new l.$Bg(50),this.v=!1,this.x=P.$mb.None,this.y=0,this.G=!1,this.J=P.$mb.None,this.K=P.$mb.None,this.L=new P.$lb,this.M=new f.$hc,this.N=new f.$hc,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=f.Event.latch(this.N.event,void 0,this.L),this.O=!1,M.horizontalScrolling&&M.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$$P(M.paddingTop??0);for(const j of N)this.j.set(j.templateId,j);this.h=this.L.add(new a.$_P(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof M.mouseSupport=="boolean"?M.mouseSupport:!0),this.O=M.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof M.paddingBottom>"u"?0:M.paddingBottom,this.D=new O(M.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(M.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$vP.addTarget(this.o)),this.p=this.L.add(new h.$Kr({forceIntegerValues:!0,smoothScrollDuration:M.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:j=>(0,S.$nO)(j)})),this.q=this.L.add(new D.$KP(this.o,{alwaysConsumeMouseWheel:M.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:M.verticalScrollMode??n.verticalScrollMode,useShadows:M.useShadows??n.useShadows,mouseWheelScrollSensitivity:M.mouseWheelScrollSensitivity,fastScrollSensitivity:M.fastScrollSensitivity,scrollByPage:M.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),m.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,S.$fO)(this.o,U.EventType.Change,j=>this.hb(j))),this.L.add((0,S.$fO)(this.q.getDomNode(),"scroll",j=>j.target.scrollTop=0)),this.L.add((0,S.$fO)(this.domNode,"dragover",j=>this.jb(this.fb(j)))),this.L.add((0,S.$fO)(this.domNode,"drop",j=>this.lb(this.fb(j)))),this.L.add((0,S.$fO)(this.domNode,"dragleave",j=>this.kb(this.fb(j)))),this.L.add((0,S.$fO)(this.domNode,"dragend",j=>this.mb(j))),this.z=M.setRowLineHeight??n.setRowLineHeight,this.A=M.setRowHeight??n.setRowHeight,this.B=M.supportDynamicHeights??n.supportDynamicHeights,this.F=M.dnd??n.dnd,this.layout(M.initialSize?.height,M.initialSize?.width)}updateOptions(m){m.paddingBottom!==void 0&&(this.C=m.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.P=m.horizontalScrolling);let p;if(m.scrollByPage!==void 0&&(p={...p??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&(p={...p??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&(p={...p??{},fastScrollSensitivity:m.fastScrollSensitivity}),p&&this.q.updateOptions(p),m.paddingTop!==void 0&&m.paddingTop!==this.g.paddingTop){const N=this.sb(this.k,this.m),M=m.paddingTop-this.g.paddingTop;this.g.paddingTop=m.paddingTop,this.W(N,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(m){this.q.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.q.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,p,N){if(m<0||m>=this.d.length)return;const M=this.d[m].size;if(typeof p>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[m].lastDynamicHeightWidth=void 0,p=M+this.ub(m)}if(M===p)return;const H=this.sb(this.k,this.m);let j=0;m<H.start||N!==null&&N>m&&N<=H.end?j=p-M:j=0,this.g.splice(m,1,[{size:p}]),this.d[m].size=p,this.W(H,Math.max(0,this.k+j),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(m,p,N=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(m,p,N)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(m,p,N=[]){const M=this.sb(this.k,this.m),H={start:m,end:m+p},j=r.Range.intersect(M,H),W=new Map;for(let J=j.end-1;J>=j.start;J--){const X=this.d[J];if(X.dragStartDisposable.dispose(),X.checkedDisposable.dispose(),X.row){let k=W.get(X.templateId);k||(k=[],W.set(X.templateId,k));const V=this.j.get(X.templateId);V&&V.disposeElement&&V.disposeElement(X.element,J,X.row.templateData,X.size),k.push(X.row)}X.row=null}const ee={start:m+p,end:this.d.length},ne=r.Range.intersect(ee,M),re=r.Range.relativeComplement(ee,M),ce=N.map(J=>({id:String(this.f++),element:J,templateId:this.Q.getTemplateId(J),size:this.Q.getHeight(J),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(J),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$mb.None,checkedDisposable:P.$mb.None}));let he;m===0&&p>=this.d.length?(this.g=new e.$$P(this.g.paddingTop),this.g.splice(0,0,ce),he=this.d,this.d=ce):(this.g.splice(m,p,ce),he=this.d.splice(m,p,...ce));const ae=N.length-p,we=this.sb(this.k,this.m),Oe=(0,e.$9P)(ne,ae),Ie=r.Range.intersect(we,Oe);for(let J=Ie.start;J<Ie.end;J++)this.Z(this.d[J],J);const Me=r.Range.relativeComplement(Oe,we);for(const J of Me)for(let X=J.start;X<J.end;X++)this.ab(X);const fe=re.map(J=>(0,e.$9P)(J,ae)),G=[{start:m,end:m+N.length},...fe].map(J=>r.Range.intersect(we,J)),x=this.vb(G);for(const J of G)for(let X=J.start;X<J.end;X++){const k=this.d[X],d=W.get(k.templateId)?.pop();this.X(X,x,d)}for(const J of W.values())for(const X of J)this.h.release(X);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),he.map(J=>J.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,S.$nO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let m=0;for(const p of this.d)typeof p.width<"u"&&(m=Math.max(m,p.width));this.E=m,this.q.setScrollDimensions({scrollWidth:m===0?0:m+10}),this.N.fire(this.E)}updateWidth(m){if(!this.P||typeof this.E>"u")return;const p=this.d[m];this.Y(p),typeof p.width<"u"&&p.width>this.E&&(this.E=p.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const m of this.d)m.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const m=this.sb(this.k,this.m),p=this.g.positionAt(m.start),N=this.g.positionAt(m.start+1);return N!==-1&&(N-p)/2+p<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(m){return this.d[m].element}indexOf(m){return this.d.findIndex(p=>p.element===m)}domElement(m){const p=this.d[m].row;return p&&p.domNode}elementHeight(m){return this.d[m].size}elementTop(m){return this.g.positionAt(m)}indexAt(m){return this.g.indexAt(m)}indexAfter(m){return this.g.indexAfter(m)}layout(m,p){const N={height:typeof m=="number"?m:(0,S.$CO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,N.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(N),typeof p<"u"&&(this.n=p,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof p=="number"?p:(0,S.$AO)(this.domNode)})}W(m,p,N,M,H,j=!1){const W=this.sb(p,N),ee=r.Range.relativeComplement(W,m),ne=r.Range.relativeComplement(m,W),re=this.vb(ee);if(j){const ce=r.Range.intersect(m,W);for(let he=ce.start;he<ce.end;he++)this.Z(this.d[he],he)}this.h.transact(()=>{for(const ce of ne)for(let he=ce.start;he<ce.end;he++)this.ab(he);for(const ce of ee)for(let he=ce.start;he<ce.end;he++)this.X(he,re)}),M!==void 0&&(this.o.style.left=`-${M}px`),this.o.style.top=`-${p}px`,this.P&&H!==void 0&&(this.o.style.width=`${Math.max(H,this.n)}px`),this.k=p,this.m=N}X(m,p,N){const M=this.d[m];let H=!1;if(!M.row)if(N)M.row=N;else{const re=this.h.alloc(M.templateId);M.row=re.row,H=re.isReusingConnectedDomNode}const j=this.D.getRole(M.element)||"listitem";M.row.domNode.setAttribute("role",j);const W=this.D.isChecked(M.element);if(typeof W=="boolean")M.row.domNode.setAttribute("aria-checked",String(!!W));else if(W){const re=ce=>M.row.domNode.setAttribute("aria-checked",String(!!ce));re(W.value),M.checkedDisposable=W.onDidChange(re)}(H||!M.row.domNode.parentElement)&&(p?this.o.insertBefore(M.row.domNode,p):this.o.appendChild(M.row.domNode)),this.Z(M,m);const ee=this.j.get(M.templateId);if(!ee)throw new Error(`No renderer found for template id ${M.templateId}`);ee?.renderElement(M.element,m,M.row.templateData,M.size);const ne=this.F.getDragURI(M.element);M.dragStartDisposable.dispose(),M.row.domNode.draggable=!!ne,ne&&(M.dragStartDisposable=(0,S.$fO)(M.row.domNode,"dragstart",re=>this.ib(M.element,ne,re))),this.P&&(this.Y(M),this.U())}Y(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,S.$AO)(m.row.domNode);const p=window.getComputedStyle(m.row.domNode);p.paddingLeft&&(m.width+=parseFloat(p.paddingLeft)),p.paddingRight&&(m.width+=parseFloat(p.paddingRight)),m.row.domNode.style.width=""}Z(m,p){m.row.domNode.style.top=`${this.elementTop(p)}px`,this.A&&(m.row.domNode.style.height=`${m.size}px`),this.z&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${p}`),m.row.domNode.setAttribute("data-last-element",p===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",p%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(m.element,p,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(m.element,p))),m.row.domNode.setAttribute("id",this.getElementDomId(p)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}ab(m){const p=this.d[m];if(p.dragStartDisposable.dispose(),p.checkedDisposable.dispose(),p.row){const N=this.j.get(p.templateId);N&&N.disposeElement&&N.disposeElement(p.element,m,p.row.templateData,p.size),this.h.release(p.row),p.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(m,p){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:m,reuseAnimation:p})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(m){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"click")).event,m=>this.bb(m),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"dblclick")).event,m=>this.bb(m),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new i.$ZP(this.domNode,"auxclick")).event,m=>this.bb(m),this.L),m=>m.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"mouseup")).event,m=>this.bb(m),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"mousedown")).event,m=>this.bb(m),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"mouseover")).event,m=>this.bb(m),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"mousemove")).event,m=>this.bb(m),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"mouseout")).event,m=>this.bb(m),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new i.$ZP(this.domNode,"contextmenu")).event,m=>this.bb(m),this.L),f.Event.map(this.L.add(new i.$ZP(this.domNode,U.EventType.Contextmenu)).event,m=>this.eb(m),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new i.$ZP(this.domNode,"touchstart")).event,m=>this.db(m),this.L)}get onTap(){return f.Event.map(this.L.add(new i.$ZP(this.o,U.EventType.Tap)).event,m=>this.eb(m),this.L)}bb(m){const p=this.rb(m.target||null),N=typeof p>"u"?void 0:this.d[p],M=N&&N.element;return{browserEvent:m,index:p,element:M}}db(m){const p=this.rb(m.target||null),N=typeof p>"u"?void 0:this.d[p],M=N&&N.element;return{browserEvent:m,index:p,element:M}}eb(m){const p=this.rb(m.initialTarget||null),N=typeof p>"u"?void 0:this.d[p],M=N&&N.element;return{browserEvent:m,index:p,element:M}}fb(m){const p=this.rb(m.target||null),N=typeof p>"u"?void 0:this.d[p],M=N&&N.element;return{browserEvent:m,index:p,element:M}}gb(m){try{const p=this.sb(this.k,this.m);this.W(p,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.B&&this.tb(m.scrollTop,m.height,m.inSmoothScrolling)}catch(p){throw console.error("Got bad scroll event:",m),p}}hb(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}ib(m,p,N){if(!N.dataTransfer)return;const M=this.F.getDragElements(m);if(N.dataTransfer.effectAllowed="copyMove",N.dataTransfer.setData(y.$tP.TEXT,p),N.dataTransfer.setDragImage){let H;this.F.getDragLabel&&(H=this.F.getDragLabel(M,N)),typeof H>"u"&&(H=String(M.length));const j=(0,S.$)(".monaco-drag-image");j.textContent=H;const ee=(ne=>{for(;ne&&!ne.classList.contains("monaco-workbench");)ne=ne.parentElement;return ne||document.body})(this.domNode);ee.appendChild(j),N.dataTransfer.setDragImage(j,-10,-10),setTimeout(()=>ee.removeChild(j),0)}this.domNode.classList.add("dragging"),this.H=new g(M),s.CurrentDragAndDropData=new b(M),this.F.onDragStart?.(this.H,N)}jb(m){if(m.browserEvent.preventDefault(),this.K.dispose(),s.CurrentDragAndDropData&&s.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.H)if(s.CurrentDragAndDropData)this.H=s.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.H=new $}const p=this.F.onDragOver(this.H,m.element,m.index,m.browserEvent);if(this.G=typeof p=="boolean"?p:p.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof p!="boolean"&&p.effect===0?"copy":"move";let N;if(typeof p!="boolean"&&p.feedback?N=p.feedback:typeof m.index>"u"?N=[-1]:N=[m.index],N=(0,v.$Ff)(N).filter(M=>M>=-1&&M<this.length).sort((M,H)=>M-H),N=N[0]===-1?[-1]:N,c(this.I,N))return!0;if(this.I=N,this.J.dispose(),N[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,P.$kb)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const M of N){const H=this.d[M];H.dropTarget=!0,H.row?.domNode.classList.add("drop-target")}this.J=(0,P.$kb)(()=>{for(const M of N){const H=this.d[M];H.dropTarget=!1,H.row?.domNode.classList.remove("drop-target")}})}return!0}kb(m){this.K.dispose(),this.K=(0,l.$Gg)(()=>this.nb(),100),this.H&&this.F.onDragLeave?.(this.H,m.element,m.index,m.browserEvent)}lb(m){if(!this.G)return;const p=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,!(!p||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),p.update(m.browserEvent.dataTransfer),this.F.drop(p,m.element,m.index,m.browserEvent))}mb(m){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,s.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(m)}nb(){this.I=void 0,this.J.dispose(),this.J=P.$mb.None}ob(m){if(!this.w){const p=(0,S.$uO)(this.domNode).top;this.w=(0,S.$dP)(this.pb.bind(this,p))}this.x.dispose(),this.x=(0,l.$Gg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=m.pageY}pb(m){if(this.y===void 0)return;const p=this.y-m,N=this.renderHeight-35;p<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(p-35))):p>N&&(this.scrollTop+=Math.min(14,Math.floor(.3*(p-N))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(m){const p=this.q.getDomNode();let N=m;for(;N instanceof HTMLElement&&N!==this.o&&p.contains(N);){const M=N.getAttribute("data-index");if(M){const H=Number(M);if(!isNaN(H))return H}N=N.parentElement}}sb(m,p){return{start:this.g.indexAt(m),end:this.g.indexAfter(m+p-1)}}tb(m,p,N){const M=this.sb(m,p);let H,j;m===this.elementTop(M.start)?(H=M.start,j=0):M.end-M.start>1&&(H=M.start+1,j=this.elementTop(H)-m);let W=0;for(;;){const ee=this.sb(m,p);let ne=!1;for(let re=ee.start;re<ee.end;re++){const ce=this.ub(re);ce!==0&&this.g.splice(re,1,[this.d[re]]),W+=ce,ne=ne||ce!==0}if(!ne){W!==0&&this.S();const re=r.Range.relativeComplement(M,ee);for(const he of re)for(let ae=he.start;ae<he.end;ae++)this.d[ae].row&&this.ab(ae);const ce=r.Range.relativeComplement(ee,M);for(const he of ce)for(let ae=he.start;ae<he.end;ae++){const we=ae+1,Oe=we<this.d.length?this.d[we].row:null,Ie=Oe?Oe.domNode:null;this.X(ae,Ie)}for(let he=ee.start;he<ee.end;he++)this.d[he].row&&this.Z(this.d[he],he);if(typeof H=="number"){const he=this.p.getFutureScrollPosition().scrollTop-m,ae=this.elementTop(H)-j+he;this.setScrollTop(ae,N)}this.M.fire(this.contentHeight);return}}}ub(m){const p=this.d[m];if(this.Q.getDynamicHeight){const j=this.Q.getDynamicHeight(p.element);if(j!==null){const W=p.size;return p.size=j,p.lastDynamicHeightWidth=this.n,j-W}}if(!p.hasDynamicHeight||p.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(p.element))return 0;const N=p.size;if(p.row)return p.row.domNode.style.height="",p.size=p.row.domNode.offsetHeight,p.lastDynamicHeightWidth=this.n,p.size-N;const{row:M}=this.h.alloc(p.templateId);M.domNode.style.height="",this.o.appendChild(M.domNode);const H=this.j.get(p.templateId);if(!H)throw new o.$ab("Missing renderer for templateId: "+p.templateId);return H.renderElement(p.element,m,M.templateData,void 0),p.size=M.domNode.offsetHeight,H.disposeElement?.(p.element,m,M.templateData,void 0),this.Q.setDynamicHeight?.(p.element,p.size),p.lastDynamicHeightWidth=this.n,this.o.removeChild(M.domNode),this.h.release(M),p.size-N}vb(m){const p=m[m.length-1];if(!p)return null;const N=this.d[p.end];return!N||!N.row?null:N.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){for(const m of this.d)if(m.dragStartDisposable.dispose(),m.checkedDisposable.dispose(),m.row){const p=this.j.get(m.row.templateId);p&&(p.disposeElement?.(m.element,-1,m.row.templateData,void 0),p.disposeTemplate(m.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.$hb)(this.L)}}t.$dQ=R,Ke([u.$4g],R.prototype,"onMouseClick",null),Ke([u.$4g],R.prototype,"onMouseDblClick",null),Ke([u.$4g],R.prototype,"onMouseMiddleClick",null),Ke([u.$4g],R.prototype,"onMouseUp",null),Ke([u.$4g],R.prototype,"onMouseDown",null),Ke([u.$4g],R.prototype,"onMouseOver",null),Ke([u.$4g],R.prototype,"onMouseMove",null),Ke([u.$4g],R.prototype,"onMouseOut",null),Ke([u.$4g],R.prototype,"onContextMenu",null),Ke([u.$4g],R.prototype,"onTouchStart",null),Ke([u.$4g],R.prototype,"onTap",null)}),define(me[37],$e([1,0,4,21,14,23,54,68,13,9,71,25,3,32,2,44,5,7,67,58,19,95]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h,e,a,o,s,n,g,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.TypeNavigationMode=t.$gQ=t.$fQ=t.$eQ=void 0;class ${constructor(k){this.d=k,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(k){return k}renderElement(k,V,d){const w=this.c.findIndex(E=>E.templateData===d);if(w>=0){const E=this.c[w];this.d.unrender(d),E.index=V}else{const E={index:V,templateData:d};this.c.push(E)}this.d.renderIndex(V,d)}splice(k,V,d){const w=[];for(const E of this.c)E.index<k?w.push(E):E.index>=k+V&&w.push({index:E.index+d-V,templateData:E.templateData});this.c=w}renderIndexes(k){for(const{index:V,templateData:d}of this.c)k.indexOf(V)>-1&&this.d.renderIndex(V,d)}disposeTemplate(k){const V=this.c.findIndex(d=>d.templateData===k);V<0||this.c.splice(V,1)}}class c{get name(){return this.h}get renderer(){return new $(this)}constructor(k){this.h=k,this.c=0,this.d=[],this.f=[],this.g=new r.$hc,this.onChange=this.g.event}splice(k,V,d){V=Math.max(0,Math.min(V,this.c-k));const w=d.length-V,E=k+V,I=[];let F=0;for(;F<this.f.length&&this.f[F]<k;)I.push(this.f[F++]);for(let q=0;q<d.length;q++)d[q]&&I.push(q+k);for(;F<this.f.length&&this.f[F]>=E;)I.push(this.f[F++]+w);const B=this.c+w;if(this.f.length>0&&I.length===0&&B>0){const q=this.f.find(T=>T>=k)??B-1;I.push(Math.min(q,B-1))}this.renderer.splice(k,V,d.length),this.k(I,I),this.c=B}renderIndex(k,V){V.classList.toggle(this.h,this.contains(k))}unrender(k){k.classList.remove(this.h)}set(k,V){return this.k(k,[...k].sort(fe),V)}k(k,V,d){const w=this.d,E=this.f;this.d=k,this.f=V;const I=Ie(E,k);return this.renderer.renderIndexes(I),this.g.fire({indexes:k,browserEvent:d}),w}get(){return this.d}contains(k){return(0,l.$qf)(this.f,k,fe)>=0}dispose(){(0,e.$hb)(this.g)}}Ke([P.$4g],c.prototype,"renderer",null);class O extends c{constructor(k){super("selected"),this.l=k}renderIndex(k,V){super.renderIndex(k,V),this.l&&(this.contains(k)?V.setAttribute("aria-selected","true"):V.setAttribute("aria-selected","false"))}}class R{constructor(k,V,d){this.c=k,this.d=V,this.f=d}splice(k,V,d){if(!this.f)return this.c.splice(k,V,new Array(d.length).fill(!1));const w=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString());if(w.length===0)return this.c.splice(k,V,new Array(d.length).fill(!1));const E=new Set(w),I=d.map(F=>E.has(this.f.getId(F).toString()));this.c.splice(k,V,I)}}function L(X){return X.tagName==="INPUT"||X.tagName==="TEXTAREA"}t.$eQ=L;function m(X){return X.classList.contains("monaco-editor")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:m(X.parentElement)}t.$fQ=m;function p(X){return X.tagName==="A"&&X.classList.contains("monaco-button")||X.tagName==="DIV"&&X.classList.contains("monaco-button-dropdown")?!0:X.classList.contains("monaco-list")||!X.parentElement?!1:p(X.parentElement)}t.$gQ=p;class N{get g(){return r.Event.chain(this.c.add(new S.$ZP(this.k.domNode,"keydown")).event,k=>k.filter(V=>!L(V.target)).map(V=>new i.$cO(V)))}constructor(k,V,d){this.h=k,this.k=V,this.c=new e.$lb,this.d=new e.$lb,this.f=d.multipleSelectionSupport,this.c.add(this.g(w=>{switch(w.keyCode){case 3:return this.l(w);case 16:return this.o(w);case 18:return this.p(w);case 11:return this.q(w);case 12:return this.s(w);case 9:return this.u(w);case 31:this.f&&(o.$j?w.metaKey:w.ctrlKey)&&this.t(w)}}))}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.f=k.multipleSelectionSupport)}l(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection(this.h.getFocus(),k.browserEvent)}o(k){k.preventDefault(),k.stopPropagation(),this.h.focusPrevious(1,!1,k.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}p(k){k.preventDefault(),k.stopPropagation(),this.h.focusNext(1,!1,k.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}q(k){k.preventDefault(),k.stopPropagation(),this.h.focusPreviousPage(k.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}s(k){k.preventDefault(),k.stopPropagation(),this.h.focusNextPage(k.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}t(k){k.preventDefault(),k.stopPropagation(),this.h.setSelection((0,l.$Lf)(this.h.length),k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(k){this.h.getSelection().length&&(k.preventDefault(),k.stopPropagation(),this.h.setSelection([],k.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ke([P.$4g],N.prototype,"g",null);var M;(function(X){X[X.Automatic=0]="Automatic",X[X.Trigger=1]="Trigger"})(M||(t.TypeNavigationMode=M={}));var H;(function(X){X[X.Idle=0]="Idle",X[X.Typing=1]="Typing"})(H||(H={})),t.$hQ=new class{mightProducePrintableCharacter(X){return X.ctrlKey||X.metaKey||X.altKey?!1:X.keyCode>=31&&X.keyCode<=56||X.keyCode>=21&&X.keyCode<=30||X.keyCode>=98&&X.keyCode<=107||X.keyCode>=85&&X.keyCode<=95}};class j{constructor(k,V,d,w,E){this.o=k,this.p=V,this.q=d,this.s=w,this.t=E,this.c=!1,this.d=H.Idle,this.f=M.Automatic,this.g=!1,this.h=-1,this.k=new e.$lb,this.l=new e.$lb,this.updateOptions(k.options)}updateOptions(k){k.typeNavigationEnabled??!0?this.u():this.v(),this.f=k.typeNavigationMode??M.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let k=!1;const V=r.Event.chain(this.k.add(new S.$ZP(this.p.domNode,"keydown")).event,E=>E.filter(I=>!L(I.target)).filter(()=>this.f===M.Automatic||this.g).map(I=>new i.$cO(I)).filter(I=>k||this.s(I)).filter(I=>this.t.mightProducePrintableCharacter(I)).forEach(I=>y.$VO.stop(I,!0)).map(I=>I.browserEvent.key)),d=r.Event.debounce(V,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(V,d),(E,I)=>I===null?null:(E||"")+I,void 0,this.k)(this.x,this,this.k),d(this.w,this,this.k),V(()=>k=!0,void 0,this.k),d(()=>k=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const k=this.o.getFocus();if(k.length>0&&k[0]===this.h){const V=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(k[0]));V&&(0,D.$2P)(V)}this.h=-1}x(k){if(!k){this.d=H.Idle,this.g=!1;return}const V=this.o.getFocus(),d=V.length>0?V[0]:0,w=this.d===H.Idle?1:0;this.d=H.Typing;for(let E=0;E<this.o.length;E++){const I=(d+E+w)%this.o.length,F=this.q.getKeyboardNavigationLabel(this.p.element(I)),B=F&&F.toString();if(this.o.options.typeNavigationEnabled){if(typeof B<"u"){if((0,h.$wj)(k,B)){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}const q=(0,h.$Dj)(k,B);if(q&&q[0].end-q[0].start>1&&q.length===1){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}}}else if(typeof B>"u"||(0,h.$wj)(k,B)){this.h=d,this.o.setFocus([I]),this.o.reveal(I);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class W{constructor(k,V){this.d=k,this.f=V,this.c=new e.$lb;const d=r.Event.chain(this.c.add(new S.$ZP(V.domNode,"keydown")).event,E=>E.filter(I=>!L(I.target)).map(I=>new i.$cO(I)));r.Event.chain(d,E=>E.filter(I=>I.keyCode===2&&!I.ctrlKey&&!I.metaKey&&!I.shiftKey&&!I.altKey))(this.g,this,this.c)}g(k){if(k.target!==this.f.domNode)return;const V=this.d.getFocus();if(V.length===0)return;const d=this.f.domElement(V[0]);if(!d)return;const w=d.querySelector("[tabIndex]");if(!w||!(w instanceof HTMLElement)||w.tabIndex===-1)return;const E=window.getComputedStyle(w);E.visibility==="hidden"||E.display==="none"||(k.preventDefault(),k.stopPropagation(),w.focus())}dispose(){this.c.dispose()}}function ee(X){return o.$j?X.browserEvent.metaKey:X.browserEvent.ctrlKey}t.$iQ=ee;function ne(X){return X.browserEvent.shiftKey}t.$jQ=ne;function re(X){return X instanceof MouseEvent&&X.button===2}const ce={isSelectionSingleChangeEvent:ee,isSelectionRangeChangeEvent:ne};class he{constructor(k){this.k=k,this.f=new e.$lb,this.g=new r.$hc,this.onPointer=this.g.event,k.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof k.options.mouseSupport>"u"||!!k.options.mouseSupport,this.d&&(k.onMouseDown(this.s,this,this.f),k.onContextMenu(this.t,this,this.f),k.onMouseDblClick(this.v,this,this.f),k.onTouchStart(this.s,this,this.f),this.f.add(U.$vP.addTarget(k.getHTMLElement()))),r.Event.any(k.onMouseClick,k.onMouseMiddleClick,k.onTap)(this.u,this,this.f)}updateOptions(k){k.multipleSelectionSupport!==void 0&&(this.c=void 0,k.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(k){return this.c?this.c.isSelectionSingleChangeEvent(k):!1}p(k){return this.c?this.c.isSelectionRangeChangeEvent(k):!1}q(k){return this.o(k)||this.p(k)}s(k){m(k.browserEvent.target)||document.activeElement!==k.browserEvent.target&&this.k.domFocus()}t(k){if(L(k.browserEvent.target)||m(k.browserEvent.target))return;const V=typeof k.index>"u"?[]:[k.index];this.k.setFocus(V,k.browserEvent)}u(k){if(!this.d||L(k.browserEvent.target)||m(k.browserEvent.target)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const V=k.index;if(typeof V>"u"){this.k.setFocus([],k.browserEvent),this.k.setSelection([],k.browserEvent),this.k.setAnchor(void 0);return}if(this.q(k))return this.w(k);this.k.setFocus([V],k.browserEvent),this.k.setAnchor(V),re(k.browserEvent)||this.k.setSelection([V],k.browserEvent),this.g.fire(k)}v(k){if(L(k.browserEvent.target)||m(k.browserEvent.target)||this.q(k)||k.browserEvent.isHandledByList)return;k.browserEvent.isHandledByList=!0;const V=this.k.getFocus();this.k.setSelection(V,k.browserEvent)}w(k){const V=k.index;let d=this.k.getAnchor();if(this.p(k)){typeof d>"u"&&(d=this.k.getFocus()[0]??V,this.k.setAnchor(d));const w=Math.min(d,V),E=Math.max(d,V),I=(0,l.$Lf)(w,E+1),F=this.k.getSelection(),B=Oe(Ie(F,[d]),d);if(B.length===0)return;const q=Ie(I,Me(F,B));this.k.setSelection(q,k.browserEvent),this.k.setFocus([V],k.browserEvent)}else if(this.o(k)){const w=this.k.getSelection(),E=w.filter(I=>I!==V);this.k.setFocus([V]),this.k.setAnchor(V),w.length===E.length?this.k.setSelection([...E,V],k.browserEvent):this.k.setSelection(E,k.browserEvent)}}dispose(){this.f.dispose()}}t.$kQ=he;class ae{constructor(k,V){this.c=k,this.d=V}style(k){const V=this.d&&`.${this.d}`,d=[];k.listBackground&&d.push(`.monaco-list${V} .monaco-list-rows { background: ${k.listBackground}; }`),k.listFocusBackground&&(d.push(`.monaco-list${V}:focus .monaco-list-row.focused { background-color: ${k.listFocusBackground}; }`),d.push(`.monaco-list${V}:focus .monaco-list-row.focused:hover { background-color: ${k.listFocusBackground}; }`)),k.listFocusForeground&&d.push(`.monaco-list${V}:focus .monaco-list-row.focused { color: ${k.listFocusForeground}; }`),k.listActiveSelectionBackground&&(d.push(`.monaco-list${V}:focus .monaco-list-row.selected { background-color: ${k.listActiveSelectionBackground}; }`),d.push(`.monaco-list${V}:focus .monaco-list-row.selected:hover { background-color: ${k.listActiveSelectionBackground}; }`)),k.listActiveSelectionForeground&&d.push(`.monaco-list${V}:focus .monaco-list-row.selected { color: ${k.listActiveSelectionForeground}; }`),k.listActiveSelectionIconForeground&&d.push(`.monaco-list${V}:focus .monaco-list-row.selected .codicon { color: ${k.listActiveSelectionIconForeground}; }`),k.listFocusAndSelectionBackground&&d.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { background-color: ${k.listFocusAndSelectionBackground}; }
			`),k.listFocusAndSelectionForeground&&d.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { color: ${k.listFocusAndSelectionForeground}; }
			`),k.listInactiveFocusForeground&&(d.push(`.monaco-list${V} .monaco-list-row.focused { color:  ${k.listInactiveFocusForeground}; }`),d.push(`.monaco-list${V} .monaco-list-row.focused:hover { color:  ${k.listInactiveFocusForeground}; }`)),k.listInactiveSelectionIconForeground&&d.push(`.monaco-list${V} .monaco-list-row.focused .codicon { color:  ${k.listInactiveSelectionIconForeground}; }`),k.listInactiveFocusBackground&&(d.push(`.monaco-list${V} .monaco-list-row.focused { background-color:  ${k.listInactiveFocusBackground}; }`),d.push(`.monaco-list${V} .monaco-list-row.focused:hover { background-color:  ${k.listInactiveFocusBackground}; }`)),k.listInactiveSelectionBackground&&(d.push(`.monaco-list${V} .monaco-list-row.selected { background-color:  ${k.listInactiveSelectionBackground}; }`),d.push(`.monaco-list${V} .monaco-list-row.selected:hover { background-color:  ${k.listInactiveSelectionBackground}; }`)),k.listInactiveSelectionForeground&&d.push(`.monaco-list${V} .monaco-list-row.selected { color: ${k.listInactiveSelectionForeground}; }`),k.listHoverBackground&&d.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${k.listHoverBackground}; }`),k.listHoverForeground&&d.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${k.listHoverForeground}; }`);const w=(0,y.$gP)(k.listFocusAndSelectionOutline,(0,y.$gP)(k.listSelectionOutline,k.listFocusOutline??""));w&&d.push(`.monaco-list${V}:focus .monaco-list-row.focused.selected { outline: 1px solid ${w}; outline-offset: -1px;}`),k.listFocusOutline&&d.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${V}.last-focused .monaco-list-row.focused { outline: 1px solid ${k.listFocusOutline}; outline-offset: -1px; }
			`);const E=(0,y.$gP)(k.listSelectionOutline,k.listInactiveFocusOutline??"");E&&d.push(`.monaco-list${V} .monaco-list-row.focused.selected { outline: 1px dotted ${E}; outline-offset: -1px; }`),k.listSelectionOutline&&d.push(`.monaco-list${V} .monaco-list-row.selected { outline: 1px dotted ${k.listSelectionOutline}; outline-offset: -1px; }`),k.listInactiveFocusOutline&&d.push(`.monaco-list${V} .monaco-list-row.focused { outline: 1px dotted ${k.listInactiveFocusOutline}; outline-offset: -1px; }`),k.listHoverOutline&&d.push(`.monaco-list${V} .monaco-list-row:hover { outline: 1px dashed ${k.listHoverOutline}; outline-offset: -1px; }`),k.listDropBackground&&d.push(`
				.monaco-list${V}.drop-target,
				.monaco-list${V} .monaco-list-rows.drop-target,
				.monaco-list${V} .monaco-list-row.drop-target { background-color: ${k.listDropBackground} !important; color: inherit !important; }
			`),k.tableColumnsBorder&&d.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${k.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),k.tableOddRowsBackgroundColor&&d.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${k.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=d.join(`
`)}}t.$lQ=ae,t.$mQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:f.$Ls.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:f.$Ls.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:f.$Ls.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const we={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Oe(X,k){const V=X.indexOf(k);if(V===-1)return[];const d=[];let w=V-1;for(;w>=0&&X[w]===k-(V-w);)d.push(X[w--]);for(d.reverse(),w=V;w<X.length&&X[w]===k+(w-V);)d.push(X[w++]);return d}function Ie(X,k){const V=[];let d=0,w=0;for(;d<X.length||w<k.length;)if(d>=X.length)V.push(k[w++]);else if(w>=k.length)V.push(X[d++]);else if(X[d]===k[w]){V.push(X[d]),d++,w++;continue}else X[d]<k[w]?V.push(X[d++]):V.push(k[w++]);return V}function Me(X,k){const V=[];let d=0,w=0;for(;d<X.length||w<k.length;)if(d>=X.length)V.push(k[w++]);else if(w>=k.length)V.push(X[d++]);else if(X[d]===k[w]){d++,w++;continue}else X[d]<k[w]?V.push(X[d++]):w++;return V}const fe=(X,k)=>X-k;class ie{constructor(k,V){this.c=k,this.d=V}get templateId(){return this.c}renderTemplate(k){return this.d.map(V=>V.renderTemplate(k))}renderElement(k,V,d,w){let E=0;for(const I of this.d)I.renderElement(k,V,d[E++],w)}disposeElement(k,V,d,w){let E=0;for(const I of this.d)I.disposeElement?.(k,V,d[E],w),E+=1}disposeTemplate(k){let V=0;for(const d of this.d)d.disposeTemplate(k[V++])}}class G{constructor(k){this.c=k,this.templateId="a18n"}renderTemplate(k){return k}renderElement(k,V,d){const w=this.c.getAriaLabel(k);w?d.setAttribute("aria-label",w):d.removeAttribute("aria-label");const E=this.c.getAriaLevel&&this.c.getAriaLevel(k);typeof E=="number"?d.setAttribute("aria-level",`${E}`):d.removeAttribute("aria-level")}disposeTemplate(k){}}class x{constructor(k,V){this.c=k,this.d=V}getDragElements(k){const V=this.c.getSelectedElements();return V.indexOf(k)>-1?V:[k]}getDragURI(k){return this.d.getDragURI(k)}getDragLabel(k,V){if(this.d.getDragLabel)return this.d.getDragLabel(k,V)}onDragStart(k,V){this.d.onDragStart?.(k,V)}onDragOver(k,V,d,w){return this.d.onDragOver(k,V,d,w)}onDragLeave(k,V,d,w){this.d.onDragLeave?.(k,V,d,w)}onDragEnd(k){this.d.onDragEnd?.(k)}drop(k,V,d,w){this.d.drop(k,V,d,w)}}class J{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),k=>this.G(k),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),k=>this.G(k),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let k=!1;const V=r.Event.chain(this.y.add(new S.$ZP(this.k.domNode,"keydown")).event,E=>E.map(I=>new i.$cO(I)).filter(I=>k=I.keyCode===58||I.shiftKey&&I.keyCode===68).map(I=>y.$VO.stop(I,!0)).filter(()=>!1)),d=r.Event.chain(this.y.add(new S.$ZP(this.k.domNode,"keyup")).event,E=>E.forEach(()=>k=!1).map(I=>new i.$cO(I)).filter(I=>I.keyCode===58||I.shiftKey&&I.keyCode===68).map(I=>y.$VO.stop(I,!0)).map(({browserEvent:I})=>{const F=this.getFocus(),B=F.length?F[0]:void 0,q=typeof B<"u"?this.k.element(B):void 0,T=typeof B<"u"?this.k.domElement(B):this.k.domNode;return{index:B,element:q,anchor:T,browserEvent:I}})),w=r.Event.chain(this.k.onContextMenu,E=>E.filter(I=>!k).map(({element:I,index:F,browserEvent:B})=>({element:I,index:F,anchor:new b.$0N(B),browserEvent:B})));return r.Event.any(V,d,w)}get onKeyDown(){return this.y.add(new S.$ZP(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new S.$ZP(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new S.$ZP(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new S.$ZP(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new S.$ZP(this.k.domNode,"blur",!0)).event)}constructor(k,V,d,w,E=we){this.A=k,this.B=E,this.c=new c("focused"),this.f=new c("anchor"),this.g=new r.$pc,this.x="",this.y=new e.$lb,this.z=new r.$hc,this.onDidDispose=this.z.event;const I=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new O(I!=="listbox");const F=[this.c.renderer,this.d.renderer];this.u=E.accessibilityProvider,this.u&&(F.push(new G(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),w=w.map(q=>new ie(q.templateId,[...F,q]));const B={...E,dnd:E.dnd&&new x(this,E.dnd)};if(this.k=this.C(V,d,w,B),this.k.domNode.setAttribute("role",I),E.styleController)this.q=E.styleController(this.k.domId);else{const q=(0,y.$OO)(this.k.domNode);this.q=new ae(q,this.k.domId)}if(this.o=new v.$4P([new R(this.c,this.k,E.identityProvider),new R(this.d,this.k,E.identityProvider),new R(this.f,this.k,E.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new W(this,this.k)),(typeof E.keyboardSupport!="boolean"||E.keyboardSupport)&&(this.v=new N(this,this.k,E),this.y.add(this.v)),E.keyboardNavigationLabelProvider){const q=E.keyboardNavigationDelegate||t.$hQ;this.t=new j(this,this.k,E.keyboardNavigationLabelProvider,E.keyboardNavigationEventFilter??(()=>!0),q),this.y.add(this.t)}this.w=this.D(E),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(k,V,d,w){return new g.$dQ(k,V,d,w)}D(k){return new he(this)}updateOptions(k={}){this.B={...this.B,...k},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(k),this.v?.updateOptions(k),this.k.updateOptions(k)}get options(){return this.B}splice(k,V,d=[]){if(k<0||k>this.k.length)throw new n.$6P(this.A,`Invalid start index: ${k}`);if(V<0)throw new n.$6P(this.A,`Invalid delete count: ${V}`);V===0&&d.length===0||this.g.bufferEvents(()=>this.o.splice(k,V,d))}updateWidth(k){this.k.updateWidth(k)}updateElementHeight(k,V){this.k.updateElementHeight(k,V,null)}rerender(){this.k.rerender()}element(k){return this.k.element(k)}indexOf(k){return this.k.indexOf(k)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(k){this.k.setScrollTop(k)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(k){this.k.setScrollLeft(k)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(k){this.x=k,this.k.domNode.setAttribute("aria-label",k)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(k,V){this.k.layout(k,V)}triggerTypeNavigation(){this.t?.trigger()}setSelection(k,V){for(const d of k)if(d<0||d>=this.length)throw new n.$6P(this.A,`Invalid index ${d}`);this.d.set(k,V)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(k=>this.k.element(k))}setAnchor(k){if(typeof k>"u"){this.f.set([]);return}if(k<0||k>=this.length)throw new n.$6P(this.A,`Invalid index ${k}`);this.f.set([k])}getAnchor(){return(0,l.$Hf)(this.f.get(),void 0)}getAnchorElement(){const k=this.getAnchor();return typeof k>"u"?void 0:this.element(k)}setFocus(k,V){for(const d of k)if(d<0||d>=this.length)throw new n.$6P(this.A,`Invalid index ${d}`);this.c.set(k,V)}focusNext(k=1,V=!1,d,w){if(this.length===0)return;const E=this.c.get(),I=this.E(E.length>0?E[0]+k:0,V,w);I>-1&&this.setFocus([I],d)}focusPrevious(k=1,V=!1,d,w){if(this.length===0)return;const E=this.c.get(),I=this.F(E.length>0?E[0]-k:0,V,w);I>-1&&this.setFocus([I],d)}async focusNextPage(k,V){let d=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);d=d===0?0:d-1;const w=this.getFocus()[0];if(w!==d&&(w===void 0||d>w)){const E=this.F(d,!1,V);E>-1&&w!==E?this.setFocus([E],k):this.setFocus([d],k)}else{const E=this.k.getScrollTop();let I=E+this.k.renderHeight;d>w&&(I-=this.k.elementHeight(d)),this.k.setScrollTop(I),this.k.getScrollTop()!==E&&(this.setFocus([]),await(0,u.$Fg)(0),await this.focusNextPage(k,V))}}async focusPreviousPage(k,V){let d;const w=this.k.getScrollTop();w===0?d=this.k.indexAt(w):d=this.k.indexAfter(w-1);const E=this.getFocus()[0];if(E!==d&&(E===void 0||E>=d)){const I=this.E(d,!1,V);I>-1&&E!==I?this.setFocus([I],k):this.setFocus([d],k)}else{const I=w;this.k.setScrollTop(w-this.k.renderHeight),this.k.getScrollTop()!==I&&(this.setFocus([]),await(0,u.$Fg)(0),await this.focusPreviousPage(k,V))}}focusLast(k,V){if(this.length===0)return;const d=this.F(this.length-1,!1,V);d>-1&&this.setFocus([d],k)}focusFirst(k,V){this.focusNth(0,k,V)}focusNth(k,V,d){if(this.length===0)return;const w=this.E(k,!1,d);w>-1&&this.setFocus([w],V)}E(k,V=!1,d){for(let w=0;w<this.length;w++){if(k>=this.length&&!V)return-1;if(k=k%this.length,!d||d(this.element(k)))return k;k++}return-1}F(k,V=!1,d){for(let w=0;w<this.length;w++){if(k<0&&!V)return-1;if(k=(this.length+k%this.length)%this.length,!d||d(this.element(k)))return k;k--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(k=>this.k.element(k))}reveal(k,V){if(k<0||k>=this.length)throw new n.$6P(this.A,`Invalid index ${k}`);const d=this.k.getScrollTop(),w=this.k.elementTop(k),E=this.k.elementHeight(k);if((0,s.$pe)(V)){const I=E-this.k.renderHeight;this.k.setScrollTop(I*(0,a.$Fl)(V,0,1)+w)}else{const I=w+E,F=d+this.k.renderHeight;w<d&&I>=F||(w<d||I>=F&&E>=this.k.renderHeight?this.k.setScrollTop(w):I>=F&&this.k.setScrollTop(I-this.k.renderHeight))}}getRelativeTop(k){if(k<0||k>=this.length)throw new n.$6P(this.A,`Invalid index ${k}`);const V=this.k.getScrollTop(),d=this.k.elementTop(k),w=this.k.elementHeight(k);if(d<V||d+w>V+this.k.renderHeight)return null;const E=w-this.k.renderHeight;return Math.abs((V-d)/E)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(k){return this.k.getElementDomId(k)}style(k){this.q.style(k)}G({indexes:k,browserEvent:V}){return{indexes:k,elements:k.map(d=>this.k.element(d)),browserEvent:V}}H(){const k=this.c.get();this.k.domNode.classList.toggle("element-focused",k.length>0),this.I()}I(){const k=this.c.get();if(k.length>0){let V;this.u?.getActiveDescendantId&&(V=this.u.getActiveDescendantId(this.k.element(k[0]))),this.k.domNode.setAttribute("aria-activedescendant",V||this.k.getElementDomId(k[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const k=this.d.get();this.k.domNode.classList.toggle("selection-none",k.length===0),this.k.domNode.classList.toggle("selection-single",k.length===1),this.k.domNode.classList.toggle("selection-multiple",k.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$nQ=J,Ke([P.$4g],J.prototype,"onDidChangeFocus",null),Ke([P.$4g],J.prototype,"onDidChangeSelection",null),Ke([P.$4g],J.prototype,"onContextMenu",null),Ke([P.$4g],J.prototype,"onKeyDown",null),Ke([P.$4g],J.prototype,"onKeyUp",null),Ke([P.$4g],J.prototype,"onKeyPress",null),Ke([P.$4g],J.prototype,"onDidFocus",null),Ke([P.$4g],J.prototype,"onDidBlur",null)}),define(me[59],$e([1,0,6,33,35,11,15]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.MarkdownStringTextNewlineStyle=void 0;var v;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(v||(t.MarkdownStringTextNewlineStyle=v={}));class l{constructor(s="",n=!1){if(this.value=s,typeof this.value!="string")throw(0,y.$5)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(s,n=0){return this.value+=r(this.supportThemeIcons?(0,S.$Pj)(s):s).replace(/([ \t]+)/g,(g,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,n){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(s,n,g){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(s),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(s,n){const g=new RegExp((0,U.$sd)(n),"g");return s.replace(g,(b,$)=>s.charAt($-1)!=="\\"?`\\${b}`:b)}}t.$Vj=l;function u(o){return f(o)?!o.value:Array.isArray(o)?o.every(u):!0}t.$Wj=u;function f(o){return o instanceof l?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}t.$Xj=f;function P(o,s){return o===s?!0:!o||!s?!1:o.value===s.value&&o.isTrusted===s.isTrusted&&o.supportThemeIcons===s.supportThemeIcons&&o.supportHtml===s.supportHtml&&(o.baseUri===s.baseUri||!!o.baseUri&&!!s.baseUri&&(0,i.$_f)(D.URI.from(o.baseUri),D.URI.from(s.baseUri)))}t.$Yj=P;function r(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$Zj=r;function h(o){return o.replace(/"/g,"&quot;")}t.$1j=h;function e(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$2j=e;function a(o){const s=[],n=o.split("|").map(b=>b.trim());o=n[0];const g=n[1];if(g){const b=/height=(\d+)/.exec(g),$=/width=(\d+)/.exec(g),c=b?b[1]:"",O=$?$[1]:"",R=isFinite(parseInt(O)),L=isFinite(parseInt(c));R&&s.push(`width="${O}"`),L&&s.push(`height="${c}"`)}return{href:o,dimensions:s}}t.$3j=a}),define(me[123],$e([1,0,4,115,21,52,14,19,116,6,3,59,33,74,30,2,77,50,28,48,35,11,15]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h,e,a,o,s,n,g,b,$,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=void 0;const O=Object.freeze({image:(x,J,X)=>{let k=[],V=[];return x&&({href:x,dimensions:k}=(0,P.$3j)(x),V.push(`src="${(0,P.$1j)(x)}"`)),X&&V.push(`alt="${(0,P.$1j)(X)}"`),J&&V.push(`title="${(0,P.$1j)(J)}"`),k.length&&(V=V.concat(k)),"<img "+V.join(" ")+">"},paragraph:x=>`<p>${x}</p>`,link:(x,J,X)=>typeof x!="string"?"":(x===X&&(X=(0,P.$2j)(X)),J=typeof J=="string"?(0,P.$1j)((0,P.$2j)(J)):"",x=(0,P.$2j)(x),x=x.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${x}" title="${J||x}">${X}</a>`)});function R(x,J={},X={}){const k=new a.$lb;let V=!1;const d=(0,U.$YP)(J),w=function(A){let _;try{_=(0,s.$8g)(decodeURIComponent(A))}catch{}return _?(_=(0,g.$Vm)(_,K=>{if(x.uris&&x.uris[K])return c.URI.revive(x.uris[K])}),encodeURIComponent(JSON.stringify(_))):A},E=function(A,_){const K=x.uris&&x.uris[A];let te=c.URI.revive(K);return _?A.startsWith(n.Schemas.data+":")?A:(te||(te=c.URI.parse(A)),n.$4e.uriToBrowserUri(te).toString(!0)):!te||c.URI.parse(A).toString()===te.toString()?A:(te.query&&(te=te.with({query:w(te.query)})),te.toString())},I=new o.marked.Renderer;I.image=O.image,I.link=O.link,I.paragraph=O.paragraph;const F=[],B=[];if(J.codeBlockRendererSync?I.code=(A,_)=>{const K=h.$1L.nextId(),te=J.codeBlockRendererSync(L(_),A);return B.push([K,te]),`<div class="code" data-code="${K}">${(0,$.$rd)(A)}</div>`}:J.codeBlockRenderer&&(I.code=(A,_)=>{const K=h.$1L.nextId(),te=J.codeBlockRenderer(L(_),A);return F.push(te.then(se=>[K,se])),`<div class="code" data-code="${K}">${(0,$.$rd)(A)}</div>`}),J.actionHandler){const A=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(x.baseUri&&(ge=m(c.URI.from(x.baseUri),ge)),J.actionHandler.callback(ge,te))}catch(ge){(0,u.$Y)(ge)}finally{te.preventDefault()}},_=J.actionHandler.disposables.add(new i.$ZP(d,"click")),K=J.actionHandler.disposables.add(new i.$ZP(d,"auxclick"));J.actionHandler.disposables.add(f.Event.any(_.event,K.event)(te=>{const se=new v.$0N(te);!se.leftButton&&!se.middleButton||A(se)})),J.actionHandler.disposables.add(y.$fO(d,"keydown",te=>{const se=new D.$cO(te);!se.equals(10)&&!se.equals(3)||A(se)}))}x.supportHtml||(X.sanitizer=A=>(x.isTrusted?A.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?A:"",X.sanitize=!0,X.silent=!0),X.renderer=I;let q=x.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`),x.supportThemeIcons&&(q=(0,r.$Qj)(q));let T;if(J.fillInIncompleteTokens){const A={...o.marked.defaults,...X},_=o.marked.lexer(q,A),K=re(_);T=o.marked.parser(K,A)}else T=o.marked.parse(q,X);x.supportThemeIcons&&(T=(0,l.$oQ)(T).map(_=>typeof _=="string"?_:_.outerHTML).join(""));const C=new DOMParser().parseFromString(p(x,T),"text/html");if(C.body.querySelectorAll("img").forEach(A=>{const _=A.getAttribute("src");if(_){let K=_;try{x.baseUri&&(K=m(c.URI.from(x.baseUri),K))}catch{}A.src=E(K,!0)}}),C.body.querySelectorAll("a").forEach(A=>{const _=A.getAttribute("href");if(A.setAttribute("href",""),!_||/^data:|javascript:/i.test(_)||/^command:/i.test(_)&&!x.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(_))A.replaceWith(...A.childNodes);else{let K=E(_,!1);x.baseUri&&(K=m(c.URI.from(x.baseUri),_)),A.dataset.href=K}}),d.innerHTML=p(x,C.body.innerHTML),F.length>0)Promise.all(F).then(A=>{if(V)return;const _=new Map(A),K=d.querySelectorAll("div[data-code]");for(const te of K){const se=_.get(te.dataset.code??"");se&&y.$3O(te,se)}J.asyncRenderCallback?.()});else if(B.length>0){const A=new Map(B),_=d.querySelectorAll("div[data-code]");for(const K of _){const te=A.get(K.dataset.code??"");te&&y.$3O(K,te)}}if(J.asyncRenderCallback)for(const A of d.getElementsByTagName("img")){const _=k.add(y.$fO(A,"load",()=>{_.dispose(),J.asyncRenderCallback()}))}return{element:d,dispose:()=>{V=!0,k.dispose()}}}t.$qQ=R;function L(x){if(!x)return"";const J=x.split(/[\s+|:|,|\{|\?]/,1);return J.length?J[0]:x}function m(x,J){return/^\w[\w\d+.-]*:/.test(J)?J:x.path.endsWith("/")?(0,b.$jg)(x,J).toString():(0,b.$jg)((0,b.$fg)(x),J).toString()}function p(x,J){const{config:X,allowedSchemes:k}=N(x);S.addHook("uponSanitizeAttribute",(d,w)=>{if(w.attrName==="style"||w.attrName==="class"){if(d.tagName==="SPAN"){if(w.attrName==="style"){w.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(w.attrValue);return}else if(w.attrName==="class"){w.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(w.attrValue);return}}w.keepAttr=!1;return}});const V=y.$kP(k);try{return S.sanitize(J,{...X,RETURN_TRUSTED_TYPE:!0})}finally{S.removeHook("uponSanitizeAttribute"),V.dispose()}}t.$rQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function N(x){const J=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return x.isTrusted&&J.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$lP],ALLOWED_ATTR:t.$rQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:J}}function M(x){return typeof x=="string"?x:H(x)}t.$sQ=M;function H(x){let J=x.value??"";J.length>1e5&&(J=`${J.substr(0,1e5)}\u2026`);const X=o.marked.parse(J,{renderer:W.value}).replace(/&(#\d+|[a-zA-Z]+);/g,k=>j.get(k)??k);return p({isTrusted:!1},X).toString()}t.$tQ=H;const j=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),W=new e.$T(()=>{const x=new o.marked.Renderer;return x.code=J=>J,x.blockquote=J=>J,x.html=J=>"",x.heading=(J,X,k)=>J+`
`,x.hr=()=>"",x.list=(J,X)=>J,x.listitem=J=>J+`
`,x.paragraph=J=>J+`
`,x.table=(J,X)=>J+X+`
`,x.tablerow=J=>J,x.tablecell=(J,X)=>J+" ",x.strong=J=>J,x.em=J=>J,x.codespan=J=>J,x.br=()=>`
`,x.del=J=>J,x.image=(J,X,k)=>"",x.text=J=>J,x.link=(J,X,k)=>k,x});function ee(x){let J="";return x.forEach(X=>{J+=X.raw}),J}function ne(x){for(const J of x.tokens)if(J.type==="text"){const X=J.raw.split(`
`),k=X[X.length-1];if(k.includes("`"))return he(x);if(k.includes("**"))return Me(x);if(k.match(/\*\w/))return ae(x);if(k.match(/(^|\s)__\w/))return fe(x);if(k.match(/(^|\s)_\w/))return we(x);if(k.match(/(^|\s)\[.*\]\(\w*/))return Oe(x);if(k.match(/(^|\s)\[\w/))return Ie(x)}}function re(x){let J,X;for(J=0;J<x.length;J++){const k=x[J];if(k.type==="paragraph"&&k.raw.match(/(\n|^)```/)){X=ce(x.slice(J));break}if(k.type==="paragraph"&&k.raw.match(/(\n|^)\|/)){X=G(x.slice(J));break}if(J===x.length-1&&k.type==="paragraph"){const V=ne(k);if(V){X=[V];break}}}if(X){const k=[...x.slice(0,J),...X];return k.links=x.links,k}return x}t.$uQ=re;function ce(x){const J=ee(x);return o.marked.lexer(J+"\n```")}function he(x){return ie(x,"`")}function ae(x){return ie(x,"*")}function we(x){return ie(x,"_")}function Oe(x){return ie(x,")")}function Ie(x){return ie(x,"](about:blank)")}function Me(x){return ie(x,"**")}function fe(x){return ie(x,"__")}function ie(x,J){const X=ee(Array.isArray(x)?x:[x]);return o.marked.lexer(X+J)[0]}function G(x){const J=ee(x),X=J.split(`
`);let k,V=!1;for(let d=0;d<X.length;d++){const w=X[d].trim();if(typeof k>"u"&&w.match(/^\s*\|/)){const E=w.match(/(\|[^\|]+)(?=\||$)/g);E&&(k=E.length)}else if(typeof k=="number")if(w.match(/^\s*\|/)){if(d!==X.length-1)return;V=!0}else return}if(typeof k=="number"&&k>0){const d=V?X.slice(0,-1).join(`
`):J,w=!!d.match(/\|\s*$/),E=d+(w?"":"|")+`
|${" --- |".repeat(k)}`;return o.marked.lexer(E)}}}),define(me[124],$e([1,0,4,9,27,59,33,2,7,105]),function(oe,t,y,S,i,U,D,v,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QP=t.$PP=void 0;function f(h,e){(0,l.$le)(e)?h.title=(0,D.$Rj)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$PP=f;class P{constructor(e,a,o){this.c=e,this.d=a,this.f=o}async update(e,a,o){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let s;if(e===void 0||(0,l.$le)(e)||e instanceof HTMLElement)s=e;else if(!(0,l.$ze)(e.markdown))s=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,u.localize)(0,null),a),this.b=new i.$rc;const n=this.b.token;if(s=await e.markdown(n),s===void 0&&(s=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(s,a,o)}g(e,a,o){const s=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!s,...o};this.a=this.c.showHover(n,a)}s?.dispose()}h(e){return e?(0,U.$Xj)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(h,e,a,o){let s,n;const g=(R,L)=>{const m=n!==void 0;R&&(n?.dispose(),n=void 0),L&&(s?.dispose(),s=void 0),m&&h.onDidHideHover?.()},b=(R,L,m)=>new S.$Og(async()=>{(!n||n.isDisposed)&&(n=new P(h,m||e,R>0),await n.update(a,L,o))},R),$=()=>{if(s)return;const R=new v.$lb,L=N=>g(!1,N.fromElement===e);R.add(y.$fO(e,y.$TO.MOUSE_LEAVE,L,!0));const m=()=>g(!0,!0);R.add(y.$fO(e,y.$TO.MOUSE_DOWN,m,!0));const p={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const N=M=>{p.x=M.x+10,M.target instanceof HTMLElement&&M.target.classList.contains("action-label")&&g(!0,!0)};R.add(y.$fO(e,y.$TO.MOUSE_MOVE,N,!0))}R.add(b(h.delay,!1,p)),s=R},c=y.$fO(e,y.$TO.MOUSE_OVER,$,!0);return{show:R=>{g(!1,!0),b(0,R)},hide:()=>{g(!0,!0)},update:async(R,L)=>{a=R,await n?.update(a,void 0,L)},dispose:()=>{c.dispose(),g(!0,!0)}}}t.$QP=r}),define(me[125],$e([1,0,4,21,14,123,37,13,3,42,2,5,107,98]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=void 0;const h=y.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(n){const g=Object.create(null);return g.root=n,g.text=y.$1O(n,h(".option-text")),g.detail=y.$1O(n,h(".option-detail")),g.decoratorRight=y.$1O(n,h(".option-decorator-right")),g}renderElement(n,g,b){const $=b,c=n.text,O=n.detail,R=n.decoratorRight,L=n.isDisabled;$.text.textContent=c,$.detail.textContent=O||"",$.decoratorRight.innerText=R||"",L?$.root.classList.add("option-disabled"):$.root.classList.remove("option-disabled")}disposeTemplate(n){}}class o extends f.$mb{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,g,b,$,c){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.H=!1,this.f=!1,this.n=$,this.g=c||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=o.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new l.$hc,this.B(this.m),this.J(),this.I(b),this.l=g||0,n&&this.setOptions(n,g),this.M()}getHeight(){return 22}getTemplateId(){return e}I(n){this.r=n,this.s=y.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=y.$1O(this.s,h(".select-box-details-pane"));const g=y.$1O(this.s,h(".select-box-dropdown-container-width-control")),b=y.$1O(g,h(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",y.$1O(b,this.w),this.z=0,this.t=y.$OO(this.s),this.s.setAttribute("draggable","true"),this.B(y.$fO(this.s,y.$TO.DRAG_START,$=>{y.$VO.stop($,!0)}))}J(){this.B(y.$gO(this.h,"change",g=>{this.l=g.target.selectedIndex,this.m.fire({index:g.target.selectedIndex,selected:g.target.value}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(y.$fO(this.h,y.$TO.CLICK,g=>{y.$VO.stop(g),this.f?this.R(!0):this.Q()})),this.B(y.$fO(this.h,y.$TO.MOUSE_DOWN,g=>{y.$VO.stop(g)}));let n;this.B(y.$fO(this.h,"touchstart",g=>{n=this.f})),this.B(y.$fO(this.h,"touchend",g=>{y.$VO.stop(g),n?this.R(!0):this.Q()})),this.B(y.$fO(this.h,y.$TO.KEY_DOWN,g=>{const b=new i.$cO(g);let $=!1;P.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&($=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&($=!0),$&&(this.Q(),y.$VO.stop(g,!0))}))}get onDidSelect(){return this.m.event}setOptions(n,g){v.$of(this.k,n)||(this.k=n,this.h.options.length=0,this.C=!1,this.G=void 0,this.k.forEach((b,$)=>{this.h.add(this.P(b.text,$,b.isDisabled)),typeof b.description=="string"&&(this.C=!0)})),g!==void 0&&(this.select(g),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(n){n>=0&&n<this.k.length?this.l=n:n>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.N()}M(){const n=[];this.n.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=n.join(`
`)}N(){const n=this.n.selectBackground??"",g=this.n.selectForeground??"",b=this.n.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=g,this.h.style.borderColor=b}O(){const n=this.n.selectBackground??"",g=y.$gP(this.n.selectListBackground,n);this.v.style.backgroundColor=g,this.D.style.backgroundColor=g;const b=this.n.focusBorder??"";this.s.style.outlineColor=b,this.s.style.outlineOffset="-1px",this.u.style(this.n)}P(n,g,b){const $=document.createElement("option");return $.value=n,$.text=n,$.disabled=!!b,$}Q(){this.D.innerText="",!(!this.r||this.f)&&(this.Y(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:n=>this.S(n,!0),layout:()=>{this.W()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.r.showContextView({getAnchor:()=>this.h,render:n=>this.S(n),layout:()=>this.W(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(n){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.r.hideContextView())}S(n,g){return n.appendChild(this.s),this.W(g),{dispose:()=>{try{n.removeChild(this.s)}catch{}}}}U(){let n=0;return this.k.forEach((g,b)=>{this.db(b),this.D.offsetHeight>n&&(n=this.D.offsetHeight)}),n}W(n){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const g=y.$xO(this.h),b=getComputedStyle(this.h),$=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),c=window.innerHeight-g.top-g.height-(this.g.minBottomMargin||0),O=g.top-o.b,R=this.h.offsetWidth,L=this.X(this.w),m=Math.max(L,Math.round(R)).toString()+"px";this.s.style.width=m,this.u.getHTMLElement().style.height="",this.u.layout();let p=this.u.contentHeight;this.C&&this.G===void 0&&(this.G=this.U());const N=this.C?this.G:0,M=p+$+N,H=Math.floor((c-$-N)/this.getHeight()),j=Math.floor((O-$-N)/this.getHeight());if(n)return g.top+g.height>window.innerHeight-22||g.top<o.b||H<1&&j<1?!1:(H<o.c&&j>H&&this.k.length>H?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(g.top+g.height>window.innerHeight-22||g.top<o.b||this.z===0&&H<1||this.z===1&&j<1)return this.R(!0),!1;if(this.z===0){if(this.f&&H+j<1)return this.R(!0),!1;M>c&&(p=H*this.getHeight())}else M>O&&(p=j*this.getHeight());return this.u.layout(p),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=p+$+"px",this.s.style.height=""):this.s.style.height=p+$+"px",this.db(this.l),this.s.style.width=m,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}X(n){let g=0;if(n){let b=0,$=0;this.k.forEach((c,O)=>{const R=c.detail?c.detail.length:0,L=c.decoratorRight?c.decoratorRight.length:0,m=c.text.length+R+L;m>$&&(b=O,$=m)}),n.textContent=this.k[b].text+(this.k[b].decoratorRight?this.k[b].decoratorRight+" ":""),g=y.$zO(n)}return g}Y(n){if(this.u)return;this.v=y.$1O(n,h(".select-box-dropdown-list-container")),this.p=new a,this.u=new D.$nQ("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:$=>{let c=$.text;return $.detail&&(c+=`. ${$.detail}`),$.decoratorRight&&(c+=`. ${$.decoratorRight}`),$.description&&(c+=`. ${$.description}`),c},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>P.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const g=this.B(new S.$ZP(this.v,"keydown")),b=l.Event.chain(g.event,$=>$.filter(()=>this.u.length>0).map(c=>new i.$cO(c)));this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===3))(this.fb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===2))(this.fb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===9))(this.eb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===16))(this.hb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===18))(this.gb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===12))(this.jb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===11))(this.ib,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===14))(this.kb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode===13))(this.lb,this)),this.B(l.Event.chain(b,$=>$.filter(c=>c.keyCode>=21&&c.keyCode<=56||c.keyCode>=85&&c.keyCode<=113))(this.mb,this)),this.B(y.$fO(this.u.getHTMLElement(),y.$TO.POINTER_UP,$=>this.Z($))),this.B(this.u.onMouseOver($=>typeof $.index<"u"&&this.u.setFocus([$.index]))),this.B(this.u.onDidChangeFocus($=>this.cb($))),this.B(y.$fO(this.s,y.$TO.FOCUS_OUT,$=>{!this.f||y.$FO($.relatedTarget,this.s)||this.ab()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(n){if(!this.u.length)return;y.$VO.stop(n);const g=n.target;if(!g||g.classList.contains("slider"))return;const b=g.closest(".monaco-list-row");if(!b)return;const $=Number(b.getAttribute("data-index")),c=b.classList.contains("option-disabled");$>=0&&$<this.k.length&&!c&&(this.l=$,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.y&&this.select(this.y),this.R(!1))}bb(n,g){const b=c=>{for(let O=0;O<c.childNodes.length;O++){const R=c.childNodes.item(O);(R.tagName&&R.tagName.toLowerCase())==="img"?c.removeChild(R):b(R)}},$=(0,U.$qQ)({value:n,supportThemeIcons:!0},{actionHandler:g});return $.element.classList.add("select-box-description-markdown"),b($.element),$.element}cb(n){!this.f||!this.C||this.db(n.indexes[0])}db(n){this.D.innerText="";const g=this.k[n],b=g?.description??"",$=g?.descriptionIsMarkdown??!1;if(b){if($){const c=g.descriptionMarkdownActionHandler;this.D.appendChild(this.bb(b,c))}else this.D.innerText=b;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}eb(n){y.$VO.stop(n),this.select(this.y),this.R(!0)}fb(n){y.$VO.stop(n),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(n){if(this.l<this.k.length-1){y.$VO.stop(n,!0);const g=this.k[this.l+1].isDisabled;if(g&&this.k.length>this.l+2)this.l+=2;else{if(g)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}hb(n){this.l>0&&(y.$VO.stop(n,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}ib(n){y.$VO.stop(n),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(n){y.$VO.stop(n),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}kb(n){y.$VO.stop(n),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(n){y.$VO.stop(n),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}mb(n){const g=u.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let $=0;$<this.k.length-1;$++)if(b=($+this.l+1)%this.k.length,this.k[b].text.charAt(0).toUpperCase()===g&&!this.k[b].isDisabled){this.select(b),this.u.setFocus([b]),this.u.reveal(this.u.getFocus()[0]),y.$VO.stop(n);break}}dispose(){this.R(!1),super.dispose()}}t.$vQ=o}),define(me[126],$e([1,0,37,125,119,20,5,97]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=void 0,t.$xQ={...y.$mQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class v extends U.$zP{constructor(u,f,P,r,h){super(),D.$j&&!h?.useCustomDrawn?this.a=new i.$wQ(u,f,r,h):this.a=new S.$vQ(u,f,P,r,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(u,f){this.a.setOptions(u,f)}select(u){this.a.select(u)}setAriaLabel(u){this.a.setAriaLabel(u)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(u){this.a.setFocusable(u)}render(u){this.a.render(u)}}t.$yQ=v}),define(me[60],$e([1,0,16,51,4,23,124,126,34,2,5,7,102,49]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=t.$EQ=t.$DQ=void 0;class h extends u.$mb{get action(){return this._action}constructor(s,n,g={}){super(),this.m=g,this._context=s||this,this._action=n,n instanceof l.$ei&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(s){s.enabled!==void 0&&this.u(),s.checked!==void 0&&this.G(),s.class!==void 0&&this.F(),s.label!==void 0&&(this.w(),this.C()),s.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new l.$fi)),this.j}set actionRunner(s){this.j=s}isEnabled(){return this._action.enabled}setActionContext(s){this._context=s}render(s){const n=this.element=s;this.B(U.$vP.addTarget(s));const g=this.m&&this.m.draggable;g&&(s.draggable=!0,y.$XN&&this.B((0,i.$fO)(s,i.$TO.DRAG_START,b=>b.dataTransfer?.setData(S.$tP.TEXT,this._action.label)))),this.B((0,i.$fO)(n,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$fO)(n,i.$TO.MOUSE_DOWN,b=>{g||i.$VO.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),f.$j&&this.B((0,i.$fO)(n,i.$TO.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$fO)(n,i.$TO.CLICK,b=>{i.$VO.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$fO)(n,i.$TO.DBLCLICK,b=>{i.$VO.stop(b,!0)})),[i.$TO.MOUSE_UP,i.$TO.MOUSE_OUT].forEach(b=>{this.B((0,i.$fO)(n,b,$=>{i.$VO.stop($),n.classList.remove("active")}))})}onClick(s,n=!1){i.$VO.stop(s,!0);const g=P.$ue(this._context)?this.m?.useEventAsContext?s:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,g)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(s){this.element&&(this.element.tabIndex=s?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const s=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(s):(this.f=(0,D.$QP)(this.m.hoverDelegate,this.element,s),this.q.add(this.f))):this.element.title=s}D(){if(this.element){const s=this.z()??"";this.element.setAttribute("aria-label",s)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$DQ=h;class e extends h{constructor(s,n,g){super(s,n,g),this.m=g,this.m.icon=g.icon!==void 0?g.icon:!1,this.m.label=g.label!==void 0?g.label:!0,this.I=""}render(s){super.render(s),this.element&&(this.p=(0,i.$1O)(this.element,(0,i.$)("a.action-label"))),this.p&&this.p.setAttribute("role",this.J()),this.m.label&&this.m.keybinding&&this.element&&((0,i.$1O)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}J(){return this._action.id===l.$gi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(s){this.p&&(this.p.tabIndex=s?0:-1)}w(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}z(){let s=null;return this.action.tooltip?s=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(s=this.action.label,this.m.keybinding&&(s=r.localize(0,null,s,this.m.keybinding))),s??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.u()):this.p?.classList.remove("codicon")}u(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.p){const s=this.z()??"";this.p.setAttribute("aria-label",s)}}G(){this.p&&(this.action.checked!==void 0?(this.p.classList.toggle("checked",this.action.checked),this.p.setAttribute("aria-checked",this.action.checked?"true":"false"),this.p.setAttribute("role","checkbox")):(this.p.classList.remove("checked"),this.p.setAttribute("aria-checked",""),this.p.setAttribute("role",this.J())))}}t.$EQ=e;class a extends h{constructor(s,n,g,b,$,c,O){super(s,n),this.b=new v.$yQ(g,b,$,c,O),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(s,n){this.b.setOptions(s,n)}select(s){this.b.select(s)}g(){this.B(this.b.onDidSelect(s=>this.k(s.selected,s.index)))}k(s,n){this.actionRunner.run(this._action,this.n(s,n))}n(s,n){return s}setFocusable(s){this.b.setFocusable(s)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(s){this.b.render(s)}}t.$FQ=a}),define(me[61],$e([1,0,4,14,60,34,3,2,7,49]),function(oe,t,y,S,i,U,D,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SP=t.$RP=t.ActionsOrientation=void 0;var u;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(u||(t.ActionsOrientation=u={}));class f extends v.$mb{constructor(h,e={}){super(),this.g=this.B(new v.$lb),this.n=this.B(new v.$ub),this.t=!1,this.u=!0,this.w=this.B(new D.$hc),this.onDidBlur=this.w.event,this.y=this.B(new D.$hc({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new D.$hc),this.onDidRun=this.C.event,this.D=this.B(new D.$hc),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$fi,this.g.add(this.f)),this.g.add(this.f.onDidRun(s=>this.C.fire(s))),this.g.add(this.f.onWillRun(s=>this.D.fire(s))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,o;switch(this.l){case 0:a=[15],o=[17];break;case 1:a=[16],o=[18],this.domNode.className+=" vertical";break}this.B(y.$fO(this.domNode,y.$TO.KEY_DOWN,s=>{const n=new S.$cO(s);let g=!0;const b=typeof this.r=="number"?this.viewItems[this.r]:void 0;a&&(n.equals(a[0])||n.equals(a[1]))?g=this.M():o&&(n.equals(o[0])||n.equals(o[1]))?g=this.L():n.equals(9)&&this.z?this.y.fire():n.equals(14)?g=this.I():n.equals(13)?g=this.J():n.equals(2)&&b instanceof i.$DQ&&b.trapsArrowNavigation?g=this.L():this.G(n)?this.m.keyDown?this.O(n):this.t=!0:g=!1,g&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$fO(this.domNode,y.$TO.KEY_UP,s=>{const n=new S.$cO(s);this.G(n)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.H()})),this.s=this.B(y.$YO(this.domNode)),this.B(this.s.onDidBlur(()=>{(y.$NO()===this.domNode||!y.$FO(y.$NO(),this.domNode))&&(this.w.fire(),this.p=this.r,this.r=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.b.highlightToggledItems&&this.v.classList.add("highlight-toggled"),this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),h.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(h){h?this.v.setAttribute("aria-label",h):this.v.removeAttribute("aria-label")}setFocusable(h){if(this.u=h,this.u){const e=this.viewItems.find(a=>a instanceof i.$DQ&&a.isEnabled());e instanceof i.$DQ&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$DQ&&e.setFocusable(!1)})}G(h){let e=!1;return this.m.keys.forEach(a=>{e=e||h.equals(a)}),e}H(){for(let h=0;h<this.v.children.length;h++){const e=this.v.children[h];if(y.$FO(y.$NO(),e)){this.r=h;break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.v;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const a=Array.isArray(h)?h:[h];let o=l.$pe(e.index)?e.index:null;a.forEach(s=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let g;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(g=this.b.actionViewItemProvider(s,b)),g||(g=new i.$EQ(this.context,s,b)),this.b.allowContextMenu||this.n.set(g,y.$fO(n,y.$TO.CONTEXT_MENU,$=>{y.$VO.stop($,!0)})),g.actionRunner=this.f,g.setActionContext(this.context),g.render(n),this.u&&g instanceof i.$DQ&&this.viewItems.length===0&&g.setFocusable(!0),o===null||o<0||o>=this.v.children.length?(this.v.appendChild(n),this.viewItems.push(g)):(this.v.insertBefore(n,this.v.children[o]),this.viewItems.splice(o,0,g),o++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(h){if(h>=0&&h<this.v.children.length){const e=this.v.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.v.children.length){const e=this.v.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[h]),this.n.deleteAndDispose(this.viewItems[h]),(0,v.$hb)(this.viewItems.splice(h,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,v.$hb)(this.viewItems),this.n.clearAndDisposeAll(),y.$dO(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,a;if(h===void 0?e=!0:typeof h=="number"?a=h:typeof h=="boolean"&&(e=h),e&&typeof this.r>"u"){const o=this.viewItems.findIndex(s=>s.isEnabled());this.r=o===-1?void 0:o,this.N(void 0,void 0,!0)}else a!==void 0&&(this.r=a),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(h){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(!h&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===U.$gi.ID));return this.N(),!0}M(h){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(this.r=this.r-1,this.r<0){if(!h&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===U.$gi.ID));return this.N(!0),!0}N(h,e,a=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const o=this.r!==void 0&&this.viewItems[this.r];if(o){let s=!0;l.$ze(o.focus)||(s=!1),this.b.focusOnlyEnabledItems&&l.$ze(o.isEnabled)&&!o.isEnabled()&&(s=!1),o.action.id===U.$gi.ID&&(s=!1),s?(a||this.p!==this.r)&&(o.focus(h),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(h){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof i.$DQ){const a=e._context===null||e._context===void 0?h:e._context;this.run(e._action,a)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,v.$hb)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$RP=f;function P(r){if(!r.length)return r;let h=-1;for(let a=0;a<r.length;a++)if(r[a].id!==U.$gi.ID){h=a;break}if(h===-1)return[];r=r.slice(h);for(let a=r.length-1;a>=0&&r[a].id===U.$gi.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const o=r[a].id===U.$gi.ID;o&&!e?r.splice(a,1):o?o&&(e=!1):e=!0}return r}t.$SP=P}),define(me[62],$e([1,0,4,21,52,61,54,57,20,3,79,48,106,94]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kR=t.$jR=t.$iR=t.MessageType=void 0;const h=y.$;var e;(function(s){s[s.INFO=1]="INFO",s[s.WARNING=2]="WARNING",s[s.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$iR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends l.$zP{constructor(n,g,b){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new u.$hc),this.onDidChange=this.I.event,this.J=this.B(new u.$hc),this.onDidHeightChange=this.J.event,this.a=g,this.g=b,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=y.$1O(n,h(".monaco-inputbox.idle"));const $=this.g.flexibleHeight?"textarea":"input",c=y.$1O(this.element,h(".ibwrapper"));if(this.b=y.$1O(c,h($+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=y.$1O(c,h("div.mirror")),this.t.innerText="\xA0",this.H=new v.$JP(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),y.$1O(n,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(L=>this.b.scrollTop=L.scrollTop));const O=this.B(new S.$ZP(document,"selectionchange")),R=u.Event.filter(O.event,()=>document.getSelection()?.anchorNode===c);this.B(R(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new U.$RP(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(n){this.i=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.l=n,this.b.title=n}setAriaLabel(n){this.n=n,n?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.R())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.v=="number"?this.v:y.$DO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$zO(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let g=0;if(this.t){const b=parseFloat(this.t.style.paddingLeft||"")||0,$=parseFloat(this.t.style.paddingRight||"")||0;g=b+$}this.b.style.width=n-g+"px"}else this.b.style.width=n+"px";this.t&&(this.t.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.t&&(this.t.style.paddingRight=n+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const n=this.w,g=this.v,b=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:n,height:g}),this.H.setScrollPosition({scrollTop:b})}showMessage(n,g){if(this.s==="open"&&(0,P.$Xm)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$gP(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||g)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let n=null;return this.r&&(n=this.r(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const g=this.g.inputBoxStyles;switch(n){case 1:return{border:g.inputValidationInfoBorder,background:g.inputValidationInfoBackground,foreground:g.inputValidationInfoForeground};case 2:return{border:g.inputValidationWarningBorder,background:g.inputValidationWarningBackground,foreground:g.inputValidationWarningForeground};default:return{border:g.inputValidationErrorBorder,background:g.inputValidationErrorBackground,foreground:g.inputValidationErrorForeground}}}O(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let n;const g=()=>n.style.width=y.$zO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:$=>{if(!this.h)return null;n=y.$1O($,h(".monaco-inputbox-container")),g();const c={inline:!0,className:"monaco-inputbox-message"},O=this.h.formatContent?(0,i.$XP)(this.h.content,c):(0,i.$WP)(this.h.content,c);O.classList.add(this.O(this.h.type));const R=this.stylesForType(this.h.type);return O.style.backgroundColor=R.background??"",O.style.color=R.foreground??"",O.style.border=R.border?`1px solid ${R.border}`:"",y.$1O(n,O),null},onHide:()=>{this.s="closed"},layout:g});let b;this.h.type===3?b=r.localize(0,null,this.h.content):this.h.type===2?b=r.localize(1,null,this.h.content):b=r.localize(2,null,this.h.content),D.$2P(b),this.s="open"}Q(){this.a&&(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.t.textContent=n+b:this.t.innerText="\xA0",this.layout()}U(){const n=this.g.inputBoxStyles,g=n.inputBackground??"",b=n.inputForeground??"",$=n.inputBorder??"";this.element.style.backgroundColor=g,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${y.$gP($,"transparent")}`}layout(){if(!this.t)return;const n=this.w;this.w=y.$DO(this.t),n!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(n){const g=this.inputElement,b=g.selectionStart,$=g.selectionEnd,c=g.value;b!==null&&$!==null&&(this.value=c.substr(0,b)+n+c.substr($),g.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.$jR=a;class o extends a{constructor(n,g,b){const $=r.localize(3,null),c=` or \u21C5 ${$}`,O=` (\u21C5 ${$})`;super(n,g,b),this.Y=this.B(new u.$hc),this.onDidFocus=this.Y.event,this.Z=this.B(new u.$hc),this.onDidBlur=this.Z.event,this.W=new f.$gR(b.history,100);const R=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.i.endsWith(c)&&!this.i.endsWith(O)&&this.W.getHistory().length){const L=this.i.endsWith(")")?c:O,m=this.i+L;b.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=m:this.setPlaceHolder(m)}};this.X=new MutationObserver((L,m)=>{L.forEach(p=>{p.target.textContent||R()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>R()),this.C(this.b,()=>{const L=m=>{if(this.i.endsWith(m)){const p=this.i.slice(0,this.i.length-m.length);return b.showPlaceholderOnFocus?this.i=p:this.setPlaceHolder(p),!0}else return!1};L(O)||L(c)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(n){this.value&&(n||this.value!==this.cb())&&this.W.add(this.value)}prependHistory(n){const g=this.getHistory();this.clearHistory(),n.forEach(b=>{this.W.add(b)}),g.forEach(b=>{this.W.add(b)})}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let n=this.eb();n&&(n=n===this.value?this.eb():n),this.value=n??"",D.$3P(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let n=this.db();n&&(n=n===this.value?this.db():n),n&&(this.value=n,D.$3P(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let n=this.W.current();return n||(n=this.W.last(),this.W.next()),n}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()}}t.$kR=o}),define(me[63],$e([1,0,60,20,17,18,3,99]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=t.$BQ=t.$AQ=t.$zQ=void 0,t.$zQ={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class v extends y.$DQ{constructor(P,r,h){super(P,r,h),this.a=this.B(new l({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:h.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:h.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:h.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(P){this.element=P,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(P){this.a.domNode.tabIndex=P?0:-1}}t.$AQ=v;class l extends S.$zP{constructor(P){super(),this.a=this.B(new D.$hc),this.onChange=this.a.event,this.b=this.B(new D.$hc),this.onKeyDown=this.b.event,this.c=P,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,h=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),h.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,h=>{if(h.keyCode===10||h.keyCode===3){this.checked=!this.s,this.a.fire(!0),h.preventDefault(),h.stopPropagation();return}this.b.fire(h)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(P){this.s=P,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(P){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=P,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.$BQ=l;class u extends S.$zP{constructor(P,r,h){super(),this.c=P,this.g=r,this.a=new l({title:this.c,isChecked:this.g,icon:i.$Nj.check,actionClassName:"monaco-checkbox",...t.$zQ}),this.domNode=this.a.domNode,this.b=h,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(P){this.a.checked=P,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$CQ=u}),define(me[127],$e([1,0,63,17,104]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.$wR=t.$vR=void 0;const U=i.localize(0,null),D=i.localize(1,null),v=i.localize(2,null);class l extends y.$BQ{constructor(r){super({icon:S.$Nj.caseSensitive,title:U+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$vR=l;class u extends y.$BQ{constructor(r){super({icon:S.$Nj.wholeWord,title:D+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$wR=u;class f extends y.$BQ{constructor(r){super({icon:S.$Nj.regex,title:v+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$xR=f}),define(me[128],$e([1,0,4,127,62,20,3,103,2,93]),function(oe,t,y,S,i,U,D,v,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=void 0;const u=v.localize(0,null);class f extends U.$zP{static{this.OPTION_CHANGE="optionChange"}constructor(r,h,e){super(),this.i=!0,this.l=!1,this.n=this.B(new l.$nb),this.H=[],this.I=this.B(new D.$hc),this.onDidOptionChange=this.I.event,this.J=this.B(new D.$hc),this.onKeyDown=this.J.event,this.L=this.B(new D.$hc),this.onMouseDown=this.L.event,this.M=this.B(new D.$hc),this.onInput=this.M.event,this.N=this.B(new D.$hc),this.onKeyUp=this.N.event,this.O=this.B(new D.$hc),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new D.$hc),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||u,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",o=e.appendWholeWordsLabel||"",s=e.appendRegexLabel||"",n=e.history||[],g=!!e.flexibleHeight,b=!!e.flexibleWidth,$=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$kR(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:g,flexibleWidth:b,flexibleMaxHeight:$,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new S.$xR({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(O=>{this.I.fire(O),!O&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(O=>{this.P.fire(O)})),this.w=this.B(new S.$wR({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(O=>{this.I.fire(O),!O&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new S.$vR({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(O=>{this.I.fire(O),!O&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(O=>{this.O.fire(O)}));const c=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,O=>{if(O.equals(15)||O.equals(17)||O.equals(9)){const R=c.indexOf(document.activeElement);if(R>=0){let L=-1;O.equals(17)?L=(R+1)%c.length:O.equals(15)&&(R===0?L=c.length-1:L=R-1),O.equals(9)?(c[R].blur(),this.inputBox.focus()):L>=0&&c[L].focus(),y.$VO.stop(O,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.B(y.$fO(this.inputBox.inputElement,"compositionstart",c=>{this.l=!0})),this.B(y.$fO(this.inputBox.inputElement,"compositionend",c=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,c=>this.J.fire(c)),this.u(this.inputBox.inputElement,c=>this.N.fire(c)),this.z(this.inputBox.inputElement,c=>this.M.fire()),this.j(this.inputBox.inputElement,c=>this.L.fire(c))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const h of this.H)h.domNode.remove();this.H=[],this.n.value=new l.$lb;for(const h of r??[])this.n.value.add(h),this.s.appendChild(h.domNode),this.n.value.add(h.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(h);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((h,e)=>h+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}t.$yR=f}),define(me[129],$e([1,0,4,21,14,61,128,62,58,37,63,55,24,34,13,9,17,18,70,3,32,2,44,7,108,100]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h,e,a,o,s,n,g,b,$,c,O,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8R=t.TreeFindMatchType=t.TreeFindMode=t.$7R=t.$6R=t.RenderIndentGuides=t.$5R=t.$4R=void 0;class L extends l.$aQ{set context(d){this.c.context=d}get context(){return this.c.context}constructor(d){super(d.elements.map(w=>w.element)),this.c=d}}function m(V){return V instanceof l.$aQ?new L(V):V}class p{constructor(d,w){this.c=d,this.d=w,this.b=$.$mb.None}getDragURI(d){return this.d.getDragURI(d.element)}getDragLabel(d,w){if(this.d.getDragLabel)return this.d.getDragLabel(d.map(E=>E.element),w)}onDragStart(d,w){this.d.onDragStart?.(m(d),w)}onDragOver(d,w,E,I,F=!0){const B=this.d.onDragOver(m(d),w&&w.element,E,I),q=this.a!==w;if(q&&(this.b.dispose(),this.a=w),typeof w>"u")return B;if(q&&typeof B!="boolean"&&B.autoExpand&&(this.b=(0,a.$Gg)(()=>{const _=this.c(),K=_.getNodeLocation(w);_.isCollapsed(K)&&_.setCollapsed(K,!1),this.a=void 0},500)),typeof B=="boolean"||!B.accept||typeof B.bubble>"u"||B.feedback){if(!F){const _=typeof B=="boolean"?B:B.accept,K=typeof B=="boolean"?void 0:B.effect;return{accept:_,effect:K,feedback:[E]}}return B}if(B.bubble===1){const _=this.c(),K=_.getNodeLocation(w),te=_.getParentNodeLocation(K),se=_.getNode(te),ge=te&&_.getListIndex(te);return this.onDragOver(d,se,ge,I,!1)}const T=this.c(),z=T.getNodeLocation(w),C=T.getListIndex(z),A=T.getListRenderCount(z);return{...B,feedback:(0,e.$Lf)(C,C+A)}}drop(d,w,E,I){this.b.dispose(),this.a=void 0,this.d.drop(m(d),w&&w.element,E,I)}onDragEnd(d){this.d.onDragEnd?.(d)}}function N(V,d){return d&&{...d,identityProvider:d.identityProvider&&{getId(w){return d.identityProvider.getId(w.element)}},dnd:d.dnd&&new p(V,d.dnd),multipleSelectionController:d.multipleSelectionController&&{isSelectionSingleChangeEvent(w){return d.multipleSelectionController.isSelectionSingleChangeEvent({...w,element:w.element})},isSelectionRangeChangeEvent(w){return d.multipleSelectionController.isSelectionRangeChangeEvent({...w,element:w.element})}},accessibilityProvider:d.accessibilityProvider&&{...d.accessibilityProvider,getSetSize(w){const E=V(),I=E.getNodeLocation(w),F=E.getParentNodeLocation(I);return E.getNode(F).visibleChildrenCount},getPosInSet(w){return w.visibleChildIndex+1},isChecked:d.accessibilityProvider&&d.accessibilityProvider.isChecked?w=>d.accessibilityProvider.isChecked(w.element):void 0,getRole:d.accessibilityProvider&&d.accessibilityProvider.getRole?w=>d.accessibilityProvider.getRole(w.element):()=>"treeitem",getAriaLabel(w){return d.accessibilityProvider.getAriaLabel(w.element)},getWidgetAriaLabel(){return d.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:d.accessibilityProvider&&d.accessibilityProvider.getWidgetRole?()=>d.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:d.accessibilityProvider&&d.accessibilityProvider.getAriaLevel?w=>d.accessibilityProvider.getAriaLevel(w.element):w=>w.depth,getActiveDescendantId:d.accessibilityProvider.getActiveDescendantId&&(w=>d.accessibilityProvider.getActiveDescendantId(w.element))},keyboardNavigationLabelProvider:d.keyboardNavigationLabelProvider&&{...d.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(w){return d.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(w.element)}}}}class M{constructor(d){this.a=d}getHeight(d){return this.a.getHeight(d.element)}getTemplateId(d){return this.a.getTemplateId(d.element)}hasDynamicHeight(d){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(d.element)}setDynamicHeight(d,w){this.a.setDynamicHeight?.(d.element,w)}}t.$4R=M;class H{static lift(d){return d instanceof H?d:new H(d)}static empty(d=0){return new H({focus:[],selection:[],expanded:Object.create(null),scrollTop:d})}constructor(d){if(this.focus=new Set(d.focus),this.selection=new Set(d.selection),d.expanded instanceof Array){this.expanded=Object.create(null);for(const w of d.expanded)this.expanded[w]=1}else this.expanded=d.expanded;this.expanded=d.expanded,this.scrollTop=d.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$5R=H;var j;(function(V){V.None="none",V.OnHover="onHover",V.Always="always"})(j||(t.RenderIndentGuides=j={}));class W{get elements(){return this.b}constructor(d,w=[]){this.b=w,this.a=new $.$lb,this.onDidChange=g.Event.forEach(d,E=>this.b=E,this.a)}dispose(){this.a.dispose()}}class ee{static{this.a=8}constructor(d,w,E,I,F,B={}){this.o=d,this.p=w,this.q=I,this.s=F,this.b=new Map,this.c=new Map,this.d=ee.a,this.f=!1,this.g=!1,this.j=new Set,this.k=$.$mb.None,this.m=new $.$lb,this.templateId=d.templateId,this.updateOptions(B),g.Event.map(E,q=>q.node)(this.u,this,this.m),d.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(d={}){if(typeof d.indent<"u"){const w=(0,c.$Fl)(d.indent,0,40);if(w!==this.d){this.d=w;for(const[E,I]of this.c)this.v(E,I)}}if(typeof d.renderIndentGuides<"u"){const w=d.renderIndentGuides!==j.None;if(w!==this.g){this.g=w;for(const[E,I]of this.c)this.w(E,I);if(this.k.dispose(),w){const E=new $.$lb;this.q.onDidChange(this.x,this,E),this.k=E,this.x(this.q.elements)}}}typeof d.hideTwistiesOfChildlessElements<"u"&&(this.f=d.hideTwistiesOfChildlessElements)}renderTemplate(d){const w=(0,y.$1O)(d,(0,y.$)(".monaco-tl-row")),E=(0,y.$1O)(w,(0,y.$)(".monaco-tl-indent")),I=(0,y.$1O)(w,(0,y.$)(".monaco-tl-twistie")),F=(0,y.$1O)(w,(0,y.$)(".monaco-tl-contents")),B=this.o.renderTemplate(F);return{container:d,indent:E,twistie:I,indentGuidesDisposable:$.$mb.None,templateData:B}}renderElement(d,w,E,I){this.c.set(d,E),this.b.set(d.element,d),this.v(d,E),this.o.renderElement(d,w,E.templateData,I)}disposeElement(d,w,E,I){E.indentGuidesDisposable.dispose(),this.o.disposeElement?.(d,w,E.templateData,I),typeof I=="number"&&(this.c.delete(d),this.b.delete(d.element))}disposeTemplate(d){this.o.disposeTemplate(d.templateData)}t(d){const w=this.b.get(d);w&&this.u(w)}u(d){const w=this.c.get(d);w&&(this.x(this.q.elements),this.v(d,w))}v(d,w){const E=ee.a+(d.depth-1)*this.d;w.twistie.style.paddingLeft=`${E}px`,w.indent.style.width=`${E+this.d-16}px`,d.collapsible?w.container.setAttribute("aria-expanded",String(!d.collapsed)):w.container.removeAttribute("aria-expanded"),w.twistie.classList.remove(...s.ThemeIcon.asClassNameArray(o.$Nj.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(d.element,w.twistie)),d.collapsible&&(!this.f||d.visibleChildrenCount>0)?(I||w.twistie.classList.add(...s.ThemeIcon.asClassNameArray(o.$Nj.treeItemExpanded)),w.twistie.classList.add("collapsible"),w.twistie.classList.toggle("collapsed",d.collapsed)):w.twistie.classList.remove("collapsible","collapsed"),this.w(d,w)}w(d,w){if((0,y.$dO)(w.indent),w.indentGuidesDisposable.dispose(),!this.g)return;const E=new $.$lb,I=this.p();for(;;){const F=I.getNodeLocation(d),B=I.getParentNodeLocation(F);if(!B)break;const q=I.getNode(B),T=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(q)&&T.classList.add("active"),w.indent.childElementCount===0?w.indent.appendChild(T):w.indent.insertBefore(T,w.indent.firstElementChild),this.s.add(q,T),E.add((0,$.$kb)(()=>this.s.delete(q,T))),d=q}w.indentGuidesDisposable=E}x(d){if(!this.g)return;const w=new Set,E=this.p();d.forEach(I=>{const F=E.getNodeLocation(I);try{const B=E.getParentNodeLocation(F);I.collapsible&&I.children.length>0&&!I.collapsed?w.add(I):B&&w.add(E.getNode(B))}catch{}}),this.j.forEach(I=>{w.has(I)||this.s.forEach(I,F=>F.classList.remove("active"))}),w.forEach(I=>{this.j.has(I)||this.s.forEach(I,F=>F.classList.add("active"))}),this.j=w}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,$.$hb)(this.m)}}class ne{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(d){this.c=d,this.d=d.toLowerCase()}constructor(d,w,E){this.g=d,this.j=w,this.k=E,this.a=0,this.b=0,this.c="",this.d="",this.f=new $.$lb,d.onWillRefilter(this.m,this,this.f)}filter(d,w){let E=1;if(this.k){const B=this.k.filter(d,w);if(typeof B=="boolean"?E=B?1:0:(0,P.$1R)(B)?E=(0,P.$2R)(B.visibility):E=B,E===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:E};const I=this.j.getKeyboardNavigationLabel(d),F=Array.isArray(I)?I:[I];for(const B of F){const q=B&&B.toString();if(typeof q>"u")return{data:b.FuzzyScore.Default,visibility:E};let T;if(this.g.findMatchType===we.Contiguous){const z=q.toLowerCase().indexOf(this.d);if(z>-1){T=[Number.MAX_SAFE_INTEGER,0];for(let C=this.d.length;C>0;C--)T.push(z+C-1)}}else T=(0,b.$Ij)(this.c,this.d,0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(T)return this.b++,F.length===1?{data:T,visibility:E}:{data:{label:q,score:T},visibility:E}}return this.g.findMode===ae.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(d):2:{data:b.FuzzyScore.Default,visibility:E}}m(){this.a=0,this.b=0}dispose(){(0,$.$hb)(this.f)}}class re extends f.$BQ{constructor(d){super({icon:o.$Nj.listFilter,title:(0,R.localize)(0,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$6R=re;class ce extends f.$BQ{constructor(d){super({icon:o.$Nj.searchFuzzy,title:(0,R.localize)(1,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$7R=ce;const he={inputBoxStyles:v.$iR,toggleStyles:f.$zQ,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ae;(function(V){V[V.Highlight=0]="Highlight",V[V.Filter=1]="Filter"})(ae||(t.TreeFindMode=ae={}));var we;(function(V){V[V.Fuzzy=0]="Fuzzy",V[V.Contiguous=1]="Contiguous"})(we||(t.TreeFindMatchType=we={}));class Oe extends $.$mb{set mode(d){this.b.checked=d===ae.Filter,this.f.inputBox.setPlaceHolder(d===ae.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(d){this.c.checked=d===we.Fuzzy}get value(){return this.f.inputBox.value}set value(d){this.f.inputBox.value=d}constructor(d,w,E,I,F,B){super(),this.p=w,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new g.$hc,this.onDidDisable=this._onDidDisable.event,d.appendChild(this.a.root),this.B((0,$.$kb)(()=>d.removeChild(this.a.root)));const q=B?.styles??he;q.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=q.listFilterWidgetBackground),q.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${q.listFilterWidgetShadow}`),this.b=this.B(new re({...q.toggleStyles,isChecked:I===ae.Filter})),this.c=this.B(new ce({...q.toggleStyles,isChecked:F===we.Fuzzy})),this.onDidChangeMode=g.Event.map(this.b.onChange,()=>this.b.checked?ae.Filter:ae.Highlight,this.q),this.onDidChangeMatchType=g.Event.map(this.c.onChange,()=>this.c.checked?we.Fuzzy:we.Contiguous,this.q),this.f=this.B(new D.$yR(this.a.findInput,E,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:q.inputBoxStyles,toggleStyles:q.toggleStyles,history:B?.history})),this.g=this.B(new U.$RP(this.a.actionbar)),this.mode=I;const T=this.B(new S.$ZP(this.f.inputBox.inputElement,"keydown")),z=g.Event.chain(T.event,K=>K.map(te=>new i.$cO(te)));this.B(z(K=>{if(K.equals(3)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(K.equals(18)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(K.equals(16)){K.preventDefault(),K.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const C=this.B(new h.$ei("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(C,{icon:!0,label:!1});const A=this.B(new S.$ZP(this.a.grab,"mousedown"));this.B(A.event(K=>{const te=new $.$lb,se=te.add(new S.$ZP(window,"mousemove")),ge=te.add(new S.$ZP(window,"mouseup")),pe=this.k,Ce=K.pageX,Ee=this.m,ve=K.pageY;this.a.grab.classList.add("grabbing");const Te=this.a.root.style.transition;this.a.root.style.transition="unset";const Fe=qe=>{const je=qe.pageX-Ce;this.k=pe-je;const Le=qe.pageY-ve;this.m=Ee+Le,this.layout()};te.add(se.event(Fe)),te.add(ge.event(qe=>{Fe(qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Te,te.dispose()}))}));const _=g.Event.chain(this.B(new S.$ZP(this.a.grab,"keydown")).event,K=>K.map(te=>new i.$cO(te)));this.B(_(K=>{let te,se;if(K.keyCode===15?te=Number.POSITIVE_INFINITY:K.keyCode===17?te=0:K.keyCode===10&&(te=this.k===0?Number.POSITIVE_INFINITY:0),K.keyCode===16?se=0:K.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(K.preventDefault(),K.stopPropagation(),this.k=te,this.layout()),se!==void 0){K.preventDefault(),K.stopPropagation(),this.m=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(d=this.j){this.j=d,this.k=(0,c.$Fl)(this.k,0,Math.max(0,d-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,c.$Fl)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(d){this.f.showMessage(d)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.$Fg)(300),super.dispose()}}class Ie{get pattern(){return this.b}get mode(){return this.d}set mode(d){d!==this.d&&(this.d=d,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(d))}get matchType(){return this.f}set matchType(d){d!==this.f&&(this.f=d,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(d))}constructor(d,w,E,I,F,B={}){this.t=d,this.u=E,this.v=I,this.w=F,this.x=B,this.b="",this.c="",this.j=0,this.k=new g.$hc,this.onDidChangeMode=this.k.event,this.m=new g.$hc,this.onDidChangeMatchType=this.m.event,this.o=new g.$hc,this.onDidChangePattern=this.o.event,this.p=new g.$hc,this.onDidChangeOpenState=this.p.event,this.q=new $.$lb,this.s=new $.$lb,this.d=d.options.defaultFindMode??ae.Highlight,this.f=d.options.defaultFindMatchType??we.Fuzzy,w.onDidSplice(this.z,this,this.s)}updateOptions(d={}){d.defaultFindMode!==void 0&&(this.mode=d.defaultFindMode),d.defaultFindMatchType!==void 0&&(this.matchType=d.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Oe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(d=>this.mode=d,void 0,this.q),this.g.onDidChangeMatchType(d=>this.matchType=d,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new $.$lb,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(d){this.b=d,this.o.fire(d),this.v.pattern=d,this.t.refilter(),d&&this.t.focusNext(0,!0,void 0,E=>!b.FuzzyScore.isDefault(E.filterData));const w=this.t.getFocus();if(w.length>0){const E=w[0];this.t.getRelativeTop(E)===null&&this.t.reveal(E,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const d=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&d?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(d){return!this.g||!this.pattern||this.d===ae.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault(d.filterData)}layout(d){this.j=d,this.g?.layout(d)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(V){let d=r.TreeMouseEventTarget.Unknown;return(0,y.$JO)(V.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?d=r.TreeMouseEventTarget.Twistie:(0,y.$JO)(V.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?d=r.TreeMouseEventTarget.Element:(0,y.$JO)(V.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(d=r.TreeMouseEventTarget.Filter),{browserEvent:V.browserEvent,element:V.element?V.element.element:null,target:d}}function fe(V){return{element:V.element?V.element.element:null,browserEvent:V.browserEvent,anchor:V.anchor}}function ie(V,d){d(V),V.children.forEach(w=>ie(w,d))}class G{get f(){return this.d||(this.d=this.m()),this.d}constructor(d,w){this.g=d,this.j=w,this.a=[],this.c=new g.$hc,this.onDidChange=this.c.event}set(d,w){!w?.__forceEvent&&(0,e.$of)(this.a,d)||this.k(d,!1,w)}k(d,w,E){if(this.a=[...d],this.b=void 0,this.d=void 0,!w){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:E})}}get(){return this.b||(this.b=this.a.map(d=>d.element)),[...this.b]}getNodes(){return this.a}has(d){return this.f.has(d)}onDidModelSplice({insertedNodes:d,deletedNodes:w}){if(!this.j){const T=this.m(),z=C=>T.delete(C);w.forEach(C=>ie(C,z)),this.set([...T.values()]);return}const E=new Set,I=T=>E.add(this.j.getId(T.element).toString());w.forEach(T=>ie(T,I));const F=new Map,B=T=>F.set(this.j.getId(T.element).toString(),T);d.forEach(T=>ie(T,B));const q=[];for(const T of this.a){const z=this.j.getId(T.element).toString();if(!E.has(z))q.push(T);else{const A=F.get(z);A&&A.visible&&q.push(A)}}if(this.a.length>0&&q.length===0){const T=this.g();T&&q.push(T)}this.k(q,!0)}m(){const d=new Set;for(const w of this.a)d.add(w);return d}}class x extends u.$kQ{constructor(d,w){super(d),this.x=w}u(d){if((0,u.$gQ)(d.browserEvent.target)||(0,u.$eQ)(d.browserEvent.target)||(0,u.$fQ)(d.browserEvent.target)||d.browserEvent.isHandledByList)return;const w=d.element;if(!w)return super.u(d);if(this.p(d)||this.o(d))return super.u(d);const E=d.browserEvent.target,I=E.classList.contains("monaco-tl-twistie")||E.classList.contains("monaco-icon-label")&&E.classList.contains("folder-icon")&&d.browserEvent.offsetX<16;let F=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?F=this.x.expandOnlyOnTwistieClick(w.element):F=!!this.x.expandOnlyOnTwistieClick,F&&!I&&d.browserEvent.detail!==2)return super.u(d);if(!this.x.expandOnDoubleClick&&d.browserEvent.detail===2)return super.u(d);if(w.collapsible){const B=this.x.getNodeLocation(w),q=d.browserEvent.altKey;if(this.x.setFocus([B]),this.x.toggleCollapsed(B,q),F&&I){d.browserEvent.isHandledByList=!0;return}}super.u(d)}v(d){d.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||d.browserEvent.isHandledByList||super.v(d)}}class J extends u.$nQ{constructor(d,w,E,I,F,B,q,T){super(d,w,E,I,T),this.p=F,this.s=B,this.K=q}D(d){return new x(this,d.tree)}splice(d,w,E=[]){if(super.splice(d,w,E),E.length===0)return;const I=[],F=[];let B;E.forEach((q,T)=>{this.p.has(q)&&I.push(d+T),this.s.has(q)&&F.push(d+T),this.K.has(q)&&(B=d+T)}),I.length>0&&super.setFocus((0,e.$Ff)([...super.getFocus(),...I])),F.length>0&&super.setSelection((0,e.$Ff)([...super.getSelection(),...F])),typeof B=="number"&&super.setAnchor(B)}setFocus(d,w,E=!1){super.setFocus(d,w),E||this.p.set(d.map(I=>this.element(I)),w)}setSelection(d,w,E=!1){super.setSelection(d,w),E||this.s.set(d.map(I=>this.element(I)),w)}setAnchor(d,w=!1){super.setAnchor(d),w||(typeof d>"u"?this.K.set([]):this.K.set([this.element(d)]))}}class X{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return g.Event.map(this.j.onMouseClick,Me)}get onMouseDblClick(){return g.Event.filter(g.Event.map(this.j.onMouseDblClick,Me),d=>d.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return g.Event.map(this.j.onContextMenu,fe)}get onTap(){return g.Event.map(this.j.onTap,Me)}get onPointer(){return g.Event.map(this.j.onPointer,Me)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return g.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ae.Highlight}set findMode(d){this.x&&(this.x.mode=d)}get findMatchType(){return this.x?.matchType??we.Fuzzy}set findMatchType(d){this.x&&(this.x.matchType=d)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:g.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(d,w,E,I,F={}){this.D=d,this.E=F,this.w=new g.$pc,this.onDidChangeFindOpenState=g.Event.None,this.A=new $.$lb,this.B=new g.$hc,this.onWillRefilter=this.B.event,this.C=new g.$hc,this.onDidUpdateOptions=this.C.event;const B=new M(E),q=new g.$qc,T=new g.$qc,z=this.A.add(new W(T.event)),C=new n.$L;this.k=I.map(se=>new ee(se,()=>this.o,q.event,z,C,F));for(const se of this.k)this.A.add(se);let A;F.keyboardNavigationLabelProvider&&(A=new ne(this,F.keyboardNavigationLabelProvider,F.filter),F={...F,filter:A},this.A.add(A)),this.p=new G(()=>this.j.getFocusedElements()[0],F.identityProvider),this.q=new G(()=>this.j.getSelectedElements()[0],F.identityProvider),this.u=new G(()=>this.j.getAnchorElement(),F.identityProvider),this.j=new J(d,w,B,this.k,this.p,this.q,this.u,{...N(()=>this.o,F),tree:this}),this.o=this.I(d,this.j,F),q.input=this.o.onDidChangeCollapseState;const _=g.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);_(()=>null,null,this.A);const K=this.A.add(new g.$hc),te=this.A.add(new a.$Bg(0));if(this.A.add(g.Event.any(_,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);K.fire([...se.values()])})})),T.input=K.event,F.keyboardSupport!==!1){const se=g.Event.chain(this.j.onKeyDown,ge=>ge.filter(pe=>!(0,u.$eQ)(pe.target)).map(pe=>new i.$cO(pe)));g.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===15))(this.F,this,this.A),g.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===17))(this.G,this,this.A),g.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===10))(this.H,this,this.A)}if((F.findWidgetEnabled??!0)&&F.keyboardNavigationLabelProvider&&F.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Ie(this,this.o,this.j,A,F.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=g.Event.None,this.onDidChangeFindMatchType=g.Event.None;this.z=(0,y.$OO)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===j.Always)}updateOptions(d={}){this.E={...this.E,...d};for(const w of this.k)w.updateOptions(d);this.j.updateOptions(this.E),this.x?.updateOptions(d),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===j.Always)}get options(){return this.E}updateWidth(d){const w=this.o.getListIndex(d);w!==-1&&this.j.updateWidth(w)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(d){this.j.scrollTop=d}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(d){this.j.scrollLeft=d}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const d=this.j.firstVisibleIndex;return d<0||d>=this.j.length?void 0:this.j.element(d).element}get lastVisibleElement(){const d=this.j.lastVisibleIndex;return this.j.element(d).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(d){this.j.ariaLabel=d}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(d,w){this.j.layout(d,w),(0,O.$pe)(w)&&this.x?.layout(w)}style(d){const w=`.${this.j.domId}`,E=[];d.treeIndentGuidesStroke&&(E.push(`.monaco-list${w}:hover .monaco-tl-indent > .indent-guide, .monaco-list${w}.always .monaco-tl-indent > .indent-guide  { border-color: ${d.treeInactiveIndentGuidesStroke}; }`),E.push(`.monaco-list${w} .monaco-tl-indent > .indent-guide.active { border-color: ${d.treeIndentGuidesStroke}; }`)),this.z.textContent=E.join(`
`),this.j.style(d)}getParentElement(d){const w=this.o.getParentNodeLocation(d);return this.o.getNode(w).element}getFirstElementChild(d){return this.o.getFirstElementChild(d)}getNode(d){return this.o.getNode(d)}getNodeLocation(d){return this.o.getNodeLocation(d)}collapse(d,w=!1){return this.o.setCollapsed(d,!0,w)}expand(d,w=!1){return this.o.setCollapsed(d,!1,w)}toggleCollapsed(d,w=!1){return this.o.setCollapsed(d,void 0,w)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(d){return this.o.isCollapsible(d)}setCollapsible(d,w){return this.o.setCollapsible(d,w)}isCollapsed(d){return this.o.isCollapsed(d)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(d){if(typeof d>"u")return this.j.setAnchor(void 0);const w=this.o.getNode(d);this.u.set([w]);const E=this.o.getListIndex(d);E>-1&&this.j.setAnchor(E,!0)}getAnchor(){return(0,e.$Hf)(this.u.get(),void 0)}setSelection(d,w){const E=d.map(F=>this.o.getNode(F));this.q.set(E,w);const I=d.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setSelection(I,w,!0)}getSelection(){return this.q.get()}setFocus(d,w){const E=d.map(F=>this.o.getNode(F));this.p.set(E,w);const I=d.map(F=>this.o.getListIndex(F)).filter(F=>F>-1);this.j.setFocus(I,w,!0)}focusNext(d=1,w=!1,E,I=this.y){this.j.focusNext(d,w,E,I)}focusPrevious(d=1,w=!1,E,I=this.y){this.j.focusPrevious(d,w,E,I)}focusNextPage(d,w=this.y){return this.j.focusNextPage(d,w)}focusPreviousPage(d,w=this.y){return this.j.focusPreviousPage(d,w)}focusLast(d,w=this.y){this.j.focusLast(d,w)}focusFirst(d,w=this.y){this.j.focusFirst(d,w)}getFocus(){return this.p.get()}reveal(d,w){this.o.expandTo(d);const E=this.o.getListIndex(d);E!==-1&&this.j.reveal(E,w)}getRelativeTop(d){const w=this.o.getListIndex(d);return w===-1?null:this.j.getRelativeTop(w)}getViewState(d=this.options.identityProvider){if(!d)throw new r.$YR(this.D,"Can't get tree view state without an identity provider");const w=B=>d.getId(B).toString(),E=H.empty(this.scrollTop);for(const B of this.getFocus())E.focus.add(w(B));for(const B of this.getSelection())E.selection.add(w(B));const I=this.o.getNode(),F=[I];for(;F.length>0;){const B=F.shift();B!==I&&B.collapsible&&(E.expanded[w(B.element)]=B.collapsed?0:1),F.push(...B.children)}return E}F(d){d.preventDefault(),d.stopPropagation();const w=this.j.getFocusedElements();if(w.length===0)return;const E=w[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!0)){const B=this.o.getParentNodeLocation(I);if(!B)return;const q=this.o.getListIndex(B);this.j.reveal(q),this.j.setFocus([q])}}G(d){d.preventDefault(),d.stopPropagation();const w=this.j.getFocusedElements();if(w.length===0)return;const E=w[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!1)){if(!E.children.some(T=>T.visible))return;const[B]=this.j.getFocus(),q=B+1;this.j.reveal(q),this.j.setFocus([q])}}H(d){d.preventDefault(),d.stopPropagation();const w=this.j.getFocusedElements();if(w.length===0)return;const E=w[0],I=this.o.getNodeLocation(E),F=d.browserEvent.altKey;this.o.setCollapsed(I,void 0,F)}navigate(d){return new k(this.j,this.o,d)}dispose(){(0,$.$hb)(this.A),this.j.dispose()}}t.$8R=X;class k{constructor(d,w,E){this.b=d,this.c=w,E?this.a=this.c.getListIndex(E):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[130],$e([1,0,129,120,24,26]),function(oe,t,y,S,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=void 0;class D extends y.$8R{constructor(l,u,f,P,r,h={}){super(l,u,f,P,h),this.f=l,this.g=r,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(l,u){if(u&&!this.c)throw new i.$YR(this.f,"Can't restore tree view state without an identity provider");if(this.b=l,!l){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!u){this.m(l);return}const f=[],P=[],r=e=>{const a=this.c.getId(e).toString();return!u.expanded[a]},h=e=>{const a=this.c.getId(e.element).toString();u.focus.has(a)&&f.push(e.element),u.selection.has(a)&&P.push(e.element)};this.m(l,r,h),this.setFocus(f),this.setSelection(P),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(l=this.b){if(typeof this.b>"u")throw new i.$YR(this.f,"Tree input not set");let u;this.c&&(u=f=>{const P=this.c.getId(f).toString(),r=this.d.get(P);if(r)return r.collapsed}),this.m(l,u)}resort(l=this.b,u=!0){this.o.resort(l===this.b?null:l,u)}refresh(l){if(l===void 0){this.j.rerender();return}this.o.rerender(l)}m(l,u,f){let P;if(this.c){const r=new Set,h=f;f=e=>{const a=this.c.getId(e.element).toString();r.add(a),this.d.set(a,e),h?.(e)},P=e=>{const a=this.c.getId(e.element).toString();r.has(a)||this.d.delete(a)}}this.o.setChildren(l===this.b?null:l,this.s(l,u).elements,{onDidCreateNode:f,onDidDeleteNode:P})}s(l,u){const f=[...this.g.getChildren(l)];return{elements:U.Iterable.map(f,r=>{const{elements:h,size:e}=this.s(r,u),a=this.g.hasChildren?this.g.hasChildren(r):void 0,o=e===0?void 0:u&&u(r);return{element:r,children:h,collapsible:a,collapsed:o}}),size:f.length}}I(l,u,f){return new S.$9R(l,u,f)}}t.$gS=D}),define(me[64],$e([1,0,13,9,31,27,25,6,3,2,50,11,7]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ih=t.ProxyChannel=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.RequestInitiator=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=void 0;var h;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(h||(h={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(a||(a={}));function o(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(s||(s={}));function n(fe){let ie=0;for(let G=0;;G+=7){const x=fe.read(1);if(ie|=(x.buffer[0]&127)<<G,!(x.buffer[0]&128))return ie}}const g=R(0);function b(fe,ie){if(ie===0){fe.write(g);return}let G=0;for(let J=ie;J!==0;J=J>>>7)G++;const x=i.$Hc.alloc(G);for(let J=0;ie!==0;J++)x.buffer[J]=ie&127,ie=ie>>>7,ie>0&&(x.buffer[J]|=128);fe.write(x)}class ${constructor(ie){this.b=ie,this.a=0}read(ie){const G=this.b.slice(this.a,this.a+ie);return this.a+=G.byteLength,G}}t.$0g=$;class c{constructor(){this.a=[]}get buffer(){return i.$Hc.concat(this.a)}write(ie){this.a.push(ie)}}t.$$g=c;var O;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(O||(O={}));function R(fe){const ie=i.$Hc.alloc(1);return ie.writeUInt8(fe,0),ie}const L={Undefined:R(O.Undefined),String:R(O.String),Buffer:R(O.Buffer),VSBuffer:R(O.VSBuffer),Array:R(O.Array),Object:R(O.Object),Uint:R(O.Int)},m=typeof Buffer<"u";function p(fe,ie){if(typeof ie>"u")fe.write(L.Undefined);else if(typeof ie=="string"){const G=i.$Hc.fromString(ie);fe.write(L.String),b(fe,G.byteLength),fe.write(G)}else if(m&&Buffer.isBuffer(ie)){const G=i.$Hc.wrap(ie);fe.write(L.Buffer),b(fe,G.byteLength),fe.write(G)}else if(ie instanceof i.$Hc)fe.write(L.VSBuffer),b(fe,ie.byteLength),fe.write(ie);else if(Array.isArray(ie)){fe.write(L.Array),b(fe,ie.length);for(const G of ie)p(fe,G)}else if(typeof ie=="number"&&(ie|0)===ie)fe.write(L.Uint),b(fe,ie);else{const G=i.$Hc.fromString(JSON.stringify(ie));fe.write(L.Object),b(fe,G.byteLength),fe.write(G)}}t.$_g=p;function N(fe){switch(fe.read(1).readUInt8(0)){case O.Undefined:return;case O.String:return fe.read(n(fe)).toString();case O.Buffer:return fe.read(n(fe)).buffer;case O.VSBuffer:return fe.read(n(fe));case O.Array:{const G=n(fe),x=[];for(let J=0;J<G;J++)x.push(N(fe));return x}case O.Object:return JSON.parse(fe.read(n(fe)).toString());case O.Int:return n(fe)}}t.$ah=N;class M{constructor(ie,G,x=null,J=1e3){this.h=ie,this.j=G,this.k=x,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(ie,G){this.b.set(ie,G),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const G=this.o([ie.type]);this.k?.logOutgoing(G,0,1,o(ie.type));return}case 201:case 202:case 204:case 203:{const G=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(G,ie.id,1,o(ie.type),ie.data);return}}}o(ie,G=void 0){const x=new c;return p(x,ie),p(x,G),this.p(x.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const G=new $(ie),x=N(G),J=N(G),X=x[0];switch(X){case 100:return this.k?.logIncoming(ie.byteLength,x[1],1,`${e(X)}: ${x[2]}.${x[3]}`,J),this.s({type:X,id:x[1],channelName:x[2],name:x[3],arg:J});case 102:return this.k?.logIncoming(ie.byteLength,x[1],1,`${e(X)}: ${x[2]}.${x[3]}`,J),this.t({type:X,id:x[1],channelName:x[2],name:x[3],arg:J});case 101:return this.k?.logIncoming(ie.byteLength,x[1],1,`${e(X)}`),this.u({type:X,id:x[1]});case 103:return this.k?.logIncoming(ie.byteLength,x[1],1,`${e(X)}`),this.u({type:X,id:x[1]})}}s(ie){const G=this.b.get(ie.channelName);if(!G){this.v(ie);return}const x=new U.$rc;let J;try{J=G.call(this.j,ie.name,ie.arg,x.token)}catch(V){J=Promise.reject(V)}const X=ie.id;J.then(V=>{this.m({id:X,data:V,type:201})},V=>{V instanceof Error?this.m({id:X,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:X,data:V,type:203})}).finally(()=>{k.dispose(),this.d.delete(ie.id)});const k=(0,u.$kb)(()=>x.cancel());this.d.set(ie.id,k)}t(ie){const G=this.b.get(ie.channelName);if(!G){this.v(ie);return}const x=ie.id,X=G.listen(this.j,ie.name,ie.arg)(k=>this.m({id:x,data:k,type:204}));this.d.set(ie.id,X)}u(ie){const G=this.d.get(ie.id);G&&(G.dispose(),this.d.delete(ie.id))}v(ie){let G=this.g.get(ie.channelName);G||(G=[],this.g.set(ie.channelName,G));const x=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:ie,timeoutTimer:x})}w(ie){const G=this.g.get(ie);if(G){for(const x of G)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$hb)(this.d.values()),this.d.clear()}}t.$bh=M;var H;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(H||(t.RequestInitiator=H={}));class j{constructor(ie,G=null){this.l=ie,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=G}getChannel(ie){const G=this;return{call(x,J,X){return G.a?Promise.reject(new v.$3):G.m(ie,x,J,X)},listen(x,J){return G.a?l.Event.None:G.o(ie,x,J)}}}m(ie,G,x,J=U.CancellationToken.None){const X=this.g++,V={id:X,type:100,channelName:ie,name:G,arg:x};if(J.isCancellationRequested)return Promise.reject(new v.$3);let d;return new Promise((E,I)=>{if(J.isCancellationRequested)return I(new v.$3);const F=()=>{const z=C=>{switch(C.type){case 201:this.f.delete(X),E(C.data);break;case 202:{this.f.delete(X);const A=new Error(C.data.message);A.stack=Array.isArray(C.data.stack)?C.data.stack.join(`
`):C.data.stack,A.name=C.data.name,I(A);break}case 203:this.f.delete(X),I(C.data);break}};this.f.set(X,z),this.p(V)};let B=null;this.b===s.Idle?F():(B=(0,S.$sg)(z=>this.u()),B.then(()=>{B=null,F()}));const q=()=>{B?(B.cancel(),B=null):this.p({id:X,type:101}),I(new v.$3)},T=J.onCancellationRequested(q);d=(0,u.$jb)((0,u.$kb)(q),T),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(ie,G,x){const J=this.g++,k={id:J,type:102,channelName:ie,name:G,arg:x};let V=null;const d=new l.$hc({onWillAddFirstListener:()=>{V=(0,S.$sg)(E=>this.u()),V.then(()=>{V=null,this.d.add(d),this.p(k)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(d),this.p({id:J,type:103}))}}),w=E=>d.fire(E.data);return this.f.set(J,w),d.event}p(ie){switch(ie.type){case 100:case 102:{const G=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(G,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const G=this.q([ie.type,ie.id]);this.j?.logOutgoing(G,ie.id,0,e(ie.type));return}}}q(ie,G=void 0){const x=new c;return p(x,ie),p(x,G),this.r(x.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const G=new $(ie),x=N(G),J=N(G),X=x[0];switch(X){case 200:return this.j?.logIncoming(ie.byteLength,0,0,o(X)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,x[1],0,o(X),J),this.t({type:x[0],id:x[1],data:J})}}t(ie){if(ie.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$hb)(this.d.values()),this.d.clear()}}t.$ch=j,Ke([D.$4g],j.prototype,"onDidInitializePromise",null);class W{get connections(){const ie=[];return this.f.forEach(G=>ie.push(G)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new l.$hc,this.onDidAddConnection=this.g.event,this.h=new l.$hc,this.onDidRemoveConnection=this.h.event,this.j=new u.$lb,this.j.add(ie(({protocol:G,onDidClientDisconnect:x})=>{const J=l.Event.once(G.onMessage);this.j.add(J(X=>{const k=new $(X),V=N(k),d=new M(G,V),w=new j(G);this.a.forEach((I,F)=>d.registerChannel(F,I));const E={channelServer:d,channelClient:w,ctx:V};this.f.add(E),this.g.fire(E),this.j.add(x(()=>{d.dispose(),w.dispose(),this.f.delete(E),this.h.fire(E)}))}))}))}getChannel(ie,G){const x=this;return{call(J,X,k){let V;if((0,r.$ze)(G)){const w=(0,y.$Wf)(x.connections.filter(G));V=w?Promise.resolve(w):l.Event.toPromise(l.Event.filter(x.onDidAddConnection,G))}else V=G.routeCall(x,J,X);const d=V.then(w=>w.channelClient.getChannel(ie));return ne(d).call(J,X,k)},listen(J,X){if((0,r.$ze)(G))return x.k(ie,G,J,X);const k=G.routeEvent(x,J,X).then(V=>V.channelClient.getChannel(ie));return ne(k).listen(J,X)}}}k(ie,G,x,J){const X=this;let k;const V=new l.$hc({onWillAddFirstListener:()=>{k=new u.$lb;const d=new l.$nc,w=new Map,E=F=>{const q=F.channelClient.getChannel(ie).listen(x,J),T=d.add(q);w.set(F,T)},I=F=>{const B=w.get(F);B&&(B.dispose(),w.delete(F))};X.connections.filter(G).forEach(E),l.Event.filter(X.onDidAddConnection,G)(E,void 0,k),X.onDidRemoveConnection(I,void 0,k),d.event(V.fire,V,k),k.add(d)},onDidRemoveLastListener:()=>{k?.dispose(),k=void 0}});return V.event}registerChannel(ie,G){this.a.set(ie,G);for(const x of this.f)x.channelServer.registerChannel(ie,G)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$dh=W;class ee{constructor(ie,G,x=null){const J=new c;p(J,G),ie.send(J.buffer),this.a=new j(ie,x),this.d=new M(ie,G,x)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,G){this.d.registerChannel(ie,G)}dispose(){this.a.dispose(),this.d.dispose()}}t.$eh=ee;function ne(fe){return{call(ie,G,x){return fe.then(J=>J.call(ie,G,x))},listen(ie,G){const x=new l.$qc;return fe.then(J=>x.input=J.listen(ie,G)),x.event}}}t.$fh=ne;function re(fe){let ie=!1;return{call(G,x,J){return ie?fe.call(G,x,J):(0,S.$Fg)(0).then(()=>ie=!0).then(()=>fe.call(G,x,J))},listen(G,x){if(ie)return fe.listen(G,x);const J=new l.$qc;return(0,S.$Fg)(0).then(()=>ie=!0).then(()=>J.input=fe.listen(G,x)),J.event}}}t.$gh=re;class ce{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const G of ie.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await l.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$hh=ce;var he;(function(fe){function ie(X,k,V){const d=X,w=V&&V.disableMarshalling,E=new Map;for(const I in d)x(I)&&E.set(I,l.Event.buffer(d[I],!0,void 0,k));return new class{listen(I,F,B){const q=E.get(F);if(q)return q;if(J(F)){const T=d[F];if(typeof T=="function")return T.call(d,B)}throw new v.$_(`Event not found: ${F}`)}call(I,F,B){const q=d[F];if(typeof q=="function"){if(!w&&Array.isArray(B))for(let T=0;T<B.length;T++)B[T]=(0,f.$9g)(B[T]);return q.apply(d,B)}throw new v.$_(`Method not found: ${F}`)}}}fe.fromService=ie;function G(X,k){const V=k&&k.disableMarshalling;return new Proxy({},{get(d,w){if(typeof w=="string")return k?.properties?.has(w)?k.properties.get(w):J(w)?function(E){return X.listen(w,E)}:x(w)?X.listen(w):async function(...E){let I;k&&!(0,r.$ue)(k.context)?I=[k.context,...E]:I=E;const F=await X.call(w,I);return V?F:(0,f.$9g)(F)};throw new v.$_(`Property not found: ${String(w)}`)}})}fe.toService=G;function x(X){return X[0]==="o"&&X[1]==="n"&&P.$Nd(X.charCodeAt(2))}function J(X){return/^onDynamic/.test(X)&&P.$Nd(X.charCodeAt(9))}})(he||(t.ProxyChannel=he={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function we(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const ie=fe.toString();if(ie!=="[object Object]")return ie}return fe}function Oe(fe){return Array.isArray(fe)?fe.map(we):we(fe)}function Ie(fe,ie,G,x,J,X,k){k=Oe(k);const V=ae[J],d=V[x%V.length];let w=[`%c[${fe}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(X)?(w=w.concat(k),w.push(")")):w.push(k),console.log.apply(console,w)}class Me{constructor(ie,G){this.d=ie,this.f=G,this.a=0,this.b=0}logOutgoing(ie,G,x,J,X){this.b+=ie,Ie(this.d,this.b,ie,G,x,J,X)}logIncoming(ie,G,x,J,X){this.a+=ie,Ie(this.f,this.a,ie,G,x,J,X)}}t.$ih=Me}),define(me[29],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=void 0,t.$M=y.$g.vscode.ipcRenderer,t.$N=y.$g.vscode.ipcMessagePort,t.$O=y.$g.vscode.webFrame,t.$P=y.$g.vscode.process,t.$Q=y.$g.vscode.context}),define(me[131],$e([1,0,87,29]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KS=void 0;let i=0;function U(v,l,u){const f=[],P=i++,r=`vscode:onContextMenu${P}`,h=(e,a,o)=>{f[a].click?.(o)};S.$M.once(r,h),S.$M.once(y.$HS,(e,a)=>{a===P&&(S.$M.removeListener(r,h),u?.())}),S.$M.send(y.$GS,P,v.map(e=>D(e,f)),r,l)}t.$KS=U;function D(v,l){const u={id:l.length,label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:typeof v.enabled=="boolean"?v.enabled:!0,visible:typeof v.visible=="boolean"?v.visible:!0};return l.push(v),Array.isArray(v.submenu)&&(u.submenu=v.submenu.map(f=>D(f,l))),u}}),define(me[132],$e([1,0,31,3,64,88,29]),function(oe,t,y,S,i,U,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=void 0;class v extends i.$eh{static f(){const u=S.Event.fromNodeEventEmitter(D.$M,"vscode:message",(f,P)=>y.$Hc.wrap(P));return D.$M.send("vscode:hello"),new U.$OS(D.$M,u)}constructor(u){const f=v.f();super(f,u),this.b=f}dispose(){this.b.disconnect()}}t.$SS=v}),define(me[133],$e([12,10]),function(oe,t){return oe.create("vs/platform/files/common/files",t)}),define(me[134],$e([12,10]),function(oe,t){return oe.create("vs/platform/theme/common/iconRegistry",t)}),define(me[38],$e([1,0]),function(oe,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ah=t.$zh=t.$yh=t._util=void 0;var y;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function v(l){return l[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=v})(y||(t._util=y={})),t.$yh=i("instantiationService");function S(D,v,l){v[y.DI_TARGET]===v?v[y.DI_DEPENDENCIES].push({id:D,index:l}):(v[y.DI_DEPENDENCIES]=[{id:D,index:l}],v[y.DI_TARGET]=v)}function i(D){if(y.serviceIds.has(D))return y.serviceIds.get(D);const v=function(l,u,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(v,l,f)};return v.toString=()=>D,y.serviceIds.set(D,v),v}t.$zh=i;function U(D){return D}t.$Ah=U}),define(me[135],$e([1,0,38]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gm=t.$fm=t.$em=t.ID=void 0,t.ID="diagnosticsService",t.$em=(0,y.$zh)(t.ID);function S(U){return!!U.hostName&&!!U.errorMessage}t.$fm=S;class i{async getPerformanceInfo(D,v){return{}}async getSystemInfo(D,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,v){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.$gm=i}),define(me[136],$e([1,0,86,22,11,7,15,133,38,5,28]),function(oe,t,y,S,i,U,D,v,l,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.FileKind=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.$ok=t.FileOperationResult=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.FileChangeType=t.$ik=t.FileOperation=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.FileSystemProviderErrorCode=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$5j=t.$4j=void 0,t.$4j=(0,l.$zh)("fileService");function P(G){return G.create===!0}t.$5j=P;var r;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var h;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(h||(t.FilePermission=h={}));var e;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function a(G){return!!(G.capabilities&2)}t.$6j=a;function o(G){return!!(G.capabilities&8)}t.$7j=o;function s(G){return!!(G.capabilities&131072)}t.$8j=s;function n(G){return!!(G.capabilities&4)}t.$9j=n;function g(G){return!!(G.capabilities&16)}t.$0j=g;function b(G){return a(G)?!!(G.capabilities&16384):!1}t.$$j=b;function $(G){return a(G)?!!(G.capabilities&32768):!1}t.$_j=$;function c(G){return!!(G.capabilities&65536)}t.$ak=c;function O(G){return!!(G.capabilities&2048)}t.$bk=O;var R;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(R||(t.FileSystemProviderErrorCode=R={}));class L extends Error{static create(x,J){const X=new L(x.toString(),J);return N(X,J),X}constructor(x,J){super(x),this.code=J}}t.$ck=L;function m(G,x){return L.create(G,x)}t.$dk=m;function p(G){return G||m((0,v.localize)(0,null),R.Unknown)}t.$ek=p;function N(G,x){return G.name=x?`${x} (FileSystemError)`:"FileSystemError",G}t.$fk=N;function M(G){if(!G)return R.Unknown;if(G instanceof L)return G.code;const x=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!x)return R.Unknown;switch(x[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}t.$gk=M;function H(G){if(G instanceof ce)return G.fileOperationResult;switch(M(G)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 9;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileTooLarge:return 7;default:return 10}}t.$hk=H;var j;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(j||(t.FileOperation=j={}));class W{constructor(x,J,X){this.resource=x,this.operation=J,this.target=X}isOperation(x){return this.operation===x}}t.$ik=W;var ee;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(ee||(t.FileChangeType=ee={}));class ne{constructor(x,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const X=new Map;for(const k of x){const V=X.get(k.type);switch(V?V.push([k.resource,k]):X.set(k.type,[[k.resource,k]]),k.type){case 1:this.rawAdded.push(k.resource);break;case 0:this.rawUpdated.push(k.resource);break;case 2:this.rawDeleted.push(k.resource);break}}for(const[k,V]of X)switch(k){case 1:this.a=y.$Fh.forUris(()=>J),this.a.fill(V);break;case 0:this.b=y.$Fh.forUris(()=>J),this.b.fill(V);break;case 2:this.c=y.$Fh.forUris(()=>J),this.c.fill(V);break}}contains(x,...J){return this.d(x,{includeChildren:!1},...J)}affects(x,...J){return this.d(x,{includeChildren:!0},...J)}d(x,J,...X){if(!x)return!1;const k=X.length>0;return!!((!k||X.includes(1))&&(this.a?.get(x)||J.includeChildren&&this.a?.findSuperstr(x))||(!k||X.includes(0))&&(this.b?.get(x)||J.includeChildren&&this.b?.findSuperstr(x))||(!k||X.includes(2))&&(this.c?.findSubstr(x)||J.includeChildren&&this.c?.findSuperstr(x)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.$jk=ne;function re(G,x,J){return!G||!x||G===x||x.length>G.length?!1:(x.charAt(x.length-1)!==S.sep&&(x+=S.sep),J?(0,i.$Pd)(G,x):G.indexOf(x)===0)}t.$kk=re;class ce extends Error{constructor(x,J,X){super(x),this.fileOperationResult=J,this.options=X}}t.$lk=ce;class he extends ce{constructor(x,J,X,k){super(x,J,k),this.fileOperationResult=J,this.size=X}}t.$mk=he;class ae extends ce{constructor(x,J,X){super(x,2,X),this.stat=J}}t.$nk=ae;var we;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(we||(t.FileOperationResult=we={})),t.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$qk="files.associations",t.$rk="files.exclude",t.$sk="files.readonlyInclude",t.$tk="files.readonlyExclude",t.$uk="files.readonlyFromPermissions";var Oe;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(Oe||(t.FileKind=Oe={})),t.$vk="";function Ie(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}t.$wk=Ie;async function Me(G,x){if(!x.hasProvider(D.URI.from({scheme:G.scheme})))return new Promise(J=>{const X=x.onDidChangeFileSystemProviderRegistrations(k=>{k.scheme===G.scheme&&k.added&&(X.dispose(),J())})})}t.$xk=Me;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(x){return(0,U.$pe)(x)||(x=0),x<fe.KB?(0,v.localize)(1,null,x.toFixed(0)):x<fe.MB?(0,v.localize)(2,null,(x/fe.KB).toFixed(2)):x<fe.GB?(0,v.localize)(3,null,(x/fe.MB).toFixed(2)):x<fe.TB?(0,v.localize)(4,null,(x/fe.GB).toFixed(2)):(0,v.localize)(5,null,(x/fe.TB).toFixed(2))}}t.$yk=fe;function ie(G){const x=typeof G=="string"||G?.scheme===f.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===f.Schemas.file?1024*fe.MB:x?10*fe.MB:u.$o?50*fe.MB:1024*fe.MB}t.$zk=ie}),define(me[137],$e([1,0,38]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$36b=t.$26b=void 0,t.$26b=(0,y.$zh)("mainProcessService");class S{constructor(U,D){this.a=U,this.b=D}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,D){this.a.registerChannel(U,D)}}t.$36b=S}),define(me[138],$e([1,0,2,132]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$46b=void 0;class i extends y.$mb{constructor(D){super(),this.a=this.B(new S.$SS(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,v){this.a.registerChannel(D,v)}}t.$46b=i});var bi=this&&this.__param||function(oe,t){return function(y,S){t(y,S,oe)}};define(me[139],$e([1,0,64,137]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$56b=void 0;let i=class{constructor(D,v){return this.windowId=D,y.ProxyChannel.toService(v.getChannel("nativeHost"),{context:D,properties:(()=>{const l=new Map;return l.set("windowId",D),l})()})}};t.$56b=i,t.$56b=i=Ke([bi(1,S.$26b)],i)}),define(me[65],$e([1,0,73,7]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6m=void 0;class i{constructor(){this.a=new Map}add(D,v){y.ok(S.$le(D)),y.ok(S.$ne(v)),y.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,v)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.$6m=new i}),define(me[140],$e([1,0,3,65]),function(oe,t,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7m=void 0,t.$7m={JSONContribution:"base.contributions.json"};function i(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class U{constructor(){this.b=new y.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,u){this.a[i(l)]=u,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const D=new U;S.$6m.add(t.$7m.JSONContribution,D)}),define(me[141],$e([1,0,9,17,18,3,7,15,134,140,65]),function(oe,t,y,S,i,U,D,v,l,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$av=t.$_u=t.$$u=t.$0u=t.$9u=t.$8u=t.$7u=t.$6u=t.IconFontDefinition=t.IconContribution=t.$5u=void 0,t.$5u={IconContribution:"base.contributions.icons"};var P;(function(b){function $(c,O){let R=c.defaults;for(;i.ThemeIcon.isThemeIcon(R);){const L=e.getIcon(R.id);if(!L)return;R=L.defaults}return R}b.getDefinition=$})(P||(t.IconContribution=P={}));var r;(function(b){function $(O){return{weight:O.weight,style:O.style,src:O.src.map(R=>({format:R.format,location:R.location.toString()}))}}b.toJSONObject=$;function c(O){const R=L=>(0,D.$le)(L)?L:void 0;if(O&&Array.isArray(O.src)&&O.src.every(L=>(0,D.$le)(L.format)&&(0,D.$le)(L.location)))return{weight:R(O.weight),style:R(O.style),src:O.src.map(L=>({format:L.format,location:v.URI.parse(L.location)}))}}b.fromJSONObject=c})(r||(t.IconFontDefinition=r={}));class h{constructor(){this.a=new U.$hc,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon($,c,O,R){const L=this.b[$];if(L){if(O&&!L.description){L.description=O,this.d.properties[$].markdownDescription=`${O} $(${$})`;const N=this.e.enum.indexOf($);N!==-1&&(this.e.enumDescriptions[N]=O),this.a.fire()}return L}const m={id:$,description:O,defaults:c,deprecationMessage:R};this.b[$]=m;const p={$ref:"#/definitions/icons"};return R&&(p.deprecationMessage=R),O&&(p.markdownDescription=`${O}: $(${$})`),this.d.properties[$]=p,this.e.enum.push($),this.e.enumDescriptions.push(O||""),this.a.fire(),{id:$}}deregisterIcon($){delete this.b[$],delete this.d.properties[$];const c=this.e.enum.indexOf($);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map($=>this.b[$])}getIcon($){return this.b[$]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont($,c){const O=this.f[$];return O||(this.f[$]=c,this.a.fire(),c)}deregisterIconFont($){delete this.f[$]}getIconFont($){return this.f[$]}toString(){const $=(L,m)=>L.id.localeCompare(m.id),c=L=>{for(;i.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},O=[];O.push("| preview     | identifier                        | default codicon ID                | description"),O.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const R=Object.keys(this.b).map(L=>this.b[L]);for(const L of R.filter(m=>!!m.description).sort($))O.push(`|<i class="${c(L)}"></i>|${L.id}|${i.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);O.push("| preview     | identifier                        "),O.push("| ----------- | --------------------------------- |");for(const L of R.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort($))O.push(`|<i class="${c(L)}"></i>|${L.id}|`);return O.join(`
`)}}const e=new h;f.$6m.add(t.$5u.IconContribution,e);function a(b,$,c,O){return e.registerIcon(b,$,c,O)}t.$6u=a;function o(){return e}t.$7u=o;function s(){const b=(0,S.$Lj)();for(const $ in b){const c="\\"+b[$].toString(16);e.registerIcon($,{fontCharacter:c})}}s(),t.$8u="vscode://schemas/icons";const n=f.$6m.as(u.$7m.JSONContribution);n.registerSchema(t.$8u,e.getIconSchema());const g=new y.$Qg(()=>n.notifySchemaChanged(t.$8u),200);e.onDidChange(()=>{g.isScheduled()||g.schedule()}),t.$9u=a("widget-close",S.$Nj.close,(0,l.localize)(2,null)),t.$0u=a("goto-previous-location",S.$Nj.arrowUp,(0,l.localize)(3,null)),t.$$u=a("goto-next-location",S.$Nj.arrowDown,(0,l.localize)(4,null)),t.$_u=i.ThemeIcon.modify(S.$Nj.sync,"spin"),t.$av=i.ThemeIcon.modify(S.$Nj.loading,"spin")}),define(me[142],$e([1,0,4,3,18,141]),function(oe,t,y,S,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$izb=t.$hzb=void 0;function D(l){const u=new S.$hc,f=(0,U.$7u)();return f.onDidChange(()=>u.fire()),l?.onDidProductIconThemeChange(()=>u.fire()),{onDidChange:u.event,getCSS(){const P=l?l.getProductIconTheme():new v,r={},h=a=>{const o=P.getIcon(a);if(!o)return;const s=o.font;return s?(r[s.id]=s.definition,`.codicon-${a.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,y.$fP)(s.id)}; }`):`.codicon-${a.id}:before { content: '${o.fontCharacter}'; }`},e=[];for(const a of f.getIcons()){const o=h(a);o&&e.push(o)}for(const a in r){const o=r[a],s=o.weight?`font-weight: ${o.weight};`:"",n=o.style?`font-style: ${o.style};`:"",g=o.src.map(b=>`${(0,y.$eP)(b.location)} format('${b.format}')`).join(", ");e.push(`@font-face { src: ${g}; font-family: ${(0,y.$fP)(a)};${s}${n} font-display: block; }`)}return e.join(`
`)}}}t.$hzb=D;class v{getIcon(u){const f=(0,U.$7u)();let P=u.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=f.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.$izb=v}),define(me[143],$e([1,0,5]),function(oe,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SD=t.$RD=t.$QD=t.$PD=t.$OD=t.$ND=t.$MD=t.$LD=void 0,t.$LD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function S(f){return!!f.workspaceUri}t.$MD=S;function i(f){return!!f.folderUri}t.$ND=i;function U(f){return!!f.fileUri}t.$OD=U;function D(f){const P=v(f),r=f.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||y.$j&&y.$m?"classic":r}t.$PD=D;function v(f){if(y.$o)return"custom";const P=f.getValue("window");if(P){if(y.$j&&P.nativeTabs===!0||y.$j&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$k?"native":"custom"}t.$QD=v;function l(f){return!(!y.$i||y.$o||v(f)==="native")}t.$RD=l;function u(f=0){return Math.pow(1.2,f)}t.$SD=u}),define(me[144],$e([1,0,16,29,143]),function(oe,t,y,S,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$96b=t.$86b=t.$76b=void 0;function U(l){S.$O.setZoomLevel(l),(0,y.$TN)((0,i.$SD)(l)),(0,y.$QN)(l)}t.$76b=U;function D(){U((0,y.$RN)()+1)}t.$86b=D;function v(){U((0,y.$RN)()-1)}t.$96b=v}),define(me[145],$e([1,0,10,4,130,9,131,29,135,136,138,139,142,144,14,101,92]),function(oe,t,y,S,i,U,D,v,l,u,f,P,r,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,o=/\s--inspect-port=(?<port>\d+)/;class s{getHeight(H){return 22}getTemplateId(H){return L(H)?"process":O(H)?"machine":(0,l.$fm)(H)?"error":R(H)?"header":""}}class n{hasChildren(H){return(0,l.$fm)(H)?!1:L(H)?!!H.children?.length:!0}getChildren(H){return L(H)?H.children?H.children:[]:(0,l.$fm)(H)?[]:R(H)?H.processRoots.length>1?H.processRoots:[H.processRoots[0].rootProcess]:O(H)?[H.rootProcess]:[H.processes]}}class g{constructor(){this.templateId="header"}renderTemplate(H){const j=(0,S.$1O)(H,(0,S.$)(".row")),W=(0,S.$1O)(j,(0,S.$)(".nameLabel")),ee=(0,S.$1O)(j,(0,S.$)(".cpu")),ne=(0,S.$1O)(j,(0,S.$)(".memory")),re=(0,S.$1O)(j,(0,S.$)(".pid"));return{name:W,CPU:ee,memory:ne,PID:re}}renderElement(H,j,W,ee){W.name.textContent=(0,y.localize)(0,null),W.CPU.textContent=(0,y.localize)(1,null),W.PID.textContent=(0,y.localize)(2,null),W.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(H){}}class b{constructor(){this.templateId="machine"}renderTemplate(H){const j=Object.create(null),W=(0,S.$1O)(H,(0,S.$)(".row"));return j.name=(0,S.$1O)(W,(0,S.$)(".nameLabel")),j}renderElement(H,j,W,ee){W.name.textContent=H.element.name}disposeTemplate(H){}}class ${constructor(){this.templateId="error"}renderTemplate(H){const j=Object.create(null),W=(0,S.$1O)(H,(0,S.$)(".row"));return j.name=(0,S.$1O)(W,(0,S.$)(".nameLabel")),j}renderElement(H,j,W,ee){W.name.textContent=H.element.errorMessage}disposeTemplate(H){}}class c{constructor(H,j,W){this.a=H,this.b=j,this.c=W,this.templateId="process"}renderTemplate(H){const j=(0,S.$1O)(H,(0,S.$)(".row")),W=(0,S.$1O)(j,(0,S.$)(".nameLabel")),ee=(0,S.$1O)(j,(0,S.$)(".cpu")),ne=(0,S.$1O)(j,(0,S.$)(".memory")),re=(0,S.$1O)(j,(0,S.$)(".pid"));return{name:W,CPU:ee,PID:re,memory:ne}}renderElement(H,j,W,ee){const{element:ne}=H,re=ne.pid.toFixed(0);let ce=ne.name;this.c.has(ne.pid)&&(ce=this.c.get(ne.pid)),W.name.textContent=ce,W.name.title=ne.cmd,W.CPU.textContent=ne.load.toFixed(0),W.PID.textContent=re,W.PID.parentElement.id=`pid-${re}`;const he=this.a==="win32"?ne.mem:this.b*(ne.mem/100);W.memory.textContent=(he/u.$yk.MB).toFixed(0)}disposeTemplate(H){}}function O(M){return!!M.name&&!!M.rootProcess}function R(M){return!!M.processRoots}function L(M){return!!M.pid}class m{constructor(H,j){this.f=j,this.b=new Map;const W=new f.$46b(H);this.c=new P.$56b(H,W),this.k(j.styles),this.g(j),v.$M.on("vscode:pidToNameResponse",(ee,ne)=>{this.b=new Map;for(const[re,ce]of ne)this.b.set(re,ce)}),v.$M.on("vscode:listProcessesResponse",async(ee,ne)=>{ne.forEach((re,ce)=>{L(re.rootProcess)&&(re.rootProcess.name=ce===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ne}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ne),this.m(0)}),this.a=Date.now(),v.$M.send("vscode:pidToNameRequest"),v.$M.send("vscode:listProcesses")}g(H){document.onkeydown=j=>{const W=H.platform==="darwin"?j.metaKey:j.ctrlKey;W&&j.keyCode===87&&(j.stopPropagation(),j.preventDefault(),v.$M.send("vscode:closeProcessExplorer")),W&&j.keyCode===187&&(0,h.$86b)(),W&&j.keyCode===189&&(0,h.$96b)()}}async h(H){const j=document.getElementById("process-list");if(!j)return;const{totalmem:W}=await this.c.getOSStatistics(),ee=[new c(this.f.platform,W,this.b),new g,new b,new $];this.d=new i.$gS("processExplorer",j,new s,ee,new n,{identityProvider:{getId:ne=>L(ne)?ne.pid.toString():(0,l.$fm)(ne)?ne.hostName:R(ne)?"processes":O(ne)?ne.name:"header"}}),this.d.setInput({processes:{processRoots:H}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ne=>{const re=new e.$cO(ne);if(re.keyCode===35&&re.altKey){const ce=this.n();Promise.all(ce.map(he=>this.c.killProcess(he,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ne=>{L(ne.element)&&this.l(ne.element,!0)}),j.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{j.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(H){const j=a.exec(H);return j&&j.groups.port!=="0"||H.indexOf("node ")>=0||H.indexOf("node.exe")>=0}j(H){const j={type:"node",request:"attach",name:`process ${H.pid}`};let W=a.exec(H.cmd);W?j.port=Number(W.groups.port):j.processId=String(H.pid),W=o.exec(H.cmd),W&&(j.port=Number(W.groups.port)),v.$M.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[j]})}k(H){const j=(0,S.$OO)(),W=[];H.listFocusBackground&&(W.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${H.listFocusBackground}; }`),W.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${H.listFocusBackground}; }`)),H.listFocusForeground&&W.push(`.monaco-list:focus .monaco-list-row.focused { color: ${H.listFocusForeground}; }`),H.listActiveSelectionBackground&&(W.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${H.listActiveSelectionBackground}; }`),W.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${H.listActiveSelectionBackground}; }`)),H.listActiveSelectionForeground&&W.push(`.monaco-list:focus .monaco-list-row.selected { color: ${H.listActiveSelectionForeground}; }`),H.listHoverBackground&&W.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${H.listHoverBackground}; }`),H.listHoverForeground&&W.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${H.listHoverForeground}; }`),H.listFocusOutline&&W.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${H.listFocusOutline}; outline-offset: -1px; }`),H.listHoverOutline&&W.push(`.monaco-list-row:hover { outline: 1px dashed ${H.listHoverOutline}; outline-offset: -1px; }`),H.scrollbarShadowColor&&W.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${H.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${H.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${H.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),H.scrollbarSliderBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${H.scrollbarSliderBackgroundColor};
				}
			`),H.scrollbarSliderHoverBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${H.scrollbarSliderHoverBackgroundColor};
				}
			`),H.scrollbarSliderActiveBackgroundColor&&W.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${H.scrollbarSliderActiveBackgroundColor};
				}
			`),j.textContent=W.join(`
`),H.color&&(document.body.style.color=H.color)}l(H,j){const W=[],ee=Number(H.pid);j&&(W.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(ee,"SIGTERM")}}),W.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(ee,"SIGKILL")}}),W.push({type:"separator"})),W.push({label:(0,y.localize)(6,null),click:()=>{const ne=this.n();ne?.includes(ee)||(ne.length=0,ne.push(ee));const re=ne?.map(ce=>document.getElementById(`pid-${ce}`)).filter(ce=>!!ce);if(re){const ce=re.map(he=>he.innerText).filter(he=>!!he);this.c.writeClipboardText(ce.join(`
`))}}}),W.push({label:(0,y.localize)(7,null),click:()=>{const ne=document.getElementById("process-list");ne&&this.c.writeClipboardText(ne.innerText)}}),H&&j&&this.i(H.cmd)&&(W.push({type:"separator"}),W.push({label:(0,y.localize)(8,null),click:()=>{this.j(H)}})),(0,D.$KS)(W)}m(H){setTimeout(()=>{const j=Date.now(),W=H+j-this.a;this.a=j,W>1e3?(v.$M.send("vscode:pidToNameRequest"),v.$M.send("vscode:listProcesses")):this.m(W)},200)}n(){return this.d?.getSelection()?.map(H=>{if(!(!H||!("pid"in H)))return H.pid}).filter(H=>!!H)}}function p(){const M=(0,S.$OO)();M.id="codiconStyles";const H=(0,r.$hzb)(void 0);function j(){M.textContent=H.getCSS()}const W=new U.$Qg(j,0);H.onDidChange(()=>W.schedule()),W.schedule()}function N(M){const H=M.data.platform==="win32"?"windows":M.data.platform==="linux"?"linux":"mac";document.body.classList.add(H),p(),(0,h.$76b)(M.data.zoomLevel),new m(M.windowId,M.data)}t.startup=N})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03671d332bf6a34782d5adc64086bc8e083a1590/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
