/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(be){for(var e=[],C=0,T=be.length;C<T;C++)e[C]=De[be[C]];return e};define(De[156],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class C{static get(){const f=new Map,R=new Map,A=new Map,m=new Map;function S(k,D){k.has(D.detail)||k.set(D.detail,-D.timestamp)}function $(k,D){const y=k.get(D.detail);y&&(y>=0||k.set(D.detail,y+D.timestamp))}let P=[];typeof be=="function"&&typeof be.getStats=="function"&&(P=be.getStats().slice(0).sort((k,D)=>k.timestamp-D.timestamp));for(const k of P)switch(k.type){case 10:S(f,k);break;case 11:case 12:$(f,k);break;case 21:S(R,k);break;case 22:$(R,k);break;case 33:S(A,k);break;case 34:$(A,k);break;case 31:S(m,k);break;case 32:$(m,k);break}let I=0;A.forEach(k=>I+=k);function p(k){const D=[];return k.forEach((y,r)=>D.push([r,y])),D}return{amdLoad:p(f),amdInvoke:p(R),nodeRequire:p(A),nodeEval:p(m),nodeRequireTotal:I}}static toMarkdownTable(f,R){let A="";const m=[];return f.forEach((S,$)=>{m[$]=S.length}),R.forEach(S=>{S.forEach(($,P)=>{typeof $>"u"&&($=S[P]="-");const I=$.toString().length;m[P]=Math.max(I,m[P])})}),f.forEach((S,$)=>{A+=`| ${S+" ".repeat(m[$]-S.toString().length)} `}),A+=`|
`,f.forEach((S,$)=>{A+=`| ${"-".repeat(m[$])} `}),A+=`|
`,R.forEach(S=>{S.forEach(($,P)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(m[P]-$.toString().length)} `)}),A+=`|
`}),A}}e.$S=C}),define(De[118],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=void 0;function C(y,r,i){const s=T(y,r);if(s!==-1)return y[s]}e.$_e=C;function T(y,r,i=y.length-1){for(let s=i;s>=0;s--){const d=y[s];if(r(d))return s}return-1}e.$af=T;function f(y,r){const i=R(y,r);return i===-1?void 0:y[i]}e.$bf=f;function R(y,r,i=0,s=y.length){let d=i,b=s;for(;d<b;){const g=Math.floor((d+b)/2);r(y[g])?d=g+1:b=g}return d-1}e.$cf=R;function A(y,r){const i=m(y,r);return i===y.length?void 0:y[i]}e.$df=A;function m(y,r,i=0,s=y.length){let d=i,b=s;for(;d<b;){const g=Math.floor((d+b)/2);r(y[g])?b=g:d=g+1}return d}e.$ef=m;function S(y,r,i=0,s=y.length){const d=m(y,r,i,s);return d===y.length?-1:d}e.$ff=S;class ${static{this.assertInvariants=!1}constructor(r){this.e=r,this.c=0}findLastMonotonous(r){if($.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!r(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=r}const i=R(this.e,r,this.c);return this.c=i+1,i===-1?void 0:this.e[i]}}e.$gf=$;function P(y,r){if(y.length===0)return;let i=y[0];for(let s=1;s<y.length;s++){const d=y[s];r(d,i)>0&&(i=d)}return i}e.$hf=P;function I(y,r){if(y.length===0)return;let i=y[0];for(let s=1;s<y.length;s++){const d=y[s];r(d,i)>=0&&(i=d)}return i}e.$if=I;function p(y,r){return P(y,(i,s)=>-r(i,s))}e.$jf=p;function k(y,r){if(y.length===0)return-1;let i=0;for(let s=1;s<y.length;s++){const d=y[s];r(d,y[i])>0&&(i=s)}return i}e.$kf=k;function D(y,r){for(const i of y){const s=r(i);if(s!==void 0)return s}}e.$lf=D}),define(De[73],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function C(A,m){const S=Object.create(null);for(const $ of A){const P=m($);let I=S[P];I||(I=S[P]=[]),I.push($)}return S}e.$I=C;function T(A,m){const S=[],$=[];for(const P of A)m.has(P)||S.push(P);for(const P of m)A.has(P)||$.push(P);return{removed:S,added:$}}e.$J=T;function f(A,m){const S=[],$=[];for(const[P,I]of A)m.has(P)||S.push(I);for(const[P,I]of m)A.has(P)||$.push(I);return{removed:S,added:$}}e.$K=f;class R{constructor(){this.a=new Map}add(m,S){let $=this.a.get(m);$||($=new Set,this.a.set(m,$)),$.add(S)}delete(m,S){const $=this.a.get(m);$&&($.delete(S),$.size===0&&this.a.delete(m))}forEach(m,S){const $=this.a.get(m);$&&$.forEach(S)}get(m){const S=this.a.get(m);return S||new Set}}e.$L=R}),define(De[56],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6g=e.$5g=e.$4g=void 0;function C(A){return(m,S,$)=>{let P=null,I=null;if(typeof $.value=="function"?(P="value",I=$.value):typeof $.get=="function"&&(P="get",I=$.get),!I)throw new Error("not supported");$[P]=A(I,S)}}function T(A,m,S){let $=null,P=null;if(typeof S.value=="function"?($="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&($="get",P=S.get),!P)throw new Error("not supported");const I=`$memoize$${m}`;S[$]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[I]}}e.$4g=T;function f(A,m,S){return C(($,P)=>{const I=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...k){this[p]||(this[p]=S?S():void 0),clearTimeout(this[I]),m&&(this[p]=m(this[p],...k),k=[this[p]]),this[I]=setTimeout(()=>{$.apply(this,k),this[p]=S?S():void 0},A)}})}e.$5g=f;function R(A,m,S){return C(($,P)=>{const I=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,k=`$throttle$lastRun$${P}`,D=`$throttle$pending$${P}`;return function(...y){if(this[p]||(this[p]=S?S():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),m&&(this[p]=m(this[p],...y)),this[D])return;const r=this[k]+A;r<=Date.now()?(this[k]=Date.now(),$.apply(this,[this[p]]),this[p]=S?S():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[k]=Date.now(),$.apply(this,[this[p]]),this[p]=S?S():void 0},r-Date.now()))}})}e.$6g=R}),define(De[8],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=C,e.$V=new C;function T(g){e.$V.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=T;function f(g){if(!g||typeof g!="object")return!1;const t=g;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=f;function R(g){$(g)||e.$V.onUnexpectedError(g)}e.$Y=R;function A(g){$(g)||e.$V.onUnexpectedExternalError(g)}e.$Z=A;function m(g){if(g instanceof Error){const{name:t,message:o}=g,c=g.stacktrace||g.stack;return{$isError:!0,name:t,message:o,stack:c,noTelemetry:d.isErrorNoTelemetry(g)}}return g}e.$1=m;const S="Canceled";function $(g){return g instanceof P?!0:g instanceof Error&&g.name===S&&g.message===S}e.$2=$;class P extends Error{constructor(){super(S),this.name=this.message}}e.$3=P;function I(){const g=new Error(S);return g.name=g.message,g}e.$4=I;function p(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.$5=p;function k(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.$6=k;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=D;function y(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.$8=y;class r extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=r;class i extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=i;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=s;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const o=new d;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=d;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$ab=b}),define(De[19],Ce([1,0,8,118]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.CompareResult=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.top=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=void 0;function f(G,ce=0){return G[G.length-(1+ce)]}e.$mf=f;function R(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.$nf=R;function A(G,ce,re=(de,Ee)=>de===Ee){if(G===ce)return!0;if(!G||!ce||G.length!==ce.length)return!1;for(let de=0,Ee=G.length;de<Ee;de++)if(!re(G[de],ce[de]))return!1;return!0}e.$of=A;function m(G,ce){const re=G.length-1;ce<re&&(G[ce]=G[re]),G.pop()}e.$pf=m;function S(G,ce,re){return $(G.length,de=>re(G[de],ce))}e.$qf=S;function $(G,ce){let re=0,de=G-1;for(;re<=de;){const Ee=(re+de)/2|0,he=ce(Ee);if(he<0)re=Ee+1;else if(he>0)de=Ee-1;else return Ee}return-(re+1)}e.$rf=$;function P(G,ce,re){if(G=G|0,G>=ce.length)throw new TypeError("invalid index");const de=ce[Math.floor(ce.length*Math.random())],Ee=[],he=[],ge=[];for(const ne of ce){const ue=re(ne,de);ue<0?Ee.push(ne):ue>0?he.push(ne):ge.push(ne)}return G<Ee.length?P(G,Ee,re):G<Ee.length+ge.length?ge[0]:P(G-(Ee.length+ge.length),he,re)}e.$sf=P;function I(G,ce){const re=[];let de;for(const Ee of G.slice(0).sort(ce))!de||ce(de[0],Ee)!==0?(de=[Ee],re.push(de)):de.push(Ee);return re}e.$tf=I;function*p(G,ce){let re,de;for(const Ee of G)de!==void 0&&ce(de,Ee)?re.push(Ee):(re&&(yield re),re=[Ee]),de=Ee;re&&(yield re)}e.$uf=p;function k(G,ce){for(let re=0;re<=G.length;re++)ce(re===0?void 0:G[re-1],re===G.length?void 0:G[re])}e.$vf=k;function D(G,ce,re){const de=[];function Ee(ne,ue,we){if(ue===0&&we.length===0)return;const Pe=de[de.length-1];Pe&&Pe.start+Pe.deleteCount===ne?(Pe.deleteCount+=ue,Pe.toInsert.push(...we)):de.push({start:ne,deleteCount:ue,toInsert:we})}let he=0,ge=0;for(;;){if(he===G.length){Ee(he,0,ce.slice(ge));break}if(ge===ce.length){Ee(he,G.length-he,[]);break}const ne=G[he],ue=ce[ge],we=re(ne,ue);we===0?(he+=1,ge+=1):we<0?(Ee(he,1,[]),he+=1):we>0&&(Ee(he,0,[ue]),ge+=1)}return de}e.$wf=D;function y(G,ce,re){const de=D(G,ce,re),Ee=[],he=[];for(const ge of de)Ee.push(...G.slice(ge.start,ge.start+ge.deleteCount)),he.push(...ge.toInsert);return{removed:Ee,added:he}}e.$xf=y;function r(G,ce,re){if(re===0)return[];const de=G.slice(0,re).sort(ce);return s(G,ce,de,re,G.length),de}e.top=r;function i(G,ce,re,de,Ee){return re===0?Promise.resolve([]):new Promise((he,ge)=>{(async()=>{const ne=G.length,ue=G.slice(0,re).sort(ce);for(let we=re,Pe=Math.min(re+de,ne);we<ne;we=Pe,Pe=Math.min(Pe+de,ne)){if(we>re&&await new Promise(B=>setTimeout(B)),Ee&&Ee.isCancellationRequested)throw new C.$3;s(G,ce,ue,we,Pe)}return ue})().then(he,ge)})}e.$zf=i;function s(G,ce,re,de,Ee){for(const he=re.length;de<Ee;de++){const ge=G[de];if(ce(ge,re[he-1])<0){re.pop();const ne=(0,T.$ef)(re,ue=>ce(ge,ue)<0);re.splice(ne,0,ge)}}}function d(G){return G.filter(ce=>!!ce)}e.$Af=d;function b(G){let ce=0;for(let re=0;re<G.length;re++)G[re]&&(G[ce]=G[re],ce+=1);G.length=ce}e.$Bf=b;function g(G,ce,re){G.splice(re,0,G.splice(ce,1)[0])}e.$Cf=g;function t(G){return!Array.isArray(G)||G.length===0}e.$Df=t;function o(G){return Array.isArray(G)&&G.length>0}e.$Ef=o;function c(G,ce=re=>re){const re=new Set;return G.filter(de=>{const Ee=ce(de);return re.has(Ee)?!1:(re.add(Ee),!0)})}e.$Ff=c;function n(G){const ce=new Set;return re=>{const de=G(re);return ce.has(de)?!1:(ce.add(de),!0)}}e.$Gf=n;function a(G,ce){return G.length>0?G[0]:ce}e.$Hf=a;function l(G,ce){return G.length>0?G[G.length-1]:ce}e.$If=l;function v(G,ce,re=(de,Ee)=>de===Ee){let de=0;for(let Ee=0,he=Math.min(G.length,ce.length);Ee<he&&re(G[Ee],ce[Ee]);Ee++)de++;return de}e.$Jf=v;function E(G){return[].concat(...G)}e.$Kf=E;function u(G,ce){let re=typeof ce=="number"?G:0;typeof ce=="number"?re=G:(re=0,ce=G);const de=[];if(re<=ce)for(let Ee=re;Ee<ce;Ee++)de.push(Ee);else for(let Ee=re;Ee>ce;Ee--)de.push(Ee);return de}e.$Lf=u;function h(G,ce,re){return G.reduce((de,Ee)=>(de[ce(Ee)]=re?re(Ee):Ee,de),Object.create(null))}e.$Mf=h;function w(G,ce){return G.push(ce),()=>L(G,ce)}e.$Nf=w;function L(G,ce){const re=G.indexOf(ce);if(re>-1)return G.splice(re,1),ce}e.$Of=L;function O(G,ce,re){const de=G.slice(0,ce),Ee=G.slice(ce);return de.concat(re,Ee)}e.$Pf=O;function N(G,ce){let re;if(typeof ce=="number"){let de=ce;re=()=>{const Ee=Math.sin(de++)*179426549;return Ee-Math.floor(Ee)}}else re=Math.random;for(let de=G.length-1;de>0;de-=1){const Ee=Math.floor(re()*(de+1)),he=G[de];G[de]=G[Ee],G[Ee]=he}}e.$Qf=N;function M(G,ce){const re=G.indexOf(ce);re>-1&&(G.splice(re,1),G.unshift(ce))}e.$Rf=M;function z(G,ce){const re=G.indexOf(ce);re>-1&&(G.splice(re,1),G.push(ce))}e.$Sf=z;function j(G,ce){for(const re of ce)G.push(re)}e.$Tf=j;function F(G,ce){return Array.isArray(G)?G.map(ce):ce(G)}e.$Uf=F;function K(G){return Array.isArray(G)?G:[G]}e.$Vf=K;function H(G){return G[Math.floor(Math.random()*G.length)]}e.$Wf=H;function $e(G,ce,re){const de=Q(G,ce),Ee=G.length,he=re.length;G.length=Ee+he;for(let ge=Ee-1;ge>=de;ge--)G[ge+he]=G[ge];for(let ge=0;ge<he;ge++)G[ge+de]=re[ge]}e.$Xf=$e;function _(G,ce,re,de){const Ee=Q(G,ce);let he=G.splice(Ee,re);return he===void 0&&(he=[]),$e(G,Ee,de),he}e.$Yf=_;function Q(G,ce){return ce<0?Math.max(ce+G.length,0):Math.min(ce,G.length)}var V;(function(G){function ce(he){return he<0}G.isLessThan=ce;function re(he){return he<=0}G.isLessThanOrEqual=re;function de(he){return he>0}G.isGreaterThan=de;function Ee(he){return he===0}G.isNeitherLessOrGreaterThan=Ee,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function ee(G,ce){return(re,de)=>ce(G(re),G(de))}e.$Zf=ee;function me(...G){return(ce,re)=>{for(const de of G){const Ee=de(ce,re);if(!V.isNeitherLessOrGreaterThan(Ee))return Ee}return V.neitherLessOrGreaterThan}}e.$1f=me;const ae=(G,ce)=>G-ce;e.$2f=ae;const te=(G,ce)=>(0,e.$2f)(G?1:0,ce?1:0);e.$3f=te;function X(G){return(ce,re)=>-G(ce,re)}e.$4f=X;class U{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let re=this.c;for(;re<this.g.length&&ce(this.g[re]);)re++;const de=re===this.c?null:this.g.slice(this.c,re);return this.c=re,de}takeFromEndWhile(ce){let re=this.d;for(;re>=0&&ce(this.g[re]);)re--;const de=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,de}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const re=this.g.slice(this.c,this.c+ce);return this.c+=ce,re}}e.$5f=U;class q{static{this.empty=new q(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(re=>(ce(re),!0))}toArray(){const ce=[];return this.iterate(re=>(ce.push(re),!0)),ce}filter(ce){return new q(re=>this.iterate(de=>ce(de)?re(de):!0))}map(ce){return new q(re=>this.iterate(de=>re(ce(de))))}some(ce){let re=!1;return this.iterate(de=>(re=ce(de),!re)),re}findFirst(ce){let re;return this.iterate(de=>ce(de)?(re=de,!1):!0),re}findLast(ce){let re;return this.iterate(de=>(ce(de)&&(re=de),!0)),re}findLastMaxBy(ce){let re,de=!0;return this.iterate(Ee=>((de||V.isGreaterThan(ce(Ee,re)))&&(de=!1,re=Ee),!0)),re}}e.$6f=q}),define(De[57],Ce([1,0,8]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ab=e.$zb=e.$yb=e.$xb=e.ok=void 0;function T(S,$){if(!S)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=T;function f(S,$="Unreachable"){throw new Error($)}e.$xb=f;function R(S){if(!S)throw new C.$ab("Assertion Failed")}e.$yb=R;function A(S){if(!S()){debugger;S(),(0,C.$Y)(new C.$ab("Assertion Failed"))}}e.$zb=A;function m(S,$){let P=0;for(;P<S.length-1;){const I=S[P],p=S[P+1];if(!$(I,p))return!1;P++}return!0}e.$Ab=m}),define(De[74],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function C(T){const f=this;let R=!1,A;return function(){return R||(R=!0,A=T.apply(f,arguments)),A}}e.$bb=C}),define(De[119],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$ZL=C,e.$1L=new C("id#")}),define(De[50],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(T){function f(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}T.is=f;const R=Object.freeze([]);function A(){return R}T.empty=A;function*m(b){yield b}T.single=m;function S(b){return f(b)?b:m(b)}T.wrap=S;function $(b){return b||R}T.from=$;function P(b){return!b||b[Symbol.iterator]().next().done===!0}T.isEmpty=P;function I(b){return b[Symbol.iterator]().next().value}T.first=I;function p(b,g){for(const t of b)if(g(t))return!0;return!1}T.some=p;function k(b,g){for(const t of b)if(g(t))return t}T.find=k;function*D(b,g){for(const t of b)g(t)&&(yield t)}T.filter=D;function*y(b,g){let t=0;for(const o of b)yield g(o,t++)}T.map=y;function*r(...b){for(const g of b)for(const t of g)yield t}T.concat=r;function i(b,g,t){let o=t;for(const c of b)o=g(o,c);return o}T.reduce=i;function*s(b,g,t=b.length){for(g<0&&(g+=b.length),t<0?t+=b.length:t>b.length&&(t=b.length);g<t;g++)yield b[g]}T.slice=s;function d(b,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,b];const o=b[Symbol.iterator]();for(let c=0;c<g;c++){const n=o.next();if(n.done)return[t,T.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return o}}]}T.consume=d})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,o=!1){let c=0;const n=t.length;let a="",l=0,v=16,E=0;function u(z){let j=0,F=0;for(;j<z;){const K=t.charCodeAt(c);if(K>=48&&K<=57)F=F*16+K-48;else if(K>=65&&K<=70)F=F*16+K-65+10;else if(K>=97&&K<=102)F=F*16+K-97+10;else break;c++,j++}return j<z&&(F=-1),F}function h(z){c=z,a="",l=0,v=16,E=0}function w(){const z=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&$(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&$(t.charCodeAt(c)))for(c++;c<t.length&&$(t.charCodeAt(c));)c++;else return E=3,t.substring(z,c);let j=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&$(t.charCodeAt(c))){for(c++;c<t.length&&$(t.charCodeAt(c));)c++;j=c}else E=3;return t.substring(z,j)}function L(){let z="",j=c;for(;;){if(c>=n){z+=t.substring(j,c),E=2;break}const F=t.charCodeAt(c);if(F===34){z+=t.substring(j,c),c++;break}if(F===92){if(z+=t.substring(j,c),c++,c>=n){E=2;break}switch(t.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const H=u(4);H>=0?z+=String.fromCharCode(H):E=4;break}default:E=5}j=c;continue}if(F>=0&&F<=31)if(S(F)){z+=t.substring(j,c),E=2;break}else E=6;c++}return z}function O(){if(a="",E=0,l=c,c>=n)return l=n,v=17;let z=t.charCodeAt(c);if(m(z)){do c++,a+=String.fromCharCode(z),z=t.charCodeAt(c);while(m(z));return v=15}if(S(z))return c++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(c)===10&&(c++,a+=`
`),v=14;switch(z){case 123:return c++,v=1;case 125:return c++,v=2;case 91:return c++,v=3;case 93:return c++,v=4;case 58:return c++,v=6;case 44:return c++,v=5;case 34:return c++,a=L(),v=10;case 47:{const j=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<n&&!S(t.charCodeAt(c));)c++;return a=t.substring(j,c),v=12}if(t.charCodeAt(c+1)===42){c+=2;const F=n-1;let K=!1;for(;c<F;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,E=1),a=t.substring(j,c),v=13}return a+=String.fromCharCode(z),c++,v=16}case 45:if(a+=String.fromCharCode(z),c++,c===n||!$(t.charCodeAt(c)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=w(),v=11;default:for(;c<n&&N(z);)c++,z=t.charCodeAt(c);if(l!==c){switch(a=t.substring(l,c),a){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return a+=String.fromCharCode(z),c++,v=16}}function N(z){if(m(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:h,getPosition:()=>c,scan:o?M:O,getToken:()=>v,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>c-l,getTokenError:()=>E}}e.$Hm=A;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function I(t,o){const c=[],n=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function E(u,h,w,L){l.value=u,l.offset=h,l.length=w,l.type=L,l.colonOffset=void 0,a=l}try{d(t,{onObjectBegin:(u,h)=>{if(o<=u)throw n;a=void 0,v=o>u,c.push("")},onObjectProperty:(u,h,w)=>{if(o<h||(E(u,h,w,"property"),c[c.length-1]=u,o<=h+w))throw n},onObjectEnd:(u,h)=>{if(o<=u)throw n;a=void 0,c.pop()},onArrayBegin:(u,h)=>{if(o<=u)throw n;a=void 0,c.push(0)},onArrayEnd:(u,h)=>{if(o<=u)throw n;a=void 0,c.pop()},onLiteralValue:(u,h,w)=>{if(o<h||(E(u,h,w,g(u)),o<=h+w))throw n},onSeparator:(u,h,w)=>{if(o<=h)throw n;if(u===":"&&a&&a.type==="property")a.colonOffset=h,v=!1,a=void 0;else if(u===","){const L=c[c.length-1];typeof L=="number"?c[c.length-1]=L+1:(v=!0,c[c.length-1]=""),a=void 0}}})}catch(u){if(u!==n)throw u}return{path:c,previousNode:a,isAtPropertyKey:v,matches:u=>{let h=0;for(let w=0;h<u.length&&w<c.length;w++)if(u[h]===c[w]||u[h]==="*")h++;else if(u[h]!=="**")return!1;return h===u.length}}}e.$Im=I;function p(t,o=[],c=R.DEFAULT){let n=null,a=[];const l=[];function v(u){Array.isArray(a)?a.push(u):n!==null&&(a[n]=u)}return d(t,{onObjectBegin:()=>{const u={};v(u),l.push(a),a=u,n=null},onObjectProperty:u=>{n=u},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const u=[];v(u),l.push(a),a=u,n=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:v,onError:(u,h,w)=>{o.push({error:u,offset:h,length:w})}},c),a[0]}e.$Jm=p;function k(t,o=[],c=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(u){n.type==="property"&&(n.length=u-n.offset,n=n.parent)}function l(u){return n.children.push(u),u}d(t,{onObjectBegin:u=>{n=l({type:"object",offset:u,length:-1,parent:n,children:[]})},onObjectProperty:(u,h,w)=>{n=l({type:"property",offset:h,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:u,offset:h,length:w,parent:n})},onObjectEnd:(u,h)=>{n.length=u+h-n.offset,n=n.parent,a(u+h)},onArrayBegin:(u,h)=>{n=l({type:"array",offset:u,length:-1,parent:n,children:[]})},onArrayEnd:(u,h)=>{n.length=u+h-n.offset,n=n.parent,a(u+h)},onLiteralValue:(u,h,w)=>{l({type:g(u),offset:h,length:w,parent:n,value:u}),a(h+w)},onSeparator:(u,h,w)=>{n.type==="property"&&(u===":"?n.colonOffset=h:u===","&&a(h))},onError:(u,h,w)=>{o.push({error:u,offset:h,length:w})}},c);const E=n.children[0];return E&&delete E.parent,E}e.$Km=k;function D(t,o){if(!t)return;let c=t;for(const n of o)if(typeof n=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let a=!1;for(const l of c.children)if(Array.isArray(l.children)&&l.children[0].value===n){c=l.children[1],a=!0;break}if(!a)return}else{const a=n;if(c.type!=="array"||a<0||!Array.isArray(c.children)||a>=c.children.length)return;c=c.children[a]}return c}e.$Lm=D;function y(t){if(!t.parent||!t.parent.children)return[];const o=y(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;o.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&o.push(c)}return o}e.$Mm=y;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const o=Object.create(null);for(const c of t.children){const n=c.children[1];n&&(o[c.children[0].value]=r(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Nm=r;function i(t,o,c=!1){return o>=t.offset&&o<t.offset+t.length||c&&o===t.offset+t.length}e.$Om=i;function s(t,o,c=!1){if(i(t,o,c)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=o;a++){const l=s(n[a],o,c);if(l)return l}return t}}e.$Pm=s;function d(t,o,c=R.DEFAULT){const n=A(t,!1);function a(me){return me?()=>me(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(me){return me?ae=>me(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=a(o.onObjectBegin),E=l(o.onObjectProperty),u=a(o.onObjectEnd),h=a(o.onArrayBegin),w=a(o.onArrayEnd),L=l(o.onLiteralValue),O=l(o.onSeparator),N=a(o.onComment),M=l(o.onError),z=c&&c.disallowComments,j=c&&c.allowTrailingComma;function F(){for(;;){const me=n.scan();switch(n.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:z||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(me){case 12:case 13:z?K(10):N();break;case 16:K(1);break;case 15:case 14:break;default:return me}}}function K(me,ae=[],te=[]){if(M(me),ae.length+te.length>0){let X=n.getToken();for(;X!==17;){if(ae.indexOf(X)!==-1){F();break}else if(te.indexOf(X)!==-1)break;X=F()}}}function H(me){const ae=n.getTokenValue();return me?L(ae):E(ae),F(),!0}function $e(){switch(n.getToken()){case 11:{let me=0;try{me=JSON.parse(n.getTokenValue()),typeof me!="number"&&(K(2),me=0)}catch{K(2)}L(me);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function _(){return n.getToken()!==10?(K(3,[],[2,5]),!1):(H(!1),n.getToken()===6?(O(":"),F(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Q(){v(),F();let me=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(me||K(4,[],[]),O(","),F(),n.getToken()===2&&j)break}else me&&K(6,[],[]);_()||K(4,[],[2,5]),me=!0}return u(),n.getToken()!==2?K(7,[2],[]):F(),!0}function V(){h(),F();let me=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(me||K(4,[],[]),O(","),F(),n.getToken()===4&&j)break}else me&&K(6,[],[]);ee()||K(4,[],[4,5]),me=!0}return w(),n.getToken()!==4?K(8,[4],[]):F(),!0}function ee(){switch(n.getToken()){case 3:return V();case 1:return Q();case 10:return H(!0);default:return $e()}}return F(),n.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(n.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$Qm=d;function b(t,o){const c=A(t),n=[];let a,l=0,v;do switch(v=c.getPosition(),a=c.scan(),a){case 12:case 13:case 17:l!==v&&n.push(t.substring(l,v)),o!==void 0&&n.push(c.getTokenValue().replace(/[^\r\n]/g,o)),l=c.getPosition();break}while(a!==17);return n.join("")}e.$Rm=b;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Sm=g}),define(De[58],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=C}),define(De[3],Ce([1,0,74,50]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=e.$cb=void 0;const f=!1;let R=null;function A(l){R=l}if(e.$cb=A,f){const l="__is_disposable_tracked__";A(new class{trackDisposable(v){const E=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[l]||console.log(E)},3e3)}setParent(v,E){if(v&&v!==s.None)try{v[l]=!0}catch{}}markAsDisposed(v){if(v&&v!==s.None)try{v[l]=!0}catch{}}markAsSingleton(v){}})}function m(l){return R?.trackDisposable(l),l}e.$db=m;function S(l){R?.markAsDisposed(l)}e.$eb=S;function $(l,v){R?.setParent(l,v)}function P(l,v){if(R)for(const E of l)R.setParent(E,v)}function I(l){return R?.markAsSingleton(l),l}e.$fb=I;function p(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.$gb=p;function k(l){if(T.Iterable.is(l)){const v=[];for(const E of l)if(E)try{E.dispose()}catch(u){v.push(u)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.$hb=k;function D(l){for(const v of l)p(v)&&v.dispose();return[]}e.$ib=D;function y(...l){const v=r(()=>k(l));return P(l,v),v}e.$jb=y;function r(l){const v=m({dispose:(0,C.$bb)(()=>{S(v),l()})});return v}e.$kb=r;class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(S(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{k(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return $(v,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}e.$lb=i;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,m(this),$(this.q,this)}dispose(){S(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$mb=s;class d{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&$(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&$(v,null),v}}e.$nb=d;class b{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$ob=b;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(v){let E=v;return this.unset=()=>E=void 0,this.isset=()=>E!==void 0,this.dispose=()=>{E&&(E(),E=void 0,S(this))},this}}e.$pb=g;class t{constructor(){this.a=new Map}acquire(v,...E){let u=this.a.get(v);u||(u={counter:0,object:this.b(v,...E)},this.a.set(v,u));const{object:h}=u,w=(0,C.$bb)(()=>{--u.counter===0&&(this.c(v,u.object),this.a.delete(v))});return u.counter++,{object:h,dispose:w}}}e.$qb=t;class o{constructor(v){this.a=v}async acquire(v,...E){const u=this.a.acquire(v,...E);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(h){throw u.dispose(),h}}}e.$rb=o;class c{constructor(v){this.object=v}dispose(){}}e.$sb=c;function n(l){const v=new i;try{l(v)}finally{v.dispose()}}e.$tb=n;class a{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,E,u=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this.a.get(v)?.dispose(),this.a.set(v,E)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$ub=a}),define(De[75],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vb=void 0;class C{static{this.Undefined=new C(void 0)}constructor(R){this.element=R,this.next=C.Undefined,this.prev=C.Undefined}}class T{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let R=this.a;for(;R!==C.Undefined;){const A=R.next;R.prev=C.Undefined,R.next=C.Undefined,R=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const m=new C(R);if(this.a===C.Undefined)this.a=m,this.b=m;else if(A){const $=this.b;this.b=m,m.prev=$,$.next=m}else{const $=this.a;this.a=m,m.next=$,$.prev=m}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(m))}}shift(){if(this.a!==C.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==C.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==C.Undefined&&R.next!==C.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===C.Undefined&&R.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):R.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):R.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==C.Undefined;)yield R.element,R=R.next}}e.$vb=T}),define(De[28],Ce([1,0]),function(be,e){"use strict";var C,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.Touch=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;function R(r,i,s){let d=r.get(i);return d===void 0&&(d=s,r.set(i,d)),d}e.$ui=R;function A(r){const i=[];return r.forEach((s,d)=>{i.push(`${d} => ${s}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.$vi=A;function m(r){const i=[];return r.forEach(s=>{i.push(s)}),`Set(${r.size}) {${i.join(", ")}}`}e.$wi=m;class S{constructor(i,s){this.uri=i,this.value=s}}class ${static{this.a=i=>i.toString()}constructor(i,s){this[C]="ResourceMap",i instanceof $?(this.b=new Map(i.b),this.c=s??$.a):(this.b=new Map,this.c=i??$.a)}set(i,s){return this.b.set(this.c(i),new S(i,s)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,s){typeof s<"u"&&(i=i.bind(s));for(const[d,b]of this.b)i(b.value,b.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.$xi=$;class P{constructor(i,s){this[T]="ResourceSet",!i||typeof i=="function"?this.a=new $(i):(this.a=new $(s),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,s){this.a.forEach((d,b)=>i.call(s,b,b,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$yi=P;var I;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class p{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,s=0){const d=this.a.get(i);if(d)return s!==0&&this.j(d,s),d.value}set(i,s,d=0){let b=this.a.get(i);if(b)b.value=s,d!==0&&this.j(b,d);else{switch(b={key:i,value:s,next:void 0,previous:void 0},d){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(i,b),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this.a.get(i);if(s)return this.a.delete(i),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,s){const d=this.e;let b=this.b;for(;b;){if(s?i.bind(s)(b.value,b.key,this):i(b.value,b.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const i=this,s=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.key,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return b}values(){const i=this,s=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:d.value,done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return b}entries(){const i=this,s=this.e;let d=this.b;const b={[Symbol.iterator](){return b},next(){if(i.e!==s)throw new Error("LinkedMap got modified during iteration.");if(d){const g={value:[d.key,d.value],done:!1};return d=d.next,g}else return{value:void 0,done:!0}}};return b}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this.b,d=this.size;for(;s&&d>i;)this.a.delete(s.key),s=s.next,d--;this.b=s,this.d=d,s&&(s.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const s=i.next,d=i.previous;if(!s||!d)throw new Error("Invalid list");s.previous=d,d.next=s}i.next=void 0,i.previous=void 0,this.e++}j(i,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this.b)return;const d=i.next,b=i.previous;i===this.c?(b.next=void 0,this.c=b):(d.previous=b,b.next=d),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(s===2){if(i===this.c)return;const d=i.next,b=i.previous;i===this.b?(d.previous=void 0,this.b=d):(d.previous=b,b.next=d),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((s,d)=>{i.push([d,s])}),i}fromJSON(i){this.clear();for(const[s,d]of i)this.set(s,d)}}e.$zi=p;class k extends p{constructor(i,s=1){super(),this.k=i,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ai=k;class D{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let s=this.a.get(i)||0;return s===0?!1:(s--,s===0?this.a.delete(i):this.a.set(i,s),!0)}has(i){return this.a.has(i)}}e.$Bi=D;class y{constructor(i){if(this.a=new Map,this.b=new Map,i)for(const[s,d]of i)this.set(s,d)}clear(){this.a.clear(),this.b.clear()}set(i,s){this.a.set(i,s),this.b.set(s,i)}get(i){return this.a.get(i)}getKey(i){return this.b.get(i)}delete(i){const s=this.a.get(i);return s===void 0?!1:(this.a.delete(i),this.b.delete(s),!0)}forEach(i,s){this.a.forEach((d,b)=>{i.call(s,d,b,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ci=y}),function(be,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(re,de){for(var Ee=0;Ee<de.length;Ee++){var he=de[Ee];he.enumerable=he.enumerable||!1,he.configurable=!0,"value"in he&&(he.writable=!0),Object.defineProperty(re,he.key,he)}}function C(re,de,Ee){return de&&e(re.prototype,de),Ee&&e(re,Ee),Object.defineProperty(re,"prototype",{writable:!1}),re}function T(re,de){if(re){if(typeof re=="string")return f(re,de);var Ee=Object.prototype.toString.call(re).slice(8,-1);if(Ee==="Object"&&re.constructor&&(Ee=re.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(re);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return f(re,de)}}function f(re,de){(de==null||de>re.length)&&(de=re.length);for(var Ee=0,he=new Array(de);Ee<de;Ee++)he[Ee]=re[Ee];return he}function R(re,de){var Ee=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(Ee)return(Ee=Ee.call(re)).next.bind(Ee);if(Array.isArray(re)||(Ee=T(re))||de&&re&&typeof re.length=="number"){Ee&&(re=Ee);var he=0;return function(){return he>=re.length?{done:!0}:{done:!1,value:re[he++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function m(re){be.defaults=re}var S=/[&<>"']/,$=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(de){return p[de]};function D(re,de){if(de){if(S.test(re))return re.replace($,k)}else if(P.test(re))return re.replace(I,k);return re}var y=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(re){return re.replace(y,function(de,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var i=/(^|[^\[])\^/g;function s(re,de){re=typeof re=="string"?re:re.source,de=de||"";var Ee={replace:function(ge,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),re=re.replace(ge,ne),Ee},getRegex:function(){return new RegExp(re,de)}};return Ee}var d=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(re,de,Ee){if(re){var he;try{he=decodeURIComponent(r(Ee)).replace(d,"").toLowerCase()}catch{return null}if(he.indexOf("javascript:")===0||he.indexOf("vbscript:")===0||he.indexOf("data:")===0)return null}de&&!b.test(Ee)&&(Ee=a(de,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},o=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(re,de){t[" "+re]||(o.test(re)?t[" "+re]=re+"/":t[" "+re]=u(re,"/",!0)),re=t[" "+re];var Ee=re.indexOf(":")===-1;return de.substring(0,2)==="//"?Ee?de:re.replace(c,"$1")+de:de.charAt(0)==="/"?Ee?de:re.replace(n,"$1")+de:re+de}var l={exec:function(){}};function v(re){for(var de=1,Ee,he;de<arguments.length;de++){Ee=arguments[de];for(he in Ee)Object.prototype.hasOwnProperty.call(Ee,he)&&(re[he]=Ee[he])}return re}function E(re,de){var Ee=re.replace(/\|/g,function(ne,ue,we){for(var Pe=!1,B=ue;--B>=0&&we[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),he=Ee.split(/ \|/),ge=0;if(he[0].trim()||he.shift(),he.length>0&&!he[he.length-1].trim()&&he.pop(),he.length>de)he.splice(de);else for(;he.length<de;)he.push("");for(;ge<he.length;ge++)he[ge]=he[ge].trim().replace(/\\\|/g,"|");return he}function u(re,de,Ee){var he=re.length;if(he===0)return"";for(var ge=0;ge<he;){var ne=re.charAt(he-ge-1);if(ne===de&&!Ee)ge++;else if(ne!==de&&Ee)ge++;else break}return re.slice(0,he-ge)}function h(re,de){if(re.indexOf(de[1])===-1)return-1;for(var Ee=re.length,he=0,ge=0;ge<Ee;ge++)if(re[ge]==="\\")ge++;else if(re[ge]===de[0])he++;else if(re[ge]===de[1]&&(he--,he<0))return ge;return-1}function w(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(re,de){if(de<1)return"";for(var Ee="";de>1;)de&1&&(Ee+=re),de>>=1,re+=re;return Ee+re}function O(re,de,Ee,he){var ge=de.href,ne=de.title?D(de.title):null,ue=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){he.state.inLink=!0;var we={type:"link",raw:Ee,href:ge,title:ne,text:ue,tokens:he.inlineTokens(ue)};return he.state.inLink=!1,we}return{type:"image",raw:Ee,href:ge,title:ne,text:D(ue)}}function N(re,de){var Ee=re.match(/^(\s+)(?:```)/);if(Ee===null)return de;var he=Ee[1];return de.split(`
`).map(function(ge){var ne=ge.match(/^\s+/);if(ne===null)return ge;var ue=ne[0];return ue.length>=he.length?ge.slice(he.length):ge}).join(`
`)}var M=function(){function re(Ee){this.options=Ee||be.defaults}var de=re.prototype;return de.space=function(he){var ge=this.rules.block.newline.exec(he);if(ge&&ge[0].length>0)return{type:"space",raw:ge[0]}},de.code=function(he){var ge=this.rules.block.code.exec(he);if(ge){var ne=ge[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ge[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:u(ne,`
`)}}},de.fences=function(he){var ge=this.rules.block.fences.exec(he);if(ge){var ne=ge[0],ue=N(ne,ge[3]||"");return{type:"code",raw:ne,lang:ge[2]?ge[2].trim():ge[2],text:ue}}},de.heading=function(he){var ge=this.rules.block.heading.exec(he);if(ge){var ne=ge[2].trim();if(/#$/.test(ne)){var ue=u(ne,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(ne=ue.trim())}return{type:"heading",raw:ge[0],depth:ge[1].length,text:ne,tokens:this.lexer.inline(ne)}}},de.hr=function(he){var ge=this.rules.block.hr.exec(he);if(ge)return{type:"hr",raw:ge[0]}},de.blockquote=function(he){var ge=this.rules.block.blockquote.exec(he);if(ge){var ne=ge[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ge[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},de.list=function(he){var ge=this.rules.block.list.exec(he);if(ge){var ne,ue,we,Pe,B,Z,x,se,Y,fe,ye,ze,We=ge[1].trim(),xe=We.length>1,Ye={type:"list",raw:"",ordered:xe,start:xe?+We.slice(0,-1):"",loose:!1,items:[]};We=xe?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=xe?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");he&&(ze=!1,!(!(ge=it.exec(he))||this.rules.block.hr.test(he)));){if(ne=ge[0],he=he.substring(ne.length),se=ge[2].split(`
`,1)[0],Y=he.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=se.trimLeft()):(Pe=ge[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=se.slice(Pe),Pe+=ge[1].length),Z=!1,!se&&/^ *$/.test(Y)&&(ne+=Y+`
`,he=he.substring(Y.length+1),ze=!0),!ze)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");he&&(fe=he.split(`
`,1)[0],se=fe,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(se)||Ve.test(se)||et.test(se)||Ae.test(he)));){if(se.search(/[^ ]/)>=Pe||!se.trim())ye+=`
`+se.slice(Pe);else if(!Z)ye+=`
`+se;else break;!Z&&!se.trim()&&(Z=!0),ne+=fe+`
`,he=he.substring(fe.length+1)}Ye.loose||(x?Ye.loose=!0:/\n *\n *$/.test(ne)&&(x=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(ye),ue&&(we=ue[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ue,checked:we,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Qe=Ye.items[B].tokens.filter(function(oe){return oe.type==="space"}),le=Qe.every(function(oe){for(var Ie=oe.raw.split(""),qe=0,je=R(Ie),Xe;!(Xe=je()).done;){var nt=Xe.value;if(nt===`
`&&(qe+=1),qe>1)return!0}return!1});!Ye.loose&&Qe.length&&le&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},de.html=function(he){var ge=this.rules.block.html.exec(he);if(ge){var ne={type:"html",raw:ge[0],pre:!this.options.sanitizer&&(ge[1]==="pre"||ge[1]==="script"||ge[1]==="style"),text:ge[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]);ne.type="paragraph",ne.text=ue,ne.tokens=this.lexer.inline(ue)}return ne}},de.def=function(he){var ge=this.rules.block.def.exec(he);if(ge){ge[3]&&(ge[3]=ge[3].substring(1,ge[3].length-1));var ne=ge[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ge[0],href:ge[2],title:ge[3]}}},de.table=function(he){var ge=this.rules.block.table.exec(he);if(ge){var ne={type:"table",header:E(ge[1]).map(function(x){return{text:x}}),align:ge[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ge[3]&&ge[3].trim()?ge[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ge[0];var ue=ne.align.length,we,Pe,B,Z;for(we=0;we<ue;we++)/^ *-+: *$/.test(ne.align[we])?ne.align[we]="right":/^ *:-+: *$/.test(ne.align[we])?ne.align[we]="center":/^ *:-+ *$/.test(ne.align[we])?ne.align[we]="left":ne.align[we]=null;for(ue=ne.rows.length,we=0;we<ue;we++)ne.rows[we]=E(ne.rows[we],ne.header.length).map(function(x){return{text:x}});for(ue=ne.header.length,Pe=0;Pe<ue;Pe++)ne.header[Pe].tokens=this.lexer.inline(ne.header[Pe].text);for(ue=ne.rows.length,Pe=0;Pe<ue;Pe++)for(Z=ne.rows[Pe],B=0;B<Z.length;B++)Z[B].tokens=this.lexer.inline(Z[B].text);return ne}}},de.lheading=function(he){var ge=this.rules.block.lheading.exec(he);if(ge)return{type:"heading",raw:ge[0],depth:ge[2].charAt(0)==="="?1:2,text:ge[1],tokens:this.lexer.inline(ge[1])}},de.paragraph=function(he){var ge=this.rules.block.paragraph.exec(he);if(ge){var ne=ge[1].charAt(ge[1].length-1)===`
`?ge[1].slice(0,-1):ge[1];return{type:"paragraph",raw:ge[0],text:ne,tokens:this.lexer.inline(ne)}}},de.text=function(he){var ge=this.rules.block.text.exec(he);if(ge)return{type:"text",raw:ge[0],text:ge[0],tokens:this.lexer.inline(ge[0])}},de.escape=function(he){var ge=this.rules.inline.escape.exec(he);if(ge)return{type:"escape",raw:ge[0],text:D(ge[1])}},de.tag=function(he){var ge=this.rules.inline.tag.exec(he);if(ge)return!this.lexer.state.inLink&&/^<a /i.test(ge[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ge[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]):ge[0]}},de.link=function(he){var ge=this.rules.inline.link.exec(he);if(ge){var ne=ge[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ue=u(ne.slice(0,-1),"\\");if((ne.length-ue.length)%2===0)return}else{var we=h(ge[2],"()");if(we>-1){var Pe=ge[0].indexOf("!")===0?5:4,B=Pe+ge[1].length+we;ge[2]=ge[2].substring(0,we),ge[0]=ge[0].substring(0,B).trim(),ge[3]=""}}var Z=ge[2],x="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);se&&(Z=se[1],x=se[3])}else x=ge[3]?ge[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(ne)?Z=Z.slice(1):Z=Z.slice(1,-1)),O(ge,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:x&&x.replace(this.rules.inline._escapes,"$1")},ge[0],this.lexer)}},de.reflink=function(he,ge){var ne;if((ne=this.rules.inline.reflink.exec(he))||(ne=this.rules.inline.nolink.exec(he))){var ue=(ne[2]||ne[1]).replace(/\s+/g," ");if(ue=ge[ue.toLowerCase()],!ue||!ue.href){var we=ne[0].charAt(0);return{type:"text",raw:we,text:we}}return O(ne,ue,ne[0],this.lexer)}},de.emStrong=function(he,ge,ne){ne===void 0&&(ne="");var ue=this.rules.inline.emStrong.lDelim.exec(he);if(ue&&!(ue[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=ue[1]||ue[2]||"";if(!we||we&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Pe=ue[0].length-1,B,Z,x=Pe,se=0,Y=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ge=ge.slice(-1*he.length+Pe);(ue=Y.exec(ge))!=null;)if(B=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!B){if(Z=B.length,ue[3]||ue[4]){x+=Z;continue}else if((ue[5]||ue[6])&&Pe%3&&!((Pe+Z)%3)){se+=Z;continue}if(x-=Z,!(x>0)){if(Z=Math.min(Z,Z+x+se),Math.min(Pe,Z)%2){var fe=he.slice(1,Pe+ue.index+Z);return{type:"em",raw:he.slice(0,Pe+ue.index+Z+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}var ye=he.slice(2,Pe+ue.index+Z-1);return{type:"strong",raw:he.slice(0,Pe+ue.index+Z+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},de.codespan=function(he){var ge=this.rules.inline.code.exec(he);if(ge){var ne=ge[2].replace(/\n/g," "),ue=/[^ ]/.test(ne),we=/^ /.test(ne)&&/ $/.test(ne);return ue&&we&&(ne=ne.substring(1,ne.length-1)),ne=D(ne,!0),{type:"codespan",raw:ge[0],text:ne}}},de.br=function(he){var ge=this.rules.inline.br.exec(he);if(ge)return{type:"br",raw:ge[0]}},de.del=function(he){var ge=this.rules.inline.del.exec(he);if(ge)return{type:"del",raw:ge[0],text:ge[2],tokens:this.lexer.inlineTokens(ge[2])}},de.autolink=function(he,ge){var ne=this.rules.inline.autolink.exec(he);if(ne){var ue,we;return ne[2]==="@"?(ue=D(this.options.mangle?ge(ne[1]):ne[1]),we="mailto:"+ue):(ue=D(ne[1]),we=ue),{type:"link",raw:ne[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},de.url=function(he,ge){var ne;if(ne=this.rules.inline.url.exec(he)){var ue,we;if(ne[2]==="@")ue=D(this.options.mangle?ge(ne[0]):ne[0]),we="mailto:"+ue;else{var Pe;do Pe=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Pe!==ne[0]);ue=D(ne[0]),ne[1]==="www."?we="http://"+ue:we=ue}return{type:"link",raw:ne[0],text:ue,href:we,tokens:[{type:"text",raw:ue,text:ue}]}}},de.inlineText=function(he,ge){var ne=this.rules.inline.text.exec(he);if(ne){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):D(ne[0]):ne[0]:ue=D(this.options.smartypants?ge(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ue}}},re}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=s(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=s(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=s(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=s(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=s(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=s(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=v({},z),z.gfm=v({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=s(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=s(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=v({},z.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:s(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=s(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=s(z._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=s(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=s(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=s(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=s(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=s(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=s(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=s(j.reflink).replace("label",j._label).replace("ref",z._label).getRegex(),j.nolink=s(j.nolink).replace("ref",z._label).getRegex(),j.reflinkSearch=s(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=v({},j),j.pedantic=v({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=v({},j.normal,{escape:s(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=s(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=v({},j.gfm,{br:s(j.br).replace("{2,}","*").getRegex(),text:s(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(re){var de="",Ee,he,ge=re.length;for(Ee=0;Ee<ge;Ee++)he=re.charCodeAt(Ee),Math.random()>.5&&(he="x"+he.toString(16)),de+="&#"+he+";";return de}var H=function(){function re(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||be.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var he={block:z.normal,inline:j.normal};this.options.pedantic?(he.block=z.pedantic,he.inline=j.pedantic):this.options.gfm&&(he.block=z.gfm,this.options.breaks?he.inline=j.breaks:he.inline=j.gfm),this.tokenizer.rules=he}re.lex=function(he,ge){var ne=new re(ge);return ne.lex(he)},re.lexInline=function(he,ge){var ne=new re(ge);return ne.inlineTokens(he)};var de=re.prototype;return de.lex=function(he){he=he.replace(/\r\n|\r/g,`
`),this.blockTokens(he,this.tokens);for(var ge;ge=this.inlineQueue.shift();)this.inlineTokens(ge.src,ge.tokens);return this.tokens},de.blockTokens=function(he,ge){var ne=this;ge===void 0&&(ge=[]),this.options.pedantic?he=he.replace(/\t/g,"    ").replace(/^ +$/gm,""):he=he.replace(/^( *)(\t+)/gm,function(x,se,Y){return se+"    ".repeat(Y.length)});for(var ue,we,Pe,B;he;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(x){return(ue=x.call({lexer:ne},he,ge))?(he=he.substring(ue.raw.length),ge.push(ue),!0):!1}))){if(ue=this.tokenizer.space(he)){he=he.substring(ue.raw.length),ue.raw.length===1&&ge.length>0?ge[ge.length-1].raw+=`
`:ge.push(ue);continue}if(ue=this.tokenizer.code(he)){he=he.substring(ue.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue);continue}if(ue=this.tokenizer.fences(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.heading(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.hr(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.blockquote(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.list(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.html(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.def(he)){he=he.substring(ue.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.lheading(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(Pe=he,this.options.extensions&&this.options.extensions.startBlock&&function(){var x=1/0,se=he.slice(1),Y=void 0;ne.options.extensions.startBlock.forEach(function(fe){Y=fe.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(x=Math.min(x,Y))}),x<1/0&&x>=0&&(Pe=he.substring(0,x+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(Pe))){we=ge[ge.length-1],B&&we.type==="paragraph"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue),B=Pe.length!==he.length,he=he.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(he)){he=he.substring(ue.raw.length),we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=`
`+ue.raw,we.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(ue);continue}if(he){var Z="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ge},de.inline=function(he,ge){return ge===void 0&&(ge=[]),this.inlineQueue.push({src:he,tokens:ge}),ge},de.inlineTokens=function(he,ge){var ne=this;ge===void 0&&(ge=[]);var ue,we,Pe,B=he,Z,x,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Z.index)+"["+L("a",Z[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Z.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;he;)if(x||(se=""),x=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ue=ye.call({lexer:ne},he,ge))?(he=he.substring(ue.raw.length),ge.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.tag(he)){he=he.substring(ue.raw.length),we=ge[ge.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(ue=this.tokenizer.link(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.reflink(he,this.tokens.links)){he=he.substring(ue.raw.length),we=ge[ge.length-1],we&&ue.type==="text"&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(ue=this.tokenizer.emStrong(he,B,se)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.codespan(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.br(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.del(he)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(ue=this.tokenizer.autolink(he,K)){he=he.substring(ue.raw.length),ge.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(he,K))){he=he.substring(ue.raw.length),ge.push(ue);continue}if(Pe=he,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=he.slice(1),We=void 0;ne.options.extensions.startInline.forEach(function(xe){We=xe.call({lexer:this},ze),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=he.substring(0,ye+1))}(),ue=this.tokenizer.inlineText(Pe,F)){he=he.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(se=ue.raw.slice(-1)),x=!0,we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=ue.raw,we.text+=ue.text):ge.push(ue);continue}if(he){var fe="Infinite loop on byte: "+he.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return ge},C(re,null,[{key:"rules",get:function(){return{block:z,inline:j}}}]),re}(),$e=function(){function re(Ee){this.options=Ee||be.defaults}var de=re.prototype;return de.code=function(he,ge,ne){var ue=(ge||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(he,ue);we!=null&&we!==he&&(ne=!0,he=we)}return he=he.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+D(ue,!0)+'">'+(ne?he:D(he,!0))+`</code></pre>
`:"<pre><code>"+(ne?he:D(he,!0))+`</code></pre>
`},de.blockquote=function(he){return`<blockquote>
`+he+`</blockquote>
`},de.html=function(he){return he},de.heading=function(he,ge,ne,ue){if(this.options.headerIds){var we=this.options.headerPrefix+ue.slug(ne);return"<h"+ge+' id="'+we+'">'+he+"</h"+ge+`>
`}return"<h"+ge+">"+he+"</h"+ge+`>
`},de.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},de.list=function(he,ge,ne){var ue=ge?"ol":"ul",we=ge&&ne!==1?' start="'+ne+'"':"";return"<"+ue+we+`>
`+he+"</"+ue+`>
`},de.listitem=function(he){return"<li>"+he+`</li>
`},de.checkbox=function(he){return"<input "+(he?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},de.paragraph=function(he){return"<p>"+he+`</p>
`},de.table=function(he,ge){return ge&&(ge="<tbody>"+ge+"</tbody>"),`<table>
<thead>
`+he+`</thead>
`+ge+`</table>
`},de.tablerow=function(he){return`<tr>
`+he+`</tr>
`},de.tablecell=function(he,ge){var ne=ge.header?"th":"td",ue=ge.align?"<"+ne+' align="'+ge.align+'">':"<"+ne+">";return ue+he+("</"+ne+`>
`)},de.strong=function(he){return"<strong>"+he+"</strong>"},de.em=function(he){return"<em>"+he+"</em>"},de.codespan=function(he){return"<code>"+he+"</code>"},de.br=function(){return this.options.xhtml?"<br/>":"<br>"},de.del=function(he){return"<del>"+he+"</del>"},de.link=function(he,ge,ne){if(he=g(this.options.sanitize,this.options.baseUrl,he),he===null)return ne;var ue='<a href="'+D(he)+'"';return ge&&(ue+=' title="'+ge+'"'),ue+=">"+ne+"</a>",ue},de.image=function(he,ge,ne){if(he=g(this.options.sanitize,this.options.baseUrl,he),he===null)return ne;var ue='<img src="'+he+'" alt="'+ne+'"';return ge&&(ue+=' title="'+ge+'"'),ue+=this.options.xhtml?"/>":">",ue},de.text=function(he){return he},re}(),_=function(){function re(){}var de=re.prototype;return de.strong=function(he){return he},de.em=function(he){return he},de.codespan=function(he){return he},de.del=function(he){return he},de.html=function(he){return he},de.text=function(he){return he},de.link=function(he,ge,ne){return""+ne},de.image=function(he,ge,ne){return""+ne},de.br=function(){return""},re}(),Q=function(){function re(){this.seen={}}var de=re.prototype;return de.serialize=function(he){return he.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},de.getNextSafeSlug=function(he,ge){var ne=he,ue=0;if(this.seen.hasOwnProperty(ne)){ue=this.seen[he];do ue++,ne=he+"-"+ue;while(this.seen.hasOwnProperty(ne))}return ge||(this.seen[he]=ue,this.seen[ne]=0),ne},de.slug=function(he,ge){ge===void 0&&(ge={});var ne=this.serialize(he);return this.getNextSafeSlug(ne,ge.dryrun)},re}(),V=function(){function re(Ee){this.options=Ee||be.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Q}re.parse=function(he,ge){var ne=new re(ge);return ne.parse(he)},re.parseInline=function(he,ge){var ne=new re(ge);return ne.parseInline(he)};var de=re.prototype;return de.parse=function(he,ge){ge===void 0&&(ge=!0);var ne="",ue,we,Pe,B,Z,x,se,Y,fe,ye,ze,We,xe,Ye,it,et,Ae,Ne,Ve,Le=he.length;for(ue=0;ue<Le;ue++){if(ye=he[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,r(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",se="",B=ye.header.length,we=0;we<B;we++)se+=this.renderer.tablecell(this.parseInline(ye.header[we].tokens),{header:!0,align:ye.align[we]});for(Y+=this.renderer.tablerow(se),fe="",B=ye.rows.length,we=0;we<B;we++){for(x=ye.rows[we],se="",Z=x.length,Pe=0;Pe<Z;Pe++)se+=this.renderer.tablecell(this.parseInline(x[Pe].tokens),{header:!1,align:ye.align[Pe]});fe+=this.renderer.tablerow(se)}ne+=this.renderer.table(Y,fe);continue}case"blockquote":{fe=this.parse(ye.tokens),ne+=this.renderer.blockquote(fe);continue}case"list":{for(ze=ye.ordered,We=ye.start,xe=ye.loose,B=ye.items.length,fe="",we=0;we<B;we++)it=ye.items[we],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,xe),fe+=this.renderer.listitem(Ye,Ae,et);ne+=this.renderer.list(fe,ze,We);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(fe=ye.tokens?this.parseInline(ye.tokens):ye.text;ue+1<Le&&he[ue+1].type==="text";)ye=he[++ue],fe+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ge?this.renderer.paragraph(fe):fe;continue}default:{var Qe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return ne},de.parseInline=function(he,ge){ge=ge||this.renderer;var ne="",ue,we,Pe,B=he.length;for(ue=0;ue<B;ue++){if(we=he[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Pe=this.options.extensions.renderers[we.type].call({parser:this},we),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){ne+=Pe||"";continue}switch(we.type){case"escape":{ne+=ge.text(we.text);break}case"html":{ne+=ge.html(we.text);break}case"link":{ne+=ge.link(we.href,we.title,this.parseInline(we.tokens,ge));break}case"image":{ne+=ge.image(we.href,we.title,we.text);break}case"strong":{ne+=ge.strong(this.parseInline(we.tokens,ge));break}case"em":{ne+=ge.em(this.parseInline(we.tokens,ge));break}case"codespan":{ne+=ge.codespan(we.text);break}case"br":{ne+=ge.br();break}case"del":{ne+=ge.del(this.parseInline(we.tokens,ge));break}case"text":{ne+=ge.text(we.text);break}default:{var Z='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return ne},re}();function ee(re,de,Ee){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof de=="function"&&(Ee=de,de=null),de=v({},ee.defaults,de||{}),w(de),Ee){var he=de.highlight,ge;try{ge=H.lex(re,de)}catch(B){return Ee(B)}var ne=function(Z){var x;if(!Z)try{de.walkTokens&&ee.walkTokens(ge,de.walkTokens),x=V.parse(ge,de)}catch(se){Z=se}return de.highlight=he,Z?Ee(Z):Ee(null,x)};if(!he||he.length<3||(delete de.highlight,!ge.length))return ne();var ue=0;ee.walkTokens(ge,function(B){B.type==="code"&&(ue++,setTimeout(function(){he(B.text,B.lang,function(Z,x){if(Z)return ne(Z);x!=null&&x!==B.text&&(B.text=x,B.escaped=!0),ue--,ue===0&&ne()})},0))}),ue===0&&ne();return}function we(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=H.lex(re,de);if(de.walkTokens){if(de.async)return Promise.all(ee.walkTokens(Pe,de.walkTokens)).then(function(){return V.parse(Pe,de)}).catch(we);ee.walkTokens(Pe,de.walkTokens)}return V.parse(Pe,de)}catch(B){we(B)}}ee.options=ee.setOptions=function(re){return v(ee.defaults,re),m(ee.defaults),ee},ee.getDefaults=A,ee.defaults=be.defaults,ee.use=function(){for(var re=arguments.length,de=new Array(re),Ee=0;Ee<re;Ee++)de[Ee]=arguments[Ee];var he=v.apply(void 0,[{}].concat(de)),ge=ee.defaults.extensions||{renderers:{},childTokens:{}},ne;de.forEach(function(ue){if(ue.extensions&&(ne=!0,ue.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=ge.renderers?ge.renderers[Pe.name]:null;B?ge.renderers[Pe.name]=function(){for(var Z=arguments.length,x=new Array(Z),se=0;se<Z;se++)x[se]=arguments[se];var Y=Pe.renderer.apply(this,x);return Y===!1&&(Y=B.apply(this,x)),Y}:ge.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Pe.level]?ge[Pe.level].unshift(Pe.tokenizer):ge[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?ge.startBlock?ge.startBlock.push(Pe.start):ge.startBlock=[Pe.start]:Pe.level==="inline"&&(ge.startInline?ge.startInline.push(Pe.start):ge.startInline=[Pe.start]))}Pe.childTokens&&(ge.childTokens[Pe.name]=Pe.childTokens)})),ue.renderer&&function(){var Pe=ee.defaults.renderer||new $e,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var fe=arguments.length,ye=new Array(fe),ze=0;ze<fe;ze++)ye[ze]=arguments[ze];var We=ue.renderer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var Z in ue.renderer)B(Z);he.renderer=Pe}(),ue.tokenizer&&function(){var Pe=ee.defaults.tokenizer||new M,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var fe=arguments.length,ye=new Array(fe),ze=0;ze<fe;ze++)ye[ze]=arguments[ze];var We=ue.tokenizer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var Z in ue.tokenizer)B(Z);he.tokenizer=Pe}(),ue.walkTokens){var we=ee.defaults.walkTokens;he.walkTokens=function(Pe){var B=[];return B.push(ue.walkTokens.call(this,Pe)),we&&(B=B.concat(we.call(this,Pe))),B}}ne&&(he.extensions=ge),ee.setOptions(he)})},ee.walkTokens=function(re,de){for(var Ee=[],he=function(){var we=ne.value;switch(Ee=Ee.concat(de.call(ee,we)),we.type){case"table":{for(var Pe=R(we.header),B;!(B=Pe()).done;){var Z=B.value;Ee=Ee.concat(ee.walkTokens(Z.tokens,de))}for(var x=R(we.rows),se;!(se=x()).done;)for(var Y=se.value,fe=R(Y),ye;!(ye=fe()).done;){var ze=ye.value;Ee=Ee.concat(ee.walkTokens(ze.tokens,de))}break}case"list":{Ee=Ee.concat(ee.walkTokens(we.items,de));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[we.type]?ee.defaults.extensions.childTokens[we.type].forEach(function(We){Ee=Ee.concat(ee.walkTokens(we[We],de))}):we.tokens&&(Ee=Ee.concat(ee.walkTokens(we.tokens,de)))}},ge=R(re),ne;!(ne=ge()).done;)he();return Ee},ee.parseInline=function(re,de){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");de=v({},ee.defaults,de||{}),w(de);try{var Ee=H.lexInline(re,de);return de.walkTokens&&ee.walkTokens(Ee,de.walkTokens),V.parseInline(Ee,de)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,de.silent)return"<p>An error occurred:</p><pre>"+D(he.message+"",!0)+"</pre>";throw he}},ee.Parser=V,ee.parser=V.parse,ee.Renderer=$e,ee.TextRenderer=_,ee.Lexer=H,ee.lexer=H.lex,ee.Tokenizer=M,ee.Slugger=Q,ee.parse=ee;var me=ee.options,ae=ee.setOptions,te=ee.use,X=ee.walkTokens,U=ee.parseInline,q=ee,G=V.parse,ce=H.lex;be.Lexer=H,be.Parser=V,be.Renderer=$e,be.Slugger=Q,be.TextRenderer=_,be.Tokenizer=M,be.getDefaults=A,be.lexer=ce,be.marked=ee,be.options=me,be.parse=q,be.parseInline=U,be.parser=G,be.setOptions=ae,be.use=te,be.walkTokens=X,Object.defineProperty(be,"__esModule",{value:!0})}),define(De[76],Ce([1,0,28]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=void 0;const T=new C.$Ai(1e4);function f($){return S($,"NFC",T)}e.$fl=f;const R=new C.$Ai(1e4);function A($){return S($,"NFD",R)}e.$gl=A;const m=/[^\u0000-\u0080]/;function S($,P,I){if(!$)return $;const p=I.get($);if(p)return p;let k;return m.test($)?k=$.normalize(P):k=$,I.set($,k),k}e.$hl=function(){const $=/[\u0300-\u036f]/g;return function(P){return A(P).replace($,"")}}()}),define(De[120],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.rot=e.$Fl=void 0;function C(m,S,$){return Math.min(Math.max(m,S),$)}e.$Fl=C;function T(m,S){return(S+m%S)%S}e.rot=T;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Hl=f;class R{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Il=R;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const $=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jl=A}),function(){function be(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function A(S){R.push(S,Date.now())}function m(){const S=[];for(let $=0;$<R.length;$+=2)S.push({name:R[$],startTime:R[$+1]});return S}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(f+A.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=C(T))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var T in C)(typeof exports=="object"?exports:be)[T]=C[T]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function C(T){if(e[T])return e[T].exports;var f=e[T]={i:T,l:!1,exports:{}};return be[T].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=be,C.c=e,C.d=function(T,f,R){C.o(T,f)||Object.defineProperty(T,f,{enumerable:!0,get:R})},C.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},C.t=function(T,f){if(1&f&&(T=C(T)),8&f||4&f&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&f&&typeof T!="string")for(var A in T)C.d(R,A,function(m){return T[m]}.bind(null,A));return R},C.n=function(T){var f=T&&T.__esModule?function(){return T.default}:function(){return T};return C.d(f,"a",f),f},C.o=function(T,f){return Object.prototype.hasOwnProperty.call(T,f)},C.p="",C(C.s=0)}([function(be,e,C){(function(T){var f;e=be.exports=te,f=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],S=e.src=[],$=0,P=$++;S[P]="0|[1-9]\\d*";var I=$++;S[I]="[0-9]+";var p=$++;S[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=$++;S[k]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var D=$++;S[D]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var y=$++;S[y]="(?:"+S[P]+"|"+S[p]+")";var r=$++;S[r]="(?:"+S[I]+"|"+S[p]+")";var i=$++;S[i]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var s=$++;S[s]="(?:-?("+S[r]+"(?:\\."+S[r]+")*))";var d=$++;S[d]="[0-9A-Za-z-]+";var b=$++;S[b]="(?:\\+("+S[d]+"(?:\\."+S[d]+")*))";var g=$++,t="v?"+S[k]+S[i]+"?"+S[b]+"?";S[g]="^"+t+"$";var o="[v=\\s]*"+S[D]+S[s]+"?"+S[b]+"?",c=$++;S[c]="^"+o+"$";var n=$++;S[n]="((?:<|>)?=?)";var a=$++;S[a]=S[I]+"|x|X|\\*";var l=$++;S[l]=S[P]+"|x|X|\\*";var v=$++;S[v]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[i]+")?"+S[b]+"?)?)?";var E=$++;S[E]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[s]+")?"+S[b]+"?)?)?";var u=$++;S[u]="^"+S[n]+"\\s*"+S[v]+"$";var h=$++;S[h]="^"+S[n]+"\\s*"+S[E]+"$";var w=$++;S[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=$++;S[L]="(?:~>?)";var O=$++;S[O]="(\\s*)"+S[L]+"\\s+",m[O]=new RegExp(S[O],"g");var N=$++;S[N]="^"+S[L]+S[v]+"$";var M=$++;S[M]="^"+S[L]+S[E]+"$";var z=$++;S[z]="(?:\\^)";var j=$++;S[j]="(\\s*)"+S[z]+"\\s+",m[j]=new RegExp(S[j],"g");var F=$++;S[F]="^"+S[z]+S[v]+"$";var K=$++;S[K]="^"+S[z]+S[E]+"$";var H=$++;S[H]="^"+S[n]+"\\s*("+o+")$|^$";var $e=$++;S[$e]="^"+S[n]+"\\s*("+t+")$|^$";var _=$++;S[_]="(\\s*)"+S[n]+"\\s*("+o+"|"+S[v]+")",m[_]=new RegExp(S[_],"g");var Q=$++;S[Q]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var V=$++;S[V]="^\\s*("+S[E]+")\\s+-\\s+("+S[E]+")\\s*$";var ee=$++;S[ee]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)f(me,S[me]),m[me]||(m[me]=new RegExp(S[me]));function ae(Y,fe){if(Y instanceof te)return Y;if(typeof Y!="string"||Y.length>R||!(fe?m[c]:m[g]).test(Y))return null;try{return new te(Y,fe)}catch{return null}}function te(Y,fe){if(Y instanceof te){if(Y.loose===fe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof te))return new te(Y,fe);f("SemVer",Y,fe),this.loose=fe;var ye=Y.trim().match(fe?m[c]:m[g]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<A)return We}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Y,fe){var ye=ae(Y,fe);return ye?ye.version:null},e.clean=function(Y,fe){var ye=ae(Y.trim().replace(/^[=v]+/,""),fe);return ye?ye.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(Y){return f("SemVer.compare",this.version,this.loose,Y),Y instanceof te||(Y=new te(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},te.prototype.compareMain=function(Y){return Y instanceof te||(Y=new te(Y,this.loose)),U(this.major,Y.major)||U(this.minor,Y.minor)||U(this.patch,Y.patch)},te.prototype.comparePre=function(Y){if(Y instanceof te||(Y=new te(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var fe=0;do{var ye=this.prerelease[fe],ze=Y.prerelease[fe];if(f("prerelease compare",fe,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return U(ye,ze)}while(++fe)},te.prototype.inc=function(Y,fe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,fe,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new te(Y,ye).inc(fe,ze).version}catch{return null}},e.diff=function(Y,fe){if(re(Y,fe))return null;var ye=ae(Y),ze=ae(fe);if(ye.prerelease.length||ze.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return We},e.compareIdentifiers=U;var X=/^[0-9]+$/;function U(Y,fe){var ye=X.test(Y),ze=X.test(fe);return ye&&ze&&(Y=+Y,fe=+fe),ye&&!ze?-1:ze&&!ye?1:Y<fe?-1:Y>fe?1:0}function q(Y,fe,ye){return new te(Y,ye).compare(new te(fe,ye))}function G(Y,fe,ye){return q(Y,fe,ye)>0}function ce(Y,fe,ye){return q(Y,fe,ye)<0}function re(Y,fe,ye){return q(Y,fe,ye)===0}function de(Y,fe,ye){return q(Y,fe,ye)!==0}function Ee(Y,fe,ye){return q(Y,fe,ye)>=0}function he(Y,fe,ye){return q(Y,fe,ye)<=0}function ge(Y,fe,ye,ze){var We;switch(fe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=re(Y,ye,ze);break;case"!=":We=de(Y,ye,ze);break;case">":We=G(Y,ye,ze);break;case">=":We=Ee(Y,ye,ze);break;case"<":We=ce(Y,ye,ze);break;case"<=":We=he(Y,ye,ze);break;default:throw new TypeError("Invalid operator: "+fe)}return We}function ne(Y,fe){if(Y instanceof ne){if(Y.loose===fe)return Y;Y=Y.value}if(!(this instanceof ne))return new ne(Y,fe);f("comparator",Y,fe),this.loose=fe,this.parse(Y),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(Y,fe){return U(fe,Y)},e.major=function(Y,fe){return new te(Y,fe).major},e.minor=function(Y,fe){return new te(Y,fe).minor},e.patch=function(Y,fe){return new te(Y,fe).patch},e.compare=q,e.compareLoose=function(Y,fe){return q(Y,fe,!0)},e.rcompare=function(Y,fe,ye){return q(fe,Y,ye)},e.sort=function(Y,fe){return Y.sort(function(ye,ze){return e.compare(ye,ze,fe)})},e.rsort=function(Y,fe){return Y.sort(function(ye,ze){return e.rcompare(ye,ze,fe)})},e.gt=G,e.lt=ce,e.eq=re,e.neq=de,e.gte=Ee,e.lte=he,e.cmp=ge,e.Comparator=ne;var ue={};function we(Y,fe){if(Y instanceof we)return Y.loose===fe?Y:new we(Y.raw,fe);if(Y instanceof ne)return new we(Y.value,fe);if(!(this instanceof we))return new we(Y,fe);if(this.loose=fe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,fe,ye,ze,We,xe,Ye,it,et,Ae,Ne,Ve,Le){return((fe=Pe(ye)?"":Pe(ze)?">="+ye+".0.0":Pe(We)?">="+ye+"."+ze+".0":">="+fe)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":Ve?"<="+et+"."+Ae+"."+Ne+"-"+Ve:"<="+it)).trim()}function Z(Y,fe){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(fe))return!1;if(fe.prerelease.length){for(ye=0;ye<Y.length;ye++)if(f(Y[ye].semver),Y[ye].semver!==ue&&Y[ye].semver.prerelease.length>0){var ze=Y[ye].semver;if(ze.major===fe.major&&ze.minor===fe.minor&&ze.patch===fe.patch)return!0}return!1}return!0}function x(Y,fe,ye){try{fe=new we(fe,ye)}catch{return!1}return fe.test(Y)}function se(Y,fe,ye,ze){var We,xe,Ye,it,et;switch(Y=new te(Y,ze),fe=new we(fe,ze),ye){case">":We=G,xe=he,Ye=ce,it=">",et=">=";break;case"<":We=ce,xe=Ee,Ye=G,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(x(Y,fe,ze))return!1;for(var Ae=0;Ae<fe.set.length;++Ae){var Ne=fe.set[Ae],Ve=null,Le=null;if(Ne.forEach(function(Qe){Qe.semver===ue&&(Qe=new ne(">=0.0.0")),Ve=Ve||Qe,Le=Le||Qe,We(Qe.semver,Ve.semver,ze)?Ve=Qe:Ye(Qe.semver,Le.semver,ze)&&(Le=Qe)}),Ve.operator===it||Ve.operator===et||(!Le.operator||Le.operator===it)&&xe(Y,Le.semver)||Le.operator===et&&Ye(Y,Le.semver))return!1}return!0}ne.prototype.parse=function(Y){var fe=this.loose?m[H]:m[$e],ye=Y.match(fe);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new te(ye[2],this.loose):this.semver=ue},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(Y){return f("Comparator.test",Y,this.loose),this.semver===ue||(typeof Y=="string"&&(Y=new te(Y,this.loose)),ge(Y,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(Y,fe){if(!(Y instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new we(Y.value,fe),x(this.value,ye,fe);if(Y.operator==="")return ye=new we(this.value,fe),x(Y.semver,ye,fe);var ze=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),xe=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=ge(this.semver,"<",Y.semver,fe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=ge(this.semver,">",Y.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return ze||We||xe&&Ye||it||et},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(Y){var fe=this.loose;Y=Y.trim(),f("range",Y,fe);var ye=fe?m[V]:m[Q];Y=Y.replace(ye,B),f("hyphen replace",Y),Y=Y.replace(m[_],"$1$2$3"),f("comparator trim",Y,m[_]),Y=(Y=(Y=Y.replace(m[O],"$1~")).replace(m[j],"$1^")).split(/\s+/).join(" ");var ze=fe?m[H]:m[$e],We=Y.split(" ").map(function(xe){return function(Ye,it){return f("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){f("caret",Ve,Le);var Qe=Le?m[K]:m[F];return Ve.replace(Qe,function(le,oe,Ie,qe,je){var Xe;return f("caret",Ve,le,oe,Ie,qe,je),Pe(oe)?Xe="":Pe(Ie)?Xe=">="+oe+".0.0 <"+(+oe+1)+".0.0":Pe(qe)?Xe=oe==="0"?">="+oe+"."+Ie+".0 <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+".0 <"+(+oe+1)+".0.0":je?(f("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=oe==="0"?Ie==="0"?">="+oe+"."+Ie+"."+qe+je+" <"+oe+"."+Ie+"."+(+qe+1):">="+oe+"."+Ie+"."+qe+je+" <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+"."+qe+je+" <"+(+oe+1)+".0.0"):(f("no pr"),Xe=oe==="0"?Ie==="0"?">="+oe+"."+Ie+"."+qe+" <"+oe+"."+Ie+"."+(+qe+1):">="+oe+"."+Ie+"."+qe+" <"+oe+"."+(+Ie+1)+".0":">="+oe+"."+Ie+"."+qe+" <"+(+oe+1)+".0.0"),f("caret return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),f("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){var Qe=Le?m[M]:m[N];return Ve.replace(Qe,function(le,oe,Ie,qe,je){var Xe;return f("tilde",Ve,le,oe,Ie,qe,je),Pe(oe)?Xe="":Pe(Ie)?Xe=">="+oe+".0.0 <"+(+oe+1)+".0.0":Pe(qe)?Xe=">="+oe+"."+Ie+".0 <"+oe+"."+(+Ie+1)+".0":je?(f("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Xe=">="+oe+"."+Ie+"."+qe+je+" <"+oe+"."+(+Ie+1)+".0"):Xe=">="+oe+"."+Ie+"."+qe+" <"+oe+"."+(+Ie+1)+".0",f("tilde return",Xe),Xe})}(Ne,Ae)}).join(" ")}(Ye,it),f("tildes",Ye),Ye=function(et,Ae){return f("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(Ve,Le){Ve=Ve.trim();var Qe=Le?m[h]:m[u];return Ve.replace(Qe,function(le,oe,Ie,qe,je,Xe){f("xRange",Ve,le,oe,Ie,qe,je,Xe);var nt=Pe(Ie),ot=nt||Pe(qe),bt=ot||Pe(je);return oe==="="&&bt&&(oe=""),nt?le=oe===">"||oe==="<"?"<0.0.0":"*":oe&&bt?(ot&&(qe=0),bt&&(je=0),oe===">"?(oe=">=",ot?(Ie=+Ie+1,qe=0,je=0):bt&&(qe=+qe+1,je=0)):oe==="<="&&(oe="<",ot?Ie=+Ie+1:qe=+qe+1),le=oe+Ie+"."+qe+"."+je):ot?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(le=">="+Ie+"."+qe+".0 <"+Ie+"."+(+qe+1)+".0"),f("xRange return",le),le})}(Ne,Ae)}).join(" ")}(Ye,it),f("xrange",Ye),Ye=function(et,Ae){return f("replaceStars",et,Ae),et.trim().replace(m[ee],"")}(Ye,it),f("stars",Ye),Ye}(xe,fe)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(xe){return!!xe.match(ze)})),We=We.map(function(xe){return new ne(xe,fe)})},we.prototype.intersects=function(Y,fe){if(!(Y instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return Y.set.some(function(We){return We.every(function(xe){return ze.intersects(xe,fe)})})})})},e.toComparators=function(Y,fe){return new we(Y,fe).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},we.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new te(Y,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Z(this.set[fe],Y))return!0;return!1},e.satisfies=x,e.maxSatisfying=function(Y,fe,ye){var ze=null,We=null;try{var xe=new we(fe,ye)}catch{return null}return Y.forEach(function(Ye){xe.test(Ye)&&(ze&&We.compare(Ye)!==-1||(We=new te(ze=Ye,ye)))}),ze},e.minSatisfying=function(Y,fe,ye){var ze=null,We=null;try{var xe=new we(fe,ye)}catch{return null}return Y.forEach(function(Ye){xe.test(Ye)&&(ze&&We.compare(Ye)!==1||(We=new te(ze=Ye,ye)))}),ze},e.validRange=function(Y,fe){try{return new we(Y,fe).range||"*"}catch{return null}},e.ltr=function(Y,fe,ye){return se(Y,fe,"<",ye)},e.gtr=function(Y,fe,ye){return se(Y,fe,">",ye)},e.outside=se,e.prerelease=function(Y,fe){var ye=ae(Y,fe);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,fe,ye){return Y=new we(Y,ye),fe=new we(fe,ye),Y.intersects(fe)},e.coerce=function(Y){if(Y instanceof te)return Y;if(typeof Y!="string")return null;var fe=Y.match(m[w]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,C(1))},function(be,e){var C,T,f=be.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(r){if(C===setTimeout)return setTimeout(r,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var S,$=[],P=!1,I=-1;function p(){P&&S&&(P=!1,S.length?$=S.concat($):I=-1,$.length&&k())}function k(){if(!P){var r=m(p);P=!0;for(var i=$.length;i;){for(S=$,$=[];++I<i;)S&&S[I].run();I=-1,i=$.length}S=null,P=!1,function(s){if(T===clearTimeout)return clearTimeout(s);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(s);try{T(s)}catch{try{return T.call(null,s)}catch{return T.call(this,s)}}}(r)}}function D(r,i){this.fun=r,this.array=i}function y(){}f.nextTick=function(r){var i=new Array(arguments.length-1);if(arguments.length>1)for(var s=1;s<arguments.length;s++)i[s-1]=arguments[s];$.push(new D(r,i)),$.length!==1||P||m(k)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=y,f.addListener=y,f.once=y,f.off=y,f.removeListener=y,f.removeAllListeners=y,f.emit=y,f.prependListener=y,f.prependOnceListener=y,f.listeners=function(r){return[]},f.binding=function(r){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(r){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=C&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$dc=T}),define(De[4],Ce([1,0,8,74,3,75,37]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.Event=void 0;const m=!1,S=!1;var $;(function(u){u.None=()=>f.$mb.None;function h(ge){if(S){const{onDidAddListener:ne}=ge,ue=D.create();let we=0;ge.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),ne?.()}}}function w(ge,ne){return $e(ge,()=>{},0,void 0,!0,void 0,ne)}u.defer=w;function L(ge){return(ne,ue=null,we)=>{let Pe=!1,B;return B=ge(Z=>{if(!Pe)return B?B.dispose():Pe=!0,ne.call(ue,Z)},null,we),Pe&&B.dispose(),B}}u.once=L;function O(ge,ne,ue){return K((we,Pe=null,B)=>ge(Z=>we.call(Pe,ne(Z)),null,B),ue)}u.map=O;function N(ge,ne,ue){return K((we,Pe=null,B)=>ge(Z=>{ne(Z),we.call(Pe,Z)},null,B),ue)}u.forEach=N;function M(ge,ne,ue){return K((we,Pe=null,B)=>ge(Z=>ne(Z)&&we.call(Pe,Z),null,B),ue)}u.filter=M;function z(ge){return ge}u.signal=z;function j(...ge){return(ne,ue=null,we)=>{const Pe=(0,f.$jb)(...ge.map(B=>B(Z=>ne.call(ue,Z))));return H(Pe,we)}}u.any=j;function F(ge,ne,ue,we){let Pe=ue;return O(ge,B=>(Pe=ne(Pe,B),Pe),we)}u.reduce=F;function K(ge,ne){let ue;const we={onWillAddFirstListener(){ue=ge(Pe.fire,Pe)},onDidRemoveLastListener(){ue?.dispose()}};ne||h(we);const Pe=new d(we);return ne?.add(Pe),Pe.event}function H(ge,ne){return ne instanceof Array?ne.push(ge):ne&&ne.add(ge),ge}function $e(ge,ne,ue=100,we=!1,Pe=!1,B,Z){let x,se,Y,fe=0,ye;const ze={leakWarningThreshold:B,onWillAddFirstListener(){x=ge(xe=>{fe++,se=ne(se,xe),we&&!Y&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,Y=void 0,(!we||fe>1)&&We.fire(Ye),fe=0},typeof ue=="number"?(clearTimeout(Y),Y=setTimeout(ye,ue)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&fe>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,x.dispose()}};Z||h(ze);const We=new d(ze);return Z?.add(We),We.event}u.debounce=$e;function _(ge,ne=0,ue){return u.debounce(ge,(we,Pe)=>we?(we.push(Pe),we):[Pe],ne,void 0,!0,void 0,ue)}u.accumulate=_;function Q(ge,ne=(we,Pe)=>we===Pe,ue){let we=!0,Pe;return M(ge,B=>{const Z=we||!ne(B,Pe);return we=!1,Pe=B,Z},ue)}u.latch=Q;function V(ge,ne,ue){return[u.filter(ge,ne,ue),u.filter(ge,we=>!ne(we),ue)]}u.split=V;function ee(ge,ne=!1,ue=[],we){let Pe=ue.slice(),B=ge(se=>{Pe?Pe.push(se):x.fire(se)});we&&we.add(B);const Z=()=>{Pe?.forEach(se=>x.fire(se)),Pe=null},x=new d({onWillAddFirstListener(){B||(B=ge(se=>x.fire(se)),we&&we.add(B))},onDidAddFirstListener(){Pe&&(ne?setTimeout(Z):Z())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return we&&we.add(x),x.event}u.buffer=ee;function me(ge,ne){return(we,Pe,B)=>{const Z=ne(new te);return ge(function(x){const se=Z.evaluate(x);se!==ae&&we.call(Pe,se)},void 0,B)}}u.chain=me;const ae=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ue=>(ne(ue),ue)),this}filter(ne){return this.f.push(ue=>ne(ue)?ue:ae),this}reduce(ne,ue){let we=ue;return this.f.push(Pe=>(we=ne(we,Pe),we)),this}latch(ne=(ue,we)=>ue===we){let ue=!0,we;return this.f.push(Pe=>{const B=ue||!ne(Pe,we);return ue=!1,we=Pe,B?Pe:ae}),this}evaluate(ne){for(const ue of this.f)if(ne=ue(ne),ne===ae)break;return ne}}function X(ge,ne,ue=we=>we){const we=(...x)=>Z.fire(ue(...x)),Pe=()=>ge.on(ne,we),B=()=>ge.removeListener(ne,we),Z=new d({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Z.event}u.fromNodeEventEmitter=X;function U(ge,ne,ue=we=>we){const we=(...x)=>Z.fire(ue(...x)),Pe=()=>ge.addEventListener(ne,we),B=()=>ge.removeEventListener(ne,we),Z=new d({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Z.event}u.fromDOMEventEmitter=U;function q(ge){return new Promise(ne=>L(ge)(ne))}u.toPromise=q;function G(ge){const ne=new d;return ge.then(ue=>{ne.fire(ue)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}u.fromPromise=G;function ce(ge,ne){return ne(void 0),ge(ue=>ne(ue))}u.runAndSubscribe=ce;function re(ge,ne){let ue=null;function we(B){ue?.dispose(),ue=new f.$lb,ne(B,ue)}we(void 0);const Pe=ge(B=>we(B));return(0,f.$kb)(()=>{Pe.dispose(),ue?.dispose()})}u.runAndSubscribeWithStore=re;class de{constructor(ne,ue){this._observable=ne,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ue||h(we),this.emitter=new d(we),ue&&ue.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ue){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(ge,ne){return new de(ge,ne).emitter.event}u.fromObservable=Ee;function he(ge){return ne=>{let ue=0,we=!1;const Pe={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(ge.reportChanges(),we&&(we=!1,ne()))},handlePossibleChange(){},handleChange(){we=!0}};return ge.addObserver(Pe),ge.reportChanges(),{dispose(){ge.removeObserver(Pe)}}}}u.fromObservableLight=he})($||(e.Event=$={}));class P{static{this.all=new Set}static{this.f=0}constructor(h){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${h}_${P.f++}`,P.all.add(this)}start(h){this.g=new A.$dc,this.listenerCount=h}stop(){if(this.g){const h=this.g.elapsed();this.durations.push(h),this.elapsedOverall+=h,this.invocationCount+=1,this.g=void 0}}}e.$fc=P;let I=-1;function p(u){const h=I;return I=u,{dispose(){I=h}}}e.$gc=p;class k{constructor(h,w=Math.random().toString(18).slice(2,5)){this.threshold=h,this.name=w,this.g=0}dispose(){this.f?.clear()}check(h,w){const L=this.threshold;if(L<=0||w<L)return;this.f||(this.f=new Map);const O=this.f.get(h.value)||0;if(this.f.set(h.value,O+1),this.g-=1,this.g<=0){this.g=L*.5;let N,M=0;for(const[z,j]of this.f)(!N||M<j)&&(N=z,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${M}):`),console.warn(N)}return()=>{const N=this.f.get(h.value)||0;this.f.set(h.value,N-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(h){this.value=h}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class r{constructor(h){this.value=h,this.id=y++}}const i=2,s=(u,h)=>{if(u instanceof r)h(u);else for(let w=0;w<u.length;w++){const L=u[w];L&&h(L)}};class d{constructor(h){this.w=0,this.f=h,this.g=I>0||this.f?.leakWarningThreshold?new k(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const h=this.t;queueMicrotask(()=>{s(h,w=>w.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(h,w,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$mb.None;if(this.m)return f.$mb.None;w&&(h=h.bind(w));const O=new r(h);let N,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=D.create(),N=this.g.check(O.stack,this.w+1)),m&&(O.stack=M??D.create()),this.t?this.t instanceof r?(this.u??=new g,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,f.$kb)(()=>{N?.(),this.x(O)});return L instanceof f.$lb?L.add(z):Array.isArray(L)&&L.push(z),z},this.q}x(h){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const w=this.t,L=w.indexOf(h);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,w[L]=void 0;const O=this.u.current===this;if(this.w*i<=w.length){let N=0;for(let M=0;M<w.length;M++)w[M]?w[N++]=w[M]:O&&(this.u.end--,N<this.u.i&&this.u.i--);w.length=N}}y(h,w){if(!h)return;const L=this.f?.onListenerError||C.$Y;if(!L){h.value(w);return}try{h.value(w)}catch(O){L(O)}}z(h){const w=h.current.t;for(;h.i<h.end;)this.y(w[h.i++],h.value);h.reset()}fire(h){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof r)this.y(this.t,h);else{const w=this.u;w.enqueue(this,h,this.t.length),this.z(w)}this.j?.stop()}hasListeners(){return this.w>0}}e.$hc=d;const b=()=>new g;e.$ic=b;class g{constructor(){this.i=-1,this.end=0}enqueue(h,w,L){this.i=0,this.end=L,this.current=h,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends d{async fireAsync(h,w,L){if(this.t)for(this.h||(this.h=new R.$vb),s(this.t,O=>this.h.push([O.value,h]));this.h.size>0&&!w.isCancellationRequested;){const[O,N]=this.h.shift(),M=[],z={...N,token:w,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");L&&(j=L(j,O)),M.push(j)}};try{O(z)}catch(j){(0,C.$Y)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const F of j)F.status==="rejected"&&(0,C.$Y)(F.reason)})}}}e.$jc=t;class o extends d{get isPaused(){return this.h!==0}constructor(h){super(h),this.h=0,this.s=new R.$vb,this.A=h?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const h=Array.from(this.s);this.s.clear(),super.fire(this.A(h))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(h){this.w&&(this.h!==0?this.s.push(h):super.fire(h))}}e.$kc=o;class c extends o{constructor(h){super(h),this.k=h.delay??100}fire(h){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(h)}}e.$lc=c;class n extends d{constructor(h){super(h),this.h=[],this.k=h?.merge}fire(h){this.hasListeners()&&(this.h.push(h),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$mc=n;class a{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(h){const w={event:h,listener:null};this.h.push(w),this.g&&this.m(w);const L=()=>{this.g&&this.o(w);const O=this.h.indexOf(w);this.h.splice(O,1)};return(0,f.$kb)((0,T.$bb)(L))}j(){this.g=!0,this.h.forEach(h=>this.m(h))}k(){this.g=!1,this.h.forEach(h=>this.o(h))}m(h){h.listener=h.event(w=>this.f.fire(w))}o(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.f.dispose()}}e.$nc=a;class l{constructor(h,w,L,O){this.f=new f.$lb;const N=this.f.add(new a),M=this.f.add(new f.$ub);function z(j){M.set(j,N.add(O(j)))}for(const j of h)z(j);this.f.add(w(j=>{z(j)})),this.f.add(L(j=>{M.deleteAndDispose(j)})),this.event=N.event}dispose(){this.f.dispose()}}e.$oc=l;class v{constructor(){this.f=[]}wrapEvent(h){return(w,L,O)=>h(N=>{const M=this.f[this.f.length-1];M?M.push(()=>w.call(L,N)):w.call(L,N)},void 0,O)}bufferEvents(h){const w=[];this.f.push(w);const L=h();return this.f.pop(),w.forEach(O=>O()),L}}e.$pc=v;class E{constructor(){this.f=!1,this.g=$.None,this.h=f.$mb.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(h){this.g=h,this.f&&(this.h.dispose(),this.h=h(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qc=E}),define(De[21],Ce([1,0,4]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.CancellationToken=void 0;const T=Object.freeze(function(m,S){const $=setTimeout(m.bind(S),0);return{dispose(){clearTimeout($)}}});var f;(function(m){function S($){return $===m.None||$===m.Cancelled||$ instanceof R?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}m.isCancellationToken=S,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new C.$hc),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$rc=A}),define(De[159],Ce([1,0,21]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ld=e.$kd=e.$jd=void 0;class T{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new C.$rc,S=this.b(m.token);return this.a={promise:S,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$jd=T;class f{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const S=JSON.stringify(m);return this.b!==S&&(this.b=S,this.a=this.c(m)),this.a}}e.$kd=f;class R{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const S=this.b(m);return this.a.set(m,S),S}}e.$ld=R}),define(De[97],Ce([1,0,8,3]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=void 0;function f(b){const g=b;return g?typeof g.read=="function":!1}e.$sc=f;function R(b){const g=b;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.$tc=R;function A(b){const g=b;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$uc=A;function m(b,g){return new S(b,g)}e.$vc=m;class S{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,C.$Y)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let o;switch(g){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const c=o.indexOf(t);c>=0&&o.splice(c,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(b,g){const t=[];let o;for(;(o=b.read())!==null;)t.push(o);return g(t)}e.$wc=$;function P(b,g,t){const o=[];let c;for(;(c=b.read())!==null&&o.length<t;)o.push(c);return c===null&&o.length>0?g(o):{read:()=>{if(o.length>0)return o.shift();if(typeof c<"u"){const n=c;return c=void 0,n}return b.read()}}}e.$xc=P;function I(b,g){return new Promise((t,o)=>{const c=[];p(b,{onData:n=>{g&&c.push(n)},onError:n=>{g?o(n):t(void 0)},onEnd:()=>{t(g?g(c):void 0)}})})}e.$yc=I;function p(b,g,t){b.on("error",o=>{t?.isCancellationRequested||g.onError(o)}),b.on("end",()=>{t?.isCancellationRequested||g.onEnd()}),b.on("data",o=>{t?.isCancellationRequested||g.onData(o)})}e.$zc=p;function k(b,g){return new Promise((t,o)=>{const c=new T.$lb,n=[],a=E=>{if(n.push(E),n.length>g)return c.dispose(),b.pause(),t({stream:b,buffer:n,ended:!1})},l=E=>(c.dispose(),o(E)),v=()=>(c.dispose(),t({stream:b,buffer:n,ended:!0}));c.add((0,T.$kb)(()=>b.removeListener("error",l))),b.on("error",l),c.add((0,T.$kb)(()=>b.removeListener("end",v))),b.on("end",v),c.add((0,T.$kb)(()=>b.removeListener("data",a))),b.on("data",a)})}e.$Ac=k;function D(b,g){const t=m(g);return t.end(b),t}e.$Bc=D;function y(){const b=m(()=>{throw new Error("not supported")});return b.end(),b}e.$Cc=y;function r(b){let g=!1;return{read:()=>g?null:(g=!0,b)}}e.$Dc=r;function i(b,g,t){const o=m(t);return p(b,{onData:c=>o.write(g.data(c)),onError:c=>o.error(g.error?g.error(c):c),onEnd:()=>o.end()}),o}e.$Ec=i;function s(b,g,t){let o=!1;return{read:()=>{const c=g.read();return o?c:(o=!0,c!==null?t([b,c]):b)}}}e.$Fc=s;function d(b,g,t){let o=!1;const c=m(t);return p(g,{onData:n=>o?c.write(n):(o=!0,c.write(t([b,n]))),onError:n=>c.error(n),onEnd:()=>{o||(o=!0,c.write(b)),c.end()}}),c}e.$Gc=d}),define(De[22],Ce([1,0,58,97]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const f=typeof Buffer<"u",R=new C.$T(()=>new Uint8Array(256));let A,m;class S{static alloc(w){return f?new S(Buffer.allocUnsafe(w)):new S(new Uint8Array(w))}static wrap(w){return f&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new S(w)}static fromString(w,L){return!(L?.dontUseNodeBuffer||!1)&&f?new S(Buffer.from(w)):(A||(A=new TextEncoder),new S(A.encode(w)))}static fromByteArray(w){const L=S.alloc(w.length);for(let O=0,N=w.length;O<N;O++)L.buffer[O]=w[O];return L}static concat(w,L){if(typeof L>"u"){L=0;for(let M=0,z=w.length;M<z;M++)L+=w[M].byteLength}const O=S.alloc(L);let N=0;for(let M=0,z=w.length;M<z;M++){const j=w[M];O.set(j,N),N+=j.byteLength}return O}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=S.alloc(this.byteLength);return w.set(this),w}toString(){return f?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,L){return new S(this.buffer.subarray(w,L))}set(w,L){if(w instanceof S)this.buffer.set(w.buffer,L);else if(w instanceof Uint8Array)this.buffer.set(w,L);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),L);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return p(this.buffer,w)}writeUInt32BE(w,L){k(this.buffer,w,L)}readUInt32LE(w){return D(this.buffer,w)}writeUInt32LE(w,L){y(this.buffer,w,L)}readUInt8(w){return r(this.buffer,w)}writeUInt8(w,L){i(this.buffer,w,L)}indexOf(w,L=0){return $(this.buffer,w instanceof S?w.buffer:w,L)}}e.$Hc=S;function $(h,w,L=0){const O=w.byteLength,N=h.byteLength;if(O===0)return 0;if(O===1)return h.indexOf(w[0]);if(O>N-L)return-1;const M=R.value;M.fill(w.length);for(let K=0;K<w.length;K++)M[w[K]]=w.length-K-1;let z=L+w.length-1,j=z,F=-1;for(;z<N;)if(h[z]===w[j]){if(j===0){F=z;break}z--,j--}else z+=Math.max(w.length-j,M[h[z]]),j=w.length-1;return F}e.$Ic=$;function P(h,w){return h[w+0]<<0>>>0|h[w+1]<<8>>>0}e.$Jc=P;function I(h,w,L){h[L+0]=w&255,w=w>>>8,h[L+1]=w&255}e.$Kc=I;function p(h,w){return h[w]*2**24+h[w+1]*2**16+h[w+2]*2**8+h[w+3]}e.$Lc=p;function k(h,w,L){h[L+3]=w,w=w>>>8,h[L+2]=w,w=w>>>8,h[L+1]=w,w=w>>>8,h[L]=w}e.$Mc=k;function D(h,w){return h[w+0]<<0>>>0|h[w+1]<<8>>>0|h[w+2]<<16>>>0|h[w+3]<<24>>>0}e.$Nc=D;function y(h,w,L){h[L+0]=w&255,w=w>>>8,h[L+1]=w&255,w=w>>>8,h[L+2]=w&255,w=w>>>8,h[L+3]=w&255}e.$Oc=y;function r(h,w){return h[w]}e.$Pc=r;function i(h,w,L){h[L]=w}e.$Qc=i;function s(h){return T.$wc(h,w=>S.concat(w))}e.$Rc=s;function d(h){return T.$Dc(h)}e.$Sc=d;function b(h){return T.$yc(h,w=>S.concat(w))}e.$Tc=b;async function g(h){return h.ended?S.concat(h.buffer):S.concat([...h.buffer,await b(h.stream)])}e.$Uc=g;function t(h){return T.$Bc(h,w=>S.concat(w))}e.$Vc=t;function o(h){return T.$Ec(h,{data:w=>typeof w=="string"?S.fromString(w):S.wrap(w)},w=>S.concat(w))}e.$Wc=o;function c(h){return T.$vc(w=>S.concat(w),h)}e.$Xc=c;function n(h,w){return T.$Fc(h,w,L=>S.concat(L))}e.$Yc=n;function a(h,w){return T.$Gc(h,w,L=>S.concat(L))}e.$Zc=a;function l(h){let w=0,L=0,O=0;const N=new Uint8Array(Math.floor(h.length/4*3)),M=j=>{switch(L){case 3:N[O++]=w|j,L=0;break;case 2:N[O++]=w|j>>>2,w=j<<6,L=3;break;case 1:N[O++]=w|j>>>4,w=j<<4,L=2;break;default:w=j<<2,L=1}};for(let j=0;j<h.length;j++){const F=h.charCodeAt(j);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${h[j]}`)}}const z=O;for(;L>0;)M(0);return S.wrap(N).slice(0,z)}e.$1c=l;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:h},w=!0,L=!1){const O=L?E:v;let N="";const M=h.byteLength%3;let z=0;for(;z<h.byteLength-M;z+=3){const j=h[z+0],F=h[z+1],K=h[z+2];N+=O[j>>>2],N+=O[(j<<4|F>>>4)&63],N+=O[(F<<2|K>>>6)&63],N+=O[K&63]}if(M===1){const j=h[z+0];N+=O[j>>>2],N+=O[j<<4&63],w&&(N+="==")}else if(M===2){const j=h[z+0],F=h[z+1];N+=O[j>>>2],N+=O[(j<<4|F>>>4)&63],N+=O[F<<2&63],w&&(N+="=")}return N}e.$2c=u}),define(De[15],Ce([1,0,159,58]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ke=e.$je=e.$ie=e.$he=e.GraphemeBreakType=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$od=f;const R=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(Ve,Le){const Qe=parseInt(Le,10);return isNaN(Qe)||Qe<0||Qe>=Ne.length?Ve:Ne[Qe]})}e.$pd=A;const m=/{([^}]+)}/g;function S(Ae,Ne){return Ae.replace(m,(Ve,Le)=>Ne[Le]??Ve)}e.$qd=S;function $(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$rd=$;function P(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$sd=P;function I(Ae,Ne){let Ve=0;const Le=Ne.charCodeAt(0);for(let Qe=Ae.length-1;Qe>=0;Qe--)Ae.charCodeAt(Qe)===Le&&Ve++;return Ve}e.$td=I;function p(Ae,Ne,Ve="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${Ve}`}e.$ud=p;function k(Ae,Ne=" "){const Ve=D(Ae,Ne);return y(Ve,Ne)}e.$vd=k;function D(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$wd=D;function y(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Qe=Le,le=-1;for(;le=Ae.lastIndexOf(Ne,Qe-1),!(le===-1||le+Ve!==Qe);){if(le===0)return"";Qe=le}return Ae.substring(0,Qe)}e.$xd=y;function r(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$yd=r;function i(Ae){return Ae.replace(/\*/g,"")}e.$zd=i;function s(Ae,Ne,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=P(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ad=s;function d(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Bd=d;function b(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Cd=b;function g(Ae){for(let Ne=0,Ve=Ae.length;Ne<Ve;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Dd=g;function t(Ae,Ne=0,Ve=Ae.length){for(let Le=Ne;Le<Ve;Le++){const Qe=Ae.charCodeAt(Le);if(Qe!==32&&Qe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,Ve)}e.$Ed=t;function o(Ae,Ne=Ae.length-1){for(let Ve=Ne;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$Fd=o;function c(Ae,Ne,Ve){const Le=[];let Qe=0;for(const le of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Qe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Qe=le.index+le[0].length,Le.push(Ve(le[0],...le.slice(1),le.index,Ae,le.groups))}return Le.push(Ae.slice(Qe)),Promise.all(Le).then(le=>le.join(""))}e.$Gd=c;function n(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Hd=n;function a(Ae,Ne,Ve=0,Le=Ae.length,Qe=0,le=Ne.length){for(;Ve<Le&&Qe<le;Ve++,Qe++){const qe=Ae.charCodeAt(Ve),je=Ne.charCodeAt(Qe);if(qe<je)return-1;if(qe>je)return 1}const oe=Le-Ve,Ie=le-Qe;return oe<Ie?-1:oe>Ie?1:0}e.$Id=a;function l(Ae,Ne){return v(Ae,Ne,0,Ae.length,0,Ne.length)}e.$Jd=l;function v(Ae,Ne,Ve=0,Le=Ae.length,Qe=0,le=Ne.length){for(;Ve<Le&&Qe<le;Ve++,Qe++){let qe=Ae.charCodeAt(Ve),je=Ne.charCodeAt(Qe);if(qe===je)continue;if(qe>=128||je>=128)return a(Ae.toLowerCase(),Ne.toLowerCase(),Ve,Le,Qe,le);u(qe)&&(qe-=32),u(je)&&(je-=32);const Xe=qe-je;if(Xe!==0)return Xe}const oe=Le-Ve,Ie=le-Qe;return oe<Ie?-1:oe>Ie?1:0}e.$Kd=v;function E(Ae){return Ae>=48&&Ae<=57}e.$Ld=E;function u(Ae){return Ae>=97&&Ae<=122}e.$Md=u;function h(Ae){return Ae>=65&&Ae<=90}e.$Nd=h;function w(Ae,Ne){return Ae.length===Ne.length&&v(Ae,Ne)===0}e.$Od=w;function L(Ae,Ne){const Ve=Ne.length;return Ne.length>Ae.length?!1:v(Ae,Ne,0,Ve)===0}e.$Pd=L;function O(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return Ve}e.$Qd=O;function N(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;const Qe=Ae.length-1,le=Ne.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Qe-Le)!==Ne.charCodeAt(le-Le))return Le;return Ve}e.$Rd=N;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$Sd=M;function z(Ae){return 56320<=Ae&&Ae<=57343}e.$Td=z;function j(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$Ud=j;function F(Ae,Ne,Ve){const Le=Ae.charCodeAt(Ve);if(M(Le)&&Ve+1<Ne){const Qe=Ae.charCodeAt(Ve+1);if(z(Qe))return j(Le,Qe)}return Le}e.$Vd=F;function K(Ae,Ne){const Ve=Ae.charCodeAt(Ne-1);if(z(Ve)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return j(Le,Ve)}return Ve}class H{get offset(){return this.e}constructor(Ne,Ve=0){this.c=Ne,this.d=Ne.length,this.e=Ve}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=K(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=F(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$Wd=H;class $e{get offset(){return this.c.offset}constructor(Ne,Ve=0){this.c=new H(Ne,Ve)}nextGraphemeLength(){const Ne=fe.getInstance(),Ve=this.c,Le=Ve.offset;let Qe=Ne.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const le=Ve.offset,oe=Ne.getGraphemeBreakType(Ve.nextCodePoint());if(se(Qe,oe)){Ve.setOffset(le);break}Qe=oe}return Ve.offset-Le}prevGraphemeLength(){const Ne=fe.getInstance(),Ve=this.c,Le=Ve.offset;let Qe=Ne.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const le=Ve.offset,oe=Ne.getGraphemeBreakType(Ve.prevCodePoint());if(se(oe,Qe)){Ve.setOffset(le);break}Qe=oe}return Le-Ve.offset}eol(){return this.c.eol()}}e.$Xd=$e;function _(Ae,Ne){return new $e(Ae,Ne).nextGraphemeLength()}e.$Yd=_;function Q(Ae,Ne){return new $e(Ae,Ne).prevGraphemeLength()}e.$Zd=Q;function V(Ae,Ne){Ne>0&&z(Ae.charCodeAt(Ne))&&Ne--;const Ve=Ne+_(Ae,Ne);return[Ve-Q(Ae,Ve),Ve]}e.$1d=V;function ee(Ae){const Ne=new $e(Ae);let Ve=0;for(;!Ne.eol();)Ve++,Ne.nextGraphemeLength();return Ve}e.$2d=ee;let me;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function te(Ae){return me||(me=ae()),me.test(Ae)}e.$3d=te;const X=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return X.test(Ae)}e.$4d=U,e.$5d=/[\u2028\u2029]/;function q(Ae){return e.$5d.test(Ae)}e.$6d=q;function G(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$7d=G;function ce(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$8d=ce;function re(Ae,Ne){if(Ae.length<Ne)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Ne);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$9d=re;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function he(Ae){return Ae&&(Ae=Ae.replace(de,"").replace(Ee,"")),Ae}e.$0d=he,e.$$d=String.fromCharCode(65279);function ge(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$_d=ge;function ne(Ae){return ge(Ae)?Ae.substr(1):Ae}e.$ae=ne;function ue(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const Ve=Ne.length,Le=Ae.toLowerCase();let Qe=0,le=-1;for(;Qe<Ve;){const oe=Le.indexOf(Ne[Qe],le+1);if(oe<0)return!1;le=oe,Qe++}return!0}e.$be=ue;function we(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$ce=we;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$de=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Ne--;while(Ne>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$ee=B;function Z(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$fe=Z;function x(Ae){return fe.getInstance().getGraphemeBreakType(Ae)}e.$ge=x;function se(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class fe{static{this.c=null}static getInstance(){return fe.c||(fe.c=new fe),fe.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const Ve=this.d,Le=Ve.length/3;let Qe=1;for(;Qe<=Le;)if(Ne<Ve[3*Qe])Qe=2*Qe;else if(Ne>Ve[3*Qe+1])Qe=2*Qe+1;else return Ve[3*Qe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Ne){if(Ae===0)return 0;const Ve=We(Ae,Ne);if(Ve!==void 0)return Ve;const Le=new H(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$he=ze;function We(Ae,Ne){const Ve=new H(Ne,Ae);let Le=Ve.prevCodePoint();for(;xe(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!ce(Le))return;let Qe=Ve.offset;return Qe>0&&Ve.prevCodePoint()===8205&&(Qe=Ve.offset),Qe}function xe(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$ie="\xA0";class it{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$kd(Ne=>{function Ve(Xe){const nt=new Map;for(let ot=0;ot<Xe.length;ot+=2)nt.set(Xe[ot],Xe[ot+1]);return nt}function Le(Xe,nt){const ot=new Map(Xe);for(const[bt,Dt]of nt)ot.set(bt,Dt);return ot}function Qe(Xe,nt){if(!Xe)return nt;const ot=new Map;for(const[bt,Dt]of Xe)nt.has(bt)&&ot.set(bt,Dt);return ot}const le=this.c.value;let oe=Ne.filter(Xe=>!Xe.startsWith("_")&&Xe in le);oe.length===0&&(oe=["_default"]);let Ie;for(const Xe of oe){const nt=Ve(le[Xe]);Ie=Qe(Ie,nt)}const qe=Ve(le._common),je=Le(qe,Ie);return new it(je)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new T.$T(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$je=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$ke=et}),define(De[121],Ce([1,0,28,15]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.FuzzyScore=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.or=void 0;function f(...ne){return function(ue,we){for(let Pe=0,B=ne.length;Pe<B;Pe++){const Z=ne[Pe](ue,we);if(Z)return Z}return null}}e.or=f,e.$vj=R.bind(void 0,!1),e.$wj=R.bind(void 0,!0);function R(ne,ue,we){if(!we||we.length<ue.length)return null;let Pe;return ne?Pe=T.$Pd(we,ue):Pe=we.indexOf(ue)===0,Pe?ue.length>0?[{start:0,end:ue.length}]:[]:null}function A(ne,ue){const we=ue.toLowerCase().indexOf(ne.toLowerCase());return we===-1?null:[{start:we,end:we+ne.length}]}e.$xj=A;function m(ne,ue){return S(ne.toLowerCase(),ue.toLowerCase(),0,0)}e.$yj=m;function S(ne,ue,we,Pe){if(we===ne.length)return[];if(Pe===ue.length)return null;if(ne[we]===ue[Pe]){let B=null;return(B=S(ne,ue,we+1,Pe+1))?i({start:Pe,end:Pe+1},B):null}return S(ne,ue,we,Pe+1)}function $(ne){return 97<=ne&&ne<=122}function P(ne){return 65<=ne&&ne<=90}e.$zj=P;function I(ne){return 48<=ne&&ne<=57}function p(ne){return ne===32||ne===9||ne===10||ne===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>k.add(ne.charCodeAt(0)));function D(ne){return p(ne)||k.has(ne)}function y(ne,ue){return ne===ue||D(ne)&&D(ue)}function r(ne){return $(ne)||P(ne)||I(ne)}function i(ne,ue){return ue.length===0?ue=[ne]:ne.end===ue[0].start?ue[0].start=ne.start:ue.unshift(ne),ue}function s(ne,ue){for(let we=ue;we<ne.length;we++){const Pe=ne.charCodeAt(we);if(P(Pe)||I(Pe)||we>0&&!r(ne.charCodeAt(we-1)))return we}return ne.length}function d(ne,ue,we,Pe){if(we===ne.length)return[];if(Pe===ue.length)return null;if(ne[we]!==ue[Pe].toLowerCase())return null;{let B=null,Z=Pe+1;for(B=d(ne,ue,we+1,Pe+1);!B&&(Z=s(ue,Z))<ue.length;)B=d(ne,ue,we+1,Z),Z++;return B===null?null:i({start:Pe,end:Pe+1},B)}}function b(ne){let ue=0,we=0,Pe=0,B=0,Z=0;for(let ye=0;ye<ne.length;ye++)Z=ne.charCodeAt(ye),P(Z)&&ue++,$(Z)&&we++,r(Z)&&Pe++,I(Z)&&B++;const x=ue/ne.length,se=we/ne.length,Y=Pe/ne.length,fe=B/ne.length;return{upperPercent:x,lowerPercent:se,alphaPercent:Y,numericPercent:fe}}function g(ne){const{upperPercent:ue,lowerPercent:we}=ne;return we===0&&ue>.6}function t(ne){const{upperPercent:ue,lowerPercent:we,alphaPercent:Pe,numericPercent:B}=ne;return we>.2&&ue<.8&&Pe>.6&&B<.2}function o(ne){let ue=0,we=0,Pe=0,B=0;for(let Z=0;Z<ne.length;Z++)Pe=ne.charCodeAt(Z),P(Pe)&&ue++,$(Pe)&&we++,p(Pe)&&B++;return(ue===0||we===0)&&B===0?ne.length<=30:ue<=5}function c(ne,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!o(ne)||ue.length>60)return null;const we=b(ue);if(!t(we)){if(!g(we))return null;ue=ue.toLowerCase()}let Pe=null,B=0;for(ne=ne.toLowerCase();B<ue.length&&(Pe=d(ne,ue,0,B))===null;)B=s(ue,B+1);return Pe}e.$Aj=c;function n(ne,ue,we=!1){if(!ue||ue.length===0)return null;let Pe=null,B=0;for(ne=ne.toLowerCase(),ue=ue.toLowerCase();B<ue.length&&(Pe=a(ne,ue,0,B,we))===null;)B=l(ue,B+1);return Pe}e.$Bj=n;function a(ne,ue,we,Pe,B){if(we===ne.length)return[];if(Pe===ue.length)return null;if(y(ne.charCodeAt(we),ue.charCodeAt(Pe))){let Z=null,x=Pe+1;if(Z=a(ne,ue,we+1,Pe+1,B),!B)for(;!Z&&(x=l(ue,x))<ue.length;)Z=a(ne,ue,we+1,x,B),x++;return Z?ne.charCodeAt(we)!==ue.charCodeAt(Pe)?Z:i({start:Pe,end:Pe+1},Z):null}else return null}function l(ne,ue){for(let we=ue;we<ne.length;we++)if(D(ne.charCodeAt(we))||we>0&&D(ne.charCodeAt(we-1)))return we;return ne.length}const v=f(e.$wj,c,A),E=f(e.$wj,c,m),u=new C.$Ai(1e4);function h(ne,ue,we=!1){if(typeof ne!="string"||typeof ue!="string")return null;let Pe=u.get(ne);Pe||(Pe=new RegExp(T.$yd(ne),"i"),u.set(ne,Pe));const B=Pe.exec(ue);return B?[{start:B.index,end:B.index+B[0].length}]:we?E(ne,ue):v(ne,ue)}e.$Cj=h;function w(ne,ue){const we=G(ne,ne.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?O(we):null}e.$Dj=w;function L(ne,ue,we,Pe,B,Z){const x=Math.min(13,ne.length);for(;we<x;we++){const se=G(ne,ue,we,Pe,B,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,Z]}e.$Ej=L;function O(ne){if(typeof ne>"u")return[];const ue=[],we=ne[1];for(let Pe=ne.length-1;Pe>1;Pe--){const B=ne[Pe]+we,Z=ue[ue.length-1];Z&&Z.end===B?Z.end=B+1:ue.push({start:B,end:B+1})}return ue}e.$Fj=O;const N=128;function M(){const ne=[],ue=[];for(let we=0;we<=N;we++)ue[we]=0;for(let we=0;we<=N;we++)ne.push(ue.slice(0));return ne}function z(ne){const ue=[];for(let we=0;we<=ne;we++)ue[we]=0;return ue}const j=z(2*N),F=z(2*N),K=M(),H=M(),$e=M(),_=!1;function Q(ne,ue,we,Pe,B){function Z(se,Y,fe=" "){for(;se.length<Y;)se=fe+se;return se}let x=` |   |${Pe.split("").map(se=>Z(se,3)).join("|")}
`;for(let se=0;se<=we;se++)se===0?x+=" |":x+=`${ue[se-1]}|`,x+=ne[se].slice(0,B+1).map(Y=>Z(Y.toString(),3)).join("|")+`
`;return x}function V(ne,ue,we,Pe){ne=ne.substr(ue),we=we.substr(Pe),console.log(Q(H,ne,ne.length,we,we.length)),console.log(Q($e,ne,ne.length,we,we.length)),console.log(Q(K,ne,ne.length,we,we.length))}function ee(ne,ue){if(ue<0||ue>=ne.length)return!1;const we=ne.codePointAt(ue);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$8d(we)}}function me(ne,ue){if(ue<0||ue>=ne.length)return!1;switch(ne.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function ae(ne,ue,we){return ue[ne]!==we[ne]}function te(ne,ue,we,Pe,B,Z,x=!1){for(;ue<we&&B<Z;)ne[ue]===Pe[B]&&(x&&(j[ue]=B),ue+=1),B+=1;return ue===we}e.$Gj=te;var X;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(X||(X={}));var U;(function(ne){ne.Default=[-100,0];function ue(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}ne.isDefault=ue})(U||(e.FuzzyScore=U={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ue,we){this.firstMatchCanBeWeak=ue,this.boostFullMatch=we}}e.$Hj=q;function G(ne,ue,we,Pe,B,Z,x=q.default){const se=ne.length>N?N:ne.length,Y=Pe.length>N?N:Pe.length;if(we>=se||Z>=Y||se-we>Y-Z||!te(ue,we,se,B,Z,Y,!0))return;ce(se,Y,we,Z,ue,B);let fe=1,ye=1,ze=we,We=Z;const xe=[!1];for(fe=1,ze=we;ze<se;fe++,ze++){const Ne=j[ze],Ve=F[ze],Le=ze+1<se?F[ze+1]:Y;for(ye=Ne-Z+1,We=Ne;We<Le;ye++,We++){let Qe=Number.MIN_SAFE_INTEGER,le=!1;We<=Ve&&(Qe=re(ne,ue,ze,we,Pe,B,We,Y,Z,K[fe-1][ye-1]===0,xe));let oe=0;Qe!==Number.MAX_SAFE_INTEGER&&(le=!0,oe=Qe+H[fe-1][ye-1]);const Ie=We>Ne,qe=Ie?H[fe][ye-1]+(K[fe][ye-1]>0?-5:0):0,je=We>Ne+1&&K[fe][ye-1]>0,Xe=je?H[fe][ye-2]+(K[fe][ye-2]>0?-5:0):0;if(je&&(!Ie||Xe>=qe)&&(!le||Xe>=oe))H[fe][ye]=Xe,$e[fe][ye]=3,K[fe][ye]=0;else if(Ie&&(!le||qe>=oe))H[fe][ye]=qe,$e[fe][ye]=2,K[fe][ye]=0;else if(le)H[fe][ye]=oe,$e[fe][ye]=1,K[fe][ye]=K[fe-1][ye-1]+1;else throw new Error("not possible")}}if(_&&V(ne,we,Pe,Z),!xe[0]&&!x.firstMatchCanBeWeak)return;fe--,ye--;const Ye=[H[fe][ye],Z];let it=0,et=0;for(;fe>=1;){let Ne=ye;do{const Ve=$e[fe][Ne];if(Ve===3)Ne=Ne-2;else if(Ve===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&ue[we+fe-1]===B[Z+ye-1]&&!ae(Ne+Z-1,Pe,B)&&it+1>K[fe][Ne]&&(Ne=ye),Ne===ye?it++:it=1,et||(et=Ne),fe--,ye=Ne-1,Ye.push(ye)}Y===se&&x.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Ij=G;function ce(ne,ue,we,Pe,B,Z){let x=ne-1,se=ue-1;for(;x>=we&&se>=Pe;)B[x]===Z[se]&&(F[x]=se,x--),se--}function re(ne,ue,we,Pe,B,Z,x,se,Y,fe,ye){if(ue[we]!==Z[x])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return x===we-Pe?ze=ne[we]===B[x]?7:5:ae(x,B,Z)&&(x===0||!ae(x-1,B,Z))?(ze=ne[we]===B[x]?7:5,We=!0):ee(Z,x)&&(x===0||!ee(Z,x-1))?ze=5:(ee(Z,x-1)||me(Z,x-1))&&(ze=5,We=!0),ze>1&&we===Pe&&(ye[0]=!0),We||(We=ae(x,B,Z)||ee(Z,x-1)||me(Z,x-1)),we===Pe?x>Y&&(ze-=We?3:5):fe?ze+=We?2:0:ze+=We?0:1,x+1===se&&(ze-=We?3:5),ze}function de(ne,ue,we,Pe,B,Z,x){return he(ne,ue,we,Pe,B,Z,!0,x)}e.$Jj=de;function Ee(ne,ue,we,Pe,B,Z,x){return he(ne,ue,we,Pe,B,Z,!1,x)}e.$Kj=Ee;function he(ne,ue,we,Pe,B,Z,x,se){let Y=G(ne,ue,we,Pe,B,Z,se);if(Y&&!x)return Y;if(ne.length>=3){const fe=Math.min(7,ne.length-1);for(let ye=we+1;ye<fe;ye++){const ze=ge(ne,ye);if(ze){const We=G(ze,ze.toLowerCase(),we,Pe,B,Z,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function ge(ne,ue){if(ue+1>=ne.length)return;const we=ne[ue],Pe=ne[ue+1];if(we!==Pe)return ne.slice(0,ue)+Pe+we+ne.slice(ue+2)}}),define(De[51],Ce([1,0,15]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=void 0;function T(i){return f(i,0)}e.$ni=T;function f(i,s){switch(typeof i){case"object":return i===null?R(349,s):Array.isArray(i)?S(i,s):$(i,s);case"string":return m(i,s);case"boolean":return A(i,s);case"number":return R(i,s);case"undefined":return R(937,s);default:return R(617,s)}}e.$oi=f;function R(i,s){return(s<<5)-s+i|0}e.$pi=R;function A(i,s){return R(i?433:863,s)}function m(i,s){s=R(149417,s);for(let d=0,b=i.length;d<b;d++)s=R(i.charCodeAt(d),s);return s}e.$qi=m;function S(i,s){return s=R(104579,s),i.reduce((d,b)=>f(b,d),s)}function $(i,s){return s=R(181387,s),Object.keys(i).sort().reduce((d,b)=>(d=m(b,d),f(i[b],d)),s)}class P{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=f(s,this.g),this.g}}e.$ri=P;var I;(function(i){i[i.BLOCK_SIZE=64]="BLOCK_SIZE",i[i.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(i,s,d=32){const b=d-s,g=~((1<<b)-1);return(i<<s|(g&i)>>>b)>>>0}function k(i,s=0,d=i.byteLength,b=0){for(let g=0;g<d;g++)i[s+g]=b}function D(i,s,d="0"){for(;i.length<s;)i=d+i;return i}function y(i,s=32){return i instanceof ArrayBuffer?Array.from(new Uint8Array(i)).map(d=>d.toString(16).padStart(2,"0")).join(""):D((i>>>0).toString(16),s/4)}e.$si=y;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const d=s.length;if(d===0)return;const b=this.p;let g=this.r,t=this.u,o,c;for(t!==0?(o=t,c=-1,t=0):(o=s.charCodeAt(0),c=0);;){let n=o;if(C.$Sd(o))if(c+1<d){const a=s.charCodeAt(c+1);C.$Td(a)?(c++,n=C.$Ud(o,a)):n=65533}else{t=o;break}else C.$Td(o)&&(n=65533);if(g=this.w(b,g,n),c++,c<d)o=s.charCodeAt(c);else break}this.r=g,this.u=t}w(s,d,b){return b<128?s[d++]=b:b<2048?(s[d++]=192|(b&1984)>>>6,s[d++]=128|(b&63)>>>0):b<65536?(s[d++]=224|(b&61440)>>>12,s[d++]=128|(b&4032)>>>6,s[d++]=128|(b&63)>>>0):(s[d++]=240|(b&1835008)>>>18,s[d++]=128|(b&258048)>>>12,s[d++]=128|(b&4032)>>>6,s[d++]=128|(b&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=r.g,d=this.q;for(let v=0;v<64;v+=4)s.setUint32(v,d.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)s.setUint32(v,p(s.getUint32(v-12,!1)^s.getUint32(v-32,!1)^s.getUint32(v-56,!1)^s.getUint32(v-64,!1),1),!1);let b=this.h,g=this.l,t=this.m,o=this.n,c=this.o,n,a,l;for(let v=0;v<80;v++)v<20?(n=g&t|~g&o,a=1518500249):v<40?(n=g^t^o,a=1859775393):v<60?(n=g&t|g&o|t&o,a=2400959708):(n=g^t^o,a=3395469782),l=p(b,5)+n+c+a+s.getUint32(v*4,!1)&4294967295,c=o,o=t,t=p(g,30),g=b,b=l;this.h=this.h+b&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+c&4294967295}}e.$ti=r}),define(De[38],Ce([1,0,15]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(T||(T={})),function(f){const R="error",A="warning",m="warn",S="info",$="ignore";function P(p){return p?C.$Od(R,p)?f.Error:C.$Od(A,p)||C.$Od(m,p)?f.Warning:C.$Od(S,p)?f.Info:f.Ignore:f.Ignore}f.fromValue=P;function I(p){switch(p){case f.Error:return R;case f.Warning:return A;case f.Info:return S;default:return $}}f.toString=I}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=void 0,e.$ec=Symbol("MicrotaskDelay")}),define(De[77],Ce([1,0,19,15]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;class f{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const D=k.charCodeAt(0),y=this.b.charCodeAt(this.c);return D-y}value(){return this.b[this.c]}}e.$Bh=f;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,T.$Id)(k,this.b,0,k.length,this.c,this.d):(0,T.$Kd)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ch=R;class A{constructor(k=!0,D=!0){this.f=k,this.g=D}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let D=k.length-1;D>=0;D--,this.c--){const y=this.b.charCodeAt(D);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,T.$Id)(k,this.b,0,k.length,this.d,this.e):(0,T.$Kd)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Dh=A;var m;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(m||(m={}));class S{constructor(k,D){this.f=k,this.g=D,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,T.$Jd)(k,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Jd)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,T.$Hd)(k,this.c.query);if(this.d[this.e]===5)return(0,T.$Hd)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Eh=S;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class I{static forUris(k=()=>!1,D=()=>!1){return new I(new S(k,D))}static forPaths(k=!1){return new I(new A(void 0,!k))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,D){if(D){const y=D.slice(0);(0,C.$Qf)(y);for(const r of y)this.set(r,k)}else{const y=k.slice(0);(0,C.$Qf)(y);for(const r of y)this.set(r[0],r[1])}}set(k,D){const y=this.b.reset(k);let r;this.c||(this.c=new $,this.c.segment=y.value());const i=[];for(r=this.c;;){const d=y.cmp(r.segment);if(d>0)r.left||(r.left=new $,r.left.segment=y.value()),i.push([-1,r]),r=r.left;else if(d<0)r.right||(r.right=new $,r.right.segment=y.value()),i.push([1,r]),r=r.right;else if(y.hasNext())y.next(),r.mid||(r.mid=new $,r.mid.segment=y.value()),i.push([0,r]),r=r.mid;else break}const s=r.value;r.value=D,r.key=k;for(let d=i.length-1;d>=0;d--){const b=i[d][1];b.updateHeight();const g=b.balanceFactor();if(g<-1||g>1){const t=i[d][0],o=i[d+1][0];if(t===1&&o===1)i[d][1]=b.rotateLeft();else if(t===-1&&o===-1)i[d][1]=b.rotateRight();else if(t===1&&o===-1)b.right=i[d+1][1]=i[d+1][1].rotateRight(),i[d][1]=b.rotateLeft();else if(t===-1&&o===1)b.left=i[d+1][1]=i[d+1][1].rotateLeft(),i[d][1]=b.rotateRight();else throw new Error;if(d>0)switch(i[d-1][0]){case-1:i[d-1][1].left=i[d][1];break;case 1:i[d-1][1].right=i[d][1];break;case 0:i[d-1][1].mid=i[d][1];break}else this.c=i[0][1]}}return s}get(k){return this.d(k)?.value}d(k){const D=this.b.reset(k);let y=this.c;for(;y;){const r=D.cmp(y.segment);if(r>0)y=y.left;else if(r<0)y=y.right;else if(D.hasNext())D.next(),y=y.mid;else break}return y}has(k){const D=this.d(k);return!(D?.value===void 0&&D?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,D){const y=this.b.reset(k),r=[];let i=this.c;for(;i;){const s=y.cmp(i.segment);if(s>0)r.push([-1,i]),i=i.left;else if(s<0)r.push([1,i]),i=i.right;else if(y.hasNext())y.next(),r.push([0,i]),i=i.mid;else break}if(i){if(D?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const s=this.f(i.right);if(s.key){const{key:d,value:b,segment:g}=s;this.e(s.key,!1),i.key=d,i.value=b,i.segment=g}}else{const s=i.left??i.right;if(r.length>0){const[d,b]=r[r.length-1];switch(d){case-1:b.left=s;break;case 0:b.mid=s;break;case 1:b.right=s;break}}else this.c=s}for(let s=r.length-1;s>=0;s--){const d=r[s][1];d.updateHeight();const b=d.balanceFactor();if(b>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),r[s][1]=d.rotateLeft()):b<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),r[s][1]=d.rotateRight()),s>0)switch(r[s-1][0]){case-1:r[s-1][1].left=r[s][1];break;case 1:r[s-1][1].right=r[s][1];break;case 0:r[s-1][1].mid=r[s][1];break}else this.c=r[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const D=this.b.reset(k);let y=this.c,r;for(;y;){const i=D.cmp(y.segment);if(i>0)y=y.left;else if(i<0)y=y.right;else if(D.hasNext())D.next(),r=y.value||r,y=y.mid;else break}return y&&y.value||r}findSuperstr(k){return this.g(k,!1)}g(k,D){const y=this.b.reset(k);let r=this.c;for(;r;){const i=y.cmp(r.segment);if(i>0)r=r.left;else if(i<0)r=r.right;else if(y.hasNext())y.next(),r=r.mid;else return r.mid?this.h(r.mid):D?r.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[D,y]of this)k(y,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const D=[];return this.j(k,D),D[Symbol.iterator]()}j(k,D){k&&(k.left&&this.j(k.left,D),k.value&&D.push([k.key,k.value]),k.mid&&this.j(k.mid,D),k.right&&this.j(k.right,D))}_isBalanced(){const k=D=>{if(!D)return!0;const y=D.balanceFactor();return y<-1||y>1?!1:k(D.left)&&k(D.right)};return k(this.c)}}e.$Fh=I}),define(De[18],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function C(g){return typeof g=="string"}e.$le=C;function T(g){return Array.isArray(g)&&g.every(t=>C(t))}e.$me=T;function f(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.$ne=f;function R(g){const t=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof t}e.$oe=R;function A(g){return typeof g=="number"&&!isNaN(g)}e.$pe=A;function m(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.$qe=m;function S(g){return g===!0||g===!1}e.$re=S;function $(g){return typeof g>"u"}e.$se=$;function P(g){return!I(g)}e.$te=P;function I(g){return $(g)||g===null}e.$ue=I;function p(g,t){if(!g)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$ve=p;function k(g){if(I(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.$we=k;function D(...g){const t=[];for(let o=0;o<g.length;o++){const c=g[o];if(I(c))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(c)}return t}e.$xe=D;const y=Object.prototype.hasOwnProperty;function r(g){if(!f(g))return!1;for(const t in g)if(y.call(g,t))return!1;return!0}e.$ye=r;function i(g){return typeof g=="function"}e.$ze=i;function s(...g){return g.length>0&&g.every(i)}e.$Ae=s;function d(g,t){const o=Math.min(g.length,t.length);for(let c=0;c<o;c++)b(g[c],t[c])}e.$Be=d;function b(g,t){if(C(t)){if(typeof g!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(i(t)){try{if(g instanceof t)return}catch{}if(!I(g)&&g.constructor===t||t.length===1&&t.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Ce=b}),define(De[78],Ce([1,0,18]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=void 0;const T=Object.create(null);function f(m,S){if((0,C.$le)(S)){const $=T[S];if($===void 0)throw new Error(`${m} references an unknown codicon: ${S}`);S=$}return T[m]=S,{id:m}}function R(){return T}e.$Lj=R;function A(){return Object.values(e.$Nj)}e.$Mj=A,e.$Nj={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package_:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,18]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=void 0;function T(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const s=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([d,b])=>{s[d]=b&&typeof b=="object"?T(b):b}),s}e.$Tm=T;function f(i){if(!i||typeof i!="object")return i;const s=[i];for(;s.length>0;){const d=s.shift();Object.freeze(d);for(const b in d)if(R.call(d,b)){const g=d[b];typeof g=="object"&&!Object.isFrozen(g)&&!(0,C.$oe)(g)&&s.push(g)}}return i}e.$Um=f;const R=Object.prototype.hasOwnProperty;function A(i,s){return m(i,s,new Set)}e.$Vm=A;function m(i,s,d){if((0,C.$ue)(i))return i;const b=s(i);if(typeof b<"u")return b;if(Array.isArray(i)){const g=[];for(const t of i)g.push(m(t,s,d));return g}if((0,C.$ne)(i)){if(d.has(i))throw new Error("Cannot clone recursive data-structure");d.add(i);const g={};for(const t in i)R.call(i,t)&&(g[t]=m(i[t],s,d));return d.delete(i),g}return i}function S(i,s,d=!0){return(0,C.$ne)(i)?((0,C.$ne)(s)&&Object.keys(s).forEach(b=>{b in i?d&&((0,C.$ne)(i[b])&&(0,C.$ne)(s[b])?S(i[b],s[b],d):i[b]=s[b]):i[b]=s[b]}),i):s}e.$Wm=S;function $(i,s){if(i===s)return!0;if(i==null||s===null||s===void 0||typeof i!=typeof s||typeof i!="object"||Array.isArray(i)!==Array.isArray(s))return!1;let d,b;if(Array.isArray(i)){if(i.length!==s.length)return!1;for(d=0;d<i.length;d++)if(!$(i[d],s[d]))return!1}else{const g=[];for(b in i)g.push(b);g.sort();const t=[];for(b in s)t.push(b);if(t.sort(),!$(g,t))return!1;for(d=0;d<g.length;d++)if(!$(i[g[d]],s[g[d]]))return!1}return!0}e.$Xm=$;function P(i){const s=new Set;return JSON.stringify(i,(d,b)=>{if((0,C.$ne)(b)||Array.isArray(b)){if(s.has(b))return"[Circular]";s.add(b)}return b})}e.$Ym=P;function I(i,s){const d=Object.create(null);return!i||!s||Object.keys(s).forEach(g=>{const t=i[g],o=s[g];$(t,o)||(d[g]=o)}),d}e.$Zm=I;function p(i,s){const d=s.toLowerCase(),b=Object.keys(i).find(g=>g.toLowerCase()===d);return b?i[b]:i[s]}e.$1m=p;function k(i,s){const d=Object.create(null);for(const[b,g]of Object.entries(i))s(b,g)&&(d[b]=g);return d}e.$2m=k;function D(i){let s=[];for(;Object.prototype!==i;)s=s.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return s}e.$3m=D;function y(i){const s=[];for(const d of D(i))typeof i[d]=="function"&&s.push(d);return s}e.$4m=y;function r(i,s){const d=g=>function(){const t=Array.prototype.slice.call(arguments,0);return s(g,t)},b={};for(const g of i)b[g]=d(g);return b}e.$5m=r}),define(De[59],Ce([1,0,78]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Oj=e.ThemeColor=void 0;var T;(function(A){function m(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=m})(T||(e.ThemeColor=T={}));function f(A){return{id:A}}e.$Oj=f;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(s){const d=m.exec(s.id);if(!d)return S(C.$Nj.error);const[,b,g]=d,t=["codicon","codicon-"+b];return g&&t.push("codicon-modifier-"+g.substring(1)),t}A.asClassNameArray=S;function $(s){return S(s).join(" ")}A.asClassName=$;function P(s){return"."+S(s).join(".")}A.asCSSSelector=P;function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||T.isThemeColor(s.color))}A.isThemeIcon=I;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function k(s){const d=p.exec(s);if(!d)return;const[,b]=d;return{id:b}}A.fromString=k;function D(s){return{id:s}}A.fromId=D;function y(s,d){let b=s.id;const g=b.lastIndexOf("~");return g!==-1&&(b=b.substring(0,g)),d&&(b=`${b}~${d}`),{id:b}}A.modify=y;function r(s){const d=s.id.lastIndexOf("~");if(d!==-1)return s.id.substring(d+1)}A.getModifier=r;function i(s,d){return s.id===d.id&&s.color?.id===d.color?.id}A.isEqual=i})(R||(e.ThemeIcon=R={}))}),define(De[161],Ce([1,0,121,15,59]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=void 0;const R="$(",A=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function S(i){return i.replace(m,(s,d)=>d?s:`\\${s}`)}e.$Pj=S;const $=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace($,s=>`\\${s}`)}e.$Qj=P;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(i){return i.indexOf(R)===-1?i:i.replace(I,(s,d,b,g)=>b?s:d||g||"")}e.$Rj=p;function k(i){return i?i.replace(/\$\((.*?)\)/g,(s,d)=>` ${d} `).trim():""}e.$Sj=k;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function y(i){D.lastIndex=0;let s="";const d=[];let b=0;for(;;){const g=D.lastIndex,t=D.exec(i),o=i.substring(g,t?.index);if(o.length>0){s+=o;for(let c=0;c<o.length;c++)d.push(b)}if(!t)break;b+=t[0].length}return{text:s,iconOffsets:d}}e.$Tj=y;function r(i,s,d=!1){const{text:b,iconOffsets:g}=s;if(!g||g.length===0)return(0,C.$Cj)(i,b,d);const t=(0,T.$wd)(b," "),o=b.length-t.length,c=(0,C.$Cj)(i,t,d);if(c)for(const n of c){const a=g[n.start+o]+o;n.start+=a,n.end+=a}return c}e.$Uj=r}),define(De[122],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.Constants=void 0;var C;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function T(R){return R<0?0:R>255?255:R|0}e.$md=T;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$nd=f}),define(De[31],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(f){return C.test(f)}e.$5e=T,e.$6e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(m){for(let S=0;S<m.length;S++)m[S]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,$="";return $+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$+="-",$+=A[R[S++]],$+=A[R[S++]],$+="-",$+=A[R[S++]],$+=A[R[S++]],$+="-",$+=A[R[S++]],$+=A[R[S++]],$+="-",$+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$+=A[R[S++]],$}}()}),define(De[162],Ce([1,0,19,50,31]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.$Os=e.$Ns=e.$Ms=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Ms=R;function A(I,p,k){const D={id:(0,f.$6e)(),name:I,uri:p,data:k};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$Ns=A;class m{constructor(){this.a=new Map}get size(){let p=0;for(const k of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const k=[...this.a.keys()];return T.Iterable.some(this,([D,y])=>y.asFile())&&k.push("files"),P(S(p),k)}get(p){return this.a.get(this.b(p))?.[0]}append(p,k){const D=this.a.get(p);D?D.push(k):this.a.set(this.b(p),[k])}replace(p,k){this.a.set(this.b(p),[k])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,k]of this.a)for(const D of k)yield[p,D]}b(p){return S(p)}}e.$Os=m;function S(I){return I.toLowerCase()}function $(I,p){return P(S(I),p.map(S))}e.$Ps=$;function P(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const k=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[D,y,r]=k;return r==="*"?p.some(i=>i.startsWith(y+"/")):!1}e.$Qs=Object.freeze({create:I=>(0,C.$Ff)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Qs.split(I).filter(p=>!p.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$8e=void 0;function T(m,S,$,P=1){let I=!1;return new Promise(p=>{const k=setTimeout(()=>{if(!I)return I=!0,p(0)},$);f(m,S,P,D=>{if(!I)return I=!0,clearTimeout(k),p(D)})})}e.$8e=T;function f(m,S,$,P){if(S===0)return P(0);const I=new C.Socket;I.once("connect",()=>(A(I),f(m+$,S-1,$,P))),I.once("data",()=>{}),I.once("error",p=>(A(I),p.code!=="ECONNREFUSED"?f(m+$,S-1,$,P):P(m))),I.connect(m,"127.0.0.1")}e.$9e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(m,S,$,P="127.0.0.1"){let I=!1,p,k=1;const D=C.createServer({pauseOnConnect:!0});function y(r,i){I||(I=!0,D.removeAllListeners(),D.close(),p&&clearTimeout(p),i(r))}return new Promise(r=>{p=setTimeout(()=>{y(0,r)},$),D.on("listening",()=>{y(m,r)}),D.on("error",i=>{i&&(i.code==="EADDRINUSE"||i.code==="EACCES")&&k<S?(m++,k++,D.listen(m,P)):y(0,r)}),D.on("close",()=>{y(0,r)}),D.listen(m,P)})}e.$0e=R;function A(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(S){console.error(S)}}}),define(De[123],Ce([1,0,122]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.$Es=void 0;class T{constructor(m){const S=(0,C.$md)(m);this.c=S,this.a=T.d(S),this.b=new Map}static d(m){const S=new Uint8Array(256);return S.fill(m),S}set(m,S){const $=(0,C.$md)(S);m>=0&&m<256?this.a[m]=$:this.b.set(m,$)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Es=T;var f;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new T(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Fs=R}),define(De[61],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;class C{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new C(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return C.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const A=f.lineNumber|0,m=R.lineNumber|0;if(A===m){const S=f.column|0,$=R.column|0;return S-$}return A-m}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$gs=C}),define(De[34],Ce([1,0,61]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=void 0;class T{constructor(R,A,m,S){R>m||R===m&&A>S?(this.startLineNumber=m,this.startColumn=S,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=m,this.endColumn=S)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,A){let m,S,$,P;return A.startLineNumber<R.startLineNumber?(m=A.startLineNumber,S=A.startColumn):A.startLineNumber===R.startLineNumber?(m=A.startLineNumber,S=Math.min(A.startColumn,R.startColumn)):(m=R.startLineNumber,S=R.startColumn),A.endLineNumber>R.endLineNumber?($=A.endLineNumber,P=A.endColumn):A.endLineNumber===R.endLineNumber?($=A.endLineNumber,P=Math.max(A.endColumn,R.endColumn)):($=R.endLineNumber,P=R.endColumn),new T(m,S,$,P)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,A){let m=R.startLineNumber,S=R.startColumn,$=R.endLineNumber,P=R.endColumn;const I=A.startLineNumber,p=A.startColumn,k=A.endLineNumber,D=A.endColumn;return m<I?(m=I,S=p):m===I&&(S=Math.max(S,p)),$>k?($=k,P=D):$===k&&(P=Math.min(P,D)),m>$||m===$&&S>P?null:new T(m,S,$,P)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new C.$gs(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new C.$gs(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new T(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new T(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new T(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const $=R.startLineNumber|0,P=A.startLineNumber|0;if($===P){const I=R.startColumn|0,p=A.startColumn|0;if(I===p){const k=R.endLineNumber|0,D=A.endLineNumber|0;if(k===D){const y=R.endColumn|0,r=A.endColumn|0;return y-r}return k-D}return I-p}return $-P}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$hs=T}),define(De[164],Ce([1,0,34]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class T{static insert(R,A){return{range:new C.$hs(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$is=T}),define(De[165],Ce([1,0,61,34]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.SelectionDirection=void 0;var f;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends T.$hs{constructor(m,S,$,P){super(m,S,$,P),this.selectionStartLineNumber=m,this.selectionStartColumn=S,this.positionLineNumber=$,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return R.selectionsEqual(this,m)}static selectionsEqual(m,S){return m.selectionStartLineNumber===S.selectionStartLineNumber&&m.selectionStartColumn===S.selectionStartColumn&&m.positionLineNumber===S.positionLineNumber&&m.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,S){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,m,S):new R(m,S,this.startLineNumber,this.startColumn)}getPosition(){return new C.$gs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$gs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,S){return this.getDirection()===0?new R(m,S,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,m,S)}static fromPositions(m,S=m){return new R(m.lineNumber,m.column,S.lineNumber,S.column)}static fromRange(m,S){return S===0?new R(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new R(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new R(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,S){if(m&&!S||!m&&S)return!1;if(!m&&!S)return!0;if(m.length!==S.length)return!1;for(let $=0,P=m.length;$<P;$++)if(!this.selectionsEqual(m[$],S[$]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,S,$,P,I){return I===0?new R(m,S,$,P):new R($,P,m,S)}}e.$js=R}),define(De[166],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0,e.$Rr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=e.$Gs=e.WordCharacterClass=void 0;var T;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class f extends C.$Es{constructor(m){super(0);for(let S=0,$=m.length;S<$;S++)this.set(m.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.$Gs=f;function R(A){const m={};return S=>(m.hasOwnProperty(S)||(m[S]=A(S)),m[S])}e.$Hs=R(A=>new f(A))}),define(De[124],Ce([1,0,50,3,75]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=void 0,e.$Sr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$Sr)I.indexOf(k)>=0||(p+="\\"+k);return p+="\\s]+)",new RegExp(p,"g")}e.$Tr=R();function A(I){let p=e.$Tr;if(I&&I instanceof RegExp)if(I.global)p=I;else{let k="g";I.ignoreCase&&(k+="i"),I.multiline&&(k+="m"),I.unicode&&(k+="u"),p=new RegExp(I.source,k)}return p.lastIndex=0,p}e.$Ur=A;const m=new f.$vb;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(I){const p=m.unshift(I);return(0,T.$kb)(p)}e.$Vr=S;function $(I,p,k,D,y){if(y||(y=C.Iterable.first(m)),k.length>y.maxLen){let b=I-y.maxLen/2;return b<0?b=0:D+=b,k=k.substring(b,I+y.maxLen/2),$(I,p,k,D,y)}const r=Date.now(),i=I-1-D;let s=-1,d=null;for(let b=1;!(Date.now()-r>=y.timeBudget);b++){const g=i-y.windowSize*b;p.lastIndex=Math.max(0,g);const t=P(p,k,i,s);if(!t&&d||(d=t,g<=0))break;s=g}if(d){const b={word:d[0],startColumn:D+1+d.index,endColumn:D+1+d.index+d[0].length};return p.lastIndex=0,b}return null}e.$Wr=$;function P(I,p,k,D){let y;for(;y=I.exec(p);){const r=y.index||0;if(r<=k&&I.lastIndex>=k)return y;if(D>0&&r>D)return null}return null}}),define(De[168],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let S=0,$=m.notIn.length;S<$;S++)switch(m.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,S){if(m.getTokenCount()===0)return!0;const $=m.findTokenIndexAtOffset(S-2),P=m.getStandardTokenType($);return this.isOK(P)}g(m,S){for(let $=m;$<=S;$++){const P=String.fromCharCode($);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$dt=T;class f{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of m)R(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),R(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),R(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),R(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&R(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$et=f;function R(A,m,S){A.has(m)?A.get(m).push(S):A.set(m,[S])}}),define(De[169],Ce([1,0,123]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pY=e.$oY=e.$nY=e.State=void 0;var T;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class f{constructor(D,y,r){const i=new Uint8Array(D*y);for(let s=0,d=D*y;s<d;s++)i[s]=r;this.a=i,this.rows=D,this.cols=y}get(D,y){return this.a[D*this.cols+y]}set(D,y,r){this.a[D*this.cols+y]=r}}class R{constructor(D){let y=0,r=0;for(let s=0,d=D.length;s<d;s++){const[b,g,t]=D[s];g>y&&(y=g),b>r&&(r=b),t>r&&(r=t)}y++,r++;const i=new f(r,y,0);for(let s=0,d=D.length;s<d;s++){const[b,g,t]=D[s];i.set(b,g,t)}this.a=i,this.b=y}nextState(D,y){return y<0||y>=this.b?0:this.a.get(D,y)}}e.$nY=R;let A=null;function m(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var S;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let $=null;function P(){if($===null){$=new C.$Es(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let y=0;y<k.length;y++)$.set(k.charCodeAt(y),1);const D=".,;:";for(let y=0;y<D.length;y++)$.set(D.charCodeAt(y),2)}return $}class I{static a(D,y,r,i,s){let d=s-1;do{const b=y.charCodeAt(d);if(D.get(b)!==2)break;d--}while(d>i);if(i>0){const b=y.charCodeAt(i-1),g=y.charCodeAt(d);(b===40&&g===41||b===91&&g===93||b===123&&g===125)&&d--}return{range:{startLineNumber:r,startColumn:i+1,endLineNumber:r,endColumn:d+2},url:y.substring(i,d+1)}}static computeLinks(D,y=m()){const r=P(),i=[];for(let s=1,d=D.getLineCount();s<=d;s++){const b=D.getLineContent(s),g=b.length;let t=0,o=0,c=0,n=1,a=!1,l=!1,v=!1,E=!1;for(;t<g;){let u=!1;const h=b.charCodeAt(t);if(n===13){let w;switch(h){case 40:a=!0,w=0;break;case 41:w=a?0:1;break;case 91:v=!0,l=!0,w=0;break;case 93:v=!1,w=l?0:1;break;case 123:E=!0,w=0;break;case 125:w=E?0:1;break;case 39:case 34:case 96:c===h?w=1:c===39||c===34||c===96?w=0:w=1;break;case 42:w=c===42?1:0;break;case 124:w=c===124?1:0;break;case 32:w=v?0:1;break;default:w=r.get(h)}w===1&&(i.push(I.a(r,b,s,o,t)),u=!0)}else if(n===12){let w;h===91?(l=!0,w=0):w=r.get(h),w===1?u=!0:n=13}else n=y.nextState(n,h),n===0&&(u=!0);u&&(n=1,a=!1,l=!1,E=!1,o=t+1,c=h),t++}n===13&&i.push(I.a(r,b,s,o,g))}return i}}e.$oY=I;function p(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:I.computeLinks(k)}e.$pY=p}),define(De[125],Ce([1,0,23]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Du=e.$Cu=e.$Bu=e.$Au=e.ModelConstants=e.PositionAffinity=e.$zu=e.TrackedRangeStickiness=e.$yu=e.$xu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var f;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var m;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var S;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var $;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})($||(e.EndOfLineSequence=$={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=!!g.insertSpaces,this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=!!g.trimAutoWhitespace,this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,C.$Xm)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.$xu=P;class I{constructor(g,t){this._findMatchBrand=void 0,this.range=g,this.matches=t}}e.$yu=I;var p;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function k(b){return b&&typeof b.read=="function"}e.$zu=k;var D;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var y;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y||(e.ModelConstants=y={}));class r{constructor(g,t,o,c,n,a){this.identifier=g,this.range=t,this.text=o,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=n,this._isTracked=a}}e.$Au=r;class i{constructor(g,t,o){this.regex=g,this.wordSeparators=t,this.simpleSearch=o}}e.$Bu=i;class s{constructor(g,t,o){this.reverseEdits=g,this.changes=t,this.trimAutoWhitespaceLineNumbers=o}}e.$Cu=s;function d(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.$Du=d}),define(De[170],Ce([1,0,19,122]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=e.$Hu=e.$Gu=void 0;class f{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,$){S=(0,T.$nd)(S);const P=this.a,I=this.b,p=$.length;return p===0?!1:(this.a=new Uint32Array(P.length+p),this.a.set(P.subarray(0,S),0),this.a.set(P.subarray(S),S+p),this.a.set($,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(S,$){return S=(0,T.$nd)(S),$=(0,T.$nd)($),this.a[S]===$?!1:(this.a[S]=$,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,$){S=(0,T.$nd)(S),$=(0,T.$nd)($);const P=this.a,I=this.b;if(S>=P.length)return!1;const p=P.length-S;return $>=p&&($=p),$===0?!1:(this.a=new Uint32Array(P.length-$),this.a.set(P.subarray(0,S),0),this.a.set(P.subarray(S+$),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,T.$nd)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let $=this.c[0]+1;$===0&&(this.b[0]=this.a[0],$++),S>=this.a.length&&(S=this.a.length-1);for(let P=$;P<=S;P++)this.b[P]=this.b[P-1]+this.a[P];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let $=0,P=this.a.length-1,I=0,p=0,k=0;for(;$<=P;)if(I=$+(P-$)/2|0,p=this.b[I],k=p-this.a[I],S<k)P=I-1;else if(S>=p)$=I+1;else break;return new A(I,S-k)}}e.$Gu=f;class R{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const $=this.e[S],P=$>0?this.d[$-1]:0;return new A($,S-P)}removeValues(S,$){this.a.splice(S,$),this.f(S)}insertValues(S,$){this.a=(0,C.$Pf)(this.a,S,$),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,$=this.a.length;S<$;S++){const P=this.a[S],I=S>0?this.d[S-1]:0;this.d[S]=I+P;for(let p=0;p<P;p++)this.e[I+p]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,$){this.a[S]!==$&&(this.a[S]=$,this.f(S))}}e.$Hu=R;class A{constructor(S,$){this.index=S,this.remainder=$,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=$}}e.$Iu=A}),define(De[171],Ce([1,0,15,61,170]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ju=void 0;class R{constructor(m,S,$,P){this.d=m,this.f=S,this.g=$,this.h=P,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const S=m.changes;for(const $ of S)this.o($.range),this.p(new T.$gs($.range.startLineNumber,$.range.startColumn),$.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,S=this.f.length,$=new Uint32Array(S);for(let P=0;P<S;P++)$[P]=this.f[P].length+m;this.j=new f.$Gu($)}}n(m,S){this.f[m]=S,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,S){if(S.length===0)return;const $=(0,C.$Cd)(S);if($.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+$[0]+this.f[m.lineNumber-1].substring(m.column-1));return}$[$.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+$[0]);const P=new Uint32Array($.length-1);for(let I=1;I<$.length;I++)this.f.splice(m.lineNumber+I-1,0,$[I]),P[I-1]=$[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,P)}}e.$Ju=R}),define(De[172],Ce([1,0,15,167,61,34,125]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=e.$hC=e.$gC=e.$fC=e.$eC=e.$dC=void 0;const m=999;class S{constructor(s,d,b,g){this.searchString=s,this.isRegex=d,this.matchCase=b,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=$(this.searchString):s=this.searchString.indexOf(`
`)>=0;let d=null;try{d=C.$Ad(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch{return null}if(!d)return null;let b=!this.isRegex&&!s;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new A.$Bu(d,this.wordSeparators?(0,T.$Hs)(this.wordSeparators):null,b?this.searchString:null)}}e.$dC=S;function $(i){if(!i||i.length===0)return!1;for(let s=0,d=i.length;s<d;s++){const b=i.charCodeAt(s);if(b===10)return!0;if(b===92){if(s++,s>=d)break;const g=i.charCodeAt(s);if(g===110||g===114||g===87)return!0}}return!1}e.$eC=$;function P(i,s,d){if(!d)return new A.$yu(i,null);const b=[];for(let g=0,t=s.length;g<t;g++)b[g]=s[g];return new A.$yu(i,b)}e.$fC=P;class I{constructor(s){const d=[];let b=0;for(let g=0,t=s.length;g<t;g++)s.charCodeAt(g)===10&&(d[b++]=g);this.a=d}findLineFeedCountBeforeOffset(s){const d=this.a;let b=0,g=d.length-1;if(g===-1||s<=d[0])return 0;for(;b<g;){const t=b+((g-b)/2>>0);d[t]>=s?g=t-1:d[t+1]>=s?(b=t,g=t):b=t+1}return b+1}}class p{static findMatches(s,d,b,g,t){const o=d.parseSearchRequest();return o?o.regex.multiline?this.b(s,b,new r(o.wordSeparators,o.regex),g,t):this.c(s,b,o,g,t):[]}static a(s,d,b,g,t,o){let c,n=0;g?(n=g.findLineFeedCountBeforeOffset(t),c=d+t+n):c=d+t;let a;if(g){const u=g.findLineFeedCountBeforeOffset(t+o.length)-n;a=c+o.length+u}else a=c+o.length;const l=s.getPositionAt(c),v=s.getPositionAt(a);return new R.$hs(l.lineNumber,l.column,v.lineNumber,v.column)}static b(s,d,b,g,t){const o=s.getOffsetAt(d.getStartPosition()),c=s.getValueInRange(d,1),n=s.getEOL()===`\r
`?new I(c):null,a=[];let l=0,v;for(b.reset(0);v=b.next(c);)if(a[l++]=P(this.a(s,o,c,n,v.index,v[0]),v,g),l>=t)return a;return a}static c(s,d,b,g,t){const o=[];let c=0;if(d.startLineNumber===d.endLineNumber){const a=s.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return c=this.d(b,a,d.startLineNumber,d.startColumn-1,c,o,g,t),o}const n=s.getLineContent(d.startLineNumber).substring(d.startColumn-1);c=this.d(b,n,d.startLineNumber,d.startColumn-1,c,o,g,t);for(let a=d.startLineNumber+1;a<d.endLineNumber&&c<t;a++)c=this.d(b,s.getLineContent(a),a,0,c,o,g,t);if(c<t){const a=s.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);c=this.d(b,a,d.endLineNumber,0,c,o,g,t)}return o}static d(s,d,b,g,t,o,c,n){const a=s.wordSeparators;if(!c&&s.simpleSearch){const E=s.simpleSearch,u=E.length,h=d.length;let w=-u;for(;(w=d.indexOf(E,w+u))!==-1;)if((!a||y(a,d,h,w,u))&&(o[t++]=new A.$yu(new R.$hs(b,w+1+g,b,w+1+u+g),null),t>=n))return t;return t}const l=new r(s.wordSeparators,s.regex);let v;l.reset(0);do if(v=l.next(d),v&&(o[t++]=P(new R.$hs(b,v.index+1+g,b,v.index+1+v[0].length+g),v,c),t>=n))return t;while(v);return t}static findNextMatch(s,d,b,g){const t=d.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.e(s,b,o,g):this.f(s,b,o,g)}static e(s,d,b,g){const t=new f.$gs(d.lineNumber,1),o=s.getOffsetAt(t),c=s.getLineCount(),n=s.getValueInRange(new R.$hs(t.lineNumber,t.column,c,s.getLineMaxColumn(c)),1),a=s.getEOL()===`\r
`?new I(n):null;b.reset(d.column-1);const l=b.next(n);return l?P(this.a(s,o,n,a,l.index,l[0]),l,g):d.lineNumber!==1||d.column!==1?this.e(s,new f.$gs(1,1),b,g):null}static f(s,d,b,g){const t=s.getLineCount(),o=d.lineNumber,c=s.getLineContent(o),n=this.g(b,c,o,d.column,g);if(n)return n;for(let a=1;a<=t;a++){const l=(o+a-1)%t,v=s.getLineContent(l+1),E=this.g(b,v,l+1,1,g);if(E)return E}return null}static g(s,d,b,g,t){s.reset(g-1);const o=s.next(d);return o?P(new R.$hs(b,o.index+1,b,o.index+1+o[0].length),o,t):null}static findPreviousMatch(s,d,b,g){const t=d.parseSearchRequest();if(!t)return null;const o=new r(t.wordSeparators,t.regex);return t.regex.multiline?this.h(s,b,o,g):this.j(s,b,o,g)}static h(s,d,b,g){const t=this.b(s,new R.$hs(1,1,d.lineNumber,d.column),b,g,10*m);if(t.length>0)return t[t.length-1];const o=s.getLineCount();return d.lineNumber!==o||d.column!==s.getLineMaxColumn(o)?this.h(s,new f.$gs(o,s.getLineMaxColumn(o)),b,g):null}static j(s,d,b,g){const t=s.getLineCount(),o=d.lineNumber,c=s.getLineContent(o).substring(0,d.column-1),n=this.k(b,c,o,g);if(n)return n;for(let a=1;a<=t;a++){const l=(t+o-a-1)%t,v=s.getLineContent(l+1),E=this.k(b,v,l+1,g);if(E)return E}return null}static k(s,d,b,g){let t=null,o;for(s.reset(0);o=s.next(d);)t=P(new R.$hs(b,o.index+1,b,o.index+1+o[0].length),o,g);return t}}e.$gC=p;function k(i,s,d,b,g){if(b===0)return!0;const t=s.charCodeAt(b-1);if(i.get(t)!==0||t===13||t===10)return!0;if(g>0){const o=s.charCodeAt(b);if(i.get(o)!==0)return!0}return!1}function D(i,s,d,b,g){if(b+g===d)return!0;const t=s.charCodeAt(b+g);if(i.get(t)!==0||t===13||t===10)return!0;if(g>0){const o=s.charCodeAt(b+g-1);if(i.get(o)!==0)return!0}return!1}function y(i,s,d,b,g){return k(i,s,d,b,g)&&D(i,s,d,b,g)}e.$hC=y;class r{constructor(s,d){this._wordSeparators=s,this.a=d,this.b=-1,this.c=0}reset(s){this.a.lastIndex=s,this.b=-1,this.c=0}next(s){const d=s.length;let b;do{if(this.b+this.c===d||(b=this.a.exec(s),!b))return null;const g=b.index,t=b[0].length;if(g===this.b&&t===this.c){if(t===0){C.$Vd(s,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=t,!this._wordSeparators||y(this._wordSeparators,s,d,g,t))return b}while(b);return null}}e.$iC=r}),define(De[173],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7=e.$_6=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$_6=C;class T{constructor(R){this.identifier=R}}e.$a7=T}),define(De[174],Ce([1,0,4,3]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$hc,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,S){return this.a.set(m,S),this.handleChange([m]),(0,T.$kb)(()=>{this.a.get(m)===S&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,S){this.b.get(m)?.dispose();const $=new R(this,m,S);return this.b.set(m,$),(0,T.$kb)(()=>{const P=this.b.get(m);!P||P!==$||(this.b.delete(m),P.dispose())})}async getOrCreate(m){const S=this.get(m);if(S)return S;const $=this.b.get(m);return!$||$.isResolved?null:(await $.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const $=this.b.get(m);return!!(!$||$.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ss=f;class R extends T.$mb{get isResolved(){return this.c}constructor(m,S,$){super(),this.f=m,this.g=S,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[175],Ce([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class R extends T.$mb{constructor(p,k="",D="",y=!0,r){super(),this.h=this.B(new C.$hc),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=k,this.u=D,this.w=y,this.C=r}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,k){this.C&&await this.C(p)}}e.$ei=R;class A extends T.$mb{constructor(){super(...arguments),this.f=this.B(new C.$hc),this.onWillRun=this.f.event,this.k=this.B(new C.$hc),this.onDidRun=this.k.event}async run(p,k){if(!p.enabled)return;this.f.fire({action:p});let D;try{await this.l(p,k)}catch(y){D=y}this.k.fire({action:p,error:D})}async l(p,k){await p.run(k)}}e.$fi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let k=[];for(const D of p)D.length&&(k.length?k=[...k,new m,...D]:k=D);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$gi=m;class S{get actions(){return this.a}constructor(p,k,D,y){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=k,this.class=y,this.a=D}async run(){}}e.$hi=S;class $ extends R{static{this.ID="vs.actions.empty"}constructor(){super($.ID,f.localize(0,null),void 0,!1)}}e.$ii=$;function P(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$ji=P}),define(De[177],Ce([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=void 0;const T=60,f=T*60,R=f*24,A=R*7,m=R*30,S=R*365;function $(I,p,k,D){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,C.localize)(0,null,$(new Date().getTime()+y*1e3,!1));if(!D&&y<30)return(0,C.localize)(1,null);let r;return y<T?(r=y,p?r===1?k?(0,C.localize)(2,null,r):(0,C.localize)(3,null,r):k?(0,C.localize)(4,null,r):(0,C.localize)(5,null,r):r===1?k?(0,C.localize)(6,null,r):(0,C.localize)(7,null,r):k?(0,C.localize)(8,null,r):(0,C.localize)(9,null,r)):y<f?(r=Math.floor(y/T),p?r===1?k?(0,C.localize)(10,null,r):(0,C.localize)(11,null,r):k?(0,C.localize)(12,null,r):(0,C.localize)(13,null,r):r===1?k?(0,C.localize)(14,null,r):(0,C.localize)(15,null,r):k?(0,C.localize)(16,null,r):(0,C.localize)(17,null,r)):y<R?(r=Math.floor(y/f),p?r===1?k?(0,C.localize)(18,null,r):(0,C.localize)(19,null,r):k?(0,C.localize)(20,null,r):(0,C.localize)(21,null,r):r===1?k?(0,C.localize)(22,null,r):(0,C.localize)(23,null,r):k?(0,C.localize)(24,null,r):(0,C.localize)(25,null,r)):y<A?(r=Math.floor(y/R),p?r===1?(0,C.localize)(26,null,r):(0,C.localize)(27,null,r):r===1?(0,C.localize)(28,null,r):(0,C.localize)(29,null,r)):y<m?(r=Math.floor(y/A),p?r===1?k?(0,C.localize)(30,null,r):(0,C.localize)(31,null,r):k?(0,C.localize)(32,null,r):(0,C.localize)(33,null,r):r===1?k?(0,C.localize)(34,null,r):(0,C.localize)(35,null,r):k?(0,C.localize)(36,null,r):(0,C.localize)(37,null,r)):y<S?(r=Math.floor(y/m),p?r===1?k?(0,C.localize)(38,null,r):(0,C.localize)(39,null,r):k?(0,C.localize)(40,null,r):(0,C.localize)(41,null,r):r===1?k?(0,C.localize)(42,null,r):(0,C.localize)(43,null,r):k?(0,C.localize)(44,null,r):(0,C.localize)(45,null,r)):(r=Math.floor(y/S),p?r===1?k?(0,C.localize)(46,null,r):(0,C.localize)(47,null,r):k?(0,C.localize)(48,null,r):(0,C.localize)(49,null,r):r===1?k?(0,C.localize)(50,null,r):(0,C.localize)(51,null,r):k?(0,C.localize)(52,null,r):(0,C.localize)(53,null,r))}e.$4l=$;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$5l=P}),define(De[179],Ce([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(De[46],Ce([1,0,19,18,179]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=void 0;function R(I,p){return p&&(I.stack||I.stacktrace)?f.localize(0,null,m(I),A(I.stack)||A(I.stacktrace)):m(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function S(I=null,p=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const k=C.$Af(I),D=S(k[0],p);return k.length>1?f.localize(4,null,D,k.length):D}if(T.$le(I))return I;if(I.detail){const k=I.detail;if(k.error)return R(k.error,p);if(k.exception)return R(k.exception,p)}return I.stack?R(I,p):I.message?I.message:f.localize(5,null)}e.$ki=S;function $(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}e.$li=$;function P(I,p){let k;return typeof I=="string"?k=new Error(I):k=I,k.actions=p,k}e.$mi=P}),define(De[180],Ce([9,10]),function(be,e){return be.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let T=!1,f=!1,R=!1,A=!1,m=!1,S=!1,$=!1,P=!1,I=!1,p=!1,k,D=e.$f,y=e.$f,r,i;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?s=e.$g.vscode.process:typeof process<"u"&&(s=process);const d=typeof s?.versions?.electron=="string",b=d&&s?.type==="renderer";if(typeof navigator=="object"&&!b)i=navigator.userAgent,T=i.indexOf("Windows")>=0,f=i.indexOf("Macintosh")>=0,P=(i.indexOf("Macintosh")>=0||i.indexOf("iPad")>=0||i.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=i.indexOf("Linux")>=0,p=i?.indexOf("Mobi")>=0,S=!0,k=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$f,D=k,y=navigator.language;else if(typeof s=="object"){T=s.platform==="win32",f=s.platform==="darwin",R=s.platform==="linux",A=R&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,$=d,I=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$f,D=e.$f;const E=s.env.VSCODE_NLS_CONFIG;if(E)try{const u=JSON.parse(E),h=u.availableLanguages["*"];k=u.locale,y=u.osLocale,D=h||e.$f,r=u._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var g;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(g||(e.Platform=g={}));function t(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let o=0;f?o=1:T?o=3:R&&(o=2),e.$i=T,e.$j=f,e.$k=R,e.$l=A,e.$m=m,e.$n=$,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=p,e.$s=I,e.$t=o,e.$u=i,e.$v=D;var c;(function(E){function u(){return e.$v}E.value=u;function h(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}E.isDefaultVariant=h;function w(){return e.$v==="en"}E.isDefault=w})(c||(e.Language=c={})),e.$w=k,e.$x=y,e.$y=r,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const E=[];e.$g.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let w=0,L=E.length;w<L;w++){const O=E[w];if(O.id===h.data.vscodeScheduleAsyncWork){E.splice(w,1),O.callback();return}}});let u=0;return h=>{const w=++u;E.push({id:w,callback:h}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=f||P?2:T?1:3;let a=!0,l=!1;function v(){if(!l){l=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,a=new Uint16Array(E.buffer)[0]===(2<<8)+1}return a}e.$C=v,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(De[47],Ce([1,0,12]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.env=e.cwd=void 0;let T;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.process<"u"){const f=C.$g.vscode.process;T={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$5c=T.platform,e.$6c=T.arch}),define(De[16],Ce([1,0,47]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.sep=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;const T=65,f=97,R=90,A=122,m=46,S=47,$=92,P=58,I=63;class p extends Error{constructor(o,c,n){let a;typeof c=="string"&&c.indexOf("not ")===0?(a="must not be",c=c.replace(/^not /,"")):a="must be";const l=o.indexOf(".")!==-1?"property":"argument";let v=`The "${o}" ${l} ${a} of type ${c}`;v+=`. Received type ${typeof n}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function D(t,o){if(typeof t!="string")throw new p(o,"string",t)}const y=C.$5c==="win32";function r(t){return t===S||t===$}function i(t){return t===S}function s(t){return t>=T&&t<=R||t>=f&&t<=A}function d(t,o,c,n){let a="",l=0,v=-1,E=0,u=0;for(let h=0;h<=t.length;++h){if(h<t.length)u=t.charCodeAt(h);else{if(n(u))break;u=S}if(n(u)){if(!(v===h-1||E===1))if(E===2){if(a.length<2||l!==2||a.charCodeAt(a.length-1)!==m||a.charCodeAt(a.length-2)!==m){if(a.length>2){const w=a.lastIndexOf(c);w===-1?(a="",l=0):(a=a.slice(0,w),l=a.length-1-a.lastIndexOf(c)),v=h,E=0;continue}else if(a.length!==0){a="",l=0,v=h,E=0;continue}}o&&(a+=a.length>0?`${c}..`:"..",l=2)}else a.length>0?a+=`${c}${t.slice(v+1,h)}`:a=t.slice(v+1,h),l=h-v-1;v=h,E=0}else u===m&&E!==-1?++E:E=-1}return a}function b(t,o){k(o,"pathObject");const c=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${n}`:`${c}${t}${n}`:n}e.$7c={resolve(...t){let o="",c="",n=!1;for(let a=t.length-1;a>=-1;a--){let l;if(a>=0){if(l=t[a],D(l,"path"),l.length===0)continue}else o.length===0?l=C.cwd():(l=C.env[`=${o}`]||C.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==o.toLowerCase()&&l.charCodeAt(2)===$)&&(l=`${o}\\`));const v=l.length;let E=0,u="",h=!1;const w=l.charCodeAt(0);if(v===1)r(w)&&(E=1,h=!0);else if(r(w))if(h=!0,r(l.charCodeAt(1))){let L=2,O=L;for(;L<v&&!r(l.charCodeAt(L));)L++;if(L<v&&L!==O){const N=l.slice(O,L);for(O=L;L<v&&r(l.charCodeAt(L));)L++;if(L<v&&L!==O){for(O=L;L<v&&!r(l.charCodeAt(L));)L++;(L===v||L!==O)&&(u=`\\\\${N}\\${l.slice(O,L)}`,E=L)}}}else E=1;else s(w)&&l.charCodeAt(1)===P&&(u=l.slice(0,2),E=2,v>2&&r(l.charCodeAt(2))&&(h=!0,E=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(n){if(o.length>0)break}else if(c=`${l.slice(E)}\\${c}`,n=h,h&&o.length>0)break}return c=d(c,!n,"\\",r),n?`${o}\\${c}`:`${o}${c}`||"."},normalize(t){D(t,"path");const o=t.length;if(o===0)return".";let c=0,n,a=!1;const l=t.charCodeAt(0);if(o===1)return i(l)?"\\":t;if(r(l))if(a=!0,r(t.charCodeAt(1))){let E=2,u=E;for(;E<o&&!r(t.charCodeAt(E));)E++;if(E<o&&E!==u){const h=t.slice(u,E);for(u=E;E<o&&r(t.charCodeAt(E));)E++;if(E<o&&E!==u){for(u=E;E<o&&!r(t.charCodeAt(E));)E++;if(E===o)return`\\\\${h}\\${t.slice(u)}\\`;E!==u&&(n=`\\\\${h}\\${t.slice(u,E)}`,c=E)}}}else c=1;else s(l)&&t.charCodeAt(1)===P&&(n=t.slice(0,2),c=2,o>2&&r(t.charCodeAt(2))&&(a=!0,c=3));let v=c<o?d(t.slice(c),!a,"\\",r):"";return v.length===0&&!a&&(v="."),v.length>0&&r(t.charCodeAt(o-1))&&(v+="\\"),n===void 0?a?`\\${v}`:v:a?`${n}\\${v}`:`${n}${v}`},isAbsolute(t){D(t,"path");const o=t.length;if(o===0)return!1;const c=t.charCodeAt(0);return r(c)||o>2&&s(c)&&t.charCodeAt(1)===P&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,c;for(let l=0;l<t.length;++l){const v=t[l];D(v,"path"),v.length>0&&(o===void 0?o=c=v:o+=`\\${v}`)}if(o===void 0)return".";let n=!0,a=0;if(typeof c=="string"&&r(c.charCodeAt(0))){++a;const l=c.length;l>1&&r(c.charCodeAt(1))&&(++a,l>2&&(r(c.charCodeAt(2))?++a:n=!1))}if(n){for(;a<o.length&&r(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.$7c.normalize(o)},relative(t,o){if(D(t,"from"),D(o,"to"),t===o)return"";const c=e.$7c.resolve(t),n=e.$7c.resolve(o);if(c===n||(t=c.toLowerCase(),o=n.toLowerCase(),t===o))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===$;)a++;let l=t.length;for(;l-1>a&&t.charCodeAt(l-1)===$;)l--;const v=l-a;let E=0;for(;E<o.length&&o.charCodeAt(E)===$;)E++;let u=o.length;for(;u-1>E&&o.charCodeAt(u-1)===$;)u--;const h=u-E,w=v<h?v:h;let L=-1,O=0;for(;O<w;O++){const M=t.charCodeAt(a+O);if(M!==o.charCodeAt(E+O))break;M===$&&(L=O)}if(O!==w){if(L===-1)return n}else{if(h>w){if(o.charCodeAt(E+O)===$)return n.slice(E+O+1);if(O===2)return n.slice(E+O)}v>w&&(t.charCodeAt(a+O)===$?L=O:O===2&&(L=3)),L===-1&&(L=0)}let N="";for(O=a+L+1;O<=l;++O)(O===l||t.charCodeAt(O)===$)&&(N+=N.length===0?"..":"\\..");return E+=L,N.length>0?`${N}${n.slice(E,u)}`:(n.charCodeAt(E)===$&&++E,n.slice(E,u))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$7c.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===$){if(o.charCodeAt(1)===$){const c=o.charCodeAt(2);if(c!==I&&c!==m)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(s(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===$)return`\\\\?\\${o}`;return t},dirname(t){D(t,"path");const o=t.length;if(o===0)return".";let c=-1,n=0;const a=t.charCodeAt(0);if(o===1)return r(a)?t:".";if(r(a)){if(c=n=1,r(t.charCodeAt(1))){let E=2,u=E;for(;E<o&&!r(t.charCodeAt(E));)E++;if(E<o&&E!==u){for(u=E;E<o&&r(t.charCodeAt(E));)E++;if(E<o&&E!==u){for(u=E;E<o&&!r(t.charCodeAt(E));)E++;if(E===o)return t;E!==u&&(c=n=E+1)}}}}else s(a)&&t.charCodeAt(1)===P&&(c=o>2&&r(t.charCodeAt(2))?3:2,n=c);let l=-1,v=!0;for(let E=o-1;E>=n;--E)if(r(t.charCodeAt(E))){if(!v){l=E;break}}else v=!1;if(l===-1){if(c===-1)return".";l=c}return t.slice(0,l)},basename(t,o){o!==void 0&&D(o,"ext"),D(t,"path");let c=0,n=-1,a=!0,l;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(c=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let v=o.length-1,E=-1;for(l=t.length-1;l>=c;--l){const u=t.charCodeAt(l);if(r(u)){if(!a){c=l+1;break}}else E===-1&&(a=!1,E=l+1),v>=0&&(u===o.charCodeAt(v)?--v===-1&&(n=l):(v=-1,n=E))}return c===n?n=E:n===-1&&(n=t.length),t.slice(c,n)}for(l=t.length-1;l>=c;--l)if(r(t.charCodeAt(l))){if(!a){c=l+1;break}}else n===-1&&(a=!1,n=l+1);return n===-1?"":t.slice(c,n)},extname(t){D(t,"path");let o=0,c=-1,n=0,a=-1,l=!0,v=0;t.length>=2&&t.charCodeAt(1)===P&&s(t.charCodeAt(0))&&(o=n=2);for(let E=t.length-1;E>=o;--E){const u=t.charCodeAt(E);if(r(u)){if(!l){n=E+1;break}continue}a===-1&&(l=!1,a=E+1),u===m?c===-1?c=E:v!==1&&(v=1):c!==-1&&(v=-1)}return c===-1||a===-1||v===0||v===1&&c===a-1&&c===n+1?"":t.slice(c,a)},format:b.bind(null,"\\"),parse(t){D(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const c=t.length;let n=0,a=t.charCodeAt(0);if(c===1)return r(a)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(r(a)){if(n=1,r(t.charCodeAt(1))){let L=2,O=L;for(;L<c&&!r(t.charCodeAt(L));)L++;if(L<c&&L!==O){for(O=L;L<c&&r(t.charCodeAt(L));)L++;if(L<c&&L!==O){for(O=L;L<c&&!r(t.charCodeAt(L));)L++;L===c?n=L:L!==O&&(n=L+1)}}}}else if(s(a)&&t.charCodeAt(1)===P){if(c<=2)return o.root=o.dir=t,o;if(n=2,r(t.charCodeAt(2))){if(c===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let l=-1,v=n,E=-1,u=!0,h=t.length-1,w=0;for(;h>=n;--h){if(a=t.charCodeAt(h),r(a)){if(!u){v=h+1;break}continue}E===-1&&(u=!1,E=h+1),a===m?l===-1?l=h:w!==1&&(w=1):l!==-1&&(w=-1)}return E!==-1&&(l===-1||w===0||w===1&&l===E-1&&l===v+1?o.base=o.name=t.slice(v,E):(o.name=t.slice(v,l),o.base=t.slice(v,E),o.ext=t.slice(l,E))),v>0&&v!==n?o.dir=t.slice(0,v-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(y){const t=/\\/g;return()=>{const o=C.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>C.cwd()})();e.$8c={resolve(...t){let o="",c=!1;for(let n=t.length-1;n>=-1&&!c;n--){const a=n>=0?t[n]:g();D(a,"path"),a.length!==0&&(o=`${a}/${o}`,c=a.charCodeAt(0)===S)}return o=d(o,!c,"/",i),c?`/${o}`:o.length>0?o:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,c=t.charCodeAt(t.length-1)===S;return t=d(t,!o,"/",i),t.length===0?o?"/":c?"./":".":(c&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let c=0;c<t.length;++c){const n=t[c];D(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$8c.normalize(o)},relative(t,o){if(D(t,"from"),D(o,"to"),t===o||(t=e.$8c.resolve(t),o=e.$8c.resolve(o),t===o))return"";const c=1,n=t.length,a=n-c,l=1,v=o.length-l,E=a<v?a:v;let u=-1,h=0;for(;h<E;h++){const L=t.charCodeAt(c+h);if(L!==o.charCodeAt(l+h))break;L===S&&(u=h)}if(h===E)if(v>E){if(o.charCodeAt(l+h)===S)return o.slice(l+h+1);if(h===0)return o.slice(l+h)}else a>E&&(t.charCodeAt(c+h)===S?u=h:h===0&&(u=0));let w="";for(h=c+u+1;h<=n;++h)(h===n||t.charCodeAt(h)===S)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(l+u)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let c=-1,n=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===S){if(!n){c=a;break}}else n=!1;return c===-1?o?"/":".":o&&c===1?"//":t.slice(0,c)},basename(t,o){o!==void 0&&D(o,"ext"),D(t,"path");let c=0,n=-1,a=!0,l;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let v=o.length-1,E=-1;for(l=t.length-1;l>=0;--l){const u=t.charCodeAt(l);if(u===S){if(!a){c=l+1;break}}else E===-1&&(a=!1,E=l+1),v>=0&&(u===o.charCodeAt(v)?--v===-1&&(n=l):(v=-1,n=E))}return c===n?n=E:n===-1&&(n=t.length),t.slice(c,n)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===S){if(!a){c=l+1;break}}else n===-1&&(a=!1,n=l+1);return n===-1?"":t.slice(c,n)},extname(t){D(t,"path");let o=-1,c=0,n=-1,a=!0,l=0;for(let v=t.length-1;v>=0;--v){const E=t.charCodeAt(v);if(E===S){if(!a){c=v+1;break}continue}n===-1&&(a=!1,n=v+1),E===m?o===-1?o=v:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||n===-1||l===0||l===1&&o===n-1&&o===c+1?"":t.slice(o,n)},format:b.bind(null,"/"),parse(t){D(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const c=t.charCodeAt(0)===S;let n;c?(o.root="/",n=1):n=0;let a=-1,l=0,v=-1,E=!0,u=t.length-1,h=0;for(;u>=n;--u){const w=t.charCodeAt(u);if(w===S){if(!E){l=u+1;break}continue}v===-1&&(E=!1,v=u+1),w===m?a===-1?a=u:h!==1&&(h=1):a!==-1&&(h=-1)}if(v!==-1){const w=l===0&&c?1:l;a===-1||h===0||h===1&&a===v-1&&a===l+1?o.base=o.name=t.slice(w,v):(o.name=t.slice(w,a),o.base=t.slice(w,v),o.ext=t.slice(a,v))}return l>0?o.dir=t.slice(0,l-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$8c.win32=e.$7c.win32=e.$7c,e.$8c.posix=e.$7c.posix=e.$8c,e.$9c=y?e.$7c.normalize:e.$8c.normalize,e.$0c=y?e.$7c.isAbsolute:e.$8c.isAbsolute,e.$$c=y?e.$7c.join:e.$8c.join,e.$_c=y?e.$7c.resolve:e.$8c.resolve,e.$ad=y?e.$7c.relative:e.$8c.relative,e.$bd=y?e.$7c.dirname:e.$8c.dirname,e.$cd=y?e.$7c.basename:e.$8c.basename,e.$dd=y?e.$7c.extname:e.$8c.extname,e.$ed=y?e.$7c.format:e.$8c.format,e.$fd=y?e.$7c.parse:e.$8c.parse,e.$gd=y?e.$7c.toNamespacedPath:e.$8c.toNamespacedPath,e.sep=y?e.$7c.sep:e.$8c.sep,e.$id=y?e.$7c.delimiter:e.$8c.delimiter}),define(De[126],Ce([1,0,58,16]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=void 0;const f=new C.$T(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),R=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(E,u,h=!1){const w=E||"",L=u||"",O=f.value.collator.compare(w,L);return f.value.collatorIsNumeric&&O===0&&w!==L?w<L?-1:1:O}e.$7p=m;function S(E,u){const h=R.value.collator;return E=E||"",u=u||"",b(h,E,u)}e.$8p=S;function $(E,u){const h=R.value.collator;return E=E||"",u=u||"",c(E,u)||b(h,E,u)}e.$9p=$;function P(E,u){const h=R.value.collator;return E=E||"",u=u||"",o(E,u)||b(h,E,u)}e.$0p=P;function I(E,u){return E=E||"",u=u||"",E===u?0:E<u?-1:1}e.$$p=I;function p(E,u){const[h,w]=s(E),[L,O]=s(u);let N=f.value.collator.compare(w,O);if(N===0){if(f.value.collatorIsNumeric&&w!==O)return w<O?-1:1;if(N=f.value.collator.compare(h,L),f.value.collatorIsNumeric&&N===0&&h!==L)return h<L?-1:1}return N}e.$_p=p;function k(E,u){E=E||"",u=u||"";const h=d(E),w=d(u),L=R.value.collator,O=A.value.collator;return b(O,h,w)||b(L,E,u)}e.$aq=k;function D(E,u){E=E||"",u=u||"";const h=d(E),w=d(u),L=R.value.collator,O=A.value.collator;return b(O,h,w)||c(E,u)||b(L,E,u)}e.$bq=D;function y(E,u){E=E||"",u=u||"";const h=d(E),w=d(u),L=R.value.collator,O=A.value.collator;return b(O,h,w)||o(E,u)||b(L,E,u)}e.$cq=y;function r(E,u){E=E||"",u=u||"";const h=d(E).toLowerCase(),w=d(u).toLowerCase();return h!==w?h<w?-1:1:E!==u?E<u?-1:1:0}e.$dq=r;const i=/^(.*?)(\.([^.]*))?$/;function s(E,u=!1){const h=E?i.exec(E):[];let w=[h&&h[1]||"",h&&h[3]||""];return u&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function d(E){const u=E?i.exec(E):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function b(E,u,h){const w=E.compare(u,h);return w!==0?w:u.length!==h.length?u.length<h.length?-1:1:0}function g(E){const u=E.charAt(0);return u.toLocaleUpperCase()!==u}function t(E){const u=E.charAt(0);return u.toLocaleLowerCase()!==u}function o(E,u){return g(E)&&t(u)?-1:t(E)&&g(u)?1:0}function c(E,u){return t(E)&&g(u)?-1:g(E)&&t(u)?1:0}function n(E,u,h=!1){return h||(E=E&&E.toLowerCase(),u=u&&u.toLowerCase()),E===u?0:E<u?-1:1}function a(E,u,h=!1){const w=E.split(T.sep),L=u.split(T.sep),O=w.length-1,N=L.length-1;let M,z;for(let j=0;;j++){if(M=O===j,z=N===j,M&&z)return m(w[j],L[j],h);if(M)return-1;if(z)return 1;const F=n(w[j],L[j],h);if(F!==0)return F}}e.$eq=a;function l(E,u,h){const w=E.toLowerCase(),L=u.toLowerCase(),O=v(E,u,h);if(O)return O;const N=w.endsWith(h),M=L.endsWith(h);if(N!==M)return N?-1:1;const z=m(w,L);return z!==0?z:w.localeCompare(L)}e.$fq=l;function v(E,u,h){const w=E.toLowerCase(),L=u.toLowerCase(),O=w.startsWith(h),N=L.startsWith(h);if(O!==N)return O?-1:1;if(O&&N){if(w.length<L.length)return-1;if(w.length>L.length)return 1}return 0}e.$gq=v}),define(De[32],Ce([1,0,16,12,15,18]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=void 0;function A(l){return l===47||l===92}e.$De=A;function m(l){return l.replace(/[\\/]/g,C.$8c.sep)}e.$Ee=m;function S(l){return l.indexOf("/")===-1&&(l=m(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Fe=S;function $(l,v=C.$8c.sep){if(!l)return"";const E=l.length,u=l.charCodeAt(0);if(A(u)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let w=3;const L=w;for(;w<E&&!A(l.charCodeAt(w));w++);if(L!==w&&!A(l.charCodeAt(w+1))){for(w+=1;w<E;w++)if(A(l.charCodeAt(w)))return l.slice(0,w+1).replace(/[\\/]/g,v)}}return v}else if(i(u)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+v:l.slice(0,2);let h=l.indexOf("://");if(h!==-1){for(h+=3;h<E;h++)if(A(l.charCodeAt(h)))return l.slice(0,h+1)}return""}e.$Ge=$;function P(l){if(!T.$i||!l||l.length<5)return!1;let v=l.charCodeAt(0);if(v!==92||(v=l.charCodeAt(1),v!==92))return!1;let E=2;const u=E;for(;E<l.length&&(v=l.charCodeAt(E),v!==92);E++);return!(u===E||(v=l.charCodeAt(E+1),isNaN(v)||v===92))}e.$He=P;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(l,v=T.$i){const E=v?I:p;return!(!l||l.length===0||/^\s+$/.test(l)||(E.lastIndex=0,E.test(l))||v&&k.test(l)||l==="."||l===".."||v&&l[l.length-1]==="."||v&&l.length!==l.trim().length||l.length>255)}e.$Ie=D;function y(l,v,E){const u=l===v;return!E||u?u:!l||!v?!1:(0,f.$Od)(l,v)}e.$Je=y;function r(l,v,E,u=C.sep){if(l===v)return!0;if(!l||!v||v.length>l.length)return!1;if(E){if(!(0,f.$Pd)(l,v))return!1;if(v.length===l.length)return!0;let w=v.length;return v.charAt(v.length-1)===u&&w--,l.charAt(w)===u}return v.charAt(v.length-1)!==u&&(v+=u),l.indexOf(v)===0}e.$Ke=r;function i(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Le=i;function s(l,v){return T.$i&&l.endsWith(":")&&(l+=C.sep),(0,C.$0c)(l)||(l=(0,C.$$c)(v,l)),l=(0,C.$9c)(l),T.$i?(l=(0,f.$xd)(l,C.sep),l.endsWith(":")&&(l+=C.sep)):(l=(0,f.$xd)(l,C.sep),l||(l=C.sep)),l}e.$Me=s;function d(l){const v=(0,C.$9c)(l);return T.$i?l.length>3?!1:b(v)&&(l.length===2||v.charCodeAt(2)===92):v===C.$8c.sep}e.$Ne=d;function b(l,v=T.$i){return v?i(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$Oe=b;function g(l,v=T.$i){return b(l,v)?l[0]:void 0}e.$Pe=g;function t(l,v,E){return v.length>l.length?-1:l===v?0:(E&&(l=l.toLowerCase(),v=v.toLowerCase()),l.indexOf(v))}e.$Qe=t;function o(l){const v=l.split(":");let E,u,h;for(const w of v){const L=Number(w);(0,R.$pe)(L)?u===void 0?u=L:h===void 0&&(h=L):E=E?[E,w].join(":"):w}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:u!==void 0?u:void 0,column:h!==void 0?h:u!==void 0?1:void 0}}e.$Re=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(l,v,E=8){let u="";for(let w=0;w<E;w++){let L;w===0&&T.$i&&!v&&(E===3||E===4)?L=n:L=c,u+=L.charAt(Math.floor(Math.random()*L.length))}let h;return v?h=`${v}-${u}`:h=u,l?(0,C.$$c)(l,h):h}e.$Se=a}),define(De[127],Ce([1,0,126,121,51,16,12,15]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const S=0,$=[S,[]];function P(K,H,$e,_){if(!K||!H)return $;const Q=K.length,V=H.length;if(Q<V)return $;const ee=K.toLowerCase();return I(H,$e,V,K,ee,Q,_)}e.$hq=P;function I(K,H,$e,_,Q,V,ee){const me=[],ae=[];for(let q=0;q<$e;q++){const G=q*V,ce=G-V,re=q>0,de=K[q],Ee=H[q];for(let he=0;he<V;he++){const ge=he>0,ne=G+he,ue=ne-1,we=ce+he-1,Pe=ge?me[ue]:0,B=re&&ge?me[we]:0,Z=re&&ge?ae[we]:0;let x;!B&&re?x=0:x=p(de,Ee,_,Q,he,Z),x&&B+x>=Pe&&(ee||re||Q.startsWith(H,he))?(ae[ne]=Z+1,me[ne]=B+x):(ae[ne]=S,me[ne]=Pe)}}const te=[];let X=$e-1,U=V-1;for(;X>=0&&U>=0;){const q=X*V+U;ae[q]===S||(te.push(U),X--),U--}return[me[$e*V-1],te.reverse()]}function p(K,H,$e,_,Q,V){let ee=0;if(!k(H,_[Q]))return ee;if(ee+=1,V>0&&(ee+=V*5),K===$e[Q]&&(ee+=1),Q===0)ee+=8;else{const me=D($e.charCodeAt(Q-1));me?ee+=me:(0,T.$zj)($e.charCodeAt(Q))&&V===0&&(ee+=2)}return ee}function k(K,H){return K===H?!0:K==="/"||K==="\\"?H==="/"||H==="\\":!1}function D(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const y=[void 0,[]];function r(K,H,$e=0,_=0){const Q=H;return Q.values&&Q.values.length>1?i(K,Q.values,$e,_):s(K,H,$e,_)}e.$iq=r;function i(K,H,$e,_){let Q=0;const V=[];for(const ee of H){const[me,ae]=s(K,ee,$e,_);if(typeof me!="number")return y;Q+=me,V.push(...ae)}return[Q,E(V)]}function s(K,H,$e,_){const Q=(0,T.$Ij)(H.original,H.originalLowercase,$e,K,K.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,T.$Fj)(Q)]:y}const d=Object.freeze({score:0}),b=1<<18,g=1<<17,t=1<<16;function o(K,H,$e,_){const Q=_.values?_.values:[_];return(0,f.$ni)({[_.normalized]:{values:Q.map(ee=>({value:ee.normalized,expectContiguousMatch:ee.expectContiguousMatch})),label:K,description:H,allowNonContiguousMatches:$e}})}function c(K,H,$e,_,Q){if(!K||!H.normalized)return d;const V=_.getItemLabel(K);if(!V)return d;const ee=_.getItemDescription(K),me=o(V,ee,$e,H),ae=Q[me];if(ae)return ae;const te=n(V,ee,_.getItemPath(K),H,$e);return Q[me]=te,te}e.$jq=c;function n(K,H,$e,_,Q){const V=!$e||!_.containsPathSeparator;return $e&&(A.$k?_.pathNormalized===$e:(0,m.$Od)(_.pathNormalized,$e))?{score:b,labelMatch:[{start:0,end:K.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:_.values&&_.values.length>1?a(K,H,$e,_.values,V,Q):l(K,H,$e,_,V,Q)}function a(K,H,$e,_,Q,V){let ee=0;const me=[],ae=[];for(const te of _){const{score:X,labelMatch:U,descriptionMatch:q}=l(K,H,$e,te,Q,V);if(X===S)return d;ee+=X,U&&me.push(...U),q&&ae.push(...q)}return{score:ee,labelMatch:E(me),descriptionMatch:E(ae)}}function l(K,H,$e,_,Q,V){if(Q||!H){const[ee,me]=P(K,_.normalized,_.normalizedLowercase,V&&!_.expectContiguousMatch);if(ee){const ae=(0,T.$wj)(_.normalized,K);let te;if(ae){te=g;const X=Math.round(_.normalized.length/K.length*100);te+=X}else te=t;return{score:te+ee,labelMatch:ae||v(me)}}}if(H){let ee=H;$e&&(ee=`${H}${R.sep}`);const me=ee.length,ae=`${ee}${K}`,[te,X]=P(ae,_.normalized,_.normalizedLowercase,V&&!_.expectContiguousMatch);if(te){const U=v(X),q=[],G=[];return U.forEach(ce=>{ce.start<me&&ce.end>me?(q.push({start:0,end:ce.end-me}),G.push({start:ce.start,end:me})):ce.start>=me?q.push({start:ce.start-me,end:ce.end-me}):G.push(ce)}),{score:te,labelMatch:q,descriptionMatch:G}}}return d}function v(K){const H=[];if(!K)return H;let $e;for(const _ of K)$e&&$e.end===_?$e.end+=1:($e={start:_,end:_+1},H.push($e));return H}function E(K){const H=K.sort((Q,V)=>Q.start-V.start),$e=[];let _;for(const Q of H)!_||!u(_,Q)?(_=Q,$e.push(Q)):(_.start=Math.min(_.start,Q.start),_.end=Math.max(_.end,Q.end));return $e}function u(K,H){return!(K.end<H.start||H.end<K.start)}function h(K,H,$e,_,Q,V){const ee=c(K,$e,_,Q,V),me=c(H,$e,_,Q,V),ae=ee.score,te=me.score;if((ae===b||te===b)&&ae!==te)return ae===b?-1:1;if(ae>t||te>t){if(ae!==te)return ae>te?-1:1;if(ae<g&&te<g){const de=L(ee.labelMatch,me.labelMatch);if(de!==0)return de}const ce=Q.getItemLabel(K)||"",re=Q.getItemLabel(H)||"";if(ce.length!==re.length)return ce.length-re.length}if(ae!==te)return ae>te?-1:1;const X=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0,U=Array.isArray(me.labelMatch)&&me.labelMatch.length>0;if(X&&!U)return-1;if(U&&!X)return 1;const q=w(K,ee,Q),G=w(H,me,Q);return q&&G&&q!==G?G>q?-1:1:O(K,H,$e,Q)}e.$kq=h;function w(K,H,$e){let _=-1,Q=-1;if(H.descriptionMatch&&H.descriptionMatch.length?_=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(_=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(Q=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const V=$e.getItemDescription(K);V&&(Q+=V.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(Q=H.descriptionMatch[H.descriptionMatch.length-1].end);return Q-_}function L(K,H){if(!K&&!H||(!K||!K.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!K||!K.length)return 1;const $e=K[0].start,Q=K[K.length-1].end-$e,V=H[0].start,me=H[H.length-1].end-V;return Q===me?0:me<Q?1:-1}function O(K,H,$e,_){const Q=_.getItemLabel(K)||"",V=_.getItemLabel(H)||"",ee=_.getItemDescription(K),me=_.getItemDescription(H),ae=Q.length+(ee?ee.length:0),te=V.length+(me?me.length:0);if(ae!==te)return ae-te;const X=_.getItemPath(K),U=_.getItemPath(H);return X&&U&&X.length!==U.length?X.length-U.length:Q!==V?(0,C.$fq)(Q,V,$e.normalized):ee&&me&&ee!==me?(0,C.$fq)(ee,me,$e.normalized):X&&U&&X!==U?(0,C.$fq)(X,U,$e.normalized):0}function N(K){return K.startsWith('"')&&K.endsWith('"')}const M=" ";function z(K){typeof K!="string"&&(K="");const H=K.toLowerCase(),{pathNormalized:$e,normalized:_,normalizedLowercase:Q}=j(K),V=$e.indexOf(R.sep)>=0,ee=N(K);let me;const ae=K.split(M);if(ae.length>1)for(const te of ae){const X=N(te),{pathNormalized:U,normalized:q,normalizedLowercase:G}=j(te);q&&(me||(me=[]),me.push({original:te,originalLowercase:te.toLowerCase(),pathNormalized:U,normalized:q,normalizedLowercase:G,expectContiguousMatch:X}))}return{original:K,originalLowercase:H,pathNormalized:$e,normalized:_,normalizedLowercase:Q,values:me,containsPathSeparator:V,expectContiguousMatch:ee}}e.$lq=z;function j(K){let H;A.$i?H=K.replace(/\//g,R.sep):H=K.replace(/\\/g,R.sep);const $e=(0,m.$zd)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:$e,normalizedLowercase:$e.toLowerCase()}}function F(K){return Array.isArray(K)?z(K.map(H=>H.original).join(M)):z(K.original)}e.$mq=F}),define(De[98],Ce([1,0,16]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0,e.$Er=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(P){const I=(0,C.$dd)(P),p=T[I.toLowerCase()];return p!==void 0?p:A(P)}e.$Fr=R;function A(P){const I=(0,C.$dd)(P);return f[I.toLowerCase()]}e.$Gr=A;function m(P){for(const I in f)if(f[I]===P)return I}e.$Hr=m;const S=/^(.+)\/(.+?)(;.+)?$/;function $(P,I){const p=S.exec(P);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:P}e.$Ir=$}),define(De[99],Ce([1,0,12]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.TerminateResponseCode=e.Source=void 0;var T;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(T||(e.Source=T={}));var f;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R(m,...S){const $=S.reduce((p,k)=>(p[k]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(p=>!$[p]).forEach(p=>{for(let k=0;k<P.length;k++)if(p.search(P[k])!==-1){delete m[p];break}})}e.$ql=R;function A(m){m&&(delete m.DEBUG,C.$j&&delete m.DYLD_LIBRARY_PATH,C.$k&&delete m.LD_PRELOAD)}e.$rl=A}),define(De[2],Ce([1,0,16,12]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ve=e.$Ue=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function m(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!f.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,a){return!n&&!a?"file":n}function $(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const P="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(a){return a instanceof k?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,l,v,E,u,h=!1){typeof a=="object"?(this.scheme=a.scheme||P,this.authority=a.authority||P,this.path=a.path||P,this.query=a.query||P,this.fragment=a.fragment||P):(this.scheme=S(a,h),this.authority=l||P,this.path=$(this.scheme,v||P),this.query=E||P,this.fragment=u||P,m(this,h))}get fsPath(){return b(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:v,path:E,query:u,fragment:h}=a;return l===void 0?l=this.scheme:l===null&&(l=P),v===void 0?v=this.authority:v===null&&(v=P),E===void 0?E=this.path:E===null&&(E=P),u===void 0?u=this.query:u===null&&(u=P),h===void 0?h=this.fragment:h===null&&(h=P),l===this.scheme&&v===this.authority&&E===this.path&&u===this.query&&h===this.fragment?this:new r(l,v,E,u,h)}static parse(a,l=!1){const v=p.exec(a);return v?new r(v[2]||P,c(v[4]||P),c(v[5]||P),c(v[7]||P),c(v[9]||P),l):new r(P,P,P,P,P)}static file(a){let l=P;if(T.$i&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const v=a.indexOf(I,2);v===-1?(l=a.substring(2),a=I):(l=a.substring(2,v),a=a.substring(v)||I)}return new r("file",l,a,P,P)}static from(a,l){return new r(a.scheme,a.authority,a.path,a.query,a.fragment,l)}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return T.$i&&a.scheme==="file"?v=k.file(C.$7c.join(b(a,!0),...l)).path:v=C.$8c.join(a.path,...l),a.with({path:v})}toString(a=!1){return g(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof k)return a;{const l=new r(a);return l._formatted=a.external??null,l._fsPath=a._sep===y?a.fsPath??null:null,l}}else return a}}e.URI=k;function D(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Ue=D;const y=T.$i?1:void 0;class r extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(a=!1){return a?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=y),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const i={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(n,a,l){let v,E=-1;for(let u=0;u<n.length;u++){const h=n.charCodeAt(u);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||l&&h===91||l&&h===93||l&&h===58)E!==-1&&(v+=encodeURIComponent(n.substring(E,u)),E=-1),v!==void 0&&(v+=n.charAt(u));else{v===void 0&&(v=n.substr(0,u));const w=i[h];w!==void 0?(E!==-1&&(v+=encodeURIComponent(n.substring(E,u)),E=-1),v+=w):E===-1&&(E=u)}}return E!==-1&&(v+=encodeURIComponent(n.substring(E))),v!==void 0?v:n}function d(n){let a;for(let l=0;l<n.length;l++){const v=n.charCodeAt(l);v===35||v===63?(a===void 0&&(a=n.substr(0,l)),a+=i[v]):a!==void 0&&(a+=n[l])}return a!==void 0?a:n}function b(n,a){let l;return n.authority&&n.path.length>1&&n.scheme==="file"?l=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?l=n.path.substr(1):l=n.path[1].toLowerCase()+n.path.substr(2):l=n.path,T.$i&&(l=l.replace(/\//g,"\\")),l}e.$Ve=b;function g(n,a){const l=a?d:s;let v="",{scheme:E,authority:u,path:h,query:w,fragment:L}=n;if(E&&(v+=E,v+=":"),(u||E==="file")&&(v+=I,v+=I),u){let O=u.indexOf("@");if(O!==-1){const N=u.substr(0,O);u=u.substr(O+1),O=N.lastIndexOf(":"),O===-1?v+=l(N,!1,!1):(v+=l(N.substr(0,O),!1,!1),v+=":",v+=l(N.substr(O+1),!1,!0)),v+="@"}u=u.toLowerCase(),O=u.lastIndexOf(":"),O===-1?v+=l(u,!1,!0):(v+=l(u.substr(0,O),!1,!0),v+=u.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}v+=l(h,!0,!1)}return w&&(v+="?",v+=l(w,!1,!1)),L&&(v+="#",v+=a?L:s(L,!1,!1)),v}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(n){return n.match(o)?n.replace(o,a=>t(a)):n}}),define(De[181],Ce([1,0,2]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Mp=e.$Lp=e.$Kp=void 0;function T($){const P=$;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Kp=T;function f($){const P=[];let I;try{const p=JSON.parse($.arguments),k=p[p.length-1];k&&k.__$stack&&(p.pop(),I=k.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",$.arguments)}return{args:P,stack:I}}e.$Lp=f;function R($){if(typeof $!="string")return R(f($).stack);const P=$;if(P){const I=A(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:C.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Mp=R;function A($){if(!$)return $;const P=$.indexOf(`
`);return P===-1?$:$.substring(0,P)}function m($,P){const{args:I,stack:p}=f($),k=typeof I[0]=="string"&&I.length===1;let D=A(p);D&&(D=`(${D.trim()})`);let y=[];if(typeof I[0]=="string"?D&&k?y=[`%c[${P}] %c${I[0]} %c${D}`,S("blue"),S(""),S("grey")]:y=[`%c[${P}] %c${I[0]}`,S("blue"),S(""),...I.slice(1)]:y=[`%c[${P}]%`,S("blue"),...I],D&&!k&&y.push(D),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,y)}e.log=m;function S($){return`color: ${$}`}}),define(De[62],Ce([1,0,22,2]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.$8g=e.$7g=void 0;function f(S){return JSON.stringify(S,A)}e.$7g=f;function R(S){let $=JSON.parse(S);return $=m($),$}e.$8g=R;function A(S,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function m(S,$=0){if(!S||$>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return T.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof C.$Hc||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=m(S[P],$+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=m(S[P],$+1))}return S}e.$9g=m}),define(De[17],Ce([1,0,8,12,2]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.Schemas=void 0;var R;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$We="vscode-tkn",e.$Xe="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${R.vscodeRemoteResource}`}set(P,I,p){this.a[P]=I,this.b[P]=p}setConnectionToken(P,I){this.c[P]=I}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(r){return C.$Y(r),P}const I=P.authority;let p=this.a[I];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const k=this.b[I],D=this.c[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof D=="string"&&(y+=`&${e.$Xe}=${encodeURIComponent(D)}`),f.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${p}:${k}`,path:this.f,query:y})}}e.$Ye=new A,e.$Ze="vs/../../extensions",e.$1e="vs/../../node_modules",e.$2e="vs/../../node_modules.asar",e.$3e="vs/../../node_modules.asar.unpacked";class m{static{this.a="vscode-app"}asBrowserUri(P){const I=this.b(P,be);return this.uriToBrowserUri(I)}uriToBrowserUri(P){return P.scheme===R.vscodeRemote?e.$Ye.rewrite(P):P.scheme===R.file&&(T.$m||T.$p&&T.$g.origin===`${R.vscodeFileResource}://${m.a}`)?P.with({scheme:R.vscodeFileResource,authority:P.authority||m.a,query:null,fragment:null}):P}asFileUri(P){const I=this.b(P,be);return this.uriToFileUri(I)}uriToFileUri(P){return P.scheme===R.vscodeFileResource?P.with({scheme:R.file,authority:P.authority!==m.a?P.authority:null,query:null,fragment:null}):P}b(P,I){return f.URI.isUri(P)?P:f.URI.parse(I.toUrl(P))}}e.$4e=new m;var S;(function($){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(P.get("3"));const I="vscode-coi";function p(D){let y;typeof D=="string"?y=new URL(D).searchParams:D instanceof URL?y=D.searchParams:f.URI.isUri(D)&&(y=new URL(D.toString(!0)).searchParams);const r=y?.get(I);if(r)return P.get(r)}$.getHeadersFromQuery=p;function k(D,y,r){if(!globalThis.crossOriginIsolated)return;const i=y&&r?"3":r?"2":"1";D instanceof URLSearchParams?D.set(I,i):D[I]=i}$.addSearchParam=k})(S||(e.COI=S={}))}),define(De[182],Ce([1,0,156,17,12,2]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9C=void 0;class A{constructor(p,k,D){this.id=p,this.dependencies=k,this.callback=D}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,k,D)=>{typeof p!="string"&&(D=k,k=p,p=null),(typeof k!="object"||!Array.isArray(k))&&(D=k,k=null),this.c.push(new A(p,k,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const k=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!k)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(p){return new Promise((k,D)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const r=()=>{y.removeEventListener("load",i),y.removeEventListener("error",s)},i=d=>{r(),k(this.c.pop())},s=d=>{r(),D(d)};y.addEventListener("load",i),y.addEventListener("error",s),this.f&&(p=this.f.createScriptURL(p)),y.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(y)})}i(p){return new Promise((k,D)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),k(this.c.pop())}catch(y){D(y)}})}async j(p){try{const k=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,r=R.URI.parse(p).fsPath,i=k.readFileSync(r).toString(),s=y.wrap(i.replace(/^#!.*/,""));return new D.Script(s).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const S=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function P(I,p,k){if(C.$R){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[I]&&(I=$[I]);const D=`${I}/${p}`;if(S.has(D))return S.get(D);let y;if(/^\w[\w\d+.-]*:\/\//.test(D))y=D;else{const d=`${k&&!f.$o?T.$2e:T.$1e}/${D}`;y=T.$4e.asBrowserUri(d).toString(!0)}const r=m.INSTANCE.load(y);return S.set(D,r),r}else return await new Promise((D,y)=>{be([I],D,y)})}e.$9C=P}),define(De[24],Ce([1,0,32,17,16,12,15,2]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.DataUri=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=void 0;function S(k){return(0,m.$Ve)(k,!0)}e.$7f=S;class ${constructor(D){this.a=D}compare(D,y,r=!1){return D===y?0:(0,A.$Hd)(this.getComparisonKey(D,r),this.getComparisonKey(y,r))}isEqual(D,y,r=!1){return D===y?!0:!D||!y?!1:this.getComparisonKey(D,r)===this.getComparisonKey(y,r)}getComparisonKey(D,y=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,y,r=!1){if(D.scheme===y.scheme){if(D.scheme===T.Schemas.file)return C.$Ke(S(D),S(y),this.a(D))&&D.query===y.query&&(r||D.fragment===y.fragment);if((0,e.$lg)(D.authority,y.authority))return C.$Ke(D.path,y.path,this.a(D),"/")&&D.query===y.query&&(r||D.fragment===y.fragment)}return!1}joinPath(D,...y){return m.URI.joinPath(D,...y)}basenameOrAuthority(D){return(0,e.$dg)(D)||D.authority}basename(D){return f.$8c.basename(D.path)}extname(D){return f.$8c.extname(D.path)}dirname(D){if(D.path.length===0)return D;let y;return D.scheme===T.Schemas.file?y=m.URI.file(f.$bd(S(D))).path:(y=f.$8c.dirname(D.path),D.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),y="/")),D.with({path:y})}normalizePath(D){if(!D.path.length)return D;let y;return D.scheme===T.Schemas.file?y=m.URI.file(f.$9c(S(D))).path:y=f.$8c.normalize(D.path),D.with({path:y})}relativePath(D,y){if(D.scheme!==y.scheme||!(0,e.$lg)(D.authority,y.authority))return;if(D.scheme===T.Schemas.file){const s=f.$ad(S(D),S(y));return R.$i?C.$Ee(s):s}let r=D.path||"/";const i=y.path||"/";if(this.a(D)){let s=0;for(const d=Math.min(r.length,i.length);s<d&&!(r.charCodeAt(s)!==i.charCodeAt(s)&&r.charAt(s).toLowerCase()!==i.charAt(s).toLowerCase());s++);r=i.substr(0,s)+r.substr(s)}return f.$8c.relative(r,i)}resolvePath(D,y){if(D.scheme===T.Schemas.file){const r=m.URI.file(f.$_c(S(D),y));return D.with({authority:r.authority,path:r.path})}return y=C.$Fe(y),D.with({path:f.$8c.resolve(D.path,y)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,y){return D===y||D!==void 0&&y!==void 0&&(0,A.$Od)(D,y)}hasTrailingPathSeparator(D,y=f.sep){if(D.scheme===T.Schemas.file){const r=S(D);return r.length>C.$Ge(r).length&&r[r.length-1]===y}else{const r=D.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,y=f.sep){return(0,e.$mg)(D,y)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,y=f.sep){let r=!1;if(D.scheme===T.Schemas.file){const i=S(D);r=i!==void 0&&i.length===C.$Ge(i).length&&i[i.length-1]===y}else{y="/";const i=D.path;r=i.length===1&&i.charCodeAt(i.length-1)===47}return!r&&!(0,e.$mg)(D,y)?D.with({path:D.path+"/"}):D}}e.$8f=$,e.$9f=new $(()=>!1),e.$0f=new $(k=>k.scheme===T.Schemas.file?!R.$k:!0),e.$$f=new $(k=>!0),e.$_f=e.$9f.isEqual.bind(e.$9f),e.$ag=e.$9f.isEqualOrParent.bind(e.$9f),e.$bg=e.$9f.getComparisonKey.bind(e.$9f),e.$cg=e.$9f.basenameOrAuthority.bind(e.$9f),e.$dg=e.$9f.basename.bind(e.$9f),e.$eg=e.$9f.extname.bind(e.$9f),e.$fg=e.$9f.dirname.bind(e.$9f),e.$gg=e.$9f.joinPath.bind(e.$9f),e.$hg=e.$9f.normalizePath.bind(e.$9f),e.$ig=e.$9f.relativePath.bind(e.$9f),e.$jg=e.$9f.resolvePath.bind(e.$9f),e.$kg=e.$9f.isAbsolutePath.bind(e.$9f),e.$lg=e.$9f.isEqualAuthority.bind(e.$9f),e.$mg=e.$9f.hasTrailingPathSeparator.bind(e.$9f),e.$ng=e.$9f.removeTrailingPathSeparator.bind(e.$9f),e.$og=e.$9f.addTrailingPathSeparator.bind(e.$9f);function P(k,D){const y=[];for(let r=0;r<k.length;r++){const i=D(k[r]);k.some((s,d)=>d===r?!1:(0,e.$ag)(i,D(s)))||y.push(k[r])}return y}e.$pg=P;var I;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function D(y){const r=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(d=>{const[b,g]=d.split(":");b&&g&&r.set(b,g)});const s=y.path.substring(0,y.path.indexOf(";"));return s&&r.set(k.META_DATA_MIME,s),r}k.parseMetaData=D})(I||(e.DataUri=I={}));function p(k,D,y){if(D){let r=k.path;return r&&r[0]!==f.$8c.sep&&(r=f.$8c.sep+r),k.with({scheme:y,authority:D,path:r})}return k.with({scheme:y})}e.$qg=p}),define(De[11],Ce([1,0,21,8,4,3,24,12,160]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=e.$2g=e.$1g=e.Promises=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function $(U){return!!U&&typeof U.then=="function"}e.$rg=$;function P(U){const q=new C.$rc,G=U(q.token),ce=new Promise((re,de)=>{const Ee=q.token.onCancellationRequested(()=>{Ee.dispose(),q.dispose(),de(new T.$3)});Promise.resolve(G).then(he=>{Ee.dispose(),q.dispose(),re(he)},he=>{Ee.dispose(),q.dispose(),de(he)})});return new class{cancel(){q.cancel()}then(re,de){return ce.then(re,de)}catch(re){return this.then(void 0,re)}finally(re){return ce.finally(re)}}}e.$sg=P;function I(U,q,G){return new Promise((ce,re)=>{const de=q.onCancellationRequested(()=>{de.dispose(),ce(G)});U.then(ce,re).finally(()=>de.dispose())})}e.$tg=I;function p(U,q){return new Promise((G,ce)=>{const re=q.onCancellationRequested(()=>{re.dispose(),ce(new T.$3)});U.then(G,ce).finally(()=>re.dispose())})}e.$ug=p;async function k(U){let q=-1;const G=U.map((ce,re)=>ce.then(de=>(q=re,de)));try{return await Promise.race(G)}finally{U.forEach((ce,re)=>{re!==q&&ce.cancel()})}}e.$vg=k;function D(U,q,G){let ce;const re=setTimeout(()=>{ce?.(void 0),G?.()},q);return Promise.race([U.finally(()=>clearTimeout(re)),new Promise(de=>ce=de)])}e.$wg=D;function y(U){return new Promise((q,G)=>{const ce=U();$(ce)?ce.then(q,G):q(ce)})}e.$xg=y;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const G=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(G,G).then(ce)})}return new Promise((G,ce)=>{this.b.then(G,ce)})}return this.a=q(),new Promise((G,ce)=>{this.a.then(re=>{this.a=null,G(re)},re=>{this.a=null,ce(re)})})}dispose(){this.f=!0}}e.$yg=r;class i{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$zg=i;class s{constructor(){this.a=new Map}queue(q,G){const re=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(q)===re&&this.a.delete(q)});return this.a.set(q,re),re}}e.$Ag=s;const d=(U,q)=>{let G=!0;const ce=setTimeout(()=>{G=!1,q()},U);return{isTriggered:()=>G,dispose:()=>{clearTimeout(ce),G=!1}}},b=U=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,U())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class g{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,G=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((re,de)=>{this.d=re,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const re=this.g;return this.g=null,re()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=G===S.$ec?b(ce):d(G,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bg=g;class t{constructor(q){this.a=new g(q),this.b=new r}trigger(q,G){return this.a.trigger(()=>this.b.queue(q),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Cg=t;class o{constructor(){this.a=!1,this.b=new Promise((q,G)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dg=o;class c extends o{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Eg=c;function n(U,q){return q?new Promise((G,ce)=>{const re=setTimeout(()=>{de.dispose(),G()},U),de=q.onCancellationRequested(()=>{clearTimeout(re),de.dispose(),ce(new T.$3)})}):P(G=>n(U,G))}e.$Fg=n;function a(U,q=0){const G=setTimeout(U,q);return(0,R.$kb)(()=>clearTimeout(G))}e.$Gg=a;function l(U){const q=[];let G=0;const ce=U.length;function re(){return G<ce?U[G++]():null}function de(Ee){Ee!=null&&q.push(Ee);const he=re();return he?he.then(de):Promise.resolve(q)}return Promise.resolve(null).then(de)}e.$Hg=l;function v(U,q=ce=>!!ce,G=null){let ce=0;const re=U.length,de=()=>{if(ce>=re)return Promise.resolve(G);const Ee=U[ce++];return Promise.resolve(Ee()).then(ge=>q(ge)?Promise.resolve(ge):de())};return de()}e.$Ig=v;function E(U,q=ce=>!!ce,G=null){if(U.length===0)return Promise.resolve(G);let ce=U.length;const re=()=>{ce=-1;for(const de of U)de.cancel?.()};return new Promise((de,Ee)=>{for(const he of U)he.then(ge=>{--ce>=0&&q(ge)?(re(),de(ge)):ce===0&&de(G)}).catch(ge=>{--ce>=0&&(re(),Ee(ge))})})}e.$Jg=E;class u{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new f.$hc}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((G,ce)=>{this.f.push({factory:q,c:G,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const G=q.factory();G.then(q.c,q.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Kg=u;class h extends u{constructor(){super(1)}}e.$Lg=h;class w{constructor(){this.a=new $e,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Mg=w;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new V;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,G=A.$9f){const ce=G.getComparisonKey(q);let re=this.a.get(ce);if(!re){re=new h;const de=this.f++,Ee=f.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$ub),this.d.set(de,Ee),this.a.set(ce,re)}return re}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Ng=L;class O{constructor(q,G){this.a=-1,typeof q=="function"&&typeof G=="number"&&this.setIfNotSet(q,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},G)}setIfNotSet(q,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},G))}}e.$Og=O;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,G){this.cancel(),this.a=setInterval(()=>{q()},G)}}e.$Pg=N;class M{constructor(q,G){this.b=-1,this.a=q,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qg=M;class z{constructor(q,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=q,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rg=z;class j extends M{constructor(q,G){super(q,G),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Sg=j;class F extends R.$mb{constructor(q,G){super(),this.g=q,this.h=G,this.a=[],this.b=this.B(new R.$nb),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of q)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Tg=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ug=U=>{(0,m.$A)(()=>{if(q)return;const G=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Ug=(U,q)=>{const G=requestIdleCallback(U,typeof q=="number"?{timeout:q}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,cancelIdleCallback(G))}}}}();class K{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(G){this.g=G}finally{this.d=!0}},this.b=(0,e.$Ug)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Vg=K;async function H(U,q,G){let ce;for(let re=0;re<G;re++)try{return await U()}catch(de){ce=de,await n(q)}throw ce}e.$Wg=H;class $e{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,G,ce){return this.a={taskId:q,cancel:()=>ce?.(),promise:G},G.then(()=>this.d(q),()=>this.d(q)),G}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let G,ce;const re=new Promise((de,Ee)=>{G=de,ce=Ee});this.b={run:q,promise:re,promiseResolve:G,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xg=$e;class _{constructor(q,G=()=>Date.now()){this.d=q,this.f=G,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Yg=_;var Q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Q||(Q={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,G)=>{this.a=q,this.b=G})}complete(q){return new Promise(G=>{this.a(q),this.d={outcome:0,value:q},G()})}error(q){return new Promise(G=>{this.b(q),this.d={outcome:1,value:q},G()})}cancel(){return this.error(new T.$3)}}e.$Zg=V;var ee;(function(U){async function q(ce){let re;const de=await Promise.all(ce.map(Ee=>Ee.then(he=>he,he=>{re||(re=he)})));if(typeof re<"u")throw re;return de}U.settled=q;function G(ce){return new Promise(async(re,de)=>{try{await ce(re,de)}catch(Ee){de(Ee)}})}U.withAsyncBody=G})(ee||(e.Promises=ee={}));var me;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(me||(me={}));class ae{static fromArray(q){return new ae(G=>{G.emitMany(q)})}static fromPromise(q){return new ae(async G=>{G.emitMany(await q)})}static fromPromises(q){return new ae(async G=>{await Promise.all(q.map(async ce=>G.emitOne(await ce)))})}static merge(q){return new ae(async G=>{await Promise.all(q.map(async ce=>{for await(const re of ce)G.emitOne(re)}))})}static{this.EMPTY=ae.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new f.$hc,queueMicrotask(async()=>{const G={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(q(G)),this.j()}catch(ce){this.k(ce)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(q,G){return new ae(async ce=>{for await(const re of q)ce.emitOne(G(re))})}map(q){return ae.map(this,q)}static filter(q,G){return new ae(async ce=>{for await(const re of q)G(re)&&ce.emitOne(re)})}filter(q){return ae.filter(this,q)}static coalesce(q){return ae.filter(q,G=>!!G)}coalesce(){return ae.coalesce(this)}static async toPromise(q){const G=[];for await(const ce of q)G.push(ce);return G}toPromise(){return ae.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$1g=ae;class te extends ae{constructor(q,G){super(G),this.l=q}cancel(){this.l.cancel()}}e.$2g=te;function X(U){const q=new C.$rc,G=U(q.token);return new te(q,async ce=>{const re=q.token.onCancellationRequested(()=>{re.dispose(),q.dispose(),ce.reject(new T.$3)});try{for await(const de of G){if(q.token.isCancellationRequested)return;ce.emitOne(de)}re.dispose(),q.dispose()}catch(de){re.dispose(),q.dispose(),ce.reject(de)}})}e.$3g=X}),define(De[35],Ce([1,0,19,11,32,28,16,12,15]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0;function $(){return Object.create(null)}e.$kj=$,e.$lj="**",e.$mj="/";const P="[/\\\\]",I="[^/\\\\]",p=/\//g;function k($e,_){switch($e){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}${_?`|${P}${I}+`:""})*?`}}function D($e,_){if(!$e)return[];const Q=[];let V=!1,ee=!1,me="";for(const ae of $e){switch(ae){case _:if(!V&&!ee){Q.push(me),me="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}me+=ae}return me&&Q.push(me),Q}e.$nj=D;function y($e){if(!$e)return"";let _="";const Q=D($e,e.$mj);if(Q.every(V=>V===e.$lj))_=".*";else{let V=!1;Q.forEach((ee,me)=>{if(ee===e.$lj){if(V)return;_+=k(2,me===Q.length-1)}else{let ae=!1,te="",X=!1,U="";for(const q of ee){if(q!=="}"&&ae){te+=q;continue}if(X&&(q!=="]"||!U)){let G;q==="-"?G=q:(q==="^"||q==="!")&&!U?G="^":q===e.$mj?G="":G=(0,S.$sd)(q),U+=G;continue}switch(q){case"{":ae=!0;continue;case"[":X=!0;continue;case"}":{const ce=`(?:${D(te,",").map(re=>y(re)).join("|")})`;_+=ce,ae=!1,te="";break}case"]":{_+="["+U+"]",X=!1,U="";break}case"?":_+=I;continue;case"*":_+=k(1);continue;default:_+=(0,S.$sd)(q)}}me<Q.length-1&&(Q[me+1]!==e.$lj||me+2<Q.length)&&(_+=P)}V=ee===e.$lj})}return _}const r=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,s=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,b=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ai(1e4),o=function(){return!1},c=function(){return null};function n($e,_){if(!$e)return c;let Q;typeof $e!="string"?Q=$e.pattern:Q=$e,Q=Q.trim();const V=`${Q}_${!!_.trimForExclusions}`;let ee=t.get(V);if(ee)return a(ee,$e);let me;return r.test(Q)?ee=v(Q.substr(4),Q):(me=i.exec(l(Q,_)))?ee=E(me[1],Q):(_.trimForExclusions?d:s).test(Q)?ee=u(Q,_):(me=b.exec(l(Q,_)))?ee=h(me[1].substr(1),Q,!0):(me=g.exec(l(Q,_)))?ee=h(me[1],Q,!1):ee=w(Q),t.set(V,ee),a(ee,$e)}function a($e,_){if(typeof _=="string")return $e;const Q=function(V,ee){return(0,f.$Ke)(V,_.base,!m.$k)?$e((0,S.$wd)(V.substr(_.base.length),A.sep),ee):null};return Q.allBasenames=$e.allBasenames,Q.allPaths=$e.allPaths,Q.basenames=$e.basenames,Q.patterns=$e.patterns,Q}function l($e,_){return _.trimForExclusions&&$e.endsWith("/**")?$e.substr(0,$e.length-2):$e}function v($e,_){return function(Q,V){return typeof Q=="string"&&Q.endsWith($e)?_:null}}function E($e,_){const Q=`/${$e}`,V=`\\${$e}`,ee=function(ae,te){return typeof ae!="string"?null:te?te===$e?_:null:ae===$e||ae.endsWith(Q)||ae.endsWith(V)?_:null},me=[$e];return ee.basenames=me,ee.patterns=[_],ee.allBasenames=me,ee}function u($e,_){const Q=K($e.slice(1,-1).split(",").map(te=>n(te,_)).filter(te=>te!==c),$e),V=Q.length;if(!V)return c;if(V===1)return Q[0];const ee=function(te,X){for(let U=0,q=Q.length;U<q;U++)if(Q[U](te,X))return $e;return null},me=Q.find(te=>!!te.allBasenames);me&&(ee.allBasenames=me.allBasenames);const ae=Q.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return ae.length&&(ee.allPaths=ae),ee}function h($e,_,Q){const V=A.sep===A.$8c.sep,ee=V?$e:$e.replace(p,A.sep),me=A.sep+ee,ae=A.$8c.sep+$e;let te;return Q?te=function(X,U){return typeof X=="string"&&(X===ee||X.endsWith(me)||!V&&(X===$e||X.endsWith(ae)))?_:null}:te=function(X,U){return typeof X=="string"&&(X===ee||!V&&X===$e)?_:null},te.allPaths=[(Q?"*/":"./")+$e],te}function w($e){try{const _=new RegExp(`^${y($e)}$`);return function(Q){return _.lastIndex=0,typeof Q=="string"&&_.test(Q)?$e:null}}catch{return c}}function L($e,_,Q){return!$e||typeof _!="string"?!1:O($e)(_,void 0,Q)}e.$oj=L;function O($e,_={}){if(!$e)return o;if(typeof $e=="string"||N($e)){const Q=n($e,_);if(Q===c)return o;const V=function(ee,me){return!!Q(ee,me)};return Q.allBasenames&&(V.allBasenames=Q.allBasenames),Q.allPaths&&(V.allPaths=Q.allPaths),V}return j($e,_)}e.$pj=O;function N($e){const _=$e;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.$qj=N;function M($e){return $e.allBasenames||[]}e.$rj=M;function z($e){return $e.allPaths||[]}e.$sj=z;function j($e,_){const Q=K(Object.getOwnPropertyNames($e).map(te=>F(te,$e[te],_)).filter(te=>te!==c)),V=Q.length;if(!V)return c;if(!Q.some(te=>!!te.requiresSiblings)){if(V===1)return Q[0];const te=function(q,G){let ce;for(let re=0,de=Q.length;re<de;re++){const Ee=Q[re](q,G);if(typeof Ee=="string")return Ee;(0,T.$rg)(Ee)&&(ce||(ce=[]),ce.push(Ee))}return ce?(async()=>{for(const re of ce){const de=await re;if(typeof de=="string")return de}return null})():null},X=Q.find(q=>!!q.allBasenames);X&&(te.allBasenames=X.allBasenames);const U=Q.reduce((q,G)=>G.allPaths?q.concat(G.allPaths):q,[]);return U.length&&(te.allPaths=U),te}const ee=function(te,X,U){let q,G;for(let ce=0,re=Q.length;ce<re;ce++){const de=Q[ce];de.requiresSiblings&&U&&(X||(X=(0,A.$cd)(te)),q||(q=X.substr(0,X.length-(0,A.$dd)(te).length)));const Ee=de(te,X,q,U);if(typeof Ee=="string")return Ee;(0,T.$rg)(Ee)&&(G||(G=[]),G.push(Ee))}return G?(async()=>{for(const ce of G){const re=await ce;if(typeof re=="string")return re}return null})():null},me=Q.find(te=>!!te.allBasenames);me&&(ee.allBasenames=me.allBasenames);const ae=Q.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return ae.length&&(ee.allPaths=ae),ee}function F($e,_,Q){if(_===!1)return c;const V=n($e,Q);if(V===c)return c;if(typeof _=="boolean")return V;if(_){const ee=_.when;if(typeof ee=="string"){const me=(ae,te,X,U)=>{if(!U||!V(ae,te))return null;const q=ee.replace("$(basename)",()=>X),G=U(q);return(0,T.$rg)(G)?G.then(ce=>ce?$e:null):G?$e:null};return me.requiresSiblings=!0,me}}return V}function K($e,_){const Q=$e.filter(te=>!!te.basenames);if(Q.length<2)return $e;const V=Q.reduce((te,X)=>{const U=X.basenames;return U?te.concat(U):te},[]);let ee;if(_){ee=[];for(let te=0,X=V.length;te<X;te++)ee.push(_)}else ee=Q.reduce((te,X)=>{const U=X.patterns;return U?te.concat(U):te},[]);const me=function(te,X){if(typeof te!="string")return null;if(!X){let q;for(q=te.length;q>0;q--){const G=te.charCodeAt(q-1);if(G===47||G===92)break}X=te.substr(q)}const U=V.indexOf(X);return U!==-1?ee[U]:null};me.basenames=V,me.patterns=ee,me.allBasenames=V;const ae=$e.filter(te=>!te.basenames);return ae.push(me),ae}function H($e,_){return(0,C.$of)($e,_,(Q,V)=>typeof Q=="string"&&typeof V=="string"?Q===V:typeof Q!="string"&&typeof V!="string"?Q.base===V.base&&Q.pattern===V.pattern:!1)}e.$tj=H}),define(De[79],Ce([1,0,8,161,24,15,2]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class S{constructor(i="",s=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$5)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(i,s=0){return this.value+=p(this.supportThemeIcons?(0,T.$Pj)(i):i).replace(/([ \t]+)/g,(d,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,s){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(i,s,d){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(i),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(i,s){const d=new RegExp((0,R.$sd)(s),"g");return i.replace(d,(b,g)=>i.charAt(g-1)!=="\\"?`\\${b}`:b)}}e.$Vj=S;function $(r){return P(r)?!r.value:Array.isArray(r)?r.every($):!0}e.$Wj=$;function P(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$Xj=P;function I(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,f.$_f)(A.URI.from(r.baseUri),A.URI.from(i.baseUri)))}e.$Yj=I;function p(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Zj=p;function k(r){return r.replace(/"/g,"&quot;")}e.$1j=k;function D(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$2j=D;function y(r){const i=[],s=r.split("|").map(b=>b.trim());r=s[0];const d=s[1];if(d){const b=/height=(\d+)/.exec(d),g=/width=(\d+)/.exec(d),t=b?b[1]:"",o=g?g[1]:"",c=isFinite(parseInt(o)),n=isFinite(parseInt(t));c&&i.push(`width="${o}"`),n&&i.push(`height="${t}"`)}return{href:r,dimensions:i}}e.$3j=y}),define(De[100],Ce([1,0,19,32,16,12,24,15]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=e.$cA=e.$bA=e.$aA=void 0;function S(n,a){const{os:l,tildify:v,relative:E}=a;if(E){const w=$(n,E,l);if(typeof w=="string")return w}let u=n.fsPath;if(l===1&&!R.$i?u=u.replace(/\//g,"\\"):l!==1&&R.$i&&(u=u.replace(/\\/g,"/")),l!==1&&v?.userHome){const w=v.userHome.fsPath;let L;n.scheme!==v.userHome.scheme&&n.path.startsWith(f.$8c.sep)?L=v.userHome.with({path:n.path}).fsPath:L=n.fsPath,u=p(L,w,l)}return(l===1?f.$7c:f.$8c).normalize(P(u,l===1))}e.$aA=S;function $(n,a,l){const v=l===1?f.$7c:f.$8c,E=l===3?A.$9f:A.$$f,u=a.getWorkspace(),h=(0,C.$Hf)(u.folders);if(!h)return;n.scheme!==h.uri.scheme&&n.path.startsWith(f.$8c.sep)&&(n=h.uri.with({path:n.path}));const w=a.getWorkspaceFolder(n);if(!w)return;let L;if(E.isEqual(w.uri,n)?L="":L=E.relativePath(w.uri,n)??"",L&&(L=v.normalize(L)),u.folders.length>1&&!a.noPrefix){const O=w.name?w.name:E.basenameOrAuthority(w.uri);L=L?`${O} \u2022 ${L}`:O}return L}function P(n,a=R.$i){return(0,T.$Oe)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$bA=P;let I=Object.create(null);function p(n,a,l=R.OS){if(l===1||!n||!a)return n;let v=I.original===a?I.normalized:void 0;v||(v=a,R.$i&&(v=(0,T.$Ee)(v)),v=`${(0,m.$xd)(v,f.$8c.sep)}${f.$8c.sep}`,I={original:a,normalized:v});let E=n;return R.$i&&(E=(0,T.$Ee)(E)),(l===3?E.startsWith(v):(0,m.$Pd)(E,v))?`~/${E.substr(v.length)}`:n}e.$cA=p;function k(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.$dA=k;const D="\u2026",y="\\\\",r="~";function i(n,a=f.sep){const l=new Array(n.length);let v=!1;for(let E=0;E<n.length;E++){const u=n[E];if(u===""){l[E]=`.${a}`;continue}if(!u){l[E]=u;continue}v=!0;let h="",w=u;w.indexOf(y)===0?(h=w.substr(0,w.indexOf(y)+y.length),w=w.substr(w.indexOf(y)+y.length)):w.indexOf(a)===0?(h=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(r)===0&&(h=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const L=w.split(a);for(let O=1;v&&O<=L.length;O++)for(let N=L.length-O;v&&N>=0;N--){v=!1;let M=L.slice(N,N+O).join(a);for(let z=0;!v&&z<n.length;z++)if(z!==E&&n[z]&&n[z].indexOf(M)>-1){const j=N+O===L.length,F=N>0&&n[z].indexOf(a)>-1?a+M:M,K=n[z].endsWith(F);v=!j||K}if(!v){let z="";(L[0].endsWith(":")||h!=="")&&(N===1&&(N=0,O++,M=L[0]+a+M),N>0&&(z=L[0]+a),z=h+z),N>0&&(z=z+D+a),z=z+M,N+O<L.length&&(z=z+a+D),l[E]=z}}v&&(l[E]=u)}return l}e.$eA=i;var s;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function d(n,a=Object.create(null)){const l=[];let v=!1,E="";for(const u of n)if(u==="$"||v&&u==="{")E&&l.push({value:E,type:s.TEXT}),E="",v=!0;else if(u==="}"&&v){const h=a[E];if(typeof h=="string")h.length&&l.push({value:h,type:s.VARIABLE});else if(h){const w=l[l.length-1];(!w||w.type!==s.SEPARATOR)&&l.push({value:h.label,type:s.SEPARATOR})}E="",v=!1}else E+=u;return E&&!v&&l.push({value:E,type:s.TEXT}),l.filter((u,h)=>{if(u.type===s.SEPARATOR){const w=l[h-1],L=l[h+1];return[w,L].every(O=>O&&(O.type===s.VARIABLE||O.type===s.TEXT)&&O.value.length>0)}return!0}).map(u=>u.value).join("")}e.$fA=d;function b(n,a){return R.$j||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$gA=b;function g(n,a){return R.$j||a?n.replace(/\(&&\w\)|&&/g,""):R.$i?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$hA=g;function t(n){return n.replace(/&/g,"&&")}e.$iA=t;function o(n){if(n.endsWith("]")){const a=n.lastIndexOf(" [",n.length-2);if(a!==-1){const l=c(n.substring(0,a));return{name:l.name,parentPath:l.parentPath+n.substring(a)}}}return c(n)}e.$jA=o;function c(n){const a=n.indexOf("/")!==-1?f.$8c:f.$7c,l=a.basename(n),v=a.dirname(n);return l.length?{name:l,parentPath:v}:{name:v,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=void 0;function f(I){return I.toJSON()}class R{constructor(p){this.a=p}transformIncoming(p){const k=this.a.transformIncoming(p);return k===p?p:f(T.URI.from(k))}transformOutgoing(p){const k=this.a.transformOutgoing(p);return k===p?p:f(T.URI.from(k))}transformOutgoingURI(p){const k=this.a.transformOutgoing(p);return k===p?p:T.URI.from(k)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$zm=R,e.$Am=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,p,k){if(!I||k>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return p.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const y=A(I[D],p,k+1);y!==null&&(I[D]=y)}}return null}function m(I,p){const k=A(I,p,0);return k===null?I:k}e.$Bm=m;function S(I,p,k,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return k?T.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof C.$Hc)return null;for(const y in I)if(Object.hasOwnProperty.call(I,y)){const r=S(I[y],p,k,D+1);r!==null&&(I[y]=r)}}return null}function $(I,p){const k=S(I,p,!1,0);return k===null?I:k}e.$Cm=$;function P(I,p){const k=S(I,p,!0,0);return k===null?I:k}e.$Dm=P}),define(De[29],Ce([1,0,52,63,370,11,32,76,16,12,24,2]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function k(F,K=p.UNLINK,H){if((0,A.$Ne)(F))throw new Error("rimraf - will refuse to recursively delete root");return K===p.UNLINK?y(F):D(F,H)}async function D(F,K=(0,A.$Se)((0,T.tmpdir)())){try{try{await C.promises.rename(F,K)}catch(H){return H.code==="ENOENT"?void 0:y(F)}y(K).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(F){return(0,f.promisify)(C.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function r(F){if((0,A.$Ne)(F))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function i(F,K){return b(await(K?s(F):(0,f.promisify)(C.readdir)(F)))}async function s(F){try{return await(0,f.promisify)(C.readdir)(F,{withFileTypes:!0})}catch($e){console.warn("[node.js fs] readdir with filetypes failed with error: ",$e)}const K=[],H=await i(F);for(const $e of H){let _=!1,Q=!1,V=!1;try{const ee=await e.Promises.lstat((0,S.$$c)(F,$e));_=ee.isFile(),Q=ee.isDirectory(),V=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}K.push({name:$e,isFile:()=>_,isDirectory:()=>Q,isSymbolicLink:()=>V})}return K}function d(F){return b(C.readdirSync(F))}e.readdirSync=d;function b(F){return F.map(K=>typeof K=="string"?$.$j?(0,m.$fl)(K):K:(K.name=$.$j?(0,m.$fl)(K.name):K.name,K))}async function g(F){const K=await i(F),H=[];for(const $e of K)await o.existsDirectory((0,S.$$c)(F,$e))&&H.push($e);return H}function t(F,K=1e3){return new Promise(H=>{let $e=!1;const _=setInterval(()=>{$e||($e=!0,C.access(F,Q=>{$e=!1,Q&&(clearInterval(_),H(void 0))}))},K)})}e.whenDeleted=t;var o;(function(F){async function K(_){let Q;try{if(Q=await e.Promises.lstat(_),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if($.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ee}throw V}}F.stat=K;async function H(_){try{const{stat:Q,symbolicLink:V}=await F.stat(_);return Q.isFile()&&V?.dangling!==!0}catch{}return!1}F.existsFile=H;async function $e(_){try{const{stat:Q,symbolicLink:V}=await F.stat(_);return Q.isDirectory()&&V?.dangling!==!0}catch{}return!1}F.existsDirectory=$e})(o||(e.SymlinkSupport=o={}));const c=new R.$Ng;function n(F,K,H){return c.queueFor(I.URI.file(F),P.$0f).queue(()=>{const $e=u(H);return new Promise((_,Q)=>v(F,K,$e,V=>V?Q(V):_()))})}let a=!0;function l(F){a=F}e.configureFlushOnWrite=l;function v(F,K,H,$e){if(!a)return C.writeFile(F,K,{mode:H.mode,flag:H.flag},$e);C.open(F,H.flag,H.mode,(_,Q)=>{if(_)return $e(_);C.writeFile(Q,K,V=>{if(V)return C.close(Q,()=>$e(V));C.fdatasync(Q,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),C.close(Q,me=>$e(me))))})})}function E(F,K,H){const $e=u(H);if(!a)return C.writeFileSync(F,K,{mode:$e.mode,flag:$e.flag});const _=C.openSync(F,$e.flag,$e.mode);try{C.writeFileSync(_,K);try{C.fdatasyncSync(_)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{C.closeSync(_)}}e.writeFileSync=E;function u(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function h(F,K,H=6e4){if(F!==K)try{$.$i&&typeof H=="number"?await w(F,K,Date.now(),H):await(0,f.promisify)(C.rename)(F,K)}catch($e){if(F.toLowerCase()!==K.toLowerCase()&&$e.code==="EXDEV"||F.endsWith("."))await L(F,K,{preserveSymlinks:!1}),await k(F,p.MOVE);else throw $e}}async function w(F,K,H,$e,_=0){try{return await(0,f.promisify)(C.rename)(F,K)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-H>=$e)throw console.error(`[node.js fs] rename failed after ${_} retries with error: ${Q}`),Q;if(_===0){let V=!1;try{const{stat:ee}=await o.stat(K);ee.isFile()||(V=!0)}catch{}if(V)throw Q}return await(0,R.$Fg)(Math.min(100,_*10)),w(F,K,H,$e,_+1)}}async function L(F,K,H){return N(F,K,{root:{source:F,target:K},options:H,handledSourcePaths:new Set})}const O=511;async function N(F,K,H){if(H.handledSourcePaths.has(F))return;H.handledSourcePaths.add(F);const{stat:$e,symbolicLink:_}=await o.stat(F);if(_){if(H.options.preserveSymlinks)try{return await j(F,K,H)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(_.dangling)return}return $e.isDirectory()?M(F,K,$e.mode&O,H):z(F,K,$e.mode&O)}async function M(F,K,H,$e){await e.Promises.mkdir(K,{recursive:!0,mode:H});const _=await i(F);for(const Q of _)await N((0,S.$$c)(F,Q),(0,S.$$c)(K,Q),$e)}async function z(F,K,H){await e.Promises.copyFile(F,K),await e.Promises.chmod(K,H)}async function j(F,K,H){let $e=await e.Promises.readlink(F);(0,A.$Ke)($e,H.root.source,!$.$k)&&($e=(0,S.$$c)(H.root.target,$e.substr(H.root.source.length+1))),await e.Promises.symlink($e,K)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(F,K,H,$e,_)=>new Promise((Q,V)=>{C.read(F,K,H,$e,_,(ee,me,ae)=>ee?V(ee):Q({bytesRead:me,buffer:ae}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(F,K,H,$e,_)=>new Promise((Q,V)=>{C.write(F,K,H,$e,_,(ee,me,ae)=>ee?V(ee):Q({bytesWritten:me,buffer:ae}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return i}get readDirsInDir(){return g}get writeFile(){return n}get rm(){return k}get rename(){return h}get copy(){return L}}}),define(De[101],Ce([1,0,52,16,12,15,29]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=e.$Sp=e.$Rp=void 0;function m(p){if(f.$k)return p;const k=(0,T.$bd)(p);if(p===k)return p;const D=((0,T.$cd)(p)||p).toLowerCase();try{const r=(0,A.readdirSync)(k).filter(i=>i.toLowerCase()===D);if(r.length===1){const i=m(k);if(i)return(0,T.$$c)(i,r[0])}else if(r.length>1){const i=r.indexOf(D);if(i>=0){const s=m(k);if(s)return(0,T.$$c)(s,r[i])}}}catch{}return null}e.$Rp=m;async function S(p){if(f.$k)return p;const k=(0,T.$bd)(p);if(p===k)return p;const D=((0,T.$cd)(p)||p).toLowerCase();try{const r=(await A.Promises.readdir(k)).filter(i=>i.toLowerCase()===D);if(r.length===1){const i=await S(k);if(i)return(0,T.$$c)(i,r[0])}else if(r.length>1){const i=r.indexOf(D);if(i>=0){const s=await S(k);if(s)return(0,T.$$c)(s,r[i])}}}catch{}return null}e.$Sp=S;async function $(p){try{return await A.Promises.realpath(p)}catch{const D=I(p);return await A.Promises.access(D,C.constants.R_OK),D}}e.$Tp=$;function P(p){try{return C.realpathSync(p)}catch{const D=I(p);return C.accessSync(D,C.constants.R_OK),D}}e.$Up=P;function I(p){return(0,R.$xd)((0,T.$9c)(p),T.sep)}}),define(De[102],Ce([1,0,16,12,47,99,18,29]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function S(I=f.env){return I.comspec||"cmd.exe"}e.$sl=S;function $(I){let p=[],k=!1;const D=function(y){if(k){p.push(y);return}(!I.send(y,i=>{if(i&&console.error(i),k=!1,p.length>0){const s=p.slice(0);p=[],s.forEach(d=>D(d))}})||T.$i)&&(k=!0)};return{send:D}}e.$tl=$;var P;(function(I){async function p(k,D,y){if(C.$0c(k))return k;if(D===void 0&&(D=f.cwd()),C.$bd(k)!=="."||(y===void 0&&A.$le(f.env.PATH)&&(y=f.env.PATH.split(C.$id)),y===void 0||y.length===0))return C.$$c(D,k);async function i(s){if(await m.Promises.exists(s)){let d;try{d=await m.Promises.stat(s)}catch(b){b.message.startsWith("EACCES")&&(d=await m.Promises.lstat(s))}return d?!d.isDirectory():!1}return!1}for(const s of y){let d;if(C.$0c(s)?d=C.$$c(s,k):d=C.$$c(D,s,k),await i(d))return d;let b=d+".com";if(await i(b)||(b=d+".exe",await i(b)))return b}return C.$$c(D,k)}I.findExecutable=p})(P||(e.win32=P={}))});var Ke=this&&this.__decorate||function(be,e,C,T){var f=arguments.length,R=f<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,C):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(be,e,C,T);else for(var m=be.length-1;m>=0;m--)(A=be[m])&&(R=(f<3?A(R):f>3?A(e,C,R):A(e,C))||R);return f>3&&R&&Object.defineProperty(e,C,R),R};define(De[80],Ce([1,0,19,11,22,21,56,8,4,3,62,15,18]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.ProxyChannel=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.RequestInitiator=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=void 0;var k;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(k||(k={}));function D(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(y||(y={}));function r(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var i;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(i||(i={}));function s(_){let Q=0;for(let V=0;;V+=7){const ee=_.read(1);if(Q|=(ee.buffer[0]&127)<<V,!(ee.buffer[0]&128))return Q}}const d=c(0);function b(_,Q){if(Q===0){_.write(d);return}let V=0;for(let me=Q;me!==0;me=me>>>7)V++;const ee=f.$Hc.alloc(V);for(let me=0;Q!==0;me++)ee.buffer[me]=Q&127,Q=Q>>>7,Q>0&&(ee.buffer[me]|=128);_.write(ee)}class g{constructor(Q){this.b=Q,this.a=0}read(Q){const V=this.b.slice(this.a,this.a+Q);return this.a+=V.byteLength,V}}e.$0g=g;class t{constructor(){this.a=[]}get buffer(){return f.$Hc.concat(this.a)}write(Q){this.a.push(Q)}}e.$$g=t;var o;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(o||(o={}));function c(_){const Q=f.$Hc.alloc(1);return Q.writeUInt8(_,0),Q}const n={Undefined:c(o.Undefined),String:c(o.String),Buffer:c(o.Buffer),VSBuffer:c(o.VSBuffer),Array:c(o.Array),Object:c(o.Object),Uint:c(o.Int)},a=typeof Buffer<"u";function l(_,Q){if(typeof Q>"u")_.write(n.Undefined);else if(typeof Q=="string"){const V=f.$Hc.fromString(Q);_.write(n.String),b(_,V.byteLength),_.write(V)}else if(a&&Buffer.isBuffer(Q)){const V=f.$Hc.wrap(Q);_.write(n.Buffer),b(_,V.byteLength),_.write(V)}else if(Q instanceof f.$Hc)_.write(n.VSBuffer),b(_,Q.byteLength),_.write(Q);else if(Array.isArray(Q)){_.write(n.Array),b(_,Q.length);for(const V of Q)l(_,V)}else if(typeof Q=="number"&&(Q|0)===Q)_.write(n.Uint),b(_,Q);else{const V=f.$Hc.fromString(JSON.stringify(Q));_.write(n.Object),b(_,V.byteLength),_.write(V)}}e.$_g=l;function v(_){switch(_.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return _.read(s(_)).toString();case o.Buffer:return _.read(s(_)).buffer;case o.VSBuffer:return _.read(s(_));case o.Array:{const V=s(_),ee=[];for(let me=0;me<V;me++)ee.push(v(_));return ee}case o.Object:return JSON.parse(_.read(s(_)).toString());case o.Int:return s(_)}}e.$ah=v;class E{constructor(Q,V,ee=null,me=1e3){this.h=Q,this.j=V,this.k=ee,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(Q,V){this.b.set(Q,V),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const V=this.o([Q.type]);this.k?.logOutgoing(V,0,1,r(Q.type));return}case 201:case 202:case 204:case 203:{const V=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(V,Q.id,1,r(Q.type),Q.data);return}}}o(Q,V=void 0){const ee=new t;return l(ee,Q),l(ee,V),this.p(ee.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const V=new g(Q),ee=v(V),me=v(V),ae=ee[0];switch(ae){case 100:return this.k?.logIncoming(Q.byteLength,ee[1],1,`${D(ae)}: ${ee[2]}.${ee[3]}`,me),this.s({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:me});case 102:return this.k?.logIncoming(Q.byteLength,ee[1],1,`${D(ae)}: ${ee[2]}.${ee[3]}`,me),this.t({type:ae,id:ee[1],channelName:ee[2],name:ee[3],arg:me});case 101:return this.k?.logIncoming(Q.byteLength,ee[1],1,`${D(ae)}`),this.u({type:ae,id:ee[1]});case 103:return this.k?.logIncoming(Q.byteLength,ee[1],1,`${D(ae)}`),this.u({type:ae,id:ee[1]})}}s(Q){const V=this.b.get(Q.channelName);if(!V){this.v(Q);return}const ee=new R.$rc;let me;try{me=V.call(this.j,Q.name,Q.arg,ee.token)}catch(X){me=Promise.reject(X)}const ae=Q.id;me.then(X=>{this.m({id:ae,data:X,type:201})},X=>{X instanceof Error?this.m({id:ae,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:ae,data:X,type:203})}).finally(()=>{te.dispose(),this.d.delete(Q.id)});const te=(0,$.$kb)(()=>ee.cancel());this.d.set(Q.id,te)}t(Q){const V=this.b.get(Q.channelName);if(!V){this.v(Q);return}const ee=Q.id,ae=V.listen(this.j,Q.name,Q.arg)(te=>this.m({id:ee,data:te,type:204}));this.d.set(Q.id,ae)}u(Q){const V=this.d.get(Q.id);V&&(V.dispose(),this.d.delete(Q.id))}v(Q){let V=this.g.get(Q.channelName);V||(V=[],this.g.set(Q.channelName,V));const ee=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:Q,timeoutTimer:ee})}w(Q){const V=this.g.get(Q);if(V){for(const ee of V)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$hb)(this.d.values()),this.d.clear()}}e.$bh=E;var u;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(u||(e.RequestInitiator=u={}));class h{constructor(Q,V=null){this.l=Q,this.a=!1,this.b=i.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$hc,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=V}getChannel(Q){const V=this;return{call(ee,me,ae){return V.a?Promise.reject(new m.$3):V.m(Q,ee,me,ae)},listen(ee,me){return V.a?S.Event.None:V.o(Q,ee,me)}}}m(Q,V,ee,me=R.CancellationToken.None){const ae=this.g++,X={id:ae,type:100,channelName:Q,name:V,arg:ee};if(me.isCancellationRequested)return Promise.reject(new m.$3);let U;return new Promise((G,ce)=>{if(me.isCancellationRequested)return ce(new m.$3);const re=()=>{const ge=ne=>{switch(ne.type){case 201:this.f.delete(ae),G(ne.data);break;case 202:{this.f.delete(ae);const ue=new Error(ne.data.message);ue.stack=Array.isArray(ne.data.stack)?ne.data.stack.join(`
`):ne.data.stack,ue.name=ne.data.name,ce(ue);break}case 203:this.f.delete(ae),ce(ne.data);break}};this.f.set(ae,ge),this.p(X)};let de=null;this.b===i.Idle?re():(de=(0,T.$sg)(ge=>this.u()),de.then(()=>{de=null,re()}));const Ee=()=>{de?(de.cancel(),de=null):this.p({id:ae,type:101}),ce(new m.$3)},he=me.onCancellationRequested(Ee);U=(0,$.$jb)((0,$.$kb)(Ee),he),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,V,ee){const me=this.g++,te={id:me,type:102,channelName:Q,name:V,arg:ee};let X=null;const U=new S.$hc({onWillAddFirstListener:()=>{X=(0,T.$sg)(G=>this.u()),X.then(()=>{X=null,this.d.add(U),this.p(te)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(U),this.p({id:me,type:103}))}}),q=G=>U.fire(G.data);return this.f.set(me,q),U.event}p(Q){switch(Q.type){case 100:case 102:{const V=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(V,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const V=this.q([Q.type,Q.id]);this.j?.logOutgoing(V,Q.id,0,D(Q.type));return}}}q(Q,V=void 0){const ee=new t;return l(ee,Q),l(ee,V),this.r(ee.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const V=new g(Q),ee=v(V),me=v(V),ae=ee[0];switch(ae){case 200:return this.j?.logIncoming(Q.byteLength,0,0,r(ae)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ee[1],0,r(ae),me),this.t({type:ee[0],id:ee[1],data:me})}}t(Q){if(Q.type===200){this.b=i.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===i.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$hb)(this.d.values()),this.d.clear()}}e.$ch=h,Ke([A.$4g],h.prototype,"onDidInitializePromise",null);class w{get connections(){const Q=[];return this.f.forEach(V=>Q.push(V)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new S.$hc,this.onDidAddConnection=this.g.event,this.h=new S.$hc,this.onDidRemoveConnection=this.h.event,this.j=new $.$lb,this.j.add(Q(({protocol:V,onDidClientDisconnect:ee})=>{const me=S.Event.once(V.onMessage);this.j.add(me(ae=>{const te=new g(ae),X=v(te),U=new E(V,X),q=new h(V);this.a.forEach((ce,re)=>U.registerChannel(re,ce));const G={channelServer:U,channelClient:q,ctx:X};this.f.add(G),this.g.fire(G),this.j.add(ee(()=>{U.dispose(),q.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(Q,V){const ee=this;return{call(me,ae,te){let X;if((0,p.$ze)(V)){const q=(0,C.$Wf)(ee.connections.filter(V));X=q?Promise.resolve(q):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,V))}else X=V.routeCall(ee,me,ae);const U=X.then(q=>q.channelClient.getChannel(Q));return O(U).call(me,ae,te)},listen(me,ae){if((0,p.$ze)(V))return ee.k(Q,V,me,ae);const te=V.routeEvent(ee,me,ae).then(X=>X.channelClient.getChannel(Q));return O(te).listen(me,ae)}}}k(Q,V,ee,me){const ae=this;let te;const X=new S.$hc({onWillAddFirstListener:()=>{te=new $.$lb;const U=new S.$nc,q=new Map,G=re=>{const Ee=re.channelClient.getChannel(Q).listen(ee,me),he=U.add(Ee);q.set(re,he)},ce=re=>{const de=q.get(re);de&&(de.dispose(),q.delete(re))};ae.connections.filter(V).forEach(G),S.Event.filter(ae.onDidAddConnection,V)(G,void 0,te),ae.onDidRemoveConnection(ce,void 0,te),U.event(X.fire,X,te),te.add(U)},onDidRemoveLastListener:()=>{te?.dispose(),te=void 0}});return X.event}registerChannel(Q,V){this.a.set(Q,V);for(const ee of this.f)ee.channelServer.registerChannel(Q,V)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$dh=w;class L{constructor(Q,V,ee=null){const me=new t;l(me,V),Q.send(me.buffer),this.a=new h(Q,ee),this.d=new E(Q,V,ee)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,V){this.d.registerChannel(Q,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$eh=L;function O(_){return{call(Q,V,ee){return _.then(me=>me.call(Q,V,ee))},listen(Q,V){const ee=new S.$qc;return _.then(me=>ee.input=me.listen(Q,V)),ee.event}}}e.$fh=O;function N(_){let Q=!1;return{call(V,ee,me){return Q?_.call(V,ee,me):(0,T.$Fg)(0).then(()=>Q=!0).then(()=>_.call(V,ee,me))},listen(V,ee){if(Q)return _.listen(V,ee);const me=new S.$qc;return(0,T.$Fg)(0).then(()=>Q=!0).then(()=>me.input=_.listen(V,ee)),me.event}}}e.$gh=N;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const V of Q.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$hh=M;var z;(function(_){function Q(ae,te,X){const U=ae,q=X&&X.disableMarshalling,G=new Map;for(const ce in U)ee(ce)&&G.set(ce,S.Event.buffer(U[ce],!0,void 0,te));return new class{listen(ce,re,de){const Ee=G.get(re);if(Ee)return Ee;if(me(re)){const he=U[re];if(typeof he=="function")return he.call(U,de)}throw new m.$_(`Event not found: ${re}`)}call(ce,re,de){const Ee=U[re];if(typeof Ee=="function"){if(!q&&Array.isArray(de))for(let he=0;he<de.length;he++)de[he]=(0,P.$9g)(de[he]);return Ee.apply(U,de)}throw new m.$_(`Method not found: ${re}`)}}}_.fromService=Q;function V(ae,te){const X=te&&te.disableMarshalling;return new Proxy({},{get(U,q){if(typeof q=="string")return te?.properties?.has(q)?te.properties.get(q):me(q)?function(G){return ae.listen(q,G)}:ee(q)?ae.listen(q):async function(...G){let ce;te&&!(0,p.$ue)(te.context)?ce=[te.context,...G]:ce=G;const re=await ae.call(q,ce);return X?re:(0,P.$9g)(re)};throw new m.$_(`Property not found: ${String(q)}`)}})}_.toService=V;function ee(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$Nd(ae.charCodeAt(2))}function me(ae){return/^onDynamic/.test(ae)&&I.$Nd(ae.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Q=_.toString();if(Q!=="[object Object]")return Q}return _}function K(_){return Array.isArray(_)?_.map(F):F(_)}function H(_,Q,V,ee,me,ae,te){te=K(te);const X=j[me],U=X[ee%X.length];let q=[`%c[${_}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(q=q.concat(te),q.push(")")):q.push(te),console.log.apply(console,q)}class $e{constructor(Q,V){this.d=Q,this.f=V,this.a=0,this.b=0}logOutgoing(Q,V,ee,me,ae){this.b+=Q,H(this.d,this.b,Q,V,ee,me,ae)}logIncoming(Q,V,ee,me,ae){this.a+=Q,H(this.f,this.a,Q,V,ee,me,ae)}}e.$ih=$e}),define(De[81],Ce([1,0,22,4,3,80]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=e.$kh=e.ProtocolConstants=e.$jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var m;(function(n){n.enableDiagnostics=!1,n.records=[];const a=new WeakMap;let l=0;function v(u,h){if(!a.has(u)){const w=String(++l);a.set(u,w)}return a.get(u)}function E(u,h,w,L){if(!n.enableDiagnostics)return;const O=v(u,h);if(L instanceof C.$Hc||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const N=C.$Hc.alloc(L.byteLength);N.set(L),n.records.push({timestamp:Date.now(),id:O,label:h,type:w,buff:N})}else n.records.push({timestamp:Date.now(),id:O,label:h,type:w,data:L})}n.traceSocketEvent=E})(m||(e.SocketDiagnostics=m={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let $=null;function P(){return $||($=C.$Hc.alloc(0)),$}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return P();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const h=this.a[0];return l&&(this.a.shift(),this.b-=a),h}if(this.a[0].byteLength>a){const h=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),h}const v=C.$Hc.alloc(a);let E=0,u=0;for(;a>0;){const h=this.a[u];if(h.byteLength>a){const w=h.slice(0,a);v.set(w,E),E+=a,l&&(this.a[u]=h.slice(a),this.b-=a),a-=a}else v.set(h,E),E+=h.byteLength,l?(this.a.shift(),this.b-=h.byteLength):u++,a-=h.byteLength}return v}}e.$jh=I;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function k(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class y{constructor(a,l,v,E){this.type=a,this.id=l,this.ack=v,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends f.$mb{constructor(a){super(),this.f=this.B(new T.$hc),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,E=this.g.id,u=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new y(v,E,u,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class i{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=C.$Hc.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:k(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(l,a.data)}g(a,l){const v=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,v}h(){const a=C.$Hc.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class s extends f.$mb{constructor(a){super(),this.f=new T.$hc,this.onMessage=this.f.event,this.g=new T.$hc,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new i(this.a)),this.c=this.B(new r(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new y(1,0,0,a))}}e.$kh=s;class d extends R.$eh{static fromSocket(a,l){return new d(new s(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,v=null){super(a,l,v),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$lh=d;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$hc({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$mh=b;class g{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,v=this.a;for(;v;)a[l++]=v.data,v=v.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new g(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<o.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=o.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+o.a)*1e3;let v=0;for(let E=0;E<o.a;E++)a-this.c[E]<=l&&v++;return 1-v/o.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??o.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$lb,this.o=a.socket,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new y(5,0,0,P());this.p.write(a),this.p.flush()}sendPause(){const a=new y(7,0,0,P());this.p.write(a)}sendResume(){const a=new y(8,0,0,P());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.r.dispose(),this.r=new f.$lb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new i(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new y(3,0,this.h,P());this.p.write(a);const l=this.b.toArray();for(let v=0,E=l.length;v<E;v++)this.p.write(l[v]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const l=this.b.peek();if(l&&l.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new y(6,0,0,P())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let v=0,E=l.length;v<E;v++)this.p.write(l[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const l=++this.c;this.h=this.g;const v=new y(1,l,this.h,a);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(a){const l=new y(2,0,0,a);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),l=Date.now()-a.writtenTime,v=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(l>=2e4&&v>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:v});return}const u=Math.max(2e4-l,2e4-v,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},u)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new y(3,0,this.h,P());this.p.write(a)}D(){this.h=this.g;const a=new y(9,0,this.h,P());this.p.write(a)}}e.$nh=c}),define(De[183],Ce([1,0,48,11,22,21,181,8,4,3,23,102,99,80]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0;class D extends k.$bh{constructor(i){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",s=>f.$Hc.wrap(Buffer.from(s,"base64")))},i),process.once("disconnect",()=>this.dispose())}}e.$Op=D;class y{constructor(i,s){this.i=i,this.j=s,this.c=new Set,this.g=new Map,this.h=new S.$hc,this.onDidProcessExit=this.h.event;const d=s&&s.timeout?s.timeout:6e4;this.b=new T.$Bg(d),this.d=null,this.f=null}getChannel(i){const s=this;return{call(d,b,g){return s.k(i,d,b,g)},listen(d,b){return s.l(i,d,b)}}}k(i,s,d,b=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const g=this.n(i),t=(0,T.$sg)(n=>g.call(s,d,n)),o=b.onCancellationRequested(()=>t.cancel()),c=(0,$.$kb)(()=>t.cancel());return this.c.add(c),t.finally(()=>{o.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(i,s,d){if(!this.b)return S.Event.None;this.b.cancel();let b;const g=new S.$hc({onWillAddFirstListener:()=>{b=this.n(i).listen(s,d)(g.fire,g),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const i=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,P.$Tm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,p.$rl)(s.env),this.d=(0,C.fork)(this.i,i,s);const d=new S.$hc;S.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,A.$Kp)(a)){(0,A.log)(a,`IPC Library: ${this.j.serverName}`);return}d.fire(f.$Hc.wrap(Buffer.from(a,"base64")))});const g=this.j.useQueue?(0,I.$tl)(this.d):this.d,t=a=>this.d&&this.d.connected&&g.send(a.buffer.toString("base64")),o=d.event,c={send:t,onMessage:o};this.f=new k.$ch(c);const n=()=>this.o();process.once("exit",n),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",n),this.c.forEach(v=>(0,$.$hb)(v)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(i){let s=this.g.get(i);return s||(s=this.m.getChannel(i),this.g.set(i,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Pp=y}),define(De[184],Ce([1,0,11,4,3,62,18]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.StorageState=e.$No=e.StorageHint=void 0;var m;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function S(p){const k=p;return k?.changed instanceof Map||k?.deleted instanceof Set}e.$No=S;var $;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})($||(e.StorageState=$={}));class P extends f.$mb{static{this.a=100}constructor(k,D=Object.create(null)){super(),this.m=k,this.n=D,this.b=this.B(new T.$kc),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new C.$Cg(P.a)),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(k=>this.r(k)))}r(k){this.b.pause();try{k.changed?.forEach((D,y)=>this.s(y,D)),k.deleted?.forEach(D=>this.s(D,void 0))}finally{this.b.resume()}}s(k,D){if(this.c===$.Closed)return;let y=!1;(0,A.$ue)(D)?y=this.f.delete(k):this.f.get(k)!==D&&(this.f.set(k,D),y=!0),y&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.n.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(k,D){const y=this.f.get(k);return(0,A.$ue)(y)?D:y}getBoolean(k,D){const y=this.get(k);return(0,A.$ue)(y)?D:y==="true"}getNumber(k,D){const y=this.get(k);return(0,A.$ue)(y)?D:parseInt(y,10)}getObject(k,D){const y=this.get(k);return(0,A.$ue)(y)?D:(0,R.$8g)(y)}async set(k,D,y=!1){if(this.c===$.Closed)return;if((0,A.$ue)(D))return this.delete(k,y);const r=(0,A.$ne)(D)||Array.isArray(D)?(0,R.$7g)(D):String(D);if(this.f.get(k)!==r)return this.f.set(k,r),this.j.set(k,r),this.h.delete(k),this.b.fire({key:k,external:y}),this.w()}async delete(k,D=!1){if(!(this.c===$.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:D}),this.w()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.m.optimize()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=$.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(k).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(k){if(this.u)return this.w(k)}async w(k){return this.n.hint===m.STORAGE_IN_MEMORY?this.v():this.g.trigger(()=>this.v(),k)}async whenFlushed(){if(this.u)return new Promise(k=>this.l.push(k))}isInMemory(){return this.n.hint===m.STORAGE_IN_MEMORY}}e.$Oo=P;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((D,y)=>this.a.set(y,D)),k.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$Po=I}),define(De[185],Ce([1,0,35,16]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$E=void 0;function f(R,A,m,S,$,P){if(Array.isArray(R)){let I=0;for(const p of R){const k=f(p,A,m,S,$,P);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof R=="string")return S?R==="*"?5:R===m?10:0:0;if(R){const{language:I,pattern:p,scheme:k,hasAccessToAllModels:D,notebookType:y}=R;if(!S&&!D)return 0;y&&$&&(A=$);let r=0;if(k)if(k===A.scheme)r=10;else if(k==="*")r=5;else return 0;if(I)if(I===m)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(y)if(y===P)r=10;else if(y==="*"&&P!==void 0)r=Math.max(r,5);else return 0;if(p){let i;if(typeof p=="string"?i=p:i={...p,base:(0,T.$9c)(p.base)},i===A.fsPath||(0,C.$oj)(i,A.fsPath))r=10;else return 0}return r}else return 0}}e.$$E=f}),define(De[129],Ce([1,0,22,12]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k0=e.$j0=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function R(I){for(let p=0,k=I.length;p<k;p+=4){const D=I[p+0],y=I[p+1],r=I[p+2],i=I[p+3];I[p+0]=i,I[p+1]=r,I[p+2]=y,I[p+3]=D}}function A(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$C()||R(p),C.$Hc.wrap(p)}function m(I){const p=I.buffer;if(T.$C()||R(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const k=new Uint8Array(p.byteLength);return k.set(p),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function S(I){const p=new Uint32Array($(I));let k=0;if(p[k++]=I.id,I.type==="full")p[k++]=1,p[k++]=I.data.length,p.set(I.data,k),k+=I.data.length;else{p[k++]=2,p[k++]=I.deltas.length;for(const D of I.deltas)p[k++]=D.start,p[k++]=D.deleteCount,D.data?(p[k++]=D.data.length,p.set(D.data,k),k+=D.data.length):p[k++]=0}return A(p)}e.$j0=S;function $(I){let p=0;if(p+=1+1,I.type==="full")p+=1+I.data.length;else{p+=1,p+=(1+1+1)*I.deltas.length;for(const k of I.deltas)k.data&&(p+=k.data.length)}return p}function P(I){const p=m(I);let k=0;const D=p[k++];if(p[k++]===1){const s=p[k++],d=p.subarray(k,k+s);return k+=s,{id:D,type:"full",data:d}}const r=p[k++],i=[];for(let s=0;s<r;s++){const d=p[k++],b=p[k++],g=p[k++];let t;g>0&&(t=p.subarray(k,k+g),k+=g),i[s]={start:d,deleteCount:b,data:t}}return{id:D,type:"delta",deltas:i}}e.$k0=P}),define(De[186],Ce([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,23,12,166,124,186]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=$;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class I{constructor(oe,Ie,qe,je){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=je}applyUpdate(oe,Ie){return k(oe,Ie)}compute(oe,Ie,qe){return qe}}class p{constructor(oe,Ie){this.newValue=oe,this.didChange=Ie}}e.ApplyUpdateResult=p;function k(le,oe){if(typeof le!="object"||typeof oe!="object"||!le||!oe)return new p(oe,le!==oe);if(Array.isArray(le)||Array.isArray(oe)){const qe=Array.isArray(le)&&Array.isArray(oe)&&C.$of(le,oe);return new p(oe,!qe)}let Ie=!1;for(const qe in oe)if(oe.hasOwnProperty(qe)){const je=k(le[qe],oe[qe]);je.didChange&&(le[qe]=je.newValue,Ie=!0)}return new p(le,Ie)}class D{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ie){return k(oe,Ie)}validate(oe){return this.defaultValue}}class y{constructor(oe,Ie,qe,je){this.id=oe,this.name=Ie,this.defaultValue=qe,this.schema=je}applyUpdate(oe,Ie){return k(oe,Ie)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ie,qe){return qe}}function r(le,oe){return typeof le>"u"?oe:le==="false"?!1:!!le}e.boolean=r;class i extends y{constructor(oe,Ie,qe,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=qe),super(oe,Ie,qe,je)}validate(oe){return r(oe,this.defaultValue)}}function s(le,oe,Ie,qe){if(typeof le>"u")return oe;let je=parseInt(le,10);return isNaN(je)?oe:(je=Math.max(Ie,je),je=Math.min(qe,je),je|0)}e.clampedInt=s;class d extends y{static clampedInt(oe,Ie,qe,je){return s(oe,Ie,qe,je)}constructor(oe,Ie,qe,je,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=je,nt.maximum=Xe),super(oe,Ie,qe,nt),this.minimum=je,this.maximum=Xe}validate(oe){return d.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function b(le,oe,Ie,qe){if(typeof le>"u")return oe;const je=g.float(le,oe);return g.clamp(je,Ie,qe)}e.clampedFloat=b;class g extends y{static clamp(oe,Ie,qe){return oe<Ie?Ie:oe>qe?qe:oe}static float(oe,Ie){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ie;const qe=parseFloat(oe);return isNaN(qe)?Ie:qe}constructor(oe,Ie,qe,je,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=qe),super(oe,Ie,qe,Xe),this.validationFn=je}validate(oe){return this.validationFn(g.float(oe,this.defaultValue))}}class t extends y{static string(oe,Ie){return typeof oe!="string"?Ie:oe}constructor(oe,Ie,qe,je=void 0){typeof je<"u"&&(je.type="string",je.default=qe),super(oe,Ie,qe,je)}validate(oe){return t.string(oe,this.defaultValue)}}function o(le,oe,Ie,qe){return typeof le!="string"?oe:qe&&le in qe?qe[le]:Ie.indexOf(le)===-1?oe:le}e.stringSet=o;class c extends y{constructor(oe,Ie,qe,je,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=qe),super(oe,Ie,qe,Xe),this.c=je}validate(oe){return o(oe,this.defaultValue,this.c)}}class n extends I{constructor(oe,Ie,qe,je,Xe,nt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Xe,ot.default=je),super(oe,Ie,qe,ot),this.c=Xe,this.d=nt}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function a(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ie,qe){return qe===0?oe.accessibilitySupport:qe}}class v extends I{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:m.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertSpace:r(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function u(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function w(le){switch(le){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function L(le){switch(le){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends D{constructor(){super(140)}compute(oe,Ie,qe){const je=["monaco-editor"];return Ie.get(39)&&je.push(Ie.get(39)),oe.extraEditorClassName&&je.push(oe.extraEditorClassName),Ie.get(73)==="default"?je.push("mouse-default"):Ie.get(73)==="copy"&&je.push("mouse-copy"),Ie.get(110)&&je.push("showUnused"),Ie.get(138)&&je.push("showDeprecated"),je.join(" ")}}class N extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(oe,Ie,qe){return qe&&oe.emptySelectionClipboard}}class M extends I{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:m.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:m.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{cursorMoveOnType:r(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":o(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":o(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(Ie.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?z.OFF:oe==="true"?z.ON:oe:oe?z.ON:z.OFF}}e.EditorFontLigatures=z;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?j.OFF:oe==="true"?j.TRANSLATE:oe:oe?j.TRANSLATE:j.OFF}compute(oe,Ie,qe){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class F extends D{constructor(){super(50)}compute(oe,Ie,qe){return oe.fontInfo}}class K extends y{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(oe){const Ie=g.float(oe,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(Ie,6,100)}compute(oe,Ie,qe){return oe.fontInfo.fontSize}}class H extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(d.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class $e extends I{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:qe,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:qe,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:qe,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:qe,description:m.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{multiple:o(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??o(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??o(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??o(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??o(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??o(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends I{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:m.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),delay:d.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:r(Ie.sticky,this.defaultValue.sticky),hidingDelay:d.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r(Ie.above,this.defaultValue.above)}}}var Q;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class V extends D{constructor(){super(143)}compute(oe,Ie,qe){return V.computeLayout(Ie,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ie=oe.height/oe.lineHeight,qe=Math.floor(oe.paddingTop/oe.lineHeight);let je=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(je=Math.max(je,Ie-1));const Xe=(qe+oe.viewLineCount+je)/(oe.pixelRatio*oe.height),nt=Math.floor(oe.viewLineCount/Xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:je,desiredRatio:Xe,minimapLineCount:nt}}static c(oe,Ie){const qe=oe.outerWidth,je=oe.outerHeight,Xe=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const nt=Ie.stableMinimapLayoutInput,ot=nt&&oe.outerHeight===nt.outerHeight&&oe.lineHeight===nt.lineHeight&&oe.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&oe.pixelRatio===nt.pixelRatio&&oe.scrollBeyondLastLine===nt.scrollBeyondLastLine&&oe.paddingTop===nt.paddingTop&&oe.paddingBottom===nt.paddingBottom&&oe.minimap.enabled===nt.minimap.enabled&&oe.minimap.side===nt.minimap.side&&oe.minimap.size===nt.minimap.size&&oe.minimap.showSlider===nt.minimap.showSlider&&oe.minimap.renderCharacters===nt.minimap.renderCharacters&&oe.minimap.maxColumn===nt.minimap.maxColumn&&oe.minimap.scale===nt.minimap.scale&&oe.verticalScrollbarWidth===nt.verticalScrollbarWidth&&oe.isViewportWrapping===nt.isViewportWrapping,bt=oe.lineHeight,Dt=oe.typicalHalfwidthCharacterWidth,Qt=oe.scrollBeyondLastLine,Vt=oe.minimap.renderCharacters;let vt=Xe>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Tt=oe.minimap.maxColumn,Nt=oe.minimap.size,Kt=oe.minimap.side,At=oe.verticalScrollbarWidth,Rt=oe.viewLineCount,Ot=oe.remainingWidth,Ut=oe.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Xe*je);const ct=Bt/Xe;let lt=!1,Jt=!1,Pt=qt*vt,kt=vt/Xe,dt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Te,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:ie,desiredRatio:Fe,minimapLineCount:He}=V.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Qt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:je,lineHeight:bt,pixelRatio:Xe});if(Rt/He>1)lt=!0,Jt=!0,vt=1,Pt=1,kt=vt/Xe;else{let Je=!1,rt=vt+1;if(Nt==="fit"){const pt=Math.ceil((Se+Rt+ie)*Pt);Ut&&ot&&Ot<=Ie.stableFitRemainingWidth?(Je=!0,rt=Ie.stableFitMaxMinimapScale):Je=pt>Bt}if(Nt==="fill"||Je){lt=!0;const pt=vt;Pt=Math.min(bt*Xe,Math.max(1,Math.floor(1/Fe))),Ut&&ot&&Ot<=Ie.stableFitRemainingWidth&&(rt=Ie.stableFitMaxMinimapScale),vt=Math.min(rt,Math.max(1,Math.floor(Pt/qt))),vt>pt&&(dt=Math.min(2,vt/pt)),kt=vt/Xe/dt,Bt=Math.ceil(Math.max(Te,Se+Rt+ie)*Pt),Ut?(Ie.stableMinimapLayoutInput=oe,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Ct=Math.floor(Tt*kt),Ft=Math.min(Ct,Math.max(0,Math.floor((Ot-At-2)*kt/(Dt+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Xe*Ft);const Ge=Et/Xe;Et=Math.floor(Et*dt);const zt=Vt?1:2,Me=Kt==="left"?0:qe-Ft-At;return{renderMinimap:zt,minimapLeft:Me,minimapWidth:Ft,minimapHeightIsEditorHeight:lt,minimapIsSampling:Jt,minimapScale:vt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:Ge,minimapCanvasOuterHeight:ct}}static computeLayout(oe,Ie){const qe=Ie.outerWidth|0,je=Ie.outerHeight|0,Xe=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Dt=Ie.pixelRatio,Qt=Ie.viewLineCount,Vt=oe.get(135),vt=Vt==="inherit"?oe.get(134):Vt,Tt=vt==="inherit"?oe.get(130):vt,Nt=oe.get(133),Kt=Ie.isDominatedByLongLines,At=oe.get(57),Rt=oe.get(67).renderType!==0,Ot=oe.get(68),Ut=oe.get(104),qt=oe.get(83),Bt=oe.get(72),ct=oe.get(102),lt=ct.verticalScrollbarSize,Jt=ct.verticalHasArrows,Pt=ct.arrowSize,kt=ct.horizontalScrollbarSize,dt=oe.get(43),Ct=oe.get(109)!=="never";let Ft=oe.get(65);dt&&Ct&&(Ft+=16);let Et=0;if(Rt){const ft=Math.max(nt,Ot);Et=Math.round(ft*bt)}let Ge=0;At&&(Ge=Xe*Ie.glyphMarginDecorationLaneCount);let zt=0,Me=zt+Ge,Te=Me+Et,Se=Te+Ft;const ie=qe-Ge-Et-Ft;let Fe=!1,He=!1,_e=-1;vt==="inherit"&&Kt?(Fe=!0,He=!0):Tt==="on"||Tt==="bounded"?He=!0:Tt==="wordWrapColumn"&&(_e=Nt);const Je=V.c({outerWidth:qe,outerHeight:je,lineHeight:Xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:Dt,scrollBeyondLastLine:Ut,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:lt,viewLineCount:Qt,remainingWidth:ie,isViewportWrapping:He},Ie.memory||new P);Je.renderMinimap!==0&&Je.minimapLeft===0&&(zt+=Je.minimapWidth,Me+=Je.minimapWidth,Te+=Je.minimapWidth,Se+=Je.minimapWidth);const rt=ie-Je.minimapWidth,pt=Math.max(1,Math.floor((rt-lt-2)/ot)),wt=Jt?Pt:0;return He&&(_e=Math.max(1,pt),Tt==="bounded"&&(_e=Math.min(_e,Nt))),{width:qe,height:je,glyphMarginLeft:zt,glyphMarginWidth:Ge,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Me,lineNumbersWidth:Et,decorationsLeft:Te,decorationsWidth:Ft,contentLeft:Se,contentWidth:rt,minimap:Je,viewportColumn:pt,isWordWrapMinified:Fe,isViewportWrapping:He,wrappingColumn:_e,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:wt,width:lt,height:je-2*wt,right:0}}}}e.EditorLayoutInfoComputer=V;class ee extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(oe){return o(oe,"simple",["simple","advanced"])}compute(oe,Ie,qe){return Ie.get(2)===2?"advanced":qe}}class me extends I{constructor(){const oe={enabled:!0};super(64,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:m.localize(50,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:r(oe.enabled,this.defaultValue.enabled)}}}class ae extends I{constructor(){const oe={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:m.localize(54,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),maxLineCount:d.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:o(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends I{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:m.localize(62,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:o(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:d.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:r(Ie.padding,this.defaultValue.padding)}}}class X extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):d.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ie,qe){return qe<0?d.clampedInt(-qe*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class U extends g{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>g.clamp(oe,0,150),{markdownDescription:m.localize(63,null)})}compute(oe,Ie,qe){return oe.fontInfo.lineHeight}}class q extends I{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:oe.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:m.localize(74,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),autohide:r(Ie.autohide,this.defaultValue.autohide),size:o(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(Ie.side,this.defaultValue.side,["right","left"]),showSlider:o(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(Ie.scale,1,1,3),maxColumn:d.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(le){return le==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class ce extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{top:d.clampedInt(Ie.top,0,0,1e3),bottom:d.clampedInt(Ie.bottom,0,0,1e3)}}}class re extends I{constructor(){const oe={enabled:!0,cycle:!0};super(85,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:m.localize(78,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),cycle:r(Ie.cycle,this.defaultValue.cycle)}}}class de extends D{constructor(){super(141)}compute(oe,Ie,qe){return oe.pixelRatio}}class Ee extends I{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:oe.strings,description:m.localize(82,null)},comments:{anyOf:Ie,default:oe.comments,description:m.localize(83,null)},other:{anyOf:Ie,default:oe.other,description:m.localize(84,null)}},default:oe,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Dt=oe?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ie,comments:qe,strings:je}=oe,Xe=["on","inline","off"];let nt,ot,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=o(Ie,this.defaultValue.other,Xe),typeof qe=="boolean"?ot=qe?"on":"off":ot=o(qe,this.defaultValue.comments,Xe),typeof je=="boolean"?bt=je?"on":"off":bt=o(je,this.defaultValue.strings,Xe),{other:nt,comments:ot,strings:bt}}}var he;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(he||(e.RenderLineNumbersType=he={}));class ge extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(oe){let Ie=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ie=4,qe=oe):oe==="interval"?Ie=3:oe==="relative"?Ie=2:oe==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:qe}}}function ne(le){const oe=le.get(97);return oe==="editable"?le.get(90):oe!=="on"}e.filterValidationDecorations=ne;class ue extends I{constructor(){const oe=[],Ie={type:"number",description:m.localize(91,null)};super(101,"rulers",oe,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:oe,description:m.localize(93,null)})}validate(oe){if(Array.isArray(oe)){const Ie=[];for(const qe of oe)if(typeof qe=="number")Ie.push({column:d.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const je=qe;Ie.push({column:d.clampedInt(je.column,0,0,1e4),color:je.color})}return Ie.sort((qe,je)=>qe.column-je.column),Ie}return this.defaultValue}}class we extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Pe(le,oe){if(typeof le!="string")return oe;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:m.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe,qe=d.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=d.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:r(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:d.clampedInt(Ie.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:d.clampedInt(Ie.verticalSliderSize,je,0,1e3),scrollByPage:r(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends I{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:m.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:m.localize(111,null)}})}applyUpdate(oe,Ie){let qe=!1;Ie.allowedCharacters&&oe&&(T.$Xm(oe.allowedCharacters,Ie.allowedCharacters)||(oe={...oe,allowedCharacters:Ie.allowedCharacters},qe=!0)),Ie.allowedLocales&&oe&&(T.$Xm(oe.allowedLocales,Ie.allowedLocales)||(oe={...oe,allowedLocales:Ie.allowedLocales},qe=!0));const je=super.applyUpdate(oe,Ie);return qe?new p(je.newValue,!0):je}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{nonBasicASCII:fe(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ie){if(typeof oe!="object"||!oe)return Ie;const qe={};for(const[je,Xe]of Object.entries(oe))Xe===!0&&(qe[je]=!0);return qe}}class x extends I{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:m.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(113,null),m.localize(114,null)],description:m.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:m.localize(116,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),mode:o(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:o(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const oe={enabled:R.$Rr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Rr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:m.localize(118,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(119,null),m.localize(120,null),m.localize(121,null)],default:oe.bracketPairs,description:m.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(123,null),m.localize(124,null),m.localize(125,null)],default:oe.bracketPairsHorizontal,description:m.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:m.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:m.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:oe.highlightActiveIndentation,description:m.localize(132,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{bracketPairs:fe(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(le,oe,Ie){const qe=Ie.indexOf(le);return qe===-1?oe:Ie[qe]}class ye extends I{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(133,null),m.localize(134,null)],default:oe.insertMode,description:m.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:m.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:m.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:m.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null),m.localize(142,null)],default:oe.selectionMode,markdownDescription:m.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:m.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:m.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:m.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:m.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:m.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{insertMode:o(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:o(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:r(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:r(Ie.preview,this.defaultValue.preview),previewMode:o(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(Ie.showMethods,this.defaultValue.showMethods),showFunctions:r(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:r(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(Ie.showFields,this.defaultValue.showFields),showVariables:r(Ie.showVariables,this.defaultValue.showVariables),showClasses:r(Ie.showClasses,this.defaultValue.showClasses),showStructs:r(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:r(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:r(Ie.showModules,this.defaultValue.showModules),showProperties:r(Ie.showProperties,this.defaultValue.showProperties),showEvents:r(Ie.showEvents,this.defaultValue.showEvents),showOperators:r(Ie.showOperators,this.defaultValue.showOperators),showUnits:r(Ie.showUnits,this.defaultValue.showUnits),showValues:r(Ie.showValues,this.defaultValue.showValues),showConstants:r(Ie.showConstants,this.defaultValue.showConstants),showEnums:r(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:r(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(Ie.showKeywords,this.defaultValue.showKeywords),showWords:r(Ie.showWords,this.defaultValue.showWords),showColors:r(Ie.showColors,this.defaultValue.showColors),showFiles:r(Ie.showFiles,this.defaultValue.showFiles),showReferences:r(Ie.showReferences,this.defaultValue.showReferences),showFolders:r(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:r(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:r(Ie.showUsers,this.defaultValue.showUsers),showIssues:r(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(182,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class xe extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(183,null),m.localize(184,null),m.localize(185,null),m.localize(186,null)],description:m.localize(187,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ie,qe){return Ie.get(2)===2?0:qe}}class Ye extends D{constructor(){super(144)}compute(oe,Ie,qe){const je=Ie.get(143);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class it extends I{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(190,null),m.localize(191,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showDropSelector:o(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:m.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(194,null),m.localize(195,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ie=oe;return{enabled:r(Ie.enabled,this.defaultValue.enabled),showPasteSelector:o(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Ne:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(le){return e.editorOptionsRegistry[le.id]=le,le}var Qe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(196,null)})),acceptSuggestionOnEnter:Le(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(197,null),""],markdownDescription:m.localize(198,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new d(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(200,null))),ariaRequired:Le(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(202,null),m.localize(203,null),""],description:m.localize(204,null)})),autoClosingComments:Le(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(205,null),m.localize(206,null),""],description:m.localize(207,null)})),autoClosingDelete:Le(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(208,null),""],description:m.localize(209,null)})),autoClosingOvertype:Le(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingQuotes:Le(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),""],description:m.localize(214,null)})),autoIndent:Le(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[m.localize(215,null),m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null)],description:m.localize(220,null)})),automaticLayout:Le(new i(13,"automaticLayout",!1)),autoSurround:Le(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),""],description:m.localize(224,null)})),bracketPairColorization:Le(new se),bracketPairGuides:Le(new Y),stickyTabStops:Le(new i(115,"stickyTabStops",!1,{description:m.localize(225,null)})),codeLens:Le(new i(17,"codeLens",!0,{description:m.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(227,null)})),codeLensFontSize:Le(new d(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(228,null)})),colorDecorators:Le(new i(20,"colorDecorators",!0,{description:m.localize(229,null)})),colorDecoratorActivatedOn:Le(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),colorDecoratorsLimit:Le(new d(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(234,null)})),columnSelection:Le(new i(22,"columnSelection",!1,{description:m.localize(235,null)})),comments:Le(new v),contextmenu:Le(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new i(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(236,null)})),cursorBlinking:Le(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:m.localize(237,null)})),cursorSmoothCaretAnimation:Le(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(238,null),m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorStyle:Le(new n(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:m.localize(242,null)})),cursorSurroundingLines:Le(new d(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(243,null)})),cursorSurroundingLinesStyle:Le(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(244,null),m.localize(245,null)],markdownDescription:m.localize(246,null)})),cursorWidth:Le(new d(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(247,null)})),disableLayerHinting:Le(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new i(34,"domReadOnly",!1)),dragAndDrop:Le(new i(35,"dragAndDrop",!0,{description:m.localize(248,null)})),emptySelectionClipboard:Le(new N),dropIntoEditor:Le(new it),stickyScroll:Le(new ae),experimentalWhitespaceRendering:Le(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(249,null),m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new g(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:m.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new i(42,"fixedOverflowWidgets",!1)),folding:Le(new i(43,"folding",!0,{description:m.localize(254,null)})),foldingStrategy:Le(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),foldingHighlight:Le(new i(45,"foldingHighlight",!0,{description:m.localize(258,null)})),foldingImportsByDefault:Le(new i(46,"foldingImportsByDefault",!1,{description:m.localize(259,null)})),foldingMaximumRegions:Le(new d(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(262,null)})),fontInfo:Le(new F),fontLigatures2:Le(new z),fontSize:Le(new K),fontWeight:Le(new H),fontVariations:Le(new j),formatOnPaste:Le(new i(55,"formatOnPaste",!1,{description:m.localize(263,null)})),formatOnType:Le(new i(56,"formatOnType",!1,{description:m.localize(264,null)})),glyphMargin:Le(new i(57,"glyphMargin",!0,{description:m.localize(265,null)})),gotoLocation:Le(new $e),hideCursorInOverviewRuler:Le(new i(59,"hideCursorInOverviewRuler",!1,{description:m.localize(266,null)})),hover:Le(new _),inDiffEditor:Le(new i(61,"inDiffEditor",!1)),letterSpacing:Le(new g(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>g.clamp(le,-5,20),{description:m.localize(267,null)})),lightbulb:Le(new me),lineDecorationsWidth:Le(new X),lineHeight:Le(new U),lineNumbers:Le(new ge),lineNumbersMinChars:Le(new d(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new i(69,"linkedEditing",!1,{description:m.localize(268,null)})),links:Le(new i(70,"links",!0,{description:m.localize(269,null)})),matchBrackets:Le(new c(71,"matchBrackets","always",["always","near","never"],{description:m.localize(270,null)})),minimap:Le(new q),mouseStyle:Le(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new g(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:m.localize(271,null)})),mouseWheelZoom:Le(new i(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(272,null)})),multiCursorMergeOverlapping:Le(new i(76,"multiCursorMergeOverlapping",!0,{description:m.localize(273,null)})),multiCursorModifier:Le(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[m.localize(274,null),m.localize(275,null)],markdownDescription:m.localize(276,null)})),multiCursorPaste:Le(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(277,null),m.localize(278,null)],markdownDescription:m.localize(279,null)})),multiCursorLimit:Le(new d(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(280,null)})),occurrencesHighlight:Le(new i(80,"occurrencesHighlight",!0,{description:m.localize(281,null)})),overviewRulerBorder:Le(new i(81,"overviewRulerBorder",!0,{description:m.localize(282,null)})),overviewRulerLanes:Le(new d(82,"overviewRulerLanes",3,0,3)),padding:Le(new ce),pasteAs:Le(new et),parameterHints:Le(new re),peekWidgetDefaultFocus:Le(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(283,null),m.localize(284,null)],description:m.localize(285,null)})),definitionLinkOpensInPeek:Le(new i(87,"definitionLinkOpensInPeek",!1,{description:m.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new d(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(287,null)})),readOnly:Le(new i(90,"readOnly",!1)),readOnlyMessage:Le(new we),renameOnType:Le(new i(92,"renameOnType",!1,{description:m.localize(288,null),markdownDeprecationMessage:m.localize(289,null)})),renderControlCharacters:Le(new i(93,"renderControlCharacters",!0,{description:m.localize(290,null),restricted:!0})),renderFinalNewline:Le(new c(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(291,null)})),renderLineHighlight:Le(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(292,null)],description:m.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(294,null)})),renderValidationDecorations:Le(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(295,null),m.localize(296,null),m.localize(297,null),""],description:m.localize(298,null)})),revealHorizontalRightPadding:Le(new d(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new i(100,"roundedSelection",!0,{description:m.localize(299,null)})),rulers:Le(new ue),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new d(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(300,null)})),scrollBeyondLastLine:Le(new i(104,"scrollBeyondLastLine",!0,{description:m.localize(301,null)})),scrollPredominantAxis:Le(new i(105,"scrollPredominantAxis",!0,{description:m.localize(302,null)})),selectionClipboard:Le(new i(106,"selectionClipboard",!0,{description:m.localize(303,null),included:f.$k})),selectionHighlight:Le(new i(107,"selectionHighlight",!0,{description:m.localize(304,null)})),selectOnLineNumbers:Le(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(305,null),m.localize(306,null),m.localize(307,null)],description:m.localize(308,null)})),showUnused:Le(new i(110,"showUnused",!0,{description:m.localize(309,null)})),showDeprecated:Le(new i(138,"showDeprecated",!0,{description:m.localize(310,null)})),inlayHints:Le(new te),snippetSuggestions:Le(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(311,null),m.localize(312,null),m.localize(313,null),m.localize(314,null)],description:m.localize(315,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new i(113,"smoothScrolling",!1,{description:m.localize(316,null)})),stopRenderingLineAfter:Le(new d(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new x),inlineCompletionsAccessibilityVerbose:Le(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(317,null)})),suggestFontSize:Le(new d(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new d(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new i(120,"suggestOnTriggerCharacters",!0,{description:m.localize(320,null)})),suggestSelection:Le(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),tabCompletion:Le(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(325,null),m.localize(326,null),m.localize(327,null)],description:m.localize(328,null)})),tabIndex:Le(new d(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Z),unusualLineTerminators:Le(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),useShadowDOM:Le(new i(126,"useShadowDOM",!0)),useTabStops:Le(new i(127,"useTabStops",!0,{description:m.localize(333,null)})),wordBreak:Le(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$Sr,{description:m.localize(337,null)})),wordWrap:Le(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new d(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(343,null)})),wordWrapOverride1:Le(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new O),defaultColorDecorators:Le(new i(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(344,null)})),pixelRatio:Le(new de),tabFocusMode:Le(new i(142,"tabFocusMode",!1,{markdownDescription:m.localize(345,null)})),layoutInfo:Le(new V),wrappingInfo:Le(new Ye),wrappingIndent:Le(new xe),wrappingStrategy:Le(new ee)}}),define(De[187],Ce([9,10]),function(be,e){return be.create("vs/editor/common/languages",e)}),define(De[82],Ce([1,0,78,2,164,34,174,187]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$$s=e.$0s=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$9s=e.$8s=e.SymbolKinds=e.SymbolTag=e.$7s=e.$6s=e.SymbolKind=e.$5s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$4s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$3s=e.$2s=e.$1s=void 0;class S{constructor(z,j,F){this.offset=z,this.type=j,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$1s=S;class ${constructor(z,j){this.tokens=z,this.endState=j,this._tokenizationResultBrand=void 0}}e.$2s=$;class P{constructor(z,j){this.tokens=z,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$3s=P;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(M){const z=new Map;z.set(0,C.$Nj.symbolMethod),z.set(1,C.$Nj.symbolFunction),z.set(2,C.$Nj.symbolConstructor),z.set(3,C.$Nj.symbolField),z.set(4,C.$Nj.symbolVariable),z.set(5,C.$Nj.symbolClass),z.set(6,C.$Nj.symbolStruct),z.set(7,C.$Nj.symbolInterface),z.set(8,C.$Nj.symbolModule),z.set(9,C.$Nj.symbolProperty),z.set(10,C.$Nj.symbolEvent),z.set(11,C.$Nj.symbolOperator),z.set(12,C.$Nj.symbolUnit),z.set(13,C.$Nj.symbolValue),z.set(15,C.$Nj.symbolEnum),z.set(14,C.$Nj.symbolConstant),z.set(15,C.$Nj.symbolEnum),z.set(16,C.$Nj.symbolEnumMember),z.set(17,C.$Nj.symbolKeyword),z.set(27,C.$Nj.symbolSnippet),z.set(18,C.$Nj.symbolText),z.set(19,C.$Nj.symbolColor),z.set(20,C.$Nj.symbolFile),z.set(21,C.$Nj.symbolReference),z.set(22,C.$Nj.symbolCustomColor),z.set(23,C.$Nj.symbolFolder),z.set(24,C.$Nj.symbolTypeParameter),z.set(25,C.$Nj.account),z.set(26,C.$Nj.issues);function j(H){let $e=z.get(H);return $e||(console.info("No codicon found for CompletionItemKind "+H),$e=C.$Nj.symbolProperty),$e}M.toIcon=j;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function K(H,$e){let _=F.get(H);return typeof _>"u"&&!$e&&(_=9),_}M.fromString=K})(p||(e.CompletionItemKinds=p={}));var k;(function(M){M[M.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var D;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var y;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y||(e.CompletionTriggerKind=y={}));var r;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class i{constructor(z,j,F,K){this.range=z,this.text=j,this.completionKind=F,this.isSnippetText=K}equals(z){return R.$hs.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$4s=i;var s;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(s||(e.CodeActionTriggerType=s={}));var d;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(d||(e.SignatureHelpTriggerKind=d={}));var b;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(b||(e.DocumentHighlightKind=b={}));function g(M){return M&&T.URI.isUri(M.uri)&&R.$hs.isIRange(M.range)&&(R.$hs.isIRange(M.originSelectionRange)||R.$hs.isIRange(M.targetSelectionRange))}e.$5s=g;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$6s={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function o(M,z){return(0,m.localize)(26,null,M,e.$6s[z])}e.$7s=o;var c;(function(M){M[M.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var n;(function(M){const z=new Map;z.set(0,C.$Nj.symbolFile),z.set(1,C.$Nj.symbolModule),z.set(2,C.$Nj.symbolNamespace),z.set(3,C.$Nj.symbolPackage),z.set(4,C.$Nj.symbolClass),z.set(5,C.$Nj.symbolMethod),z.set(6,C.$Nj.symbolProperty),z.set(7,C.$Nj.symbolField),z.set(8,C.$Nj.symbolConstructor),z.set(9,C.$Nj.symbolEnum),z.set(10,C.$Nj.symbolInterface),z.set(11,C.$Nj.symbolFunction),z.set(12,C.$Nj.symbolVariable),z.set(13,C.$Nj.symbolConstant),z.set(14,C.$Nj.symbolString),z.set(15,C.$Nj.symbolNumber),z.set(16,C.$Nj.symbolBoolean),z.set(17,C.$Nj.symbolArray),z.set(18,C.$Nj.symbolObject),z.set(19,C.$Nj.symbolKey),z.set(20,C.$Nj.symbolNull),z.set(21,C.$Nj.symbolEnumMember),z.set(22,C.$Nj.symbolStruct),z.set(23,C.$Nj.symbolEvent),z.set(24,C.$Nj.symbolOperator),z.set(25,C.$Nj.symbolTypeParameter);function j(F){let K=z.get(F);return K||(console.info("No codicon found for SymbolKind "+F),K=C.$Nj.symbolProperty),K}M.toIcon=j})(n||(e.SymbolKinds=n={}));class a{static asEditOperation(z){return f.$is.replace(R.$hs.lift(z.range),z.text)}}e.$8s=a;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(z){switch(z){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(z)}constructor(z){this.value=z}}e.$9s=l;var v;(function(M){function z(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=z})(v||(e.Command=v={}));var E;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(E||(e.CommentThreadCollapsibleState=E={}));var u;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(u||(e.CommentThreadState=u={}));var h;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(h||(e.CommentMode=h={}));var w;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(w||(e.CommentState=w={}));var L;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class O{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$0s=O,e.$$s=new A.$Ss;var N;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[188],Ce([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([9,10]),function(be,e){return be.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([9,10]),function(be,e){return be.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(De[196],Ce([9,10]),function(be,e){return be.create("vs/platform/files/common/io",e)}),define(De[197],Ce([9,10]),function(be,e){return be.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([9,10]),function(be,e){return be.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([9,10]),function(be,e){return be.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(De[217],Ce([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(De[218],Ce([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([9,10]),function(be,e){return be.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.TokenType=void 0;var f;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...$){switch($.length){case 1:return(0,T.localize)(0,null,$[0]);case 2:return(0,T.localize)(1,null,$[0],$[1]);case 3:return(0,T.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,C.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const I=this.d,p=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:P}),this.f.push(k)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const I=this.c.substring(this.d,this.e),p=S.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,I=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(m);return}const D=this.c.charCodeAt(P);if(I)I=!1;else if(D===47&&!p){P++;break}else D===91?p=!0:D===92?I=!0:D===93&&(p=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$Di=S}),define(De[228],Ce([1,0,24,38,193,371]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function S(i){return i=i.trim(),i==="*"||A.test(i)}e.$zo=S;function $(i){if(!S(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const s=i.match(A);return s?{hasCaret:s[1]==="^",hasGreaterEquals:s[1]===">=",majorBase:s[2]==="x"?0:parseInt(s[2],10),majorMustEqual:s[2]!=="x",minorBase:s[4]==="x"?0:parseInt(s[4],10),minorMustEqual:s[4]!=="x",patchBase:s[6]==="x"?0:parseInt(s[6],10),patchMustEqual:s[6]!=="x",preRelease:s[8]||null}:null}e.$Ao=$;function P(i){if(!i)return null;const s=i.majorBase,d=i.majorMustEqual,b=i.minorBase;let g=i.minorMustEqual;const t=i.patchBase;let o=i.patchMustEqual;i.hasCaret&&(s===0||(g=!1),o=!1);let c=0;if(i.preRelease){const n=m.exec(i.preRelease);if(n){const[,a,l,v]=n;c=Date.UTC(Number(a),Number(l)-1,Number(v))}}return{majorBase:s,majorMustEqual:d,minorBase:b,minorMustEqual:g,patchBase:t,patchMustEqual:o,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$Bo=P;function I(i,s,d){let b;typeof i=="string"?b=P($(i)):b=i;let g;s instanceof Date?g=s.getTime():typeof s=="string"&&(g=new Date(s).getTime());let t;if(typeof d=="string"?t=P($(d)):t=d,!b||!t)return!1;const o=b.majorBase,c=b.minorBase,n=b.patchBase;let a=t.majorBase,l=t.minorBase,v=t.patchBase;const E=t.notBefore;let u=t.majorMustEqual,h=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?o>a?!0:o<a?!1:c>l?!0:c<l||g&&g<E?!1:n>=v:(o===1&&a===0&&(!u||!h||!w)&&(a=1,l=0,v=0,u=!0,h=!1,w=!1),o<a?!1:o>a?!u:c<l?!1:c>l?!h:n<v?!1:n>v?!w:!(g&&g<E))}e.$Co=I;function p(i,s,d,b,g){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([T.default.Error,f.localize(0,null)]),t;if(typeof b.name!="string")return t.push([T.default.Error,f.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([T.default.Error,f.localize(2,null,"version")]),t;if(!b.engines)return t.push([T.default.Error,f.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([T.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!r(b.extensionDependencies))return t.push([T.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!r(b.activationEvents))return t.push([T.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([T.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([T.default.Warning,f.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([T.default.Error,f.localize(9,null,"main")]),t;{const n=(0,C.$gg)(d,b.main);(0,C.$ag)(n,d)||t.push([T.default.Warning,f.localize(10,null,n.path,d.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([T.default.Error,f.localize(11,null,"browser")]),t;{const n=(0,C.$gg)(d,b.browser);(0,C.$ag)(n,d)||t.push([T.default.Warning,f.localize(12,null,n.path,d.path)])}}if(!R.valid(b.version))return t.push([T.default.Error,f.localize(13,null)]),t;const o=[];if(!k(i,s,b,g,o))for(const n of o)t.push([T.default.Error,n]);return t}e.$Do=p;function k(i,s,d,b,g){return b||typeof d.main>"u"&&typeof d.browser>"u"?!0:y(i,s,d.engines.vscode,g)}e.$Eo=k;function D(i,s,d){return i==="*"||y(s,d,i)}e.$Fo=D;function y(i,s,d,b=[]){const g=P($(d));if(!g)return b.push(f.localize(14,null,d)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return b.push(f.localize(15,null,d)),!1}else if(!g.majorMustEqual)return b.push(f.localize(16,null,d)),!1;return I(i,s,g)?!0:(b.push(f.localize(17,null,i,d)),!1)}function r(i){if(!Array.isArray(i))return!1;for(let s=0,d=i.length;s<d;s++)if(typeof i[s]!="string")return!1;return!0}}),define(De[103],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=void 0;class C{constructor(f,R=[],A=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$wh=C}),define(De[104],Ce([1,0,103]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.InstantiationType=void 0;const T=[];var f;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R(m,S,$){S instanceof C.$wh||(S=new C.$wh(S,[],!!$)),T.push([m,S])}e.$jr=R;function A(){return T}e.$kr=A}),define(De[229],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=void 0;class C{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$1p=C;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const m=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(A);m.outgoing.set(S.key,S),S.incoming.set(m.key,m)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let m=this.a.get(A);return m||(m=new C(A,R),this.a.set(A,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,m]of this.a)R.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const m=new Set([R]),S=this.c(A,m);if(S)return S}}c(R,A){for(const[m,S]of R.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const $=this.c(S,A);if($)return $;A.delete(m)}}}e.$2p=T}),define(De[5],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(C||(e._util=C={})),e.$yh=f("instantiationService");function T(A,m,S){m[C.DI_TARGET]===m?m[C.DI_DEPENDENCIES].push({id:A,index:S}):(m[C.DI_DEPENDENCIES]=[{id:A,index:S}],m[C.DI_TARGET]=m)}function f(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const m=function(S,$,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,S,P)};return m.toString=()=>A,C.serviceIds.set(A,m),m}e.$zh=f;function R(A){return A}e.$Ah=R}),define(De[49],Ce([1,0,18,2,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.ConfigurationTarget=e.$8h=e.$7h=e.$6h=void 0,e.$6h=(0,f.$zh)("configurationService");function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.$7h=R;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof T.URI)}e.$8h=A;var m;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function S(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$9h=S;function $(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$0h=$;function P(i,s){const d=Object.create(null);for(const b in i)I(d,b,i[b],s);return d}e.$$h=P;function I(i,s,d,b){const g=s.split("."),t=g.pop();let o=i;for(let c=0;c<g.length;c++){const n=g[c];let a=o[n];switch(typeof a){case"undefined":a=o[n]=Object.create(null);break;case"object":break;default:b(`Ignoring ${s} as ${g.slice(0,c+1).join(".")} is ${JSON.stringify(a)}`);return}o=a}if(typeof o=="object"&&o!==null)try{o[t]=d}catch{b(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(o)}`)}else b(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(o)}`)}e.$_h=I;function p(i,s){const d=s.split(".");k(i,d)}e.$ai=p;function k(i,s){const d=s.shift();if(s.length===0){delete i[d];return}if(Object.keys(i).indexOf(d)!==-1){const b=i[d];typeof b=="object"&&!Array.isArray(b)&&(k(b,s),Object.keys(b).length===0&&delete i[d])}}function D(i,s,d){function b(o,c){let n=o;for(const a of c){if(typeof n!="object"||n===null)return;n=n[a]}return n}const g=s.split("."),t=b(i,g);return typeof t>"u"?d:t}e.$bi=D;function y(i,s,d){Object.keys(s).forEach(b=>{b!=="__proto__"&&(b in i?C.$ne(i[b])&&C.$ne(s[b])?y(i[b],s[b],d):d&&(i[b]=s[b]):i[b]=s[b])})}e.$ci=y;function r(i){return i.replace(/[\[\]]/g,"")}e.$di=r}),define(De[41],Ce([1,0,12,15,227,5,189,8]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.ContextKeyExprType=e.$Ei=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",C.$j),S.set("isLinux",C.$k),S.set("isWindows",C.$i),S.set("isWeb",C.$o),S.set("isMacNative",C.$j&&!C.$o),S.set("isEdge",C.$G),S.set("isFirefox",C.$E),S.set("isChrome",C.$D),S.set("isSafari",C.$F);function $(X,U){if(S.get(X)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(X,U)}e.$Ei=$;const P=Object.prototype.hasOwnProperty;var I;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},k=(0,A.localize)(0,null),D=(0,A.localize)(1,null),y=(0,A.localize)(2,null),r=(0,A.localize)(3,null),i=(0,A.localize)(4,null),s=(0,A.localize)(5,null),d=(0,A.localize)(6,null),b=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new f.$Di,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const G=this.D(),ce=G.type===17?s:void 0;throw this.h.push({message:i,offset:G.offset,lexeme:f.$Di.getLexeme(G),additionalInfo:ce}),g.c}return q}catch(q){if(q!==g.c)throw q;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const q=this.o();U.push(q)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const q=this.s();U.push(q)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,r),q?.negate()}case 17:return this.z(),L.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const q=this.l();return this.A(1,r),q}case 17:{const q=U.lexeme;if(this.z(),this.y(9)){const ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ce.type!==10)throw this.B("REGEX",ce);const re=ce.lexeme,de=re.lastIndexOf("/"),Ee=de===re.length-1?void 0:this.w(re.substring(de+1));let he;try{he=new RegExp(re.substring(1,de),Ee)}catch{throw this.B("REGEX",ce)}return F.create(q,he)}switch(ce.type){case 10:case 19:{const re=[ce.lexeme];this.z();let de=this.D(),Ee=0;for(let we=0;we<ce.lexeme.length;we++)ce.lexeme.charCodeAt(we)===40?Ee++:ce.lexeme.charCodeAt(we)===41&&Ee--;for(;!this.E()&&de.type!==15&&de.type!==16;){switch(de.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let we=0;we<de.lexeme.length;we++)de.lexeme.charCodeAt(we)===40?Ee++:ce.lexeme.charCodeAt(we)===41&&Ee--}if(Ee<0)break;re.push(f.$Di.getLexeme(de)),this.z(),de=this.D()}const he=re.join(""),ge=he.lastIndexOf("/"),ne=ge===he.length-1?void 0:this.w(he.substring(ge+1));let ue;try{ue=new RegExp(he.substring(1,ge),ne)}catch{throw this.B("REGEX",ce)}return t.regex(q,ue)}case 18:{const re=ce.lexeme;this.z();let de=null;if(!(0,T.$od)(re)){const Ee=re.indexOf("/"),he=re.lastIndexOf("/");if(Ee!==he&&Ee>=0){const ge=re.slice(Ee+1,he),ne=re[he+1]==="i"?"i":"";try{de=new RegExp(ge,ne)}catch{throw this.B("REGEX",ce)}}}if(de===null)throw this.B("REGEX",ce);return F.create(q,de)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const ce=this.u();return t.notIn(q,ce)}switch(this.D().type){case 3:{this.z();const ce=this.u();if(this.x().type===18)return t.equals(q,ce);switch(ce){case"true":return t.has(q);case"false":return t.not(q);default:return t.equals(q,ce)}}case 4:{this.z();const ce=this.u();if(this.x().type===18)return t.notEquals(q,ce);switch(ce){case"true":return t.not(q);case"false":return t.has(q);default:return t.notEquals(q,ce)}}case 5:return this.z(),z.create(q,this.u());case 6:return this.z(),j.create(q,this.u());case 7:return this.z(),N.create(q,this.u());case 8:return this.z(),M.create(q,this.u());case 13:return this.z(),t.in(q,this.u());default:return t.has(q)}}case 20:throw this.h.push({message:d,offset:U.offset,lexeme:"",additionalInfo:b}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,q){if(this.C(U))return this.z();throw this.B(q,this.D())}B(U,q,G){const ce=(0,A.localize)(8,null,U,f.$Di.getLexeme(q)),re=q.offset,de=f.$Di.getLexeme(q);return this.h.push({message:ce,offset:re,lexeme:de,additionalInfo:G}),g.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Fi=g;class t{static false(){return a.INSTANCE}static true(){return l.INSTANCE}static has(U){return v.create(U)}static equals(U,q){return E.create(U,q)}static notEquals(U,q){return w.create(U,q)}static regex(U,q){return F.create(U,q)}static in(U,q){return u.create(U,q)}static notIn(U,q){return h.create(U,q)}static not(U){return L.create(U)}static and(...U){return $e.create(U,null,!0)}static or(...U){return _.create(U,null,!0)}static greater(U,q){return N.create(U,q)}static greaterEquals(U,q){return M.create(U,q)}static smaller(U,q){return z.create(U,q)}static smallerEquals(U,q){return j.create(U,q)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Gi=t;function o(X){const U=new g({regexParsingWithErrorRecovery:!1});return X.map(q=>(U.parse(q),U.lexingErrors.length>0?U.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,A.localize)(9,null,G.additionalInfo):(0,A.localize)(10,null),offset:G.offset,length:G.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Hi=o;function c(X,U){const q=X?X.substituteConstants():void 0,G=U?U.substituteConstants():void 0;return!q&&!G?!0:!q||!G?!1:q.equals(G)}e.$Ii=c;function n(X,U){return X.cmp(U)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Ji=a;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return a.INSTANCE}}e.$Ki=l;class v{static create(U,q=null){const G=S.get(U);return typeof G=="boolean"?G?l.INSTANCE:a.INSTANCE:new v(U,q)}constructor(U,q){this.key=U,this.c=q,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:V(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=S.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:a.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Li=v;class E{static create(U,q,G=null){if(typeof q=="boolean")return q?v.create(U,G):L.create(U,G);const ce=S.get(U);return typeof ce=="boolean"?q===(ce?"true":"false")?l.INSTANCE:a.INSTANCE:new E(U,q,G)}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?l.INSTANCE:a.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Mi=E;class u{static create(U,q){return new u(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.f),G=U.getValue(this.d);return Array.isArray(q)?q.includes(G):typeof G=="string"&&typeof q=="object"&&q!==null?P.call(q,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Ni=u;class h{static create(U,q){return new h(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=11,this.c=u.create(U,q)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Oi=h;class w{static create(U,q,G=null){if(typeof q=="boolean")return q?L.create(U,G):v.create(U,G);const ce=S.get(U);return typeof ce=="boolean"?q===(ce?"true":"false")?a.INSTANCE:l.INSTANCE:new w(U,q,G)}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?a.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Pi=w;class L{static create(U,q=null){const G=S.get(U);return typeof G=="boolean"?G?a.INSTANCE:l.INSTANCE:new L(U,q)}constructor(U,q){this.c=U,this.d=q,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:V(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=S.get(this.c);return typeof U=="boolean"?U?a.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Qi=L;function O(X,U){if(typeof X=="string"){const q=parseFloat(X);isNaN(q)||(X=q)}return typeof X=="string"||typeof X=="number"?U(X):a.INSTANCE}class N{static create(U,q,G=null){return O(q,ce=>new N(U,ce,G))}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ri=N;class M{static create(U,q,G=null){return O(q,ce=>new M(U,ce,G))}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Si=M;class z{static create(U,q,G=null){return O(q,ce=>new z(U,ce,G))}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Ti=z;class j{static create(U,q,G=null){return O(q,ce=>new j(U,ce,G))}constructor(U,q,G){this.c=U,this.d=q,this.f=G,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ee(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Ui=j;class F{static create(U,q){return new F(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const q=this.f?this.f.source:"",G=U.f?U.f.source:"";return q<G?-1:q>G?1:0}equals(U){if(U.type===this.type){const q=this.f?this.f.source:"",G=U.f?U.f.source:"";return this.d===U.d&&q===G}return!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Vi=F;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Wi=K;function H(X){let U=null;for(let q=0,G=X.length;q<G;q++){const ce=X[q].substituteConstants();if(X[q]!==ce&&U===null){U=[];for(let re=0;re<q;re++)U[re]=X[re]}U!==null&&(U[q]=ce)}return U===null?X:U}class $e{static create(U,q,G){return $e.d(U,q,G)}constructor(U,q){this.expr=U,this.c=q,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,G=this.expr.length;q<G;q++){const ce=n(this.expr[q],U.expr[q]);if(ce!==0)return ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,G=this.expr.length;q<G;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:$e.create(U,this.c,!1)}evaluate(U){for(let q=0,G=this.expr.length;q<G;q++)if(!this.expr[q].evaluate(U))return!1;return!0}static d(U,q,G){const ce=[];let re=!1;for(const de of U)if(de){if(de.type===1){re=!0;continue}if(de.type===0)return a.INSTANCE;if(de.type===6){ce.push(...de.expr);continue}ce.push(de)}if(ce.length===0&&re)return l.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(n);for(let de=1;de<ce.length;de++)ce[de-1].equals(ce[de])&&(ce.splice(de,1),de--);if(ce.length===1)return ce[0];for(;ce.length>1;){const de=ce[ce.length-1];if(de.type!==9)break;ce.pop();const Ee=ce.pop(),he=ce.length===0,ge=_.create(de.expr.map(ne=>$e.create([ne,Ee],null,G)),null,he);ge&&(ce.push(ge),ce.sort(n))}if(ce.length===1)return ce[0];if(G){for(let de=0;de<ce.length;de++)for(let Ee=de+1;Ee<ce.length;Ee++)if(ce[de].negate().equals(ce[Ee]))return a.INSTANCE;if(ce.length===1)return ce[0]}return new $e(ce,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new $e(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());this.c=_.create(U,this,!0)}return this.c}}e.$Xi=$e;class _{static create(U,q,G){return _.d(U,q,G)}constructor(U,q){this.expr=U,this.c=q,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,G=this.expr.length;q<G;q++){const ce=n(this.expr[q],U.expr[q]);if(ce!==0)return ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,G=this.expr.length;q<G;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=H(this.expr);return U===this.expr?this:_.create(U,this.c,!1)}evaluate(U){for(let q=0,G=this.expr.length;q<G;q++)if(this.expr[q].evaluate(U))return!0;return!1}static d(U,q,G){let ce=[],re=!1;if(U){for(let de=0,Ee=U.length;de<Ee;de++){const he=U[de];if(he){if(he.type===0){re=!0;continue}if(he.type===1)return l.INSTANCE;if(he.type===9){ce=ce.concat(he.expr);continue}ce.push(he)}}if(ce.length===0&&re)return a.INSTANCE;ce.sort(n)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let de=1;de<ce.length;de++)ce[de-1].equals(ce[de])&&(ce.splice(de,1),de--);if(ce.length===1)return ce[0];if(G){for(let de=0;de<ce.length;de++)for(let Ee=de+1;Ee<ce.length;Ee++)if(ce[de].negate().equals(ce[Ee]))return l.INSTANCE;if(ce.length===1)return ce[0]}return new _(ce,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new _(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());for(;U.length>1;){const q=U.shift(),G=U.shift(),ce=[];for(const re of te(q))for(const de of te(G))ce.push($e.create([re,de],null,!1));U.unshift(_.create(ce,null,!1))}this.c=_.create(U,this,!0)}return this.c}}e.$Yi=_;class Q extends v{static{this.d=[]}static all(){return Q.d.values()}constructor(U,q,G){super(U,null),this.f=q,typeof G=="object"?Q.d.push({...G,key:U}):G!==!0&&Q.d.push({key:U,description:G,type:q!=null?typeof q:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return E.create(this.key,U)}notEqualsTo(U){return w.create(this.key,U)}}e.$Zi=Q,e.$1i=(0,R.$zh)("contextKeyService");function V(X,U){return X<U?-1:X>U?1:0}function ee(X,U,q,G){return X<q?-1:X>q?1:U<G?-1:U>G?1:0}function me(X,U){if(X.type===0||U.type===1)return!0;if(X.type===9)return U.type===9?ae(X.expr,U.expr):!1;if(U.type===9){for(const q of U.expr)if(me(X,q))return!0;return!1}if(X.type===6){if(U.type===6)return ae(U.expr,X.expr);for(const q of X.expr)if(me(q,U))return!0;return!1}return X.equals(U)}e.$2i=me;function ae(X,U){let q=0,G=0;for(;q<X.length&&G<U.length;){const ce=X[q].cmp(U[G]);if(ce<0)return!1;ce===0&&q++,G++}return q===X.length}function te(X){return X.type===9?X.expr:[X]}}),define(De[230],Ce([1,0,24,38,191,5,100,12,23]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oA=e.$nA=e.ConfirmResult=e.$mA=e.$lA=e.$kA=void 0,e.$kA=(0,R.$zh)("dialogService");var $;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})($||($={}));class P{a(r){return this.d(r,$.Confirmation)}b(r){return this.d(r,$.Prompt)}c(r){return this.d(r,$.Input)}d(r,i){const s=[];switch(i){case $.Confirmation:{const d=r;d.primaryButton?s.push(d.primaryButton):s.push((0,f.localize)(0,null)),d.cancelButton?s.push(d.cancelButton):s.push((0,f.localize)(1,null));break}case $.Prompt:{const d=r;Array.isArray(d.buttons)&&d.buttons.length>0&&s.push(...d.buttons.map(b=>b.label)),d.cancelButton&&(d.cancelButton===!0?s.push((0,f.localize)(2,null)):typeof d.cancelButton=="string"?s.push(d.cancelButton):d.cancelButton.label?s.push(d.cancelButton.label):s.push((0,f.localize)(3,null))),s.length===0&&s.push((0,f.localize)(4,null));break}case $.Input:{const d=r;d.primaryButton?s.push(d.primaryButton):s.push((0,f.localize)(5,null)),d.cancelButton?s.push(d.cancelButton):s.push((0,f.localize)(6,null));break}}return s}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===T.default.Info?"info":r===T.default.Error?"error":r===T.default.Warning?"warning":"none"}async f(r,i,s){const d=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&d.push(r.cancelButton),{result:await d[i]?.run({checkboxChecked:s}),checkboxChecked:s}}}e.$lA=P,e.$mA=(0,R.$zh)("fileDialogService");var I;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function k(y){const r=[];return r.push(...y.slice(0,p).map(i=>typeof i=="string"?i:(0,C.$dg)(i))),y.length>p&&(y.length-p===1?r.push((0,f.localize)(7,null)):r.push((0,f.localize)(8,null,y.length-p))),r.push(""),r.join(`
`)}e.$nA=k;function D(y,r){const i=(0,S.$Tm)(y);let s=(i.buttons??[]).map(t=>(0,A.$hA)(t)),d=(y.buttons||[]).map((t,o)=>o),b=0,g=i.cancelId??s.length-1;if(s.length>1){const t=typeof g=="number"?s[g]:void 0;if(m.$k||m.$j){if(typeof t=="string"&&s.length>1&&g!==1){s.splice(g,1),s.splice(1,0,t);const o=d[g];d.splice(g,1),d.splice(1,0,o),g=1}m.$k&&s.length>1&&(s=s.reverse(),d=d.reverse(),b=s.length-1,typeof t=="string"&&(g=b-1))}else if(m.$i&&typeof t=="string"&&s.length>1&&g!==s.length-1){s.splice(g,1),s.push(t);const o=d[g];d.splice(g,1),d.push(o),g=s.length-1}}return i.buttons=s,i.defaultId=b,i.cancelId=g,i.noLink=!0,i.title=i.title||r.nameLong,{options:i,buttonIndeces:d}}e.$oA=D}),define(De[131],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=void 0,e.$Gh=(0,C.$zh)("environmentService"),e.$Hh=(0,C.$Ah)(e.$Gh)}),define(De[132],Ce([1,0,192,5]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Xn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=void 0,e.$Kn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Ln=new RegExp(e.$Kn),e.$Mn="__web_extension",e.$Nn="skipWalkthrough",e.$On="extensionsSync",e.$Pn="dependecyOrPackExtensionInstall";function f(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Qn=f;function R(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Rn=R;function A(s,d){switch(s){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Sn=A;function m(s,d){return d==="web"&&!s.includes("web")}e.$Tn=m;function S(s,d,b){return m(d,b)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===b?!0:$(b).includes(s)}e.$Un=S;function $(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Vn=$;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$Wn=P;var I;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var p;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var k;(function(s){s.Install="install",s.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var D;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$Xn=(0,T.$zh)("extensionGalleryService");var y;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var r;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class i extends Error{constructor(d,b){super(d),this.code=b,this.name=b}}e.$Yn=i,e.$Zn=(0,T.$zh)("extensionManagementService"),e.$1n="extensionsIdentifiers/disabled",e.$2n="extensionsIdentifiers/enabled",e.$3n=(0,T.$zh)("IGlobalExtensionEnablementService"),e.$4n=(0,T.$zh)("IExtensionTipsService"),e.$5n=(0,C.localize)(0,null),e.$6n={value:e.$5n,original:"Extensions"},e.$7n={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SWb=e.$RWb=e.$QWb=void 0,e.$QWb=(0,C.$zh)("externalTerminal"),e.$RWb="Terminal.app",e.$SWb=(0,C.$zh)("externalTerminal")}),define(De[232],Ce([1,0,48,17,16,12,99,29,102,194,231]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=e.$H5b=e.$G5b=void 0;const I=$.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends p{static{this.b="cmd.exe"}openTerminal(b,g){return this.spawnTerminal(C,b,S.$sl(),g)}spawnTerminal(b,g,t,o){const c=g.windowsExec||k.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const n=f.$cd(c,".exe").toLowerCase();if(n==="cmder")return b.spawn(c,o?[o]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return c.indexOf(" ")>=0&&a.push('""'),a.push(c),n==="wt"&&a.push("-d ."),new Promise((l,v)=>{const E=r(process),u=b.spawn(t,a,{cwd:o,env:E});u.on("error",v),u.on("exit",()=>l())})}runInTerminal(b,g,t,o,c){const n="windowsExec"in c&&c.windowsExec?c.windowsExec:k.getDefaultTerminalWindows();return new Promise((a,l)=>{const v=`"${g} - ${I}"`,E=`""${t.join('" "')}" & pause"`,u=Object.assign({},r(process),o);Object.keys(u).filter(N=>u[N]===null).forEach(N=>delete u[N]);const h={cwd:g,env:u,windowsVerbatimArguments:!0};let w,L;f.$cd(n,".exe")==="wt"?(w=n,L=["-d",".",k.b,"/c",E]):(w=k.b,L=["/c","start",v,"/wait",n,"/c",E]),C.spawn(w,L,h).on("error",N=>{l(i(N))}),a(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const b=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${b?"Sysnative":"System32"}\\cmd.exe`}return k.d}}e.$G5b=k;class D extends p{static{this.b="/usr/bin/osascript"}openTerminal(b,g){return this.spawnTerminal(C,b,g)}runInTerminal(b,g,t,o,c){const n=c.osxExec||P.$RWb;return new Promise((a,l)=>{if(n===P.$RWb||n==="iTerm.app"){const v=n===P.$RWb?"TerminalHelper":"iTermHelper",u=[T.$4e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",b||I,"-w",g];for(const L of t)u.push("-a"),u.push(L);if(o){const L=Object.assign({},r(process),o);for(const O in L){const N=L[O];N===null?(u.push("-u"),u.push(O)):(u.push("-e"),u.push(`${O}=${N}`))}}let h="";const w=C.spawn(D.b,u);w.on("error",L=>{l(i(L))}),w.stderr.on("data",L=>{h+=L.toString()}),w.on("exit",L=>{if(L===0)a(void 0);else if(h){const O=h.split(`
`,1);l(new Error(O[0]))}else l(new Error($.localize(1,null,v,L)))})}else l(new Error($.localize(2,null,n)))})}spawnTerminal(b,g,t){const o=g.osxExec||P.$RWb;return new Promise((c,n)=>{const a=["-a",o];t&&a.push(t);const l=r(process),v=b.spawn("/usr/bin/open",a,{cwd:t,env:l});v.on("error",n),v.on("exit",()=>c())})}}e.$H5b=D;class y extends p{static{this.b=$.localize(3,null)}openTerminal(b,g){return this.spawnTerminal(C,b,g)}runInTerminal(b,g,t,o,c){const n=c.linuxExec?Promise.resolve(c.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((a,l)=>{const v=[];n.then(E=>{E.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const u=`${s(t)}; echo; read -p "${y.b}" -n1;`;v.push(`''${u}''`);const h=Object.assign({},r(process),o);Object.keys(h).filter(N=>h[N]===null).forEach(N=>delete h[N]);const w={cwd:g,env:h};let L="";const O=C.spawn(E,v,w);O.on("error",N=>{l(i(N))}),O.stderr.on("data",N=>{L+=N.toString()}),O.on("exit",N=>{if(N===0)a(void 0);else if(L){const M=L.split(`
`,1);l(new Error(M[0]))}else l(new Error($.localize(4,null,E,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!R.$k)y.d=Promise.resolve("xterm");else{const b=await m.Promises.exists("/etc/debian_version");y.d=new Promise(g=>{b?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return y.d}spawnTerminal(b,g,t){const o=g.linuxExec?Promise.resolve(g.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((c,n)=>{o.then(a=>{const l=r(process),v=b.spawn(a,[],{cwd:t,env:l});v.on("error",n),v.on("exit",()=>c())})})}}e.$I5b=y;function r(d){const b={...d.env};return(0,A.$ql)(b),b}function i(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error($.localize(5,null,d.path)):d}function s(d){let b="";for(const g of d)g.indexOf(" ")>=0?b+='"'+g+'"':b+=g,b+=" ";return b}}),define(De[30],Ce([1,0,77,16,15,18,2,195,5,12,17]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileKind=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileOperationResult=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileChangeType=e.$ik=e.FileOperation=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderErrorCode=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$5j=e.$4j=void 0,e.$4j=(0,S.$zh)("fileService");function I(V){return V.create===!0}e.$5j=I;var p;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var k;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(k||(e.FilePermission=k={}));var D;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function y(V){return!!(V.capabilities&2)}e.$6j=y;function r(V){return!!(V.capabilities&8)}e.$7j=r;function i(V){return!!(V.capabilities&131072)}e.$8j=i;function s(V){return!!(V.capabilities&4)}e.$9j=s;function d(V){return!!(V.capabilities&16)}e.$0j=d;function b(V){return y(V)?!!(V.capabilities&16384):!1}e.$$j=b;function g(V){return y(V)?!!(V.capabilities&32768):!1}e.$_j=g;function t(V){return!!(V.capabilities&65536)}e.$ak=t;function o(V){return!!(V.capabilities&2048)}e.$bk=o;var c;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class n extends Error{static create(ee,me){const ae=new n(ee.toString(),me);return v(ae,me),ae}constructor(ee,me){super(ee),this.code=me}}e.$ck=n;function a(V,ee){return n.create(V,ee)}e.$dk=a;function l(V){return V||a((0,m.localize)(0,null),c.Unknown)}e.$ek=l;function v(V,ee){return V.name=ee?`${ee} (FileSystemError)`:"FileSystemError",V}e.$fk=v;function E(V){if(!V)return c.Unknown;if(V instanceof n)return V.code;const ee=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ee)return c.Unknown;switch(ee[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$gk=E;function u(V){if(V instanceof M)return V.fileOperationResult;switch(E(V)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$hk=u;var h;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class w{constructor(ee,me,ae){this.resource=ee,this.operation=me,this.target=ae}isOperation(ee){return this.operation===ee}}e.$ik=w;var L;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class O{constructor(ee,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const te of ee){const X=ae.get(te.type);switch(X?X.push([te.resource,te]):ae.set(te.type,[[te.resource,te]]),te.type){case 1:this.rawAdded.push(te.resource);break;case 0:this.rawUpdated.push(te.resource);break;case 2:this.rawDeleted.push(te.resource);break}}for(const[te,X]of ae)switch(te){case 1:this.a=C.$Fh.forUris(()=>me),this.a.fill(X);break;case 0:this.b=C.$Fh.forUris(()=>me),this.b.fill(X);break;case 2:this.c=C.$Fh.forUris(()=>me),this.c.fill(X);break}}contains(ee,...me){return this.d(ee,{includeChildren:!1},...me)}affects(ee,...me){return this.d(ee,{includeChildren:!0},...me)}d(ee,me,...ae){if(!ee)return!1;const te=ae.length>0;return!!((!te||ae.includes(1))&&(this.a?.get(ee)||me.includeChildren&&this.a?.findSuperstr(ee))||(!te||ae.includes(0))&&(this.b?.get(ee)||me.includeChildren&&this.b?.findSuperstr(ee))||(!te||ae.includes(2))&&(this.c?.findSubstr(ee)||me.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$jk=O;function N(V,ee,me){return!V||!ee||V===ee||ee.length>V.length?!1:(ee.charAt(ee.length-1)!==T.sep&&(ee+=T.sep),me?(0,f.$Pd)(V,ee):V.indexOf(ee)===0)}e.$kk=N;class M extends Error{constructor(ee,me,ae){super(ee),this.fileOperationResult=me,this.options=ae}}e.$lk=M;class z extends M{constructor(ee,me,ae,te){super(ee,me,te),this.fileOperationResult=me,this.size=ae}}e.$mk=z;class j extends M{constructor(ee,me,ae){super(ee,2,ae),this.stat=me}}e.$nk=j;var F;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(F||(e.FileOperationResult=F={})),e.$ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$qk="files.associations",e.$rk="files.exclude",e.$sk="files.readonlyInclude",e.$tk="files.readonlyExclude",e.$uk="files.readonlyFromPermissions";var K;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$vk="";function H(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$wk=H;async function $e(V,ee){if(!ee.hasProvider(A.URI.from({scheme:V.scheme})))return new Promise(me=>{const ae=ee.onDidChangeFileSystemProviderRegistrations(te=>{te.scheme===V.scheme&&te.added&&(ae.dispose(),me())})})}e.$xk=$e;class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(ee){return(0,R.$pe)(ee)||(ee=0),ee<_.KB?(0,m.localize)(1,null,ee.toFixed(0)):ee<_.MB?(0,m.localize)(2,null,(ee/_.KB).toFixed(2)):ee<_.GB?(0,m.localize)(3,null,(ee/_.MB).toFixed(2)):ee<_.TB?(0,m.localize)(4,null,(ee/_.GB).toFixed(2)):(0,m.localize)(5,null,(ee/_.TB).toFixed(2))}}e.$yk=_;function Q(V){const ee=typeof V=="string"||V?.scheme===P.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===P.Schemas.file?1024*_.MB:ee?10*_.MB:$.$o?50*_.MB:1024*_.MB}e.$zk=Q}),define(De[233],Ce([1,0,22,8,196,30]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;async function A(P,I,p,k,D,y){let r;try{await m(P,I,p,k,D,y)}catch(i){r=i}finally{r&&D.errorTransformer&&(r=D.errorTransformer(r)),typeof r<"u"&&p.error(r),p.end()}}e.$zp=A;async function m(P,I,p,k,D,y){S(y);const r=await P.open(I,{create:!1});try{S(y);let i=0,s=0,d=D&&typeof D.length=="number"?D.length:void 0,b=C.$Hc.alloc(Math.min(D.bufferSize,typeof d=="number"?d:D.bufferSize)),g=D&&typeof D.position=="number"?D.position:0,t=0;do s=await P.read(r,g,b.buffer,t,b.byteLength-t),g+=s,t+=s,i+=s,typeof d=="number"&&(d-=s),t===b.byteLength&&(await p.write(k(b)),b=C.$Hc.alloc(Math.min(D.bufferSize,typeof d=="number"?d:D.bufferSize)),t=0);while(s>0&&(typeof d!="number"||d>0)&&S(y)&&$(i,D));if(t>0){let o=t;typeof d=="number"&&(o=Math.min(t,d)),p.write(k(b.slice(0,o)))}}catch(i){throw(0,R.$ek)(i)}finally{await P.close(r)}}function S(P){if(P.isCancellationRequested)throw(0,T.$4)();return!0}function $(P,I){if(typeof I?.limits?.size=="number"&&P>I.limits.size)throw(0,R.$dk)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[83],Ce([1,0,35,3,16,12,2,30]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.$Cp=e.$Bp=void 0;function S(i){return i.recursive===!0}e.$Bp=S;class $ extends T.$mb{static{this.a=5}constructor(s,d,b,g){super(),this.h=s,this.i=d,this.j=b,this.k=g,this.c=this.B(new T.$nb),this.f=void 0,this.g=0}m(){const s=new T.$lb;this.c.value=s,this.b=this.l(s),this.b.setVerboseLogging(this.j),s.add(this.b.onDidChangeFile(d=>this.h(d))),s.add(this.b.onDidLogMessage(d=>this.i(d))),s.add(this.b.onDidError(d=>this.n(d)))}n(s){this.k.restartOnError?this.g<$.a&&this.f?(this.r(`restarting watcher after error: ${s}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${s}`):this.r(s)}p(s){this.g++,this.m(),this.watch(s)}async watch(s){this.f=s,await this.b?.watch(s)}async setVerboseLogging(s){this.j=s,await this.b?.setVerboseLogging(s)}r(s){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${s}`})}s(s){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${s}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Cp=$;class P extends ${constructor(s,d,b){super(s,d,b,{type:"node.js",restartOnError:!1})}}e.$Dp=P;class I extends ${constructor(s,d,b){super(s,d,b,{type:"universal",restartOnError:!0})}}e.$Ep=I;function p(i){return i.map(s=>({type:s.type,resource:A.URI.file(s.path)}))}e.$Fp=p;function k(i){const s=new r;for(const d of i)s.processEvent(d);return s.coalesce()}e.$Gp=k;function D(i,s){return typeof s=="string"&&!s.startsWith(C.$lj)&&!(0,f.$0c)(s)?{base:i,pattern:s}:s}e.$Hp=D;function y(i,s){const d=[];for(const b of s)d.push((0,C.$pj)(D(i,b)));return d}e.$Ip=y;class r{constructor(){this.a=new Set,this.b=new Map}c(s){return R.$k?s.path:s.path.toLowerCase()}processEvent(s){const d=this.b.get(this.c(s));let b=!1;if(d){const g=d.type,t=s.type;d.path!==s.path&&(s.type===2||s.type===1)?b=!0:g===1&&t===2?(this.b.delete(this.c(s)),this.a.delete(d)):g===2&&t===1?d.type=0:g===1&&t===0||(d.type=t)}else b=!0;b&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],d=[];return Array.from(this.a).filter(b=>b.type!==2?(s.push(b),!1):!0).sort((b,g)=>b.path.length-g.path.length).filter(b=>d.some(g=>(0,m.$kk)(b.path,g,!R.$k))?!1:(d.push(b.path),!0)).concat(s)}}}),define(De[234],Ce([1,0,52,11,21,32,3,76,16,12,101,29,83]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class k extends A.$mb{static{this.a=100}static{this.b=75}constructor(r,i,s,d){super(),this.j=r,this.k=i,this.l=s,this.m=d,this.c=this.B(new T.$Tg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},b=>this.k(b))),this.f=this.B(new T.$Sg(b=>this.u(b),k.b)),this.g=(0,p.$Ip)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$Ip)(this.j.path,this.j.includes):void 0,this.i=new f.$rc,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const i=await I.Promises.stat(r);this.B(await this.s(r,i.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let i=r.path;try{i=await I.Promises.realpath(r.path),r.path===i&&(i=await(0,P.$Sp)(r.path)??r.path),r.path!==i&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${i})`)}catch{}return i}async s(r,i){if($.$j&&(0,R.$Ke)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$mb.None;const s=new f.$rc(this.i.token),d=new A.$lb;try{const b=(0,S.$cd)(r),g=(0,C.watch)(r);d.add((0,A.$kb)(()=>{g.removeAllListeners(),g.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(i)try{for(const c of await I.Promises.readdir(r))t.add(c)}catch(c){this.w(c)}const o=new Map;d.add((0,A.$kb)(()=>{for(const[,c]of o)c.dispose();o.clear()})),g.on("error",(c,n)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${c}, ${n})`),this.dispose()}),g.on("change",(c,n)=>{if(s.token.isCancellationRequested)return;this.z(`[raw] ["${c}"] ${n}`);let a="";if(n&&(a=n.toString(),$.$j&&(a=(0,m.$fl)(a))),!(!a||c!=="change"&&c!=="rename"))if(i)if(c==="rename"){o.get(a)?.dispose();const l=setTimeout(async()=>{if(o.delete(a),a===b&&!await I.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.v((0,S.$$c)(r,a));if(s.token.isCancellationRequested)return;let E;v?t.has(a)?E=0:(E=1,t.add(a)):(t.delete(a),E=2),this.t({path:(0,S.$$c)(this.j.path,a),type:E})},k.a);o.set(a,(0,A.$kb)(()=>clearTimeout(l)))}else{let l;t.has(a)?l=0:(l=1,t.add(a)),this.t({path:(0,S.$$c)(this.j.path,a),type:l})}else if(c==="rename"||a!==b){const l=setTimeout(async()=>{const v=await I.Promises.exists(r);s.token.isCancellationRequested||(v?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},k.a);d.clear(),d.add((0,A.$kb)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(b){await I.Promises.exists(r)&&!s.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${b.toString()})`)}return(0,A.$kb)(()=>{s.dispose(!0),d.dispose()})}t(r,i=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!i&&this.g.some(s=>s(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!i&&this.h&&this.h.length>0&&!this.h.some(s=>s(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const i=(0,p.$Gp)(r);if(i.length>0){if(this.m)for(const d of i)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(i)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if($.$k)return I.Promises.exists(r);try{const i=(0,S.$cd)(r);return(await I.Promises.readdir((0,S.$bd)(r))).some(d=>d===i)}catch(i){return this.z(i),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Vp=k;async function D(y,r,i,s,d=512){const b=await I.Promises.open(y,"r"),g=Buffer.allocUnsafe(d),t=new f.$rc(s);let o,c=!1;const n={path:y,excludes:[],recursive:!1},a=new k(n,l=>{(async()=>{for(const{type:v}of l)if(v===0){if(c)return;c=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:E}=await I.Promises.read(b,g,0,d,null);if(!E||t.token.isCancellationRequested)break;r(g.slice(0,E))}}catch(E){o=new Error(E),t.dispose(!0)}finally{c=!1}}})()});return await a.ready,i(),new Promise((l,v)=>{t.token.onCancellationRequested(async()=>{a.dispose();try{await I.Promises.close(b)}catch(E){o=new Error(E)}o?v(o):l()})})}e.$Wp=D}),define(De[235],Ce([1,0,4,35,3,12,234]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class m extends f.$mb{constructor(){super(...arguments),this.a=this.B(new C.$hc),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$hc),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch($){const P=this.i($),I=P.filter(k=>{const D=this.c.get(k.path);return D?!(0,T.$tj)(D.request.excludes,k.excludes)||!(0,T.$tj)(D.request.includes,k.includes):!0}),p=Array.from(this.c.values()).filter(({request:k})=>!P.find(D=>D.path===k.path&&(0,T.$tj)(D.excludes,k.excludes)&&(0,T.$tj)(D.includes,k.includes))).map(({request:k})=>k.path);I.length&&this.j(`Request to start watching: ${I.map(k=>`${k.path} (excludes: ${k.excludes.length>0?k.excludes:"<none>"}, includes: ${k.includes&&k.includes.length>0?JSON.stringify(k.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const k of p)this.h(k);for(const k of I)this.g(k)}g($){const P=new A.$Vp($,p=>this.a.fire(p),p=>this.b.fire(p),this.f),I={request:$,instance:P};this.c.set($.path,I)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const P=this.c.get($);P&&(this.c.delete($),P.instance.dispose())}i($){const P=new Map;for(const I of $){const p=R.$k?I.path:I.path.toLowerCase();P.set(p,I)}return Array.from(P.values())}async setVerboseLogging($){this.f=$;for(const[,P]of this.c)P.instance.setVerboseLogging($)}j($){this.f&&this.b.fire({type:"trace",message:this.k($)})}k($,P){return P?`[File Watcher (node.js)] ${$} (path: ${P.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Xp=m}),define(De[236],Ce([1,0,83,235]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;class f extends C.$Dp{constructor(A,m,S){super(A,m,S),this.m()}l(A){return A.add(new T.$Xp)}}e.$Yp=f}),define(De[237],Ce([1,0,17,80,183,83]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;class A extends R.$Ep{constructor(S,$,P){super(S,$,P),this.m()}l(S){const $=S.add(new f.$Pp(C.$4e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add($.onDidProcessExit(({code:P,signal:I})=>this.n(`terminated by itself with code ${P}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$gh)($.getChannel("watcher")))}}e.$Qp=A}),define(De[105],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class C{constructor(...f){this.a=new Map;for(const[R,A]of f)this.set(R,A)}set(f,R){const A=this.a.get(f);return this.a.set(f,R),A}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$xh=C}),define(De[238],Ce([1,0,11,8,3,103,229,5,105,75]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;const P=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class p{constructor(r=new S.$xh,i=!1,s,d=P){this.f=r,this.g=i,this.h=s,this.i=d,this.o=new Set,this.f.set(m.$yh,this),this._globalGraph=d?s?._globalGraph??new A.$2p(b=>b):void 0}createChild(r){return new p(r,this.g,this,this.i)}invokeFunction(r,...i){const s=D.traceInvocation(this.i,r);let d=!1;try{return r({get:g=>{if(d)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(g,s);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...i)}finally{d=!0,s.stop()}}createInstance(r,...i){let s,d;return r instanceof R.$wh?(s=D.traceCreation(this.i,r.ctor),d=this.j(r.ctor,r.staticArguments.concat(i),s)):(s=D.traceCreation(this.i,r),d=this.j(r,i,s)),s.stop(),d}j(r,i=[],s){const d=m._util.getServiceDependencies(r).sort((t,o)=>t.index-o.index),b=[];for(const t of d){const o=this.m(t.id,s);o||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(o)}const g=d.length>0?d[0].index:i.length;if(i.length!==g){console.trace(`[createInstance] First service dependency of ${r.name} at position ${g+1} conflicts with ${i.length} static arguments`);const t=g-i.length;t>0?i=i.concat(new Array(t)):i=i.slice(0,g)}return Reflect.construct(r,i.concat(b))}k(r,i){if(this.f.get(r)instanceof R.$wh)this.f.set(r,i);else if(this.h)this.h.k(r,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const i=this.f.get(r);return!i&&this.h?this.h.l(r):i}m(r,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const s=this.l(r);return s instanceof R.$wh?this.q(r,s,i.branch(r,!0)):(i.branch(r,!1),s)}q(r,i,s){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,i,s)}finally{this.o.delete(r)}}r(r,i,s){const d=new A.$2p(t=>t.id.toString());let b=0;const g=[{id:r,desc:i,_trace:s}];for(;g.length;){const t=g.pop();if(d.lookupOrInsertNode(t),b++>1e3)throw new I(d);for(const o of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(o.id);if(c||this.u(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),c instanceof R.$wh){const n={id:o.id,desc:c,_trace:t._trace.branch(o.id,!0)};d.insertEdge(t,n),g.push(n)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new I(d);break}for(const{data:o}of t){if(this.l(o.id)instanceof R.$wh){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}d.removeNode(o)}}return this.l(r)}s(r,i,s=[],d,b){if(this.f.get(r)instanceof R.$wh)return this.t(r,i,s,d,b);if(this.h)return this.h.s(r,i,s,d,b);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(r,i,s=[],d,b){if(d){const g=new p(void 0,this.g,this,this.i);g.c=String(r);const t=new Map,o=new C.$Vg(()=>{const c=g.j(i,s,b);for(const[n,a]of t){const l=c[n];if(typeof l=="function")for(const v of a)l.apply(c,v)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let v=t.get(n);return v||(v=new $.$vb,t.set(n,v)),(u,h,w)=>{const L=v.push([u,h,w]);return(0,f.$kb)(L)}}if(n in c)return c[n];const a=o.value;let l=a[n];return typeof l!="function"||(l=l.bind(a),c[n]=l),l},set(c,n,a){return o.value[n]=a,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,s,b)}u(r,i){if(i&&console.warn(r),this.g)throw new Error(r)}}e.$3p=p;var k;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(k||(k={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,i){return r?new D(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(r,i){return r?new D(1,i.name):D.c}static{this.f=0}constructor(r,i){this.type=r,this.name=i,this.g=Date.now(),this.h=[]}branch(r,i){const s=new D(3,r.toString());return this.h.push([r,i,s]),s}stop(){const r=Date.now()-this.g;D.f+=r;let i=!1;function s(b,g){const t=[],o=new Array(b+1).join("	");for(const[c,n,a]of g.h)if(n&&a){i=!0,t.push(`${o}CREATES -> ${c}`);const l=s(b+1,a);l&&t.push(l)}else t.push(`${o}uses -> ${c}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${s(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(r>2||i)&&D.all.add(d.join(`
`))}}e.$4p=D}),define(De[14],Ce([1,0,46,4,51,3,28,12,24,18,2,41,5]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.log=e.$6i=e.LogLevel=e.$5i=e.$4i=e.$3i=void 0,e.$3i=(0,p.$zh)("logService"),e.$4i=(0,p.$zh)("loggerService");function k(){return new Date().toISOString()}function D(u){return(0,$.$pe)(u)}e.$5i=D;var y;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$6i=y.Info;function r(u,h,w){switch(h){case y.Trace:u.trace(w);break;case y.Debug:u.debug(w);break;case y.Info:u.info(w);break;case y.Warning:u.warn(w);break;case y.Error:u.error(w);break;case y.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=r;function i(u,h=!1){let w="";for(let L=0;L<u.length;L++){let O=u[L];if(O instanceof Error&&(O=(0,C.$ki)(O,h)),typeof O=="object")try{O=JSON.stringify(O)}catch{}w+=(L>0?" ":"")+O}return w}class s extends R.$mb{constructor(){super(...arguments),this.b=e.$6i,this.c=this.B(new T.$hc),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==y.Off&&this.b<=h}}e.$8i=s;class d extends s{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...w){this.f(y.Trace)&&this.g(y.Trace,i([h,...w],!0))}debug(h,...w){this.f(y.Debug)&&this.g(y.Debug,i([h,...w]))}info(h,...w){this.f(y.Info)&&this.g(y.Info,i([h,...w]))}warn(h,...w){this.f(y.Warning)&&this.g(y.Warning,i([h,...w]))}error(h,...w){if(this.f(y.Error))if(h instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=h.stack,this.g(y.Error,i(L))}else this.g(y.Error,i([h,...w]))}flush(){}}e.$9i=d;class b extends s{constructor(h=e.$6i){super(),this.setLevel(h),this.g=!m.$i}trace(h,...w){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,h,...w):console.log(`[main ${k()}]`,h,...w))}debug(h,...w){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,h,...w):console.log(`[main ${k()}]`,h,...w))}info(h,...w){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,h,...w):console.log(`[main ${k()}]`,h,...w))}warn(h,...w){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,h,...w):console.warn(`[main ${k()}]`,h,...w))}error(h,...w){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,h,...w):console.error(`[main ${k()}]`,h,...w))}dispose(){}flush(){}}e.$0i=b;class g extends s{constructor(h=e.$6i,w=!0){super(),this.g=w,this.setLevel(h)}trace(h,...w){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...w):console.log(h,...w))}debug(h,...w){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...w):console.log(h,...w))}info(h,...w){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...w):console.log(h,...w))}warn(h,...w){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...w):console.log(h,...w))}error(h,...w){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...w):console.error(h,...w))}dispose(){}flush(){}}e.$$i=g;class t extends s{constructor(h,w=e.$6i){super(),this.g=h,this.setLevel(w)}trace(h,...w){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(h),...w])}debug(h,...w){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(h),...w])}info(h,...w){this.f(y.Info)&&this.g.log(y.Info,[this.h(h),...w])}warn(h,...w){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(h),...w])}error(h,...w){this.f(y.Error)&&this.g.log(y.Error,[this.h(h),...w])}h(h){return typeof h=="string"?h:(0,C.$ki)(h,this.f(y.Trace))}dispose(){}flush(){}}e.$_i=t;class o extends s{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const w of this.g)w.setLevel(h);super.setLevel(h)}trace(h,...w){for(const L of this.g)L.trace(h,...w)}debug(h,...w){for(const L of this.g)L.debug(h,...w)}info(h,...w){for(const L of this.g)L.info(h,...w)}warn(h,...w){for(const L of this.g)L.warn(h,...w)}error(h,...w){for(const L of this.g)L.error(h,...w)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$aj=o;class c extends R.$mb{constructor(h,w,L){if(super(),this.h=h,this.j=w,this.b=new A.$xi,this.c=this.B(new T.$hc),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$hc),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$hc),this.onDidChangeVisibility=this.g.event,L)for(const O of L)this.b.set(O.resource,{logger:void 0,info:O})}k(h){return(0,$.$le)(h)?[...this.b.values()].find(w=>w.info.id===h):this.b.get(h)}getLogger(h){return this.k(h)?.logger}createLogger(h,w){const L=this.l(h),O=(0,$.$le)(h)?h:w?.id??(0,f.$ni)(L.toString()).toString(16);let N=this.b.get(L)?.logger;const M=w?.logLevel==="always"?y.Trace:w?.logLevel;N||(N=this.m(L,M??this.getLogLevel(L)??this.h,{...w,id:O}));const z={logger:N,info:{resource:L,id:O,logLevel:M,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(z.info),this.b.set(L,z),N}l(h){return(0,$.$le)(h)?(0,S.$gg)(this.j,`${h}.log`):h}setLogLevel(h,w){if(P.URI.isUri(h)){const L=h,O=w,N=this.b.get(L);N&&O!==N.info.logLevel&&(N.info.logLevel=O===this.h?void 0:O,N.logger?.setLevel(O),this.b.set(N.info.resource,N),this.f.fire([L,O]))}else{this.h=h;for(const[L,O]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,w){const L=this.k(h);L&&w!==!L.info.hidden&&(L.info.hidden=!w,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,w]))}getLogLevel(h){let w;return h&&(w=this.b.get(h)?.info.logLevel),w??this.h}registerLogger(h){const w=this.b.get(h.resource);w?w.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const w=this.b.get(h);w&&(w.logger&&w.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bj=c;class n{constructor(){this.onDidChangeLogLevel=new T.$hc().event}setLevel(h){}getLevel(){return y.Info}trace(h,...w){}debug(h,...w){}info(h,...w){}warn(h,...w){}error(h,...w){}critical(h,...w){}dispose(){}flush(){}}e.$cj=n;class a extends n{}e.$dj=a;function l(u){if(u.verbose)return y.Trace;if(typeof u.logLevel=="string"){const h=E(u.logLevel.toLowerCase());if(h!==void 0)return h}return e.$6i}e.$ej=l;function v(u){switch(u){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$fj=v;function E(u){switch(u){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$gj=E,e.$hj=new I.$Zi("logLevel",v(y.Info))}),define(De[239],Ce([1,0,19,11,8,4,3,16,83,14]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;class P extends A.$mb{constructor(p,k){super(),this.a=p,this.b=k,this.c=this.B(new R.$hc),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$hc),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new T.$Cg(0)),this.s=[],this.t=this.B(new T.$Cg(0))}watch(p,k){return k.recursive||this.b?.watcher?.forceUniversal?this.l(p,k):this.u(p,k)}l(p,k){const D={path:this.C(p),excludes:k.excludes,includes:k.includes,recursive:k.recursive},y=(0,C.$Nf)(this.j,D);return this.m(),(0,A.$kb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,f.$Y)(p))}n(){this.h||(this.h=this.B(this.p(k=>this.c.fire((0,S.$Fp)(k)),k=>this.z(k),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const k of this.j)(0,S.$Bp)(k)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const k of this.j)(0,S.$Bp)(k)&&p.includes(k.path)&&(k.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,k){const D={path:this.C(p),excludes:k.excludes,includes:k.includes,recursive:!1},y=(0,C.$Nf)(this.s,D);return this.v(),(0,A.$kb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,f.$Y)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,S.$Fp)(p)),p=>this.z(p),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,m.$9c)(p.fsPath)}}e.$Jp=P}),define(De[240],Ce([1,0,52,372,11,28,22,4,32,3,16,12,24,97,29,197,30,233,239,46,237,236]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0,(()=>{try{(0,T.gracefulify)(C)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$ki)(o)}`)}})();class t extends s.$Jp{static{this.D=!1}constructor(c,n){super(c,n),this.onDidChangeCapabilities=m.Event.None,this.I=new R.$xi(a=>p.$0f.getComparisonKey(a)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$k&&(this.F|=1024)),this.F}async stat(c){try{const{stat:n,symbolicLink:a}=await D.SymlinkSupport.stat(this.C(c));return{type:this.H(n,a),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:r.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const n=await D.Promises.readdir(this.C(c),{withFileTypes:!0}),a=[];return await Promise.all(n.map(async l=>{try{let v;l.isSymbolicLink()?v=(await this.stat((0,p.$gg)(c,l.name))).type:v=this.H(l),a.push([l.name,v])}catch(v){this.a.trace(v)}})),a}catch(n){throw this.ab(n)}}H(c,n){let a;return n?.dangling?a=r.FileType.Unknown:c.isFile()?a=r.FileType.File:c.isDirectory()?a=r.FileType.Directory:a=r.FileType.Unknown,n&&(a|=r.FileType.SymbolicLink),a}async J(c){const n=this.C(c);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let a;for(;a=this.I.get(c);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await a.wait();const l=new f.$Dg;return this.I.set(c,l),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,$.$kb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(c)===l&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(c)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),l.open()})}async readFile(c,n){let a;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(c)})`),a=await this.J(c));const l=this.C(c);return await D.Promises.readFile(l)}catch(l){throw this.ab(l)}finally{a?.dispose()}}L(c){t.D&&this.a.trace(c)}readFileStream(c,n,a){const l=(0,k.$vc)(v=>A.$Hc.concat(v.map(E=>A.$Hc.wrap(E))).buffer);return(0,i.$zp)(this,c,l,v=>v.buffer,{...n,bufferSize:256*1024},a),l}async writeFile(c,n,a){return a?.atomic!==!1&&a?.atomic?.postfix?this.M(c,(0,p.$gg)((0,p.$fg)(c),`${(0,p.$dg)(c)}${a.atomic.postfix}`),n,a):this.N(c,n,a)}async M(c,n,a,l){await this.N(n,a,l);try{await this.rename(n,c,{overwrite:!0})}catch(v){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}async N(c,n,a){let l;try{const v=this.C(c);if(!a.create||!a.overwrite){if(await D.Promises.exists(v)){if(!a.overwrite)throw(0,r.$dk)((0,y.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,r.$dk)((0,y.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(c,{create:!0,unlock:a.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(v){throw await this.bb(c,v)}finally{typeof l=="number"&&await this.close(l)}}static{this.R=!0}static configureFlushOnWrite(c){t.R=c}async open(c,n){const a=this.C(c);let l;(0,r.$5j)(n)&&(l=await this.J(c));let v;try{if((0,r.$5j)(n)&&n.unlock)try{const{stat:u}=await D.SymlinkSupport.stat(a);u.mode&128||await D.Promises.chmod(a,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let E;if((0,r.$5j)(n)){if(I.$i)try{await D.Promises.truncate(a,0),E="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}E||(E="w")}else E="r";v=await D.Promises.open(a,E)}catch(E){throw l?.dispose(),(0,r.$5j)(n)?await this.bb(c,E):this.ab(E)}if(this.O.set(v,0),(0,r.$5j)(n)&&this.Q.set(v,c),l){const E=this.P.get(v);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${a})`),this.P.set(v,l),E&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${a})`),E.dispose())}return v}async close(c){const n=this.P.get(c);try{if(this.O.delete(c),this.Q.delete(c)&&t.R)try{await D.Promises.fdatasync(c)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await D.Promises.close(c)}catch(a){throw this.ab(a)}finally{n&&(this.P.get(c)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.P.delete(c)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),n.dispose())}}async read(c,n,a,l,v){const E=this.S(c,n);let u=null;try{u=(await D.Promises.read(c,a,l,v,E)).bytesRead}catch(h){throw this.ab(h)}finally{this.U(c,E,u)}return u}S(c,n){return n===this.O.get(c)?null:n}U(c,n,a){const l=this.O.get(c);typeof l=="number"&&(typeof n=="number"||(typeof a=="number"?this.O.set(c,l+a):this.O.delete(c)))}async write(c,n,a,l,v){return(0,f.$Wg)(()=>this.W(c,n,a,l,v),100,3)}async W(c,n,a,l,v){const E=this.S(c,n);let u=null;try{u=(await D.Promises.write(c,a,l,v,E)).bytesWritten}catch(h){throw await this.bb(this.Q.get(c),h)}finally{this.U(c,E,u)}return u}async mkdir(c){try{await D.Promises.mkdir(this.C(c))}catch(n){throw this.ab(n)}}async delete(c,n){try{const a=this.C(c);if(n.recursive){let l;n?.atomic!==!1&&n.atomic.postfix&&(l=(0,P.$$c)((0,P.$bd)(a),`${(0,P.$cd)(a)}${n.atomic.postfix}`)),await D.Promises.rm(a,D.RimRafMode.MOVE,l)}else try{await D.Promises.unlink(a)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let v=!1;try{const{stat:E,symbolicLink:u}=await D.SymlinkSupport.stat(a);v=E.isDirectory()&&!u}catch{}if(v)await D.Promises.rmdir(a);else throw l}else throw l}}catch(a){throw this.ab(a)}}async rename(c,n,a){const l=this.C(c),v=this.C(n);if(l!==v)try{await this.X(c,n,"move",a.overwrite),await D.Promises.rename(l,v)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(2,null,(0,P.$cd)(l),(0,P.$cd)((0,P.$bd)(v)),E.toString()))),this.ab(E)}}async copy(c,n,a){const l=this.C(c),v=this.C(n);if(l!==v)try{await this.X(c,n,"copy",a.overwrite),await D.Promises.copy(l,v,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,y.localize)(3,null,(0,P.$cd)(l),(0,P.$cd)((0,P.$bd)(v)),E.toString()))),this.ab(E)}}async X(c,n,a,l){const v=this.C(c),E=this.C(n);let u=!1;if(!!(this.capabilities&1024)||(u=(0,S.$Je)(v,E,!0)),u){if(a==="copy")throw(0,r.$dk)((0,y.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const w=await this.G(c);if(!w)throw(0,r.$dk)((0,y.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const L=await this.G(n);if(L){if(!l)throw(0,r.$dk)((0,y.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&L.type&r.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,n){return this.Y(c,n,!1)}async Y(c,n,a){const l=this.C(c),v=this.C(n),E=!!(this.capabilities&1024);if((0,S.$Je)(l,v,!E))return;const u=new $.$lb;try{const[h,w]=await Promise.all([this.J(c),this.J(n)]);u.add(h),u.add(w),a&&await D.Promises.mkdir((0,P.$bd)(v),{recursive:!0}),await D.Promises.copyFile(l,v)}catch(h){if(h.code==="ENOENT"&&!a)return this.Y(c,n,!0);throw this.ab(h)}finally{u.dispose()}}p(c,n,a){return new b.$Qp(l=>c(l),l=>n(l),a)}y(c,n,a){return new g.$Yp(l=>c(l),l=>n(l),a)}ab(c){if(c instanceof r.$ck)return c;let n=c,a;switch(c.code){case"ENOENT":a=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=r.FileSystemProviderErrorCode.Unknown;break;default:a=r.FileSystemProviderErrorCode.Unknown}return(0,r.$dk)(n,a)}async bb(c,n){let a=this.ab(n);if(c&&a.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await D.SymlinkSupport.stat(this.C(c));l.mode&128||(a=(0,r.$dk)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.$Zp=t}),define(De[241],Ce([1,0,3,14]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;class f extends C.$mb{constructor(A,m=[]){super(),this.a=new T.$aj([A,...m]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$fN=f}),define(De[242],Ce([1,0,30,14]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0;var f;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(f||(f={}));async function R($,P,I,p,k){try{const D=await new Promise((r,i)=>{be(["@vscode/spdlog"],r,i)});D.setFlushOn(f.Trace);const y=await D.createAsyncRotatingLogger($,P,I,p);return k?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(D){console.error(D)}return null}function A($,P,I){switch(P){case T.LogLevel.Trace:$.trace(I);break;case T.LogLevel.Debug:$.debug(I);break;case T.LogLevel.Info:$.info(I);break;case T.LogLevel.Warning:$.warn(I);break;case T.LogLevel.Error:$.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function m($,P){switch(P){case T.LogLevel.Trace:$.setLevel(f.Trace);break;case T.LogLevel.Debug:$.setLevel(f.Debug);break;case T.LogLevel.Info:$.setLevel(f.Info);break;case T.LogLevel.Warning:$.setLevel(f.Warning);break;case T.LogLevel.Error:$.setLevel(f.Error);break;case T.LogLevel.Off:$.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class S extends T.$9i{constructor(P,I,p,k,D){super(),this.k=[],this.setLevel(D),this.l=this.n(P,I,p,k),this.B(this.onDidChangeLogLevel(y=>{this.m&&m(this.m,y)}))}async n(P,I,p,k){const D=p?6:1,y=30/D*C.$yk.MB,r=await R(P,I,y,D,k);if(r){this.m=r,m(this.m,this.getLevel());for(const{level:i,message:s}of this.k)A(this.m,i,s);this.k=[]}}g(P,I){this.m?A(this.m,P,I):this.getLevel()<=P&&this.k.push({level:P,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$7M=S}),define(De[133],Ce([1,0,38,198,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function $(D,y){return y-D}S.compare=$;const P=Object.create(null);P[S.Error]=(0,T.localize)(0,null),P[S.Warning]=(0,T.localize)(1,null),P[S.Info]=(0,T.localize)(2,null);function I(D){return P[D]||""}S.toString=I;function p(D){switch(D){case C.default.Error:return S.Error;case C.default.Warning:return S.Warning;case C.default.Info:return S.Info;case C.default.Ignore:return S.Hint}}S.fromSeverity=p;function k(D){switch(D){case S.Error:return C.default.Error;case S.Warning:return C.default.Warning;case S.Info:return C.default.Info;case S.Hint:return C.default.Ignore}}S.toSeverity=k}(A||(e.MarkerSeverity=A={}));var m;(function(S){const $="";function P(p){return I(p,!0)}S.makeKey=P;function I(p,k){const D=[$];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push($),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push($),p.severity!==void 0&&p.severity!==null?D.push(A.toString(p.severity)):D.push($),p.message&&k?D.push(p.message.replace("\xA6","\\\xA6")):D.push($),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push($),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push($),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push($),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push($),D.push($),D.join("\xA6")}S.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$Zs=(0,f.$zh)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=T.default,e.$Vu=(0,f.$zh)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class S{constructor(){this.progress=new $,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Wu=S;class ${infinite(){}done(){}total(I){}worked(I){}}e.$Xu=$}),define(De[134],Ce([1,0,15,2,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GT=e.$FT=e.$ET=e.$DT=e.$CT=void 0,e.$CT=(0,f.$zh)("openerService");function R($,P){return T.URI.isUri($)?(0,C.$Od)($.scheme,P):(0,C.$Pd)($,P+":")}e.$DT=R;function A($,...P){return P.some(I=>R($,I))}e.$ET=A;function m($,P){return $.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$FT=m;function S($){let P;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return I&&(P={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},$=$.with({fragment:""})),{selection:P,uri:$}}e.$GT=S}),define(De[244],Ce([1,0,12,47]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let f;if(typeof C.$g.vscode<"u"&&typeof C.$g.vscode.context<"u"){const R=C.$g.vscode.context.configuration();if(R)f=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(f=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(f,{nameShort:`${f.nameShort} Dev`,nameLong:`${f.nameLong} Dev`,dataFolderName:`${f.dataFolderName}-dev`,serverDataFolderName:f.serverDataFolderName?`${f.serverDataFolderName}-dev`:void 0}),!f.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(f,{version:R.version})}}else f={},Object.keys(f).length===0&&Object.assign(f,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=f}),define(De[135],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=void 0,e.$ij=(0,C.$zh)("productService"),e.$jj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(be,e){return function(C,T){e(C,T,be)}};define(De[84],Ce([1,0,11,21,3,5]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,R.$zh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,p){this.c=I,this.report=p?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const p=this.c(this.a);this.b=Promise.resolve(p).finally(()=>this.b=void 0)})}}e.$1u=m;let S=class extends f.$mb{constructor(I,p){super(),this.a=new C.$Zg,p.withProgress(I,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,f.$kb)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$2u=S,e.$2u=S=Ke([Be(1,e.$Yu)],S);class $ extends f.$mb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new f.$lb)}start(I){this.stop();const p=++this.a,k=new T.$rc;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,f.$kb)(()=>clearTimeout(this.f))),this.b.add((0,f.$kb)(()=>k.cancel())),this.b.add((0,f.$kb)(()=>this.c?this.c.done():void 0)),{id:p,token:k.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$3u=$,e.$4u=(0,R.$zh)("editorProgressService")}),define(De[42],Ce([1,0,57,18]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0;class f{constructor(){this.a=new Map}add(A,m){C.ok(T.$le(A)),C.ok(T.$ne(m)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$6m=new f}),define(De[106],Ce([1,0,4,42]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0,e.$7m={JSONContribution:"base.contributions.json"};function f(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new C.$hc,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,$){this.a[f(S)]=$,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;T.$6m.add(e.$7m.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,18,188,49,106,42]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.ConfigurationScope=e.$$m=e.EditPresentationTypes=void 0;var $;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$$m={Configuration:"base.contributions.configuration"};var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$_m={properties:{},patternProperties:{}},e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn="vscode://schemas/settings/resourceLanguage",e.$gn="vscode://schemas/settings/configurationDefaults";const I=S.$6m.as(m.$7m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new T.$hc,this.onDidSchemaChange=this.i.event,this.j=new T.$hc,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$fn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const c=new Set;this.n(t,o,c),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const o=new Set;this.o(t,o),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const c=new Set;this.o(o,c),this.n(t,!1,c),I.registerSchema(e.$fn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const c=[];for(const{overrides:n,source:a}of t)for(const l in n)if(o.add(l),e.$in.test(l)){const v=this.a.get(l),E=v?.valuesSources??new Map;if(a)for(const L of Object.keys(n[l]))E.set(L,a);const u={...v?.value||{},...n[l]};this.a.set(l,{source:a,value:u,valuesSources:E});const h=(0,A.$di)(l),w={type:"object",default:u,description:R.localize(1,null,h),$ref:e.$fn,defaultDefaultValue:u,source:f.$le(a)?void 0:a,defaultValueSource:a};c.push(...y(l)),this.d[l]=w,this.b.properties[l]=w}else{this.a.set(l,{value:n[l],source:a});const v=this.d[l];v&&(this.w(l,v),this.r(l,v))}this.m(c)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:c,source:n}of t)for(const a in c){const l=this.a.get(a),v=f.$le(n)?n:n?.id,E=f.$le(l?.source)?l?.source:l?.source?.id;if(v===E)if(o.add(a),this.a.delete(a),e.$in.test(a))delete this.d[a],delete this.b.properties[a];else{const u=this.d[a];u&&(this.w(a,u),this.r(a,u))}}this.u()}deltaConfiguration(t){let o=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,c){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,c),this.c.push(n),this.q(n)})}o(t,o){const c=n=>{if(n.properties)for(const a in n.properties){o.add(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.s(a,n.properties[a])}n.allOf?.forEach(a=>c(a))};for(const n of t){c(n);const a=this.c.indexOf(n);a!==-1&&this.c.splice(a,1)}}p(t,o=!0,c,n,a=3,l){a=f.$ue(t.scope)?a:t.scope;const v=t.properties;if(v)for(const u in v){const h=v[u];if(o&&d(u,h)){delete v[u];continue}if(h.source=c,h.defaultDefaultValue=v[u].default,this.w(u,h),e.$in.test(u)?h.scope=void 0:(h.scope=f.$ue(h.scope)?a:h.scope,h.restricted=f.$ue(h.restricted)?!!n?.includes(u):h.restricted),v[u].hasOwnProperty("included")&&!v[u].included){this.f[u]=v[u],delete v[u];continue}else this.d[u]=v[u],v[u].policy?.name&&this.e.set(v[u].policy.name,u);!v[u].deprecationMessage&&v[u].markdownDeprecationMessage&&(v[u].deprecationMessage=v[u].markdownDeprecationMessage),l.add(u)}const E=t.allOf;if(E)for(const u of E)this.p(u,o,c,n,a,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=c=>{const n=c.properties;if(n)for(const l in n)this.r(l,n[l]);c.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$_m.properties[t]=o,o.scope){case 1:e.$an.properties[t]=o;break;case 2:e.$bn.properties[t]=o;break;case 6:e.$cn.properties[t]=o;break;case 3:e.$dn.properties[t]=o;break;case 4:e.$en.properties[t]=o;break;case 5:e.$en.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$_m.properties[t],o.scope){case 1:delete e.$an.properties[t];break;case 2:delete e.$bn.properties[t];break;case 6:delete e.$cn.properties[t];break;case 3:delete e.$dn.properties[t];break;case 4:case 5:delete e.$en.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,c={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$fn};this.w(o,c),e.$_m.properties[o]=c,e.$an.properties[o]=c,e.$bn.properties[o]=c,e.$cn.properties[o]=c,e.$dn.properties[o]=c,e.$en.properties[o]=c}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$fn};e.$_m.patternProperties[e.$hn]=t,e.$an.patternProperties[e.$hn]=t,e.$bn.patternProperties[e.$hn]=t,e.$cn.patternProperties[e.$hn]=t,e.$dn.patternProperties[e.$hn]=t,e.$en.patternProperties[e.$hn]=t,this.i.fire()}w(t,o){const c=this.a.get(t);let n=c?.value,a=c?.source;f.$se(n)&&(n=o.defaultDefaultValue,a=void 0),f.$se(n)&&(n=i(o.type)),o.default=n,o.defaultValueSource=a}}const k="\\[([^\\]]+)\\]",D=new RegExp(k,"g");e.$hn=`^(${k})+$`,e.$in=new RegExp(e.$hn);function y(g){const t=[];if(e.$in.test(g)){let o=D.exec(g);for(;o?.length;){const c=o[1].trim();c&&t.push(c),o=D.exec(g)}}return(0,C.$Ff)(t)}e.$jn=y;function r(g){return g.reduce((t,o)=>`${t}[${o}]`,"")}e.$kn=r;function i(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$ln=i;const s=new p;S.$6m.add(e.$$m.Configuration,s);function d(g,t){return g.trim()?e.$in.test(g)?R.localize(7,null,g):s.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):t.policy?.name&&s.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,g,t.policy?.name,s.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$mn=d;function b(){const g=[],t=s.getConfigurationProperties();for(const o of Object.keys(t))g.push([o,t[o].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$nn=b}),define(De[245],Ce([1,0,19,4,157,3,28,23,18,2,49,136,42]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=void 0;function k(o){return Object.isFrozen(o)?o:m.$Um(o)}class D{constructor(c={},n=[],a=[],l){this.b=c,this.c=n,this.d=a,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(n=>{if(n instanceof D)return n;const a=new y("");return a.parseRaw(n),a.configurationModel});this.f=c.reduce((n,a)=>a===n?a:n.merge(a),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,P.$bi)(this.contents,c):this.contents}inspect(c,n){const a=this.rawConfiguration.getValue(c),l=n?this.rawConfiguration.getOverrideValue(c,n):void 0,v=n?this.rawConfiguration.override(n).getValue(c):a;return{value:a,override:l,merged:v}}getOverrideValue(c,n){const a=this.i(n);return a?c?(0,P.$bi)(a,c):a:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const a of this.overrides)a.identifiers.includes(c)&&n.push(...a.keys);return C.$Ff(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return C.$Ff(c)}override(c){let n=this.a.get(c);return n||(n=this.g(c),this.a.set(c,n)),n}merge(...c){const n=m.$Tm(this.contents),a=m.$Tm(this.overrides),l=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const E of c)if(v.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(n,E.contents);for(const u of E.overrides){const[h]=a.filter(w=>C.$of(w.identifiers,u.identifiers));h?(this.h(h.contents,u.contents),h.keys.push(...u.keys),h.keys=C.$Ff(h.keys)):a.push(m.$Tm(u))}for(const u of E.keys)l.indexOf(u)===-1&&l.push(u)}return new D(n,l,a,v.every(E=>E instanceof D)?void 0:v)}g(c){const n=this.i(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const l of C.$Ff([...Object.keys(this.contents),...Object.keys(n)])){let v=this.contents[l];const E=n[l];E&&(typeof v=="object"&&typeof E=="object"?(v=m.$Tm(v),this.h(v,E)):v=E),a[l]=v}return new D(a,this.keys,this.overrides)}h(c,n){for(const a of Object.keys(n)){if(a in c&&S.$ne(c[a])&&S.$ne(n[a])){this.h(c[a],n[a]);continue}c[a]=m.$Tm(n[a])}}i(c){let n=null,a=null;const l=v=>{v&&(a?this.h(a,v):a=m.$Tm(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===c?n=v.contents:v.identifiers.includes(c)&&l(v.contents);return l(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,n){this.j(c,n,!0)}setValue(c,n){this.j(c,n,!1)}removeValue(c){const n=this.keys.indexOf(c);n!==-1&&(this.keys.splice(n,1),(0,P.$ai)(this.contents,c),I.$in.test(c)&&this.overrides.splice(this.overrides.findIndex(a=>C.$of(a.identifiers,(0,I.$jn)(c))),1))}j(c,n,a){(0,P.$_h)(this.contents,c,n,l=>console.error(l)),a=a||this.keys.indexOf(c)===-1,a&&this.keys.push(c),I.$in.test(c)&&this.overrides.push({identifiers:(0,I.$jn)(c),keys:Object.keys(this.contents[c]),contents:(0,P.$$h)(this.contents[c],l=>console.error(l))})}}e.$on=D;class y{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,n){if(!S.$ue(c)){const a=this.g(c);this.parseRaw(a,n)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,n){this.a=c;const{contents:a,keys:l,overrides:v,restricted:E,hasExcludedProperties:u}=this.h(c,n);this.b=new D(a,l,v,u?[c]:void 0),this.c=E||[]}g(c){let n={},a=null,l=[];const v=[],E=[];function u(w){Array.isArray(l)?l.push(w):a!==null&&(l[a]=w)}const h={onObjectBegin:()=>{const w={};u(w),v.push(l),l=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{l=v.pop()},onArrayBegin:()=>{const w=[];u(w),v.push(l),l=w,a=null},onArrayEnd:()=>{l=v.pop()},onLiteralValue:u,onError:(w,L,O)=>{E.push({error:w,offset:L,length:O})}};if(c)try{f.$Qm(c,h),n=l[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return n}h(c,n){const a=p.$6m.as(I.$$m.Configuration).getConfigurationProperties(),l=this.i(c,a,!0,n);c=l.raw;const v=(0,P.$$h)(c,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),E=Object.keys(c),u=this.j(c,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:v,keys:E,overrides:u,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(c,n,a,l){let v=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:v};const E={},u=[];for(const h in c)if(I.$in.test(h)&&a){const w=this.i(c[h],n,!1,l);E[h]=w.raw,v=v||w.hasExcludedProperties,u.push(...w.restricted)}else{const w=n[h],L=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&u.push(h),!l.exclude?.includes(h)&&(l.include?.includes(h)||(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&w?.restricted))?E[h]=c[h]:v=!0}return{raw:E,restricted:u,hasExcludedProperties:v}}j(c,n){const a=[];for(const l of Object.keys(c))if(I.$in.test(l)){const v={};for(const E in c[l])v[E]=c[l][E];a.push({identifiers:(0,I.$jn)(l),keys:Object.keys(v),contents:(0,P.$$h)(v,n)})}return a}}e.$pn=y;class r extends R.$mb{constructor(c,n,a,l){super(),this.c=c,this.f=n,this.g=l,this.b=this.B(new T.$hc),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&a.isEqual(v.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$qn=r;class i{constructor(c,n,a,l,v,E,u,h,w,L,O,N,M){this.a=c,this.b=n,this.c=a,this.overrideIdentifiers=l,this.d=v,this.f=E,this.g=u,this.h=h,this.i=w,this.j=L,this.k=O,this.l=N,this.m=M}get value(){return k(this.c)}n(c,n,a){const l=c.inspect(n,a);return{get value(){return k(l.value)},get override(){return k(l.override)},get merged(){return k(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class s{constructor(c,n,a,l,v=new D,E=new D,u=new A.$xi,h=new D,w=new A.$xi){this.c=c,this.d=n,this.f=a,this.g=l,this.h=v,this.i=E,this.j=u,this.l=h,this.m=w,this.a=null,this.b=new A.$xi,this.n=null}getValue(c,n,a){return this.q(c,n,a).getValue(c)}updateValue(c,n,a={}){let l;a.resource?(l=this.m.get(a.resource),l||(l=new D,this.m.set(a.resource,l))):l=this.l,n===void 0?l.removeValue(c):l.setValue(c,n),a.resource||(this.a=null)}inspect(c,n,a){const l=this.q(c,n,a),v=this.u(n.resource,a),E=n.resource?this.m.get(n.resource)||this.l:this.l,u=new Set;for(const h of l.overrides)for(const w of h.identifiers)l.getOverrideValue(c,w)!==void 0&&u.add(w);return new i(c,n,l.getValue(c),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,v||void 0,E)}keys(c){const n=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,n){this.j.set(c,n),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const a=[];if(!n){const{added:l,updated:v,removed:E}=g(this.c,c);n=[...l,...v,...E]}for(const l of n)for(const v of(0,I.$jn)(l)){const E=this.c.getKeysForOverrideIdentifier(v),u=c.getKeysForOverrideIdentifier(v),h=[...u.filter(w=>E.indexOf(w)===-1),...E.filter(w=>u.indexOf(w)===-1),...E.filter(w=>!m.$Xm(this.c.override(v).getValue(w),c.override(v).getValue(w)))];a.push([v,h])}return this.updateDefaultConfiguration(c),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(c){const{added:n,updated:a,removed:l}=g(this.d,c),v=[...n,...a,...l];return v.length&&this.updatePolicyConfiguration(c),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:n,updated:a,removed:l,overrides:v}=g(this.applicationConfiguration,c),E=[...n,...a,...l];return E.length&&this.updateApplicationConfiguration(c),{keys:E,overrides:v}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:a,removed:l,overrides:v}=g(this.localUserConfiguration,c),E=[...n,...a,...l];return E.length&&this.updateLocalUserConfiguration(c),{keys:E,overrides:v}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:a,removed:l,overrides:v}=g(this.remoteUserConfiguration,c),E=[...n,...a,...l];return E.length&&this.updateRemoteUserConfiguration(c),{keys:E,overrides:v}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:a,removed:l,overrides:v}=g(this.workspaceConfiguration,c),E=[...n,...a,...l];return E.length&&this.updateWorkspaceConfiguration(c),{keys:E,overrides:v}}compareAndUpdateFolderConfiguration(c,n){const a=this.p.get(c),{added:l,updated:v,removed:E,overrides:u}=g(a,n),h=[...l,...v,...E];return(h.length||!a)&&this.updateFolderConfiguration(c,n),{keys:h,overrides:u}}compareAndDeleteFolderConfiguration(c){const n=this.p.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:a,updated:l,removed:v,overrides:E}=g(n,void 0);return{keys:[...a,...l,...v],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,n,a){let l=this.r(n,a);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(l=l.merge(this.d)),l}r({resource:c},n){let a=this.s();if(n&&c){const l=n.getFolder(c);l&&(a=this.t(l.uri)||a);const v=this.m.get(c);v&&(a=a.merge(v))}return a}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let n=this.b.get(c);if(!n){const a=this.s(),l=this.j.get(c);l?(n=a.merge(l),this.b.set(c,n)):n=a}return n}u(c,n){if(n&&c){const a=n.getFolder(c);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,n)=>{const{contents:a,overrides:l,keys:v}=this.j.get(n);return c.push([n,{contents:a,overrides:l,keys:v}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(n=>c.add(n)),this.userConfiguration.keys.forEach(n=>c.add(n)),this.i.keys.forEach(n=>c.add(n)),this.j.forEach(n=>n.keys.forEach(a=>c.add(a))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(a=>c.add(a))),[...c.values()]}w(c){const n=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(a=>n.add(a)),this.i.getKeysForOverrideIdentifier(c).forEach(a=>n.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(c).forEach(l=>n.add(l))),[...n.values()]}static parse(c){const n=this.x(c.defaults),a=this.x(c.policy),l=this.x(c.application),v=this.x(c.user),E=this.x(c.workspace),u=c.folders.reduce((h,w)=>(h.set($.URI.revive(w[0]),this.x(w[1])),h),new A.$xi);return new s(n,a,l,v,new D,E,u,new D,new A.$xi)}static x(c){return new D(c.contents,c.keys,c.overrides)}}e.$rn=s;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const c=new Set,n=new Map;for(const l of o)l.keys.forEach(v=>c.add(v)),l.overrides.forEach(([v,E])=>{const u=(0,A.$ui)(n,v,new Set);E.forEach(h=>u.add(h))});const a=[];return n.forEach((l,v)=>a.push([v,[...l.values()]])),{keys:[...c.values()],overrides:a}}e.$sn=d;class b{constructor(c,n,a,l){this.change=c,this.f=n,this.g=a,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of c.keys)this.affectedKeys.add(v);for(const[,v]of c.overrides)for(const E of v)this.affectedKeys.add(E);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=s.parse(this.f.data)),this.i}affectsConfiguration(c,n){const a=this.a+c,l=this.d.indexOf(a);if(l<0)return!1;const v=l+a.length;if(v>=this.d.length)return!1;const E=this.d.charCodeAt(v);if(E!==this.b&&E!==this.c)return!1;if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.f?.workspace):void 0,h=this.g.getValue(c,n,this.h);return!m.$Xm(u,h)}return!0}}e.$tn=b;function g(o,c){const{added:n,removed:a,updated:l}=t(c?.rawConfiguration,o?.rawConfiguration),v=[],E=o?.getAllOverrideIdentifiers()||[],u=c?.getAllOverrideIdentifiers()||[];if(c){const h=u.filter(w=>!E.includes(w));for(const w of h)v.push([w,c.getKeysForOverrideIdentifier(w)])}if(o){const h=E.filter(w=>!u.includes(w));for(const w of h)v.push([w,o.getKeysForOverrideIdentifier(w)])}if(c&&o){for(const h of E)if(u.includes(h)){const w=t({contents:o.getOverrideValue(void 0,h)||{},keys:o.getKeysForOverrideIdentifier(h)},{contents:c.getOverrideValue(void 0,h)||{},keys:c.getKeysForOverrideIdentifier(h)});v.push([h,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:a,updated:l,overrides:v}}function t(o,c){const n=o?c?o.keys.filter(v=>c.keys.indexOf(v)===-1):[...o.keys]:[],a=c?o?c.keys.filter(v=>o.keys.indexOf(v)===-1):[...c.keys]:[],l=[];if(o&&c){for(const v of c.keys)if(o.keys.indexOf(v)!==-1){const E=(0,P.$bi)(c.contents,v),u=(0,P.$bi)(o.contents,v);m.$Xm(E,u)||l.push(v)}}return{added:n,removed:a,updated:l}}}),define(De[246],Ce([1,0,22,4,3,81]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkb=e.$lkb=e.$kkb=e.$jkb=void 0;const A=($,P,I)=>{const p=new Uint8Array(16);for(let y=0;y<16;y++)p[y]=Math.round(Math.random()*256);const k=(0,C.$2c)(C.$Hc.wrap(p));return[`GET ws://localhost${$}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$jkb=A,e.$kkb=C.$Hc.fromString(`\r
\r
`);async function m($,P,I,p,k){$.write(C.$Hc.fromString((0,e.$jkb)(P,I,p)));const D=new f.$lb;try{return await new Promise((y,r)=>{let i;D.add($.onData(s=>{i?i=C.$Hc.concat([i,s],i.byteLength+s.byteLength):i=s;const d=i.indexOf(e.$kkb);if(d===-1)return;y($),$.pauseData();const b=i.slice(d+e.$kkb.byteLength);b.byteLength&&k.onData.fire(b)})),D.add($.onClose(s=>r(s??new Error("socket closed")))),D.add($.onEnd(()=>r(new Error("socket ended"))))})}catch(y){throw $.dispose(),y}finally{D.dispose()}}e.$lkb=m;class S extends f.$mb{constructor(P,I){super(),this.g=P,this.a=this.B(new T.$kc),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new T.$hc),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(P,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,P,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$mkb=S}),define(De[64],Ce([1,0,8,5]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.$Kk=e.RemoteAuthorityResolverErrorCode=e.$Jk=e.$Ik=e.RemoteConnectionType=e.$Hk=void 0,e.$Hk=(0,T.$zh)("remoteAuthorityResolverService");var f;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ik=R;class A{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jk=A;var m;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class S extends C.$_{static isNotAvailable(I){return I instanceof S&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof S&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof S&&I._code===m.NoResolverFound}static isInvalidAuthority(I){return I instanceof S&&I._code===m.InvalidAuthority}static isHandled(I){return I instanceof S&&I.isHandled}constructor(I,p=m.Unknown,k){super(I),this._message=I,this._code=p,this._detail=k,this.isHandled=p===m.NotAvailable&&k===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Kk=S;function $(P){const I=P.indexOf("+");return I===-1?P:P.substring(0,I)}e.$Lk=$}),define(De[65],Ce([1,0,17]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=void 0;function T($){return $.scheme===C.Schemas.vscodeRemote?$.authority:void 0}e.$Mk=T;function f($){if(!$)return;const P=$.indexOf("+");return P<0?$:$.substr(0,P)}e.$Nk=f;function R($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Ok=R;function A($){const{host:P,port:I}=S($);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:I}}e.$Pk=A;function m($,P){let{host:I,port:p}=S($);return typeof p>"u"&&(p=P),{host:I,port:p}}e.$Qk=m;function S($){const P=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const p=$.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:$,port:void 0}}}),define(De[25],Ce([1,0,15,5,65]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.TargetPlatform=e.ExtensionType=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl="extensions.user.cache",e.$Ol="extensions.builtin.cache",e.$Pl="undefined_publisher",e.$Ql=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Rl=R,e.$Sl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class S{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,i){if(typeof r>"u"||r===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof r=="string"||typeof i=="string"){const s=typeof r=="string"?r:r.value,d=typeof i=="string"?i:i.value;return C.$Od(s,d)}return r._lower===i._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Tl=S;class ${get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const i of r)this.add(i)}add(r){this.c.add(S.toKey(r))}delete(r){return this.c.delete(S.toKey(r))}has(r){return this.c.has(S.toKey(r))}}e.$Ul=$;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(S.toKey(r))}get(r){return this.c.get(S.toKey(r))}has(r){return this.c.has(S.toKey(r))}set(r,i){this.c.set(S.toKey(r),i)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vl=P;function I(y){return p(y)}e.$Wl=I;function p(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Xl=p;function k(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Yl=k;function D(y,r){if(r){const i=`onResolveRemoteAuthority:${(0,f.$Nk)(r)}`;return!!y.activationEvents?.includes(i)}return!1}e.$Zl=D,e.$1l=(0,T.$zh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const S of A){const $=this.readActivationEvents(S);$.length>0&&(m[T.$Tl.toKey(S.identifier)]=$)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return m;for(const S in A.contributes){const $=this.a.get(S);if(!$)continue;const P=A.contributes[S],I=Array.isArray(P)?P:[P];try{$(I,m)}catch(p){(0,C.$Y)(p)}}return m}}e.$wF=f,e.$xF=new f}),define(De[247],Ce([1,0,11,22,21,8,4,3,53,37,31,81,64,65]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.PersistentConnectionEventType=e.$Xk=e.$Wk=e.$Vk=e.ConnectionType=void 0;const D=30*1e3;var y;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function r(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function i(X){const U=new f.$rc;return setTimeout(()=>U.cancel(),X),U.token}function s(X,U){if(X.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const q=new f.$rc;return X.onCancellationRequested(()=>q.cancel()),U.onCancellationRequested(()=>q.cancel()),q.token}class d{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new m.$lb,this.promise=new Promise((q,G)=>{this.f=q,this.g=G}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function b(X,U){const q=new d(U);return q.registerDisposable(X.onControlMessage(G=>{const ce=JSON.parse(G.toString()),re=Q(ce);re?q.reject(re):q.resolve(ce)})),q.promise}function g(X,U,q,G,ce,re,de,Ee){const he=new d(Ee),ge=$.$dc.create(!1);return X.info(`Creating a socket (${de})...`),S.mark(`code/willCreateSocket/${re}`),U.connect(q,G,ce,de).then(ne=>{he.didTimeout?(S.mark(`code/didCreateSocketError/${re}`),X.info(`Creating a socket (${de}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),ne?.dispose()):(S.mark(`code/didCreateSocketOK/${re}`),X.info(`Creating a socket (${de}) was successful after ${ge.elapsed()} ms.`),he.resolve(ne))},ne=>{S.mark(`code/didCreateSocketError/${re}`),X.info(`Creating a socket (${de}) returned an error after ${ge.elapsed()} ms.`),X.error(ne),he.reject(ne)}),he.promise}function t(X,U){const q=new d(U);return X.then(G=>{q.didTimeout||q.resolve(G)},G=>{q.didTimeout||q.reject(G)}),q.promise}async function o(X,U,q,G){const ce=ae(X,U);X.logService.trace(`${ce} 1/6. invoking socketFactory.connect().`);let re;try{re=await g(X.logService,X.remoteSocketFactoryService,X.connectTo,(0,k.$Ok)(X),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,r(U),`renderer-${r(U)}-${X.reconnectionToken}`,G)}catch(ne){throw X.logService.error(`${ce} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ne),ne}X.logService.trace(`${ce} 2/6. socketFactory.connect() was successful.`);let de,Ee;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(re,null),de=X.reconnectionProtocol,Ee=!1):(de=new I.$nh({socket:re}),Ee=!0),X.logService.trace(`${ce} 3/6. sending AuthRequest control message.`);const he=await t(X.signService.createNewMessage((0,P.$6e)()),G),ge={type:"auth",auth:X.connectionToken||"00000000000000000000",data:he.data};de.sendControl(T.$Hc.fromString(JSON.stringify(ge)));try{const ne=await b(de,s(G,i(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(X.logService.trace(`${ce} 4/6. received SignRequest control message.`),!await t(X.signService.validate(he,ne.signedData),G)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const we=await t(X.signService.sign(ne.data),G),Pe={type:"connectionType",commit:X.commit,signedData:we,desiredConnectionType:U};return q&&(Pe.args=q),X.logService.trace(`${ce} 5/6. sending ConnectionTypeRequest control message.`),de.sendControl(T.$Hc.fromString(JSON.stringify(Pe))),{protocol:de,ownsProtocol:Ee}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(X.logService.error(`${ce} the handshake timed out. Error:`),X.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${ce} received error control message when negotiating connection. Error:`),X.logService.error(ne)),Ee&&_(de),ne}}async function c(X,U,q,G){const ce=Date.now(),re=ae(X,U),{protocol:de,ownsProtocol:Ee}=await o(X,U,q,G),he=new d(G);return he.registerDisposable(de.onControlMessage(ge=>{const ne=JSON.parse(ge.toString()),ue=Q(ne);ue?(X.logService.error(`${re} received error control message when negotiating connection. Error:`),X.logService.error(ue),Ee&&_(de),he.reject(ue)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${re} 6/6. handshake finished, connection is up and running after ${te(ce)}!`),he.resolve({protocol:de,firstMessage:ne}))})),he.promise}async function n(X,U){const{protocol:q}=await c(X,1,void 0,U);return{protocol:q}}async function a(X,U,q){const{protocol:G,firstMessage:ce}=await c(X,2,U,q),re=ce&&ce.debugPort;return{protocol:G,debugPort:re}}async function l(X,U,q){const G=Date.now(),ce=ae(X,3),{protocol:re}=await o(X,3,U,q);return X.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${te(G)}!`),re}async function v(X,U,q){const{connectTo:G,connectionToken:ce}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:G,connectionToken:ce,reconnectionToken:U,reconnectionProtocol:q,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function E(X,U,q){return h(X,async G=>{const{protocol:ce}=await n(G,f.CancellationToken.None);return new H(X,U,q,G.reconnectionToken,ce)})}e.$Vk=E;async function u(X,U){return h(X,async q=>{const{protocol:G,debugPort:ce}=await a(q,U,f.CancellationToken.None);return new $e(X,U,q.reconnectionToken,G,ce)})}e.$Wk=u;async function h(X,U){for(let G=1;;G++)try{const ce=(0,P.$6e)(),re=await v(X,ce,null);return await U(re)}catch(ce){if(G<5)X.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(ce);else throw X.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(ce),K.triggerPermanentFailure(0,0,p.$Kk.isHandled(ce)),ce}}async function w(X,U,q){const G=await v(X,(0,P.$6e)(),null);return await l(G,{host:U,port:q},f.CancellationToken.None)}e.$Xk=w;function L(X){return(0,C.$sg)(U=>new Promise((q,G)=>{const ce=setTimeout(q,X*1e3);U.onCancellationRequested(()=>{clearTimeout(ce),q()})}))}var O;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class N{constructor(U,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.type=0}}e.$Yk=N;class M{constructor(U,q,G,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.durationSeconds=G,this.c=ce,this.type=1}skipWait(){this.c.cancel()}}e.$Zk=M;class z{constructor(U,q,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.type=2}}e.$1k=z;class j{constructor(U,q,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.type=4}}e.$2k=j;class F{constructor(U,q,G,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.handled=ce,this.type=3}}e.$3k=F;class K extends m.$mb{static triggerPermanentFailure(U,q,G){this._permanentFailure=!0,this.f=U,this.g=q,this.h=G,this.i.forEach(ce=>ce.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.s())}static debugPauseSocketWriting(){this.i.forEach(U=>U.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||K._permanentFailure}constructor(U,q,G,ce,re){super(),this.n=U,this.p=q,this.reconnectionToken=G,this.protocol=ce,this.r=re,this.j=this.B(new A.$hc),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new j(this.reconnectionToken,0,0)),this.B(ce.onSocketClose(de=>{const Ee=me(this.n,this.reconnectionToken,!0);de?de.type===0?(this.p.logService.info(`${Ee} received socket close event (hadError: ${de.hadError}).`),de.error&&this.p.logService.error(de.error)):(this.p.logService.info(`${Ee} received socket close event (wasClean: ${de.wasClean}, code: ${de.code}, reason: ${de.reason}).`),de.event&&this.p.logService.error(de.event)):this.p.logService.info(`${Ee} received socket close event.`),this.s()})),this.B(ce.onSocketTimeout(de=>{const Ee=me(this.n,this.reconnectionToken,!0);this.p.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${de.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${de.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${de.timeSinceLastReceivedSomeData}).`),this.s()})),K.i.push(this),this.B((0,m.$kb)(()=>{const de=K.i.indexOf(this);de>=0&&K.i.splice(de,1)})),this.k&&this.v(K.f,K.g,K.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const U=me(this.n,this.reconnectionToken,!0);this.p.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const ce=G<q.length?q[G]:q[q.length-1];try{if(ce>0){const de=L(ce);this.j.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ce,de)),this.p.logService.info(`${U} waiting for ${ce} seconds before reconnecting...`);try{await de}catch{}}if(this.k){this.p.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.p.logService.info(`${U} resolving connection...`);const re=await v(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${U} connecting to ${re.connectTo}...`),await this.y(re,i(D)),this.p.logService.info(`${U} reconnected!`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(re){if(re.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(re),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.p.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(re),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(p.$Kk.isTemporarilyNotAvailable(re)){this.p.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(re);continue}if((re.code==="ETIMEDOUT"||re.code==="ENETUNREACH"||re.code==="ECONNREFUSED"||re.code==="ECONNRESET")&&re.syscall==="connect"){this.p.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(re);continue}if((0,R.$2)(re)){this.p.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(re);continue}if(re instanceof p.$Kk){this.p.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(re),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,p.$Kk.isHandled(re));break}this.p.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(re),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k&&!this.m)}u(U,q,G){this.r?K.triggerPermanentFailure(U,q,G):this.v(U,q,G)}v(U,q,G){this.j.fire(new F(this.reconnectionToken,U,q,G)),_(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$4k=K;class H extends K{constructor(U,q,G,ce,re){super(1,U,ce,re,!0),this.client=this.B(new I.$lh(re,{remoteAuthority:q,clientId:G},U.ipcLogger))}async y(U,q){await n(U,q)}}e.$5k=H;class $e extends K{constructor(U,q,G,ce,re){super(2,U,G,ce,!1),this.z=q,this.debugPort=re}async y(U,q){await a(U,this.z,q)}}e.$6k=$e;function _(X){try{X.acceptDisconnect();const U=X.getSocket();X.dispose(),U.dispose()}catch(U){(0,R.$Y)(U)}}function Q(X){if(X&&X.type==="error"){const U=new Error(`Connection error: ${X.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function V(X,U){for(;X.length<U;)X+=" ";return X}function ee(X,U){return`[remote-connection][${V(r(X),13)}][${U.substr(0,5)}\u2026]`}function me(X,U,q){return`${ee(X,U)}[${q?"reconnect":"initial"}]`}function ae(X,U){return`${me(U,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function te(X){return`${Date.now()-X} ms`}}),define(De[248],Ce([1,0,3,5]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=void 0,e.$Rk=(0,T.$zh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(A,m){return this.a[A]??=[],this.a[A].push(m),(0,C.$kb)(()=>{const S=this.a[A]?.indexOf(m);typeof S=="number"&&S>=0&&this.a[A]?.splice(S,1)})}b(A){return(this.a[A.type]||[]).find(S=>S.supports(A))}connect(A,m,S,$){const P=this.b(A);if(!P)throw new Error(`No socket factory found for ${A}`);return P.connect(A,m,S,$)}}e.$Sk=f}),define(De[249],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a2b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const R=await this.c();if(R){const A=String(C.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const A=this.b.get(f.id);if(!A)return!1;this.b.delete(f.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$a2b=C}),define(De[107],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk="signService",e.$Uk=(0,C.$zh)(e.$Tk)}),define(De[138],Ce([1,0,249]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;class T extends C.$a2b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>be(["vsda"],R,A))}}e.$X6b=T}),define(De[250],Ce([1,0,12,47,31]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=void 0;function R(S){if(C.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,$,P,I,p,k,D,y){const r=Object.create(null);r["common.machineId"]=k,r.sessionID=(0,f.$6e)()+Date.now(),r.commitHash=I,r.version=p,r["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,C.$h)(C.$t),r["common.nodePlatform"]=T.$5c,r["common.nodeArch"]=P,r["common.product"]=y||"desktop",D&&(r["common.msftInternal"]=D);let i=0;const s=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(r["common.snap"]="true");const d=R($);return d&&(r["common.platformDetail"]=d),r}e.$8n=A;function m(S){const $=T.env.USERDNSDOMAIN;if(!$)return!1;const P=$.toLowerCase();return S.some(I=>P===I)}e.$9n=m}),define(De[251],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=void 0,e.$7k=(0,C.$zh)("telemetryService"),e.$8k=(0,C.$zh)("customEndpointTelemetryService"),e.$9k="telemetry.currentSessionDate",e.$0k="telemetry.firstSessionDate",e.$$k="telemetry.lastSessionDate",e.$_k="telemetry.machineId",e.$al="telemetry",e.$bl="telemetry.telemetryLevel",e.$cl="telemetry.enableCrashReporter",e.$dl="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(De[85],Ce([1,0,23,18,4,49,65,250,251]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=void 0;class ${constructor(a){this.value=a,this.isTrustedTelemetryValue=!0}}e.$0n=$;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$$n=P,e.$_n=new P;class I{async publicLog(a,l,v){}async publicLogError(a,l,v){}}e.$ao=I,e.$bo="telemetry",e.$co="extensionTelemetryLog",e.$do={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,a){return f.Event.debounce(a.onDidChangeConfiguration,(v,E)=>{const u=v?new Set([...v.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:u}},1e3,!0)(v=>{v.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.$9h)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$eo=p;function k(n,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!n.enableTelemetry||a.extensionTestsLocationURI)}e.$fo=k;function D(n,a){return!(a.isBuilt||a.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$go=D;function y(n){const a=n.getValue(S.$bl),l=n.getValue(S.$cl);if(n.getValue(S.$dl)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ho=y;function r(n){const a={},l={},v={};d(n,v);for(let E in v){E=E.length>150?E.substr(E.length-149):E;const u=v[E];typeof u=="number"?l[E]=u:typeof u=="boolean"?l[E]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${u.length}`),a[E]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(a[E]=u)}return{properties:a,measurements:l}}e.$io=r;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(n){if(!n)return"none";const a=(0,A.$Nk)(n);return i.has(a)?a:"other"}e.$jo=s;function d(n,a,l=0,v){if(n)for(const E of Object.getOwnPropertyNames(n)){const u=n[E],h=v?v+E:E;Array.isArray(u)?a[h]=(0,C.$Ym)(u):u instanceof Date?a[h]=u.toISOString():(0,T.$ne)(u)?l<2?d(u,a,l+1,h+"."):a[h]=(0,C.$Ym)(u):a[h]=u}}function b(n,a){const l=n.msftInternalDomains||[],v=a.getValue("telemetry.internalTesting");return(0,m.$9n)(l)||v}e.$ko=b;function g(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$lo=g;function t(n,a){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const v=[];for(const w of a)for(;;){const L=w.exec(n);if(!L)break;v.push([L.index,w.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(l="";;){const w=u.exec(n);if(!w)break;const L=v.some(([O,N])=>w.index<N&&O<u.lastIndex);!E.test(w[0])&&!L&&(l+=n.substring(h,w.index)+"<REDACTED: user-file-path>",h=u.lastIndex)}return h<n.length&&(l+=n.substr(h)),l}function o(n){if(!n)return n;const a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of a)if(l.regex.test(n))return`<REDACTED: ${l.label}>`;return n}function c(n,a){return(0,C.$Vm)(n,l=>{if(l instanceof $||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let v=l.replaceAll("%20"," ");v=t(v,a);for(const E of a)v=v.replace(E,"");return v=o(v),v}})}e.$mo=c}),define(De[252],Ce([1,0,15,132,25,12,2,8,47,85]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=void 0;function P(c,n){return c.uuid&&n.uuid?c.uuid===n.uuid:c.id===n.id?!0:(0,C.$Jd)(c.id,n.id)===0}e.$no=P;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const a=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,a,l)}static parse(n){const a=I.exec(n);return a&&a[1]&&a[2]?new p({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,l="undefined"){this.version=a,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$oo=p;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(c){const n=k.exec(c);return n&&n[1]?[r(n[1]),n[2]]:[r(c),void 0]}e.$po=D;function y(c,n){return`${c}.${n}`}e.$qo=y;function r(c){return c.toLowerCase()}e.$ro=r;function i(c,n){return r(y(c??f.$Pl,n))}e.$so=i;function s(c,n){const a=[],l=v=>{for(const E of a)if(E.some(u=>P(n(u),n(v))))return E;return null};for(const v of c){const E=l(v);E?E.push(v):a.push([v])}return a}e.$to=s;function d(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$uo=d;function b(c){return{id:new $.$0n(c.identifier.id),name:new $.$0n(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$vo=b,e.$wo=new f.$Tl("pprice.better-merge");function g(c,n){const a=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const v=l.shift();if(v&&a.every(E=>!P(E.identifier,{id:v}))){const E=c.filter(u=>P(u.identifier,{id:v}));E.length===1&&(a.push(E[0]),l.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$xo=g;async function t(c,n){if(!R.$k)return!1;let a;try{a=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){n.debug("Error while getting the os-release file.",(0,m.$8)(v))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(c,n){const a=await t(c,n),l=(0,T.$Sn)(a?"alpine":R.$t,S.$6c);return n.debug("ComputeTargetPlatform:",l),l}e.$yo=o}),define(De[253],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.$_q=e.$$q=e.$0q=void 0;function C(S){return[...S.entries()]}e.$0q=C;function T(S){return S?[...S.entries()]:[]}e.$$q=T;function f(S){return new Map(S)}e.$_q=f;function R(S){return new Map(S??[])}e.$ar=R;function A(S){return Array.from(S.entries()).map($=>[$[0],C($[1].map),T($[1].descriptionMap)])}e.$br=A;function m(S){return new Map(S.map($=>[$[0],{map:f($[1]),descriptionMap:R($[2])}]))}e.$cr=m}),define(De[254],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,A=5){const m=R(S=>{const $=typeof S=="string"?S:S.data;let P=this.a.get(f);if(P){P.data.push($);return}const I=setTimeout(()=>this.flushBuffer(f),A);P={data:[$],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),m.dispose()}},this.a.set(f,P)});return m}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$Ckb=C}),define(De[255],Ce([1,0,11,78,59,4,18,2,199,106,42]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.IconFontDefinition=e.IconContribution=e.$5u=void 0,e.$5u={IconContribution:"base.contributions.icons"};var I;(function(b){function g(t,o){let c=t.defaults;for(;f.ThemeIcon.isThemeIcon(c);){const n=D.getIcon(c.id);if(!n)return;c=n.defaults}return c}b.getDefinition=g})(I||(e.IconContribution=I={}));var p;(function(b){function g(o){return{weight:o.weight,style:o.style,src:o.src.map(c=>({format:c.format,location:c.location.toString()}))}}b.toJSONObject=g;function t(o){const c=n=>(0,A.$le)(n)?n:void 0;if(o&&Array.isArray(o.src)&&o.src.every(n=>(0,A.$le)(n.format)&&(0,A.$le)(n.location)))return{weight:c(o.weight),style:c(o.style),src:o.src.map(n=>({format:n.format,location:m.URI.parse(n.location)}))}}b.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class k{constructor(){this.a=new R.$hc,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,t,o,c){const n=this.b[g];if(n){if(o&&!n.description){n.description=o,this.d.properties[g].markdownDescription=`${o} $(${g})`;const v=this.e.enum.indexOf(g);v!==-1&&(this.e.enumDescriptions[v]=o),this.a.fire()}return n}const a={id:g,description:o,defaults:t,deprecationMessage:c};this.b[g]=a;const l={$ref:"#/definitions/icons"};return c&&(l.deprecationMessage=c),o&&(l.markdownDescription=`${o}: $(${g})`),this.d.properties[g]=l,this.e.enum.push(g),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const t=this.e.enum.indexOf(g);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,t){const o=this.f[g];return o||(this.f[g]=t,this.a.fire(),t)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(n,a)=>n.id.localeCompare(a.id),t=n=>{for(;f.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(n=>this.b[n]);for(const n of c.filter(a=>!!a.description).sort(g))o.push(`|<i class="${t(n)}"></i>|${n.id}|${f.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const n of c.filter(a=>!f.ThemeIcon.isThemeIcon(a.defaults)).sort(g))o.push(`|<i class="${t(n)}"></i>|${n.id}|`);return o.join(`
`)}}const D=new k;P.$6m.add(e.$5u.IconContribution,D);function y(b,g,t,o){return D.registerIcon(b,g,t,o)}e.$6u=y;function r(){return D}e.$7u=r;function i(){const b=(0,T.$Lj)();for(const g in b){const t="\\"+b[g].toString(16);D.registerIcon(g,{fontCharacter:t})}}i(),e.$8u="vscode://schemas/icons";const s=P.$6m.as($.$7m.JSONContribution);s.registerSchema(e.$8u,D.getIconSchema());const d=new C.$Qg(()=>s.notifySchemaChanged(e.$8u),200);D.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.$9u=y("widget-close",T.$Nj.close,(0,S.localize)(2,null)),e.$0u=y("goto-previous-location",T.$Nj.arrowUp,(0,S.localize)(3,null)),e.$$u=y("goto-next-location",T.$Nj.arrowDown,(0,S.localize)(4,null)),e.$_u=f.ThemeIcon.modify(T.$Nj.sync,"spin"),e.$av=f.ThemeIcon.modify(T.$Nj.loading,"spin")}),define(De[86],Ce([1,0,4,49,5,14]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=e.$Wz=e.$Vz=e.ProvidedOnAutoForward=e.$Uz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Tz=e.$Sz=void 0,e.$Sz=(0,f.$zh)("tunnelService"),e.$Tz=(0,f.$zh)("sharedTunnelsService");var A;(function(r){r.Http="http",r.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(m||(e.TunnelPrivacyId=m={}));function S(r){return!!r.forwardPort}e.$Uz=S;var $;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function P(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}e.$Vz=P,e.$Wz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(r){return e.$Wz.indexOf(r)>=0}e.$Xz=I,e.$Yz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(r){return e.$Yz.indexOf(r)>=0}e.$Zz=p;function k(r,i,s,d){if(s===1)return!1;if(s===2&&p(i)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(b?.length===4&&parseInt(b[1])>=18)return!1}return r<1024}e.$1z=k;class D{constructor(i,s,d){this.remoteAddress=i,this.localAddress=s,this.b=d,this.a=new C.$hc,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$2z=D;let y=class{constructor(i,s){this.j=i,this.k=s,this.a=new C.$hc,this.onTunnelOpened=this.a.event,this.b=new C.$hc,this.onTunnelClosed=this.b.event,this.c=new C.$hc,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],s=Array.from(this.e.values());for(const d of s){const b=Array.from(d.values());for(const g of b){const t=await g.value;t&&typeof t!="string"&&i.push(t)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:s}of i.values())await s.then(d=>typeof d!="string"?d?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,s,d,b,g){this.p(i,s,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:s,localAddress:d,privacy:b,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,s){(p(i)||I(i))&&(i=e.$Wz[0]);const d=this.r(i,s);if(d)return++d.refcount,d.value}openTunnel(i,s,d,b,g,t=!1,o,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${s}:${d} on local port ${g}.`);const n=this.f??i;if(!n)return;if(s||(s="localhost"),b||(b=this.l),this.f&&this.i.has(d)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.s(n,s,d,b,g,t,o,c);return a?a.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(s,d),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(s,d);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(l);return(l.tunnelRemoteHost!==s||l.tunnelRemotePort!==d)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&l.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const s=this.e.get(i.tunnelRemoteHost);if(s){const d=s.get(i.tunnelRemotePort);d&&(d.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,d))}}}}async o(i,s,d){if(d.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${s}.`);const b=d.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(s),b}}async closeTunnel(i,s){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${s} `);const d=this.e.get(i);if(d&&d.has(s)){const b=d.get(s);b.refcount=0,await this.o(i,s,b)}}p(i,s,d){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(s,{refcount:1,value:d})}async q(i,s){const d=this.e.get(i);if(d){const b=d.get(s),g=b?await b.value:void 0;(!g||typeof g=="string")&&d.delete(s),d.size===0&&this.e.delete(i)}}r(i,s){const d=[i];I(i)?(d.push(...e.$Wz),d.push(...e.$Yz)):p(i)&&d.push(...e.$Yz);const b=d.map(g=>this.e.get(g));for(const g of b){const t=g?.get(s);if(t)return t}}canTunnel(i){return!!P(i)}t(i,s,d,b,g,t,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${s}:${d} on local port ${b}.`);const c=d;this.i.add(c);const n=b===void 0?d:b,a={elevationRequired:g?this.isPortPrivileged(n):!1},l={remoteAddress:{host:s,port:d},localAddressPort:b,privacy:t,public:t?t!==m.Private:void 0,protocol:o},v=i.forwardPort(l,a);return v?(this.p(s,d,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),v}};e.$3z=y,e.$3z=y=Ke([Be(0,R.$3i),Be(1,T.$6h)],y)}),define(De[256],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=void 0,e.$Ak=(0,C.$zh)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$4z=void 0,e.$4z=(0,C.$zh)("editSessionIdentityService");var T;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[258],Ce([1,0,17]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=void 0;function T(S){return S.scheme!==C.Schemas.file&&S.scheme!==C.Schemas.vscodeRemote}e.$jJ=T;function f(S){if(S.folders.length)return S.folders.every($=>T($.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.$kJ=f;function R(S){return f(S)?.scheme}e.$lJ=R;function A(S){return f(S)?.authority}e.$mJ=A;function m(S){return f(S)!==void 0}e.$nJ=m}),define(De[43],Ce([1,0,201,16,77,24,2,5,17]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.WorkbenchState=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0,e.$Ih=(0,m.$zh)("contextService");function $(n){const a=n;return typeof a?.id=="string"&&A.URI.isUri(a.uri)}e.$Jh=$;function P(n){return typeof n?.id=="string"&&!$(n)&&!p(n)}e.$Kh=P,e.$Lh={id:"ext-dev"},e.$Mh={id:"empty-window"};function I(n,a){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,T.$cd)(n)}:a?e.$Lh:e.$Mh;const l=n;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$Nh=I;function p(n){const a=n;return typeof a?.id=="string"&&A.URI.isUri(a.configPath)}e.$Oh=p;function k(n){const a=n;if(a?.uri)return{id:a.id,uri:A.URI.revive(a.uri)};const l=n;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(n?.id)return{id:n.id}}e.$Ph=k;var D;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function y(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$Qh=y;function r(n){const a=n;return!!(a&&typeof a=="object"&&A.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$Rh=r;class i{constructor(a,l,v,E,u){this.h=a,this.j=v,this.k=E,this.l=u,this.c=f.$Fh.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=f.$Fh.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Sh=i;class s{constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$gg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Th=s;function d(n){return new s({uri:n,index:0,name:(0,R.$cg)(n)},{uri:n.toString()})}e.$Uh=d,e.$Vh="code-workspace",e.$Wh=`.${e.$Vh}`,e.$Xh=[{name:(0,C.localize)(0,null),extensions:[e.$Vh]}],e.$Yh="workspace.json";function b(n,a){return R.$0f.isEqualOrParent(n,a.untitledWorkspacesHome)}e.$Zh=b;function g(n){let a;return A.URI.isUri(n)?a=n:a=n.configuration,a?.scheme===S.Schemas.tmp}e.$1h=g,e.$2h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$2h}e.$3h=t;function o(n,a){return!b(n,a)&&!g(n)}e.$4h=o;function c(n){return(typeof n=="string"?(0,T.$dd)(n):(0,R.$eg)(n))===e.$Wh}e.$5h=c}),define(De[259],Ce([1,0,51,4,3,24,2,200,131,30,5,14,43,28,256,11,31,15,18]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.ProfileResourceType=void 0;var d;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function b(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.$Bk=b,e.$Ck=(0,P.$zh)("IUserDataProfilesService");function g(n,a){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:a}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:a}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:a}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Dk=g;function t(n,a,l,v,E,u){return{id:n,name:a,location:l,isDefault:!1,shortName:E?.shortName,globalStorageHome:u&&E?.useDefaultFlags?.globalState?u.globalStorageHome:(0,R.$gg)(l,"globalStorage"),settingsResource:u&&E?.useDefaultFlags?.settings?u.settingsResource:(0,R.$gg)(l,"settings.json"),keybindingsResource:u&&E?.useDefaultFlags?.keybindings?u.keybindingsResource:(0,R.$gg)(l,"keybindings.json"),tasksResource:u&&E?.useDefaultFlags?.tasks?u.tasksResource:(0,R.$gg)(l,"tasks.json"),snippetsHome:u&&E?.useDefaultFlags?.snippets?u.snippetsHome:(0,R.$gg)(l,"snippets"),extensionsResource:u&&E?.useDefaultFlags?.extensions?u.extensionsResource:(0,R.$gg)(l,"extensions.json"),cacheHome:(0,R.$gg)(v,n),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$Ek=t;let o=class extends f.$mb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(a,l,v,E){super(),this.n=a,this.r=l,this.s=v,this.t=E,this.f=!0,this.h=this.B(new T.$hc),this.onDidChangeProfiles=this.h.event,this.i=this.B(new T.$hc),this.onWillCreateProfile=this.i.event,this.j=this.B(new T.$hc),this.onWillRemoveProfile=this.j.event,this.k=this.B(new T.$hc),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new k.$xi,emptyWindows:new Map},this.profilesHome=(0,R.$gg)(this.n.userRoamingDataHome,"profiles"),this.g=(0,R.$gg)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(a){this.f!==a&&(this.u=void 0,this.f=a)}isEnabled(){return this.f}get v(){if(!this.u){const a=this.w(),l=[a];if(this.f)try{for(const u of this.J()){if(!u.name||!(0,s.$le)(u.name)||!u.location){this.t.warn("Skipping the invalid stored profile",u.location||u.name);continue}l.push(t((0,R.$dg)(u.location),u.name,u.location,this.g,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags},a))}}catch(u){this.t.error(u)}const v=new k.$xi,E=new Map;if(l.length)try{const u=this.M();if(u.workspaces)for(const[h,w]of Object.entries(u.workspaces)){const L=A.URI.parse(h),O=l.find(N=>N.id===w);O&&v.set(L,O)}if(u.emptyWindows)for(const[h,w]of Object.entries(u.emptyWindows)){const L=l.find(O=>O.id===w);L&&E.set(h,L)}}catch(u){this.t.error(u)}this.u={profiles:l,workspaces:v,emptyWindows:E}}return this.u}w(){const a=t("__default__profile__",(0,m.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...a,extensionsResource:this.O()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",v=new RegExp(`${(0,i.$sd)(l)}\\s(\\d+)`);let E=0;for(const h of this.profiles){const w=v.exec(h.name),L=w?parseInt(w[1]):0;E=L>E?L:E}const u=`${l} ${E+1}`;return this.createProfile((0,C.$ni)((0,r.$6e)()).toString(16),u,{transient:!0},a)}async createNamedProfile(a,l,v){return this.createProfile((0,C.$ni)((0,r.$6e)()).toString(16),a,l,v)}async createProfile(a,l,v,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=await this.y(a,l,v);return E&&await this.setProfileForWorkspace(E,u),u}async y(a,l,v){if(!(0,s.$le)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.l.get(l);return E||(E=(async()=>{try{const u=this.profiles.find(L=>L.name===l||L.id===a);if(u)return u;const h=t(a,l,(0,R.$gg)(this.profilesHome,a),this.g,v,this.defaultProfile);await this.r.createFolder(h.location);const w=[];return this.i.fire({profile:h,join(L){w.push(L)}}),await y.Promises.settled(w),this.D([h],[],[]),h}finally{this.l.delete(l)}})(),this.l.set(l,E)),E}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(E=>E.id===a.id);if(!v)throw new Error(`Profile '${a.name}' does not exist`);return v=t(v.id,l.name??v.name,v.location,this.g,{shortName:l.shortName??v.shortName,transient:l.transient??v.isTransient,useDefaultFlags:l.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.D([],[],[v]),v}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(E=>E.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const v=[];this.j.fire({profile:l,join(E){v.push(E)}});try{await Promise.allSettled(v)}catch(E){this.t.error(E)}for(const E of[...this.v.emptyWindows.keys()])l.id===this.v.emptyWindows.get(E)?.id&&this.v.emptyWindows.delete(E);for(const E of[...this.v.workspaces.keys()])l.id===this.v.workspaces.get(E)?.id&&this.v.workspaces.delete(E);this.H(),this.D([],[l],[]);try{await this.r.del(l.cacheHome,{recursive:!0})}catch(E){(0,$.$hk)(E)!==1&&this.t.error(E)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(E=>E.id===l.id);if(!v)throw new Error(`Profile '${l.name}' does not exist`);this.G(a,v)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(a,void 0,l)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const a=await this.r.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(v=>!this.s.extUri.isEqual(v.location,l.resource))).map(l=>this.r.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.m.profiles.filter(l=>!this.C(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.z(a);return A.URI.isUri(l)?this.m.workspaces.get(l)??this.v.workspaces.get(l):this.m.emptyWindows.get(l)??this.v.emptyWindows.get(l)}z(a){return(0,p.$Jh)(a)?a.uri:(0,p.$Oh)(a)?a.configPath:a.id}C(a){return!!([...this.m.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,a.location))||[...this.m.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,a.location))||[...this.v.emptyWindows.values()].some(l=>this.s.extUri.isEqual(l.location,a.location))||[...this.v.workspaces.values()].some(l=>this.s.extUri.isEqual(l.location,a.location)))}D(a,l,v){const E=[...this.profiles,...a],u=[];this.m.profiles=[];for(let h of E)h.isDefault||l.some(w=>h.id===w.id)||(h=v.find(w=>h.id===w.id)??h,h.isTransient?this.m.profiles.push(h):u.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.L(u),this.u=void 0,this.F(a,l,v)}F(a,l,v){this.h.fire({added:a,removed:l,updated:v,all:this.profiles})}G(a,l,v){v=l?.isTransient?!0:v,v||this.G(a,void 0,!0);const E=this.z(a),u=v?this.m:this.v;A.URI.isUri(E)?(u.workspaces.delete(E),l&&u.workspaces.set(E,l)):(u.emptyWindows.delete(E),l&&u.emptyWindows.set(E,l)),v||this.H()}H(){const a={};for(const[v,E]of this.v.workspaces.entries())a[v.toString()]=E.id;const l={};for(const[v,E]of this.v.emptyWindows.entries())l[v.toString()]=E.id;this.N({workspaces:a,emptyWindows:l}),this.u=void 0}I(a){const l={},v=this.w();if(a.workspaces)for(const[u,h]of Object.entries(a.workspaces)){const w=A.URI.parse(h);l[u]=this.s.extUri.isEqual(w,v.location)?v.id:this.s.extUri.basename(w)}const E={};if(a.emptyWindows)for(const[u,h]of Object.entries(a.emptyWindows)){const w=A.URI.parse(h);E[u]=this.s.extUri.isEqual(w,v.location)?v.id:this.s.extUri.basename(w)}return{workspaces:l,emptyWindows:E}}J(){return[]}L(a){throw new Error("not implemented")}M(){return{}}N(a){throw new Error("not implemented")}O(){}};e.$Fk=o,e.$Fk=o=Ke([Be(0,S.$Gh),Be(1,$.$4j),Be(2,D.$Ak),Be(3,I.$3i)],o);class c extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(a){this.a=a}M(){return this.R}N(a){this.R=a}}e.$Gk=c}),define(De[260],Ce([1,0,11,4,3,53,18,184,5,259]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo="__$__isNewStorageMarker",e.$Ro="__$__targetStorageMarker",e.$So=(0,S.$zh)("storageService");var P;(function(s){s[s.NONE=0]="NONE",s[s.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var I;(function(s){s[s.APPLICATION=-1]="APPLICATION",s[s.PROFILE=0]="PROFILE",s[s.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(s){s[s.USER=0]="USER",s[s.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function k(s){const d=s.get(e.$Ro);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$To=k;class D extends f.$mb{static{this.a=60*1e3}constructor(d={flushInterval:D.a}){super(),this.j=d,this.b=this.B(new T.$kc),this.c=this.B(new T.$kc),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$hc),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Qg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new f.$nb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(d,b,g){return T.Event.filter(this.b.event,t=>t.scope===d&&(b===void 0||t.key===b),g)}k(){this.i.value=(0,C.$Ug)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,f.$hb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,b){const{key:g,external:t}=b;if(g===e.$Ro){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:g,target:this.F(d)[g],external:t})}r(d){this.f.fire({reason:d})}get(d,b,g){return this.L(b)?.get(d,g)}getBoolean(d,b,g){return this.L(b)?.getBoolean(d,g)}getNumber(d,b,g){return this.L(b)?.getNumber(d,g)}getObject(d,b,g){return this.L(b)?.getObject(d,g)}storeAll(d,b){this.t(()=>{for(const g of d)this.store(g.key,g.value,g.scope,g.target,b)})}store(d,b,g,t,o=!1){if((0,A.$ue)(b)){this.remove(d,g,o);return}this.t(()=>{this.u(d,g,t),this.L(g)?.set(d,b,o)})}remove(d,b,g=!1){this.t(()=>{this.u(d,b,void 0),this.L(b)?.delete(d,g)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,b){const g=[],t=this.F(d);for(const o of Object.keys(t))t[o]===b&&g.push(o);return g}u(d,b,g,t=!1){const o=this.F(b);typeof g=="number"?o[d]!==g&&(o[d]=g,this.L(b)?.set(e.$Ro,JSON.stringify(o),t)):typeof o[d]=="number"&&(delete o[d],this.L(b)?.set(e.$Ro,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const b=this.L(d);return b?k(b):Object.create(null)}isNew(d){return this.getBoolean(e.$Qo,d)===!0}async flush(d=P.NONE){this.f.fire({reason:d});const b=this.L(-1),g=this.L(0),t=this.L(1);switch(d){case P.NONE:await C.Promises.settled([b?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await C.Promises.settled([b?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,b=this.L(0)?.items??new Map,g=this.L(1)?.items??new Map;return i(d,b,g,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async optimize(d){return await this.flush(),this.L(d)?.optimize()}async switch(d,b){return this.r(P.NONE),(0,$.$Bk)(d)?this.N(d,b):this.O(d,b)}H(d,b){return!(d.id===b.id||y(b)&&y(d))}I(d,b,g){this.t(()=>{const t=new Set;for(const[o,c]of d)t.add(o),b.get(o)!==c&&this.n(g,{key:o,external:!0});for(const[o]of b.items)t.has(o)||this.n(g,{key:o,external:!0})})}}e.$Uo=D;function y(s){return s.isDefault||!!s.useDefaultFlags?.globalState}e.$Vo=y;class r extends D{constructor(){super(),this.p=this.B(new m.$Oo(new m.$Po,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new m.$Oo(new m.$Po,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new m.$Oo(new m.$Po,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}l(){return!1}hasScope(d){return!1}}e.$Wo=r;async function i(s,d,b,g,t,o){const c=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,a=new Map;s.forEach((L,O)=>{n.set(O,L),a.set(O,c(L))});const l=new Map,v=new Map;d.forEach((L,O)=>{l.set(O,L),v.set(O,c(L))});const E=new Map,u=new Map;b.forEach((L,O)=>{E.set(O,L),u.set(O,c(L))}),console.group(g!==t?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const h=[];if(n.forEach((L,O)=>{h.push({key:O,value:L})}),console.table(h),console.groupEnd(),console.log(a),g!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];l.forEach((O,N)=>{L.push({key:N,value:O})}),console.table(L),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${o})`);const w=[];E.forEach((L,O)=>{w.push({key:O,value:L})}),console.table(w),console.groupEnd(),console.log(u)}e.$Xo=i}),define(De[87],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Gac=C}),define(De[54],Ce([1,0,17,24,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=void 0;class R{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new T.$8f(m=>{const S=this.b.get(m.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(m,S){S===null?this.b.delete(m.scheme):this.b.set(m.scheme,S)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Iac=R,e.$Jac=(0,f.$zh)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=void 0,e.$$L=(0,C.$zh)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,14,241,26]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;let A=class extends f.$fN{constructor(S,$,P){const I=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",p=P.remote.isRemote?(0,C.localize)(0,null):S?(0,C.localize)(1,null):(0,C.localize)(2,null);super($.createLogger(I,{name:p}))}};e.$Pcc=A,e.$Pcc=A=Ke([Be(1,T.$4i),Be(2,R.$$L)],A)}),define(De[262],Ce([1,0,11]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=e.$_ac=void 0;class T{constructor(A,m,S){this.h=new Map,this.a=A,this.b=m,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new C.$Qg(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of $.values())P.complete()}catch(P){for(const I of $.values())I.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let S=this.f[A];return typeof S>"u"&&(S=m),S}update(A,m){this.f[A]=m;const S=this.h.get(A);if(S!==void 0)return S.p;const $=new C.$Zg;return this.h.set(A,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$_ac=T;class f extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$abc=f}),define(De[263],Ce([1,0,4,2]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class f{constructor(A){this.c=A,this.a=new C.$hc,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$hc,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,S,$){const I=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(m.value,S,$);this.b.fire(I)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$ycc=f}),define(De[20],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=void 0,e.$UL=(0,C.$zh)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$VL=T}),define(De[264],Ce([1,0,25,4]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class f{#e;constructor(A,m){this.b=new T.$hc,this.onDidChange=this.b.event,this.a=C.$Tl.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$lbc=f}),define(De[66],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=e.$Tac=void 0,e.$Tac=(0,C.$zh)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Uac=T}),define(De[265],Ce([1,0,22]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybb=e.$Xbb=void 0;class T{constructor(){this.buffers=[]}add(S){let $=this.buffers.indexOf(S);return $<0&&($=this.buffers.length,this.buffers.push(S)),$}}function f(m,S){if(S.serializeBuffersForPostMessage){const $=new T,I=JSON.stringify(m,(k,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D)};if(ArrayBuffer.isView(D)){const y=R(D);if(y)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D.buffer),view:{type:y,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=$.buffers.map(k=>{const D=new Uint8Array(k);return C.$Hc.wrap(D)});return{message:I,buffers:p}}else return{message:JSON.stringify(m),buffers:[]}}e.$Xbb=f;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,S){const $=S.map(p=>{const k=new ArrayBuffer(p.byteLength);return new Uint8Array(k).set(p.buffer),k}),P=S.length?(p,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const D=k,{index:y}=D,r=$[y];if(D.view)switch(D.view.type){case 1:return new Int8Array(r,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return k}:void 0;return{message:JSON.parse(m,P),arrayBuffers:$}}e.$Ybb=A}),define(De[266],Ce([1,0,267,373,374,60,2,375]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;const S=!1;function $(s,d,b,g,t,o){const c=o.environment.useHostProxy,n=typeof c=="boolean"?c:!o.remote.isRemote,a={resolveProxy:E=>s.resolveProxy(E),lookupProxyAuthorization:y.bind(void 0,g,t,d,{},o.remote.isRemote),getProxyURL:()=>d.getConfiguration("http").get("proxy"),getProxySupport:()=>d.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(d),getSystemCertificatesV2:()=>p(d),log:(E,u,...h)=>{switch(E){case m.LogLevel.Trace:g.trace(u,...h);break;case m.LogLevel.Debug:g.debug(u,...h);break;case m.LogLevel.Info:g.info(u,...h);break;case m.LogLevel.Warning:g.warn(u,...h);break;case m.LogLevel.Error:g.error(u,...h);break;case m.LogLevel.Critical:g.error(u,...h);break;case m.LogLevel.Off:break;default:w(E,u,h);break}function w(L,O,...N){g.error("Unknown log level",L),g.error(O,...N)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:n,addCertificates:[],env:process.env},l=(0,m.createProxyResolver)(a),v=P(a,l);return D(b,v)}e.$ldc=$;function P(s,d){return{http:Object.assign(C,(0,m.createHttpPatch)(s,C,d)),https:Object.assign(T,(0,m.createHttpPatch)(s,T,d)),net:Object.assign(R,(0,m.createNetPatch)(s,R)),tls:Object.assign(f,(0,m.createTlsPatch)(s,f))}}function I(s){const d=s.getConfiguration("http");return!d.get("experimental.systemCertificatesV2",S)&&!!d.get("systemCertificates")}function p(s){const d=s.getConfiguration("http");return!!d.get("experimental.systemCertificatesV2",S)&&!!d.get("systemCertificates")}const k=new Map;function D(s,d){return s.getExtensionPathIndex().then(b=>{const g=globalThis._VSCODE_NODE_MODULES.module,t=g._load;g._load=function(c,n,a){if(c==="net")return d.net;if(c==="tls")return d.tls;if(c!=="http"&&c!=="https")return t.apply(this,arguments);const l=b.findSubstr(A.URI.file(n.filename));let v=k.get(l);if(v||k.set(l,v={}),!v[c]){const E=d[c];v[c]={...E}}return v[c]}})}async function y(s,d,b,g,t,o,c,n){const a=g[o];c&&(g[o]=c),s.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${a}`);const l=c||a,v=Array.isArray(l)?l:typeof l=="string"?[l]:[];if(i(d,v,t),v.some(E=>/^(Negotiate|Kerberos)( |$)/i.test(E))&&!n.kerberosRequested)try{n.kerberosRequested=!0;const E=await new Promise((O,N)=>{be(["kerberos"],O,N)}),u=new URL(o),h=b.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${u.hostname}`:`HTTP@${u.hostname}`);return s.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${h}`),"Negotiate "+await(await E.initializeClient(h)).step("")}catch(E){s.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",E)}}let r=!1;function i(s,d,b){r||!d.length||(r=!0,s.$publicLog2("proxyAuthenticationRequest",{authenticationType:d.map(g=>g.split(" ")[0]).join(","),extensionHostType:b?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;function T(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function f(R){return new C.$zm(T(R))}e.$nr=f}),define(De[139],Ce([1,0,216,18,2,3,5,42,30,17,46,176,38]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.$1E=e.EditorsOrder=e.$ZE=e.CloseDirection=e.$YE=e.$XE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorInputCapabilities=e.$OE=e.SaveReason=e.Verbosity=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=void 0,e.$CE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$DE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$EE="workbench.editor.sidebysideEditor",e.$FE="workbench.editors.textDiffEditor",e.$GE="workbench.editors.binaryResourceDiffEditor";var k;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var D;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function y(ae){const te=ae;return!!te&&typeof te.getSelection=="function"&&!!te.onDidChangeSelection}e.$HE=y;function r(ae,te,X){for(const U of X.visibleEditorPanes)if(U.group.id===te&&ae.matches(U.input))return U.getViewState()}e.$IE=r;function i(ae){if(l(ae))return!1;const te=ae;return f.URI.isUri(te?.resource)}e.$JE=i;function s(ae){if(l(ae))return!1;const te=ae;return te?.original!==void 0&&te.modified!==void 0}e.$KE=s;function d(ae){if(l(ae)||s(ae))return!1;const te=ae;return te?.primary!==void 0&&te.secondary!==void 0}e.$LE=d;function b(ae){if(l(ae))return!1;const te=ae;return te?te.resource===void 0||te.resource.scheme===$.Schemas.untitled||te.forceUntitled===!0:!1}e.$ME=b;function g(ae){if(l(ae))return!1;const te=ae;return f.URI.isUri(te?.base?.resource)&&f.URI.isUri(te?.input1?.resource)&&f.URI.isUri(te?.input2?.resource)&&f.URI.isUri(te?.result?.resource)}e.$NE=g;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var o;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class c{constructor(){this.a=new Map}registerSource(te,X){let U=this.a.get(te);return U||(U={source:te,label:X},this.a.set(te,U)),U.source}getSourceLabel(te){return this.a.get(te)?.label??te}}e.$OE=new c;var n;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(n||(e.EditorInputCapabilities=n={}));class a extends R.$mb{}e.$PE=a;function l(ae){return ae instanceof a}e.$QE=l;function v(ae){const te=ae;return f.URI.isUri(te?.preferredResource)}function E(ae){const te=ae;return l(te?.primary)&&l(te?.secondary)}e.$RE=E;function u(ae){const te=ae;return l(te?.modified)&&l(te?.original)}e.$SE=u;function h(ae,te,X,U,q){return me(U,[(0,I.$ji)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const G={...X,limits:{size:Number.MAX_VALUE}};ae.openEditor(te,G)}}),(0,I.$ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$TE=h;function w(ae){return l(ae?.editor)}e.$UE=w;function L(ae){const te=ae;return w(ae)&&te?.group!==void 0}e.$VE=L;function O(ae){const te=ae;return typeof te?.groupId=="number"&&l(te.editor)}e.$WE=O;var N;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var M;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var z;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class j{getOriginalUri(te,X){if(!te)return;if(g(te))return e.$YE.getOriginalUri(te.result,X);if(X?.supportSideBySide){const{primary:q,secondary:G}=this.a(te);if(q&&G){if(X?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===z.ANY)return this.getOriginalUri(q,{filterByScheme:X.filterByScheme})??this.getOriginalUri(G,{filterByScheme:X.filterByScheme});te=X.supportSideBySide===z.PRIMARY?q:G}}if(s(te)||d(te)||g(te))return;const U=v(te)?te.preferredResource:te.resource;return!U||!X||!X.filterByScheme?U:this.b(U,X.filterByScheme)}a(te){return E(te)||d(te)?{primary:te.primary,secondary:te.secondary}:u(te)||s(te)?{primary:te.modified,secondary:te.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(te,X){if(!te)return;if(g(te))return e.$YE.getCanonicalUri(te.result,X);if(X?.supportSideBySide){const{primary:q,secondary:G}=this.a(te);if(q&&G){if(X?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===z.ANY)return this.getCanonicalUri(q,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:X.filterByScheme});te=X.supportSideBySide===z.PRIMARY?q:G}}if(s(te)||d(te)||g(te))return;const U=te.resource;return!U||!X||!X.filterByScheme?U:this.b(U,X.filterByScheme)}b(te,X){if(Array.isArray(X)){if(X.some(U=>te.scheme===U))return te}else if(X===te.scheme)return te}}var F;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function K(ae,te,X,U){if(!ae.isSticky(te))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return X===F.MOUSE||X===F.KEYBOARD;case"mouse":return X===F.MOUSE;case"keyboard":return X===F.KEYBOARD}return!1}e.$XE=K,e.$YE=new j;var H;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class $e{constructor(){this.c=new Map,this.d=new Map}start(te){const X=this.a=te.get(A.$yh);for(const[U,q]of this.c)this.e(U,q,X);this.c.clear()}e(te,X,U){const q=U.createInstance(X);this.d.set(te,q)}registerFileEditorFactory(te){if(this.b)throw new Error("Can only register one file editor factory.");this.b=te}getFileEditorFactory(){return(0,T.$we)(this.b)}registerEditorSerializer(te,X){if(this.c.has(te)||this.d.has(te))throw new Error(`A editor serializer with type ID '${te}' was already registered.`);return this.a?this.e(te,X,this.a):this.c.set(te,X),(0,R.$kb)(()=>{this.c.delete(te),this.d.delete(te)})}getEditorSerializer(te){return this.d.get(typeof te=="string"?te:te.typeId)}}m.$6m.add(e.$CE.EditorFactory,new $e);async function _(ae,te,X){return!ae||!ae.length?[]:await Promise.all(ae.map(async U=>{const q=f.URI.revive(U.fileUri);if(!q){X.info("Cannot resolve the path because it is not valid.",U);return}if(!await te.canHandleResource(q)){X.info("Cannot resolve the path because it cannot be handled",U);return}let ce=U.exists,re=U.type;if(typeof ce!="boolean"||typeof re!="number")try{re=(await te.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,ce=!0}catch(Ee){X.error(Ee),ce=!1}if(!ce&&U.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",U);return}if(re===S.FileType.Directory){X.info("Cannot resolve the path because it is a directory",U);return}const de={...U.options,pinned:!0};return ce?{resource:q,options:de}:{resource:q,options:de,forceUntitled:!0}}))}e.$ZE=_;var Q;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function V(ae){const te=ae;if(!te)return!1;const X=te;if(X.modified)return V(X.modified);const U=te;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$1E=V;function ee(ae){return(0,P.$li)(ae)}e.$2E=ee;function me(ae,te,X){const U=(0,P.$mi)(ae,te);return U.forceMessage=X?.forceMessage,U.forceSeverity=X?.forceSeverity,U.allowDialog=X?.allowDialog,U}e.$3E=me}),define(De[269],Ce([1,0,4,217,5,3,28,42,19,73,23,78,255]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0E=e.$9E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$8E=e.$7E=e.ViewContentGroups=e.$6E=e.$5E=e.ViewContainerLocation=e.Extensions=e.$4E=void 0,e.$4E=(0,p.$6u)("default-view-icon",I.$Nj.window,(0,T.localize)(0,null));var k;(function(c){c.ViewContainersRegistry="workbench.registry.view.containers",c.ViewsRegistry="workbench.registry.view"})(k||(e.Extensions=k={}));var D;(function(c){c[c.Sidebar=0]="Sidebar",c[c.Panel=1]="Panel",c[c.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.$5E=[0,1,2];function y(c){switch(c){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$6E=y;class r extends R.$mb{constructor(){super(...arguments),this.c=this.B(new C.$hc),this.onDidRegister=this.c.event,this.f=this.B(new C.$hc),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Kf)([...this.g.values()])}registerViewContainer(n,a,l){const v=this.get(n.id);if(v)return v;const E=n;return E.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$ui)(this.g,a,[]).push(E),l?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:a}),E}deregisterViewContainer(n){for(const a of this.g.keys()){const l=this.g.get(a),v=l?.indexOf(n);if(v!==-1){l?.splice(v,1),l.length===0&&this.g.delete(a),this.f.fire({viewContainer:n,viewContainerLocation:a});return}}}get(n){return this.all.filter(a=>a.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(l=>l?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(a=>this.getViewContainerLocation(a)===n)}}m.$6m.add(k.ViewContainersRegistry,new r);var i;(function(c){c.Open="2_open",c.Debug="4_debug",c.SCM="5_scm",c.More="9_more"})(i||(e.ViewContentGroups=i={}));function s(c,n){const a=c.group??i.More,l=n.group??i.More;return a!==l?a.localeCompare(l):(c.order??5)-(n.order??5)}class d extends R.$mb{constructor(){super(...arguments),this.c=this.B(new C.$hc),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$hc),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$hc),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$hc),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new $.$L}registerViews(n,a){this.registerViews2([{views:n,viewContainer:a}])}registerViews2(n){n.forEach(({views:a,viewContainer:l})=>this.l(a,l)),this.c.fire(n)}deregisterViews(n,a){const l=this.m(n,a);l.length&&this.f.fire({views:l,viewContainer:a})}moveViews(n,a){for(const l of this.j.keys())if(l!==a){const v=this.m(n,l);v.length&&(this.l(v,a),this.g.fire({views:v,from:l,to:a}))}}getViews(n){return this.j.get(n)||[]}getView(n){for(const a of this.i){const l=(this.j.get(a)||[]).filter(v=>v.id===n)[0];if(l)return l}return null}getViewContainer(n){for(const a of this.i)if((this.j.get(a)||[]).filter(v=>v.id===n)[0])return a;return null}registerViewWelcomeContent(n,a){return this.k.add(n,a),this.h.fire(n),(0,R.$kb)(()=>{this.k.delete(n,a),this.h.fire(n)})}registerViewWelcomeContent2(n,a){const l=new Map;for(const[v,E]of a)this.k.add(n,E),l.set(v,(0,R.$kb)(()=>{this.k.delete(n,E),this.h.fire(n)}));return this.h.fire(n),l}getViewWelcomeContent(n){const a=[];return this.k.forEach(n,l=>a.push(l)),a.sort(s)}l(n,a){let l=this.j.get(a);l||(l=[],this.j.set(a,l),this.i.push(a));for(const v of n){if(this.getView(v.id)!==null)throw new Error((0,T.localize)(1,null,v.id));l.push(v)}}m(n,a){const l=this.j.get(a);if(!l)return[];const v=[],E=[];for(const u of l)n.includes(u)?v.push(u):E.push(u);return v.length&&(E.length?this.j.set(a,E):(this.j.delete(a),this.i.splice(this.i.indexOf(a),1))),v}}m.$6m.add(k.ViewsRegistry,new d),e.$7E=(0,f.$zh)("viewsService"),e.$8E=(0,f.$zh)("viewDescriptorService");var b;(function(c){c[c.Default=0]="Default",c[c.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var g;(function(c){c[c.None=0]="None",c[c.Collapsed=1]="Collapsed",c[c.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class t{constructor(n,a){this.c=!1,this.d=!1,(0,P.$Wm)(this,n),this.d=!!a,this.resolve=async l=>{if(a&&!this.c){const v=await a(l);v&&(this.tooltip=this.tooltip??v.tooltip,this.command=this.command??v.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$9E=t;class o extends Error{constructor(n){super((0,T.localize)(2,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$0E=o}),define(De[140],Ce([1,0,4,11,218]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new C.$hc,this.n=new C.$hc,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,S,$,P){const I={command:m};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.s("request",I),typeof P=="number"){const p=setTimeout(()=>{clearTimeout(p);const k=this.f.get(I.seq);if(k){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,f.localize)(0,null,P,m)};k(D)}},P)}return $&&this.f.set(I.seq,$),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,S){return m.type!=="event"||S.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$Fg)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const S=m,$=this.f.get(S.request_seq);$&&(this.f.delete(S.request_seq),$(S));break}}}}s(m,S){S.type=m,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((S,$)=>m.set($,S)),await(0,T.$Fg)(500),m.forEach((S,$)=>{S({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$rcb=R}),define(De[270],Ce([1,0,219,41,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$jH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$iH=e.MemoryRangeType=e.$hH=e.State=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new T.$Zi("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$pG=new T.$Zi("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$qG=new T.$Zi("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$rG="debugUx",e.$sG=new T.$Zi(e.$rG,"default",{type:"string",description:C.localize(3,null)}),e.$tG=new T.$Zi("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$uG=new T.$Zi("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$vG=new T.$Zi("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$wG=new T.$Zi("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$xG=new T.$Zi("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$yG=new T.$Zi("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$zG=new T.$Zi("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$AG=new T.$Zi("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$BG=new T.$Zi("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$CG=new T.$Zi("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$DG=new T.$Zi("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$EG=new T.$Zi("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$FG=new T.$Zi("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$GG=new T.$Zi("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$HG=new T.$Zi("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$IG=new T.$Zi("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$JG=new T.$Zi("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$KG=new T.$Zi("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$LG=new T.$Zi("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$MG=new T.$Zi("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$NG=new T.$Zi("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$OG=new T.$Zi("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$PG=new T.$Zi("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$QG=new T.$Zi("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$RG=new T.$Zi("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$SG=new T.$Zi("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$TG=new T.$Zi("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$UG=new T.$Zi("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$VG=new T.$Zi("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$WG=new T.$Zi("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$XG=new T.$Zi("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$YG=new T.$Zi("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$ZG=new T.$Zi("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$1G=new T.$Zi("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$2G=new T.$Zi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$3G=new T.$Zi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$4G=new T.$Zi("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$5G=new T.$Zi("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$6G=new T.$Zi("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$7G=new T.$Zi("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$8G=new T.$Zi("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$9G=new T.$Zi("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$0G=new T.$Zi("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$$G=new T.$Zi("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$_G=new T.$Zi("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$aH=new T.$Zi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$bH=new T.$Zi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const R=p=>C.localize(51,null,p);e.$cH=R,e.$dH="editor.contrib.debug",e.$eH="editor.contrib.breakpoint",e.$fH="debug",e.$gH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(A||(e.State=A={}));function m(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$hH=m;var S;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$iH="vscode-debug-memory";var $;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var P;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$jH=(0,f.$zh)("debugService");var I;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,23,17,34,21,19]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const P=/{([^}]+)}/g;function I(E,u,h){return E.replace(P,function(w,L){return u&&L.length>0&&L[0]!=="_"?w:h&&h.hasOwnProperty(L)?h[L]:w})}e.$eF=I;function p(E){const u={};for(const h of Object.keys(E))h.startsWith("!")||(u[h]=E[h]);return u}e.$fF=p;function k(E){return E.configuration.request==="attach"&&!D(E)&&(!E.parentSession||k(E.parentSession))}e.$gF=k;function D(E){let u=E.configuration.type;if(u)return u==="vslsShare"&&(u=E.configuration.adapterProxy.configuration.type),(0,C.$Od)(u,"extensionhost")||(0,C.$Od)(u,"pwa-extensionhost")?E:E.parentSession?D(E.parentSession):void 0}e.$hF=D;function y(E){return E.type&&(E.label||E.program||E.runtime)}e.$iF=y;function r(E,u,h){let w,L=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=O.exec(E);){const M=N.index+1,z=M+N[0].length;if(M<=u&&z>=h){w=N[0],L=M;break}}if(w){const M=/\w+/g;let z=null;for(;(z=M.exec(w))&&!(z.index+1+L+z[0].length>=h););z&&(w=w.substring(0,M.lastIndex))}return w?{start:L,end:L+w.length-1}:{start:0,end:0}}e.$jF=r;async function i(E,u,h,w){if(E.evaluatableExpressionProvider.has(u)){const L=E.evaluatableExpressionProvider.ordered(u),O=(0,$.$Af)(await Promise.all(L.map(async N=>{try{return await N.provideEvaluatableExpression(u,h,w??S.CancellationToken.None)}catch{return}})));if(O.length>0){let N=O[0].expression;const M=O[0].range;return N||(N=u.getLineContent(h.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:N}}}else{const L=u.getLineContent(h.lineNumber),{start:O,end:N}=r(L,h.column,h.column),M=L.substring(O-1,N);return{matchingExpression:M,range:new m.$hs(h.lineNumber,O,h.lineNumber,O+M.length)}}return null}e.$kF=i;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(E){return!!(E&&E.match(s))}e.$lF=d;function b(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(d(E.path))return T.URI.parse(E.path);if((0,f.$0c)(E.path))return T.URI.file(E.path)}return E.path}function g(E){if(typeof E.path=="object"){const u=T.URI.revive(E.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return E.path}function t(E,u){const h=u?b:g,w=(0,R.$Tm)(E);return c(w,(L,O)=>{L&&O&&(O.path=h(O))}),w}e.$mF=t;function o(E,u){const h=u?b:g,w=(0,R.$Tm)(E);return c(w,(L,O)=>{!L&&O&&(O.path=h(O))}),w}e.$nF=o;function c(E,u){switch(E.type){case"event":{const h=E;switch(h.event){case"output":u(!1,h.body.source);break;case"loadedSource":u(!1,h.body.source);break;case"breakpoint":u(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=E;switch(h.command){case"setBreakpoints":u(!0,h.arguments.source);break;case"breakpointLocations":u(!0,h.arguments.source);break;case"source":u(!0,h.arguments.source);break;case"gotoTargets":u(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(w=>u(!1,w));break;default:break}break}case"response":{const h=E;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(w=>u(!1,w.source));break;case"loadedSources":h.body.sources.forEach(w=>u(!1,w));break;case"scopes":h.body.scopes.forEach(w=>u(!1,w.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(w=>u(!1,w.source));break;case"setBreakpoints":h.body.breakpoints.forEach(w=>u(!1,w.source));break;case"disassemble":h.body?.instructions.forEach(L=>u(!1,L.location));break;default:break}break}}}function n(E){return E.filter(u=>!u.presentation?.hidden).sort((u,h)=>u.presentation?h.presentation?u.presentation.group?h.presentation.group?u.presentation.group!==h.presentation.group?u.presentation.group.localeCompare(h.presentation.group):a(u.presentation.order,h.presentation.order):-1:h.presentation.group?1:a(u.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.$oF=n;function a(E,u){return typeof E!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:E-u}async function l(E,u){const h=E.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(h!=="none"&&(await u.saveAll(),h==="allEditorsInActiveGroup")){const w=u.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:w.input,groupId:w.group.id})}await E.reloadConfiguration()}e.$pF=l;const v=(E,u)=>!E||!u?E===u:E.name===u.name&&E.path===u.path&&E.sourceReference===u.sourceReference;e.$qF=v}),define(De[272],Ce([1,0,48,60,23,16,12,15,29,220,140]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;class I extends P.$rcb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(i,s){this.p=s,this.r=Buffer.allocUnsafe(0),this.t=-1,i.on("data",d=>this.w(d))}sendMessage(i){if(this.p){const s=JSON.stringify(i);this.p.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${I.a}${s}`,"utf8")}}w(i){for(this.r=Buffer.concat([this.r,i]);;){if(this.t>=0){if(this.r.length>=this.t){const s=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(d){this.m.fire(new Error((d.message||d)+`
`+s))}continue}}else{const s=this.r.indexOf(I.a);if(s!==-1){const b=this.r.toString("utf8",0,s).split(I.b);for(const g of b){const t=g.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(s+I.a.length);continue}}break}}}e.$Vcc=I;class p extends I{startSession(){return new Promise((i,s)=>{let d=!1;this.x=this.y(()=>{this.v(this.x,this.x),i(),d=!0}),this.x.on("close",()=>{d?this.m.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.x.on("error",b=>{d?this.m.fire(b):s(b)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Wcc=p;class k extends p{constructor(i){super(),this.z=i}y(i){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",i)}}e.$Xcc=k;class D extends p{constructor(i){super(),this.z=i}y(i){return T.createConnection(this.z.path,i)}}e.$Ycc=D;class y extends I{constructor(i,s){super(),this.y=i,this.z=s}async startSession(){const i=this.y.command,s=this.y.args,d=this.y.options||{};try{if(i)if(R.$0c(i)){if(!await S.Promises.exists(i))throw new Error($.localize(0,null,i))}else i.indexOf("/")<0&&i.indexOf("\\")<0;else throw new Error($.localize(1,null,this.z));let b=process.env;if(d.env&&Object.keys(d.env).length>0&&(b=f.$Wm(f.$Tm(process.env),d.env)),i==="node")if(Array.isArray(s)&&s.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:b,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(t.cwd=d.cwd);const o=C.fork(s[0],s.slice(1),t);if(!o.pid)throw new Error($.localize(2,null,s[0]));this.x=o}else throw new Error($.localize(3,null));else{const g={env:b};d.cwd&&(g.cwd=d.cwd),this.x=C.spawn(i,s,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,t)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(b){this.m.fire(b)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((i,s)=>{const d=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(b,g,t){if(b)return s(b)});d.on("exit",i),d.on("error",s)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(i,s){if(!i)return;const d=Object.create(null);i.runtime&&(i.runtime.indexOf("./")===0?d.runtime=R.$$c(s,i.runtime):d.runtime=i.runtime),i.runtimeArgs&&(d.runtimeArgs=i.runtimeArgs),i.program&&(R.$0c(i.program)?d.program=i.program:d.program=R.$$c(s,i.program)),i.args&&(d.args=i.args);const b=i;return b.win&&(d.win=y.A(b.win,s)),b.winx86&&(d.winx86=y.A(b.winx86,s)),b.windows&&(d.windows=y.A(b.windows,s)),b.osx&&(d.osx=y.A(b.osx,s)),b.linux&&(d.linux=y.A(b.linux,s)),d}static platformAdapterExecutable(i,s){let d=Object.create(null);s=s.toLowerCase();for(const n of i)if(n.contributes){const a=n.contributes.debuggers;a&&a.length>0&&a.filter(l=>typeof l.type=="string"&&m.$Od(l.type,s)).forEach(l=>{const v=y.A(l,n.extensionLocation.fsPath);d=f.$Wm(d,v,n.isBuiltin)})}let b;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?b=d.winx86||d.win||d.windows:A.$i?b=d.win||d.windows:A.$j?b=d.osx:A.$k&&(b=d.linux),b=b||d;const g=b.program||d.program,t=b.args||d.args,o=b.runtime||d.runtime,c=b.runtimeArgs||d.runtimeArgs;if(o)return{type:"executable",command:o,args:(c||[]).concat(typeof g=="string"?[g]:[]).concat(t||[])};if(g)return{type:"executable",command:g,args:t||[]}}}e.$Zcc=y}),define(De[273],Ce([1,0,48,32,12]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0;function R($,P){return new Promise((I,p)=>{let k="";const D=C.spawn($,P);D.pid&&D.stdout.on("data",y=>{k+=y.toString()}),D.on("error",y=>{p(y)}),D.on("close",y=>{I(k)})})}async function A($){if($)if(f.$i){const P=await new Promise((I,p)=>{be(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{P.getProcessTree($,p=>{I(!!p&&p.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String($)]).then(P=>{const I=P.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},P=>!0);return Promise.resolve(!0)}e.$1cc=A;var m;(function($){$[$.cmd=0]="cmd",$[$.powershell=1]="powershell",$[$.bash=2]="bash"})(m||(m={}));function S($,P,I,p,k){$=$.trim().toLowerCase();let D;$.indexOf("powershell")>=0||$.indexOf("pwsh")>=0?D=1:$.indexOf("cmd.exe")>=0?D=0:$.indexOf("bash")>=0?D=2:f.$i?D=0:D=2;let y,r=" ";switch(D){case 1:if(y=i=>(i=i.replace(/\'/g,"''"),i.length>0&&i.charAt(i.length-1)==="\\"?`'${i}\\'`:`'${i}'`),p){const i=(0,T.$Pe)(p);i&&(r+=`${i}:; `),r+=`cd ${y(p)}; `}if(k)for(const i in k){const s=k[i];s===null?r+=`Remove-Item env:${i}; `:r+=`\${env:${i}}='${s}'; `}if(P.length>0){const i=P.shift(),s=I?i:y(i);r+=s[0]==="'"?`& ${s} `:`${s} `;for(const d of P)r+=d==="<"||d===">"||I?d:y(d),r+=" "}break;case 0:if(y=i=>(i=i.replace(/\"/g,'""'),i=i.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(s=>i.includes(s))||i.length===0?`"${i}"`:i),p){const i=(0,T.$Pe)(p);i&&(r+=`${i}: && `),r+=`cd ${y(p)} && `}if(k){r+='cmd /C "';for(const i in k){let s=k[i];s===null?r+=`set "${i}=" && `:(s=s.replace(/[&^|<>]/g,d=>`^${d}`),r+=`set "${i}=${s}" && `)}}for(const i of P)r+=i==="<"||i===">"||I?i:y(i),r+=" ";k&&(r+='"');break;case 2:{y=s=>(s=s.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),s.length===0?'""':s);const i=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(p&&(r+=`cd ${y(p)} ; `),k){r+="/usr/bin/env";for(const s in k){const d=k[s];d===null?r+=` -u ${i(s)}`:r+=` ${i(`${s}=${d}`)}`}r+=" "}for(const s of P)r+=s==="<"||s===">"||I?s:y(s),r+=" ";break}}return r}e.$2cc=S}),define(De[108],Ce([1,0,22,35,50,98,17,16,12,41]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2H=e.$1H=e.$ZH=e.$YH=e.CellStatusbarAlignment=e.$XH=e.$WH=e.$VH=e.NotebookEditorPriority=e.$UH=e.$TH=e.$SH=e.$RH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$QH=e.$PH=e.$OH=e.$NH=e.CellKind=e.$MH=e.$LH=e.$KH=void 0,e.$KH="workbench.editor.notebook",e.$LH="workbench.editor.notebookTextDiffEditor",e.$MH="workbench.editor.interactive";var P;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(P||(e.CellKind=P={})),e.$NH=["application/json","application/javascript","text/html","image/svg+xml",R.$Er.latex,R.$Er.markdown,"image/png","image/jpeg",R.$Er.text],e.$OH=[R.$Er.latex,R.$Er.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Er.text],e.$PH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$QH="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var p;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var k;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var D;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var y;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(y||(e.RendererMessagingSpec=y={}));var r;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var s;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(s||(e.CellEditType=s={}));var d;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${K.join("")}]+`),$e=7;function _(te,X){const U=X.toString($e),G=`${U.length<K.length?K[U.length-1]:"z"}${U}s${(0,C.$2c)(C.$Hc.fromString(te.scheme),!0,!0)}`;return te.with({scheme:F.scheme,fragment:G})}F.generate=_;function Q(te){if(te.scheme!==F.scheme)return;const X=te.fragment.indexOf("s");if(X<0)return;const U=parseInt(te.fragment.substring(0,X).replace(H,""),$e),q=(0,C.$1c)(te.fragment.substring(X+1)).toString();if(!isNaN(U))return{handle:U,notebook:te.with({scheme:q,fragment:null})}}F.parse=Q;function V(te,X){return te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${te.scheme!==A.Schemas.file?te.scheme:""}`})}F.generateCellOutputUri=V;function ee(te){if(te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!X)return;const U=X[1]&&X[1]!==""?X[1]:void 0,q=X[2];return{outputId:U,notebook:te.with({scheme:q||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=ee;function me(te,X,U){return F.generate(te,X).with({scheme:U})}F.generateCellPropertyUri=me;function ae(te,X){if(te.scheme===X)return F.parse(te.with({scheme:F.scheme}))}F.parseCellPropertyUri=ae})(d||(e.CellUri=d={}));const b=F=>S.$i?F.replace(/\//g,"\\"):F;class g{constructor(K=[],H=e.$NH){this.e=H,this.d=[...new Set(K)].map($e=>({pattern:$e,matches:T.$pj(b($e))}))}sort(K){const H=new Map(f.Iterable.map(K,_=>[_,b(_)]));let $e=[];for(const{matches:_}of this.d)for(const[Q,V]of H)if(_(V)){$e.push(Q),H.delete(Q);break}return H.size&&($e=$e.concat([...H.keys()].sort((_,Q)=>this.e.indexOf(_)-this.e.indexOf(Q)))),$e}prioritize(K,H){const $e=this.f(K);if($e===-1){this.d.unshift({pattern:K,matches:T.$pj(b(K))});return}const _=new Set(H.map(V=>this.f(V,$e)));_.delete(-1);const Q=Array.from(_).sort();this.d.splice($e+1,0,...Q.map(V=>this.d[V]));for(let V=Q.length-1;V>=0;V--)this.d.splice(Q[V],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,H=this.d.length){const $e=b(K);for(let _=0;_<H;_++)if(this.d[_].matches($e))return _;return-1}}e.$RH=g;function t(F,K,H,$e=(_,Q)=>_===Q){const _=[];function Q(me,ae,te){if(ae===0&&te.length===0)return;const X=_[_.length-1];X&&X.start+X.deleteCount===me?(X.deleteCount+=ae,X.toInsert.push(...te)):_.push({start:me,deleteCount:ae,toInsert:te})}let V=0,ee=0;for(;;){if(V===F.length){Q(V,0,K.slice(ee));break}if(ee===K.length){Q(V,F.length-V,[]);break}const me=F[V],ae=K[ee];if($e(me,ae)){V+=1,ee+=1;continue}H(ae)?(Q(V,1,[]),V+=1):(Q(V,0,[ae]),ee+=1)}return _}e.$SH=t,e.$TH=new $.$Zi("notebookEditorCursorAtBoundary","none"),e.$UH=new $.$Zi("notebookEditorCursorAtLineBoundary","none");var o;(function(F){F.default="default",F.option="option"})(o||(e.NotebookEditorPriority=o={}));function c(F){const K=F;return!!((typeof K.include=="string"||T.$qj(K.include))&&(typeof K.exclude=="string"||T.$qj(K.exclude)))}e.$VH=c;function n(F,K,H){if(Array.isArray(F.viewType)&&F.viewType.indexOf(K)>=0||F.viewType===K)return!0;if(F.filenamePattern){const $e=c(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,_=c(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$oj($e,(0,m.$cd)(H.fsPath).toLowerCase()))return!(_&&T.$oj(_,(0,m.$cd)(H.fsPath).toLowerCase()))}return!1}e.$WH=n,e.$XH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var a;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(a||(e.CellStatusbarAlignment=a={}));class l{static{this.d="notebook/"}static create(K){return`${l.d}${K}`}static parse(K){if(K.startsWith(l.d))return K.substring(l.d.length)}}e.$YH=l;function v(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$ZH=v;const E=new TextDecoder;function u(F){const K=[];let H=!1;for(const V of F)(K.length===0||H)&&(K.push(V),H=!0);let $e=L(K);const _=C.$Hc.concat(K.map(V=>C.$Hc.wrap(V))),Q=j(_);return $e=$e||Q.byteLength!==_.byteLength,{data:Q,didCompression:$e}}e.$1H=u,e.$2H=`${String.fromCharCode(27)}[A`;const h=e.$2H.split("").map(F=>F.charCodeAt(0)),w=10;function L(F){let K=!1;return F.forEach((H,$e)=>{if($e===0||H.length<e.$2H.length)return;const _=F[$e-1],Q=H.subarray(0,e.$2H.length);if(Q[0]===h[0]&&Q[1]===h[1]&&Q[2]===h[2]){const V=_.lastIndexOf(w);if(V===-1)return;K=!0,F[$e-1]=_.subarray(0,V),F[$e]=H.subarray(e.$2H.length)}}),K}function O(F){let K=F;do F=K,K=F.replace(/[^\n]\x08/gm,"");while(K.length<F.length);return F}function N(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const K=F.match(/^(.*)\r+/m)[1];let H=F.match(/\r+(.*)$/m)[1];H=H+K.slice(H.length,K.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return F}const M="\b".charCodeAt(0),z="\r".charCodeAt(0);function j(F){return!F.buffer.includes(M)&&!F.buffer.includes(z)?F:C.$Hc.fromString(N(O(E.decode(F.buffer))))}}),define(De[7],Ce([1,0,19,8,79,28,98,15,18,2,31,25,30,64,108]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D){"use strict";var y,r,i,s,d,b,g,t,o,c,n,a,l,v,E,u,h,w;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$JL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.TestRunProfileKind=e.TestResultState=e.$qL=e.$pL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oL=e.$nL=e.$mL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.ColorThemeKind=e.$fL=e.$eL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dL=e.DebugConsoleMode=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$0K=e.$9K=e.FileChangeType=e.$8K=e.$7K=e.$6K=e.$5K=e.InlineCompletionTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.ConfigurationTarget=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$HK=e.ViewBadge=e.ProgressLocation=e.$GK=e.$FK=e.TaskScope=e.ShellQuoting=e.$EK=e.$DK=e.$CK=e.TaskPanelKind=e.TaskRevealKind=e.$BK=e.TerminalLocation=e.$AK=e.$zK=e.$yK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$xK=e.$wK=e.$vK=e.$uK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$tK=e.StatusBarAlignment=e.ViewColumn=e.$sK=e.$rK=e.$qK=e.$pK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$oK=e.$nK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.LanguageStatusSeverity=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.CodeActionTriggerKind=e.$aK=e.$_J=e.SymbolTag=e.SymbolKind=e.$$J=e.DocumentHighlightKind=e.$0J=e.$9J=e.$8J=e.$7J=e.DiagnosticSeverity=e.DiagnosticTag=e.$6J=e.$5J=e.FileEditType=e.$4J=e.$3J=e.$2J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(J){return Object.assign(J,{apply:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(J,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(J,[]);{const[Re,...Ze]=ve;return Reflect.construct(J,Ze,Re.constructor)}}})}var O;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(O||(e.TerminalOutputAnchor=O={}));var N;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let M=y=class{static from(...W){let ve=W;return new y(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$UJ=M,e.$UJ=M=y=Ke([L],M);let z=r=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ze=W[Re];Ze.isBefore(ve)&&(ve=Ze)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ze=W[Re];Ze.isAfter(ve)&&(ve=Ze)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof r)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof r)return W;if(this.isPosition(W))return new r(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,T.$5)("line must be non-negative");if(ve<0)throw(0,T.$5)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,T.$5)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new r(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,T.$5)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new r(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$VJ=z,e.$VJ=z=r=Ke([L],z);let j=i=class{static isRange(W){return W instanceof i?!0:W?z.isPosition(W.start)&&z.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Ze){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(tt=new z(W,ve),at=new z(Re,Ze)):z.isPosition(W)&&z.isPosition(ve)&&(tt=z.of(W),at=z.of(ve)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):z.isPosition(W)?!(z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=z.Max(W.start,this.c),Re=z.Min(W.end,this.e);if(!ve.isAfter(Re))return new i(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=z.Min(W.start,this.c),Re=z.Max(W.end,this.end);return new i(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,T.$5)();let Re;return W?z.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new i(Re,ve)}toJSON(){return[this.start,this.end]}};e.$WJ=j,e.$WJ=j=i=Ke([L],j);let F=s=class extends j{static isSelection(W){return W instanceof s?!0:W?j.isRange(W)&&z.isPosition(W.anchor)&&z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Ze){let tt,at;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(tt=new z(W,ve),at=new z(Re,Ze)):z.isPosition(W)&&z.isPosition(ve)&&(tt=z.of(W),at=z.of(ve)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$XJ=F,e.$XJ=F=s=Ke([L],F);const K=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,T.$5)("connectionToken")};class H{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,T.$5)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.$5)("port");typeof Re<"u"&&K(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$YJ=H;class $e{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&K(ve)}}e.$ZJ=$e;class _ extends Error{static NotAvailable(W,ve){return new _(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new _(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=k.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,_.prototype)}}e.$1J=_;var Q;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var V;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let ee=d=class{static isTextEdit(W){return W instanceof d?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new d(W,ve)}static insert(W,ve){return d.replace(new j(W,W),ve)}static delete(W){return d.replace(W,"")}static setEndOfLine(W){const ve=new d(new j(new z(0,0),new z(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,T.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$5)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$2J=ee,e.$2J=ee=d=Ke([L],ee);let me=b=class{static isNotebookCellEdit(W){return W instanceof b?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new b(W,ve)}static insertCells(W,ve){return new b(new Xt(W,W),ve)}static deleteCells(W){return new b(W,[])}static updateCellMetadata(W,ve){const Re=new b(new Xt(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new b(new Xt(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$3J=me,e.$3J=me=b=Ke([L],me);class ae{static isSnippetTextEdit(W){return W instanceof ae?!0:W?j.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ve){return new ae(W,ve)}static insert(W,ve){return ae.replace(new j(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$4J=ae;var te;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(te||(e.FileEditType=te={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Ze){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Ze})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Ze){const tt=ve.start,at=ve.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Ze})}g(W,ve,Re,Ze){this.c.push({_type:3,metadata:Ze,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Ze){this.c.push({_type:2,uri:W,edit:new ee(ve,Re),metadata:Ze})}insert(W,ve,Re,Ze){this.replace(W,new j(ve,ve),Re,Ze)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Ze,tt;Array.isArray(Re)?(Ze=Re[0],tt=Re[1]):Ze=Re,me.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(W,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(W,Ze.newNotebookMetadata,tt):this.f(W,Ze.range,Ze.newCells,tt):ae.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:W,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Ze,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Ze=this.c[Re];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Bf)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new R.$xi;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$5J=X,e.$5J=X=Ke([L],X);let U=g=class{static isSnippetString(W){return W instanceof g?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=g.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new g;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=g.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new g;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$6J=U,e.$6J=U=g=Ke([L],U);var q;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var G;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(G||(e.DiagnosticSeverity=G={}));let ce=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&$.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(j.isRange(ve))this.range=j.of(ve);else if(z.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$7J=ce,e.$7J=ce=t=Ke([L],ce);let re=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&$.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$8J=re,e.$8J=re=Ke([L],re);let de=class{constructor(W,ve,Re=G.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,C.$of)(W.tags,ve.tags)&&(0,C.$of)(W.relatedInformation,ve.relatedInformation,re.isEqual)}};e.$9J=de,e.$9J=de=Ke([L],de);let Ee=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$0J=Ee,e.$0J=Ee=Ke([L],Ee);var he;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(he||(e.DocumentHighlightKind=he={}));let ge=class{constructor(W,ve=he.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:he[this.kind]}}};e.$$J=ge,e.$$J=ge=Ke([L],ge);var ne;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var ue;(function(J){J[J.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let we=o=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Ze,tt){this.name=W,this.kind=ve,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Ze instanceof ce?this.location=Ze:Re instanceof j&&(this.location=new ce(Ze,Re)),o.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$_J=we,e.$_J=we=o=Ke([L],we);let Pe=c=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(c.validate)}constructor(W,ve,Re,Ze,tt){this.name=W,this.detail=ve,this.kind=Re,this.range=Ze,this.selectionRange=tt,this.children=[],c.validate(this)}};e.$aK=Pe,e.$aK=Pe=c=Ke([L],Pe);var B;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Z=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$bK=Z,e.$bK=Z=Ke([L],Z);let x=class{static{n=this}static{this.c="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.c)}};e.$cK=x,e.$cK=x=n=Ke([L],x);class se extends x{constructor(W){super(W),this.value=W}}e.$dK=se,x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let Y=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$eK=Y,e.$eK=Y=Ke([L],Y);class fe{constructor(W,ve,Re,Ze,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ze,this.range=tt,this.selectionRange=at}}e.$fK=fe;class ye{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$gK=ye;class ze{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$hK=ze;var We;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(We||(e.LanguageStatusSeverity=We={}));let xe=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$iK=xe,e.$iK=xe=Ke([L],xe);let Ye=a=class{#e;static isMarkdownString(W){return W instanceof a?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$Vj(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$jK=Ye,e.$jK=Ye=a=Ke([L],Ye);let it=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$kK=it,e.$kK=it=Ke([L],it);let et=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$lK=et,e.$lK=et=Ke([L],et);let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$mK=Ae,e.$mK=Ae=Ke([L],Ae);var Ne;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var Ve;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Ve||(e.InlayHintKind=Ve={}));let Le=class{constructor(W){this.value=W}};e.$nK=Le,e.$nK=Le=Ke([L],Le);let Qe=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$oK=Qe,e.$oK=Qe=Ke([L],Qe);var le;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(le||(e.CompletionTriggerKind=le={}));var oe;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(oe||(e.CompletionItemKind=oe={}));var Ie;(function(J){J[J.Deprecated=1]="Deprecated"})(Ie||(e.CompletionItemTag=Ie={}));let qe=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$pK=qe,e.$pK=qe=Ke([L],qe);let je=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$qK=je,e.$qK=je=Ke([L],je);let Xe=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$rK=Xe,e.$rK=Xe=Ke([L],Xe);let nt=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$sK=nt,e.$sK=nt=Ke([L],nt);var ot;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var bt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(bt||(e.StatusBarAlignment=bt={}));function Dt(J,W){return`${I.$Tl.toKey(J)}.${W}`}e.$tK=Dt;var Qt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var Vt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var vt;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Tt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Nt;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Nt||(e.TextDocumentChangeReason=Nt={}));var Kt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(Kt||(e.DecorationRangeBehavior=Kt={})),function(J){function W(ve){switch(ve){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let At=class{constructor(W,ve){if(ve&&!$.URI.isUri(ve))throw(0,T.$5)("target");if(!j.isRange(W)||W.isEmpty)throw(0,T.$5)("range");this.range=W,this.target=ve}};e.$uK=At,e.$uK=At=Ke([L],At);let Rt=class{constructor(W,ve,Re,Ze){this.red=W,this.green=ve,this.blue=Re,this.alpha=Ze}};e.$vK=Rt,e.$vK=Rt=Ke([L],Rt);let Ot=class{constructor(W,ve){if(ve&&!(ve instanceof Rt))throw(0,T.$5)("color");if(!j.isRange(W)||W.isEmpty)throw(0,T.$5)("range");this.range=W,this.color=ve}};e.$wK=Ot,e.$wK=Ot=Ke([L],Ot);let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$5)("label");this.label=W}};e.$xK=Ut,e.$xK=Ut=Ke([L],Ut);var qt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var ct;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(ct||(e.TerminalExitReason=ct={}));class lt{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$5)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.$5)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$5)("tooltip")}}e.$yK=lt;class Jt{constructor(W){this.uri=W}}e.$zK=Jt;class Pt{constructor(W){this.terminalCommand=W}}e.$AK=Pt;var kt;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$5)("options")}}e.$BK=dt;var Ct;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ct||(e.TaskRevealKind=Ct={}));var Ft;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let Et=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,T.$5)("name");this.c=W}get id(){return this.c}};e.$CK=Et,e.$CK=Et=l=Ke([L],Et);function Ge(J){let W="";for(let ve=0;ve<J.length;ve++)W+=J[ve].replace(/,/g,",,")+",";return W}let zt=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,T.$5)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return Ge(W)}};e.$DK=zt,e.$DK=zt=Ke([L],zt);let Me=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,T.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$5)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,T.$5)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return Ge(W)}};e.$EK=Me,e.$EK=Me=Ke([L],Me);var Te;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Te||(e.ShellQuoting=Te={}));var Se;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class ie{constructor(W){this.c=W}computeId(){return"customExecution"+(0,P.$6e)()}set callback(W){this.c=W}get callback(){return this.c}}e.$FK=ie;let Fe=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Ze,tt,at){this.j=!1,this.k=this.definition=W;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Ze,ht=tt,this.j=!0):ve===Se.Global||ve===Se.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=tt,ht=at):(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=tt,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof zt?this.k={type:v.e,id:this.n.computeId()}:this.n instanceof Me?this.k={type:v.f,id:this.n.computeId()}:this.n instanceof ie?this.k={type:v.c,id:this.n.computeId()}:this.k={type:v.g,id:(0,P.$6e)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const ve=this.k.type;(v.g===ve||v.e===ve||v.f===ve||v.c===ve)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$GK=Fe,e.$GK=Fe=v=Ke([L],Fe);var He;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(He||(e.ProgressLocation=He={}));var _e;(function(J){function W(ve){const Re=ve;return(0,S.$pe)(Re.value)?Re.tooltip&&!(0,S.$le)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}J.isViewBadge=W})(_e||(e.ViewBadge=_e={}));let Je=E=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Ze=(0,S.$pe)(Re.checkboxState)?Re.checkboxState:(0,S.$ne)(Re.checkboxState)&&(0,S.$pe)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,S.$pe)(Re.checkboxState)&&(0,S.$ne)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==pt.Checked&&Ze!==pt.Unchecked||tt!==void 0&&!(0,S.$le)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof E)return!0;if(Re.label!==void 0&&!(0,S.$le)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,S.$le)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,S.$le)(Re.iconPath)&&!$.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,S.$le)(Re.iconPath.id))){const Ze=Re.iconPath;if(!Ze||!(0,S.$le)(Ze.light)&&!$.URI.isUri(Ze.light)&&!(0,S.$le)(Ze.dark)&&!$.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,S.$le)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!$.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,S.$le)(Re.tooltip)&&!(Re.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<rt.None&&Re.collapsibleState>rt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,S.$le)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=rt.None){this.collapsibleState=ve,$.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$HK=Je,e.$HK=Je=E=Ke([L],Je);var rt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(rt||(e.TreeItemCollapsibleState=rt={}));var pt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let wt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$IK=wt,e.$IK=wt=Ke([L],wt);class ft extends wt{}e.$JK=ft;class gt extends ft{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$KK=gt;class mt{constructor(W,ve,Re,Ze){this.name=W,this.uri=ve,this._itemId=Re,this.c=Ze}data(){return this.c()}}e.$LK=mt;let gi=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Ze=this.#e.get(this.#t(ve));Ze?Ze.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Ze]of this.#e)for(const tt of Ze)W.call(ve,tt,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$MK=gi,e.$MK=gi=Ke([L],gi);let Ht=class{constructor(W){this.insertText=W}};e.$NK=Ht,e.$NK=Ht=Ke([L],Ht);let Ei=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$OK=Ei,e.$OK=Ei=Ke([L],Ei);let Wt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$PK=Wt,e.$PK=Wt=Ke([L],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(W){this.id=W}};e.$QK=mi,e.$QK=mi=Ke([L],mi);var It;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(W){this.c=W,this.e=$.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!$.URI.isUri(W)&&!$.URI.isUri(W.uri)))throw(0,T.$5)("base");if(typeof ve!="string")throw(0,T.$5)("pattern");typeof W=="string"?this.baseUri=$.URI.file(W):$.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$RK=ki,e.$RK=ki=Ke([L],ki);const Vi=new WeakMap;function St(J,W){Vi.set(J,W)}e.$SK=St;let ti=class{constructor(W,ve,Re,Ze){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$6e)()),this.c}};e.$TK=ti,e.$TK=ti=Ke([L],ti);let $i=class extends ti{constructor(W,ve,Re,Ze,tt){if(super(ve,Re,Ze,tt),W===null)throw(0,T.$5)("location");this.location=W}};e.$UK=$i,e.$UK=$i=Ke([L],$i);let si=class extends ti{constructor(W,ve,Re,Ze,tt){super(ve,Re,Ze,tt),this.functionName=W}};e.$VK=si,e.$VK=si=Ke([L],si);let Si=class extends ti{constructor(W,ve,Re,Ze,tt,at,ht){if(super(Ze,tt,at,ht),!ve)throw(0,T.$5)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$WK=Si,e.$WK=Si=Ke([L],Si);let Di=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$XK=Di,e.$XK=Di=Ke([L],Di);let Lt=class{constructor(W,ve){this.port=W,this.host=ve}};e.$YK=Lt,e.$YK=Lt=Ke([L],Lt);let bi=class{constructor(W){this.path=W}};e.$ZK=bi,e.$ZK=bi=Ke([L],bi);let Ci=class{constructor(W){this.implementation=W}};e.$1K=Ci,e.$1K=Ci=Ke([L],Ci);let oi=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$2K=oi,e.$2K=oi=Ke([L],oi);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$3K=ai,e.$3K=ai=Ke([L],ai);let ut=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$4K=ut,e.$4K=ut=Ke([L],ut);var qi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Yt=class{constructor(W,ve){this.range=W,this.text=ve}};e.$5K=Yt,e.$5K=Yt=Ke([L],Yt);let ii=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$6K=ii,e.$6K=ii=Ke([L],ii);let pi=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$7K=pi,e.$7K=pi=Ke([L],pi);let Ii=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$8K=Ii,e.$8K=Ii=Ke([L],Ii);var Hi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Pi=u=class extends Error{static FileExists(W){return new u(W,p.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(W){return new u(W,p.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(W){return new u(W,p.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(W){return new u(W,p.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(W){return new u(W,p.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(W,ve=p.FileSystemProviderErrorCode.Unknown,Re){super($.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,p.$fk)(this,ve),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$9K=Pi,e.$9K=Pi=u=Ke([L],Pi);let wi=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$0K=wi,e.$0K=wi=Ke([L],wi);var Ki;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Ai;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Ji;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var vi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$$K=Ri;function cn(J){return typeof J>"u"||(0,S.$me)(J)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Ze,tt){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,ve,Re,Ze,tt);if(j.isRange(W)&&typeof ve=="string"&&cn(Re))return this.m(W,ve,Re);throw(0,T.$5)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,ht=this.j.get(ve);let jt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this.k.get(Zt);jt|=1<<_t>>>0}this.n(Ze,tt,at,ht,jt)}n(W,ve,Re,Ze,tt){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Zt=0,_t=0;for(let ei=0;ei<jt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Zt,Bi+=_t):ri+=Zt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Zt=ri,_t=Bi}}let at=W,ht=ve;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Ze,this.g[this.h++]=tt,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)ve[ht]=ht;ve.sort((ht,jt)=>{const Zt=W[5*ht],_t=W[5*jt];if(Zt===_t){const ei=W[5*ht+1],ri=W[5*jt+1];return ei-ri}return Zt-_t});const Ze=new Uint32Array(W.length);let tt=0,at=0;for(let ht=0;ht<Re;ht++){const jt=5*ve[ht],Zt=W[jt+0],_t=W[jt+1],ei=W[jt+2],ri=W[jt+3],Bi=W[jt+4],vn=Zt-tt,Ln=vn===0?_t-at:_t,Wi=5*ht;Ze[Wi+0]=vn,Ze[Wi+1]=Ln,Ze[Wi+2]=ei,Ze[Wi+3]=ri,Ze[Wi+4]=Bi,tt=Zt,at=_t}return Ze}build(W){return this.f?new ni(new Uint32Array(this.g),W):new ni(Li.o(this.g),W)}}e.$_K=Li;class ni{constructor(W,ve){this.resultId=ve,this.data=W}}e.$aL=ni;class un{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$bL=un;class ln{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$cL=ln;var Gi;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$dL=fi,e.$dL=fi=Ke([L],fi);var Zi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Zi||(e.QuickPickItemKind=Zi={}));var Qi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Yi{static validate(W){if(typeof W.badge=="string"){let ve=(0,m.$Yd)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,m.$Yd)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Wt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$eL=Yi;let Mi=class{constructor(W){this.kind=W}};e.$fL=Mi,e.$fL=Mi=Ke([L],Mi);var Xi;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,T.$5)("start must be positive");if(ve<0)throw(0,T.$5)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new Xt(ve,Re)}}e.$gL=Xt;class yi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>yi.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Ze,tt,at,ht){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Ze,this.outputs=tt??[],this.metadata=at,this.executionSummary=ht,yi.validate(this)}}e.$hL=yi;class hn{constructor(W){this.cells=W}}e.$iL=hn;class Gt{static isNotebookCellOutputItem(W){return W instanceof Gt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Gt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Gt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Gt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Gt(W,ve)}static#e=new TextEncoder;static text(W,ve=A.$Er.text){const Re=Gt.#e.encode(String(W));return new Gt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Gt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,A.$Ir)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$jL=Gt;class li{static isNotebookCellOutput(W){return W instanceof li?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Ze=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],ht=(0,A.$Ir)(at.mime);if(!Re.has(ht)||(0,D.$ZH)(ht)){Re.add(ht);continue}Ze.add(tt),ve&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ze.size===0?W:W.filter((tt,at)=>!Ze.has(at))}constructor(W,ve,Re){this.items=li.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,P.$6e)(),this.metadata=ve??Re)}}e.$kL=li;var Ti;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ue;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(Ue||(e.NotebookCellExecutionState=Ue={}));var xt;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(xt||(e.NotebookCellStatusBarAlignment=xt={}));var Fi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Fi||(e.NotebookEditorRevealType=Fi={}));class $t{constructor(W,ve){this.text=W,this.alignment=ve}}e.$lL=$t;var xi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(W,ve=[]){this.uri=W,this.provides=(0,C.$Vf)(ve)}}e.$mL=en;class dn{constructor(W){this.label=W}}e.$nL=dn;let hi=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$oL=hi,e.$oL=hi=Ke([L],hi);var tn;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$pL=sn;class fn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$qL=fn;var on;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(W=void 0,ve=void 0,Re=void 0,Ze=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Ze}};e.$rL=Ni,e.$rL=Ni=Ke([L],Ni);let Oi=h=class{static diff(W,ve,Re){const Ze=new h(W);return Ze.expectedOutput=ve,Ze.actualOutput=Re,Ze}constructor(W){this.message=W}};e.$sL=Oi,e.$sL=Oi=h=Ke([L],Oi);let zi=class{constructor(W){this.id=W}};e.$tL=zi,e.$tL=zi=Ke([L],zi);let di=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$uL=di,e.$uL=di=Ke([L],di);let ji=w=class{static fromDetails(W,ve){const Re=new di(0,0),Ze=new di(0,0),tt=new di(0,0);for(const ht of ve)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Ze.total+=1,Ze.covered+=jt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const at=new w(W,Re,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ve,at}constructor(W,ve,Re,Ze){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Ze}};e.$vL=ji,e.$vL=ji=w=Ke([L],ji);let Ui=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$wL=Ui,e.$wL=Ui=Ke([L],Ui);let pe=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$xL=pe,e.$xL=pe=Ke([L],pe);let ke=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$yL=ke,e.$yL=ke=Ke([L],ke);var Oe;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var st;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(st||(e.WorkspaceTrustState=st={}));var yt;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Mt{constructor(W,ve,Re,Ze,tt,at){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ze,this.range=tt,this.selectionRange=at}}e.$zL=Mt;class yn{constructor(W){this.uri=W}}e.$AL=yn;class En{constructor(W,ve){this.original=W,this.modified=ve}}e.$BL=En;class kn{constructor(W,ve,Re,Ze){this.base=W,this.input1=ve,this.input2=Re,this.result=Ze}}e.$CL=kn;class Sn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$DL=Sn;class Dn{constructor(W){this.viewType=W}}e.$EL=Dn;class Cn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$FL=Cn;class In{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$GL=In;class Pn{constructor(){}}e.$HL=Pn;class An{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$IL=An;var gn;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var bn;(function(J){J[J.System=0]="System",J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var pn;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class Rn{constructor(W,ve){this.role=W,this.content=ve}}e.$JL=Rn;var wn;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(wn||(e.RelatedInformationType=wn={}))}),define(De[141],Ce([1,0,57,17,15,171,124,7,19]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=e.$WL=void 0;const $=new Map;function P(D,y){y?$.set(D,y):$.delete(D)}e.$WL=P;function I(D){return $.get(D)}class p extends R.$Ju{constructor(y,r,i,s,d,b,g,t){super(r,i,s,d),this.c=y,this.m=b,this.q=g,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(y){return(0,S.$of)(this.f,y)}get document(){if(!this.a){const y=this;this.a={get uri(){return y.d},get fileName(){return y.d.fsPath},get isUntitled(){return y.d.scheme===T.Schemas.untitled},get languageId(){return y.m},get version(){return y.h},get isClosed(){return y.b},get isDirty(){return y.q},save(){return y.r()},getText(r){return r?y.s(r):y.getText()},get eol(){return y.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return y.f.length},lineAt(r){return y.t(r)},offsetAt(r){return y.u(r)},positionAt(r){return y.v(r)},validateRange(r){return y.w(r)},validatePosition(r){return y.x(r)},getWordRangeAtPosition(r,i){return y.y(r,i)}}}return Object.freeze(this.a)}_acceptLanguageId(y){(0,C.ok)(!this.b),this.m=y}_acceptIsDirty(y){(0,C.ok)(!this.b),this.q=y}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(y){const r=this.w(y);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const i=this.g,s=r.start.line,d=r.end.line,b=[];b.push(this.f[s].substring(r.start.character));for(let g=s+1;g<d;g++)b.push(this.f[g]);return b.push(this.f[d].substring(0,r.end.character)),b.join(i)}t(y){let r;if(y instanceof m.$VJ?r=y.line:typeof y=="number"&&(r=y),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new k(r,this.f[r],r===this.f.length-1)}u(y){return y=this.x(y),this.l(),this.j.getPrefixSum(y.line-1)+y.character}v(y){y=Math.floor(y),y=Math.max(0,y),this.l();const r=this.j.getIndexOf(y),i=this.f[r.index].length;return new m.$VJ(r.index,Math.min(r.remainder,i))}w(y){if(!(y instanceof m.$WJ))throw new Error("Invalid argument");const r=this.x(y.start),i=this.x(y.end);return r===y.start&&i===y.end?y:new m.$WJ(r.line,r.character,i.line,i.character)}x(y){if(!(y instanceof m.$VJ))throw new Error("Invalid argument");if(this.f.length===0)return y.with(0,0);let{line:r,character:i}=y,s=!1;if(r<0)r=0,i=0,s=!0;else if(r>=this.f.length)r=this.f.length-1,i=this.f[r].length,s=!0;else{const d=this.f[r].length;i<0?(i=0,s=!0):i>d&&(i=d,s=!0)}return s?new m.$VJ(r,i):y}y(y,r){const i=this.x(y);if(!r)r=I(this.m);else if((0,f.$Bd)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const s=(0,A.$Wr)(i.character+1,(0,A.$Ur)(r),this.f[i.line],0);if(s)return new m.$WJ(i.line,s.startColumn-1,i.line,s.endColumn-1)}}e.$XL=p;class k{constructor(y,r,i){this.a=y,this.b=r,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$WJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$WJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$YL=k}),define(De[274],Ce([1,0,7,20,4]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;let R=class{constructor(m){this.a=new C.$fL(C.ColorThemeKind.Dark),this.b=new f.$hc}get activeColorTheme(){return this.a}$onColorThemeChange(m){let S;switch(m){case"light":S=C.ColorThemeKind.Light;break;case"hcDark":S=C.ColorThemeKind.HighContrast;break;case"hcLight":S=C.ColorThemeKind.HighContrastLight;break;default:S=C.ColorThemeKind.Dark}this.a=new C.$fL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$hcc=R,e.$hcc=R=Ke([Be(0,T.$UL)],R)}),define(De[275],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=e.CellExecutionUpdateType=void 0;var T;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$4H=(0,C.$zh)("INotebookExecutionService")}),define(De[67],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(R){R.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class f{static fromExtHostTestItem(A,m,S=A.parent){if(A._isRoot)return new f([m]);const $=[A.id];for(let P=S;P&&P.id!==m;P=P.parent)$.push(P.id);return $.push(m),new f($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new f(A.split("\0"))}static join(A,m){return new f([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:f.isChild(A,m)?2:f.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new f(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new f(this.path,A)}compare(A){if(typeof A=="string")return f.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$FI=f}),define(De[88],Ce([1,0,2,34,67]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$LI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$KI=e.$JI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$II=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$HI=e.$GI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(E){E[E.Run=1]="Run",E[E.Debug=2]="Debug",E[E.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable",E[E.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$GI=[2,4,8,16,32,64];const S=E=>"runId"in E;e.$HI=S;var $;(function(E){E.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),E.deserialize=u=>({range:T.$hs.lift(u.range),uri:C.URI.revive(u.uri)})})($||(e.IRichLocation=$={}));var P;(function(E){E[E.Error=0]="Error",E[E.Output=1]="Output"})(P||(e.TestMessageType=P={}));var I;(function(E){E.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.serialize(u.location)}),E.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&$.deserialize(u.location)})})(I||(e.ITestErrorMessage=I={}));const p=(E,u)=>`${u?"s":"e"}${E}`;e.$II=p;var k;(function(E){E.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.serialize(u.location)}),E.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&$.deserialize(u.location)})})(k||(e.ITestOutputMessage=k={}));var D;(function(E){E.serialize=u=>u.type===0?I.serialize(u):k.serialize(u),E.deserialize=u=>u.type===0?I.deserialize(u):k.deserialize(u)})(D||(e.ITestMessage=D={}));var y;(function(E){E.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),E.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(D.serialize)}),E.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(D.deserialize)})})(y||(e.ITestTaskState=y={}));const r="\0",i=(E,u)=>E+r+u;e.$JI=i;const s=E=>{const u=E.indexOf(r);return{ctrlId:E.slice(0,u),tagId:E.slice(u+1)}};e.$KI=s;var d;(function(E){E.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),E.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?C.URI.revive(u.uri):void 0,range:u.range?T.$hs.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(d||(e.ITestItem=d={}));var b;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(b||(e.TestItemExpandState=b={}));var g;(function(E){E.serialize=u=>({expand:u.expand,item:d.serialize(u.item)}),E.deserialize=u=>({controllerId:f.$FI.root(u.item.extId),expand:u.expand,item:d.deserialize(u.item)})})(g||(e.InternalTestItem=g={}));var t;(function(E){E.serialize=u=>{let h;return u.item&&(h={},u.item.label!==void 0&&(h.label=u.item.label),u.item.tags!==void 0&&(h.tags=u.item.tags),u.item.busy!==void 0&&(h.busy=u.item.busy),u.item.uri!==void 0&&(h.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(h.range=u.item.range?.toJSON()),u.item.description!==void 0&&(h.description=u.item.description),u.item.error!==void 0&&(h.error=u.item.error),u.item.sortText!==void 0&&(h.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:h}},E.deserialize=u=>{let h;return u.item&&(h={},u.item.label!==void 0&&(h.label=u.item.label),u.item.tags!==void 0&&(h.tags=u.item.tags),u.item.busy!==void 0&&(h.busy=u.item.busy),u.item.range!==void 0&&(h.range=u.item.range?T.$hs.lift(u.item.range):null),u.item.description!==void 0&&(h.description=u.item.description),u.item.error!==void 0&&(h.error=u.item.error),u.item.sortText!==void 0&&(h.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:h}}})(t||(e.ITestItemUpdate=t={}));const o=(E,u)=>{u.expand!==void 0&&(E.expand=u.expand),u.item!==void 0&&(E.item=E.item?Object.assign(E.item,u.item):u.item)};e.$LI=o;var c;(function(E){E.serializeWithoutMessages=u=>({...g.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.serializeWithoutMessages)}),E.serialize=u=>({...g.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.serialize)}),E.deserialize=u=>({...g.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(y.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var n;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(n||(e.DetailType=n={}));var a;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.DocumentSynced=2]="DocumentSynced",E[E.Remove=3]="Remove",E[E.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",E[E.Retire=5]="Retire",E[E.AddTag=6]="AddTag",E[E.RemoveTag=7]="RemoveTag"})(a||(e.TestDiffOpType=a={}));var l;(function(E){E.deserialize=u=>u.op===0?{op:u.op,item:g.deserialize(u.item)}:u.op===1?{op:u.op,item:t.deserialize(u.item)}:u.op===2?{op:u.op,uri:C.URI.revive(u.uri),docv:u.docv}:u,E.serialize=u=>u.op===0?{op:u.op,item:g.serialize(u.item)}:u.op===1?{op:u.op,item:t.serialize(u.item)}:u})(l||(e.TestsDiffOp=l={}));class v{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const h=this.p();for(const w of u)switch(w.op){case 0:this.k(g.deserialize(w.item),h);break;case 1:this.l(t.deserialize(w.item),h);break;case 3:this.m(w.itemId,h);break;case 5:this.o(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.d.set(w.tag.id,w.tag);break;case 7:this.d.delete(w.id);break}h.complete?.()}k(u,h){const w=f.$FI.parentId(u.item.extId)?.toString();let L;if(!w)L=this.q(u),this.g.add(L),this.f.set(u.item.extId,L);else if(this.f.has(w)){const O=this.f.get(w);O.children.add(u.item.extId),L=this.q(u,O),this.f.set(u.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return h.add?.(L),u.expand===2&&this.h++,L}l(u,h){const w=this.f.get(u.extId);if(w)return u.expand!==void 0&&(w.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$LI)(w,u),h.update?.(w),w}m(u,h){const w=this.f.get(u);if(!w)return;const L=f.$FI.parentId(w.item.extId)?.toString();L?this.f.get(L).children.delete(w.item.extId):this.g.delete(w);const O=[[u]];for(;O.length;)for(const N of O.pop()){const M=this.f.get(N);M&&(O.push(M.children),this.f.delete(N),h.remove?.(M,M!==w),M.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$MI=v}),define(De[109],Ce([1,0,11,4,3,57,88,67]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.TestItemEventOp=void 0;var S;(function(s){s[s.Upsert=0]="Upsert",s[s.SetTags=1]="SetTags",s[s.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",s[s.RemoveChild=3]="RemoveChild",s[s.SetProp=4]="SetProp",s[s.Bulk=5]="Bulk",s[s.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const $=(s,d)=>s===d,I=Object.entries({range:(s,d)=>s===d?!0:!s||!d?!1:s.equalsRange(d),busy:$,label:$,description:$,error:$,sortText:$,tags:(s,d)=>!(s.length!==d.length||s.some(b=>!d.includes(b)))}),p=(s,d)=>{let b;for(const[g,t]of I)t(s[g],d[g])||(b?b[g]=d[g]:b={[g]:d[g]});return b};class k extends f.$mb{get root(){return this.m.root}constructor(d){super(),this.m=d,this.f=this.B(new C.$Qg(()=>this.flushDiff(),200)),this.g=this.B(new T.$hc),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(d){this.h=d;for(const b of this.tree.values())this.G(b)}get resolveHandler(){return this.h}collectDiff(){const d=this.k;return this.k=[],d}pushDiff(d){switch(d.op){case 2:{for(const b of this.k)if(b.op===2&&b.uri===d.uri){b.docv=d.docv;return}break}case 1:{const b=this.k[this.k.length-1];if(b){if(b.op===1&&b.item.extId===d.item.extId){(0,A.$LI)(b.item,d.item);return}if(b.op===0&&b.item.item.extId===d.item.extId){(0,A.$LI)(b.item,d.item);return}}break}}this.k.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,b){const g=this.tree.get(d);if(g){if((g.expandLevels===void 0||b>g.expandLevels)&&(g.expandLevels=b),g.expand===1){const t=this.I(g);return t.isOpen()?this.H(g,b-1):t.wait().then(()=>this.H(g,b-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,b-1)):this.H(g,b-1)}}dispose(){for(const d of this.tree.values())this.m.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(d,b){switch(b.op){case 3:this.L(m.$FI.joinToString(d.fullId,b.id));break;case 0:this.u(b.item,d);break;case 5:for(const g of b.ops)this.p(d,g);break;case 1:this.w(b.new,b.old,d.fullId.toString());break;case 2:this.G(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:b.update}});break;case 6:this.s(d.actual.uri);break;default:(0,R.$xb)(b)}}s(d){d&&this.pushDiff({op:2,uri:d,docv:this.m.getDocumentVersion(d)})}u(d,b){const g=m.$FI.fromExtHostTestItem(d,this.root.id,b?.actual),t=this.m.getApiFor(d);t.parent&&t.parent!==b?.actual&&this.m.getChildren(t.parent).delete(d.id);let o=this.tree.get(g.toString());if(!o){o={fullId:g,actual:d,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:0},d.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(d,b),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(d)}}),this.F(d,o,b);return}if(o.actual===d){this.D(d,o,b);return}if(o.actual.uri?.toString()!==d.uri?.toString())return this.L(g.toString()),this.u(d,b);const c=this.m.getChildren(o.actual),n=o.actual,a=p(this.m.toITestItem(n),this.m.toITestItem(d));this.m.getApiFor(n).listener=void 0,o.actual=d,o.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(d.tags,n.tags,g.toString()),delete a.tags),this.p(o,{op:4,update:a})),this.F(d,o,b);for(const[l,v]of c)this.m.getChildren(d).get(v.id)||this.L(m.$FI.joinToString(g,v.id));this.s(o.actual.uri)}w(d,b,g){const t=new Set(b.map(o=>o.id));for(const o of d)t.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:g,item:{tags:d.map(o=>(0,A.$JI)(this.m.controllerId,o.id))}}}),t.forEach(this.z,this)}y(d){const b=this.j.get(d.id);b?b.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$JI)(this.m.controllerId,d.id)}}))}z(d){const b=this.j.get(d);b&&!--b.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,A.$JI)(this.m.controllerId,d)}))}C(d,b){this.m.getApiFor(d).parent=b&&b.actual!==this.root?b.actual:void 0}D(d,b,g){this.C(d,g);const t=this.m.getApiFor(d);t.parent=g?.actual,t.listener=o=>this.p(b,o),this.G(b)}F(d,b,g){this.D(d,b,g);for(const[t,o]of this.m.getChildren(d))this.u(o,b)}G(d){let b;this.h?d.resolveBarrier?b=d.resolveBarrier.isOpen()?3:2:b=d.actual.canResolveChildren?1:0:b=0,b!==d.expand&&(d.expand=b,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:b}}),b===1&&d.expandLevels!==void 0&&this.I(d))}H(d,b){if(b<0)return;const g=[];for(const[t,o]of this.m.getChildren(d.actual)){const c=this.expand(m.$FI.joinToString(d.fullId,o.id),b);(0,C.$rg)(c)&&g.push(c)}if(g.length)return Promise.all(g).then(()=>{})}I(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const o=new C.$Dg;return o.open(),o}d.expand=2,this.J(d);const b=d.resolveBarrier=new C.$Dg,g=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(o){g(o)}return(0,C.$rg)(t)?t.catch(g).then(()=>{b.open(),this.G(d)}):(b.open(),this.G(d)),d.resolveBarrier}J(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}L(d){const b=this.tree.get(d);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const g=[b];for(;g.length;){const t=g.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.z(o.id);this.tree.delete(t.fullId.toString());for(const[o,c]of this.m.getChildren(t.actual))g.push(this.tree.get(m.$FI.joinToString(t.fullId,c.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.$KL=k;class D extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.$LL=D;class y extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$ML=y;class r extends Error{constructor(d,b,g){super(`TestItem with ID "${d}" is from controller "${b}" and cannot be added as a child of an item from controller "${g}".`)}}e.$NL=r;const i=(s,d,b)=>{let g=new Map;return{get size(){return g.size},forEach(t,o){for(const c of g.values())t.call(o,c,this)},[Symbol.iterator](){return g.entries()},replace(t){const o=new Map,c=new Set(g.keys()),n={op:5,ops:[]};for(const a of t){if(!(a instanceof b))throw new y(a.id);const l=d(a).controllerId;if(l!==s.controllerId)throw new r(a.id,l,s.controllerId);if(o.has(a.id))throw new D(a.id);o.set(a.id,a),c.delete(a.id),n.ops.push({op:0,item:a})}for(const a of c.keys())n.ops.push({op:3,id:a});s.listener?.(n),g=o},add(t){if(!(t instanceof b))throw new y(t.id);g.set(t.id,t),s.listener?.({op:0,item:t})},delete(t){g.delete(t)&&s.listener?.({op:3,id:t})},get(t){return g.get(t)},toJSON(){return Array.from(g.values())}}};e.$OL=i}),define(De[142],Ce([1,0,109]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=void 0;const T=new WeakMap,f=(A,m)=>{const S={controllerId:m};return T.set(A,S),S};e.$PL=f;const R=A=>{const m=T.get(A);if(!m)throw new C.$ML(A?.id||"<unknown>");return m};e.$QL=R}),define(De[110],Ce([1,0,17,2]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lob=e.$Kob=e.$Job=e.$Iob=e.$Hob=void 0,e.$Hob="vscode-cdn.net",e.$Iob=`vscode-resource.${e.$Hob}`,e.$Job=`'self' https://*.${e.$Hob}`;function f(m,S){return m.scheme===C.Schemas.http||m.scheme===C.Schemas.https?m:(S&&S.authority&&S.isRemote&&m.scheme===C.Schemas.file&&(m=T.URI.from({scheme:C.Schemas.vscodeRemote,authority:S.authority,path:m.path})),T.URI.from({scheme:C.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$Iob}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Kob=f;function R(m){return m.replace(/./g,S=>{const $=S.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?S:"-"+$.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(S,$)=>String.fromCharCode(parseInt($,16)))}e.$Lob=A}),define(De[276],Ce([1,0,4,3,110]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class R{constructor(m,S,$){this.d=m,this.e=S,this.f=$,this.a=0,this.b=new T.$lb,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const I of this.c.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,S,$,P,I){let p;for(const d of this.e.getVisibleTextEditors(!0))if(d.value===m){p=d;break}if(!p)throw new Error("not a visible editor");const k=this,D=this.a++,y=new C.$hc,r=new C.$hc,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(d){return(0,f.$Kob)(d,k.f)}get cspSource(){return f.$Job}set options(d){this.b=d,k.d.$setOptions(D,d)}get options(){return this.b}set html(d){this.a=d,k.d.$setHtml(D,d)}get html(){return this.a}get onDidReceiveMessage(){return y.event}postMessage(d){return k.d.$postMessage(D,d)}},s=new class{constructor(){this.editor=m,this.line=S,this.height=$,this.webview=i,this.onDidDispose=r.event}dispose(){k.c.has(D)&&(k.c.delete(D),k.d.$disposeEditorInset(D),r.fire(),r.dispose(),y.dispose())}};return this.d.$createEditorInset(D,p.id,p.value.document.uri,S+1,$,P||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:m,inset:s,onDidReceiveMessage:y}),s}$onDidDispose(m){const S=this.c.get(m);S&&S.inset.dispose()}$onDidReceiveMessage(m,S){this.c.get(m)?.onDidReceiveMessage.fire(S)}}e.$Rbc=R}),define(De[277],Ce([1,0,5]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.VariableKind=e.$GM=void 0,e.$GM=(0,C.$zh)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class f extends Error{constructor(A,m){super(m),this.variable=A}}e.$HM=f}),define(De[278],Ce([1,0,16,47,18,23,12,100,223,277,15]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,D,y,r){this.h=new Map,this.a=k,this.b=D,this.g=y,r&&(this.c=r.then(i=>this.i(i)))}i(k){if(A.$i){const D=Object.create(null);return Object.keys(k).forEach(y=>{D[y.toLowerCase()]=k[y]}),D}return k}resolveWithEnvironment(k,D,y){return this.l({env:this.i(k),userHome:void 0},D?D.uri:void 0,y)}async resolveAsync(k,D){const y={env:await this.c,userHome:await this.g};return this.l(y,k?k.uri:void 0,D)}async j(k,D,y,r){const i=R.$Tm(D);A.$i&&i.windows?Object.keys(i.windows).forEach(d=>i[d]=i.windows[d]):A.$j&&i.osx?Object.keys(i.osx).forEach(d=>i[d]=i.osx[d]):A.$k&&i.linux&&Object.keys(i.linux).forEach(d=>i[d]=i.linux[d]),delete i.windows,delete i.osx,delete i.linux;const s={env:await this.c,userHome:await this.g};return this.l(s,k?k.uri:void 0,i,y,r)}async resolveAnyAsync(k,D,y){return this.j(k,D,y)}async resolveAnyMap(k,D,y){const r=new Map;return{newConfig:await this.j(k,D,y,r),resolvedVariables:r}}resolveWithInteractionReplace(k,D,y,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,D,y,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,D){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,D)}async l(k,D,y,r,i){if(f.$le(y))return this.m(k,D,y,r,i);if(Array.isArray(y))return Promise.all(y.map(s=>this.l(k,D,s,r,i)));if(f.$ne(y)){const s=Object.create(null),d=await Promise.all(Object.keys(y).map(async b=>[await this.m(k,D,b,r,i),await this.l(k,D,y[b],r,i)]));for(const[b,g]of d)s[b]=g;return s}return y}m(k,D,y,r,i){return(0,P.$Gd)(y,I.VARIABLE_REGEXP,async(s,d)=>{if(d.includes(I.VARIABLE_LHS))return s;let b=await this.o(k,s,d,D,r);return i?.set(d,b),b!==s&&f.$le(b)&&b.match(I.VARIABLE_REGEXP)&&(b=await this.m(k,D,b,r,i)),b})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,D,y,r,i){let s;const d=y.split(":");d.length>1&&(y=d[0],s=d[1]);const b=o=>{const c=this.a.getFilePath();if(c)return(0,m.$bA)(c);throw new $.$HM(o,(0,S.localize)(0,null,D))},g=o=>{const c=b(o);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,m.$bA)(n)}throw new $.$HM(o,(0,S.localize)(1,null,D,C.$cd(c)))},t=o=>{if(s){const c=this.a.getFolderUri(s);if(c)return c;throw new $.$HM(o,(0,S.localize)(2,null,D,s))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new $.$HM(o,(0,S.localize)(3,null,D)):new $.$HM(o,(0,S.localize)(4,null,D))};switch(y){case"env":if(s){if(k.env){const o=k.env[A.$i?s.toLowerCase():s];if(f.$le(o))return o}return""}throw new $.$HM($.VariableKind.Env,(0,S.localize)(5,null,D));case"config":if(s){const o=this.a.getConfigurationValue(r,s);if(f.$ue(o))throw new $.$HM($.VariableKind.Config,(0,S.localize)(6,null,D,s));if(f.$ne(o))throw new $.$HM($.VariableKind.Config,(0,S.localize)(7,null,D,s));return o}throw new $.$HM($.VariableKind.Config,(0,S.localize)(8,null,D));case"command":return this.p($.VariableKind.Command,D,s,i,"command");case"input":return this.p($.VariableKind.Input,D,s,i,"input");case"extensionInstallFolder":if(s){const o=await this.a.getExtension(s);if(!o)throw new $.$HM($.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,D,s));return this.n(o.extensionLocation)}throw new $.$HM($.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,D));default:switch(y){case"workspaceRoot":case"workspaceFolder":return(0,m.$bA)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return r||s?(0,m.$bA)(this.n(t($.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$bA)(C.$cd(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new $.$HM($.VariableKind.UserHome,(0,S.localize)(11,null,D))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new $.$HM($.VariableKind.LineNumber,(0,S.localize)(12,null,D))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new $.$HM($.VariableKind.SelectedText,(0,S.localize)(13,null,D))}case"file":return b($.VariableKind.File);case"fileWorkspaceFolder":return g($.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||s?C.$ad(this.n(t($.VariableKind.RelativeFile)),b($.VariableKind.RelativeFile)):b($.VariableKind.RelativeFile);case"relativeFileDirname":{const o=C.$bd(b($.VariableKind.RelativeFileDirname));if(r||s){const c=C.$ad(this.n(t($.VariableKind.RelativeFileDirname)),o);return c.length===0?".":c}return o}case"fileDirname":return C.$bd(b($.VariableKind.FileDirname));case"fileExtname":return C.$dd(b($.VariableKind.FileExtname));case"fileBasename":return C.$cd(b($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=C.$cd(b($.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-C.$dd(o).length)}case"fileDirnameBasename":return C.$cd(C.$bd(b($.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||D}case"execInstallFolder":{const o=this.a.getAppRoot();return o||D}case"pathSeparator":return C.sep;default:try{const o=s?`${y}:${s}`:y;return this.p($.VariableKind.Unknown,D,o,i,void 0)}catch{return D}}}}p(k,D,y,r,i){if(y&&r){const s=i===void 0?r[y]:r[i+":"+y];if(typeof s=="string")return s;throw new $.$HM(k,(0,S.localize)(14,null,D))}return D}}e.$VM=I}),define(De[143],Ce([1,0,5,139]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.OpenEditorContext=e.GroupsOrder=e.$2C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$1C=void 0,e.$1C=(0,C.$zh)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var S;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function $(D){const y=D;return(0,T.$QE)(y?.editor)&&(0,T.$QE)(y?.replacement)}e.$2C=$;var P;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(D){const y=D;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.$3C=p;function k(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$4C=k}),define(De[279],Ce([1,0,5,143]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=e.$7C=e.$6C=e.$5C=void 0,e.$5C=(0,C.$zh)("editorService"),e.$6C=-1,e.$7C=-2;function f(R){const A=R;return typeof R=="number"||(0,T.$3C)(A)}e.$8C=f}),define(De[13],Ce([1,0,19,22,162,74,79,28,158,62,98,23,18,2,34,82,133,142,139,108,67,88,279,7]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$TL=e.$SL=e.MarkdownString=e.$RL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Te(ie){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:_e,positionColumn:Je}=ie,rt=new o.$VJ(Fe-1,He-1),pt=new o.$VJ(_e-1,Je-1);return new o.$XJ(rt,pt)}Me.to=Te;function Se(ie){const{anchor:Fe,active:He}=ie;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Me.from=Se})(c||(e.Selection=c={}));var n;(function(Me){function Te(ie){if(!ie)return;const{start:Fe,end:He}=ie;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Me.from=Te;function Se(ie){if(!ie)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:_e,endColumn:Je}=ie;return new o.$WJ(Fe-1,He-1,_e-1,Je-1)}Me.to=Se})(n||(e.Range=n={}));var a;(function(Me){function Te(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Me.to=Te})(a||(e.TokenType=a={}));var l;(function(Me){function Te(ie){return new o.$VJ(ie.lineNumber-1,ie.column-1)}Me.to=Te;function Se(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Me.from=Se})(l||(e.Position=l={}));var v;(function(Me){function Te(Fe,He,_e){return(0,C.$Af)((0,C.$Vf)(Fe).map(Je=>Se(Je,He,_e)))}Me.from=Te;function Se(Fe,He,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ie(Fe.scheme,He),pattern:Qe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function ie(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(v||(e.DocumentSelector=v={}));var E;(function(Me){function Te(ie){switch(ie){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(ie){switch(ie){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(E||(e.DiagnosticTag=E={}));var u;(function(Me){function Te(ie){let Fe;return ie.code&&((0,p.$le)(ie.code)||(0,p.$pe)(ie.code)?Fe=String(ie.code):Fe={value:String(ie.code.value),target:ie.code.target}),{...n.from(ie.range),message:ie.message,source:ie.source,code:Fe,severity:w.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(h.from),tags:Array.isArray(ie.tags)?(0,C.$Af)(ie.tags.map(E.from)):void 0}}Me.from=Te;function Se(ie){const Fe=new o.$9J(n.to(ie),ie.message,w.to(ie.severity));return Fe.source=ie.source,Fe.code=(0,p.$le)(ie.code)?ie.code:ie.code?.value,Fe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(h.to),Fe.tags=ie.tags&&(0,C.$Af)(ie.tags.map(E.to)),Fe}Me.to=Se})(u||(e.Diagnostic=u={}));var h;(function(Me){function Te(ie){return{...n.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Me.from=Te;function Se(ie){return new o.$8J(new o.$7J(ie.resource,n.to(ie)),ie.message)}Me.to=Se})(h||(e.DiagnosticRelatedInformation=h={}));var w;(function(Me){function Te(ie){switch(ie){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Me.from=Te;function Se(ie){switch(ie){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Me.to=Se})(w||(e.DiagnosticSeverity=w={}));var L;(function(Me){function Te(ie){return typeof ie=="number"&&ie>=o.ViewColumn.One?ie-1:ie===o.ViewColumn.Beside?t.$7C:t.$6C}Me.from=Te;function Se(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(L||(e.ViewColumn=L={}));function O(Me){return typeof Me.range<"u"}function N(Me){return Me.length===0?!0:!!O(Me[0])}e.$RL=N;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ie(Je){let rt;if(Se(Je)){const{language:gt,value:mt}=Je;rt={value:"```"+gt+`
`+mt+"\n```\n"}}else o.$jK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const pt=Object.create(null);rt.uris=pt;const wt=gt=>{try{let mt=k.URI.parse(gt,!0);mt=mt.with({query:Fe(mt.query,pt)}),pt[gt]=mt}catch{}return""},ft=new S.marked.Renderer;return ft.link=wt,ft.image=gt=>typeof gt=="string"?wt(A.$3j(gt).href):"",(0,S.marked)(rt.value,{renderer:ft}),rt}Me.from=ie;function Fe(Je,rt){if(!Je)return Je;let pt;try{pt=(0,$.$8g)(Je)}catch{}if(!pt)return Je;let wt=!1;return pt=(0,I.$Vm)(pt,ft=>{if(k.URI.isUri(ft)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[gt]=ft,wt=!0,gt}else return}),wt?JSON.stringify(pt):Je}function He(Je){const rt=new o.$jK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?k.URI.from(Je.baseUri):void 0,rt}Me.to=He;function _e(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=_e})(M||(e.MarkdownString=M={}));function z(Me){return N(Me)?Me.map(Te=>({range:n.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:n.from(Te)}))}e.$SL=z;function j(Me){return typeof Me>"u"?Me:typeof Me=="string"?k.URI.file(Me):Me}e.$TL=j;var F;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?j(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(F||(e.ThemableDecorationAttachmentRenderOptions=F={}));var K;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(K||(e.ThemableDecorationRenderOptions=K={}));var H;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(H||(e.DecorationRangeBehavior=H={}));var $e;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?H.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})($e||(e.DecorationRenderOptions=$e={}));var _;(function(Me){function Te(ie){return{text:ie.newText,eol:ie.newEol&&et.from(ie.newEol),range:n.from(ie.range)}}Me.from=Te;function Se(ie){const Fe=new o.$2J(n.to(ie.range),ie.text);return Fe.newEol=typeof ie.eol>"u"?void 0:et.to(ie.eol),Fe}Me.to=Se})(_||(e.TextEdit=_={}));var Q;(function(Me){function Te(ie,Fe){const He={edits:[]};if(ie instanceof o.$5J){const _e=new m.$yi;for(const Je of ie._allEntries())Je._type===1&&k.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of ie._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,T.$2c)(T.$Hc.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:_.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:n.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return He}Me.from=Te;function Se(ie){const Fe=new o.$5J,He=new m.$xi;for(const _e of ie.edits)if(_e.textEdit){const Je=_e,rt=k.URI.revive(Je.resource),pt=n.to(Je.textEdit.range),wt=Je.textEdit.text,ft=Je.textEdit.insertAsSnippet;let gt;ft?gt=o.$4J.replace(pt,new o.$6J(wt)):gt=o.$2J.replace(pt,wt);const mt=He.get(rt);mt?mt.push(gt):He.set(rt,[gt])}else Fe.renameFile(k.URI.revive(_e.oldResource),k.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of He)Fe.set(_e,Je);return Fe}Me.to=Se})(Q||(e.WorkspaceEdit=Q={}));var V;(function(Me){const Te=Object.create(null);Te[o.SymbolKind.File]=0,Te[o.SymbolKind.Module]=1,Te[o.SymbolKind.Namespace]=2,Te[o.SymbolKind.Package]=3,Te[o.SymbolKind.Class]=4,Te[o.SymbolKind.Method]=5,Te[o.SymbolKind.Property]=6,Te[o.SymbolKind.Field]=7,Te[o.SymbolKind.Constructor]=8,Te[o.SymbolKind.Enum]=9,Te[o.SymbolKind.Interface]=10,Te[o.SymbolKind.Function]=11,Te[o.SymbolKind.Variable]=12,Te[o.SymbolKind.Constant]=13,Te[o.SymbolKind.String]=14,Te[o.SymbolKind.Number]=15,Te[o.SymbolKind.Boolean]=16,Te[o.SymbolKind.Array]=17,Te[o.SymbolKind.Object]=18,Te[o.SymbolKind.Key]=19,Te[o.SymbolKind.Null]=20,Te[o.SymbolKind.EnumMember]=21,Te[o.SymbolKind.Struct]=22,Te[o.SymbolKind.Event]=23,Te[o.SymbolKind.Operator]=24,Te[o.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function ie(Fe){for(const He in Te)if(Te[He]===Fe)return Number(He);return o.SymbolKind.Property}Me.to=ie})(V||(e.SymbolKind=V={}));var ee;(function(Me){function Te(ie){switch(ie){case o.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(ie){switch(ie){case 1:return o.SymbolTag.Deprecated}}Me.to=Se})(ee||(e.SymbolTag=ee={}));var me;(function(Me){function Te(ie){return{name:ie.name,kind:V.from(ie.kind),tags:ie.tags&&ie.tags.map(ee.from),containerName:ie.containerName,location:q.from(ie.location)}}Me.from=Te;function Se(ie){const Fe=new o.$_J(ie.name,V.to(ie.kind),ie.containerName,q.to(ie.location));return Fe.tags=ie.tags&&ie.tags.map(ee.to),Fe}Me.to=Se})(me||(e.WorkspaceSymbol=me={}));var ae;(function(Me){function Te(ie){const Fe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),kind:V.from(ie.kind),tags:ie.tags?.map(ee.from)??[]};return ie.children&&(Fe.children=ie.children.map(Te)),Fe}Me.from=Te;function Se(ie){const Fe=new o.$aK(ie.name,ie.detail,V.to(ie.kind),n.to(ie.range),n.to(ie.selectionRange));return(0,C.$Ef)(ie.tags)&&(Fe.tags=ie.tags.map(ee.to)),ie.children&&(Fe.children=ie.children.map(Se)),Fe}Me.to=Se})(ae||(e.DocumentSymbol=ae={}));var te;(function(Me){function Te(ie){const Fe=new o.$fK(V.to(ie.kind),ie.name,ie.detail||"",k.URI.revive(ie.uri),n.to(ie.range),n.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Se(ie,Fe,He){if(Fe=Fe??ie._sessionId,He=He??ie._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:ie.name,detail:ie.detail,kind:V.from(ie.kind),uri:ie.uri,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),tags:ie.tags?.map(ee.from)}}Me.from=Se})(te||(e.CallHierarchyItem=te={}));var X;(function(Me){function Te(Se){return new o.$gK(te.to(Se.from),Se.fromRanges.map(ie=>n.to(ie)))}Me.to=Te})(X||(e.CallHierarchyIncomingCall=X={}));var U;(function(Me){function Te(Se){return new o.$hK(te.to(Se.to),Se.fromRanges.map(ie=>n.to(ie)))}Me.to=Te})(U||(e.CallHierarchyOutgoingCall=U={}));var q;(function(Me){function Te(ie){return{range:ie.range&&n.from(ie.range),uri:ie.uri}}Me.from=Te;function Se(ie){return new o.$7J(k.URI.revive(ie.uri),n.to(ie.range))}Me.to=Se})(q||(e.location=q={}));var G;(function(Me){function Te(ie){const Fe=ie,He=ie;return{originSelectionRange:Fe.originSelectionRange?n.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:n.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?n.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(ie){return{targetUri:k.URI.revive(ie.uri),targetRange:n.to(ie.range),targetSelectionRange:ie.targetSelectionRange?n.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?n.to(ie.originSelectionRange):void 0}}Me.to=Se})(G||(e.DefinitionLink=G={}));var ce;(function(Me){function Te(ie){return{range:n.from(ie.range),contents:M.fromMany(ie.contents)}}Me.from=Te;function Se(ie){return new o.$0J(ie.contents.map(M.to),n.to(ie.range))}Me.to=Se})(ce||(e.Hover=ce={}));var re;(function(Me){function Te(ie){return{range:n.from(ie.range),expression:ie.expression}}Me.from=Te;function Se(ie){return new o.$4K(n.to(ie.range),ie.expression)}Me.to=Se})(re||(e.EvaluatableExpression=re={}));var de;(function(Me){function Te(ie){if(ie instanceof o.$5K)return{type:"text",range:n.from(ie.range),text:ie.text};if(ie instanceof o.$6K)return{type:"variable",range:n.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof o.$7K)return{type:"expression",range:n.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(ie){switch(ie.type){case"text":return{range:n.to(ie.range),text:ie.text};case"variable":return{range:n.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:n.to(ie.range),expression:ie.expression}}}Me.to=Se})(de||(e.InlineValue=de={}));var Ee;(function(Me){function Te(ie){return{frameId:ie.frameId,stoppedLocation:n.from(ie.stoppedLocation)}}Me.from=Te;function Se(ie){return new o.$8K(ie.frameId,n.to(ie.stoppedLocation))}Me.to=Se})(Ee||(e.InlineValueContext=Ee={}));var he;(function(Me){function Te(ie){return{range:n.from(ie.range),kind:ie.kind}}Me.from=Te;function Se(ie){return new o.$$J(n.to(ie.range),ie.kind)}Me.to=Se})(he||(e.DocumentHighlight=he={}));var ge;(function(Me){function Te(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Me.to=Te})(ge||(e.CompletionTriggerKind=ge={}));var ne;(function(Me){function Te(Se){return{triggerKind:ge.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(ne||(e.CompletionContext=ne={}));var ue;(function(Me){function Te(ie){switch(ie){case o.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(ie){switch(ie){case 1:return o.CompletionItemTag.Deprecated}}Me.to=Se})(ue||(e.CompletionItemTag=ue={}));var we;(function(Me){const Te=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Te.get(He)??9}Me.from=Se;const ie=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return ie.get(He)??o.CompletionItemKind.Property}Me.to=Fe})(we||(e.CompletionItemKind=we={}));var Pe;(function(Me){function Te(Se,ie){const Fe=new o.$pK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=we.to(Se.kind),Fe.tags=Se.tags?.map(ue.to),Fe.detail=Se.detail,Fe.documentation=A.$Xj(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,D.$hs.isIRange(Se.range)?Fe.range=n.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:n.to(Se.range.insert),replacing:n.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new o.$6J(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof o.$WJ?new o.$2J(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>_.to(He))),Fe.command=ie&&Se.command?ie.fromInternal(Se.command):void 0,Fe}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var B;(function(Me){function Te(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:M.fromStrict(ie.documentation)}}Me.from=Te;function Se(ie){return{label:ie.label,documentation:A.$Xj(ie.documentation)?M.to(ie.documentation):ie.documentation}}Me.to=Se})(B||(e.ParameterInformation=B={}));var Z;(function(Me){function Te(ie){return{label:ie.label,documentation:M.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(B.from):[],activeParameter:ie.activeParameter}}Me.from=Te;function Se(ie){return{label:ie.label,documentation:A.$Xj(ie.documentation)?M.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(B.to):[],activeParameter:ie.activeParameter}}Me.to=Se})(Z||(e.SignatureInformation=Z={}));var x;(function(Me){function Te(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(Z.from):[]}}Me.from=Te;function Se(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(Z.to):[]}}Me.to=Se})(x||(e.SignatureHelp=x={}));var se;(function(Me){function Te(Se,ie){const Fe=new o.$oK(l.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(Y.to.bind(void 0,Se)),ie.kind&&fe.to(ie.kind));return Fe.textEdits=ie.textEdits&&ie.textEdits.map(_.to),Fe.tooltip=A.$Xj(ie.tooltip)?M.to(ie.tooltip):ie.tooltip,Fe.paddingLeft=ie.paddingLeft,Fe.paddingRight=ie.paddingRight,Fe}Me.to=Te})(se||(e.InlayHint=se={}));var Y;(function(Me){function Te(Se,ie){const Fe=new o.$nK(ie.label);return Fe.tooltip=A.$Xj(ie.tooltip)?M.to(ie.tooltip):ie.tooltip,y.Command.is(ie.command)&&(Fe.command=Se.fromInternal(ie.command)),ie.location&&(Fe.location=q.to(ie.location)),Fe}Me.to=Te})(Y||(e.InlayHintLabelPart=Y={}));var fe;(function(Me){function Te(ie){return ie}Me.from=Te;function Se(ie){return ie}Me.to=Se})(fe||(e.InlayHintKind=fe={}));var ye;(function(Me){function Te(ie){return{range:n.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Me.from=Te;function Se(ie){let Fe;if(ie.url)try{Fe=typeof ie.url=="string"?k.URI.parse(ie.url,!0):k.URI.revive(ie.url)}catch{}return new o.$uK(n.to(ie.range),Fe)}Me.to=Se})(ye||(e.DocumentLink=ye={}));var ze;(function(Me){function Te(ie){const Fe=new o.$xK(ie.label);return ie.textEdit&&(Fe.textEdit=_.to(ie.textEdit)),ie.additionalTextEdits&&(Fe.additionalTextEdits=ie.additionalTextEdits.map(He=>_.to(He))),Fe}Me.to=Te;function Se(ie){return{label:ie.label,textEdit:ie.textEdit?_.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Fe=>_.from(Fe)):void 0}}Me.from=Se})(ze||(e.ColorPresentation=ze={}));var We;(function(Me){function Te(ie){return new o.$vK(ie[0],ie[1],ie[2],ie[3])}Me.to=Te;function Se(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Me.from=Se})(We||(e.Color=We={}));var xe;(function(Me){function Te(ie){return{range:n.from(ie.range)}}Me.from=Te;function Se(ie){return new o.$eK(n.to(ie.range))}Me.to=Se})(xe||(e.SelectionRange=xe={}));var Ye;(function(Me){function Te(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(ie){switch(ie){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(ie){switch(ie){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(ie){if(ie===o.EndOfLine.CRLF)return 1;if(ie===o.EndOfLine.LF)return 0}Me.from=Te;function Se(ie){if(ie===1)return o.EndOfLine.CRLF;if(ie===0)return o.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Me){function Te(ie){const Fe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Fe.kind=Ve.from(ie.kind)),Fe}Me.from=Te;function Se(ie){const Fe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Fe.kind=Ve.to(ie.kind)),Fe}Me.to=Se})(Ne||(e.FoldingRange=Ne={}));var Ve;(function(Me){function Te(ie){if(ie)switch(ie){case o.FoldingRangeKind.Comment:return y.$9s.Comment;case o.FoldingRangeKind.Imports:return y.$9s.Imports;case o.FoldingRangeKind.Region:return y.$9s.Region}}Me.from=Te;function Se(ie){if(ie)switch(ie.value){case y.$9s.Comment.value:return o.FoldingRangeKind.Comment;case y.$9s.Imports.value:return o.FoldingRangeKind.Imports;case y.$9s.Region.value:return o.FoldingRangeKind.Region}}Me.to=Se})(Ve||(e.FoldingRangeKind=Ve={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?n.from(Se.selection):void 0,override:typeof Se.override=="boolean"?s.$DE.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Qe;(function(Me){function Te(He){return He instanceof o.$RK?He.toJSON():typeof He=="string"?He:Se(He)||ie(He)?new o.$RK(He.baseUri??He.base,He.pattern).toJSON():He}Me.from=Te;function Se(He){const _e=He;return _e?k.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ie(He){const _e=He;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.$RK(k.URI.revive(He.baseUri),He.pattern)}Me.to=Fe})(Qe||(e.GlobPattern=Qe={}));var le;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ie=Se;return{language:ie.language,scheme:ie.scheme,pattern:Qe.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Me.from=Te})(le||(e.LanguageSelector=le={}));var oe;(function(Me){function Te(ie){return!!ie&&typeof ie=="object"&&"selections"in ie&&Array.isArray(ie.selections)&&ie.selections.every(Fe=>Fe instanceof o.$XJ)&&"related"in ie&&Array.isArray(ie.related)&&ie.related.every(Fe=>Fe&&typeof Fe=="object"&&k.URI.isUri(Fe.uri)&&Fe.range instanceof o.$WJ)}Me.is=Te;function Se(ie){return{selections:ie.selections.map(Fe=>c.from(Fe)),related:ie.related.map(Fe=>({uri:k.URI.from(Fe.uri),range:n.from(Fe.range)}))}}Me.from=Se})(oe||(e.MappedEditsContext=oe={}));var Ie;(function(Me){function Te(ie){return{start:ie.start,end:ie.end}}Me.from=Te;function Se(ie){return new o.$gL(ie.start,ie.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var qe;(function(Me){function Te(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Me.to=Te;function Se(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Me.from=Se})(qe||(e.NotebookCellExecutionSummary=qe={}));var je;(function(Me){function Te(Se){if(Se===d.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===d.NotebookCellExecutionState.Pending)return;if(Se===d.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(je||(e.NotebookCellExecutionState=je={}));var Xe;(function(Me){function Te(ie){switch(ie){case o.NotebookCellKind.Markup:return d.CellKind.Markup;case o.NotebookCellKind.Code:default:return d.CellKind.Code}}Me.from=Te;function Se(ie){switch(ie){case d.CellKind.Markup:return o.NotebookCellKind.Markup;case d.CellKind.Code:default:return o.NotebookCellKind.Code}}Me.to=Se})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Me){function Te(ie){const Fe={metadata:ie.metadata??Object.create(null),cells:[]};for(const He of ie.cells)o.$hL.validate(He),Fe.cells.push(ot.from(He));return Fe}Me.from=Te;function Se(ie){const Fe=new o.$iL(ie.cells.map(ot.to));return(0,p.$ye)(ie.metadata)||(Fe.metadata=ie.metadata),Fe}Me.to=Se})(nt||(e.NotebookData=nt={}));var ot;(function(Me){function Te(ie){return{cellKind:Xe.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:qe.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Dt.from):[]}}Me.from=Te;function Se(ie){return new o.$hL(Xe.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Dt.to):void 0,ie.metadata,ie.internalMetadata?qe.to(ie.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var bt;(function(Me){function Te(ie){return{mime:ie.mime,valueBytes:T.$Hc.wrap(ie.data)}}Me.from=Te;function Se(ie){return new o.$jL(ie.valueBytes.buffer,ie.mime)}Me.to=Se})(bt||(e.NotebookCellOutputItem=bt={}));var Dt;(function(Me){function Te(ie){return{outputId:ie.id,items:ie.items.map(bt.from),metadata:ie.metadata}}Me.from=Te;function Se(ie){const Fe=ie.items.map(bt.to);return new o.$kL(Fe,ie.outputId,ie.metadata)}Me.to=Se})(Dt||(e.NotebookCellOutput=Dt={}));var Qt;(function(Me){function Te(Fe){return ie(Fe)?{include:Qe.from(Fe.include)??void 0,exclude:Qe.from(Fe.exclude)??void 0}:Qe.from(Fe)??void 0}Me.from=Te;function Se(Fe){return ie(Fe)?{include:Qe.to(Fe.include),exclude:Qe.to(Fe.exclude)}:Qe.to(Fe)}Me.to=Se;function ie(Fe){const He=Fe;return He?!(0,p.$ue)(He.include)&&!(0,p.$ue)(He.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Me){function Te(Se,ie,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Vt||(e.NotebookStatusBarItem=Vt={}));var vt;(function(Me){function Te(Se,ie,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ie.toInternal(He,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var Tt;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Nt;(function(Me){function Te(ie){return{uri:ie.uri,provides:ie.provides}}Me.from=Te;function Se(ie){return new o.$mL(k.URI.revive(ie.uri),ie.provides)}Me.to=Se})(Nt||(e.NotebookRendererScript=Nt={}));var Kt;(function(Me){function Te(ie){return{message:M.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:n.from(ie.location.range),uri:ie.location.uri}}}Me.from=Te;function Se(ie){const Fe=new o.$sL(typeof ie.message=="string"?ie.message:M.to(ie.message));return Fe.actualOutput=ie.actual,Fe.expectedOutput=ie.expected,Fe.contextValue=ie.contextValue,Fe.location=ie.location?q.to(ie.location):void 0,Fe}Me.to=Se})(Kt||(e.TestMessage=Kt={}));var At;(function(Me){Me.namespace=g.$JI,Me.denamespace=g.$KI})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(ie){const Fe=(0,i.$QL)(ie).controllerId;return{extId:b.$FI.fromExtHostTestItem(ie,Fe).toString(),label:ie.label,uri:k.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(He=>At.namespace(Fe,He.id)),range:D.$hs.lift(n.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&M.fromStrict(ie.error)||null}}Me.from=Te;function Se(ie){return{parent:void 0,error:void 0,id:b.$FI.fromString(ie.extId).localId,label:ie.label,uri:k.URI.revive(ie.uri),tags:(ie.tags||[]).map(Fe=>{const{tagId:He}=At.denamespace(Fe);return new o.$tL(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:n.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(ie){return{id:ie.id}}Me.from=Te;function Se(ie){return new o.$tL(ie.id)}Me.to=Se}(At||(e.TestTag=At={}));var Ot;(function(Me){const Te=(ie,Fe)=>{const He=[];for(const[Je,rt]of Fe)b.$FI.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),He.push(rt));const _e={...Rt.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Kt.to)})),children:He.map(Je=>Te(Je,Fe))};for(const Je of _e.children)Je.parent=_e;return _e};function Se(ie){const Fe=[],He=new Map;for(const _e of ie.items){He.set(_e.item.extId,_e);const Je=b.$FI.root(_e.item.extId);ie.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(_e.item.extId))&&Fe.push(_e)}return{completedAt:ie.completedAt,results:Fe.map(_e=>Te(_e,He))}}Me.to=Se})(Ot||(e.TestResults=Ot={}));var Ut;(function(Me){function Te(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?l.from(He):n.from(He)}function ie(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Me.fromDetailed=ie;function Fe(He){return{uri:He.uri,statement:Te(He.statementCoverage),branch:He.branchCoverage&&Te(He.branchCoverage),function:He.functionCoverage&&Te(He.functionCoverage),details:He.detailedCoverage?.map(ie)}}Me.fromFile=Fe})(Ut||(e.TestCoverage=Ut={}));var qt;(function(Me){function Te(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Me.to=Te})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Me){function Te(ie){const Fe=new o.$zL(V.to(ie.kind),ie.name,ie.detail||"",k.URI.revive(ie.uri),n.to(ie.range),n.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Se(ie,Fe,He){if(Fe=Fe??ie._sessionId,He=He??ie._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:V.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:n.from(ie.range),selectionRange:n.from(ie.selectionRange),tags:ie.tags?.map(ee.from)}}Me.from=Se})(Bt||(e.TypeHierarchyItem=Bt={}));var ct;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(ct||(e.ViewBadge=ct={}));var lt;(function(Me){function Te(He,_e,Je){const rt=_e.fileData;return rt?new o.$KK(new o.$LK(rt.name,k.URI.revive(rt.uri),rt.id,(0,R.$bb)(()=>Je(rt.id)))):He===P.$Er.uriList&&_e.uriListData?new o.$JK(Fe(_e.uriListData)):new o.$JK(_e.asString)}Me.to=Te;async function Se(He,_e){const Je=await _e.asString();if(He===P.$Er.uriList)return{asString:Je,fileData:void 0,uriListData:ie(Je)};const rt=_e.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Se;function ie(He){return f.$Qs.split(He).map(_e=>{if(_e.startsWith("#"))return _e;try{return k.URI.parse(_e)}catch{}return _e})}function Fe(He){return f.$Qs.create(He.map(_e=>typeof _e=="string"?_e:k.URI.revive(_e)))}})(lt||(e.DataTransferItem=lt={}));var Jt;(function(Me){function Te(ie,Fe){const He=ie.items.map(([_e,Je])=>[_e,lt.to(_e,Je,Fe)]);return new o.$MK(He)}Me.toDataTransfer=Te;async function Se(ie){const Fe={items:[]},He=[];for(const[_e,Je]of ie)He.push((async()=>{Fe.items.push([_e,await lt.from(_e,Je)])})());return await Promise.all(He),Fe}Me.from=Se})(Jt||(e.DataTransfer=Jt={}));var Pt;(function(Me){function Te(ie){return{message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.to=Te;function Se(ie){return{kind:"reply",message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.from=Se})(Pt||(e.ChatReplyFollowup=Pt={}));var kt;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:Pt.from(Se)}Me.from=Te})(kt||(e.ChatFollowup=kt={}));var dt;(function(Me){function Te(ie){const Fe=new o.$JL(Ct.to(ie.role),ie.content);return Fe.name=ie.name,Fe}Me.to=Te;function Se(ie){return{role:Ct.from(ie.role),content:ie.content,name:ie.name}}Me.from=Se})(dt||(e.ChatMessage=dt={}));var Ct;(function(Me){function Te(ie){switch(ie){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant;case 3:return o.ChatMessageRole.Function}}Me.to=Te;function Se(ie){switch(ie){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.Function:return 3;case o.ChatMessageRole.User:default:return 1}}Me.from=Se})(Ct||(e.ChatMessageRole=Ct={}));var Ft;(function(Me){function Te(ie){return{level:Et.to(ie.level),value:ie.value,description:ie.description}}Me.to=Te;function Se(ie){return{level:Et.from(ie.level),value:ie.value,description:ie.description}}Me.from=Se})(Ft||(e.ChatVariable=Ft={}));var Et;(function(Me){function Te(ie){switch(ie){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Me.to=Te;function Se(ie){switch(ie){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(Et||(e.ChatVariableLevel=Et={}));var Ge;(function(Me){function Te(Se){switch(Se){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ge||(e.InteractiveEditorResponseFeedbackKind=Ge={}));var zt;(function(Me){function Te(Se,ie,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ie.toInternal(Se,Fe)}Me.from=Te})(zt||(e.TerminalQuickFix=zt={}))}),define(De[280],Ce([1,0,2,8,7,13,75]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=void 0;class m{constructor($,P,I,p={timeout:1500,errors:3}){this.c=$,this.d=P,this.f=I,this.g=p,this.a=new A.$vb,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(P,I,p)=>{const D={dispose:this.a.push([P,I,$])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave($,P){const I=C.URI.revive($);let p=!1;const k=setTimeout(()=>p=!0,this.g.timeout),D=[];try{for(const y of[...this.a]){if(p)break;const r=this.d.getDocument(I),i=await this.h(y,{document:r,reason:R.TextDocumentSaveReason.to(P)});D.push(i)}}finally{clearTimeout(k)}return D}h([$,P,I],p){const k=this.b.get($);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(I,$,P,p).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const y=this.b.get($);this.b.set($,y?y+1:1),typeof y=="number"&&y>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,P,I,p){const k=[],D=Date.now(),{document:y,reason:r}=p,{version:i}=y,s=Object.freeze({document:y,reason:r,waitUntil(d){if(Object.isFrozen(k))throw(0,T.$6)("waitUntil can not be called async");k.push(Promise.resolve(d))}});try{P.apply(I,[s])}catch(d){return Promise.reject(d)}return Object.freeze(k),new Promise((d,b)=>{const g=setTimeout(()=>b(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(g),d(t)}).catch(t=>{clearTimeout(g),b(t)})}).then(d=>{const b={edits:[]};for(const g of d)if(Array.isArray(g)&&g.every(t=>t instanceof f.$2J))for(const{newText:t,newEol:o,range:c}of g)b.edits.push({resource:y.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:t,eol:o&&R.EndOfLine.from(o)}});if(b.edits.length!==0)return i===y.version?this.f.$tryApplyWorkspaceEdit(b):Promise.reject(new Error("concurrent_edits"))})}}e.$3ac=m}),define(De[281],Ce([1,0,17,2,13,7,108]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=e.$dcc=void 0;class m{constructor(I,p,k,D){this.start=I,this.deletedCount=p,this.deletedItems=k,this.items=D}asApiEvent(){return{range:new R.$gL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(I,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,p,k){this.notebook=I,this.h=p,this.j=k,this.handle=k.handle,this.uri=T.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(f.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(k)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,p,k){const D=k.map(f.NotebookCellOutputItem.to),y=this.a.find(r=>r.id===I);if(y&&(p||(y.items.length=0),y.items.push(...D),y.items.length>1&&y.items.every(r=>A.$ZH(r.mime)))){const r=new Map,i=[];y.items.forEach(s=>{let d;r.has(s.mime)?d=r.get(s.mime):(d=[],r.set(s.mime,d),i.push(s.mime)),d.push(s.data)}),y.items.length=0,i.forEach(s=>{const d=A.$1H(r.get(s));y.items.push({mime:s,data:d.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$dcc=S;class ${static{this.a=0}constructor(I,p,k,D,y){this.k=I,this.l=p,this.m=k,this.uri=D,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=y.viewType,this.f=Object.freeze(y.metadata??Object.create(null)),this.r([[0,0,y.cells]],!0,void 0),this.g=y.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(k){return k=I.n(k),I.b[k].apiCell},getCells(k){return(k?I.p(k):I.b).map(y=>y.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,k){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:k});const D={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},y=[];for(const i of I.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,D.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,D.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),y.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),y.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),y.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?y.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),y.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),y.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const r=new Map;for(let i=0;i<y.length;i++){const s=y[i],d=r.get(s.cell);if(d===void 0){const b=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...s});r.set(s.cell,b-1)}else D.cellChanges[d]={...D.cellChanges[d],...s}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,k=I.end|0;return p<0&&(p=0),k>this.b.length&&(k=this.b.length),I.with({start:p,end:k})}p(I){I=this.o(I);const p=[];for(let k=I.start;k<I.end;k++)p.push(this.b[k]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,k){if(this.j)return;const D=[],y=[],r=[];if(I.reverse().forEach(i=>{const d=i[2].map(t=>{const o=new S(this,this.l,t);return p||y.push(S.asModelAddData(this.apiNotebook,t)),o}),b=new m(i[0],i[1],[],d),g=this.b.splice(i[0],i[1],...d);for(const t of g)r.push(t.uri),b.deletedItems.push(t.apiCell);D.push(b)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:y,removedDocuments:r}),k)for(const i of D)k.push(i.asApiEvent())}s(I,p,k,D){const y=this.b.splice(I,p);this.b.splice(k,0,...y);const r=[new m(I,p,y.map(i=>i.apiCell),[]),new m(k,0,[],y)];for(const i of r)D.push(i.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,k,D){this.b[I].setOutputItems(p,k,D)}v(I,p){const k=this.b[I];k.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(k.uri,p)}w(I,p){const k=this.b[I];k.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$ecc=$}),define(De[282],Ce([1,0,4,2,13,7]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class A{constructor(S,$,P,I={timeout:1500,errors:3}){this.b=S,this.c=$,this.d=P,this.f=I,this.a=new C.$jc}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return($,P,I)=>{const p=function(D){$.call(P,D)};return p.extension=S,this.a.event(p,void 0,I)}}async $participateInSave(S,$,P){const I=T.URI.revive(S),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:f.TextDocumentSaveReason.to($)},P,async(y,r)=>{const i=Date.now(),s=await await Promise.resolve(y);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!P.isCancellationRequested&&s&&(s instanceof R.$5J?k.push(s):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(k.length===0)return!0;const D={edits:[]};for(const y of k){const{edits:r}=f.WorkspaceEdit.from(y);D.edits=D.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Ecc=A}),define(De[144],Ce([1,0,8,13,7]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,S,$,P,I,p){this.id=m,this.f=S,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=P,this.c=p}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(S){this.selections=[S]},get selections(){return m.a},set selections(S){if(!Array.isArray(S)||!S.every(f.$gL.isNotebookRange))throw(0,C.$5)("selections");m.a=S,m.g(S)},get visibleRanges(){return m.b},revealRange(S,$){m.f.$tryRevealRange(m.id,T.NotebookRange.from(S),$??f.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$fcc=R}),define(De[283],Ce([1,0,8,4,14,13]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;let A=class{constructor(S,$){this.c=S,this.d=$,this.a=new T.$hc({onListenerError:C.$Z}),this.b=new T.$hc({onListenerError:C.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,$);const P=this.d.getEditorById(S);$.visibleRanges&&P._acceptVisibleRanges($.visibleRanges.ranges.map(R.NotebookRange.to)),$.selections&&P._acceptSelections($.selections.selections.map(R.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const $ in S)this.d.getEditorById($)._acceptViewColumn(R.ViewColumn.to(S[$]))}};e.$xcc=A,e.$xcc=A=Ke([Be(0,f.$3i)],A)}),define(De[284],Ce([1,0,13,84,208,21,56,8]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class S{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,k,D){const y=this.b++,{title:r,location:i,cancellable:s}=k,d={label:(0,f.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(y,{location:C.ProgressLocation.from(i),title:r,source:d,cancellable:s},p.isUnderDevelopment?void 0:p.identifier.value).catch(m.$Z),this.d(y,D,!!s)}d(p,k,D){let y;D&&(y=new R.$rc,this.c.set(p,y));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),y?.dispose()};let i;try{i=k(new P(this.a,p),D&&y?y.token:R.CancellationToken.None)}catch(s){throw r(p),s}return i.then(s=>r(p),s=>r(p)),i}$acceptProgressCanceled(p){const k=this.c.get(p);k&&(k.cancel(),this.c.delete(p))}}e.$Bbc=S;function $(I,p){return I.message=p.message,typeof p.increment=="number"&&(typeof I.increment=="number"?I.increment+=p.increment:I.increment=p.increment),I}class P extends T.$1u{constructor(p,k){super(D=>this.throttledReport(D)),this.f=p,this.g=k}throttledReport(p){this.f.$progressReport(this.g,p)}}Ke([(0,A.$6g)(100,(I,p)=>$(I,p),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,67,109,88,13,2]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=e.$8L=e.$7L=void 0;const $=(d,b,g,t)=>{let o=b;return{enumerable:!0,configurable:!1,get(){return o},set(c){if(!g(o,c)){const n=o;o=c,d.listener?.(t(c,n))}}}},P=(d,b)=>d===b,I={range:(d,b)=>d===b?!0:!d||!b?!1:d.isEqual(b),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(d,b)=>!(d.length!==b.length||d.some(g=>!b.find(t=>g.id===t.id)))},p=d=>b=>({op:4,update:d(b)}),k=(d,b)=>({range:(()=>{let g;const t=p(o=>({range:C.$hs.lift(m.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return g},set(o){d.listener?.({op:6}),I.range(g,o)||(g=o,d.listener?.(t(o)))}}})(),label:$(d,b,I.label,p(g=>({label:g}))),description:$(d,void 0,I.description,p(g=>({description:g}))),sortText:$(d,void 0,I.sortText,p(g=>({sortText:g}))),canResolveChildren:$(d,!1,I.canResolveChildren,g=>({op:2,state:g})),busy:$(d,!1,I.busy,p(g=>({busy:g}))),error:$(d,void 0,I.error,p(g=>({error:m.MarkdownString.fromStrict(g)||null}))),tags:$(d,[],I.tags,(g,t)=>({op:1,new:g.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),D=d=>{const b=f.$FI.fromString(d.extId),g=new r(b.controllerId,b.localId,d.label,S.URI.revive(d.uri)||void 0);return g.range=m.Range.to(d.range||void 0),g.description=d.description||void 0,g.sortText=d.sortText||void 0,g.tags=d.tags.map(t=>m.TestTag.to({id:(0,A.$KI)(t).tagId})),g},y=d=>{let b;for(const g of d.tests){const t=D(g.item);(0,T.$QL)(t).parent=b,b=t}return b};e.$7L=y;class r{constructor(b,g,t,o){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const c=(0,T.$PL)(this,b);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,R.$OL)(c,T.$QL,r),enumerable:!0,writable:!1},...k(c,t)})}}e.$8L=r;class i extends r{constructor(b,g){super(b,b,g,void 0),this._isRoot=!0}}e.$9L=i;class s extends R.$KL{constructor(b,g,t){super({controllerId:b,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:T.$QL,getChildren:o=>o.children,root:new i(b,g),toITestItem:m.TestItem.from})}}e.$0L=s}),define(De[146],Ce([1,0,57,8,119,13,7]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.$2L=void 0;class m{static{this.c=new f.$ZL("TextEditorDecorationType")}constructor(p,k,D){const y=m.c.nextId();p.$registerTextEditorDecorationType(k.identifier,y,R.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:y,dispose(){p.$removeTextEditorDecorationType(y)}})}}e.$2L=m;class S{constructor(p,k){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,k){this.k();let D=null;if(p instanceof A.$VJ)D=new A.$WJ(p,p);else if(p instanceof A.$WJ)D=p;else throw new Error("Unrecognized location");this.l(D,k,!1)}insert(p,k){this.k(),this.l(new A.$WJ(p,p),k,!0)}delete(p){this.k();let k=null;if(p instanceof A.$WJ)k=p;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(p,k,D){const y=this.c.validateRange(p);this.g.push({range:y,text:k,forceMoveMarkers:D})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,T.$5)("endOfLine");this.h=p}}class ${constructor(p,k,D,y){this.c=p,this.d=k,this._accept(D),this.e=y;const r=this;this.value={get tabSize(){return r.f},set tabSize(i){r.m(i)},get indentSize(){return r.g},set indentSize(i){r.o(i)},get insertSpaces(){return r.h},set insertSpaces(i){r.q(i)},get cursorStyle(){return r.j},set cursorStyle(i){r.s(i)},get lineNumbers(){return r.k},set lineNumbers(i){r.t(i)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}m(p){const k=this.l(p);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const k=Math.floor(p);return k>0?k:null}if(typeof p=="string"){const k=parseInt(p,10);return isNaN(k)?null:k>0?k:null}return null}o(p){const k=this.n(p);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const k=this.p(p);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(p)})))}assign(p){const k={};let D=!1;if(typeof p.tabSize<"u"){const y=this.l(p.tabSize);y==="auto"?(D=!0,k.tabSize=y):typeof y=="number"&&this.f!==y&&(this.f=y,D=!0,k.tabSize=y)}if(typeof p.indentSize<"u"){const y=this.n(p.indentSize);y==="tabSize"?(D=!0,k.indentSize=y):typeof y=="number"&&this.g!==y&&(this.g=y,D=!0,k.indentSize=y)}if(typeof p.insertSpaces<"u"){const y=this.p(p.insertSpaces);y==="auto"?(D=!0,k.insertSpaces=y):this.h!==y&&(this.h=y,D=!0,k.insertSpaces=y)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,D=!0,k.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,D=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(p,k){k.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(D)})}}e.$3L=$;class P{constructor(p,k,D,y,r,i,s,d){this.id=p,this.j=k,this.k=D,this.g=!1,this.h=new Set,this.c=r,this.d=new $(this.j,this.id,i,D),this.e=s,this.f=d;const b=this;this.value=Object.freeze({get document(){return y.value},set document(g){throw new T.$7("document")},get selection(){return b.c&&b.c[0]},set selection(g){if(!(g instanceof A.$XJ))throw(0,T.$5)("selection");b.c=[g],b.l()},get selections(){return b.c},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.$XJ)))throw(0,T.$5)("selections");b.c=g,b.l()},get visibleRanges(){return b.e},set visibleRanges(g){throw new T.$7("visibleRanges")},get options(){return b.d.value},set options(g){b.g||b.d.assign(g)},get viewColumn(){return b.f},set viewColumn(g){throw new T.$7("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new S(y.value,t);return g(o),b.m(o)},insertSnippet(g,t,o={undoStopBefore:!0,undoStopAfter:!0}){if(b.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=b.c.map(n=>R.Range.from(n));else if(t instanceof A.$VJ){const{lineNumber:n,column:a}=R.Position.from(t);c=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof A.$WJ)c=[R.Range.from(t)];else{c=[];for(const n of t)if(n instanceof A.$WJ)c.push(R.Range.from(n));else{const{lineNumber:a,column:l}=R.Position.from(n);c.push({startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l})}}return k.$tryInsertSnippet(p,y.value.version,g.value,c,o)},setDecorations(g,t){const o=t.length===0;o&&!b.h.has(g.key)||(o?b.h.delete(g.key):b.h.add(g.key),b.n(()=>{if(R.$RL(t))return k.$trySetDecorations(p,g.key,R.$SL(t));{const c=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const l=t[n];c[4*n]=l.start.line+1,c[4*n+1]=l.start.character+1,c[4*n+2]=l.end.line+1,c[4*n+3]=l.end.character+1}return k.$trySetDecorationsFast(p,g.key,c)}}))},revealRange(g,t){b.n(()=>k.$tryRevealRange(p,R.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){k.$tryShowEditor(p,R.ViewColumn.from(g))},hide(){k.$tryHideEditor(p)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,C.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,C.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,C.ok)(!this.g),this.f=p}_acceptSelections(p){(0,C.ok)(!this.g),this.c=p}async l(){const p=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const k=p.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const D=k.edits.map(r=>r.range);D.sort((r,i)=>r.end.line===i.end.line?r.end.character===i.end.character?r.start.line===i.start.line?r.start.character-i.start.character:r.start.line-i.start.line:r.end.character-i.end.character:r.end.line-i.end.line);for(let r=0,i=D.length-1;r<i;r++){const s=D[r].end;if(D[r+1].start.isBefore(s))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const y=k.edits.map(r=>({range:R.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,y,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$4L=P}),define(De[147],Ce([1,0,5,131]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=void 0,e.$0I=(0,C.$Ah)(T.$Gh)}),define(De[148],Ce([1,0,25,4,16,3]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e3b=e.$d3b=e.$c3b=e.$b3b=e.$a3b=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.$a3b=A;class m{static isHostExtension(r,i,s){if(i.getExtensionDescription(r))return!1;const d=s.getExtensionDescription(r);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(r,i){this.h=r,this.c=new T.$hc,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(k),this.e=new C.$Vl,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const i=this.h.readActivationEvents(r);if(Array.isArray(i))for(let s of i)s==="onUri"&&(s=`onUri:${C.$Tl.toKey(r.identifier)}`),this.g.has(s)||this.g.set(s,[]),this.g.get(s).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,i){this.d=D(this.d,i),this.d=this.d.concat(r);const s=m.k(this.d);return this.d=D(this.d,s.map(d=>d.identifier)),this.j(),this.c.fire(void 0),new A(s)}static k(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,o){this.addNode(t),this.addNode(o),this.c.has(t)?this.c.get(t).push(o):this.c.set(t,[o])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,o){const c=i.getArcs(t);for(let n=0;n<c.length;n++)if(!o.has(c[n]))return!1;return!0}getNodes(){return this.e}},s=new C.$Vl;for(const t of r)if(s.set(t.identifier,t),t.extensionDependencies)for(const o of t.extensionDependencies)i.addArc(C.$Tl.toKey(t.identifier),C.$Tl.toKey(o));const d=new Set;i.getNodes().filter(t=>i.getArcs(t).length===0).forEach(t=>d.add(t));const b=i.getNodes().filter(t=>!d.has(t));let g;do{g=!1;for(let t=0;t<b.length;t++){const o=b[t];i.hasOnlyGoodArcs(o,d)&&(b.splice(t,1),t--,d.add(o),g=!0)}}while(g);return b.map(t=>s.get(t))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.g.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const i=this.e.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.f)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$b3b=m,e.$c3b={readActivationEvents:y=>y.activationEvents};class S{constructor(r){this.d=new I,this.c=new m(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new $(this,i)}deltaExtensions(r,i,s){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,s)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$d3b=S;class $ extends R.$mb{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$e3b=$;class P{constructor(r){this.name=r,this.promise=new Promise((i,s)=>{this.c=i})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new P(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const s=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{i&&(clearTimeout(s),i=!1,this.d=!1,this.e())};r.resolve((0,R.$kb)(d))}}var p;(function(y){y[y.Builtin=0]="Builtin",y[y.User=1]="User",y[y.Dev=2]="Dev"})(p||(p={}));function k(y,r){const i=y.isBuiltin?0:y.isUnderDevelopment?2:1,s=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==s)return i-s;const d=f.$8c.basename(y.extensionLocation.path),b=f.$8c.basename(r.extensionLocation.path);return d<b?-1:d>b?1:0}function D(y,r){const i=new C.$Ul(r);return y.filter(s=>!i.has(s.identifier))}}),define(De[285],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.ExtHostConnectionType=void 0;var C;(function(P){P[P.IPC=1]="IPC",P[P.Socket=2]="Socket",P[P.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$lm=T;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$mm=f;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$nm=R;function A(P){delete P[T.ENV_KEY],delete P[f.ENV_KEY],delete P[R.ENV_KEY]}function m(P,I){A(I),P.serialize(I)}e.$om=m;function S(P){if(P[T.ENV_KEY])return $(P,new T(P[T.ENV_KEY]));if(P[f.ENV_KEY])return $(P,new f);if(P[R.ENV_KEY])return $(P,new R);throw new Error("No connection information defined in environment!")}e.$pm=S;function $(P,I){return A(P),I}}),define(De[111],Ce([1,0,22]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$3l=e.$2l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(T||(e.UIKind=T={}));var f;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A($){const P=C.$Hc.alloc(1);switch($){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$2l=A;function m($,P){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$3l=m;var S;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(De[89],Ce([1,0,5,4,14,26,111,65,85,23,2,3,210]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=e.$aM=e.$_L=void 0;let k=class extends I.$mb{constructor(i,s){super(),this.n=i,this.p=s,this.a=this.B(new T.$hc),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$hc),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=s.createLogger(this.j,{id:S.$co,name:(0,p.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(s.onDidChangeLogLevel(d=>{(0,f.$5i)(d)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,s,d){const b=this.getTelemetryDetails(),g=new D(s,d,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}),t=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...t,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(i,s,d){this.f=i,this.g=s,this.c=d??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const s=Object.create(null);switch(s["common.extname"]=`${i.publisher}.${i.name}`,s["common.extversion"]=i.version,s["common.vscodemachineid"]=this.n.telemetryInfo.machineId,s["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,s["common.vscodeversion"]=this.n.version,s["common.isnewappinstall"]=y(this.n.telemetryInfo.firstSessionDate),s["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:s["common.uikind"]="web";break;case A.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,m.$Nk)((0,S.$jo)(this.n.remote.authority)),s}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const s=this.getTelemetryDetails();this.m.forEach((d,b)=>{const g=d.filter(t=>!t.isDisposed);g.length===0?this.m.delete(b):this.m.set(b,g)}),this.m.forEach(d=>{for(const b of d)b.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,s){const b=this.m.get(i.value)?.filter(t=>!t.isDisposed);if(!b)return this.m.delete(i.value),!1;let g=!1;for(const t of b)t.ignoreUnhandledExtHostErrors||(t.logError(s),g=!0);return g}};e.$_L=k,e.$_L=k=Ke([Be(0,R.$$L),Be(1,f.$4i)],k);class D{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,s,d,b,g,t,o){this.g=d,this.h=b,this.i=g,this.j=t,this.a=new T.$hc,this.ignoreUnhandledExtHostErrors=s?.ignoreUnhandledErrors??!1,this.b=s?.ignoreBuiltInCommonProperties??!1,this.c=s?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(i,s){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:s},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let s="properties"in i?i.properties??{}:i;return s=(0,S.$mo)(s,[]),this.c&&(s=(0,$.$Wm)(s,this.c)),this.b||(s=(0,$.$Wm)(s,this.j)),"properties"in i?i.properties=s:i=s,i}k(i,s){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f?.sendEventData(i,s),this.h.trace(i,s))}logUsage(i,s){this.d.isUsageEnabled&&this.k(i,s)}logError(i,s){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,s);else{const d={name:i.name,message:i.message,stack:i.stack,cause:i.cause},b=(0,S.$mo)(d,[]),g=new Error(b.message,{cause:b.cause});g.stack=b.stack,g.name=b.name,s=this.mixInCommonPropsAndCleanData(s||{}),this.i||this.f.sendErrorData(g,s),this.h.trace("exception",s)}}get apiTelemetryLogger(){if(!this.e){const i=this,s={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(s)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$aM=D;function y(r){const i=Date.now()-new Date(r).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$bM=y,e.$cM=(0,C.$zh)("IExtHostTelemetry")}),define(De[27],Ce([1,0,4,2,252,137,25,5]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$Tl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,m.$zh)("extensionService");class S{constructor(g){this.dependency=g}}e.$JF=S;var $;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:R.$xF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(g,t){const o=[],c=[],n=[],a=[],l=I(this.c),v=I(g),E=(O,N)=>O.extensionLocation.toString()===N.extensionLocation.toString()||O.isBuiltin===N.isBuiltin||O.isUserBuiltin===N.isUserBuiltin||O.isUnderDevelopment===N.isUnderDevelopment;for(const O of this.c){const N=v.get(O.identifier);if(!N){o.push(O.identifier),l.delete(O.identifier);continue}if(!E(O,N)){o.push(O.identifier),l.delete(O.identifier);continue}}for(const O of g){const N=l.get(O.identifier);if(!N){c.push(O);continue}if(!E(N,O)){o.push(N.identifier),l.delete(N.identifier);continue}}const u=new A.$Ul(this.d),h=new A.$Ul(t);for(const O of this.d)h.has(O)||n.push(O);for(const O of t)u.has(O)||a.push(O);const w=R.$xF.createActivationEventsMap(c),L={toRemove:o,toAdd:c,addActivationEvents:w,myToRemove:n,myToAdd:a};return this.delta(L),L}delta(g){const{toRemove:t,toAdd:o,myToRemove:c,myToAdd:n}=g,a=new A.$Ul(t),l=new A.$Ul(c);for(let v=0;v<this.c.length;v++)a.has(this.c[v].identifier)&&(this.c.splice(v,1),v--);for(let v=0;v<this.d.length;v++)l.has(this.d[v])&&(this.d.splice(v,1),v--);for(const v of o)this.c.push(v);for(const v of n)this.d.push(v)}containsExtension(g){for(const t of this.d)if(A.$Tl.equals(t,g))return!0;return!1}}e.$KF=P;function I(b){const g=new A.$Vl;for(const t of b)g.set(t.identifier,t);return g}function p(b,g){return b.enabledApiProposals?b.enabledApiProposals.includes(g):!1}e.$LF=p;function k(b,g){if(!p(b,g))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.$MF=k;class D{constructor(g,t,o,c){this.codeLoadingTime=g,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=c}}e.$NF=D;class y{constructor(g,t){this.description=g,this.value=t}}e.$OF=y;var r;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function i(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,f.$so)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function s(b,g){return{identifier:new A.$Tl((0,f.$qo)(b.manifest.publisher,b.manifest.name)),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!g,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform}}e.$QF=s;class d{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(g,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=d}),define(De[286],Ce([1,0,8,148,25,27,14,11]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=e.$7ac=e.$6ac=e.$5ac=e.$4ac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(i,s,d,b){this.startup=i,this.codeLoadingTime=s,this.activateCallTime=d,this.activateResolvedTime=b}}e.$4ac=S;class ${constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,s){return i===-1||s===-1?-1:s-i}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$5ac=$;class P{constructor(i,s,d,b,g,t){this.activationFailed=i,this.activationFailedError=s,this.activationTimes=d,this.module=b,this.exports=g,this.subscriptions=t}}e.$6ac=P;class I extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$7ac=I;class p extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8ac=p;class k extends P{constructor(i){super(!0,i,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(i,s,d,b){this.g=b,this.a=i,this.b=s,this.c=d,this.d=new f.$Vl,this.f=Object.create(null)}dispose(){for(const[i,s]of this.d)s.dispose()}async waitForActivatingExtensions(){const i=[];for(const[s,d]of this.d)i.push(d.wait());await Promise.all(i)}isActivated(i){const s=this.d.get(i);return!!(s&&s.value)}getActivatedExtension(i){const s=this.d.get(i);if(!s||!s.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return s.value}async activateByEvent(i,s){if(this.f[i])return;const d=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(d.map(b=>({id:b.identifier,reason:{startup:s,extensionId:b.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,s){const d=this.a.getExtensionDescription(i);if(!d)throw new Error(`Extension '${i}' is not known`);return this.h([{id:d.identifier,reason:s}])}async h(i){const s=i.filter(d=>!this.isActivated(d.id)).map(d=>this.j(d));await Promise.all(s.map(d=>d.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const s=this.a.getExtensionDescription(i.id);if(!s){const g=new Error(`Cannot activate unknown extension '${i.id.value}'`),t=this.k(i,null,[],new k(g));return this.c.onExtensionActivationError(i.id,g,new R.$JF(i.id.value)),t}const d=[],b=typeof s.extensionDependencies>"u"?[]:s.extensionDependencies;for(const g of b){if(this.m(g))continue;const t=this.d.get(g);if(t){d.push(t);continue}if(this.l(g)){d.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:i.reason}));continue}const o=this.a.getExtensionDescription(g);if(o){if(!o.main&&!o.browser)continue;d.push(this.j({id:o.identifier,reason:i.reason}));continue}const c=s.displayName||s.identifier.value,n=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${g}'`),a=this.k(i,s.displayName,[],new k(n));return this.c.onExtensionActivationError(s.identifier,n,new R.$JF(g)),a}return this.k(i,s.displayName,d,null)}k(i,s,d,b){const g=new y(i.id,s,i.reason,d,b,this.c,this.g);return this.d.set(i.id,g),g}l(i){return T.$b3b.isHostExtension(i,this.a,this.b)}m(i){const s=this.b.getExtensionDescription(i);return s?!s.main&&!s.browser:!1}};e.$9ac=D,e.$9ac=D=Ke([Be(3,A.$3i)],D);let y=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,s,d,b,g,t,o){this.c=i,this.d=s,this.f=d,this.g=b,this.h=g,this.j=t,this.k=o,this.a=new m.$Dg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const s=this.g[i];if(s.value&&!s.value.activationFailed){this.g.splice(i,1),i--;continue}if(s.value&&s.value.activationFailed){const d=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${s.friendlyName}' failed to activate`);d.detail=s.value.activationFailedError,this.h=new k(d),this.j.onExtensionActivationError(this.c,d,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const s=new Error;if(i&&i.name&&(s.name=i.name),i&&i.message?s.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:s.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(s.stack=i.stack),this.h=new k(s),this.b&&C.$2(i))return;this.j.onExtensionActivationError(this.c,s,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};y=Ke([Be(6,A.$3i)],y)}),define(De[287],Ce([1,0,212,24,2,4,3,269,11,7,18,19,13,79,21,173,27]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=void 0;function i(b,g){if((0,P.$le)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let t;return Array.isArray(b.highlights)&&(t=b.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),t=t.length?t:void 0),{label:b.label,highlights:t}}}class s extends A.$mb{constructor(g,t,o){super(),this.f=g,this.g=t,this.h=o,this.a=new Map,this.b=new y.$_6;function c(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>c(n)?this.k(n):Array.isArray(n)&&n.length>0?n.map(a=>c(a)?this.k(a):a):n})}registerTreeDataProvider(g,t,o){const c=this.createTreeView(g,{treeDataProvider:t},o);return{dispose:()=>c.dispose()}}createTreeView(g,t,o){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,v=this.j(g,t,o),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:n,hasHandleDrag:a,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(g,E),h={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,r.$MF)(o,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,r.$MF)(o,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(w){(0,k.$Xj)(w)&&(0,r.$MF)(o,"treeViewMarkdownMessage"),v.message=w},get title(){return v.title},set title(w){v.title=w},get description(){return v.description},set description(w){v.description=w},get badge(){return v.badge},set badge(w){w!==void 0&&$.ViewBadge.isViewBadge(w)?v.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(v.badge=void 0)},reveal:(w,L)=>v.reveal(w,L),dispose:async()=>{await u,this.a.delete(g),v.dispose()}};return this.B(h),h}$getChildren(g,t){const o=this.a.get(g);return o?o.getChildren(t):Promise.reject(new m.$0E(g))}async $handleDrop(g,t,o,c,n,a,l,v){const E=this.a.get(g);if(!E)return Promise.reject(new m.$0E(g));const u=p.DataTransfer.toDataTransfer(o,async h=>(await this.f.$resolveDropFileData(g,t,h)).buffer);return l===g&&v&&await this.i(u,E,v,n,a),E.onDrop(u,c,n)}async i(g,t,o,c,n){const a=this.b.removeDragOperationTransfer(n);if(a)(await a)?.forEach((l,v)=>{l&&g.set(v,l)});else if(n&&t.handleDrag){const l=t.handleDrag(o,g,c);this.b.addDragOperationTransfer(n,l),await l}return g}async $handleDrag(g,t,o,c){const n=this.a.get(g);if(!n)return Promise.reject(new m.$0E(g));const a=await this.i(new $.$MK,n,t,c,o);if(!(!a||c.isCancellationRequested))return p.DataTransfer.from(a)}async $hasResolve(g){const t=this.a.get(g);if(!t)throw new m.$0E(g);return t.hasResolve}$resolve(g,t,o){const c=this.a.get(g);if(!c)throw new m.$0E(g);return c.resolveTreeItem(t,o)}$setExpanded(g,t,o){const c=this.a.get(g);if(!c)throw new m.$0E(g);c.setExpanded(t,o)}$setSelectionAndFocus(g,t,o){const c=this.a.get(g);if(!c)throw new m.$0E(g);c.setSelectionAndFocus(t,o)}$setVisible(g,t){const o=this.a.get(g);if(!o){if(!t)return;throw new m.$0E(g)}o.setVisible(t)}$changeCheckboxState(g,t){const o=this.a.get(g);if(!o)throw new m.$0E(g);o.setCheckboxState(t)}j(g,t,o){const c=this.B(new d(g,t,this.f,this.g.converter,this.h,o));return this.a.set(g,c),c}k(g){const t=this.a.get(g.$treeViewId);return t&&"$treeItemHandle"in g?t.getExtensionElement(g.$treeItemHandle):t&&"$focusedTreeItem"in g&&g.$focusedTreeItem?t.focusedElement:null}}e.$Ibc=s;class d extends A.$mb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.$ue)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,t,o,c,n,a){if(super(),this.D=g,this.F=o,this.G=c,this.H=n,this.I=a,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new R.$hc),this.onDidExpandElement=this.r.event,this.s=this.B(new R.$hc),this.onDidCollapseElement=this.s.event,this.t=this.B(new R.$hc),this.onDidChangeSelection=this.t.event,this.u=this.B(new R.$hc),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new R.$hc),this.onDidChangeVisibility=this.v.event,this.w=this.B(new R.$hc),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new R.$hc),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new D.$rc,a.contributes&&a.contributes.views)for(const u in a.contributes.views)for(const h of a.contributes.views[u])h.id===g&&(this.L=h.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.y.fire({message:!1,element:u})));let l,v;const E=R.Event.debounce(this.y.event,(u,h)=>(u||(u={message:!1,elements:[]}),h.element!==!1&&(l||(l=new Promise(w=>v=w),this.z=this.z.then(()=>l)),Array.isArray(h.element)?u.elements.push(...h.element):u.elements.push(h.element)),h.message&&(u.message=!0),u),200,!0);this.B(E(({message:u,elements:h})=>{h.length&&(this.C=this.C.then(()=>{const w=v;return l=null,this.W(h).then(()=>w())})),u&&this.F.$setMessage(this.D,p.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(g){const t=g?this.getExtensionElement(g):void 0;if(g&&!t)return this.H.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let o=this.R(g);return o||(o=await this.S(t)),o?o.map(c=>c.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,t){t=t||{select:!0,focus:!1};const o=(0,P.$ue)(t.select)?!0:t.select,c=(0,P.$ue)(t.focus)?!1:t.focus,n=(0,P.$ue)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.z.then(()=>this.O(g)).then(a=>this.Q(g,a[a.length-1]).then(l=>this.F.$reveal(this.D,{item:l.item,parentChain:a.map(v=>v.item)},{select:o,focus:c,expand:n})),a=>this.H.error(a)):this.F.$reveal(this.D,void 0,{select:o,focus:c,expand:n})}get message(){return this.J}set message(g){this.J=g,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(g){this.L=g,this.F.$setTitle(this.D,g,this.M)}get description(){return this.M}set description(g){this.M=g,this.F.$setTitle(this.D,this.L,g)}get badge(){return this.N}set badge(g){this.N?.value===g?.value&&this.N?.tooltip===g?.tooltip||(this.N=p.ViewBadge.from(g),this.F.$setBadge(this.D,g))}setExpanded(g,t){const o=this.getExtensionElement(g);o&&(t?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelectionAndFocus(g,t){const o=!(0,I.$of)(this.l,g);this.l=g;const c=this.m!==t;this.m=t,o&&this.t.fire(Object.freeze({selection:this.selectedElements})),c&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(g){g!==this.k&&(this.k=g,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const t=(await Promise.all(g.map(async o=>{const c=this.getExtensionElement(o.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:o.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);t.forEach(o=>{o.treeItem.checkboxState=o.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}),this.w.fire({items:t.map(o=>[o.extensionItem,o.newState])})}async handleDrag(g,t,o){const c=[];for(const n of g){const a=this.getExtensionElement(n);a&&c.push(a)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,o),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,t,o){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,S.$xg)(()=>this.g?.handleDrop?this.g.handleDrop(c,g,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,t){if(!this.f.resolveTreeItem)return;const o=this.i.get(g);if(o){const c=this.j.get(o);if(c){const n=await this.f.resolveTreeItem(c.extensionItem,o,t)??c.extensionItem;return this.db(n),c.item.tooltip=this.ab(n.tooltip),c.item.command=this.bb(c.disposableStore,n.command),c.item}}}O(g){return this.P(g).then(t=>t?this.O(t).then(o=>this.Q(t,o[o.length-1]).then(c=>(o.push(c),o))):Promise.resolve([]))}P(g){const t=this.j.get(g);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,S.$xg)(()=>this.f.getParent(g))}Q(g,t){const o=this.j.get(g);return o?Promise.resolve(o):(0,S.$xg)(()=>this.f.getTreeItem(g)).then(c=>this.gb(g,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(c);if(n){const a=this.j.get(n);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.I.identifier.value}`)}))}R(g){if(g){let t;if(typeof g=="string"){const o=this.getExtensionElement(g);t=o?this.j.get(o):void 0}else t=g;return t&&t.children||void 0}return this.h}async S(g){this.nb(g);const t=new D.$rc(this.U.token);try{const o=g?this.j.get(g):void 0,c=await this.f.getChildren(g);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,I.$Af)(c||[]).map(async a=>{const l=await this.f.getTreeItem(a);return l&&!t.token.isCancellationRequested?this.$(a,l,o):null}));return t.token.isCancellationRequested?void 0:(0,I.$Af)(n)}finally{t.dispose()}}W(g){if(g.some(o=>!o))return this.U.dispose(!0),this.U=new D.$rc,this.pb(),this.F.$refresh(this.D);{const o=this.X(g);if(o.length)return this.Y(o)}return Promise.resolve(void 0)}X(g){const t=new Set,o=g.map(n=>this.j.get(n));for(const n of o)if(n&&!t.has(n.item.handle)){let a=n;for(;a&&a.parent&&o.findIndex(l=>a&&a.parent&&l&&l.item.handle===a.parent.item.handle)===-1;){const l=this.i.get(a.parent.item.handle);a=l?this.j.get(l):void 0}a&&!a.parent&&t.add(n.item.handle)}const c=[];return t.forEach(n=>{const a=this.i.get(n);if(a){const l=this.j.get(a);l&&(!l.parent||!t.has(l.parent.item.handle))&&c.push(n)}}),c}Y(g){const t={};return Promise.all(g.map(o=>this.Z(o).then(c=>{c&&(t[o]=c.item)}))).then(()=>Object.keys(t).length?this.F.$refresh(this.D,t):void 0)}Z(g){const t=this.getExtensionElement(g);if(t){const o=this.j.get(t);if(o)return this.nb(t),(0,S.$xg)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const n=this.eb(t,c,o.parent);return this.lb(t,n,o,o.parent),o.dispose(),n}return null})}return Promise.resolve(null)}$(g,t,o){const c=this.eb(g,t,o);if(t.id&&this.i.has(c.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.kb(g,c),this.mb(c,o),c}ab(g){return $.$jK.isMarkdownString(g)?p.MarkdownString.from(g):g}bb(g,t){return t?{...this.G.toInternal(t,g),originalId:t.command}:void 0}cb(g){if(g.checkboxState===void 0)return;let t,o,c;return typeof g.checkboxState=="number"?t=g.checkboxState:(t=g.checkboxState.state,o=g.checkboxState.tooltip,c=g.checkboxState.accessibilityInformation),{isChecked:t===$.TreeItemCheckboxState.Checked,tooltip:o,accessibilityInformation:c}}db(g){if(!$.$HK.isTreeItem(g,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(g,t,o){this.db(t);const c=this.B(new A.$lb),n=this.gb(g,t,o),a=this.hb(t);return{item:{handle:n,parentHandle:o?o.item.handle:void 0,label:i(t.label,this.I),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(c,t.command),contextValue:t.contextValue,icon:a,iconDark:this.ib(t)||a,themeIcon:this.fb(t),collapsibleState:(0,P.$ue)(t.collapsibleState)?$.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:o,children:void 0,disposableStore:c,dispose(){c.dispose()}}}fb(g){return g.iconPath instanceof $.$PK?g.iconPath:void 0}gb(g,{id:t,label:o,resourceUri:c},n,a){if(t)return`${d.b}/${t}`;const l=i(o,this.I),v=n?n.item.handle:d.a;let E=l?l.label:c?(0,T.$dg)(c):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const u=this.j.has(g)?this.j.get(g).item.handle:void 0,h=this.R(n)||[];let w,L=0;do{if(w=`${v}/${L}:${E}`,a||!this.i.has(w)||u===w)break;L++}while(L<=h.length);return w}hb(g){if(g.iconPath&&!(g.iconPath instanceof $.$PK))return typeof g.iconPath=="string"||f.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof $.$PK)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return f.URI.isUri(g)?g:f.URI.file(g)}kb(g,t){this.i.set(t.item.handle,g),this.j.set(g,t)}lb(g,t,o,c){this.i.delete(t.item.handle),this.j.delete(g),t.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(g,t);const n=this.R(c)||[],a=n.filter(l=>l.item.handle===o.item.handle)[0];a&&n.splice(n.indexOf(a),1,t)}mb(g,t){t?(t.children||(t.children=[]),t.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const t=this.j.get(g);if(t){if(t.children)for(const o of t.children){const c=this.i.get(o.item.handle);c&&this.ob(c)}t.children=void 0}}else this.pb()}ob(g){const t=this.j.get(g);if(t){if(t.children)for(const o of t.children){const c=this.i.get(o.item.handle);c&&this.ob(c)}this.j.delete(g),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){super.dispose(),this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(De[288],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,106,42,25,288,135,137]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const p=m.$6m.as(A.$7m.JSONContribution);class k{constructor(g,t,o){this.a=g,this.b=t,this.c=o}d(g,t){this.a({type:g,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(f.default.Error,g)}warn(g){this.d(f.default.Warning,g)}info(g){this.d(f.default.Info,g)}}e.$SF=k;class D{static a(g){const t=new S.$Ul;for(let o=0,c=g.length;o<c;o++)t.add(g[o].description.identifier);return t}static compute(g,t){if(!g||!g.length)return new D(t,[]);if(!t||!t.length)return new D([],g);const o=this.a(g),c=this.a(t),n=t.filter(l=>!o.has(l.description.identifier)),a=g.filter(l=>!c.has(l.description.identifier));return new D(n,a)}constructor(g,t){this.added=g,this.removed=t}}e.$TF=D;class y{constructor(g,t){this.name=g,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=D.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,T.$Y)(g)}}}e.$UF=y;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Sl},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Kn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Kn}},extensionKind:{description:C.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class s{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const t=new y(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,t),g.activationEventsGenerator&&I.$xF.register(g.extensionPoint,g.activationEventsGenerator),e.$VF.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,p.registerSchema(i,e.$VF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=s;const d={ExtensionsRegistry:"ExtensionsRegistry"};m.$6m.add(d.ExtensionsRegistry,new s),e.$XF=m.$6m.as(d.ExtensionsRegistry),p.registerSchema(i,e.$VF),p.registerSchema(P.$jj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,18,23,289,41,4]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var $;(function(p){function k(D,y,r){if(!D)return;const i=T.$le(D.type)?D.type:void 0;if(!i||i.length===0){r.error(C.localize(3,null));return}const s=[];if(Array.isArray(D.required))for(const d of D.required)T.$le(d)&&s.push(d);return{extensionId:y.value,taskType:i,required:s,properties:D.properties?f.$Tm(D.properties):{},when:D.when?A.$Gi.deserialize(D.when):void 0}}p.from=k})($||($={}));const P=R.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,k)=>{for(const D of p)D.type&&k.push(`onTaskType:${D.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:S}});class I{constructor(){this.d=new m.$hc,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,D)=>{P.setHandler((y,r)=>{this.c=void 0;try{for(const i of r.removed){const s=i.value;for(const d of s)this.a&&d.type&&this.a[d.type]&&delete this.a[d.type]}for(const i of r.added){const s=i.value;for(const d of s){const b=$.from(d,i.description.identifier,i.collector);b&&(this.a[b.taskType]=b)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const D of this.all()){const y={type:"object",additionalProperties:!1};D.required.length>0&&(y.required=D.required.slice(0)),D.properties!==void 0?y.properties=f.$Tm(D.properties):y.properties=Object.create(null),y.properties.type={type:"string",enum:[D.taskType]},k.push(y)}this.c={oneOf:k}}return this.c}}e.$7F=new I}),define(De[291],Ce([1,0,222,18,24,23,41,290]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$Zi("taskRunning",!1,C.localize(0,null)),e.$0F={value:C.localize(1,null),original:"Tasks"};var S;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$$F="$customized",function(j){function F(K){if(!K)return j.Strong;switch(K.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=F}(S||(e.ShellQuoting=S={}));var $;(function(j){j.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var P;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(P||(e.RevealKind=P={})),function(j){function F(K){switch(K.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=F}(P||(e.RevealKind=P={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function F(K){switch(K.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=F}(I||(e.RevealProblemKind=I={}));var p;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(p||(e.PanelKind=p={})),function(j){function F(K){switch(K.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=F}(p||(e.PanelKind=p={}));var k;(function(j){j.defaults={echo:!0,reveal:P.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var D;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(j){function F(H){switch(H.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=F;function K(H){switch(H){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=K}(D||(e.RuntimeType=D={}));var y;(function(j){function F(K){return T.$le(K)?K:K.value}j.value=F})(y||(e.CommandString=y={}));var r;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function F(H){return H===j.Clean._id||H===j.Build._id||H===j.Rebuild._id||H===j.Test._id}j.is=F;function K(H){if(H!==void 0)return T.$le(H)?F(H)?{_id:H,isDefault:!1}:void 0:H}j.from=K})(r||(e.TaskGroup=r={}));var i;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var s;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function F(K){switch(K){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=F})(s||(e.TaskSourceKind=s={}));var d;(function(j){j.parallel="parallel",j.sequence="sequence"})(d||(e.DependsOrder=d={}));var b;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(b||(e.RunOnOptions=b={}));var g;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:b.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class t{constructor(F,K,H,$e,_,Q){this._label="",this._id=F,K&&(this._label=K),H&&(this.type=H),this.runOptions=$e,this.configurationProperties=_,this._source=Q}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,K=!1){if(F===void 0)return!1;if(T.$le(F))return F===this._label||F===this.configurationProperties.identifier||K&&F===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$_F=t;class o extends t{constructor(F,K,H,$e,_,Q,V,ee){super(F,H,void 0,V,ee,K),this.command={},this._source=K,this.hasDefinedMatchers=Q,_&&(this.command=_)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case D.Shell:K="shell";break;case D.Process:K="process";break;case D.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(F){return F instanceof o}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===s.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let K=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(K+=this._source.kind);const H={type:e.$$F,folder:F,id:K};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$dg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new o(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$aG=o;class c extends t{constructor(F,K,H,$e,_,Q,V){super(F,H,$e,Q,V,K),this._source=K,this.configures=_}static is(F){return F instanceof c}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$dg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===s.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let K=this.configurationProperties.identifier;this._source.kind!==s.Workspace&&(K+=this._source.kind);const H={type:e.$$F,folder:F,id:K};return JSON.stringify(H)}}e.$bG=c;class n extends t{constructor(F,K,H,$e,_,Q,V,ee,me){super(F,H,$e,ee,me,K),this.defines=_,this.hasDefinedMatchers=V,this.command=Q,this.icon=me.icon,this.hide=me.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof n}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new n(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$cG=n;class a extends t{constructor(F,K,H,$e,_,Q){super(F,H,$e,_,Q,K),this._source=K}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new a(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$dG=a;var l;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(j){j._default=j.Terminal}(l||(e.ExecutionEngine=l={}));var v;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class E{constructor(F){this.c=new Map;for(let K=0;K<F.length;K++)this.c.set(F[K].uri.toString(),K)}compare(F,K){const H=F.getWorkspaceFolder(),$e=K.getWorkspaceFolder();if(H&&$e){let _=this.c.get(H.uri.toString());_=_===void 0?0:_+1;let Q=this.c.get($e.uri.toString());return Q=Q===void 0?0:Q+1,_===Q?F._label.localeCompare(K._label):_-Q}else return!H&&$e?-1:H&&!$e?1:0}}e.$eG=E;var u;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(u||(e.TaskEventKind=u={}));var h;(function(j){j.SingleRun="singleRun",j.Background="background"})(h||(e.TaskRunType=h={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var L;(function(j){function F(ee){return{taskId:ee._id,taskName:ee.configurationProperties.name,runType:ee.configurationProperties.isBackground?"background":"singleRun",group:ee.configurationProperties.group,__task:ee}}function K(ee,me,ae){return{...F(ee),kind:"start",terminalId:me,resolvedVariables:ae}}j.start=K;function H(ee,me,ae){return{...F(ee),kind:"processStarted",terminalId:me,processId:ae}}j.processStarted=H;function $e(ee,me,ae){return{...F(ee),kind:"processEnded",terminalId:me,exitCode:ae}}j.processEnded=$e;function _(ee,me,ae){return{...F(ee),kind:"terminated",exitReason:ae,terminalId:me}}j.terminated=_;function Q(ee,me,ae){return{...F(me),kind:ee,terminalId:ae}}j.general=Q;function V(){return{kind:"changed"}}j.changed=V})(L||(e.TaskEvent=L={}));var O;(function(j){function F(H){const $e=Object.keys(H).sort();let _="";for(const Q of $e){let V=H[Q];V instanceof Object?V=F(V):typeof V=="string"&&(V=V.replace(/,/g,",,")),_+=Q+","+V+","}return _}function K(H){const _={_key:F(H),type:H.taskType};return Object.assign(_,H),_}j.create=K})(O||(e.KeyedTaskIdentifier=O={}));var N;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var z;(function(j){function F(K,H){const $e=m.$7F.get(K.type);if($e===void 0){const ee=R.$Tm(K);return delete ee._key,O.create(ee)}const _=Object.create(null);_.type=$e.taskType;const Q=new Set;$e.required.forEach(ee=>Q.add(ee));const V=$e.properties;for(const ee of Object.keys(V)){const me=K[ee];if(me!=null)_[ee]=me;else if(Q.has(ee)){const ae=V[ee];if(ae.default!==void 0)_[ee]=R.$Tm(ae.default);else switch(ae.type){case"boolean":_[ee]=!1;break;case"number":case"integer":_[ee]=0;break;case"string":_[ee]="";break;default:H.error(C.localize(2,null,JSON.stringify(K,void 0,0),ee));return}}}return O.create(_)}j.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(De[292],Ce([1,0,8]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g3b=e.$f3b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$Y)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$f3b=T;class f extends T{constructor(){super(),this.h=!0,this.i=new C.$3}}e.$g3b=f}),define(De[68],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_z=e.$$z=e.$0z=e.$9z=void 0;class C{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++C.count}}e.$9z=C;const T=[];function f(m){const S=new C(m);return T[S.nid]=S,S}e.$0z=f;function R(m){return T[m].sid}e.$$z=R;class A{constructor(S){this.value=S}}e.$_z=A}),define(De[6],Ce([1,0,68]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$RJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var f;(function(y){y[y.UnknownInput=0]="UnknownInput",y[y.TextInput=1]="TextInput",y[y.TextDiffInput=2]="TextDiffInput",y[y.TextMergeInput=3]="TextMergeInput",y[y.NotebookInput=4]="NotebookInput",y[y.NotebookDiffInput=5]="NotebookDiffInput",y[y.CustomEditorInput=6]="CustomEditorInput",y[y.WebviewEditorInput=7]="WebviewEditorInput",y[y.TerminalEditorInput=8]="TerminalEditorInput",y[y.InteractiveEditorInput=9]="InteractiveEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(y){y[y.TAB_OPEN=0]="TAB_OPEN",y[y.TAB_CLOSE=1]="TAB_CLOSE",y[y.TAB_UPDATE=2]="TAB_UPDATE",y[y.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var S;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var $;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var P;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class I{static{this.a=0}static mixin(r){return r._id=I.a++,r}}e.$RJ=I;var p;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.kindModifier="m",y.commandIdent="n",y.commandId="o",y.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var k;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var D;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$SJ={MainThreadAuthentication:(0,C.$0z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$0z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$0z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,C.$0z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,C.$0z)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$0z)("MainThreadClipboard"),MainThreadCommands:(0,C.$0z)("MainThreadCommands"),MainThreadComments:(0,C.$0z)("MainThreadComments"),MainThreadConfiguration:(0,C.$0z)("MainThreadConfiguration"),MainThreadConsole:(0,C.$0z)("MainThreadConsole"),MainThreadDebugService:(0,C.$0z)("MainThreadDebugService"),MainThreadDecorations:(0,C.$0z)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$0z)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$0z)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$0z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$0z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$0z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$0z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$0z)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$0z)("MainThreadErrors"),MainThreadTreeViews:(0,C.$0z)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$0z)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$0z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$0z)("MainThreadLanguages"),MainThreadLogger:(0,C.$0z)("MainThreadLogger"),MainThreadMessageService:(0,C.$0z)("MainThreadMessageService"),MainThreadOutputService:(0,C.$0z)("MainThreadOutputService"),MainThreadProgress:(0,C.$0z)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$0z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$0z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$0z)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$0z)("MainThreadSecretState"),MainThreadStorage:(0,C.$0z)("MainThreadStorage"),MainThreadTelemetry:(0,C.$0z)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$0z)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$0z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$0z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$0z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$0z)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$0z)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$0z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$0z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$0z)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$0z)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.$0z)("MainThreadExtensionService"),MainThreadSCM:(0,C.$0z)("MainThreadSCM"),MainThreadSearch:(0,C.$0z)("MainThreadSearch"),MainThreadShare:(0,C.$0z)("MainThreadShare"),MainThreadTask:(0,C.$0z)("MainThreadTask"),MainThreadWindow:(0,C.$0z)("MainThreadWindow"),MainThreadLabelService:(0,C.$0z)("MainThreadLabelService"),MainThreadNotebook:(0,C.$0z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$0z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$0z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$0z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$0z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$0z)("MainThreadInteractive"),MainThreadChat:(0,C.$0z)("MainThreadChat"),MainThreadInlineChat:(0,C.$0z)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$0z)("MainThreadTheming"),MainThreadTunnelService:(0,C.$0z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$0z)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$0z)("MainThreadTimeline"),MainThreadTesting:(0,C.$0z)("MainThreadTesting"),MainThreadLocalization:(0,C.$0z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$0z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$0z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$0z)("MainThreadIssueReporter")},e.$TJ={ExtHostCommands:(0,C.$0z)("ExtHostCommands"),ExtHostConfiguration:(0,C.$0z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$0z)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$0z)("ExtHostDebugService"),ExtHostDecorations:(0,C.$0z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$0z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$0z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$0z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$0z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$0z)("ExtHostEditors"),ExtHostTreeViews:(0,C.$0z)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$0z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$0z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$0z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$0z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$0z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$0z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$0z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$0z)("ExtHostStatusBar"),ExtHostShare:(0,C.$0z)("ExtHostShare"),ExtHostExtensionService:(0,C.$0z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$0z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$0z)("ExtHostTerminalService"),ExtHostSCM:(0,C.$0z)("ExtHostSCM"),ExtHostSearch:(0,C.$0z)("ExtHostSearch"),ExtHostTask:(0,C.$0z)("ExtHostTask"),ExtHostWorkspace:(0,C.$0z)("ExtHostWorkspace"),ExtHostWindow:(0,C.$0z)("ExtHostWindow"),ExtHostWebviews:(0,C.$0z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$0z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$0z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$0z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$0z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$0z)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$0z)("ExtHostProgress"),ExtHostComments:(0,C.$0z)("ExtHostComments"),ExtHostSecretState:(0,C.$0z)("ExtHostSecretState"),ExtHostStorage:(0,C.$0z)("ExtHostStorage"),ExtHostUrls:(0,C.$0z)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$0z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$0z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$0z)("ExtHostOutputService"),ExtHosLabelService:(0,C.$0z)("ExtHostLabelService"),ExtHostNotebook:(0,C.$0z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$0z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$0z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$0z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$0z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$0z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$0z)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$0z)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$0z)("ExtHostChat"),ExtHostChatSlashCommands:(0,C.$0z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,C.$0z)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$0z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,C.$0z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$0z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$0z)("ExtHostTheming"),ExtHostTunnelService:(0,C.$0z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$0z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$0z)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$0z)("ExtHostTimeline"),ExtHostTesting:(0,C.$0z)("ExtHostTesting"),ExtHostTelemetry:(0,C.$0z)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$0z)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$0z)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$SJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,S){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(A);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(m,S)??[]}getRelatedInformation(A,m,S){return this.c.$getAiRelatedInformation(m,S)}registerRelatedInformationProvider(A,m,S){const $=this.b;return this.b++,this.a.set($,S),this.c.$registerAiRelatedInformationProvider($,m),new T.$UJ(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$Kcc=f}),define(De[90],Ce([1,0,5,14,6,20]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=e.$Nac=e.$Mac=void 0,e.$Mac=(0,C.$zh)("IExtHostApiDeprecationService");let A=class{constructor(S,$){this.c=$,this.a=new Set,this.b=S.getProxy(f.$SJ.MainThreadTelemetry)}report(S,$,P){const I=this.d(S,$);this.a.has(I)||(this.a.add(I),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:S}))}d(S,$){return`${S}-${$.identifier.value}`}};e.$Nac=A,e.$Nac=A=Ke([Be(0,R.$UL),Be(1,T.$3i)],A),e.$Oac=Object.freeze(new class{report(m,S,$){}})}),define(De[294],Ce([1,0,4,6,7,25]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class A{constructor($){this.b=new Map,this.c=[],this.d=new C.$hc,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=$.getProxy(T.$SJ.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,P,I,p={}){const k=R.$Tl.toKey($.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${k} ${P} ${D}`,async()=>{await this.a.$ensureProvider(P);const y=$.displayName||$.name;return this.a.$getSession(P,I,k,y,p)})}async getSessions($,P,I){const p=R.$Tl.toKey($.identifier),k=[...I].sort().join(" ");return await this.g.getOrCreate(`${p} ${k}`,async()=>{await this.a.$ensureProvider(P);const D=$.displayName||$.name;return this.a.$getSessions(P,I,p,D)})}async removeSession($,P){const I=this.b.get($);return I?I.provider.removeSession(P):this.a.$removeSession($,P)}registerAuthenticationProvider($,P,I,p){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:P,provider:I,options:p??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===$)||this.c.push({id:$,label:P});const k=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions($,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider($,P,p?.supportsMultipleAccounts??!1),new f.$UJ(()=>{k.dispose(),this.b.delete($);const D=this.c.findIndex(y=>y.id===$);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider($)})}$createSession($,P,I){const p=this.b.get($);if(p)return Promise.resolve(p.provider.createSession(P,I));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,P){const I=this.b.get($);if(I)return Promise.resolve(I.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,P){const I=this.b.get($);if(I)return Promise.resolve(I.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,P){return this.d.fire({provider:{id:$,label:P}}),Promise.resolve()}}e.$icc=A;class m{constructor(){this.a=new Map}getOrCreate($,P){const I=this.a.get($);if(I)return I;const p=P().finally(()=>this.a.delete($));return this.a.set($,p),p}}}),define(De[295],Ce([1,0,6,20,13]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;let R=class{constructor(m,S){this.a=m.getProxy(C.$SJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>S.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,S,$){const P=f.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,$?.isRefactoring??!1)}};e.$occ=R,e.$occ=R=Ke([Be(0,T.$UL)],R)}),define(De[296],Ce([1,0,11,4,50,3,37,202,6,13]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class P{static{this.a=0}constructor(k,D){this.extension=k,this.provider=D,this.handle=P.a++}}class I{static{this.a=0}constructor(k,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new T.$hc,this.onDidPerformUserAction=this.e.event,this.g=k.getProxy(S.$SJ.MainThreadChat)}registerChatProvider(k,D,y){const r=new P(k,y);return this.b.set(r.handle,r),this.g.$registerChatProvider(r.handle,D),(0,R.$kb)(()=>{this.g.$unregisterChatProvider(r.handle),this.b.delete(r.handle)})}transferChatSession(k,D){const y=f.Iterable.find(this.d.keys(),r=>this.d.get(r)===k)??0;typeof y=="number"&&this.g.$transferChatSession(y,D)}addChatRequest(k){this.g.$addRequest(k)}sendInteractiveRequestToProvider(k,D){this.g.$sendRequestToProvider(k,D)}async $prepareChat(k,D,y){const r=this.b.get(k);if(!r)return;const i=await r.provider.prepareSession(D,y);if(!i)return;const s=I.a++;return this.d.set(s,i),{id:s,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(k,D,y,r){const i=this.b.get(k);if(!i)return;const s=this.d.get(D);if(!s||!i.provider.resolveRequest)return;const d=await i.provider.resolveRequest(s,y,r);if(d)return{message:typeof d.message=="string"?d.message:$.ChatReplyFollowup.from(d.message)}}async $provideWelcomeMessage(k,D){const y=this.b.get(k);if(!y||!y.provider.provideWelcomeMessage)return;const r=await y.provider.provideWelcomeMessage(D);if(r)return r.map(i=>typeof i=="string"?i:i.map(s=>$.ChatReplyFollowup.from(s)))}async $provideFollowups(k,D,y){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);return!i||!r.provider.provideFollowups?void 0:(await r.provider.provideFollowups(i,y))?.map(d=>$.ChatFollowup.from(d))}$removeRequest(k,D,y){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);i&&r.provider.removeRequest&&r.provider.removeRequest(i,y)}async $provideReply(k,D,y,r){const i=this.b.get(k);if(!i)return;const s=this.d.get(D);if(!s)return;const d={session:s,message:typeof y.message=="string"?y.message:$.ChatReplyFollowup.to(y.message),variables:{}};if(y.variables)for(const n of Object.keys(y.variables))d.variables[n]=y.variables[n].map($.ChatVariable.to);const b=A.$dc.create(!1);let g;const t={report:n=>{if(!r.isCancellationRequested)if(typeof g>"u"&&(g=b.elapsed()),"responseId"in n)this.g.$acceptResponseProgress(k,D,{requestId:n.responseId});else if("placeholder"in n&&"resolvedContent"in n){const a=Promise.all([this.g.$acceptResponseProgress(k,D,{placeholder:n.placeholder}),n.resolvedContent]);(0,C.$tg)(a,r).then(l=>{if(!l)return;const[v,E]=l;this.g.$acceptResponseProgress(k,D,E,v??void 0)})}else"content"in n?this.g.$acceptResponseProgress(k,D,{content:typeof n.content=="string"?n.content:$.MarkdownString.from(n.content)}):this.g.$acceptResponseProgress(k,D,n)}};let o;try{o=await i.provider.provideResponseWithProgress(d,t,r),o||(o={errorDetails:{message:(0,m.localize)(0,null)}})}catch(n){o={errorDetails:{message:(0,m.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(s.saveState&&this.d.has(D)){const n=s.saveState();this.g.$acceptChatState(D,n)}}catch(n){this.h.warn(n)}const c={firstProgress:g??0,totalElapsed:b.elapsed()};return{errorDetails:o.errorDetails,timings:c}}async $provideSlashCommands(k,D,y){const r=this.b.get(k);if(!r)return;const i=this.d.get(D);return!i||!r.provider.provideSlashCommands?void 0:(await r.provider.provideSlashCommands(i,y))?.map(d=>({...d,kind:$.CompletionItemKind.from(d.kind)}))}$releaseSession(k){this.d.delete(k)}async $onDidPerformUserAction(k){this.e.fire(k)}}e.$Ccc=I}),define(De[297],Ce([1,0,3,6,13,84,25]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class m{static{this.a=1}constructor($,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Vl,this.b=$.getProxy(T.$SJ.MainThreadChatProvider)}registerProvider($,P,I,p){const k=m.a++;return this.c.set(k,{extension:$,provider:I}),this.b.$registerProvider(k,P,{extension:$,displayName:p.name??$.value}),(0,C.$kb)(()=>{this.b.$unregisterProvider(k),this.c.delete(k)})}async $provideChatResponse($,P,I,p,k){const D=this.c.get($);if(!D)return;const y=new R.$1u(async r=>{if(k.isCancellationRequested){this.d.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:r.index,part:r.part})},{async:!0});return D.provider.provideChatResponse(I.map(f.ChatMessage.to),p,y,k)}allowListExtensionWhile($,P){this.f.set($,P),P.finally(()=>this.f.delete($))}async requestChatResponseProvider($,P){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has($)},async makeRequest(p,k,D,y){if(!I.f.has($))throw new Error("Access to chat has been revoked");const r=Math.random()*1e6|0;I.e.set(r,D);try{await I.b.$fetchResponse($,P,r,p.map(f.ChatMessage.from),k,y)}finally{I.e.delete(r)}}}}async $handleResponseFragment($,P){this.e.get($)?.report(P)}}e.$Hcc=m}),define(De[298],Ce([1,0,3,6,7,13,84,11]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class S{static{this.a=0}constructor(I,p,k){this.d=p,this.e=k,this.b=new Map,this.c=I.getProxy(T.$SJ.MainThreadChatSlashCommands)}registerCommand(I,p,k,D){const y=S.a++;return this.b.set(y,{extension:I,command:k}),this.c.$registerCommand(y,p,D.description),(0,C.$kb)(()=>{this.c.$unregisterCommand(y),this.b.delete(y)})}async $executeCommand(I,p,k,D,y){const r=this.b.get(I);if(!r){this.e.warn(`[CHAT](${I}) CANNOT execute command because the command is not registered`);return}let i=!1;function s(){if(i)throw new Error("Only valid while executing the command")}const d=new m.$Zg;y.onCancellationRequested(()=>d.complete()),setTimeout(()=>d.complete(),3*1e3),this.d.allowListExtensionWhile(r.extension,d.p);const b=r.command({role:f.ChatMessageRole.User,content:k},{history:D.history.map(R.ChatMessage.to)},new A.$1u(g=>{s(),this.c.$handleProgressChunk(p,{content:$(g.message)?g.message:g.message.value})}),y);try{return await(0,m.$tg)(Promise.resolve(b).then(g=>{if(g&&"followUp"in g)return{followUp:g?.followUp?.map(o=>R.ChatFollowup.from(o))}}),y)}finally{i=!0,d.complete()}}}e.$Icc=S;function $(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(De[299],Ce([1,0,3,6,8,13]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(T.$SJ.MainThreadChatVariables)}async $resolveVariable(S,$,P){const I=this.b.get(S);if(I)try{const p=await I.resolver.resolve(I.data.name,{message:$},P);if(p)return p.map(R.ChatVariable.from)}catch(p){(0,f.$Z)(p)}}registerVariableResolver(S,$,P,I){const p=A.a++;return this.b.set(p,{extension:S.identifier,data:{name:$,description:P},resolver:I}),this.c.$registerVariable(p,{name:$,description:P}),(0,C.$kb)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$Jcc=A}),define(De[300],Ce([1,0,6]),function(be,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;class T{constructor(R){const A=R.getProxy(C.$SJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$Rac=T}),define(De[33],Ce([1,0,18,7,13,23,6,19,14,62,34,61,2,3,5,20,145,22,68,46,37,85,89]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=void 0;let o=class{#e;#t;#i;constructor(E,u,h){this.b=new Map,this.c=new Map,this.#e=E.getProxy(A.$SJ.MainThreadCommands),this.d=u,this.#i=h,this.#t=E.getProxy(A.$SJ.MainThreadTelemetry),this.converter=new c(this,w=>{const L=this.c.get(w);return L?.result===a.Void?L:void 0},u),this.f=[{processArgument(w){return(0,$.$9g)(w)}},{processArgument(w){return(0,R.$Vm)(w,function(L){if(P.$hs.isIRange(L))return f.Range.to(L);if(I.$gs.isIPosition(L))return f.Position.to(L);if(P.$hs.isIRange(L.range)&&p.URI.isUri(L.uri))return f.location.to(L);if(L instanceof i.$Hc)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const u=this.registerCommand(!1,E.id,async(...h)=>{const w=E.args.map((O,N)=>{if(!O.validate(h[N]))throw new Error(`Invalid argument '${O.name}' when running '${E.id}', received: ${h[N]}`);return O.convert(h[N])}),L=await this.executeCommand(E.internalId,...w);return E.result.convert(L,h,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new T.$UJ(()=>{u.dispose(),this.c.delete(E.id)})}registerCommand(E,u,h,w,L,O){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:h,thisArg:w,description:L,extension:O}),E&&this.#e.$registerCommand(u),new T.$UJ(()=>{this.b.delete(u)&&E&&this.#e.$unregisterCommand(u)})}executeCommand(E,...u){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,u,!0)}async g(E,u,h){if(this.b.has(E))return this.#e.$fireCommandActivationEvent(E),this.h(E,u,!1);{let w=!1;const L=(0,R.$Vm)(u,function(O){if(O instanceof T.$VJ)return f.Position.from(O);if(O instanceof T.$WJ)return f.Range.from(O);if(O instanceof T.$7J)return f.location.from(O);if(T.$gL.isNotebookRange(O))return f.NotebookRange.from(O);if(O instanceof ArrayBuffer)return w=!0,i.$Hc.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return w=!0,i.$Hc.wrap(O);if(O instanceof i.$Hc)return w=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(E,w?new s.$_z(L):L,h);return(0,$.$9g)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(E,u,!1);throw O}}}async h(E,u,h){const w=this.b.get(E);if(!w)throw new Error("Unknown command");const{callback:L,thisArg:O,description:N}=w;if(N)for(let z=0;z<N.args.length;z++)try{(0,C.$Ce)(u[z],N.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${N.args[z].name}' - ${N.args[z].description}`)}const M=b.$dc.create();try{return await L.apply(O,u)}catch(z){if(E===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...u);j&&(E=j.command)}if(this.d.error(z,E,w.extension?.identifier),!h)throw z;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,z);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,d.$ki)(z)),this.id=E,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,E,M.elapsed())}}j(E,u,h){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new g.$0n(u),duration:h})}$executeContributedCommand(E,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const h=this.b.get(E);return h?(u=u.map(w=>this.f.reduce((L,O)=>O.processArgument(L,h.extension?.identifier),w)),this.h(E,u,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(u=>(E&&(u=u.filter(h=>h[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[u,h]of this.b){const{description:w}=h;w&&(E[u]=w)}return Promise.resolve(E)}};e.$dM=o,e.$dM=o=Ke([Be(0,y.$UL),Be(1,S.$3i),Be(2,t.$cM)],o),e.$eM=(0,D.$zh)("IExtHostCommands");class c{constructor(E,u,h){this.d=E,this.f=u,this.g=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,u){if(!E)return;const h={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return h;const w=this.f(E.command);if(w)h.id=w.internalId,h.arguments=w.args.map((L,O)=>L.convert(E.arguments&&E.arguments[O]));else if((0,m.$Ef)(E.arguments)){const L=`${E.command}/${++this.c}`;this.b.set(L,E),u.add((0,k.$kb)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),h.$ident=L,h.id=this.delegatingCommandId,h.arguments=[L],this.g.trace("CommandsConverter#CREATE",E.command,L)}return h}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const u=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.$fM=c;class n{static{this.Uri=new n("uri","Uri of a text document",E=>p.URI.isUri(E),E=>E)}static{this.Position=new n("position","A position in a text document",E=>T.$VJ.isPosition(E),f.Position.from)}static{this.Range=new n("range","A range in a text document",E=>T.$WJ.isRange(E),f.Range.from)}static{this.Selection=new n("selection","A selection in a text document",E=>T.$XJ.isSelection(E),f.Selection.from)}static{this.Number=new n("number","",E=>typeof E=="number",E=>E)}static{this.String=new n("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=n.Arr(n.String)}static Arr(E){return new n(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,u=>Array.isArray(u)&&u.every(h=>E.validate(h)),u=>u.map(h=>E.convert(h)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",E=>E instanceof T.$fK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",E=>E instanceof T.$zL,f.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",E=>E instanceof r.$8L,f.TestItem.from)}constructor(E,u,h,w){this.name=E,this.description=u,this.validate=h,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,u){return new n(E??this.name,u??this.description,this.validate,this.convert)}}e.$gM=n;class a{static{this.Void=new a("no result",E=>E)}constructor(E,u){this.description=E,this.convert=u}}e.$hM=a;class l{constructor(E,u,h,w,L){this.id=E,this.internalId=u,this.description=h,this.args=w,this.result=L}}e.$iM=l}),define(De[301],Ce([1,0,19,17,2,82,129,41,134,33,13,7]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;const p=[new $.$iM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of DocumentHighlight-instances.",D(P.DocumentHighlight.to))),new $.$iM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,i)=>{if((0,C.$Df)(r))return;class s extends I.$_J{static to(b){const g=new s(b.name,P.SymbolKind.to(b.kind),b.containerName||"",new I.$7J(i[0],P.Range.to(b.range)));return g.detail=b.detail,g.range=g.location.range,g.selectionRange=P.Range.to(b.selectionRange),g.children=b.children?b.children.map(s.to):[],g}}return r.map(s.to)})),new $.$iM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$gM.Uri,new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$iM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$gM.Uri,$.$gM.Range,new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$iM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$gM.Uri,$.$gM.Position,new $.$gM("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$gM("options","Formatting options",r=>!0,r=>r)],new $.$hM("A promise that resolves to an array of TextEdits.",D(P.TextEdit.to))),new $.$iM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location or LocationLink instances.",y)),new $.$iM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Location-instances.",D(P.location.to))),new $.$iM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of Hover-instances.",D(P.Hover.to))),new $.$iM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$gM.Uri,new $.$gM("position","A position in a text document",r=>Array.isArray(r)&&r.every(i=>I.$VJ.isPosition(i)),r=>r.map(P.Position.from))],new $.$hM("A promise that resolves to an array of ranges.",r=>r.map(i=>{let s;for(const d of i.reverse())s=new I.$eK(P.Range.to(d),s);return s}))),new $.$iM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$gM.String.with("query","Search string")],new $.$hM("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(P.WorkspaceSymbol.to))),new $.$iM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(P.CallHierarchyItem.to))),new $.$iM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$gM.CallHierarchyItem],new $.$hM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(P.CallHierarchyIncomingCall.to))),new $.$iM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$gM.CallHierarchyItem],new $.$hM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(P.CallHierarchyOutgoingCall.to))),new $.$iM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:P.Range.to(r.range),placeholder:r.text}})),new $.$iM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("newName","The new symbol name")],new $.$hM("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return P.WorkspaceEdit.to(r)}})),new $.$iM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$gM.Uri,$.$gM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$hM("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(P.DocumentLink.to))),new $.$iM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$gM.Uri],new $.$hM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$$K(r.tokenTypes,r.tokenModifiers)})),new $.$iM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$gM.Uri],new $.$hM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,A.$k0)(r);if(i.type==="full")return new I.$aL(i.data,void 0)})),new $.$iM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$gM.Uri,$.$gM.Range.optional()],new $.$hM("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$$K(r.tokenTypes,r.tokenModifiers)})),new $.$iM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$gM.Uri,$.$gM.Range],new $.$hM("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const i=(0,A.$k0)(r);if(i.type==="full")return new I.$aL(i.data,void 0)})),new $.$iM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$gM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$hM("A promise that resolves to a CompletionList-instance.",(r,i,s)=>{if(!r)return new I.$qK([]);const d=r.suggestions.map(b=>P.CompletionItem.to(b,s));return new I.$qK(d,r.incomplete)})),new $.$iM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$gM.Uri,$.$gM.Position,$.$gM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$hM("A promise that resolves to SignatureHelp.",r=>{if(r)return P.SignatureHelp.to(r)})),new $.$iM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$gM.Uri,$.$gM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$hM("A promise that resolves to an array of CodeLens-instances.",(r,i,s)=>D(d=>new I.$iK(P.Range.to(d.range),d.command&&s.fromInternal(d.command)))(r))),new $.$iM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$gM.Uri,new $.$gM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$WJ.isRange(r),r=>I.$XJ.isSelection(r)?P.Selection.from(r):P.Range.from(r)),$.$gM.String.with("kind","Code action kind to return code actions for").optional(),$.$gM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$hM("A promise that resolves to an array of Command-instances.",(r,i,s)=>D(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(d.command)}else{const b=new I.$bK(d.title,d.kind?new I.$cK(d.kind):void 0);return d.edit&&(b.edit=P.WorkspaceEdit.to(d.edit)),d.command&&(b.command=s.fromInternal(d.command)),b.isPreferred=d.isPreferred,b}})(r))),new $.$iM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(i=>new I.$wK(P.Range.to(i.range),P.Color.to(i.color))):[])),new $.$iM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$gM("color","The color to show and insert",r=>r instanceof I.$vK,P.Color.from),new $.$gM("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:P.Range.from(r.range)}))],new $.$hM("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(P.ColorPresentation.to):[])),new $.$iM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$gM.Uri,$.$gM.Range],new $.$hM("A promise that resolves to an array of Inlay objects",(r,i,s)=>r.map(P.InlayHint.to.bind(void 0,s)))),new $.$iM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$gM.Uri],new $.$hM("A promise that resolves to an array of FoldingRange objects",(r,i)=>{if(r)return r.map(P.FoldingRange.to)})),new $.$iM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$hM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new $.$iM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$gM.Uri,$.$gM.Range,new $.$gM("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$WJ,r=>P.InlineValueContext.from(r))],new $.$hM("A promise that resolves to an array of InlineValue objects",r=>r.map(P.InlineValue.to))),new $.$iM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$gM("uriOrString","Uri-instance or string (only http/https)",r=>f.URI.isUri(r)||typeof r=="string"&&(0,S.$ET)(r,T.Schemas.http,T.Schemas.https),r=>r),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional(),$.$gM.String.with("label","").optional()],$.$hM.Void),new $.$iM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$gM.Uri.with("resource","Resource to open"),$.$gM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[P.ViewColumn.from(r),void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional()],$.$hM.Void),new $.$iM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$gM.Uri.with("left","Left-hand side resource of the diff editor"),$.$gM.Uri.with("right","Right-hand side resource of the diff editor"),$.$gM.String.with("title","Human readable title for the diff editor").optional(),new $.$gM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)]).optional()],$.$hM.Void),new $.$iM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$gM.Uri,$.$gM.Position],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$gM.TypeHierarchyItem],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$gM.TypeHierarchyItem],new $.$hM("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(P.TypeHierarchyItem.to))),new $.$iM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$gM.TestItem],$.$hM.Void),new $.$iM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$gM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$hM.Void),new $.$iM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$gM.String.with("name","The context key name"),new $.$gM("value","The context key value",()=>!0,r=>r)],$.$hM.Void),new $.$iM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$gM.Uri,$.$gM.StringArray,new $.$gM("MappedEditsContext","Mapped Edits Context",r=>P.MappedEditsContext.is(r),r=>P.MappedEditsContext.from(r))],new $.$hM("A promise that resolves to a workspace edit or null",r=>r?P.WorkspaceEdit.to(r):null))];class k{static register(i){p.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",m.$Hi)}}e.$Qac=k;function D(r){return i=>{if(Array.isArray(i))return i.map(r)}}function y(r){if(!Array.isArray(r))return;const i=[];for(const s of r)R.$5s(s)?i.push(P.DefinitionLink.to(s)):i.push(P.location.to(s));return i}}),define(De[302],Ce([1,0,11,56,4,3,2,82,25,13,7,6,27]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=void 0;function k(D,y,r){const i=D.getProxy(I.$SJ.MainThreadComments);class s{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Vl,y.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const v=this.b.get(l.handle);return v?v.value:l}else if(l&&l.$mid===7){const v=this.b.get(l.commentControlHandle);if(!v)return l;const E=v.getCommentThread(l.commentThreadHandle);return E?E.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const E=v.getCommentThread(l.thread.commentThreadHandle);return E?l.$mid===8?E.value:{thread:E.value,text:l.text}:l}else if(l&&l.$mid===10){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const E=v.getCommentThread(l.thread.commentThreadHandle);if(!E)return l;const u=l.commentUniqueId,h=E.getCommentByUniqueId(u);return h||l}else if(l&&l.$mid===11){const v=this.b.get(l.thread.commentControlHandle);if(!v)return l;const E=v.getCommentThread(l.thread.commentThreadHandle);if(!E)return l;const u=l.text,h=l.commentUniqueId,w=E.getCommentByUniqueId(h);return w?(typeof w.body=="string"?w.body=u:w.body=new P.$jK(u),w):l}return l}})}createCommentController(l,v,E){const u=s.a++,h=new b(l,u,v,E);this.b.set(h.handle,h);const w=this.c.get(l.identifier)||[];return w.push(h),this.c.set(l.identifier,w),h.value}$createCommentThreadTemplate(l,v,E){const u=this.b.get(l);u&&u.$createCommentThreadTemplate(v,E)}async $updateCommentThreadTemplate(l,v,E){const u=this.b.get(l);u&&u.$updateCommentThreadTemplate(v,E)}$deleteCommentThread(l,v){this.b.get(l)?.$deleteCommentThread(v)}$provideCommentingRanges(l,v,E){const u=this.b.get(l);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const h=r.getDocument(A.URI.revive(v));return(0,C.$xg)(async()=>{const w=await u.commentingRangeProvider.provideCommentingRanges(h,E);let L;return Array.isArray(w)?L={ranges:w,fileComments:!1}:w?L={ranges:w.ranges||[],fileComments:w.fileComments||!1}:L=w??void 0,L}).then(w=>{let L;return w&&(L={ranges:w.ranges.map(O=>$.Range.from(O)),fileComments:w.fileComments}),L})}$toggleReaction(l,v,E,u,h){const w=this.b.get(l);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,C.$xg)(()=>{const L=w.getCommentThread(v);if(L){const O=L.getCommentByUniqueId(u.uniqueIdInThread);if(w!==void 0&&O&&w.reactionHandler)return w.reactionHandler(O,o(h))}return Promise.resolve(void 0)})}}class d{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,v,E,u,h,w,L,O){this.m=v,this.n=E,this.o=u,this.p=h,this.q=w,this.extensionDescription=L,this.r=O,this.handle=d.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$hc,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$nb,this.l.value=new R.$lb,this.n===void 0&&(this.n=`${l}.${this.handle}`),i.$createCommentThread(v,this.handle,this.n,this.o,$.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{i.$deleteCommentThread(v,this.handle)}});const N=this;this.value={get uri(){return N.uri},get range(){return N.range},set range(M){N.range=M},get comments(){return N.comments},set comments(M){N.comments=M},get collapsibleState(){return N.collapsibleState},set collapsibleState(M){N.collapsibleState=M},get canReply(){return N.canReply},set canReply(M){N.canReply=M},get contextValue(){return N.contextValue},set contextValue(M){N.contextValue=M},get label(){return N.label},set label(M){N.label=M},get state(){return N.state},set state(M){N.state=M},dispose:()=>{N.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$lb);const l=E=>Object.prototype.hasOwnProperty.call(this.b,E),v={};l("range")&&(v.range=$.Range.from(this.p)),l("label")&&(v.label=this.label),l("contextValue")&&(v.contextValue=this.contextValue??null),l("comments")&&(v.comments=this.q.map(E=>g(this,E,this.k,this.extensionDescription))),l("collapsibleState")&&(v.collapseState=c(this.g)),l("canReply")&&(v.canReply=this.canReply),l("state")&&(v.state=n(this.h)),l("isTemplate")&&(v.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(l){for(const v of this.k){const E=v[0],u=v[1];if(l===u)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ke([(0,T.$5g)(100)],d.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,v,E,u){this.f=l,this.g=v,this.h=E,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,E,u);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(w){h.options=w},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(w){h.commentingRangeProvider=w},get reactionHandler(){return h.reactionHandler},set reactionHandler(w){h.reactionHandler=w},createCommentThread(w,L,O){return h.createCommentThread(w,L,O).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(l,v,E){v===void 0&&(0,p.$MF)(this.f,"fileComments");const u=new d(this.id,this.handle,void 0,l,v,E,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(l,v){const E=new d(this.id,this.handle,void 0,A.URI.revive(l),$.Range.to(v),[],this.f,!0);return E.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(l,v){const E=this.a.get(l);E&&(E.range=$.Range.to(v))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function g(a,l,v,E){let u=v.get(l);return u||(u=++a.commentHandle,v.set(l,u)),l.state!==void 0&&(0,p.$MF)(E,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:u,body:typeof l.body=="string"?l.body:$.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(h=>t(h)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?$.$TL(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function o(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function c(a){if(a!==void 0)switch(a){case P.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function n(a){if(a!==void 0)switch(a){case P.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new s}e.$Sac=k}),define(De[303],Ce([1,0,23,6,26,20]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;let A=class{constructor(P,I){this.a=P.getProxy(T.$SJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,I){const p=this,k=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){p.e(P,I,k,arguments)}})}e(P,I,p,k){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:S(k,this.b)}),this.c&&this.f(P,p,k)}};e.$Occ=A,e.$Occ=A=Ke([Be(0,R.$UL),Be(1,f.$$L)],A);const m=1e5;function S($,P){const I=[];if($.length)for(let p=0;p<$.length;p++){let k=$[p];if(typeof k>"u")k="undefined";else if(k instanceof Error){const D=k;D.stack?k=D.stack:k=D.toString()}I.push(k)}if(P){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,C.$Ym)(I);return p.length>m?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,27]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0;let k=class{static{p=this}static{this.c=0}static{this.d=250}constructor(y,r){this.h=r,this.f=new Map,this.g=y.getProxy(T.$SJ.MainThreadDecorations)}registerFileDecorationProvider(y,r){const i=p.c++;this.f.set(i,{provider:y,extensionDescription:r}),this.g.$registerDecorationProvider(i,r.identifier.value);const s=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(i,null);return}const b=(0,S.$Vf)(d);if(b.length<=p.d){this.g.$onDidChange(i,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,b.length);const g=b.map(c=>({uri:c,rank:(0,$.$td)(c.path,"/")})),t=(0,S.$tf)(g,(c,n)=>c.rank-n.rank||(0,$.$Hd)(c.uri.path,n.uri.path)),o=[];e:for(const c of t){let n;for(const a of c){const l=(0,P.$bd)(a.uri.path);if(n!==l&&(n=l,o.push(a.uri)>=p.d))break e}}this.g.$onDidChange(i,o)});return new f.$UJ(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(y,r,i){if(!this.f.has(y))return Object.create(null);const s=Object.create(null),{provider:d,extensionDescription:b}=this.f.get(y);return await Promise.all(r.map(async g=>{try{const{uri:t,id:o}=g,c=await Promise.resolve(d.provideFileDecoration(C.URI.revive(t),i));if(!c)return;try{f.$eL.validate(c),c.badge&&typeof c.badge!="string"&&(0,I.$MF)(b,"codiconDecoration"),s[o]=[c.propagate,c.tooltip,c.badge,c.color]}catch(n){this.h.warn(`INVALID decoration from extension '${b.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),s}};e.$Tbc=k,e.$Tbc=k=p=Ke([Be(0,A.$UL),Be(1,m.$3i)],k),e.$Ubc=(0,R.$zh)("IExtHostDecorations")}),define(De[304],Ce([1,0,203,133,2,6,7,13,4,14,28,54]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=void 0;class k{#e;#t;#i;constructor(r,i,s,d,b,g,t,o){this.d=r,this.e=i,this.f=s,this.g=d,this.h=b,this.c=!1,this.f=Math.max(d,s),this.#i=new P.$xi(c=>g.getComparisonKey(c)),this.#e=t,this.#t=o}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,i){if(!r){this.clear();return}this.j();let s=[];if(f.URI.isUri(r)){if(!i){this.delete(r);return}this.#i.set(r,i.slice()),s=[r]}else if(Array.isArray(r)){s=[];let g;r=[...r].sort(k.k);for(const t of r){const[o,c]=t;if((!g||o.toString()!==g.toString())&&(g&&this.#i.get(g).length===0&&this.#i.delete(g),g=o,s.push(o),this.#i.set(o,[])),c)this.#i.get(o)?.push(...c);else{const n=this.#i.get(o);n&&(n.length=0)}}}if(this.#t.fire(s),!this.#e)return;const d=[];let b=0;for(const g of s){let t=[];const o=this.#i.get(g);if(o)if(o.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const a of o)if(a.severity===c[n]&&t.push({...m.Diagnostic.from(a),modelVersionId:this.h(g)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,C.localize)(0,null,o.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=o.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(g)}));if(d.push([g,t]),b+=t.length,b>this.f)break}this.#e.$changeMany(this.e,d)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,i){this.j();for(const[s,d]of this)r.call(i,s,d,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const i=this.#i.get(r);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,i){return r[0].toString()<i[0].toString()?-1:r[0].toString()>i[0].toString()?1:0}}e.$Kac=k;let D=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(r){const i=new P.$xi;for(const s of r)i.set(s,s);return{uris:Object.freeze(Array.from(i.values()))}}constructor(r,i,s,d){this.j=i,this.k=s,this.l=d,this.g=new Map,this.h=new S.$lc({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,p._mapper),this.f=r.getProxy(R.$SJ.MainThreadDiagnostics)}createDiagnosticCollection(r,i){const{g:s,f:d,h:b,j:g,k:t,l:o}=this,c=new class{$changeMany(l,v){d.$changeMany(l,v),g.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,l,v.length===0?"CLEARING":v)}$clear(l){d.$clear(l),g.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,l)}dispose(){d.dispose()}};let n;if(!i)i="_generated_diagnostic_collection_name_#"+p.c++,n=i;else if(!s.has(i))n=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do n=i+p.c++;while(s.has(n))}return new class extends k{constructor(){super(i,n,p.e,p.d,l=>o.getDocument(l)?.version,t.extUri,c,b),s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(r){if(r)return this.m(r);{const i=new Map,s=[];for(const d of this.g.values())d.forEach((b,g)=>{let t=i.get(b.toString());typeof t>"u"&&(t=s.length,i.set(b.toString(),t),s.push([b,[]])),s[t][1]=s[t][1].concat(...g)});return s}}m(r){let i=[];for(const s of this.g.values())s.has(r)&&(i=i.concat(s.get(r)));return i}$acceptMarkersChange(r){if(!this.n){const i="_generated_mirror",s=new k(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,d=>{},this.k.extUri,void 0,this.h);this.g.set(i,s),this.n=s}for(const[i,s]of r)this.n.set(f.URI.revive(i),s.map(m.Diagnostic.to))}};e.$Lac=D,e.$Lac=D=p=Ke([Be(1,$.$3i),Be(2,I.$Jac)],D)}),define(De[305],Ce([1,0,2,6,27]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;class R{constructor(m){this.a=m.getProxy(T.$SJ.MainThreadDialogs)}showOpenDialog(m,S){return S?.allowUIResources&&(0,f.$MF)(m,"showLocal"),this.a.$showOpenDialog(S).then($=>$?$.map(P=>C.URI.revive(P)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(S=>S?C.URI.revive(S):void 0)}}e.$1ac=R}),define(De[306],Ce([1,0,8,2,7,6,17,21,15]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class ${static{this.a=0}constructor(I,p,k){this.d=p,this.e=k,this.b=new Map,this.c=I.getProxy(R.$SJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const k=$.a++;this.b.set(k,p),this.c.$registerTextContentProvider(k,I);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(y=>{if(y.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${y.scheme}' which will be IGNORED`);return}this.d.getDocument(y)&&this.$provideTextDocumentContent(k,y).then(r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(y);if(!i)return;const s=(0,S.$Cd)(r);if(!i.equalLines(s))return this.c.$onVirtualDocumentChange(y,r)},C.$Y)})),new f.$UJ(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,p){const k=this.b.get(I);return k?Promise.resolve(k.provideTextDocumentContent(T.URI.revive(p),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$2ac=$}),define(De[307],Ce([1,0,4,3,2,6,141,13,18,23,7,8]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class p{constructor(D,y){this.a=new C.$hc({onListenerError:I.$Z}),this.b=new C.$hc({onListenerError:I.$Z}),this.c=new C.$hc({onListenerError:I.$Z}),this.d=new C.$hc({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$lb,this.h=new Map,this.f=D.getProxy(R.$SJ.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(r=>{for(const i of r)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const i of r)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const y=this.g.getDocument(D);if(y)return y}getDocument(D){const y=this.getDocumentData(D);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return y.document}ensureDocumentData(D){const y=this.g.getDocument(D);if(y)return Promise.resolve(y);let r=this.h.get(D.toString());return r||(r=this.f.$tryOpenDocument(D).then(i=>{this.h.delete(D.toString());const s=f.URI.revive(i);return(0,S.$we)(this.g.getDocument(s))},i=>(this.h.delete(D.toString()),Promise.reject(i))),this.h.set(D.toString(),r)),r}createDocumentData(D){return this.f.$tryCreateDocument(D).then(y=>f.URI.revive(y))}$acceptModelLanguageChanged(D,y){const r=f.URI.revive(D),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(y),this.a.fire(i.document)}$acceptModelSaved(D){const y=f.URI.revive(D),r=this.g.getDocument(y);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(D,y){const r=f.URI.revive(D),i=this.g.getDocument(r);if(!i)throw new Error("unknown document");i._acceptIsDirty(y),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,y,r){const i=f.URI.revive(D),s=this.g.getDocument(i);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(y);let d;y.isUndoing?d=P.TextDocumentChangeReason.Undo:y.isRedoing&&(d=P.TextDocumentChangeReason.Redo),this.c.fire((0,$.$Um)({document:s.document,contentChanges:y.changes.map(b=>({range:m.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:d}))}setWordDefinitionFor(D,y){(0,A.$WL)(D,y)}}e.$Hac=p}),define(De[69],Ce([1,0,57,4,3,2,5,6,141,20,146,13,14,28,17,50,58]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=void 0;class i{constructor(b){this.value=b,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let s=class{constructor(b,g){this.h=b,this.i=g,this.a=null,this.b=new Map,this.c=new k.$xi,this.d=new T.$hc,this.e=new T.$hc,this.f=new T.$hc,this.g=new T.$hc,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(b){this.acceptDocumentsAndEditorsDelta(b)}acceptDocumentsAndEditorsDelta(b){const g=[],t=[],o=[];if(b.removedDocuments)for(const c of b.removedDocuments){const n=R.URI.revive(c),a=this.c.get(n);a?.unref()&&(this.c.delete(n),g.push(a.value))}if(b.addedDocuments)for(const c of b.addedDocuments){const n=R.URI.revive(c.uri);let a=this.c.get(n);if(a&&n.scheme!==D.Schemas.vscodeNotebookCell&&n.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new i(new S.$XL(this.h.getProxy(m.$SJ.MainThreadDocuments),n,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(n,a),t.push(a.value)),a.ref()}if(b.removedEditors)for(const c of b.removedEditors){const n=this.b.get(c);this.b.delete(c),n&&o.push(n)}if(b.addedEditors)for(const c of b.addedEditors){const n=R.URI.revive(c.documentUri);C.ok(this.c.has(n),`document '${n}' does not exist`),C.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const a=this.c.get(n).value,l=new P.$4L(c.id,this.h.getProxy(m.$SJ.MainThreadTextEditors),this.i,new r.$T(()=>a.document),c.selections.map(I.Selection.to),c.options,c.visibleRanges.map(v=>I.Range.to(v)),typeof c.editorPosition=="number"?I.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,l)}b.newActiveEditor!==void 0&&(C.ok(b.newActiveEditor===null||this.b.has(b.newActiveEditor),`active editor '${b.newActiveEditor}' does not exist`),this.a=b.newActiveEditor),(0,f.$hb)(g),(0,f.$hb)(o),b.removedDocuments&&this.e.fire(g),b.addedDocuments&&this.d.fire(t),(b.removedEditors||b.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),b.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(b){return this.c.get(b)?.value}allDocuments(){return y.Iterable.map(this.c.values(),b=>b.value)}getEditor(b){return this.b.get(b)}activeEditor(b){if(!this.a)return;const g=this.b.get(this.a);return b?g:g?.value}allEditors(){return[...this.b.values()]}};e.$5L=s,e.$5L=s=Ke([Be(0,$.$UL),Be(1,p.$3i)],s),e.$6L=(0,A.$zh)("IExtHostDocumentsAndEditors")}),define(De[70],Ce([1,0,13,6,2,4,5,7,20,18,73]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0,e.$Ybc=(0,A.$zh)("IExtHostEditorTabs");class I{constructor(r,i,s){this.e=s,this.d=i,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$AL(f.URI.revive(this.b.input.uri));case 2:return new m.$BL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified));case 3:return new m.$CL(f.URI.revive(this.b.input.base),f.URI.revive(this.b.input.input1),f.URI.revive(this.b.input.input2),f.URI.revive(this.b.input.result));case 6:return new m.$DL(f.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$EL(this.b.input.viewType);case 4:return new m.$FL(f.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$GL(f.URI.revive(this.b.input.original),f.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$HL;case 9:return new m.$IL(f.URI.revive(this.b.input.uri),f.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(r,i){this.c=[],this.d="",this.b=r,this.e=i;for(const s of r.tabs)s.isActive&&(this.d=s.id),this.c.push(new I(s,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,i={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return C.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(s=>s.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(s=>s.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const s=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,s),r.tabDto.isActive&&(this.d=s.tabId),s}else if(r.kind===1){const s=this.c.splice(r.index,1)[0];if(!s)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return s.tabId===this.d&&(this.d=""),s}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const s=this.c.splice(r.oldIndex,1)[0];if(!s)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,s),s}const i=this.c.find(s=>s.tabId===r.tabDto.id);if(!i)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(r.tabDto),i}activeTabId(){return this.d}}let k=class{constructor(r){this.b=new R.$hc,this.c=new R.$hc,this.e=[],this.a=r.getProxy(T.$SJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,i={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(s=>s.apiObject))},get activeTabGroup(){const s=r.d;return(0,$.$we)(r.e.find(b=>b.groupId===s)?.apiObject)},close:async(s,d)=>{const b=Array.isArray(s)?s:[s];return b.length?D(b[0])?this.j(b,d):this.i(b,d):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(r){const i=new Set(this.e.map(c=>c.groupId)),s=new Set(r.map(c=>c.groupId)),d=(0,P.$J)(i,s),b=this.e.filter(c=>d.removed.includes(c.groupId)).map(c=>c.apiObject),g=[],t=[];this.e=r.map(c=>{const n=new p(c,()=>this.d);return d.added.includes(n.groupId)?g.push(n.apiObject):t.push(n.apiObject),n});const o=(0,$.$we)(r.find(c=>c.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:g,closed:b,changed:t}))}$acceptTabGroupUpdate(r){const i=this.e.find(s=>s.groupId===r.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const i=this.e.find(d=>d.groupId===r.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const s=i.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[s.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[s.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[s.apiObject]}));return}}g(r){for(const i of this.e)for(const s of i.tabs)if(s.apiObject===r)return s}h(r){return this.e.find(i=>i.apiObject===r)}async i(r,i){const s=[];for(const d of r){const b=this.g(d);if(!b)throw new Error("Tab close: Invalid tab not found!");s.push(b.tabId)}return this.a.$closeTab(s,i)}async j(r,i){const s=[];for(const d of r){const b=this.h(d);if(!b)throw new Error("Group close: Invalid group not found!");s.push(b.groupId)}return this.a.$closeGroup(s,i)}};e.$Zbc=k,e.$Zbc=k=Ke([Be(0,S.$UL)],k);function D(y){return y.tabs!==void 0}}),define(De[308],Ce([1,0,6,7]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class f{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$SJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(A);if(!$)throw new Error("Embedding vector provider not found");const P=await $.provideEmbeddingVector(m,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,m,S){const $=this.b;return this.b++,this.a.set($,S),this.c.$registerAiEmbeddingVectorProvider(m,$),new T.$UJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$Lcc=f}),define(De[309],Ce([1,0,2,6,3,7,13,169,15,22,27,79]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;class p{constructor(){this.a=[]}add(y){this.b=void 0,this.a.push(y)}delete(y){const r=this.a.indexOf(y);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const y=this.a.sort(),r=[];let i,s,d=14,b=14;for(const g of y){let t=i?(0,S.$Qd)(i,g):0;for(t===0?s=1:s=b;t<g.length;t++)t+1===g.length?(d=b,b=9):b+=1,r.push([s,g.toUpperCase().charCodeAt(t),b]),r.push([s,g.toLowerCase().charCodeAt(t),b]),s=b;i=g,b=d}r.push([9,58,10]),r.push([10,47,12]),this.b=new m.$nY(r)}}provideDocumentLinks(y){this.c();const r=[],i=m.$oY.computeLinks({getLineContent(s){return y.lineAt(s-1).text},getLineCount(){return y.lineCount}},this.b);for(const s of i){const d=A.DocumentLink.to(s);d.target&&r.push(d)}return r}}class k{constructor(y,r){this.i=r,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=y.getProxy(T.$SJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(y,r,i,s={}){if(k.j(i),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(y,"*",this.b));const d=this.h++;this.b.add(r),this.d.add(r),this.c.set(d,i);let b=2;s.isCaseSensitive&&(b+=1024),s.isReadonly&&(b+=2048),typeof i.copy=="function"&&(b+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$MF)(y,"fsChunks"),b+=4);let g;s.isReadonly&&(0,I.$Xj)(s.isReadonly)&&((0,P.$MF)(y,"readonlyMessage"),g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(d,r,b,g).catch(o=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${r}`),console.error(o)});const t=i.onDidChangeFile(o=>{const c=[];for(const n of o){const{uri:a,type:l}=n;if(a.scheme!==r)continue;let v;switch(l){case R.FileChangeType.Changed:v=0;break;case R.FileChangeType.Created:v=1;break;case R.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:a,type:v})}this.a.$onFileSystemChange(d,c)});return(0,f.$kb)(()=>{t.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(y){if(!y)throw new Error("MISSING provider");if(typeof y.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof y.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof y.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof y.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof y.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof y.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof y.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof y.rename!="function")throw new Error("Provider does NOT implement rename")}static k(y){const{type:r,ctime:i,mtime:s,size:d,permissions:b}=y;return{type:r,ctime:i,mtime:s,size:d,permissions:b}}$stat(y,r){return Promise.resolve(this.l(y).stat(C.URI.revive(r))).then(i=>k.k(i))}$readdir(y,r){return Promise.resolve(this.l(y).readDirectory(C.URI.revive(r)))}$readFile(y,r){return Promise.resolve(this.l(y).readFile(C.URI.revive(r))).then(i=>$.$Hc.wrap(i))}$writeFile(y,r,i,s){return Promise.resolve(this.l(y).writeFile(C.URI.revive(r),i.buffer,s))}$delete(y,r,i){return Promise.resolve(this.l(y).delete(C.URI.revive(r),i))}$rename(y,r,i,s){return Promise.resolve(this.l(y).rename(C.URI.revive(r),C.URI.revive(i),s))}$copy(y,r,i,s){const d=this.l(y);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(C.URI.revive(r),C.URI.revive(i),s))}$mkdir(y,r){return Promise.resolve(this.l(y).createDirectory(C.URI.revive(r)))}$watch(y,r,i,s){const d=this.l(y).watch(C.URI.revive(i),s);this.f.set(r,d)}$unwatch(y,r){const i=this.f.get(r);i&&(i.dispose(),this.f.delete(r))}$open(y,r,i){const s=this.l(y);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(C.URI.revive(r),i))}$close(y,r){const i=this.l(y);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(r))}$read(y,r,i,s){const d=this.l(y);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const b=$.$Hc.alloc(s);return Promise.resolve(d.read(r,i,b.buffer,0,s)).then(g=>b.slice(0,g))}$write(y,r,i,s){const d=this.l(y);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(r,i,s.buffer,0,s.byteLength))}l(y){const r=this.c.get(y);if(!r){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return r}}e.$vbc=k}),define(De[71],Ce([1,0,6,30,7,22,5,20,54,3,11,24,17]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=void 0;let D=k=class{constructor(r,i){this.b=new Map,this.c=new P.$Ng,this.a=r.getProxy(C.$SJ.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(d){try{let b;const g=s.b.get(d.scheme);return g?(await s.a.$ensureActivation(d.scheme),b=await g.impl.stat(d)):b=await s.a.$stat(d),{type:b.type,ctime:b.ctime,mtime:b.mtime,size:b.size,permissions:b.permissions===T.FilePermission.Readonly?1:void 0}}catch(b){k.e(b)}},async readDirectory(d){try{const b=s.b.get(d.scheme);return b?(await s.a.$ensureActivation(d.scheme),(await b.impl.readDirectory(d)).slice()):await s.a.$readdir(d)}catch(b){return k.e(b)}},async createDirectory(d){try{const b=s.b.get(d.scheme);return b&&!b.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d(b.impl,b.extUri,d)):await s.a.$mkdir(d)}catch(b){return k.e(b)}},async readFile(d){try{const b=s.b.get(d.scheme);return b?(await s.a.$ensureActivation(d.scheme),(await b.impl.readFile(d)).slice()):(await s.a.$readFile(d)).buffer}catch(b){return k.e(b)}},async writeFile(d,b){try{const g=s.b.get(d.scheme);return g&&!g.isReadonly?(await s.a.$ensureActivation(d.scheme),await s.d(g.impl,g.extUri,g.extUri.dirname(d)),await s.c.queueFor(d).queue(()=>Promise.resolve(g.impl.writeFile(d,b,{create:!0,overwrite:!0})))):await s.a.$writeFile(d,R.$Hc.wrap(b))}catch(g){return k.e(g)}},async delete(d,b){try{const g=s.b.get(d.scheme);return g&&!g.isReadonly?(await s.a.$ensureActivation(d.scheme),await g.impl.delete(d,{recursive:!1,...b})):await s.a.$delete(d,{recursive:!1,useTrash:!1,atomic:!1,...b})}catch(g){return k.e(g)}},async rename(d,b,g){try{return await s.a.$rename(d,b,{overwrite:!1,...g})}catch(t){return k.e(t)}},async copy(d,b,g){try{return await s.a.$copy(d,b,{overwrite:!1,...g})}catch(t){return k.e(t)}},isWritableFileSystem(d){const b=i.getCapabilities(d);if(typeof b=="number")return!(b&2048)}})}async d(r,i,s){const d=[];for(;!i.isEqual(s,i.dirname(s));)try{if(!((await r.stat(s)).type&T.FileType.Directory))throw f.$9K.FileExists(`Unable to create folder '${s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(b){if(T.$gk(b)!==T.FileSystemProviderErrorCode.FileNotFound)throw b;d.push(i.basename(s)),s=i.dirname(s)}for(let b=d.length-1;b>=0;b--){s=i.joinPath(s,d[b]);try{await r.createDirectory(s)}catch(g){if(T.$gk(g)!==T.FileSystemProviderErrorCode.FileExists)throw g}}}static e(r){if(r instanceof f.$9K)throw r;if(r instanceof T.$ck)switch(r.code){case T.FileSystemProviderErrorCode.FileExists:throw f.$9K.FileExists(r.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$9K.FileNotFound(r.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$9K.FileNotADirectory(r.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$9K.FileIsADirectory(r.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$9K.NoPermissions(r.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$9K.Unavailable(r.message);default:throw new f.$9K(r.message,r.name)}if(!(r instanceof Error))throw new f.$9K(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw f.$9K.Unavailable(r.message);switch(r.name){case T.FileSystemProviderErrorCode.FileExists:throw f.$9K.FileExists(r.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$9K.FileNotFound(r.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$9K.FileNotADirectory(r.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$9K.FileIsADirectory(r.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$9K.NoPermissions(r.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$9K.Unavailable(r.message);default:throw new f.$9K(r.message,r.name)}}addFileSystemProvider(r,i,s){return this.b.set(r,{impl:i,extUri:s?.isCaseSensitive?I.$9f:I.$$f,isReadonly:!!s?.isReadonly}),(0,$.$kb)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??I.$9f}};e.$bbc=D,e.$bbc=D=k=Ke([Be(0,m.$UL),Be(1,S.$Jac)],D),e.$cbc=(0,A.$zh)("IExtHostConsumerFileSystem")}),define(De[310],Ce([1,0,4,35,2,6,13,7]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,p,k,D,y,r,i,s){this.a=new C.$hc,this.b=new C.$hc,this.c=new C.$hc;const d=this.h(I,k,y);this.g=0,r&&(this.g+=1),i&&(this.g+=2),s&&(this.g+=4);const b=(0,T.$pj)(y),g=typeof y=="string",t=D(o=>{if(!r)for(const c of o.created){const n=f.URI.revive(c);b(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.a.fire(n)}if(!i)for(const c of o.changed){const n=f.URI.revive(c);b(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.b.fire(n)}if(!s)for(const c of o.deleted){const n=f.URI.revive(c);b(n.fsPath)&&(!g||p.getWorkspaceFolder(n))&&this.c.fire(n)}});this.d=m.$UJ.from(d,this.a,this.b,this.c,t)}h(I,p,k){const D=m.$UJ.from();if(typeof k=="string")return D;const y=I.getProxy(R.$SJ.MainThreadFileSystem);let r=!1;(k.pattern.includes(T.$lj)||k.pattern.includes(T.$mj))&&(r=!0);const i=Math.random();return y.$watch(p.identifier.value,i,k.baseUri,{recursive:r,excludes:[]}),m.$UJ.from({dispose:()=>y.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class ${constructor(I,p,k){this.j=I,this.k=p,this.l=k,this.a=new C.$hc,this.b=new C.$hc,this.c=new C.$hc,this.d=new C.$hc,this.g=new C.$jc,this.h=new C.$jc,this.i=new C.$jc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,p,k,D,y,r){return new S(this.j,I,p,this.a.event,A.GlobPattern.from(k),D,y,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,p){switch(I){case 2:this.b.fire(Object.freeze({files:p.map(k=>({oldUri:f.URI.revive(k.source),newUri:f.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(k=>f.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(k=>f.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,p){return(k,D,y)=>{const r=function(s){k.call(D,s)};return r.extension=I,p.event(r,void 0,y)}}async $onWillRunFileOperation(I,p,k,D){switch(I){case 2:return await this.n(this.g,{files:p.map(y=>({oldUri:f.URI.revive(y.source),newUri:f.URI.revive(y.target)}))},k,D);case 1:return await this.n(this.i,{files:p.map(y=>f.URI.revive(y.target))},k,D);case 0:case 3:return await this.n(this.h,{files:p.map(y=>f.URI.revive(y.target))},k,D)}}async n(I,p,k,D){const y=new Set,r=[];if(await I.fireAsync(p,D,async(s,d)=>{const b=Date.now(),g=await Promise.resolve(s);g instanceof m.$5J&&(r.push([d.extension,g]),y.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-b>k&&this.k.warn("SLOW file-participant",d.extension.identifier)}),D.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,s]of r){const{edits:d}=A.WorkspaceEdit.from(s,{getTextDocumentVersion:b=>this.l.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(d)}return{edit:i,extensionNames:Array.from(y)}}}e.$wbc=$}),define(De[311],Ce([1,0,3,2,6,13,7,33]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class S{static{this.a=0}constructor(p,k){this.extension=p,this.provider=k,this.handle=S.a++}}class ${constructor(p){this.session=p,this.responses=[]}}class P{static{this.a=0}constructor(p,k,D,y){this.f=D,this.g=y,this.b=new Map,this.d=new Map,this.e=p.getProxy(f.$SJ.MainThreadInlineChat),k.registerApiCommand(new m.$iM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$gM("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?R.Range.from(r.initialRange):void 0,initialSelection:r.initialSelection?R.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?R.Position.from(r.position):void 0}})],m.$hM.Void))}registerProvider(p,k,D){const y=new S(p,k);return this.b.set(y.handle,y),this.e.$registerInteractiveEditorProvider(y.handle,D.label,p.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$kb)(()=>{this.e.$unregisterInteractiveEditorProvider(y.handle),this.b.delete(y.handle)})}async $prepareSession(p,k,D,y){const r=this.b.get(p);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(k)),s=R.Selection.to(D),d=await r.provider.prepareInteractiveEditorSession({document:i,selection:s},y);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(s))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const b=P.a++;return this.d.set(b,new $(d)),{id:b,placeholder:d.placeholder,slashCommands:d.slashCommands?.map(g=>({command:g.command,detail:g.detail,refer:g.refer,executeImmediately:g.executeImmediately})),wholeRange:R.Range.from(d.wholeRange),message:d.message}}async $provideResponse(p,k,D,y){const r=this.b.get(p);if(!r)return;const i=this.d.get(k.id);if(!i)return;const s={session:i.session,prompt:D.prompt,selection:R.Selection.to(D.selection),wholeRange:R.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let d=!1;const b={report:o=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");d||y.isCancellationRequested||!o.message&&!o.edits||this.e.$handleProgressChunk(D.requestId,{message:o.message,edits:o.edits?.map(R.TextEdit.from)})}},g=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(s,b,y):r.provider.provideInteractiveEditorResponse(s.session,s,b,y);Promise.resolve(g).finally(()=>d=!0);const t=await g;if(t){const o=i.responses.push(t)-1,c={wholeRange:R.Range.from(t.wholeRange),placeholder:t.placeholder};if(P.h(t))return{...c,id:o,type:"message",message:R.MarkdownString.from(t.contents)};const{edits:n}=t;if(n instanceof A.$5J)return{...c,id:o,type:"bulkEdit",edits:R.WorkspaceEdit.from(n)};if(Array.isArray(n))return{...c,id:o,type:"editorEdit",edits:n.map(R.TextEdit.from)}}}$handleFeedback(p,k,D,y){const r=this.b.get(p),i=this.d.get(k),s=i?.responses[D];if(r&&s){const d=R.InteractiveEditorResponseFeedbackKind.to(y);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,s,d)}}$releaseSession(p,k){const D=this.d.get(k),y=this.b.get(p);D&&y&&y.provider.releaseInteractiveEditorSession?.(D.session),this.d.delete(k)}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Dcc=P}),define(De[312],Ce([1,0,2,33]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class f{constructor(A,m,S,$,P){this.a=m,this.b=S,this.c=$;const I=new T.$iM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$gM("showOptions","Show Options",p=>!0,p=>p),new T.$gM("resource","Interactive resource Uri",p=>!0,p=>p),new T.$gM("controllerId","Notebook controller Id",p=>!0,p=>p),new T.$gM("title","Interactive editor title",p=>!0,p=>p)],new T.$hM("Notebook and input URI",p=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const k=this.a.getEditorById(p.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri),notebookEditor:k.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:C.URI.revive(p.notebookUri),inputUri:C.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,m,S,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$zcc=f}),define(De[313],Ce([1,0,6,7]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;class f{constructor(A){this.a=new Map,this.b=A.getProxy(C.$SJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const $=await S.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(A,m){const S=A.identifier.value;return this.a.set(S,m),this.b.$registerIssueUriRequestHandler(S),new T.$UJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Fcc=f}),define(De[314],Ce([1,0,3,6]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class f{constructor(A){this.b=0,this.a=A.getProxy(T.$SJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,C.$kb)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Sbc=f}),define(De[315],Ce([1,0,2,23,13,7,82,6,15,34,19,18,165,21,25,3,129,119,87,37,8,11,27,205]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;class c{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentSymbols(B,Z){const x=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(x,Z);if(!(0,P.$Df)(se))return se[0]instanceof R.$aK?se.map(f.DocumentSymbol.from):c.f(se)}static f(B){B=B.slice(0).sort((se,Y)=>{let fe=se.location.range.start.compareTo(Y.location.range.start);return fe===0&&(fe=Y.location.range.end.compareTo(se.location.range.end)),fe});const Z=[],x=[];for(const se of B){const Y={name:se.name||"!!MISSING: name!!",kind:f.SymbolKind.from(se.kind),tags:se.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:f.Range.from(se.location.range),selectionRange:f.Range.from(se.location.range),children:[]};for(;;){if(x.length===0){x.push(Y),Z.push(Y);break}const fe=x[x.length-1];if($.$hs.containsRange(fe.range,Y.range)&&!$.$hs.equalsRange(fe.range,Y.range)){fe.children?.push(Y),x.push(Y);break}x.pop()}}return Z}}class n{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Z,x){this.g=B,this.h=Z,this.j=x,this.e=new s.$Gac("CodeLens"),this.f=new Map}async provideCodeLenses(B,Z){const x=this.g.getDocument(B),se=await this.j.provideCodeLenses(x,Z);if(!se||Z.isCancellationRequested)return;const Y=this.e.add(se),fe=new y.$lb;this.f.set(Y,fe);const ye={cacheId:Y,lenses:[]};for(let ze=0;ze<se.length;ze++)ye.lenses.push({cacheId:[Y,ze],range:f.Range.from(se[ze].range),command:this.h.toInternal(se[ze].command,fe)});return ye}async resolveCodeLens(B,Z){const x=B.cacheId&&this.e.get(...B.cacheId);if(!x)return;let se;if(typeof this.j.resolveCodeLens!="function"||x.isResolved?se=x:se=await this.j.resolveCodeLens(x,Z),se||(se=x),Z.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(se.command??n.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function a(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class l{constructor(B,Z){this.d=B,this.e=Z}async provideDefinition(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideDefinition(se,Y,x);return a(fe)}}class v{constructor(B,Z){this.d=B,this.e=Z}async provideDeclaration(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideDeclaration(se,Y,x);return a(fe)}}class E{constructor(B,Z){this.d=B,this.e=Z}async provideImplementation(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideImplementation(se,Y,x);return a(fe)}}class u{constructor(B,Z){this.d=B,this.e=Z}async provideTypeDefinition(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideTypeDefinition(se,Y,x);return a(fe)}}class h{constructor(B,Z){this.d=B,this.e=Z}async provideHover(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideHover(se,Y,x);if(!(!fe||(0,P.$Df)(fe.contents)))return fe.range||(fe.range=se.getWordRangeAtPosition(Y)),fe.range||(fe.range=new R.$WJ(Y,Y)),f.Hover.from(fe)}}class w{constructor(B,Z){this.d=B,this.e=Z}async provideEvaluatableExpression(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideEvaluatableExpression(se,Y,x);if(fe)return f.EvaluatableExpression.from(fe)}}class L{constructor(B,Z){this.d=B,this.e=Z}async provideInlineValues(B,Z,x,se){const Y=this.d.getDocument(B),fe=await this.e.provideInlineValues(Y,f.Range.to(Z),f.InlineValueContext.to(x),se);if(Array.isArray(fe))return fe.map(ye=>f.InlineValue.from(ye))}}class O{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentHighlights(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideDocumentHighlights(se,Y,x);if(Array.isArray(fe))return fe.map(f.DocumentHighlight.from)}}class N{constructor(B,Z){this.d=B,this.e=Z}async provideLinkedEditingRanges(B,Z,x){const se=this.d.getDocument(B),Y=f.Position.to(Z),fe=await this.e.provideLinkedEditingRanges(se,Y,x);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,P.$Af)(fe.ranges.map(f.Range.from)),wordPattern:fe.wordPattern}}}class M{constructor(B,Z){this.d=B,this.e=Z}async provideReferences(B,Z,x,se){const Y=this.d.getDocument(B),fe=f.Position.to(Z),ye=await this.e.provideReferences(Y,fe,x,se);if(Array.isArray(ye))return ye.map(f.location.from)}}class z{static{this.d=1e3}constructor(B,Z,x,se,Y,fe,ye){this.h=B,this.j=Z,this.k=x,this.l=se,this.m=Y,this.n=fe,this.o=ye,this.e=new s.$Gac("CodeAction"),this.f=new Map,this.g=new R.$cK("notebook")}async provideCodeActions(B,Z,x,se){const Y=this.h.getDocument(B),fe=p.$js.isISelection(Z)?f.Selection.to(Z):f.Range.to(Z),ye=[];for(const et of this.k.getDiagnostics(B))if(fe.intersection(et.range)&&ye.push(et)>z.d)break;const ze={diagnostics:ye,only:x.only?new R.$cK(x.only):void 0,triggerKind:f.CodeActionTriggerKind.to(x.trigger)},We=await this.l.provideCodeActions(Y,fe,ze,se);if(!(0,P.$Ef)(We)||se.isCancellationRequested)return;const xe=this.e.add(We),Ye=new y.$lb;this.f.set(xe,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];if(Ae)if(z.p(Ae))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.j.toInternal(Ae,Ye)});else{if(ze.triggerKind!==R.CodeActionTriggerKind.Invoke&&Ae.kind&&this.g.contains(Ae.kind))continue;ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[xe,et],title:Ae.title,command:Ae.command&&this.j.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})}}return{cacheId:xe,actions:it}}async resolveCodeAction(B,Z){const[x,se]=B,Y=this.e.get(x,se);if(!Y||z.p(Y))return{};if(!this.l.resolveCodeAction)return{};const fe=await this.l.resolveCodeAction(Y,Z)??Y;let ye;fe.edit&&(ye=f.WorkspaceEdit.from(fe.edit,void 0));let ze;if(fe.command){const We=this.f.get(x);We&&(ze=this.j.toInternal(fe.command,We))}return{edit:ye,command:ze}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static p(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,x,se,Y){this.d=B,this.e=Z,this.f=x,this.g=se,this.h=Y}async prepareDocumentPaste(B,Z,x,se){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),fe=Z.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(x,()=>{throw new b.$9});if(await this.f.prepareDocumentPaste(Y,fe,ye,se),se.isCancellationRequested)return;const ze=Array.from(ye).filter(([,We])=>!(We instanceof R.$JK));return f.DataTransfer.from(ze)}async providePasteEdits(B,Z,x,se,Y){if(!this.f.provideDocumentPasteEdits)return;const fe=this.e.getDocument(Z),ye=x.map(xe=>f.Range.to(xe)),ze=f.DataTransfer.toDataTransfer(se,async xe=>(await this.d.$resolvePasteFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentPasteEdits(fe,ye,ze,Y);if(We)return{label:We.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:j.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class F{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentFormattingEdits(B,Z,x){const se=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(se,Z,x);if(Array.isArray(Y))return Y.map(f.TextEdit.from)}}class K{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeFormattingEdits(B,Z,x,se){const Y=this.d.getDocument(B),fe=f.Range.to(Z),ye=await this.e.provideDocumentRangeFormattingEdits(Y,fe,x,se);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Z,x,se){(0,I.$ve)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),fe=Z.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,fe,x,se);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class H{constructor(B,Z){this.d=B,this.e=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Z,x,se,Y){const fe=this.d.getDocument(B),ye=f.Position.to(Z),ze=await this.e.provideOnTypeFormattingEdits(fe,ye,x,se,Y);if(Array.isArray(ze))return ze.map(f.TextEdit.from)}}class $e{constructor(B,Z){this.e=B,this.f=Z,this.d=new s.$Gac("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Z){const x=await this.e.provideWorkspaceSymbols(B,Z);if(!(0,P.$Ef)(x))return{symbols:[]};const se=this.d.add(x),Y={cacheId:se,symbols:[]};for(let fe=0;fe<x.length;fe++){const ye=x[fe];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[se,fe]})}return Y}async resolveWorkspaceSymbol(B,Z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const x=this.d.get(...B.cacheId);if(x){const se=await this.e.resolveWorkspaceSymbol(x,Z);return se&&(0,T.$Wm)(B,f.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class _{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Z,x){this.d=B,this.e=Z,this.f=x}async provideRenameEdits(B,Z,x,se){const Y=this.d.getDocument(B),fe=f.Position.to(Z);try{const ye=await this.e.provideRenameEdits(Y,fe,x,se);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const ze=_.g(ye);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Z,x){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),Y=f.Position.to(Z);try{const fe=await this.e.prepareRename(se,Y,x);let ye,ze;if(R.$WJ.isRange(fe)?(ye=fe,ze=se.getText(fe)):(0,I.$ne)(fe)&&(ye=fe.range,ze=fe.placeholder),!ye||!ze)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:ze}}catch(fe){const ye=_.g(fe);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(fe)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,Z){this.resultId=B,this.tokens=Z}}class V{constructor(B,Z){this.f=B,this.g=Z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Z,x){const se=this.f.getDocument(B),Y=Z!==0?this.d.get(Z):null;let fe=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,Y.resultId,x):await this.g.provideDocumentSemanticTokens(se,x);return Y&&this.d.delete(Z),fe?(fe=V.h(fe),this.o(V.n(Y,fe),fe)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return V.j(B)?V.k(B)?B:new R.$aL(new Uint32Array(B.data),B.resultId):V.l(B)?V.m(B)?B:new R.$cL(B.edits.map(Z=>new R.$bL(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Z of B.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static n(B,Z){if(!V.j(Z)||!B||!B.tokens)return Z;const x=B.tokens,se=x.length,Y=Z.data,fe=Y.length;let ye=0;const ze=Math.min(se,fe);for(;ye<ze&&x[ye]===Y[ye];)ye++;if(ye===se&&ye===fe)return new R.$cL([],Z.resultId);let We=0;const xe=ze-ye;for(;We<xe&&x[se-We-1]===Y[fe-We-1];)We++;return new R.$cL([{start:ye,deleteCount:se-ye-We,data:Y.subarray(ye,fe-We)}],Z.resultId)}o(B,Z){if(V.j(B)){const x=this.e++;return this.d.set(x,new Q(B.resultId,B.data)),(0,r.$j0)({id:x,type:"full",data:B.data})}if(V.l(B)){const x=this.e++;return V.j(Z)?this.d.set(x,new Q(Z.resultId,Z.data)):this.d.set(x,new Q(B.resultId)),(0,r.$j0)({id:x,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class ee{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeSemanticTokens(B,Z,x){const se=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(se,f.Range.to(Z),x);return Y?this.f(Y):null}f(B){return(0,r.$j0)({id:0,type:"full",data:B.data})}}class me{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Z,x,se,Y){this.f=B,this.g=Z,this.h=x,this.j=se,this.k=Y,this.d=new s.$Gac("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Z,x,se){const Y=this.f.getDocument(B),fe=f.Position.to(Z),ye=Y.getWordRangeAtPosition(fe)||new R.$WJ(fe,fe),ze=ye.with({end:fe}),We=new d.$dc,xe=await this.h.provideCompletionItems(Y,fe,se,f.CompletionContext.to(x));if(!xe||se.isCancellationRequested)return;const Ye=Array.isArray(xe)?new R.$qK(xe):xe,it=me.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new y.$lb;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(ze)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Le=Ye.items[Ve],Qe=this.l(Le,[it,Ve],ze,ye);Ae.push(Qe)}return Ne}async resolveCompletionItem(B,Z){if(typeof this.h.resolveCompletionItem!="function")return;const x=this.d.get(...B);if(!x)return;const se=this.l(x,B),Y=await this.h.resolveCompletionItem(x,Z);if(!Y)return;const fe=this.l(Y,B);return(se.h!==fe.h||se.i!==fe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==fe.n||se.o!==fe.o||!(0,T.$Xm)(se.p,fe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:fe.d,c:fe.c,l:fe.l,h:fe.h,i:fe.i,n:fe.n,o:fe.o,p:fe.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z,x,se){const Y=this.e.get(Z[0]);if(!Y)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(B.command,Y),ye={x:Z,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof R.$6J&&(ye.h=B.insertText.value,ye.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),R.$WJ.isRange(ze)?ye.j=f.Range.from(ze):ze&&(!x?.isEqual(ze.inserting)||!se?.isEqual(ze.replacing))&&(ye.j={insert:f.Range.from(ze.inserting),replace:f.Range.from(ze.replacing)}),ye}}class ae{async provideInlineCompletions(B,Z,x,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,Z,x){}handlePartialAccept(B,Z,x){}}class te extends ae{constructor(B,Z,x,se){super(),this.f=B,this.g=Z,this.h=x,this.j=se,this.d=new X,this.e=(0,t.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Z,x,se){const Y=this.g.getDocument(B),fe=f.Position.to(Z),ye=await this.h.provideInlineCompletionItems(Y,fe,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:f.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[x.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const ze=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],xe=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new y.$lb),Ne=this.j.toInternal(et.command,Ye));const Ve=et.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:et.filterText,range:et.range?f.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new y.$lb),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Z,x){const se=this.d.get(B)?.items[Z];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,x)}handlePartialAccept(B,Z,x){const se=this.d.get(B)?.items[Z];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,x)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Z=this.e++;return this.d.set(Z,B),Z}disposeReferenceId(B){const Z=this.d.get(B);return this.d.delete(B),Z}get(B){return this.d.get(B)}}class U{constructor(B,Z){this.e=B,this.f=Z,this.d=new s.$Gac("SignatureHelp")}async provideSignatureHelp(B,Z,x,se){const Y=this.e.getDocument(B),fe=f.Position.to(Z),ye=this.g(x),ze=await this.f.provideSignatureHelp(Y,fe,se,ye);if(ze){const We=this.d.add([ze]);return{...f.SignatureHelp.from(ze),id:We}}}g(B){let Z;if(B.activeSignatureHelp){const x=f.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(Z=se,Z.activeSignature=x.activeSignature,Z.activeParameter=x.activeParameter):Z=x}return{...B,activeSignatureHelp:Z}}releaseSignatureHelp(B){this.d.delete(B)}}class q{constructor(B,Z,x,se,Y){this.f=B,this.g=Z,this.h=x,this.j=se,this.k=Y,this.d=new s.$Gac("InlayHints"),this.e=new Map}async provideInlayHints(B,Z,x){const se=this.f.getDocument(B),Y=f.Range.to(Z),fe=await this.h.provideInlayHints(se,Y,x);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Z}`);return}if(x.isCancellationRequested)return;const ye=this.d.add(fe);this.e.set(ye,new y.$lb);const ze={hints:[],cacheId:ye};for(let We=0;We<fe.length;We++)this.l(fe[We],Y)&&ze.hints.push(this.m(fe[We],[ye,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Z}`),ze}async resolveInlayHint(B,Z){if(typeof this.h.resolveInlayHint!="function")return;const x=this.d.get(...B);if(!x)return;const se=await this.h.resolveInlayHint(x,Z);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z){return B.label.length===0||Array.isArray(B.label)&&B.label.every(x=>x.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Z&&!Z.contains(B.position))}m(B,Z){const x=this.e.get(Z[0]);if(!x)throw Error("DisposableStore is missing...");const se={label:"",cacheId:Z,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(Y=>{const fe={label:Y.value};return fe.tooltip=f.MarkdownString.fromStrict(Y.tooltip),R.$7J.isLocation(Y.location)&&(fe.location=f.location.from(Y.location)),Y.command&&(fe.command=this.g.toInternal(Y.command,x)),fe}),se}}class G{constructor(B,Z){this.e=B,this.f=Z,this.d=new s.$Gac("DocumentLink")}async provideLinks(B,Z){const x=this.e.getDocument(B),se=await this.f.provideDocumentLinks(x,Z);if(!(!Array.isArray(se)||se.length===0)&&!Z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(G.g).map(f.DocumentLink.from)};{const Y=this.d.add(se),fe={links:[],cacheId:Y};for(let ye=0;ye<se.length;ye++){if(!G.g(se[ye]))continue;const ze=f.DocumentLink.from(se[ye]);ze.cacheId=[Y,ye],fe.links.push(ze)}return fe}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Z){if(typeof this.f.resolveDocumentLink!="function")return;const x=this.d.get(...B);if(!x)return;const se=await this.f.resolveDocumentLink(x,Z);if(!(!se||!G.g(se)))return f.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class ce{constructor(B,Z){this.d=B,this.e=Z}async provideColors(B,Z){const x=this.d.getDocument(B),se=await this.e.provideDocumentColors(x,Z);return Array.isArray(se)?se.map(fe=>({color:f.Color.from(fe.color),range:f.Range.from(fe.range)})):[]}async provideColorPresentations(B,Z,x){const se=this.d.getDocument(B),Y=f.Range.to(Z.range),fe=f.Color.to(Z.color),ye=await this.e.provideColorPresentations(fe,{document:se,range:Y},x);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class re{constructor(B,Z){this.d=B,this.e=Z}async provideFoldingRanges(B,Z,x){const se=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(se,Z,x);if(Array.isArray(Y))return Y.map(f.FoldingRange.from)}}class de{constructor(B,Z,x){this.d=B,this.e=Z,this.f=x}async provideSelectionRanges(B,Z,x){const se=this.d.getDocument(B),Y=Z.map(f.Position.to),fe=await this.e.provideSelectionRanges(se,Y,x);if(!(0,P.$Ef)(fe))return[];if(fe.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ze=0;ze<Y.length;ze++){const We=[];ye.push(We);let xe=Y[ze],Ye=fe[ze];for(;;){if(!Ye.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ye)),!Ye.parent)break;xe=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,Z){this.f=B,this.g=Z,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(B,Z,x){const se=this.f.getDocument(B),Y=f.Position.to(Z),fe=await this.g.prepareCallHierarchy(se,Y,x);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ze=>this.h(ye,ze)):[this.h(ye,fe)]}async provideCallsTo(B,Z,x){const se=this.j(B,Z);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(se,x);if(Y)return Y.map(fe=>({from:this.h(B,fe.from),fromRanges:fe.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,Z,x){const se=this.j(B,Z);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(se,x);if(Y)return Y.map(fe=>({to:this.h(B,fe.to),fromRanges:fe.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Z){const x=this.e.get(B),se=f.CallHierarchyItem.from(Z,B,x.size.toString(36));return x.set(se._itemId,Z),se}j(B,Z){return this.e.get(B)?.get(Z)}}class he{constructor(B,Z){this.f=B,this.g=Z,this.d=new i.$ZL(""),this.e=new Map}async prepareSession(B,Z,x){const se=this.f.getDocument(B),Y=f.Position.to(Z),fe=await this.g.prepareTypeHierarchy(se,Y,x);if(!fe)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(fe)?fe.map(ze=>this.h(ye,ze)):[this.h(ye,fe)]}async provideSupertypes(B,Z,x){const se=this.j(B,Z);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(se,x);if(Y)return Y.map(fe=>this.h(B,fe))}async provideSubtypes(B,Z,x){const se=this.j(B,Z);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(se,x);if(Y)return Y.map(fe=>this.h(B,fe))}releaseSession(B){this.e.delete(B)}h(B,Z){const x=this.e.get(B),se=f.TypeHierarchyItem.from(Z,B,x.size.toString(36));return x.set(se._itemId,Z),se}j(B,Z){return this.e.get(B)?.get(Z)}}class ge{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,x,se,Y){this.d=B,this.e=Z,this.f=x,this.g=se,this.h=Y}async provideDocumentOnDropEdits(B,Z,x,se,Y){const fe=this.e.getDocument(Z),ye=f.Position.to(x),ze=f.DataTransfer.toDataTransfer(se,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,xe)).buffer),We=await this.f.provideDocumentDropEdits(fe,ye,ze,Y);if(We)return{label:We.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:ge.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ne{constructor(B,Z){this.d=B,this.e=Z}async provideMappedEdits(B,Z,x,se){const Y=C.URI.revive(B),fe=this.d.getDocument(Y),ye={selections:x.selections.map(We=>f.Selection.to(We)),related:x.related.map(We=>({uri:C.URI.revive(We.uri),range:f.Range.to(We.range)}))},ze=await this.e.provideMappedEdits(fe,Z,ye,se);return ze?f.WorkspaceEdit.from(ze):null}}class ue{constructor(B,Z){this.adapter=B,this.extension=Z}}class we{static{this.d=0}constructor(B,Z,x,se,Y,fe,ye,ze){this.g=Z,this.h=x,this.j=se,this.k=Y,this.l=fe,this.m=ye,this.n=ze,this.f=new Map,this.e=B.getProxy(m.$SJ.MainThreadLanguageFeatures)}o(B,Z){return f.DocumentSelector.from(B,this.g,Z)}p(B){return new R.$UJ(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return we.d++}async t(B,Z,x,se,Y,fe=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Z))return se;const ze=Date.now();fe||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const We=x(ye.adapter,ye.extension);return Promise.resolve(We).catch(xe=>{(0,b.$2)(xe)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ye.extension.identifier,xe))}).finally(()=>{fe||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),k.CancellationToken.isCancellationToken(Y)?(0,g.$ug)(We,Y):We}u(B,Z){const x=this.q();return this.f.set(x,new ue(B,Z)),x}static w(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Z,x,se){const Y=this.u(new c(this.h,x),B),fe=se&&se.label||we.w(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(Z,B),fe),this.p(Y)}$provideDocumentSymbols(B,Z,x){return this.t(B,c,se=>se.provideDocumentSymbols(C.URI.revive(Z),x),void 0,x)}registerCodeLensProvider(B,Z,x){const se=this.q(),Y=typeof x.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new ue(new n(this.h,this.j.converter,x),B)),this.e.$registerCodeLensSupport(se,this.o(Z,B),Y);let fe=this.p(se);if(Y!==void 0){const ye=x.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Y));fe=R.$UJ.from(fe,ye)}return fe}$provideCodeLenses(B,Z,x){return this.t(B,n,se=>se.provideCodeLenses(C.URI.revive(Z),x),void 0,x)}$resolveCodeLens(B,Z,x){return this.t(B,n,se=>se.resolveCodeLens(Z,x),void 0,void 0)}$releaseCodeLenses(B,Z){this.t(B,n,x=>Promise.resolve(x.releaseCodeLenses(Z)),void 0,void 0)}registerDefinitionProvider(B,Z,x){const se=this.u(new l(this.h,x),B);return this.e.$registerDefinitionSupport(se,this.o(Z,B)),this.p(se)}$provideDefinition(B,Z,x,se){return this.t(B,l,Y=>Y.provideDefinition(C.URI.revive(Z),x,se),[],se)}registerDeclarationProvider(B,Z,x){const se=this.u(new v(this.h,x),B);return this.e.$registerDeclarationSupport(se,this.o(Z,B)),this.p(se)}$provideDeclaration(B,Z,x,se){return this.t(B,v,Y=>Y.provideDeclaration(C.URI.revive(Z),x,se),[],se)}registerImplementationProvider(B,Z,x){const se=this.u(new E(this.h,x),B);return this.e.$registerImplementationSupport(se,this.o(Z,B)),this.p(se)}$provideImplementation(B,Z,x,se){return this.t(B,E,Y=>Y.provideImplementation(C.URI.revive(Z),x,se),[],se)}registerTypeDefinitionProvider(B,Z,x){const se=this.u(new u(this.h,x),B);return this.e.$registerTypeDefinitionSupport(se,this.o(Z,B)),this.p(se)}$provideTypeDefinition(B,Z,x,se){return this.t(B,u,Y=>Y.provideTypeDefinition(C.URI.revive(Z),x,se),[],se)}registerHoverProvider(B,Z,x,se){const Y=this.u(new h(this.h,x),B);return this.e.$registerHoverProvider(Y,this.o(Z,B)),this.p(Y)}$provideHover(B,Z,x,se){return this.t(B,h,Y=>Y.provideHover(C.URI.revive(Z),x,se),void 0,se)}registerEvaluatableExpressionProvider(B,Z,x,se){const Y=this.u(new w(this.h,x),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(Z,B)),this.p(Y)}$provideEvaluatableExpression(B,Z,x,se){return this.t(B,w,Y=>Y.provideEvaluatableExpression(C.URI.revive(Z),x,se),void 0,se)}registerInlineValuesProvider(B,Z,x,se){const Y=typeof x.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.u(new L(this.h,x),B);this.e.$registerInlineValuesProvider(fe,this.o(Z,B),Y);let ye=this.p(fe);if(Y!==void 0){const ze=x.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));ye=R.$UJ.from(ye,ze)}return ye}$provideInlineValues(B,Z,x,se,Y){return this.t(B,L,fe=>fe.provideInlineValues(C.URI.revive(Z),x,se,Y),void 0,Y)}registerDocumentHighlightProvider(B,Z,x){const se=this.u(new O(this.h,x),B);return this.e.$registerDocumentHighlightProvider(se,this.o(Z,B)),this.p(se)}$provideDocumentHighlights(B,Z,x,se){return this.t(B,O,Y=>Y.provideDocumentHighlights(C.URI.revive(Z),x,se),void 0,se)}registerLinkedEditingRangeProvider(B,Z,x){const se=this.u(new N(this.h,x),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(Z,B)),this.p(se)}$provideLinkedEditingRanges(B,Z,x,se){return this.t(B,N,async Y=>{const fe=await Y.provideLinkedEditingRanges(C.URI.revive(Z),x,se);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?we.y(fe.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,Z,x){const se=this.u(new M(this.h,x),B);return this.e.$registerReferenceSupport(se,this.o(Z,B)),this.p(se)}$provideReferences(B,Z,x,se,Y){return this.t(B,M,fe=>fe.provideReferences(C.URI.revive(Z),x,se,Y),void 0,Y)}registerCodeActionProvider(B,Z,x,se){const Y=new y.$lb,fe=this.u(new z(this.h,this.j.converter,this.k,x,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(fe,this.o(Z,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},we.w(B),!!x.resolveCodeAction),Y.add(this.p(fe)),Y}$provideCodeActions(B,Z,x,se,Y){return this.t(B,z,fe=>fe.provideCodeActions(C.URI.revive(Z),x,se,Y),void 0,Y)}$resolveCodeAction(B,Z,x){return this.t(B,z,se=>se.resolveCodeAction(Z,x),{},void 0)}$releaseCodeActions(B,Z){this.t(B,z,x=>Promise.resolve(x.releaseCodeActions(Z)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Z,x){const se=this.u(new F(this.h,x),B);return this.e.$registerDocumentFormattingSupport(se,this.o(Z,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,Z,x,se){return this.t(B,F,Y=>Y.provideDocumentFormattingEdits(C.URI.revive(Z),x,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,Z,x){const se=typeof x.provideDocumentRangesFormattingEdits=="function",Y=this.u(new K(this.h,x),B);return this.e.$registerRangeFormattingSupport(Y,this.o(Z,B),B.identifier,B.displayName||B.name,se),this.p(Y)}$provideDocumentRangeFormattingEdits(B,Z,x,se,Y){return this.t(B,K,fe=>fe.provideDocumentRangeFormattingEdits(C.URI.revive(Z),x,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,Z,x,se,Y){return this.t(B,K,fe=>fe.provideDocumentRangesFormattingEdits(C.URI.revive(Z),x,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,Z,x,se){const Y=this.u(new H(this.h,x),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(Z,B),se,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,Z,x,se,Y,fe){return this.t(B,H,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(Z),x,se,Y,fe),void 0,fe)}registerWorkspaceSymbolProvider(B,Z){const x=this.u(new $e(Z,this.l),B);return this.e.$registerNavigateTypeSupport(x,typeof Z.resolveWorkspaceSymbol=="function"),this.p(x)}$provideWorkspaceSymbols(B,Z,x){return this.t(B,$e,se=>se.provideWorkspaceSymbols(Z,x),{symbols:[]},x)}$resolveWorkspaceSymbol(B,Z,x){return this.t(B,$e,se=>se.resolveWorkspaceSymbol(Z,x),void 0,void 0)}$releaseWorkspaceSymbols(B,Z){this.t(B,$e,x=>x.releaseWorkspaceSymbols(Z),void 0,void 0)}registerRenameProvider(B,Z,x){const se=this.u(new _(this.h,x,this.l),B);return this.e.$registerRenameSupport(se,this.o(Z,B),_.supportsResolving(x)),this.p(se)}$provideRenameEdits(B,Z,x,se,Y){return this.t(B,_,fe=>fe.provideRenameEdits(C.URI.revive(Z),x,se,Y),void 0,Y)}$resolveRenameLocation(B,Z,x,se){return this.t(B,_,Y=>Y.resolveRenameLocation(C.URI.revive(Z),x,se),void 0,se)}registerDocumentSemanticTokensProvider(B,Z,x,se){const Y=this.u(new V(this.h,x),B),fe=typeof x.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(Z,B),se,fe);let ye=this.p(Y);if(fe){const ze=x.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(fe));ye=R.$UJ.from(ye,ze)}return ye}$provideDocumentSemanticTokens(B,Z,x,se){return this.t(B,V,Y=>Y.provideDocumentSemanticTokens(C.URI.revive(Z),x,se),null,se)}$releaseDocumentSemanticTokens(B,Z){this.t(B,V,x=>x.releaseDocumentSemanticColoring(Z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Z,x,se){const Y=this.u(new ee(this.h,x),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(Z,B),se),this.p(Y)}$provideDocumentRangeSemanticTokens(B,Z,x,se){return this.t(B,ee,Y=>Y.provideDocumentRangeSemanticTokens(C.URI.revive(Z),x,se),null,se)}registerCompletionItemProvider(B,Z,x,se){const Y=this.u(new me(this.h,this.j.converter,x,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(Z,B),se,me.supportsResolving(x),B.identifier),this.p(Y)}$provideCompletionItems(B,Z,x,se,Y){return this.t(B,me,fe=>fe.provideCompletionItems(C.URI.revive(Z),x,se,Y),void 0,Y)}$resolveCompletionItem(B,Z,x){return this.t(B,me,se=>se.resolveCompletionItem(Z,x),void 0,x)}$releaseCompletionItems(B,Z){this.t(B,me,x=>x.releaseCompletionItems(Z),void 0,void 0)}registerInlineCompletionsProvider(B,Z,x,se){const Y=new te(B,this.h,x,this.j.converter),fe=this.u(Y,B);return this.e.$registerInlineCompletionsSupport(fe,this.o(Z,B),Y.supportsHandleEvents,D.$Tl.toKey(B.identifier.value),se?.yieldTo?.map(ye=>D.$Tl.toKey(ye))||[]),this.p(fe)}$provideInlineCompletions(B,Z,x,se,Y){return this.t(B,ae,fe=>fe.provideInlineCompletions(C.URI.revive(Z),x,se,Y),void 0,Y)}$handleInlineCompletionDidShow(B,Z,x,se){this.t(B,ae,async Y=>{Y.handleDidShowCompletionItem(Z,x,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Z,x,se){this.t(B,ae,async Y=>{Y.handlePartialAccept(Z,x,se)},void 0,void 0)}$freeInlineCompletionsList(B,Z){this.t(B,ae,async x=>{x.disposeCompletions(Z)},void 0,void 0)}registerSignatureHelpProvider(B,Z,x,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,fe=this.u(new U(this.h,x),B);return this.e.$registerSignatureHelpProvider(fe,this.o(Z,B),Y),this.p(fe)}$provideSignatureHelp(B,Z,x,se,Y){return this.t(B,U,fe=>fe.provideSignatureHelp(C.URI.revive(Z),x,se,Y),void 0,Y)}$releaseSignatureHelp(B,Z){this.t(B,U,x=>x.releaseSignatureHelp(Z),void 0,void 0)}registerInlayHintsProvider(B,Z,x){const se=typeof x.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.u(new q(this.h,this.j.converter,x,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(Z,B),typeof x.resolveInlayHint=="function",se,we.w(B));let fe=this.p(Y);if(se!==void 0){const ye=x.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(se));fe=R.$UJ.from(fe,ye)}return fe}$provideInlayHints(B,Z,x,se){return this.t(B,q,Y=>Y.provideInlayHints(C.URI.revive(Z),x,se),void 0,se)}$resolveInlayHint(B,Z,x){return this.t(B,q,se=>se.resolveInlayHint(Z,x),void 0,x)}$releaseInlayHints(B,Z){this.t(B,q,x=>x.releaseHints(Z),void 0,void 0)}registerDocumentLinkProvider(B,Z,x){const se=this.u(new G(this.h,x),B);return this.e.$registerDocumentLinkProvider(se,this.o(Z,B),typeof x.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,Z,x){return this.t(B,G,se=>se.provideLinks(C.URI.revive(Z),x),void 0,x,Z.scheme==="output")}$resolveDocumentLink(B,Z,x){return this.t(B,G,se=>se.resolveLink(Z,x),void 0,void 0,!0)}$releaseDocumentLinks(B,Z){this.t(B,G,x=>x.releaseLinks(Z),void 0,void 0,!0)}registerColorProvider(B,Z,x){const se=this.u(new ce(this.h,x),B);return this.e.$registerDocumentColorProvider(se,this.o(Z,B)),this.p(se)}$provideDocumentColors(B,Z,x){return this.t(B,ce,se=>se.provideColors(C.URI.revive(Z),x),[],x)}$provideColorPresentations(B,Z,x,se){return this.t(B,ce,Y=>Y.provideColorPresentations(C.URI.revive(Z),x,se),void 0,se)}registerFoldingRangeProvider(B,Z,x){const se=this.q(),Y=typeof x.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new ue(new re(this.h,x),B)),this.e.$registerFoldingRangeProvider(se,this.o(Z,B),B.identifier,Y);let fe=this.p(se);if(Y!==void 0){const ye=x.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));fe=R.$UJ.from(fe,ye)}return fe}$provideFoldingRanges(B,Z,x,se){return this.t(B,re,Y=>Y.provideFoldingRanges(C.URI.revive(Z),x,se),void 0,se)}registerSelectionRangeProvider(B,Z,x){const se=this.u(new de(this.h,x,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(Z,B)),this.p(se)}$provideSelectionRanges(B,Z,x,se){return this.t(B,de,Y=>Y.provideSelectionRanges(C.URI.revive(Z),x,se),[],se)}registerCallHierarchyProvider(B,Z,x){const se=this.u(new Ee(this.h,x),B);return this.e.$registerCallHierarchyProvider(se,this.o(Z,B)),this.p(se)}$prepareCallHierarchy(B,Z,x,se){return this.t(B,Ee,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(Z),x,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,Z,x,se){return this.t(B,Ee,Y=>Y.provideCallsTo(Z,x,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,Z,x,se){return this.t(B,Ee,Y=>Y.provideCallsFrom(Z,x,se),void 0,se)}$releaseCallHierarchy(B,Z){this.t(B,Ee,x=>Promise.resolve(x.releaseSession(Z)),void 0,void 0)}registerTypeHierarchyProvider(B,Z,x){const se=this.u(new he(this.h,x),B);return this.e.$registerTypeHierarchyProvider(se,this.o(Z,B)),this.p(se)}$prepareTypeHierarchy(B,Z,x,se){return this.t(B,he,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(Z),x,se)),void 0,se)}$provideTypeHierarchySupertypes(B,Z,x,se){return this.t(B,he,Y=>Y.provideSupertypes(Z,x,se),void 0,se)}$provideTypeHierarchySubtypes(B,Z,x,se){return this.t(B,he,Y=>Y.provideSubtypes(Z,x,se),void 0,se)}$releaseTypeHierarchy(B,Z){this.t(B,he,x=>Promise.resolve(x.releaseSession(Z)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Z,x,se){const Y=this.q();this.f.set(Y,new ue(new ge(this.e,this.h,x,Y,B),B));const fe=(0,t.$LF)(B,"dropMetadata")&&se?ge.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(Z,B),fe,(0,t.$LF)(B,"dropMetadata")?se:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,Z,x,se,Y,fe){return this.t(B,ge,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Z,C.URI.revive(x),se,Y,fe)),void 0,void 0)}registerMappedEditsProvider(B,Z,x){const se=this.u(new ne(this.h,x),B);return this.e.$registerMappedEditsProvider(se,this.o(Z,B)),this.p(se)}$provideMappedEdits(B,Z,x,se,Y){return this.t(B,ne,fe=>Promise.resolve(fe.provideMappedEdits(Z,x,se,Y)),null,Y)}registerDocumentPasteEditProvider(B,Z,x,se){const Y=this.q();this.f.set(Y,new ue(new j(this.e,this.h,x,Y,B),B));const fe=j.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(Y,this.o(Z,B),fe,{supportsCopy:!!x.prepareDocumentPaste,supportsPaste:!!x.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,Z,x,se,Y){return this.t(B,j,fe=>fe.prepareDocumentPaste(C.URI.revive(Z),x,se,Y),void 0,Y)}$providePasteEdits(B,Z,x,se,Y,fe){return this.t(B,j,ye=>ye.providePasteEdits(Z,C.URI.revive(x),se,Y,fe),void 0,fe)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:we.y(B.decreaseIndentPattern),increaseIndentPattern:we.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?we.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?we.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:we.y(B.beforeText),afterText:B.afterText?we.y(B.afterText):void 0,previousLineText:B.previousLineText?we.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(we.B)}setLanguageConfiguration(B,Z,x){const{wordPattern:se}=x;if(se&&(0,S.$Bd)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(Z,se):this.h.setWordDefinitionFor(Z,void 0),x.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),x.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use."),x.autoClosingPairs&&(0,t.$MF)(B,"languageConfigurationAutoClosingPairs");const Y=this.q(),fe={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?we.y(x.wordPattern):void 0,indentationRules:x.indentationRules?we.z(x.indentationRules):void 0,onEnterRules:x.onEnterRules?we.C(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport,autoClosingPairs:x.autoClosingPairs};return this.e.$setLanguageConfiguration(Y,Z,fe),this.p(Y)}$setWordDefinitions(B){for(const Z of B)this.h.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.$Pac=we}),define(De[316],Ce([1,0,6,13,7,38,11,3]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class S{constructor(P,I,p,k){this.c=I,this.d=p,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(C.$SJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,I){await this.a.$changeLanguage(P,I);const p=this.c.getDocumentData(P);if(!p)throw new Error(`document '${P.toString()}' NOT found`);return p.document}async tokenAtPosition(P,I){const p=P.version,k=T.Position.from(I),D=await this.a.$tokensAtPosition(P.uri,k),y={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new f.$WJ(I.line,I.character,I.line,I.character)};if(!D)return y;const r={range:T.Range.to(D.range),type:T.TokenType.to(D.type)};return!r.range.contains(I)||p!==P.version?y:r}createLanguageStatusItem(P,I,p){const k=this.f++,D=this.a,y=this.g,r=`${P.identifier.value}/${I}`;if(y.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);y.add(r);const i={selector:p,id:I,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let s;const d=new m.$lb,b=()=>{if(s?.dispose(),!y.has(r)){console.warn(`LanguageStatusItem (${I}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}s=(0,A.$Gg)(()=>{d.clear(),this.a.$setLanguageStatus(k,{id:r,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?R.default.Error:i.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,d),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},g={dispose(){d.dispose(),s?.dispose(),D.$removeLanguageStatus(k),y.delete(r)},get id(){return i.id},get name(){return i.name},set name(t){i.name=t,b()},get selector(){return i.selector},set selector(t){i.selector=t,b()},get text(){return i.text},set text(t){i.text=t,b()},get detail(){return i.detail},set detail(t){i.detail=t,b()},get severity(){return i.severity},set severity(t){i.severity=t,b()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(t){i.accessibilityInformation=t,b()},get command(){return i.command},set command(t){i.command=t,b()},get busy(){return i.busy},set busy(t){i.busy=t,b()}};return b(),g}}e.$xbc=S}),define(De[112],Ce([1,0,12,15,2,5,14,6,26,20]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=e.$mbc=void 0;let P=class{constructor(p,k,D){this.f=D,this.d=new Map,this.a=k.getProxy(m.$SJ.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===C.$f}getMessage(p,k){const{message:D,args:y,comment:r}=k;if(this.c)return(0,T.$qd)(D,y??{});let i=D;r&&r.length>0&&(i+=`/${Array.isArray(r)?r.join(""):r}`);const s=this.d.get(p)?.contents[i];return s||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,T.$qd)(s??D,y??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let k;const D=await this.g(p);if(!D){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const y=await this.a.$fetchBundleContents(D),r=JSON.parse(y);k=p.isBuiltin?r.contents?.bundle:r}catch(y){this.f.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${y.message}`);return}k&&this.d.set(p.identifier.value,{contents:k,uri:D})}async g(p){if(p.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return f.URI.revive(k)}return p.l10n?f.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$mbc=P,e.$mbc=P=Ke([Be(0,S.$$L),Be(1,$.$UL),Be(2,A.$3i)],P),e.$nbc=(0,R.$zh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,26,20,2,62]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;let S=class extends C.$bj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(k=>(0,m.$9g)(k))),this.n=I.getProxy(T.$SJ.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(A.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.n.$setVisibility(I,p)}m(I,p,k){return new $(this.n,I,p,k)}};e.$Ncc=S,e.$Ncc=S=Ke([Be(0,R.$UL),Be(1,f.$$L)],S);class $ extends C.$9i{constructor(I,p,k,D){super(D?.logLevel==="always"),this.m=I,this.n=p,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger(p,D).then(()=>{this.r(this.l),this.k=!0})}g(I,p){const k=[[I,p]];this.k?this.r(k):this.l.push(...k)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=e.$obc=void 0,e.$obc=(0,T.$zh)("IExtHostManagedSockets");let m=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$SJ.MainThreadManagedSockets)}setFactory(I,p){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,k=await this.c.makeConnection(),D=new f.$lb;return this.d.set(p,new $(p,k,D)),D.add((0,f.$kb)(()=>this.d.delete(p))),D.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),D.dispose()})),D.add(k.onDidClose(y=>{this.a.$onDidManagedSocketClose(p,y?.stack??y?.message),D.dispose()})),D.add(k.onDidReceiveMessage(y=>this.a.$onDidManagedSocketHaveData(p,A.$Hc.wrap(y)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$pbc=m,e.$pbc=m=Ke([Be(0,R.$UL)],m);class S{constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class $ extends f.$mb{constructor(I,p,k){super(),this.socketId=I,this.actual=p,this.B(k)}}}),define(De[317],Ce([1,0,6,14,27]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=void 0;function R(m){return m&&m.title}let A=class{constructor(S,$){this.b=$,this.a=S.getProxy(C.$SJ.MainThreadMessageService)}showMessage(S,$,P,I,p){const k={source:{identifier:S.identifier,label:S.displayName||S.name}};let D;typeof I=="string"||R(I)?D=[I,...p]:(k.modal=I?.modal,k.useCustom=I?.useCustom,k.detail=I?.detail,D=p),k.useCustom&&(0,f.$MF)(S,"resolvers");const y=[];for(let r=0;r<D.length;r++){const i=D[r];if(typeof i=="string")y.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:s,isCloseAffordance:d}=i;y.push({title:s,isCloseAffordance:!!d,handle:r})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage($,P,k,y).then(r=>{if(typeof r=="number")return D[r]})}};e.$ybc=A,e.$ybc=A=Ke([Be(1,T.$3i)],A)}),define(De[318],Ce([1,0,207,22,4,3,28,15,18,2,30,87,6,33,13,7,68,281,144,8,23,17]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,n,a,l,v){this.q=a,this.r=l,this.s=v,this.f=new Map,this.g=new A.$xi,this.h=new Map,this.j=new f.$hc({onListenerError:d.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$hc({onListenerError:d.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$hc({onListenerError:d.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$hc({onListenerError:d.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Gac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=c.getProxy(p.$SJ.MainThreadNotebook),this.c=c.getProxy(p.$SJ.MainThreadNotebookDocuments),this.d=c.getProxy(p.$SJ.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const u=E.notebookEditor?.notebookUri,h=E.cell.handle,L=this.g.get(u)?.getCell(h);if(L)return L.apiCell}if(E&&E.$mid===14){const u=E.uri,h=this.g.get(u);if(h)return h.apiNotebook}return E}}),t.A(n)}getEditorById(c){const n=this.h.get(c);if(!n)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(c){for(const[n,a]of this.h)if(a.apiEditor===c)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,n){const a=this.g.get(c);if(!a&&!n)throw new Error(`NO notebook document for '${c}'`);return a}static t(c,n){if(!n)return;const a=n.filenamePattern.map(l=>D.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(n.filenamePattern&&!a){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:n.displayName,filenamePattern:a,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,n,a){const l=t.a++,v=typeof a.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(l,a),this.b.$registerNotebookCellStatusBarItemProvider(l,v,n);let E;return v!==void 0&&(E=a.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(v))),new y.$UJ(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,v),E?.dispose()})}async createNotebookDocument(c){const n=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&D.NotebookData.from(c.content)});return $.URI.revive(n)}async openNotebookDocument(c){const n=this.g.get(c);if(n)return n.apiNotebook;const a=await this.c.$tryOpenNotebook(c),l=this.g.get($.URI.revive(a));return(0,S.$we)(l?.apiNotebook)}async showNotebookDocument(c,n){$.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let a;typeof n=="object"?a={position:D.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(D.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:a={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,a),v=l&&this.h.get(l)?.apiEditor;if(v)return v;throw l?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,n,a,l){const v=this.f.get(c),E=$.URI.revive(n),u=this.g.get(E);if(!u||!v)return;const h=u.getCellFromIndex(a);if(!h)return;const w=await v.provideCellStatusBarItems(h.apiCell,l);if(!w)return;const L=new R.$lb,O=this.p.add([L]),M=(Array.isArray(w)?w:[w]).map(z=>D.NotebookStatusBarItem.from(z,this.i,L));return{cacheId:O,items:M}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,n,a,l,v){if((0,m.$od)(n))throw new Error("viewType cannot be empty or just whitespace");const E=this.u++;return this.w.set(E,{viewType:n,serializer:a,options:l}),this.b.$registerNotebookSerializer(E,{id:c.identifier,location:c.extensionLocation},n,D.NotebookDocumentContentOptions.from(l),t.t(c,v)),(0,R.$kb)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(c,n,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const v=await l.serializer.deserializeNotebook(n.buffer,a);return new r.$_z(D.NotebookData.from(v))}async $notebookToData(c,n,a){const l=this.w.get(c);if(!l)throw new Error("NO serializer found");const v=await l.serializer.serializeNotebook(D.NotebookData.to(n.value),a);return T.$Hc.wrap(v)}async $saveNotebook(c,n,a,l,v){const E=$.URI.revive(n),u=this.w.get(c);if(!u)throw new Error("NO serializer found");const h=this.g.get(E);if(!h)throw new Error("Document NOT found");if(h.versionId!==a)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new P.$lk((0,C.localize)(0,null,this.y(E)),6);await this.x(E,l);const w={metadata:(0,b.$2m)(h.apiNotebook.metadata,z=>!(u.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of h.apiNotebook.getCells()){const j=new y.$hL(z.kind,z.document.getText(),z.document.languageId,z.mime,u.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);j.metadata=(0,b.$2m)(z.metadata,F=>!(u.options?.transientCellMetadata??{})[F]),w.cells.push(j)}const L=await u.serializer.serializeNotebook(w,v);await this.s.value.writeFile(E,L);const O=this.s.getFileSystemProviderExtUri(E.scheme),N=await this.s.value.stat(E);return{name:O.basename(E),isFile:(N.type&P.FileType.File)!==0,isDirectory:(N.type&P.FileType.Directory)!==0,isSymbolicLink:(N.type&P.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((N.permissions??0)&P.FilePermission.Locked),etag:P.$wk({mtime:N.mtime,size:N.size}),children:void 0}}async x(c,n){const a=await this.s.value.stat(c);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==P.$vk&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==P.$wk({mtime:n.mtime,size:a.size}))throw new P.$lk((0,C.localize)(1,null),3,n)}y(c){return c.scheme===g.Schemas.file?c.fsPath:c.toString()}z(c,n,a){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const l=new s.$fcc(n,this.d,c,a.visibleRanges.map(D.NotebookRange.to),a.selections.map(D.NotebookRange.to),typeof a.viewColumn=="number"?D.ViewColumn.to(a.viewColumn):void 0);this.h.set(n,l)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const a of c.value.removedDocuments){const l=$.URI.revive(a),v=this.g.get(l);v&&(v.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(v.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===l.toString()&&this.h.delete(E.id)}if(c.value.addedDocuments){const a=[];for(const l of c.value.addedDocuments){const v=$.URI.revive(l.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const E=new i.$ecc(this.c,this.q,this.r,v,l);a.push(...l.cells.map(u=>i.$dcc.asModelAddData(E.apiNotebook,u))),this.g.get(v)?.dispose(),this.g.set(v,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this.m.fire(E.apiNotebook)}}if(c.value.addedEditors)for(const a of c.value.addedEditors){if(this.h.has(a.id))return;const l=$.URI.revive(a.documentUri),v=this.g.get(l);v&&this.z(v,a.id,a)}const n=[];if(c.value.removedEditors)for(const a of c.value.removedEditors){const l=this.h.get(a);l&&(this.h.delete(a),this.k?.id===l.id&&(this.k=void 0),n.push(l))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const a=new Set;this.l.forEach(l=>a.add(l.id));for(const l of this.h.values()){const v=a.has(l.id);l._acceptVisibility(v)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(c){const n=k.$gM.String.with("notebookType","A notebook type"),a=new k.$iM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new k.$gM("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>T.$Hc.wrap(v))],new k.$hM("Notebook Data",v=>D.NotebookData.to(v.value))),l=new k.$iM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new k.$gM("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new r.$_z(D.NotebookData.from(v)))],new k.$hM("Bytes",v=>v.buffer));c.registerApiCommand(a),c.registerApiCommand(l)}}e.$gcc=t}),define(De[319],Ce([1,0,19,11,21,4,3,28,2,25,14,87,6,33,13,7,110,275,27,68]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;let b=class{constructor(v,E,u,h,w){this.m=E,this.n=u,this.o=h,this.q=w,this.b=new m.$xi,this.c=new m.$xi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$Gac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new R.$hc,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=v.getProxy(p.$SJ.MainThreadNotebookKernels);const L=new k.$iM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.$gM("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const N=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:N}}else if(O&&"notebookEditor"in O){const N=this.n.getIdByEditor(O.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return O})],k.$hM.Void);this.o.registerApiCommand(L)}createNotebookController(v,E,u,h,w,L){for(const me of this.j.values())if(me.controller.id===E&&$.$Tl.equals(v.identifier,me.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const O=this.k++,N=this;this.q.trace(`NotebookController[${O}], CREATED by ${v.identifier.value}, ${E}`);const M=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${v.identifier}'`);let z=!1;const j=new R.$hc,F=new R.$hc,K={id:a(v.identifier,E),notebookType:u,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:h||v.identifier.value,preloads:L?L.map(D.NotebookRendererScript.from):[]};let H=w??M,$e;this.a.$addKernel(O,K).catch(me=>{console.log(me),z=!0});let _=0;const Q=()=>{if(z)return;const me=++_;Promise.resolve().then(()=>{me===_&&this.a.$updateKernel(O,K)})},V=new m.$xi,ee={get id(){return E},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return K.label},set label(me){K.label=me??v.displayName??v.name,Q()},get detail(){return K.detail??""},set detail(me){K.detail=me,Q()},get description(){return K.description??""},set description(me){K.description=me,Q()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(me){K.supportedLanguages=me,Q()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(me){K.supportsExecutionOrder=me,Q()},get rendererScripts(){return K.preloads?K.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(me){H=me??M},get interruptHandler(){return $e},set interruptHandler(me){$e=me,K.supportsInterrupt=!!me,Q()},createNotebookCellExecution(me){if(z)throw new Error("notebook controller is DISPOSED");if(!V.has(me.notebook.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return N._createNotebookCellExecution(me,a(v.identifier,this.id))},createNotebookExecution(me){if((0,s.$MF)(v,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!V.has(me.uri))throw N.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ae=>ae.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return N._createNotebookExecution(me,a(v.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${O}], DISPOSED`),z=!0,this.j.delete(O),j.dispose(),F.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(me,ae){ae===y.NotebookControllerAffinity2.Hidden&&(0,s.$MF)(v,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(O,me.uri,ae)},onDidReceiveMessage:F.event,postMessage(me,ae){return(0,s.$MF)(v,"notebookMessaging"),N.a.$postMessage(O,ae&&N.n.getIdByEditor(ae),me)},asWebviewUri(me){return(0,s.$MF)(v,"notebookMessaging"),(0,r.$Kob)(me,N.m.remote)}};return this.j.set(O,{extensionId:v.identifier,controller:ee,onDidReceiveMessage:F,onDidChangeSelection:j,associatedNotebooks:V}),ee}getIdByController(v){for(const[E,u]of this.j)if(u.controller===v)return a(u.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,E){const u=this.f++,h=this;this.q.trace(`NotebookControllerDetectionTask[${u}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(u,E);const w={dispose:()=>{this.e.delete(u),h.a.$removeKernelDetectionTask(u)}};return this.e.set(u,w),w}registerKernelSourceActionProvider(v,E,u){const h=this.h++,w=typeof u.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,L=this;this.g.set(h,u),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,E);let O;return w!==void 0&&(O=u.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),L.a.$removeKernelSourceActionProvider(h,h),O?.dispose()}}}async $provideKernelSourceActions(v,E){const u=this.g.get(v);if(u){const h=new A.$lb;return this.i.add([h]),(await u.provideNotebookKernelSourceActions(E)??[]).map(L=>D.NotebookKernelSourceAction.from(L,this.o.converter,h))}return[]}$acceptNotebookAssociation(v,E,u){const h=this.j.get(v);if(h){const w=this.n.getNotebookDocument(S.URI.revive(E));u?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,w.uri.toString(),u),h.onDidChangeSelection.fire({selected:u,notebook:w.apiNotebook})}}async $executeCells(v,E,u){const h=this.j.get(v);if(!h)return;const w=this.n.getNotebookDocument(S.URI.revive(E)),L=[];for(const O of u){const N=w.getCell(O);N&&L.push(N.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,w.uri.toString(),L.length),await h.controller.executeHandler.call(h.controller,L,w.apiNotebook,h.controller)}catch(O){this.q.error(`NotebookController[${v}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(v,E,u){const h=this.j.get(v);if(!h)return;const w=this.n.getNotebookDocument(S.URI.revive(E));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const L of u){const O=w.getCell(L);O&&this.b.get(O.uri)?.cancel()}if(h.controller.interruptHandler){const L=this.c.get(w.uri);u.length&&Array.isArray(L)&&L.length&&L.forEach(O=>O.dispose())}}$acceptKernelMessageFromRenderer(v,E,u){const h=this.j.get(v);if(!h)return;const w=this.n.getEditorById(E);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:u}))}$cellExecutionChanged(v,E,u){const w=this.n.getNotebookDocument(S.URI.revive(v)).getCell(E);if(w){const L=u?D.NotebookCellExecutionState.to(u):y.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:w.apiCell,state:L})}}_createNotebookCellExecution(v,E){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new t(E,h,this.a);this.b.set(h.uri,w);const L=w.onDidChangeState(()=>{w.state===g.Resolved&&(w.dispose(),L.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(v,E){const u=this.n.getNotebookDocument(v.uri),h=v.getCells().find(O=>{const N=u.getCellFromApiCell(O);return N&&this.b.has(N.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(u.uri))throw new Error(`duplicate notebook execution for ${u.uri}`);const w=new c(E,u,this.a),L=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),L.dispose(),this.c.delete(u.uri))});return this.c.set(u.uri,[w,L]),w.asApiObject()}};e.$ucc=b,e.$ucc=b=Ke([Be(4,P.$3i)],b);var g;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(g||(g={}));class t extends A.$mb{static{this.a=0}get state(){return this.f}constructor(v,E,u){super(),this.j=E,this.k=u,this.b=t.a++,this.c=new R.$hc,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new f.$rc),this.h=new n(10,h=>this.m(h)),this.i=E.internalMetadata.executionOrder,this.k.$createExecution(this.b,v,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(v){await this.h.addItem(v)}async m(v){const E=Array.isArray(v)?v:[v];return this.k.$updateExecution(this.b,new d.$_z(E))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(v){let E=this.j;if(v&&(E=this.j.notebook.getCellFromApiCell(v)),!E)throw new Error("INVALID cell");return E.handle}s(v){return v.map(E=>{const u=y.$kL.ensureUniqueMimeTypes(E.items,!0);return u===E.items?D.NotebookCellOutput.from(E):D.NotebookCellOutput.from({items:u,id:E.id,metadata:E.metadata})})}async t(v,E,u){const h=this.r(E),w=this.s((0,C.$Vf)(v));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:h,append:u,outputs:w})}async w(v,E,u){return v=y.$kL.ensureUniqueMimeTypes((0,C.$Vf)(v),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:v.map(D.NotebookCellOutputItem.from),outputId:E.id,append:u})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.j.apiCell},get executionOrder(){return v.i},set executionOrder(u){v.i=u,v.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:v.i}])},start(u){if(v.f===g.Resolved||v.f===g.Started)throw new Error("Cannot call start again");v.f=g.Started,v.c.fire(),v.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:u})},end(u,h){if(v.f===g.Resolved)throw new Error("Cannot call resolve twice");v.f=g.Resolved,v.c.fire(),v.h.flush(),v.k.$completeExecution(v.b,new d.$_z({runEndTime:h,lastRunSuccess:u}))},clearOutput(u){return v.n(),v.t([],u,!1)},appendOutput(u,h){return v.n(),v.t(u,h,!0)},replaceOutput(u,h){return v.n(),v.t(u,h,!1)},appendOutputItems(u,h){return v.n(),v.w(u,h,!0)},replaceOutputItems(u,h){return v.n(),v.w(u,h,!1)}})}}var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class c extends A.$mb{static{this.a=0}get state(){return this.f}constructor(v,E,u){super(),this.h=E,this.i=u,this.b=c.a++,this.c=new R.$hc,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new f.$rc),this.i.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===o.Resolved||this.f===o.Started)throw new Error("Cannot call start again");this.f=o.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===o.Resolved)throw new Error("Cannot call resolve twice");this.f=o.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class n{constructor(v,E){this.e=v,this.f=E,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new T.$Zg,this.b=Date.now(),(0,T.$Fg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>v.complete())}}function a(l,v){return`${l.value}/${v}`}e.$vcc=a}),define(De[320],Ce([1,0,4,6,144]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class R{constructor(m,S){this.c=S,this.a=new Map,this.b=m.getProxy(T.$SJ.MainThreadNotebookRenderers)}$postRendererMessage(m,S,$){const P=this.c.getEditorById(m);this.a.get(S)?.fire({editor:P.apiEditor,message:$})}createRendererMessaging(m,S){if(!m.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,I,p)=>this.d(S).event(P,I,p),postMessage:(P,I)=>{f.$fcc.apiEditorsToExtHost.has(P)&&([P,I]=[I,P]);const p=I&&f.$fcc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,S,P)}}}d(m){let S=this.a.get(m);return S||(S=new C.$hc({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(m)}}),this.a.set(m,S),S)}}e.$wcc=R}),define(De[321],Ce([1,0,3,18,2,27,6]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class m{constructor($){this.b=new Map,this.a=$.getProxy(A.$SJ.MainThreadProfileContentHandlers)}registrProfileContentHandler($,P,I){if((0,R.$MF)($,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,I),this.a.$registerProfileContentHandler(P,I.name,I.description,$.identifier.value),(0,C.$kb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile($,P,I,p){const k=this.b.get($);if(!k)throw new Error(`Unknown handler with id: ${$}`);return k.saveProfile(P,I,p)}async $readProfile($,P,I){const p=this.b.get($);if(!p)throw new Error(`Unknown handler with id: ${$}`);return p.readProfile((0,T.$le)(P)?P:f.URI.revive(P),I)}}e.$Acc=m}),define(De[322],Ce([1,0,2,6,11,13]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class A{static{this.a=0}constructor(S,$){this.d=$,this.c=new Map,this.b=S.getProxy(T.$SJ.MainThreadQuickDiff)}$provideOriginalResource(S,$,P){const I=C.URI.revive($),p=this.c.get(S);return p?(0,f.$xg)(()=>p.provideOriginalResource(I,P)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(S,$,P,I){const p=A.a++;return this.c.set(p,$),this.b.$registerQuickDiffProvider(p,R.DocumentSelector.from(S,this.d),P,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Bcc=A}),define(De[323],Ce([1,0,21,4,3,6,2,7,8,19,38,59,27,13]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;function D(y,r,i){const s=y.getProxy(R.$SJ.MainThreadQuickOpen);class d{constructor(v,E){this.e=new Map,this.f=0,this.a=v,this.b=E}showQuickPick(v,E,u,h=C.CancellationToken.None){this.c=void 0;const w=Promise.resolve(E),L=++this.f,O=s.$show(L,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},h),N={},M=O.then(()=>N);return Promise.race([M,w]).then(z=>{if(z===N)return;const j=(0,p.$LF)(v,"quickPickItemTooltip");return w.then(F=>{const K=[];for(let H=0;H<F.length;H++){const $e=F[H];if(typeof $e=="string")K.push({label:$e,handle:H});else if($e.kind===m.QuickPickItemKind.Separator)K.push({type:"separator",label:$e.label});else{$e.tooltip&&!j&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const _=$e.iconPath?c($e.iconPath):void 0;K.push({label:$e.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:j?k.MarkdownString.fromStrict($e.tooltip):void 0,handle:H})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=H=>{u.onDidSelectItem(F[H])}),s.$setItems(L,K),O.then(H=>{if(typeof H=="number")return F[H];if(Array.isArray(H))return H.map($e=>F[$e])})})}).then(void 0,z=>{if(!(0,S.$2)(z))return s.$setError(L,z),Promise.reject(z)})}$onItemSelected(v){this.c?.(v)}showInput(v,E=C.CancellationToken.None){return this.d=v?.validateInput,s.$input(v,typeof this.d=="function",E).then(void 0,u=>{if(!(0,S.$2)(u))return Promise.reject(u)})}async $validateInput(v){if(!this.d)return;const E=await this.d(v);if(!E||typeof E=="string")return E;let u;switch(E.severity){case m.InputBoxValidationSeverity.Info:u=P.default.Info;break;case m.InputBoxValidationSeverity.Warning:u=P.default.Warning;break;case m.InputBoxValidationSeverity.Error:u=P.default.Error;break;default:u=E.message?P.default.Error:P.default.Ignore;break}return{content:E.message,severity:u}}async showWorkspaceFolderPick(v,E=C.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!u)return;const h=await this.a.getWorkspaceFolders2();if(h)return h.find(w=>w.uri.toString()===u.uri.toString())}createQuickPick(v){const E=new n(v,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(v){const E=new a(v,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(v,E){this.e.get(v)?._fireDidChangeValue(E)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,E){const u=this.e.get(v);u instanceof n&&u._fireDidChangeActive(E)}$onDidChangeSelection(v,E){const u=this.e.get(v);u instanceof n&&u._fireDidChangeSelection(E)}$onDidTriggerButton(v,E){this.e.get(v)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(v,E,u){const h=this.e.get(v);h instanceof n&&h._fireDidTriggerItemButton(E,u)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class b{static{this.a=1}constructor(v,E){this.x=v,this.y=E,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$hc,this.q=new T.$hc,this.r=new T.$hc,this.s=new T.$hc,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((E,u)=>{const h=E===m.$dL.Back?-1:u;this.o.set(h,E)}),this.z({buttons:v.map((E,u)=>({...c(E.iconPath),tooltip:E.tooltip,handle:E===m.$dL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const E=this.o.get(v);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$hb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(v){if(!this.v){for(const E of Object.keys(v)){const u=v[E];this.u[E]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}function g(l){if(l instanceof m.$PK)return{id:l.id};const v=o(l),E=t(l);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof E=="string"?A.URI.file(E):E}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function o(l){return typeof l=="object"&&"dark"in l?l.dark:l}function c(l){const v=g(l);let E,u;return"id"in v?u=I.ThemeIcon.asClassName(v):E=v,{iconPath:E,iconClass:u}}class n extends b{constructor(v,E){super(v.identifier,E),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$hc,this.L=[],this.M=new T.$hc,this.N=new T.$hc,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((h,w)=>{this.C.set(w,h),this.D.set(h,w)});const E=(0,p.$LF)(this.O,"quickPickItemTooltip"),u=[];for(let h=0;h<v.length;h++){const w=v[h];if(w.kind===m.QuickPickItemKind.Separator)u.push({type:"separator",label:w.label});else{w.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=w.iconPath?c(w.iconPath):void 0;u.push({handle:h,label:w.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:E?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((O,N)=>({...c(O.iconPath),tooltip:O.tooltip,handle:N}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(v){const E=(0,$.$Af)(v.map(u=>this.C.get(u)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(v){const E=(0,$.$Af)(v.map(u=>this.C.get(u)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(v,E){const u=this.C.get(v);if(!u||!u.buttons||!u.buttons.length)return;const h=u.buttons[E];h&&this.N.fire({button:h,item:u})}}class a extends b{constructor(v,E){super(v.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:P.default.Error}):this.z({validationMessage:v.message,severity:v.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new d(r,i)}e.$Cbc=D}),define(De[324],Ce([1,0,2,4,56,3,11,6,19,126,14,25,59,13,27,17]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0;function i(E){if(E)return typeof E.iconPath=="string"?C.URI.file(E.iconPath):C.URI.isUri(E.iconPath)||p.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function s(E,u){if(!E.iconPath&&!u.iconPath)return 0;if(E.iconPath){if(!u.iconPath)return 1}else return-1;const h=typeof E.iconPath=="string"?E.iconPath:C.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,w=typeof u.iconPath=="string"?u.iconPath:C.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,$.$eq)(h,w)}function d(E,u){let h=0;if(E.strikeThrough!==u.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==u.faded)return E.faded?1:-1;if(E.tooltip!==u.tooltip)return(E.tooltip||"").localeCompare(u.tooltip||"");if(h=s(E,u),h!==0)return h;if(E.light&&u.light)h=s(E.light,u.light);else{if(E.light)return 1;if(u.light)return-1}if(h!==0)return h;if(E.dark&&u.dark)h=s(E.dark,u.dark);else{if(E.dark)return 1;if(u.dark)return-1}return h}function b(E,u){if(E.command!==u.command)return E.command<u.command?-1:1;if(E.title!==u.title)return E.title<u.title?-1:1;if(E.tooltip!==u.tooltip){if(E.tooltip!==void 0&&u.tooltip!==void 0)return E.tooltip<u.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(E.arguments===u.arguments)return 0;if(E.arguments)if(u.arguments){if(E.arguments.length!==u.arguments.length)return E.arguments.length-u.arguments.length}else return 1;else return-1;for(let h=0;h<E.arguments.length;h++){const w=E.arguments[h],L=u.arguments[h];if(w!==L)return w<L?-1:1}return 0}function g(E,u){let h=(0,$.$eq)(E.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(h!==0)return h;if(E.command&&u.command)h=b(E.command,u.command);else{if(E.command)return 1;if(u.command)return-1}if(h!==0)return h;if(E.decorations&&u.decorations)h=d(E.decorations,u.decorations);else{if(E.decorations)return 1;if(u.decorations)return-1}return h}function t(E,u){for(let h=0;h<E.length;h++)if(E[h]!==u[h])return!1;return!0}function o(E,u){return E.command===u.command&&E.title===u.title&&E.tooltip===u.tooltip&&(E.arguments&&u.arguments?t(E.arguments,u.arguments):E.arguments===u.arguments)}function c(E,u){return(0,S.$of)(E,u,o)}class n{#e;#t;get value(){return this.d}set value(u){u=u??"",this.#e.$setInputBoxValue(this.l,u),this.n(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){this.#e.$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,D.$MF)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,D.$MF)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,this.#e.$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,this.#e.$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,this.#e.$setInputBoxVisibility(this.l,u))}get document(){return(0,D.$MF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(u,h,w,L,O){this.k=u,this.l=L,this.m=O,this.d="",this.e=new T.$hc,this.f="",this.h=!0,this.j=!0,this.#t=h,this.#e=w}showValidationMessage(u,h){(0,D.$MF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,u,h)}$onInputBoxValueChange(u){this.n(u)}n(u){this.d=u,this.e.fire(u)}}e.$Dbc=n;class a{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,h,w,L,O){this.q=u,this.s=h,this.t=w,this.u=L,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$hc,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$hc,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=a.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,h){const w=this.h.get(u);return w?(0,A.$xg)(()=>this.s.executeCommand(w.command,...w.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(g),w=(0,S.$wf)(this.o,u,g).map(N=>{const M=N.toInsert.map(z=>{const j=this.e++;this.g.set(j,z);const F=z.resourceUri;let K;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const X=new R.$lb;K=this.s.converter.toInternal(z.command,X),this.j.set(j,X)}else this.h.set(j,z.command);const H=i(z.decorations),$e=z.decorations&&i(z.decorations.light)||H,_=z.decorations&&i(z.decorations.dark)||H,Q=[$e,_],V=z.decorations&&z.decorations.tooltip||"",ee=z.decorations&&!!z.decorations.strikeThrough,me=z.decorations&&!!z.decorations.faded,ae=z.contextValue||"";return{rawResource:[j,F,Q,V,ee,me,ae,K],handle:j}});return{start:N.start,deleteCount:N.deleteCount,toInsert:M}}),L=w.map(({start:N,deleteCount:M,toInsert:z})=>[N,M,z.map(j=>j.rawResource)]),O=w.reverse();for(const{start:N,deleteCount:M,toInsert:z}of O){const j=z.map(K=>K.handle),F=this.n.splice(N,M,...j);for(const K of F)this.g.delete(K),this.h.delete(K),this.j.get(K)?.dispose(),this.j.delete(K)}return this.o=u,L}dispose(){this.l=!0,this.m.fire()}}class l{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,this.#e.$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u;let h;(0,D.$LF)(this.u,"quickDiffProvider")&&(h=u?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!u,quickDiffLabel:h})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,this.#e.$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new R.$lb,this.l=u;const h=this.v.converter.toInternal(u,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:h})}get actionButton(){return(0,D.$MF)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,D.$MF)(this.u,"scmActionButton"),this.m.value=new R.$lb,this.n=u;const h=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(w=>w.map(L=>this.v.converter.toInternal(L,this.m.value))),description:u.description,enabled:u.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:h??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&c(this.p,u))return;this.o.value=new R.$lb,this.p=u;const h=(u||[]).map(w=>this.v.converter.toInternal(w,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:h})}get selected(){return this.q}constructor(u,h,w,L,O,N,M){this.u=u,this.v=L,this.w=O,this.x=N,this.y=M,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.$nb,this.l=void 0,this.m=new R.$nb,this.o=new R.$nb,this.p=void 0,this.q=!1,this.s=new T.$hc,this.onDidChangeSelection=this.s.event,this.t=l.d++,this.z=new Map,this.A=new Set,this.#e=w;const z=C.URI.from({scheme:y.Schemas.vscodeSourceControl,path:`${O}/scm${this.t}/input`,query:M?`rootUri=${encodeURIComponent(M.toString())}`:void 0});this.f=new n(u,h,this.#e,this.t,z),this.#e.$registerSourceControl(this.t,O,N,M,z)}createResourceGroup(u,h){const w=new a(this.#e,this.v,this.t,u,h),L=T.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,L),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const u=[],h=[];for(const[w,L]of this.z){L.dispose();const O=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});T.Event.once(w.onDidDispose)(()=>{this.A.delete(w),O.dispose(),this.e.delete(w.handle),this.#e.$unregisterGroup(this.t,w.handle)}),u.push([w.handle,w.id,w.label,w.features]);const N=w._takeResourceStateSnapshot();N.length>0&&h.push([w.handle,N]),this.e.set(w.handle,w)}this.#e.$registerGroups(this.t,u,h),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(h=>{const w=h._takeResourceStateSnapshot();w.length!==0&&u.push([h.handle,w])}),u.length>0&&this.#e.$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,f.$5g)(100)],l.prototype,"eventuallyAddResourceGroups",null),Ke([(0,f.$5g)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(u,h,w,L){this.l=h,this.m=w,this.n=L,this.g=new Map,this.h=new I.$Vl,this.j=new T.$hc,this.e=u.getProxy(m.$SJ.MainThreadSCM),this.f=u.getProxy(m.$SJ.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const N=this.g.get(O.sourceControlHandle);if(!N)return O;const M=N.getResourceGroup(O.groupHandle);return M?M.getResourceState(O.handle):O}else if(O&&O.$mid===4){const N=this.g.get(O.sourceControlHandle);return N?N.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const N=this.g.get(O.handle);return N||O}return O}})}createSourceControl(u,h,w,L){this.n.trace("ExtHostSCM#createSourceControl",u.identifier.value,h,w,L),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const O=r.d++,N=new l(u,this.m,this.e,this.l,h,w,L);this.g.set(O,N);const M=this.h.get(u.identifier)||[];return M.push(N),this.h.set(u.identifier,M),N}getLastInputBox(u){this.n.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const h=this.h.get(u.identifier),w=h&&h[h.length-1];return w&&w.inputBox}$provideOriginalResource(u,h,w){const L=C.URI.revive(h);this.n.trace("ExtHostSCM#$provideOriginalResource",u,L.toString());const O=this.g.get(u);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xg)(()=>O.quickDiffProvider.provideOriginalResource(L,w)).then(N=>N||null)}$onInputBoxValueChange(u,h){this.n.trace("ExtHostSCM#$onInputBoxValueChange",u);const w=this.g.get(u);return w&&w.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(u,h,w,L){this.n.trace("ExtHostSCM#$executeResourceCommand",u,h,w);const O=this.g.get(u);if(!O)return Promise.resolve(void 0);const N=O.getResourceGroup(h);return N?N.$executeResourceCommand(w,L):Promise.resolve(void 0)}$validateInput(u,h,w){this.n.trace("ExtHostSCM#$validateInput",u);const L=this.g.get(u);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xg)(()=>L.inputBox.validateInput(h,w)).then(O=>{if(!O)return Promise.resolve(void 0);const N=k.MarkdownString.fromStrict(O.message);return N?Promise.resolve([N,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};e.$Ebc=v,e.$Ebc=v=r=Ke([Be(3,P.$3i)],v)}),define(De[114],Ce([1,0,6,4,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=void 0;class R{constructor(m){this.b=new T.$hc,this.onDidChangePassword=this.b.event,this.a=m.getProxy(C.$SJ.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,S){return this.a.$getPassword(m,S)}store(m,S,$){return this.a.$setPassword(m,S,$)}delete(m,S){return this.a.$deletePassword(m,S)}}e.$jbc=R,e.$kbc=(0,f.$zh)("IExtHostSecretState")}),define(De[325],Ce([1,0,6,13,2]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class R{static{this.a=0}constructor(m,S){this.d=S,this.c=new Map,this.b=m.getProxy(C.$SJ.MainThreadShare)}async $provideShare(m,S,$){return await this.c.get(m)?.provideShare({selection:T.Range.to(S.selection),resourceUri:f.URI.revive(S.resourceUri)},$)??void 0}registerShareProvider(m,S){const $=R.a++;return this.c.set($,S),this.b.$registerShareProvider($,T.DocumentSelector.from(m,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$Gcc=R}),define(De[326],Ce([1,0,7,6,209,3,13,18]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=e.$Fbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$QK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$QK("statusBarItem.warningForeground")]])}#e;#t;constructor(p,k,D,y,r,i=C.StatusBarAlignment.Left,s){if(this.i=!1,this.k="",this.q=new R.$lb,this.#e=p,this.#t=k,r&&y){this.c=(0,C.$tK)(y.identifier,r);const d=D.get(this.c);d&&(i=d.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,s=d.priority,this.j=!0,this.name=d.name,this.text=d.text,this.tooltip=d.tooltip,this.command=d.command,this.accessibilityInformation=d.accessibilityInformation)}else this.c=String(S.a++);this.e=y,this.f=r,this.g=i,this.h=this.u(s)}u(p){if((0,m.$pe)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!S.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new R.$lb,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let k;this.m?k=this.m:k=(0,f.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=S.b.get(this.o.id));const y=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,k,this.k,y,this.r?.internal,D,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Fbc=S;class ${constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const k={message:p};return this.b.unshift(k),this.c(),new C.$UJ(()=>{const D=this.b.indexOf(k);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(p,k){this.e=new Map,this.a=p.getProxy(T.$SJ.MainThreadStatusBar),this.b=k,this.c=new $(this)}$acceptStaticEntries(p){for(const k of p)this.e.set(k.entryId,k)}createStatusBarEntry(p,k,D,y){return new S(this.a,this.b,this.e,p,k,D,y)}setStatusBarMessage(p,k){const D=this.c.setMessage(p);let y;return typeof k=="number"?y=setTimeout(()=>D.dispose(),k):typeof k<"u"&&k.then(()=>D.dispose(),()=>D.dispose()),new C.$UJ(()=>{D.dispose(),clearTimeout(y)})}}e.$Gbc=P}),define(De[115],Ce([1,0,6,4,5]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=void 0;class R{constructor(m,S){this.c=S,this.b=new T.$hc,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(C.$SJ.MainThreadStorage)}registerExtensionStorageKeysToSync(m,S){this.a.$registerExtensionStorageKeysToSync(m,S)}async initializeExtensionStorage(m,S,$){const P=await this.a.$initializeExtensionStorage(m,S);let I;return P&&(I=this.d(m,S,P)),I||$}setValue(m,S,$){return this.a.$setValue(m,S,$)}$acceptValue(m,S,$){const P=this.d(m,S,$);P&&this.b.fire({shared:m,key:S,value:P})}d(m,S,$){try{return JSON.parse($)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${m}): ${P}`)}}}e.$0ac=R,e.$$ac=(0,f.$zh)("IExtHostStorage")}),define(De[91],Ce([1,0,5,26,14,71,2]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=void 0,e.$dbc=(0,C.$zh)("IExtensionStoragePaths");let m=class{constructor($,P,I){this.d=P,this.f=I,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(p=>this.c=p)}async g($){return A.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,P=await this.g($);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue($){if(this.c)return A.URI.joinPath(this.c,$.identifier.value)}globalValue($){return A.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ebc=m,e.$ebc=m=Ke([Be(0,T.$$L),Be(1,f.$3i),Be(2,R.$cbc)],m)}),define(De[44],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,11,13,33]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=e.$gbc=e.$fbc=void 0,e.$fbc=(0,f.$zh)("IExtHostTerminalService");class d{constructor(u,h,w,L){this.k=u,this._id=h,this.l=w,this.m=L,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(N=>this.f=N);const O=this;this.value={get name(){return O.m||""},get processId(){return O.b},get creationOptions(){return O.l},get exitStatus(){return O.h},get state(){return O.i},get selection(){return O.j},sendText(N,M=!0){O.o(),O.k.$sendText(O._id,N,M)},show(N){O.o(),O.k.$show(O._id,N)},hide(){O.o(),O.k.$hide(O._id)},dispose(){O.a||(O.a=!0,O.k.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(u,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:a(u.iconPath)??void 0,color:y.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this.n(u.location,h?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,h,w,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:w,color:y.ThemeColor.isThemeColor(L)?L.id:void 0,location:this.n(u,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,h){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,h){this.h=Object.freeze({code:u,reason:h})}setDimensions(u,h){return u===this.d&&h===this.g||u===0||h===0?!1:(this.d=u,this.g=h,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(h=>{h!==u&&(this.b=Promise.resolve(u))})}}e.$gbc=d;class b{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new C.$hc,this.onProcessData=this.a.event,this.b=new C.$hc,this.d=new C.$hc,this.onDidChangeProperty=this.d.event,this.f=new C.$hc,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,h){this.g.setDimensions?.({columns:u,rows:h})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,t=class extends m.$mb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,h,w){super(),this.M=h,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new m.$nb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new C.$hc,this.onDidCloseTerminal=this.C.event,this.D=new C.$hc,this.onDidOpenTerminal=this.D.event,this.F=new C.$hc,this.onDidChangeActiveTerminal=this.F.event,this.G=new C.$hc,this.onDidChangeTerminalDimensions=this.G.event,this.H=new C.$hc,this.onDidChangeTerminalState=this.H.event,this.I=new C.$hc,this.onDidChangeShell=this.I.event,this.J=new C.$hc({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new C.$hc({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=w.getProxy(T.$SJ.MainThreadTerminalService),this.s=new D.$Ckb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[L,O]of this.g)O.shutdown(!0)}})}getDefaultShell(u){return(u?this.m:this.l)?.path||""}getDefaultShellArgs(u){return(u?this.m:this.l)?.args||[]}createExtensionTerminal(u,h){const w=new d(this.a,(0,k.$6e)(),u,u.name),L=new b(u.pty);return w.createExtensionTerminal(u.location,this.N(u,h).resolvedExtHostIdentifier,a(u.iconPath),l(u.color)).then(O=>{const N=this.O(O,L);this.h[O]=N}),this.f.push(w),w.value}N(u,h){if(h=h||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const w=u.location.parentTerminal;if(w){const L=this.f.find(O=>O.value===w);L&&(h.resolvedExtHostIdentifier=L._id)}}else u.location&&typeof u.location!="object"?h.location=u.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(u,h){if(!this.Q(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const L=new b(h),O=this.O(u,L);this.h[u]=O}async $acceptActiveTerminalChanged(u){const h=this.b;if(u===null){this.b=void 0,h!==this.b&&this.F.fire(this.b);return}const w=this.Q(u);w&&(this.b=w,h!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(u,h){const w=this.Q(u);w&&this.J.fire({terminal:w.value,data:h})}async $acceptTerminalDimensions(u,h,w){const L=this.Q(u);L&&L.setDimensions(h,w)&&this.G.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(u,h){const w=this.Q(u);w&&this.L.fire({terminal:w.value,...h})}async $acceptTerminalMaximumDimensions(u,h,w){this.g.get(u)?.resize(h,w)}async $acceptTerminalTitleChange(u,h){const w=this.Q(u);w&&(w.name=h)}async $acceptTerminalClosed(u,h,w){const L=this.S(this.f,u);if(L!==null){const O=this.f.splice(L,1)[0];O.setExitStatus(h,w),this.C.fire(O.value)}}$acceptTerminalOpened(u,h,w,L){if(h){const M=this.S(this.f,h);if(M!==null){this.f[M]._id=u,this.D.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const O={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:R.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},N=new d(this.a,u,O,w);this.f.push(N),this.D.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(u,h){this.Q(u)?._setProcessId(h)}async $startExtensionTerminal(u,h){const w=this.Q(u);if(!w)return{message:(0,$.localize)(0,null,u)};w.isOpen||await new Promise(O=>{const N=this.onDidOpenTerminal(async M=>{M===w.value&&(N.dispose(),O())})});const L=this.g.get(u);L?L.startSendingEvents(h):this.i[u]={initialDimensions:h}}O(u,h){const w=new m.$lb;w.add(h.onProcessReady(O=>this.a.$sendProcessReady(u,O.pid,O.cwd,O.windowsPty))),w.add(h.onDidChangeProperty(O=>this.a.$sendProcessProperty(u,O))),this.s.startBuffering(u,h.onProcessData),w.add(h.onProcessExit(O=>this.P(u,O))),this.g.set(u,h);const L=this.i[u];return L&&h instanceof b&&(h.startSendingEvents(L.initialDimensions),delete this.i[u]),w}$acceptProcessAckDataEvent(u,h){this.g.get(u)?.acknowledgeDataEvent(h)}$acceptProcessInput(u,h){this.g.get(u)?.input(h)}$acceptTerminalInteraction(u){const h=this.Q(u);h?.setInteractedWith()&&this.H.fire(h.value)}$acceptTerminalSelection(u,h){this.Q(u)?.setSelection(h)}$acceptProcessResize(u,h,w){try{this.g.get(u)?.resize(h,w)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(u,h){this.g.get(u)?.shutdown(h)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(h=>this.a.$sendProcessProperty(u,{type:"cwd",value:h}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.u.add(u),this.u.size===1&&this.a.$startLinkProvider(),new S.$UJ(()=>{this.u.delete(u),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,h,w){if(this.v.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.v.set(h,w),this.a.$registerProfileProvider(h,u.identifier.value),new S.$UJ(()=>{this.v.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(u,h,w){if(this.w.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.w.set(u,w),this.a.$registerQuickFixProvider(u,h),new S.$UJ(()=>{this.w.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,h){const w=new p.$rc().token;if(w.isCancellationRequested)return;const L=this.w.get(u);if(!L)return;const O=await L.provideTerminalQuickFixes(h,w);if(O===null||Array.isArray(O)&&O.length===0)return;const N=new m.$lb;if(this.n.value=N,!Array.isArray(O))return O?i.TerminalQuickFix.from(O,this.M.converter,N):void 0;const M=[];for(const z of O){const j=i.TerminalQuickFix.from(z,this.M.converter,N);j&&M.push(j)}return M}async $createContributedProfileTerminal(u,h){const w=new p.$rc().token;let L=await this.v.get(u)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,h);return}this.createTerminalFromOptions(L.options,h)}}async $provideLinks(u,h){const w=this.Q(u);if(!w)return[];this.y.delete(u),this.z.get(u)?.dispose(!0);const O=new p.$rc;this.z.set(u,O);const N=[],M={terminal:w.value,line:h},z=[];for(const K of this.u)z.push(r.Promises.withAsyncBody(async H=>{O.token.onCancellationRequested(()=>H({provider:K,links:[]}));const $e=await K.provideTerminalLinks(M,O.token)||[];O.token.isCancellationRequested||H({provider:K,links:$e})}));const j=await Promise.all(z);if(O.token.isCancellationRequested)return[];const F=new Map;for(const K of j)K&&K.links.length>0&&N.push(...K.links.map(H=>{const $e={id:g++,startIndex:H.startIndex,length:H.length,label:H.tooltip};return F.set($e.id,{provider:K.provider,link:H}),$e}));return this.y.set(u,F),N}$activateLink(u,h){const w=this.y.get(u)?.get(h);w&&w.provider.handleTerminalLink(w.link)}P(u,h){this.s.stopBuffering(u),this.g.delete(u),delete this.i[u];const w=this.h[u];w&&(w.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,h)}Q(u){return this.R(this.f,u)}R(u,h){const w=this.S(u,h);return w!==null?u[w]:null}S(u,h){const w=u.findIndex(L=>L._id===h);return w===-1?null:w}getEnvironmentVariableCollection(u){let h=this.k.get(u.identifier.value);return h||(h=new o,this.W(u.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}U(u,h){const w=(0,I.$0q)(h.map),L=(0,I.$$q)(h.descriptionMap);this.a.$setEnvironmentVariableCollection(u,h.persistent,w.length===0?void 0:w,L)}$initEnvironmentVariableCollections(u){u.forEach(h=>{const w=h[0],L=new o(h[1]);this.W(w,L)})}$acceptDefaultProfile(u,h){const w=this.l;this.l=u,this.m=h,w?.path!==u.path&&this.I.fire(u.path)}W(u,h){this.k.set(u,h),h.onDidChangeCollection(()=>{this.U(u,h)})}};e.$hbc=t,e.$hbc=t=Ke([Be(1,s.$eM),Be(2,A.$UL)],t);class o{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$hc,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const h=this.h(u);let w=this.a.get(h);return w||(w=new c(this,u),this.a.set(h,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(u,h,w,L){this.f(u,{value:h,type:S.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:L})}append(u,h,w,L){this.f(u,{value:h,type:S.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:L})}prepend(u,h,w,L){this.f(u,{value:h,type:S.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:L})}f(u,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(u,h.scope),L=this.map.get(w),O=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==h.value||L.type!==h.type||L.options?.applyAtProcessCreation!==O.applyAtProcessCreation||L.options?.applyAtShellIntegration!==O.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const N=this.g(u,h.scope),M={variable:u,...h,options:O};this.map.set(N,M),this.d.fire()}}get(u,h){const w=this.g(u,h),L=this.map.get(w);return L?v(L):void 0}g(u,h){const w=this.h(h);return w.length?`${u}:::${w}`:u}h(u){return this.i(u?.workspaceFolder)??""}i(u){return u?u.uri.toString():void 0}getVariableMap(u){const h=new Map;for(const[w,L]of this.map)this.h(L.scope)===this.h(u)&&h.set(L.variable,v(L));return h}delete(u,h){const w=this.g(u,h);this.map.delete(w),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[h,w]of this.map)w.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(h);this.j(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,h){const w=this.h(h),L=this.descriptionMap.get(w);if(!L||L.description!==u){let O;typeof u=="string"?O=u:O=u?.value.split(`

`)[0];const N={description:O,scope:h};this.descriptionMap.set(w,N),this.d.fire()}}getDescription(u){const h=this.h(u);return this.descriptionMap.get(h)?.description}j(u){const h=this.h(u);this.descriptionMap.delete(h)}}class c{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,h){this.b=u,this.d=h,this.a=new C.$hc}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,h,w){this.b.replace(u,h,w,this.d)}append(u,h,w){this.b.append(u,h,w,this.d)}prepend(u,h,w){this.b.prepend(u,h,w,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,h){this.b.getVariableMap(this.d).forEach((w,L)=>u.call(h,L,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor(u,h){super(!1,u,h)}createTerminal(u,h,w){throw new P.$0}createTerminalFromOptions(u,h){throw new P.$0}};e.$ibc=n,e.$ibc=n=Ke([Be(0,s.$eM),Be(1,A.$UL)],n);function a(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function l(E){return y.ThemeColor.isThemeColor(E)?E:void 0}function v(E){const u={...E};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(De[327],Ce([1,0,118,11,22,21,4,74,51,3,23,18,31,6,20,145,13,7,67,109,88,27]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=e.$qcc=e.$pcc=void 0;let t=class{constructor(M,z,j){this.k=j,this.d=new A.$hc,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(k.$SJ.MainThreadTesting),this.j=new w(this.g),this.h=new a(this.g),z.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 15:{const K=F,H=K.tests[K.tests.length-1].item.extId;return this.f.get(s.$FI.root(H))?.collection.tree.get(H)?.actual??(0,y.$7L)(F)}case 17:{const{extId:K,message:H}=F;return{test:this.f.get(s.$FI.root(K))?.collection.tree.get(K)?.actual,message:r.TestMessage.to(H)}}default:return F}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await z.executeCommand("_testing.getExplorerSelection"),K=H=>{const $e=this.f.get(s.$FI.root(H));if($e)return s.$FI.isRoot(H)?$e.controller:$e.collection.tree.get(H)?.actual};return{include:F?.include.map(K).filter(I.$te)||[],exclude:F?.exclude.map(K).filter(I.$te)||[]}})}createTestController(M,z,j,F){if(this.f.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const K=new $.$lb,H=K.add(new y.$0L(z,j,this.k));H.root.label=j;const $e=new Map,_=this.g,Q={items:H.root.children,get label(){return j},set label(ee){j=ee,H.root.label=ee,_.$updateController(z,{label:j})},get refreshHandler(){return F},set refreshHandler(ee){F=ee,_.$updateController(z,{canRefresh:!!ee})},get id(){return z},createRunProfile:(ee,me,ae,te,X,U)=>{let q=(0,S.$ni)(ee);for(;$e.has(q);)q++;return new L(this.g,$e,z,q,ee,me,ae,te,X,U)},createTestItem(ee,me,ae){return new y.$8L(z,ee,me,ae)},createTestRun:(ee,me,ae=!0)=>this.h.createTestRun(M,z,H,ee,me,ae),invalidateTestResults:ee=>{if(ee===void 0)this.g.$markTestRetired(void 0);else{const me=ee instanceof Array?ee:[ee];this.g.$markTestRetired(me.map(ae=>s.$FI.fromExtHostTestItem(ae,z).toString()))}},set resolveHandler(ee){H.resolveHandler=ee},get resolveHandler(){return H.resolveHandler},dispose:()=>{K.dispose()}};_.$registerTestController(z,j,!!F),K.add((0,$.$kb)(()=>_.$unregisterTestController(z)));const V={controller:Q,collection:H,profiles:$e,extension:M};return this.f.set(z,V),K.add((0,$.$kb)(()=>this.f.delete(z))),K.add(H.onDidGenerateDiff(ee=>_.$publishDiff(z,ee.map(b.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.j.checkout()}async runTests(M,z=R.CancellationToken.None){const j=l(M);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.f.get(j.controllerId);if(!F)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(K=>s.$FI.fromExtHostTestItem(K,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:O[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:M.exclude?.map(K=>K.id)},z)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,z,j){return(0,C.$lf)(this.h.trackers,K=>K.id===M?K.getCoverage(z):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(M,z,j,F){return(0,C.$lf)(this.h.trackers,H=>H.id===M?H.getCoverage(z):void 0)?.resolveFileCoverage(j,F)??Promise.resolve([])}$configureRunProfile(M,z){this.f.get(M)?.profiles.get(z)?.configureHandler?.()}async $refreshTests(M,z){await this.f.get(M)?.controller.refreshHandler?.(z)}$publishTestResults(M){this.results=Object.freeze(M.map(z=>(0,P.$Um)(r.TestResults.to(z))).concat(this.results).sort((z,j)=>j.completedAt-z.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,z){const j=this.f.get(s.$FI.fromString(M).controllerId)?.collection;j&&(await j.expand(M,z<0?1/0:z),j.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(b.TestsDiffOp.deserialize))}async $runControllerTests(M,z){return Promise.all(M.map(j=>this.l(j,!1,z)))}async $startContinuousRun(M,z){const j=new R.$rc(z),F=await Promise.all(M.map(K=>this.l(K,!0,j.token)));return!z.isCancellationRequested&&!F.some(K=>K.error)&&await new Promise(K=>z.onCancellationRequested(K)),j.dispose(!0),F}async l(M,z,j){const F=this.f.get(M.controllerId);if(!F)return{};const{collection:K,profiles:H,extension:$e}=F,_=H.get(M.profileId);if(!_)return{};const Q=M.testIds.map(ae=>K.tree.get(ae)).filter(I.$te),V=M.excludeExtIds.map(ae=>F.collection.tree.get(ae)).filter(I.$te).filter(ae=>Q.some(te=>te.fullId.compare(ae.fullId)===2));if(!Q.length)return{};const ee=new i.$rL(Q.some(ae=>ae.actual instanceof y.$9L)?void 0:Q.map(ae=>ae.actual),V.map(ae=>ae.actual),_,z),me=(0,b.$HI)(M)&&this.h.prepareForMainThreadTestRun(ee,v.fromInternal(M,F.collection),$e,j);try{return await _.runHandler(ee,j),{}}catch(ae){return{error:String(ae)}}finally{me&&(me.hasRunningTasks&&!j.isCancellationRequested&&await A.Event.toPromise(me.onEnd),me.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$pcc=t,e.$pcc=t=Ke([Be(0,D.$UL)],t);const o=1e4;var c;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(c||(c={}));class n extends $.$mb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(M,z,j,F){super(),this.l=M,this.m=z,this.p=j,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$hc),this.onEnd=this.k.event,this.j=this.B(new R.$rc(F));const K=this.B(new T.$Qg(()=>this.s(),o));this.B(this.j.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const z=this.l.id,j=this.l.controllerId,F=(0,p.$6e)(),K=new E(this.m,z,F),H=V=>(ee,...me)=>{if(_){console.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.l.isIncluded(ee)&&(this.v(ee),V(ee,...me))},$e=(V,ee)=>{const me=ee instanceof Array?ee.map(r.TestMessage.from):[r.TestMessage.from(ee)];if(me.some(ae=>ae.contextValue!==void 0)&&(0,g.$MF)(this.p,"testMessageContextValue"),V.uri&&V.range){const ae={range:r.Range.from(V.range),uri:V.uri};for(const te of me)te.location=te.location||ae}this.m.$appendTestMessagesInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),me)};let _=!1;const Q={isPersisted:this.l.isPersisted,token:this.j.token,name:M,get coverageProvider(){return K.coverageProvider},set coverageProvider(V){K.coverageProvider=V},enqueued:H(V=>{this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),1)}),skipped:H(V=>{this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),5)}),started:H(V=>{this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),2)}),errored:H((V,ee,me)=>{$e(V,ee),this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),6,me)}),failed:H((V,ee,me)=>{$e(V,ee),this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,j).toString(),4,me)}),passed:H((V,ee)=>{this.m.$updateTestStateInRun(z,F,s.$FI.fromExtHostTestItem(V,this.l.controllerId).toString(),3,ee)}),appendOutput:(V,ee,me)=>{_||(me&&(this.l.isIncluded(me)?this.v(me):me=void 0),this.m.$appendOutputToRun(z,F,f.$Hc.fromString(V),ee&&r.location.from(ee),me&&s.$FI.fromExtHostTestItem(me,j).toString()))},end:()=>{_||(_=!0,this.m.$finishedTestRunTask(z,F),this.g.delete(F),this.g.size||this.u())}};return this.g.set(F,{run:Q,coverage:K}),this.m.$startedTestRunTask(z,{id:F,name:M,running:!0}),Q}s(){for(const{run:M}of this.g.values())M.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(M){if(!(M instanceof y.$8L))throw new d.$ML(M.id);if(this.h.has(s.$FI.fromExtHostTestItem(M,this.l.controllerId).toString()))return;const z=[],j=this.l.colllection.root;for(;;){const F=r.TestItem.from(M);if(z.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),M===j))break;M=M.parent||j}this.m.$addTestsToRun(this.l.controllerId,this.l.id,z)}dispose(){this.u(),super.dispose()}}class a{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,z,j,F){return this.g(M,z,j,F)}cancelRunById(M){for(const z of this.d.values())if(z.id===M){z.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,z,j,F,K,H){const $e=this.d.get(F);if($e)return $e.createRun(K);const _=v.fromPublic(z,j,F,H),Q=l(F);this.f.$startedExtensionTestRun({controllerId:z,continuous:!!F.continuous,profile:Q&&{group:O[Q.kind],id:Q.profileId},exclude:F.exclude?.map(ee=>s.$FI.fromExtHostTestItem(ee,j.root.id).toString())??[],id:_.id,include:F.include?.map(ee=>s.$FI.fromExtHostTestItem(ee,j.root.id).toString())??[j.root.id],persist:H});const V=this.g(F,_,M);return A.Event.once(V.onEnd)(()=>{this.f.$finishedExtensionTestRun(_.id),V.dispose()}),V.createRun(K)}g(M,z,j,F){const K=new n(z,this.f,j,F);return this.d.set(M,K),A.Event.once(K.onEnd)(()=>this.d.delete(M)),K}}e.$qcc=a;const l=N=>{if(N.profile){if(!(N.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class v{static fromPublic(M,z,j,F){return new v(M,(0,p.$6e)(),j.include?.map(K=>s.$FI.fromExtHostTestItem(K,M).toString())??[M],j.exclude?.map(K=>s.$FI.fromExtHostTestItem(K,M).toString())??[],F,z)}static fromInternal(M,z){return new v(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,z)}constructor(M,z,j,F,K,H){this.controllerId=M,this.id=z,this.isPersisted=K,this.colllection=H,this.d=j.map($e=>$e+"\0"),this.f=F.map($e=>$e+"\0")}isIncluded(M){const z=s.$FI.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const j of this.f)if(z===j||z.startsWith(j))return!1;for(const j of this.d)if(z===j||z.startsWith(j))return!0;return!1}}e.$rcc=v;class E{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,z,j){this.g=M,this.h=z,this.j=j}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(r.TestCoverage.fromFile)??[]}catch(z){throw this.f=void 0,z}}async resolveFileCoverage(M,z){const j=await this.f;let F=j?.[M];return!this.d||!j||!F?[]:(F.detailedCoverage||(F=j[M]=await this.d.resolveFileCoverage?.(F,z)??F),F.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,r.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const z=s.$FI.parentId(M.item.extId);if(z&&this.h.has(z.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:z,g:j}=this;return{get added(){return[...M].map(F=>F.revived)},get updated(){return[...z].map(F=>F.revived)},get removed(){return[...j].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends b.$MI{constructor(){super(...arguments),this.s=new A.$hc,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,z){return{...M,revived:r.TestItem.toPlain(M.item),depth:z?z.depth+1:0,children:new Set}}p(){return new u(this.s)}}class w{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(z=>z.revived)},dispose:(0,m.$bb)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new h;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class L{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?r.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,z,j,F,K,H,$e,_=!1,Q=void 0,V=!1){this.controllerId=j,this.profileId=F,this.f=K,this.kind=H,this.runHandler=$e,this.g=_,this._tag=Q,this.h=V,this.#e=M,this.#t=z,z.set(F,this);const ee=O[H];if(typeof ee!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:j,tag:Q?r.TestTag.namespace(this.controllerId,Q.id):null,label:K,group:ee,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:V})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$scc=L;const O={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(De[328],Ce([1,0,19,8,4,6,146,13,7]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=void 0;class ${constructor(I,p){this.i=p,this.a=new f.$hc({onListenerError:T.$Z}),this.b=new f.$hc({onListenerError:T.$Z}),this.c=new f.$hc({onListenerError:T.$Z}),this.d=new f.$hc({onListenerError:T.$Z}),this.f=new f.$hc({onListenerError:T.$Z}),this.g=new f.$hc({onListenerError:T.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(R.$SJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(k=>this.g.fire(k)),this.i.onDidChangeActiveTextEditor(k=>this.f.fire(k))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const p=this.i.allEditors();return I?p:p.map(k=>k.value)}async showTextDocument(I,p,k){let D;typeof p=="number"?D={position:m.ViewColumn.from(p),preserveFocus:k}:typeof p=="object"?D={position:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?m.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(I.uri,D),r=y&&this.i.getEditor(y);if(r)return r.value;throw y?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,p){return new A.$2L(this.h,I,p).value}$acceptEditorPropertiesChanged(I,p){const k=this.i.getEditor(I);if(!k)throw new Error("unknown text editor");if(p.options&&k._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(m.Selection.to);k._acceptSelections(D)}if(p.visibleRanges){const D=C.$Af(p.visibleRanges.map(m.Range.to));k._acceptVisibleRanges(D)}if(p.options&&this.b.fire({textEditor:k.value,options:{...p.options,lineNumbers:m.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=S.TextEditorSelectionChangeKind.fromValue(p.selections.source),y=p.selections.selections.map(m.Selection.to);this.a.fire({textEditor:k.value,selections:y,kind:D})}if(p.visibleRanges){const D=C.$Af(p.visibleRanges.map(m.Range.to));this.c.fire({textEditor:k.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const p in I){const k=this.i.getEditor(p);if(!k)throw new Error("Unknown text editor");const D=m.ViewColumn.to(I[p]);k.value.viewColumn!==D&&(k._acceptViewColumn(D),this.d.fire({textEditor:k.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Hbc=$}),define(De[329],Ce([1,0,2,5,6,3,7,13,25,18]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=void 0,e.$jcc=(0,T.$zh)("IExtHostTimeline");class P{constructor(k,D){this.b=new Map,this.c=new Map,this.a=k.getProxy(f.$SJ.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(y,r)=>{if(y&&y.$mid===12)if(this.b.get(y.source)&&S.$Tl.equals(r,this.b.get(y.source)?.extension)){const i=y.uri===void 0?void 0:C.URI.revive(y.uri);return this.c.get(y.source)?.get(I(i))?.get(y.handle)}else return;return y}})}async $getTimeline(k,D,y,r){return this.b.get(k)?.provider.provideTimeline(C.URI.revive(D),y,r)}registerTimelineProvider(k,D,y,r){const i=new R.$lb,s=this.d(D.id,r,i).bind(this);let d;D.onDidChange&&(d=D.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:D.id}),this));const b=this.c;return this.f({...D,scheme:k,onDidChange:void 0,async provideTimeline(g,t,o){t?.resetCache&&(i.clear(),b.get(D.id)?.clear());const c=await D.provideTimeline(g,t,o);if(c==null)return;const n=s(g,t);return{...c,source:D.id,items:c.items.map(n)}},dispose(){for(const g of b.values())g.get(D.id)?.clear();d?.dispose(),i.dispose()}},y)}d(k,D,y){return(r,i)=>{let s;if(i?.cacheResults){let d=this.c.get(k);d===void 0&&(d=new Map,this.c.set(k,d));const b=I(r);s=d.get(b),s===void 0&&(s=new Map,d.set(b,s))}return d=>{const{iconPath:b,...g}=d,t=`${k}|${d.id??d.timestamp}`;s?.set(t,d);let o,c,n;d.iconPath&&(b instanceof A.$PK?n={id:b.id,color:b.color}:C.URI.isUri(b)?(o=b,c=b):{light:o,dark:c}=b);let a;return A.$jK.isMarkdownString(g.tooltip)?a=m.MarkdownString.from(g.tooltip):(0,$.$le)(g.tooltip)?a=g.tooltip:A.$jK.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=m.MarkdownString.from(g.detail)):(0,$.$le)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=g.detail),{...g,id:g.id??void 0,handle:t,source:k,command:d.command?D.toInternal(d.command,y):void 0,icon:o,iconDark:c,themeIcon:n,tooltip:a,accessibilityInformation:d.accessibilityInformation}}}}f(k,D){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:D}),(0,R.$kb)(()=>{for(const r of this.c.values())r.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$kcc=P;function I(p){return p?.toString()}}),define(De[72],Ce([1,0,21,4,3,213,5,14,86,6,26,20,7]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dsb=e.$csb=e.TunnelDtoConverter=void 0;class k extends S.$2z{}var D;(function(r){function i(d){return{remoteAddress:d.remoteAddress,localAddress:d.localAddress,public:!!d.public,privacy:d.privacy??(d.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:d.protocol}}r.fromApiTunnel=i;function s(d){return{remoteAddress:{host:d.tunnelRemoteHost,port:d.tunnelRemotePort},localAddress:d.localAddress,public:d.privacy!==S.TunnelPrivacyId.ConstantPrivate&&d.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:d.privacy,protocol:d.protocol}}r.fromServiceTunnel=s})(D||(e.TunnelDtoConverter=D={})),e.$csb=(0,A.$zh)("IExtHostTunnelService");let y=class extends f.$mb{constructor(i,s,d){super(),this.n=d,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$hc,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy($.$SJ.MainThreadTunnelService)}async openTunnel(i,s){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${s.remoteAddress.host}:${s.remoteAddress.port}.`);const d=await this.a.$openTunnel(s,i.displayName);if(d){const b=new k(d.remoteAddress,d.localAddress,()=>this.a.$closeTunnel(d.remoteAddress));return this.B(b),b}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,s){const d=this.p();return this.l.set(d,{selector:i,provider:s}),this.a.$registerPortsAttributesProvider(i,d),new p.$UJ(()=>{this.l.delete(d),this.a.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(i,s,d,b,g){const t=[];for(const c of i){const n=this.l.get(c);if(!n)return[];t.push(...await Promise.all(s.map(async a=>{let l;try{l=await n.provider.providePortAttributes({port:a,pid:d,commandLine:b},g)}catch{l=await n.provider.providePortAttributes(a,d,b,g)}return{providedAttributes:l,port:a}})))}const o=t.filter(c=>!!c.providedAttributes);return o.length>0?o.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,s){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(b,g)=>await i.provideTunnel(b,g,new C.$rc().token)??void 0;const d=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,privacyOptions:s.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(d),Promise.resolve((0,f.$kb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,s){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const d=i.tunnelFactory??(s?this.r(s):void 0);if(d){this.b=d;let b=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const g=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:b}:void 0;this.a.$setTunnelProvider(g)}}else this.b=void 0;return(0,f.$kb)(()=>{this.b=void 0})}r(i){}async $closeTunnel(i,s){if(this.g.has(i.host)){const d=this.g.get(i.host);d.has(i.port)&&(s&&d.get(i.port).disposeListener.dispose(),await d.get(i.port).tunnel.dispose(),d.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,s){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this.b(i,s);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const b=await d;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),b===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const g=this.B(b.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(b.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:b,disposeListener:g}),D.fromApiTunnel(b)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(d){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),d instanceof Error)return d.message}}async $applyCandidateFilter(i){const s=await Promise.all(i.map(b=>this.f(b.host,b.port,b.detail??""))),d=i.filter((b,g)=>s[g]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(b=>b.port).join(", ")} to ${d.map(b=>b.port).join(", ")}`),d}};e.$dsb=y,e.$dsb=y=Ke([Be(0,I.$UL),Be(1,P.$$L),Be(2,m.$3i)],y)}),define(De[330],Ce([1,0,3,17,2,6]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(R.$SJ.MainThreadUriOpeners)}registerExternalUriOpener(S,$,P,I){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const p=I.schemes.find(k=>!A.a.has(k));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set($,P),this.b.$registerUriOpener($,I.schemes,S,I.label),(0,C.$kb)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(S,$,P){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const p=f.URI.revive($);return I.canOpenExternalUri(p,P)}async $openUri(S,$,P){const I=this.c.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(f.URI.revive($.resolvedUri),{sourceUri:f.URI.revive($.sourceUri)},P)}}e.$tcc=A}),define(De[331],Ce([1,0,6,2,3,8,25]),function(be,e,C,T,f,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class m{static{this.a=0}constructor($){this.c=new A.$Ul,this.d=new Map,this.b=$.getProxy(C.$SJ.MainThreadUrls)}registerUriHandler($,P){const I=$.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=m.a++;return this.c.add(I),this.d.set(p,P),this.b.$registerUriHandler(p,I,$.displayName||$.name),(0,f.$kb)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri($,P){const I=this.d.get($);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(P))}catch(p){(0,R.$Y)(p)}return Promise.resolve(void 0)}async createAppUri($){return T.URI.revive(await this.b.$createAppUri($))}}e.$Jbc=m}),define(De[92],Ce([1,0,4,3,17,23,2,228,265,110,6]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=e.$Kbc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(b,g,t,o,c,n,a){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$hc,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$hc,this._onDidDispose=this.#h.event,this.#e=b,this.#t=g,this.#r=t,this.#l=o,this.#u=c,this.#n=n,this.#c=p(n),this.#d=k(n),this.#i=a}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return this.#a=!0,(0,$.$Kob)(b,this.#l)}get cspSource(){const b=this.#n.extensionLocation;if(b.scheme===f.Schemas.https||b.scheme===f.Schemas.http){let g=b.toString();return g.endsWith("/")||(g+="/"),g+" "+$.$Job}return $.$Job}get html(){return this.a(),this.#s}set html(b){this.a(),this.#s!==b&&(this.#s=b,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(b)))}get options(){return this.a(),this.#r}set options(b){this.a(),R.$Xm(this.#r,b)||this.#t.$setOptions(this.#e,r(this.#n,this.#u,b)),this.#r=b}async postMessage(b){if(this.#o)return!1;const g=(0,S.$Xbb)(b,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,g.message,...g.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(b){if(!this.#d)return b;const g=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return b.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,c,n,a,l,v)=>{const E=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),u=(0,$.$Kob)(E,{isRemote:g,authority:t}).toString();return`${c}${u}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(o,c,n,a,l,v)=>{const E=A.URI.from({scheme:a||"file",path:decodeURIComponent(l)}),u=(0,$.$Kob)(E,{isRemote:g,authority:t}).toString();return`${c}${u}${v}`})}}e.$Kbc=I;function p(d){try{const b=(0,m.$Bo)((0,m.$Ao)(d.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.$Lbc=p;function k(d){try{const b=(0,m.$Bo)((0,m.$Ao)(d.engines.vscode));return b?b.majorBase<1||b.majorBase===1&&b.minorBase<60:!1}catch{return!1}}class D extends T.$mb{constructor(b,g,t,o,c){super(),this.c=g,this.f=t,this.g=o,this.h=c,this.b=new Map,this.a=b.getProxy(P.$SJ.MainThreadWebviews)}dispose(){super.dispose();for(const b of this.b.values())b.dispose();this.b.clear()}$onMessage(b,g,t){const o=this.i(b);if(o){const{message:c}=(0,S.$Ybb)(g,t.value);o._onMessageEmitter.fire(c)}}$onMissingCsp(b,g){this.g.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,g,t){const o=new I(b,this.a,i(g),this.c,this.f,t,this.h);this.b.set(b,o);const c=o._onDidDispose(()=>{c.dispose(),this.deleteWebview(b)});return o}deleteWebview(b){this.b.delete(b)}i(b){return this.b.get(b)}}e.$Mbc=D;function y(d){return{id:d.identifier,location:d.extensionLocation}}e.$Nbc=y;function r(d,b,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||s(d,b)}}e.$Obc=r;function i(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(b=>A.URI.from(b))}}function s(d,b){return[...(b?.getWorkspaceFolders()||[]).map(g=>g.uri),d.extensionLocation]}}),define(De[332],Ce([1,0,21,51,3,17,24,2,13,92,87,6,7]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class k{constructor(o,c){this.document=o,this.b=c,this.a=1,this.c=new P.$Gac("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,c){await this.f(o).undo(),c||this.disposeBackup()}async redo(o,c){await this.f(o).redo(),c||this.disposeBackup()}disposeEdits(o){for(const c of o)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=g(this.document.uri)+this.a++;return(0,A.$gg)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const c=this.c.get(o,0);if(!c)throw new Error("No edit found");return c}}class D{constructor(){this.a=new Map}get(o,c){return this.a.get(this.b(o,c))}add(o,c,n){const a=this.b(o,c.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${o} resource:${c.uri}`);const l=new k(c,n);return this.a.set(a,l),l}delete(o,c){const n=this.b(o,c.uri);this.a.delete(n)}b(o,c){return`${o}@@@${c}`}}var y;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(y||(y={}));class r{constructor(){this.a=new Map}addTextProvider(o,c,n){return this.b(0,o,c,n)}addCustomProvider(o,c,n){return this.b(1,o,c,n)}get(o){return this.a.get(o)}b(o,c,n,a){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:o,extension:n,provider:a}),new p.$UJ(()=>this.a.delete(c))}}class i{constructor(o,c,n,a,l){this.d=c,this.f=n,this.g=a,this.h=l,this.b=new r,this.c=new D,this.a=o.getProxy(I.$SJ.MainThreadCustomEditors)}registerCustomEditorProvider(o,c,n,a){const l=new f.$lb;return d(n)?(l.add(this.b.addTextProvider(c,o,n)),this.a.$registerTextEditorProvider((0,$.$Nbc)(o),c,a.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,$.$Lbc)(o))):(l.add(this.b.addCustomProvider(c,o,n)),s(n)&&l.add(n.onDidChangeCustomDocument(v=>{const E=this.i(c,v.document.uri);if(b(v)){const u=E.addEdit(v);this.a.$onDidEdit(v.document.uri,c,u,v.label)}else this.a.$onContentChange(v.document.uri,c)})),this.a.$registerCustomEditorProvider((0,$.$Nbc)(o),c,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,$.$Lbc)(o))),p.$UJ.from(l,new p.$UJ(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(o,c,n,a,l){const v=this.b.get(c);if(!v)throw new Error(`No provider found for '${c}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${c}'`);const E=m.URI.revive(o),u=await v.provider.openCustomDocument(E,{backupId:n,untitledDocumentData:a?.buffer},l);let h;return s(v.provider)&&this.f&&(h=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(c,u,h),{editable:s(v.provider)}}async $disposeCustomDocument(o,c){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${c}'`);const a=m.URI.revive(o),{document:l}=this.i(c,a);this.c.delete(c,l),l.dispose()}async $resolveCustomEditor(o,c,n,a,l,v){const E=this.b.get(n);if(!E)throw new Error(`No provider found for '${n}'`);const u=S.ViewColumn.to(l),h=this.g.createNewWebview(c,a.contentOptions,E.extension),w=this.h.createNewWebviewPanel(c,n,a.title,u,a.options,h,a.active),L=m.URI.revive(o);switch(E.type){case 1:{const{document:O}=this.i(n,L);return E.provider.resolveCustomEditor(O,w,v)}case 0:{const O=this.d.getDocument(L);return E.provider.resolveCustomTextEditor(O,w,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,c,n){this.i(c,o).disposeEdits(n)}async $onMoveCustomEditor(o,c,n){const a=this.b.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const l=this.h.getWebviewPanel(o);if(!l)throw new Error("No webview found");const v=m.URI.revive(c),E=this.d.getDocument(v);await a.provider.moveCustomTextEditor(E,l,C.CancellationToken.None)}async $undo(o,c,n,a){return this.i(c,o).undo(n,a)}async $redo(o,c,n,a){return this.i(c,o).redo(n,a)}async $revert(o,c,n){const a=this.i(c,o);await this.j(c).revertCustomDocument(a.document,n),a.disposeBackup()}async $onSave(o,c,n){const a=this.i(c,o);await this.j(c).saveCustomDocument(a.document,n),a.disposeBackup()}async $onSaveAs(o,c,n,a){const l=this.i(c,o);return this.j(c).saveCustomDocumentAs(l.document,m.URI.revive(n),a)}async $backup(o,c,n){const a=this.i(c,o),v=await this.j(c).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},n);return a.updateBackup(v),v.id}i(o,c){const n=this.c.get(o,m.URI.revive(c));if(!n)throw new Error("No custom document found");return n}j(o){const n=this.b.get(o)?.provider;if(!n||!s(n))throw new Error("Custom document is not editable");return n}}e.$ncc=i;function s(t){return!!t.onDidChangeCustomDocument}function d(t){return typeof t.resolveCustomTextEditor=="function"}function b(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function g(t){const o=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$ni)(o)+""}}),define(De[333],Ce([1,0,4,3,2,31,13,92,6,7]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class P extends T.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,y,r,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$hc),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$hc),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=y,this.#l=r,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,f.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,y){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:A.ViewColumn.from(D),preserveFocus:!!y})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$mb{static c(){return(0,R.$6e)()}constructor(D,y,r){super(),this.i=y,this.j=r,this.g=new Map,this.h=new Map,this.f=D.getProxy(S.$SJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,y,r,i,s={}){const d=typeof i=="object"?i.viewColumn:i,b={viewColumn:A.ViewColumn.from(d),preserveFocus:typeof i=="object"&&!!i.preserveFocus},g=(0,m.$Lbc)(D),t=I.c();this.f.$createWebviewPanel((0,m.$Nbc)(D),t,y,{title:r,panelOptions:p(s),webviewOptions:(0,m.$Obc)(D,this.j,s),serializeBuffersForPostMessage:g},b);const o=this.i.createNewWebview(t,s,D);return this.createNewWebviewPanel(t,y,r,d,s,o,!0)}$onDidChangeWebviewPanelViewStates(D){const y=Object.keys(D);y.sort((r,i)=>{const s=D[r],d=D[i];return s.active?1:d.active?-1:+s.visible-+d.visible});for(const r of y){const i=this.getWebviewPanel(r);if(!i)continue;const s=D[r];i._updateViewState({active:s.active,visible:s.visible,viewColumn:A.ViewColumn.to(s.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.i.deleteWebview(D)}registerWebviewPanelSerializer(D,y,r){if(this.h.has(y))throw new Error(`Serializer for '${y}' already registered`);return this.h.set(y,{serializer:r,extension:D}),this.f.$registerSerializer(y,{serializeBuffersForPostMessage:(0,m.$Lbc)(D)}),new $.$UJ(()=>{this.h.delete(y),this.f.$unregisterSerializer(y)})}async $deserializeWebviewPanel(D,y,r,i){const s=this.h.get(y);if(!s)throw new Error(`No serializer found for '${y}'`);const{serializer:d,extension:b}=s,g=this.i.createNewWebview(D,r.webviewOptions,b),t=this.createNewWebviewPanel(D,y,r.title,i,r.panelOptions,g,r.active);await d.deserializeWebviewPanel(t,r.state)}createNewWebviewPanel(D,y,r,i,s,d,b){const g=new P(D,this.f,d,{viewType:y,title:r,viewColumn:i,panelOptions:s,active:b});return this.g.set(D,g),g}getWebviewPanel(D){return this.g.get(D)}}e.$mcc=I;function p(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(De[334],Ce([1,0,4,3,92,13,6,7]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class S extends T.$mb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,p,k,D,y,r){super(),this.#u=!1,this.#a=this.B(new C.$hc),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$hc),this.onDidDispose=this.#c.event,this.#i=k,this.#s=D,this.#e=I,this.#t=p,this.#l=y,this.#n=r}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class ${constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$SJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,k,D){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:k,extension:I}),this.a.$registerWebviewViewProvider((0,f.$Nbc)(I),p,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$Lbc)(I)}),new m.$UJ(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,k,D,y){const r=this.b.get(p);if(!r)throw new Error(`No view provider found for '${p}'`);const{provider:i,extension:s}=r,d=this.d.createNewWebview(I,{},s),b=new S(I,this.a,p,k,d,!0);this.c.set(I,b),await i.resolveWebviewView(b,{state:D},y)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$lcc=$}),define(De[151],Ce([1,0,4,6,2,17,15,5,20,27]),function(be,e,C,T,f,R,A,m,S,$){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=void 0;let I=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(k){const D=this.d;return{get focused(){return D.focused},get active(){return(0,$.$MF)(k,"windowActivity"),D.active}}}constructor(k){this.c=new C.$hc,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=k.getProxy(T.$SJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:y})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",y)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,D){D!==this.d[k]&&(this.d={...this.d,[k]:D},this.c.fire(this.d))}openUri(k,D){let y;if(typeof k=="string"){y=k;try{k=f.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.$od)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,y,D)}async asExternalUri(k,D){if((0,A.$od)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(k,D);return f.URI.from(y)}};e.$Pbc=I,e.$Pbc=I=P=Ke([Be(0,S.$UL)],I),e.$Qbc=(0,m.$zh)("IExtHostWindow")}),define(De[335],Ce([1,0,303,26,20]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=void 0;const R=1024*1024;let A=class extends C.$Occ{constructor(S,$){super(S,$),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,$,P){const I=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),$.apply(console,P),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,$){const P=process[S],I=P.write;let p="";Object.defineProperty(P,"write",{set:()=>{},get:()=>(k,D,y)=>{if(!this.g){p+=k.toString(D);const r=p.length>R?p.length:p.lastIndexOf(`
`);r!==-1&&(console[$](p.slice(0,r)),p=p.slice(r+1))}I.call(P,k,D,y)}})}};e.$ndc=A,e.$ndc=A=Ke([Be(0,f.$UL),Be(1,T.$$L)],A)}),define(De[336],Ce([1,0,71,17,14,240,30,12]),function(be,e,C,T,f,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;let S=class{constructor(I,p){I.addFileSystemProvider(T.Schemas.file,new $(p),{isCaseSensitive:m.$k})}};e.$odc=S,e.$odc=S=Ke([Be(0,C.$cbc),Be(1,f.$3i)],S);class ${constructor(I){this.b=I,this.a=new R.$Zp(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,k){return this.a.writeFile(I,p,{...k,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,k){return this.a.rename(I,p,k)}copy(I,p,k){return this.a.copy(I,p,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(De[337],Ce([1,0,16,63,31,33,3,6,2,20]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0;let P=class extends A.$mb{constructor(p,k){super();const D=p.getProxy(m.$SJ.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async y=>{const r=S.URI.file((0,C.$$c)((0,T.tmpdir)(),(0,f.$6e)()));return await D.$download(y,r),r})}};e.$mdc=P,e.$mdc=P=Ke([Be(0,$.$UL),Be(1,R.$eM)],P)}),define(De[338],Ce([1,0,150,17,242,31]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class A extends C.$Ncc{m(S,$,P){return S.scheme===T.Schemas.file?new f.$7M(P?.name||(0,R.$6e)(),S.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,$):super.m(S,$,P)}registerLogger(S){super.registerLogger(S),this.n.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.n.$deregisterLogger(S)}}e.$zdc=A}),define(De[339],Ce([1,0,52,16,2,91,3,17,11,29]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class P extends R.$ebc{constructor(){super(...arguments),this.i=null}async g(t){const o=await super.g(t);if(o.scheme!==m.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const c=o.fsPath;let n=0;do{let a;n===0?a=c:a=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${n}`:`${c}-${n}`,await I(a);const l=T.$$c(a,"vscode.lock"),v=await y(this.d,l,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),f.URI.file(a);n++}while(n<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$ydc=P;async function I(g){try{await $.Promises.stat(g);return}catch{}try{await $.Promises.mkdir(g,{recursive:!0})}catch{}}const p=1e3,k=10*60*1e3;class D extends A.$mb{constructor(t,o){super(),this.b=t,this.c=o,this.a=this.B(new S.$Pg),this.a.cancelAndSet(async()=>{const c=await r(t,o);(!c||c.pid!==process.pid)&&(t.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await $.Promises.utimes(o,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${o}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+t};await $.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function y(g,t,o){try{const n={pid:process.pid,willReleaseAt:0};await $.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){g.error(n)}const c=await r(g,t);return!c||c.pid!==process.pid?o?(g.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),d(g,t)):(g.info(`Lock '${t}': Lock acquired.`),new D(g,t))}async function r(g,t){let o;try{o=await $.Promises.readFile(t)}catch(c){return g.error(c),null}try{return JSON.parse(String(o))}catch(c){return g.error(c),null}}async function i(g,t){let o;try{o=await $.Promises.stat(t)}catch(c){return g.error(c),0}return o.mtime.getTime()}function s(g){try{return process.kill(g,0),!0}catch{return!1}}async function d(g,t){const o=await r(g,t);if(!o)return g.info(`Lock '${t}': Could not read pid of lock holder.`),b(g,t);if(o.willReleaseAt){let v=o.willReleaseAt-Date.now();if(v<5e3){for(v>0?g.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):g.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,S.$Fg)(Math.min(100,v)),await i(g,t)===0)return b(g,t);v=o.willReleaseAt-Date.now()}return b(g,t)}}if(!s(o.pid))return g.info(`Lock '${t}': The pid ${o.pid} appears to be gone.`),b(g,t);const c=await i(g,t),n=Date.now()-c;if(n<=k)return g.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;g.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,S.$Fg)(2e3);const a=await i(g,t),l=Date.now()-a;return l<=k?(g.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(g.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),b(g,t))}async function b(g,t){g.info(`Lock '${t}': Deleting a stale lock.`);try{await $.Promises.unlink(t)}catch{}return y(g,t,!0)}}),define(De[340],Ce([1,0,31,20,44,33]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;let A=class extends f.$hbc{constructor(S,$){super(!0,S,$)}createTerminal(S,$,P){return this.createTerminalFromOptions({name:S,shellPath:$,shellArgs:P})}createTerminalFromOptions(S,$){const P=new f.$gbc(this.a,(0,C.$6e)(),S,S.name);return this.f.push(P),P.create(S,this.N(S,$)),P.value}};e.$Tcc=A,e.$Tcc=A=Ke([Be(0,R.$eM),Be(1,T.$UL)],A)}),define(De[341],Ce([1,0,11,22,21,8,4,3,128,292,68]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$j3b=e.ResponsiveState=e.RequestInitiator=e.$i3b=e.$h3b=void 0;function p(h,w){try{return JSON.stringify(h,w)}catch{return"null"}}const k="$$ref$$",D={[k]:-1};class y{constructor(w,L){this.jsonString=w,this.referencedBuffers=L}}function r(h,w=null,L=!1){const O=[];return{jsonString:(L?p:JSON.stringify)(h,(M,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof T.$Hc){const j=O.push(z)-1;return{[k]:j}}if(w)return w(M,z)}return z}),referencedBuffers:O}}e.$h3b=r;function i(h,w,L){return JSON.parse(h,(O,N)=>{if(N){const M=N[k];if(typeof M=="number")return w[M];if(L&&N.$mid===1)return L.transformIncoming(N)}return N})}e.$i3b=i;function s(h,w){return JSON.stringify(h,w)}function d(h){return h?(w,L)=>L&&L.$mid===1?h.transformOutgoing(L):L:null}var b;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));var g;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const t=()=>{},o=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class n extends m.$mb{static{I=o}static{this.a=3*1e3}constructor(w,L=null,O=null){super(),this[I]=!0,this.b=this.B(new A.$hc),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=L,this.g=O,this.h=d(this.g),this.j=!1,this.k=[],this.l=[];for(let N=0,M=P.$9z.count;N<M;N++)this.k[N]=null,this.l[N]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new C.$Qg(()=>this.C(),1e3)),this.c.onMessage(N=>this.G(N))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+n.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+n.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,S.$Cm)(w,this.g):w}getProxy(w){const{nid:L,sid:O}=w;return this.l[L]||(this.l[L]=this.F(L,O)),this.l[L]}F(w,L){const O={get:(N,M)=>(typeof M=="string"&&!N[M]&&M.charCodeAt(0)===36&&(N[M]=(...z)=>this.O(w,M,z)),M===c?L:N[M])};return new Proxy(Object.create(null),O)}set(w,L){return this.k[w.nid]=L,L}assertRegistered(w){for(let L=0,O=w.length;L<O;L++){const N=w[L];if(!this.k[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}G(w){if(this.j)return;const L=w.byteLength,O=a.read(w,0),N=O.readUInt8(),M=O.readUInt32();switch(N){case 1:case 2:{let{rpcId:z,method:j,args:F}=v.deserializeRequestJSONArgs(O);this.g&&(F=(0,S.$Cm)(F,this.g)),this.H(L,M,z,j,F,N===2);break}case 3:case 4:{let{rpcId:z,method:j,args:F}=v.deserializeRequestMixedArgs(O);this.g&&(F=(0,S.$Cm)(F,this.g)),this.H(L,M,z,j,F,N===4);break}case 5:{this.f?.logIncoming(L,M,0,"ack"),this.z(M);break}case 6:{this.I(L,M);break}case 7:{this.J(L,M,void 0);break}case 9:{let z=v.deserializeReplyOKJSON(O);this.g&&(z=(0,S.$Cm)(z,this.g)),this.J(L,M,z);break}case 10:{const z=v.deserializeReplyOKJSONWithBuffers(O,this.g);this.J(L,M,z);break}case 8:{const z=v.deserializeReplyOKVSBuffer(O);this.J(L,M,z);break}case 11:{let z=v.deserializeReplyErrError(O);this.g&&(z=(0,S.$Cm)(z,this.g)),this.L(L,M,z);break}case 12:{this.L(L,M,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,L,O,N,M,z){this.f?.logIncoming(w,L,1,`receiveRequest ${(0,P.$$z)(O)}.${N}(`,M);const j=String(L);let F,K;if(z){const $e=new f.$rc;M.push($e.token),F=this.M(O,N,M),K=()=>$e.cancel()}else F=this.M(O,N,M),K=t;this.p[j]=K;const H=v.serializeAcknowledged(L);this.f?.logOutgoing(H.byteLength,L,1,"ack"),this.c.send(H),F.then($e=>{delete this.p[j];const _=v.serializeReplyOK(L,$e,this.h);this.f?.logOutgoing(_.byteLength,L,1,"reply:",$e),this.c.send(_)},$e=>{delete this.p[j];const _=v.serializeReplyErr(L,$e);this.f?.logOutgoing(_.byteLength,L,1,"replyErr:",$e),this.c.send(_)})}I(w,L){this.f?.logIncoming(w,L,1,"receiveCancel");const O=String(L);this.p[O]?.()}J(w,L,O){this.f?.logIncoming(w,L,0,"receiveReply:",O);const N=String(L);if(!this.s.hasOwnProperty(N))return;const M=this.s[N];delete this.s[N],M.resolveOk(O)}L(w,L,O){this.f?.logIncoming(w,L,0,"receiveReplyErr:",O);const N=String(L);if(!this.s.hasOwnProperty(N))return;const M=this.s[N];delete this.s[N];let z;O&&(O.$isError?(z=new Error,z.name=O.name,z.message=O.message,z.stack=O.stack):z=O),M.resolveErr(z)}M(w,L,O){try{return Promise.resolve(this.N(w,L,O))}catch(N){return Promise.reject(N)}}N(w,L,O){const N=this.k[w];if(!N)throw new Error("Unknown actor "+(0,P.$$z)(w));const M=N[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,P.$$z)(w));return M.apply(N,O)}O(w,L,O){if(this.j)return new $.$g3b;let N=null;if(O.length>0&&f.CancellationToken.isCancellationToken(O[O.length-1])&&(N=O.pop()),N&&N.isCancellationRequested)return Promise.reject(R.$4());const M=v.serializeRequestArguments(O,this.h),z=++this.m,j=String(z),F=new $.$f3b;N&&N.onCancellationRequested(()=>{const H=v.serializeCancel(z);this.f?.logOutgoing(H.byteLength,z,0,"cancel"),this.c.send(v.serializeCancel(z))}),this.s[j]=F,this.y(z);const K=v.serializeRequest(z,w,L,M,!!N);return this.f?.logOutgoing(K.byteLength,z,0,`request: ${(0,P.$$z)(w)}.${L}(`,O),this.c.send(K),F}}e.$j3b=n;class a{static alloc(w,L,O){const N=new a(T.$Hc.alloc(O+1+4),0);return N.writeUInt8(w),N.writeUInt32(L),N}static read(w,L){return new a(w,L)}get buffer(){return this.a}constructor(w,L){this.a=w,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+w).toString();return this.b+=w,O}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+w).toString();return this.b+=w,O}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+w);return this.b+=w,L}static sizeMixedArray(w){let L=0;L+=1;for(let O=0,N=w.length;O<N;O++){const M=w[O];switch(L+=1,M.type){case 1:L+=this.sizeLongString(M.value);break;case 2:L+=this.sizeVSBuffer(M.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let z=0;z<M.buffers.length;++z)L+=this.sizeVSBuffer(M.buffers[z]);break;case 4:break}}return L}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let L=0,O=w.length;L<O;L++){const N=w[L];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let M=0;M<N.buffers.length;++M)this.writeBuffer(N.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const L=new Array(w);for(let O=0;O<w;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),z=this.readLongString(),j=[];for(let F=0;F<M;++F)j.push(this.readVSBuffer());L[O]=new P.$_z(i(z,j,null));break}case 4:L[O]=void 0;break}return L}}var l;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(l||(l={}));class v{static a(w){for(let L=0,O=w.length;L<O;L++)if(w[L]instanceof T.$Hc||w[L]instanceof P.$_z||typeof w[L]>"u")return!0;return!1}static serializeRequestArguments(w,L){if(this.a(w)){const O=[];for(let N=0,M=w.length;N<M;N++){const z=w[N];if(z instanceof T.$Hc)O[N]={type:2,value:z};else if(typeof z>"u")O[N]={type:4};else if(z instanceof P.$_z){const{jsonString:j,referencedBuffers:F}=r(z.value,L);O[N]={type:3,value:T.$Hc.fromString(j),buffers:F}}else O[N]={type:1,value:T.$Hc.fromString(s(z,L))}}return{type:1,args:O}}return{type:0,args:s(w,L)}}static serializeRequest(w,L,O,N,M){switch(N.type){case 0:return this.b(w,L,O,N.args,M);case 1:return this.c(w,L,O,N.args,M)}}static b(w,L,O,N,M){const z=T.$Hc.fromString(O),j=T.$Hc.fromString(N);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(z),F+=a.sizeLongString(j);const K=a.alloc(M?2:1,w,F);return K.writeUInt8(L),K.writeShortString(z),K.writeLongString(j),K.buffer}static deserializeRequestJSONArgs(w){const L=w.readUInt8(),O=w.readShortString(),N=w.readLongString();return{rpcId:L,method:O,args:JSON.parse(N)}}static c(w,L,O,N,M){const z=T.$Hc.fromString(O);let j=0;j+=a.sizeUInt8(),j+=a.sizeShortString(z),j+=a.sizeMixedArray(N);const F=a.alloc(M?4:3,w,j);return F.writeUInt8(L),F.writeShortString(z),F.writeMixedArray(N),F.buffer}static deserializeRequestMixedArgs(w){const L=w.readUInt8(),O=w.readShortString(),N=w.readMixedArray(),M=new Array(N.length);for(let z=0,j=N.length;z<j;z++){const F=N[z];typeof F=="string"?M[z]=JSON.parse(F):M[z]=F}return{rpcId:L,method:O,args:M}}static serializeAcknowledged(w){return a.alloc(5,w,0).buffer}static serializeCancel(w){return a.alloc(6,w,0).buffer}static serializeReplyOK(w,L,O){if(typeof L>"u")return this.d(w);if(L instanceof T.$Hc)return this.e(w,L);if(L instanceof P.$_z){const{jsonString:N,referencedBuffers:M}=r(L.value,O,!0);return this.g(w,N,M)}else return this.f(w,p(L,O))}static d(w){return a.alloc(7,w,0).buffer}static e(w,L){let O=0;O+=a.sizeVSBuffer(L);const N=a.alloc(8,w,O);return N.writeVSBuffer(L),N.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,L){const O=T.$Hc.fromString(L);let N=0;N+=a.sizeLongString(O);const M=a.alloc(9,w,N);return M.writeLongString(O),M.buffer}static g(w,L,O){const N=T.$Hc.fromString(L);let M=0;M+=a.sizeUInt32,M+=a.sizeLongString(N);for(const j of O)M+=a.sizeVSBuffer(j);const z=a.alloc(10,w,M);z.writeUInt32(O.length),z.writeLongString(N);for(const j of O)z.writeBuffer(j);return z.buffer}static deserializeReplyOKJSON(w){const L=w.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(w,L){const O=w.readUInt32(),N=w.readLongString(),M=[];for(let z=0;z<O;++z)M.push(w.readVSBuffer());return new P.$_z(i(N,M,L))}static serializeReplyErr(w,L){const O=L?p(R.$1(L),null):void 0;if(typeof O!="string")return this.h(w);const N=T.$Hc.fromString(O);let M=0;M+=a.sizeLongString(N);const z=a.alloc(11,w,M);return z.writeLongString(N),z.buffer}static deserializeReplyErrError(w){const L=w.readLongString();return JSON.parse(L)}static h(w){return a.alloc(12,w,0).buffer}}var E;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var u;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(u||(u={}))}),define(De[342],Ce([1,0,4,42,41,5]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9I=e.$8I=e.OutputChannelUpdateMode=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=void 0,e.$WI="text/x-code-output",e.$XI="output",e.$YI="Log",e.$ZI="text/x-code-log-output",e.$1I="log",e.$2I="log",e.$3I="workbench.panel.output",e.$4I=new f.$Zi("inOutput",!1),e.$5I=new f.$Zi("activeLogOutput",!1),e.$6I=new f.$Zi("outputView.scrollLock",!1),e.$7I=(0,R.$zh)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$8I={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new C.$hc,this.onDidRegisterChannel=this.b.event,this.c=new C.$hc,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(P=>$.push(P)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}T.$6m.add(e.$8I.OutputChannels,new m),e.$9I=new f.$Zi("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,342,71,26,54,178,22,18,30,4,3]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=void 0;class i extends A.$9i{get disposed(){return this.l}constructor(g,t,o,c,n){super(),this.id=g,this.name=t,this.m=o,this.n=c,this.extension=n,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Clear,g)}replace(g){const t=this.k;this.info(g),this.n.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(g,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:t))}hide(){this.n.$close(this.id)}g(g,t){this.k+=p.$Hc.fromString(t).byteLength,(0,A.log)(this.m,g,t),this.visible&&(this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class s extends i{appendLine(g){this.append(g)}}let d=class{constructor(g,t,o,c,n,a){this.i=t,this.j=o,this.k=c,this.l=n,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(C.$SJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$5l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[t,o]of this.g)o.visible=t===this.h}createOutputChannel(g,t,o){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,n=(0,k.$le)(t)?t:void 0;if((0,k.$le)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const l=this.i.environment.extensionLogLevel?.find(([E])=>R.$Tl.equals(o.identifier,E))?.[1];l&&(a=(0,A.$gj)(l));const v=c?this.o(g,a,o):this.n(g,n,o);return v.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),c?this.r(g,a??this.m.getLevel(),v):this.q(g,v)}async n(g,t,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,n=this.k.extUri.joinPath(c,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(g,n,t,o.identifier.value);return new i(l,g,a,this.a,o)}async o(g,t,o){const c=await this.p(o),n=g.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(c,`${n}.log`),l=`${o.identifier.value}.${n}`,v=this.l.createLogger(a,{id:l,name:g,logLevel:t,extensionId:o.identifier.value});return new s(l,g,v,this.a,o)}p(g){let t=this.d.get(g.identifier.value);if(!t){const o=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(o)}catch(c){if((0,D.$gk)(c)!==D.FileSystemProviderErrorCode.FileExists)throw c}return o})())}return t}q(g,t){let o=!1;const c=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return g},append(n){c(),t.then(a=>a.append(n))},appendLine(n){c(),t.then(a=>a.appendLine(n))},clear(){c(),t.then(n=>n.clear())},replace(n){c(),t.then(a=>a.replace(n))},show(n,a){c(),t.then(l=>l.show(n,a))},hide(){c(),t.then(n=>n.hide())},dispose(){o=!0,t.then(n=>n.dispose())}}}r(g,t,o){const c=new r.$lb,n=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},a=c.add(new y.$hc);function l(v){t=v,a.fire(v)}return o.then(v=>{c.add(v),v.logLevel!==t&&l(v.logLevel),c.add(v.onDidChangeLogLevel(E=>l(E)))}),{...this.q(g,o),get logLevel(){return t},onDidChangeLogLevel:a.event,trace(v,...E){n(),o.then(u=>u.trace(v,...E))},debug(v,...E){n(),o.then(u=>u.debug(v,...E))},info(v,...E){n(),o.then(u=>u.info(v,...E))},warn(v,...E){n(),o.then(u=>u.warn(v,...E))},error(v,...E){n(),o.then(u=>u.error(v,...E))},dispose(){c.dispose()}}}};e.$zbc=d,e.$zbc=d=Ke([Be(0,f.$UL),Be(1,$.$$L),Be(2,S.$cbc),Be(3,P.$Jac),Be(4,A.$4i),Be(5,A.$3i)],d),e.$Abc=(0,T.$zh)("IExtHostOutputService")}),define(De[343],Ce([1,0,5,11]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=void 0,e.$hm=(0,C.$zh)("remoteAgentService"),e.$im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const S=await f.getRoundTripTime();if(S===void 0)return;R=Math.min(R,S/2),await(0,T.$Fg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((m,S)=>m+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((m,S)=>m+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[344],Ce([1,0,32,17,16,12,24,2,5,258,43,147,343]),function(be,e,C,T,f,R,A,m,S,$,P,I,p){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=void 0,e.$oJ=(0,S.$zh)("pathService");let D=k=class{constructor(r,i,s,d){this.d=r,this.e=i,this.f=s,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??r})()}hasValidBasename(r,i,s){return typeof i=="string"||typeof i>"u"?this.a.then(d=>this.h(r,d,i)):this.h(r,i,s)}h(r,i,s){return r.scheme===T.Schemas.file||r.scheme===T.Schemas.vscodeRemote?(0,C.$Ie)(s??(0,A.$dg)(r),i===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,i){if(r.remoteAuthority)return T.Schemas.vscodeRemote;const s=(0,$.$lJ)(i.getWorkspace());if(s)return s;const d=i.getWorkspace().folders[0];if(d)return d.uri.scheme;const b=i.getWorkspace().configuration;return b?b.scheme:T.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?f.$7c:f.$8c)}async fileURI(r){let i="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const d=r.indexOf("/",2);d===-1?(i=r.substring(2),r="/"):(i=r.substring(2,d),r=r.substring(d)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:i,path:r,query:"",fragment:""})}};e.$pJ=D,e.$pJ=D=k=Ke([Be(1,p.$hm),Be(2,I.$0I),Be(3,P.$Ih)],D)}),define(De[345],Ce([1,0,225,19,56,4,51,3,2,49,230,14,64,260,86,43,147,27,21,18,23,41]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.$hJ=e.$gJ=e.OnPortForward=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.TunnelSource=e.TunnelCloseReason=e.$aJ=e.$_I=e.$$I=void 0;const t=10*1e3,o="remote.tunnels.toRestore";e.$$I="onTunnel",e.$_I=new g.$Zi("forwardedPortsViewEnabled",!1,C.localize(0,null));function c(O){const N=O.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(N)return{host:N[1]?.substring(0,N[1].length-1)||"localhost",port:Number(N[2])}}e.$aJ=c;var n;(function(O){O.Other="Other",O.User="User",O.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var a;(function(O){O[O.User=0]="User",O[O.Auto=1]="Auto",O[O.Extension=2]="Extension"})(a||(e.TunnelSource=a={})),e.$bJ={source:a.User,description:C.localize(1,null)},e.$cJ={source:a.Auto,description:C.localize(2,null)};function l(O,N,M){const z=O.get(E(N,M));if(z)return z;if((0,D.$Xz)(N))for(const j of D.$Wz){const F=E(j,M);if(O.has(F))return O.get(F)}else if((0,D.$Zz)(N))for(const j of D.$Yz){const F=E(j,M);if(O.has(F))return O.get(F)}}e.$dJ=l;function v(O,N,M){const z=l(O,N,M);if(z)return z;const j=(0,D.$Zz)(N)?"localhost":(0,D.$Xz)(N)?"0.0.0.0":void 0;if(j)return l(O,j,M)}e.$eJ=v;function E(O,N){return O+":"+N}e.$fJ=E;var u;(function(O){O.Notify="notify",O.OpenBrowser="openBrowser",O.OpenBrowserOnce="openBrowserOnce",O.OpenPreview="openPreview",O.Silent="silent",O.Ignore="ignore"})(u||(e.OnPortForward=u={}));function h(O){return O&&"host"in O&&typeof O.host=="string"&&"port"in O&&typeof O.port=="number"&&(!("detail"in O)||typeof O.detail=="string")&&(!("pid"in O)||typeof O.pid=="string")}e.$gJ=h;class w extends m.$mb{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(N){super(),this.l=N,this.i=[],this.k=new R.$hc,this.onDidChangeAttributes=this.k.event,this.B(N.onDidChangeConfiguration(M=>{(M.affectsConfiguration(w.c)||M.affectsConfiguration(w.f))&&this.m()})),this.m()}m(){this.i=this.s(),this.k.fire()}getAttributes(N,M,z){let j=this.r(N,M,z,this.i,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const K=this.i[j];K.key===N?(F.onAutoForward=K.onAutoForward??F.onAutoForward,F.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:F.elevateIfNeeded,F.label=K.label??F.label,F.requireLocalPort=K.requireLocalPort,F.protocol=K.protocol):(F.onAutoForward=F.onAutoForward??K.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:K.elevateIfNeeded,F.label=F.label??K.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??K.protocol),j=this.r(N,M,z,this.i,j+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.u()}n(N){return N.start!==void 0&&N.end!==void 0}p(N){return N.host!==void 0&&N.port!==void 0&&(0,d.$le)(N.host)&&(0,d.$pe)(N.port)}r(N,M,z,j,F){if(F>=j.length)return-1;const K=!(0,D.$Xz)(M)&&!(0,D.$Zz)(M),$e=j.slice(F).findIndex(_=>(0,d.$pe)(_.key)?K?!1:_.key===N:this.n(_.key)?K?!1:N>=_.key.start&&N<=_.key.end:this.p(_.key)?N===_.key.port&&M===_.key.host:z?_.key.test(z):!1);return $e>=0?$e+F:-1}s(){const N=this.l.getValue(w.c);if(!N||!(0,d.$ne)(N))return[];const M=[];for(const j in N){if(j===void 0)continue;const F=N[j];let K;if(Number(j))K=Number(j);else if((0,d.$le)(j))if(w.g.test(j)){const H=j.match(w.g);K={start:Number(H[1]),end:Number(H[2])}}else if(w.h.test(j)){const H=j.match(w.h);K={host:H[1],port:Number(H[2])}}else{let H;try{H=RegExp(j)}catch{}H&&(K=H)}K&&M.push({key:K,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const z=this.l.getValue(w.f);return z&&(this.j={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.t(M)}t(N){function M(z,j){return(0,d.$pe)(z.key)?z.key:j.n(z.key)?z.key.start:j.p(z.key)?z.key.port:Number.MAX_VALUE}return N.sort((z,j)=>M(z,this)-M(j,this))}u(){return this.j}static providedActionToAction(N){switch(N){case D.ProvidedOnAutoForward.Notify:return u.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return u.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return u.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return u.OpenPreview;case D.ProvidedOnAutoForward.Silent:return u.Silent;case D.ProvidedOnAutoForward.Ignore:return u.Ignore;default:return}}async addAttributes(N,M,z){const F=this.l.inspect(w.c).userRemoteValue;let K;!F||!(0,d.$ne)(F)?K={}:K=(0,b.$Tm)(F),K[`${N}`]||(K[`${N}`]={});for(const H in M)K[`${N}`][H]=M[H];return this.l.updateValue(w.c,K,z)}}e.$hJ=w;let L=class extends m.$mb{constructor(N,M,z,j,F,K,H,$e,_,Q){super(),this.z=N,this.C=M,this.D=z,this.F=j,this.G=F,this.H=K,this.I=H,this.J=$e,this.L=_,this.M=Q,this.c=new Map,this.g=new R.$hc,this.onForwardPort=this.g.event,this.h=new R.$hc,this.onClosePort=this.h.event,this.i=new R.$hc,this.onPortName=this.i.event,this.k=new R.$hc,this.onCandidatesChanged=this.k.event,this.n=new R.$hc,this.onEnvironmentTunnelsSet=this.n.event,this.p=!1,this.r=void 0,this.t=!1,this.u=new R.$hc,this.v=new Map,this.w=new Map,this.y=[],this.W=new Date,this.configPortsAttributes=new w(z),this.m=this.S(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.bb,this)),this.forwarded=new Map,this.f=new Map,this.z.tunnels.then(async V=>{const ee=await this.getAttributes(V.map(me=>({port:me.tunnelRemotePort,host:me.tunnelRemoteHost})));for(const me of V)if(me.localAddress){const ae=E(me.tunnelRemoteHost,me.tunnelRemotePort),te=v(this.j??new Map,me.tunnelRemoteHost,me.tunnelRemotePort);this.forwarded.set(ae,{remotePort:me.tunnelRemotePort,remoteHost:me.tunnelRemoteHost,localAddress:me.localAddress,protocol:ee?.get(me.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.Q(me.localAddress,ee?.get(me.tunnelRemotePort)),localPort:me.tunnelLocalPort,runningProcess:te?.detail,hasRunningProcess:!!te,pid:te?.pid,privacy:me.privacy,source:e.$bJ}),this.f.set(ae,me)}}),this.detected=new Map,this.B(this.z.onTunnelOpened(async V=>{const ee=E(V.tunnelRemoteHost,V.tunnelRemotePort);if(!v(this.forwarded,V.tunnelRemoteHost,V.tunnelRemotePort)&&!v(this.detected,V.tunnelRemoteHost,V.tunnelRemotePort)&&!v(this.c,V.tunnelRemoteHost,V.tunnelRemotePort)&&V.localAddress){const me=v(this.j??new Map,V.tunnelRemoteHost,V.tunnelRemotePort),ae=(await this.getAttributes([{port:V.tunnelRemotePort,host:V.tunnelRemoteHost}]))?.get(V.tunnelRemotePort);this.forwarded.set(ee,{remoteHost:V.tunnelRemoteHost,remotePort:V.tunnelRemotePort,localAddress:V.localAddress,protocol:ae?.protocol??D.TunnelProtocol.Http,localUri:await this.Q(V.localAddress,ae),localPort:V.tunnelLocalPort,closeable:!0,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:V.privacy,source:e.$bJ})}await this.U(),this.f.set(ee,V),this.g.fire(this.forwarded.get(ee))})),this.B(this.z.onTunnelClosed(V=>this.P(V,n.Other))),this.O()}N(){return this.L.extensions.find(N=>N.activationEvents?.includes(e.$$I))?(this.M.createKey(e.$_I.key,!0),!0):!1}O(){if(this.N())return;const N=this.B(this.L.onDidRegisterExtensions(()=>{this.N()&&N.dispose()}))}async P(N,M){const z=E(N.host,N.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.U(),this.h.fire(N))}Q(N,M){if(N.startsWith("http"))return S.URI.parse(N);const z=M?.protocol??"http";return S.URI.parse(`${z}://${N}`)}async R(){const N=this.H.getWorkspace(),M=N.configuration?(0,A.$ni)(N.configuration.path):N.folders.length>0?(0,A.$ni)(N.folders[0].uri.path):void 0;if(M===void 0){this.I.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${o}.${this.F.remoteAuthority}.${M}`}async S(){const N=this.C.get(o,1);if(N)return this.C.remove(o,1),await this.U(),N;const M=await this.R();if(M)return this.C.get(M,0)}async restoreForwarded(){if(this.D.getValue("remote.restoreForwardedPorts")){const N=await this.m;if(N&&N!==this.s){const M=JSON.parse(N)??[];this.I.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(z=>z.remotePort).join(", ")}`);for(const z of M){const j=v(this.detected,z.remoteHost,z.remotePort);z.source.source!==a.Extension&&!j||z.source.source===a.Extension&&j?await this.Y({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,privacy:z.privacy,elevateIfNeeded:!0,source:z.source}):z.source.source===a.Extension&&!j&&this.v.set(E(z.remoteHost,z.remotePort),z)}}}if(this.t=!0,this.u.fire(),!this.r){const N=await this.R();this.r=this.B(new m.$lb),this.r.add(this.C.onDidChangeValue(0,void 0,this.r)(async M=>{M.key===N&&(this.m=Promise.resolve(this.C.get(N,0)),await this.restoreForwarded())}))}}async U(){if(this.D.getValue("remote.restoreForwardedPorts")){const N=JSON.stringify(Array.from(this.forwarded.values()));if(N!==this.s){this.s=N;const M=await this.R();M&&this.C.store(M,this.s,0,0)}}}async X(N,M,z){if(!N.tunnelLocalPort||!z?.requireLocalPort||N.tunnelLocalPort===M)return;const j=new Date;if(this.W.getTime()+t>j.getTime())return;this.W=j;const F=C.localize(3,null,M,N.tunnelRemotePort,N.tunnelLocalPort);return this.J.info(F)}async forward(N,M){return!this.t&&this.F.remoteAuthority&&await R.Event.toPromise(this.u.event),this.Y(N,M)}async Y(N,M){await this.L.activateByEvent(e.$$I);const z=v(this.forwarded,N.remote.host,N.remote.port);M=M??(M!==null?(await this.getAttributes([N.remote]))?.get(N.remote.port):void 0);const j=N.local!==void 0?N.local:N.remote.port;let F;if(z)return this.$(z,N,M);{const K=this.F.remoteAuthority,H=K?{getAddress:async()=>(await this.G.resolveAuthority(K)).authority}:void 0,$e=E(N.remote.host,N.remote.port);this.c.set($e,!0),N=this.Z($e,N);const _=await this.z.openTunnel(H,N.remote.host,N.remote.port,void 0,j,N.elevateIfNeeded?N.elevateIfNeeded:M?.elevateIfNeeded,N.privacy,M?.protocol);if(typeof _=="string")F=_;else if(_&&_.localAddress){const Q=v(this.j??new Map,N.remote.host,N.remote.port),V=_.protocol?_.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:M?.protocol??D.TunnelProtocol.Http,ee={remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localPort:_.tunnelLocalPort,name:M?.label??N.name,closeable:!0,localAddress:_.localAddress,protocol:V,localUri:await this.Q(_.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:N.source??e.$bJ,privacy:_.privacy};return this.forwarded.set($e,ee),this.f.set($e,_),this.c.delete($e),await this.U(),await this.X(_,j,M),this.g.fire(ee),_}this.c.delete($e)}return F}Z(N,M){const z=this.v.has(N)?this.v:this.w.has(N)?this.w:void 0;if(z){const j=z.get(N);z.delete(N),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async $(N,M,z){const j=z?.label??M.name;let F;(function(H){H[H.None=0]="None",H[H.Fire=1]="Fire",H[H.Reopen=2]="Reopen"})(F||(F={}));let K=F.None;switch(j!==N.name&&(N.name=j,K=F.Fire),(z?.protocol||N.protocol!==D.TunnelProtocol.Http)&&z?.protocol!==N.protocol&&(M.source=N.source,K=F.Reopen),M.privacy&&N.privacy!==M.privacy&&(K=F.Reopen),K){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(N.remoteHost,N.remotePort,n.User),await this.Y(M,z)}return v(this.f,M.remote.host,M.remote.port)}async name(N,M,z){const j=v(this.forwarded,N,M),F=E(N,M);if(j){j.name=z,await this.U(),this.i.fire({host:N,port:M});return}else this.detected.has(F)&&(this.detected.get(F).name=z,this.i.fire({host:N,port:M}))}async close(N,M,z){const j=E(N,M),F=this.forwarded.get(j);return z===n.AutoForwardEnd&&F&&F.source.source===a.Auto&&this.w.set(j,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.z.closeTunnel(N,M),this.P({host:N,port:M},z)}address(N,M){const z=E(N,M);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.p}addEnvironmentTunnels(N){if(N)for(const M of N){const z=v(this.j??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:E(M.localAddress.host,M.localAddress.port);this.detected.set(E(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:D.TunnelProtocol.Http,localUri:this.Q(j),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:a.Extension,description:C.localize(4,null)}}),this.z.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.p=!0,this.n.fire(),this.g.fire()}setCandidateFilter(N){this.l=N}async setCandidates(N){let M=N;this.l&&(M=await this.l(N));const z=this.ab(M);this.I.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(j=>j.port).join(", ")}`),this.k.fire(z)}ab(N){const M=this.j??new Map,z=new Map;return this.j=z,N.forEach(j=>{const F=E(j.host,j.port);z.set(F,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(F)&&M.delete(F);const K=v(this.forwarded,j.host,j.port);K&&(K.runningProcess=j.detail,K.hasRunningProcess=!0,K.pid=j.pid)}),M.forEach((j,F)=>{const K=c(F);if(!K)return;const H=v(this.forwarded,K.host,K.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0);const $e=v(this.detected,K.host,K.port);$e&&($e.runningProcess=void 0,$e.hasRunningProcess=!1,$e.pid=void 0)}),M}get candidates(){return this.j?Array.from(this.j.values()):[]}get candidatesOrUndefined(){return this.j?this.candidates:void 0}async bb(){const N=Array.from(this.forwarded.values()),M=await this.getAttributes(N.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(M)for(const z of N){const j=M.get(z.remotePort);(j?.protocol||z.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==z.protocol&&await this.Y({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},j),j&&j.label&&j.label!==z.name&&await this.name(z.remoteHost,z.remotePort,j.label)}}async getAttributes(N,M=!0){const z=new Map,j=new Map;N.forEach(_=>{const Q=v(this.j??new Map,D.$Wz[0],_.port)??_;if(Q){z.set(_.port,Q);const V=h(Q)?Q.pid:void 0;j.has(V)||j.set(V,[]),j.get(V)?.push(_.port)}});const F=new Map;if(N.forEach(_=>{const Q=this.configPortsAttributes.getAttributes(_.port,_.host,z.get(_.port)?.detail);Q&&F.set(_.port,Q)}),this.y.length===0||!M)return F.size>0?F:void 0;const K=await Promise.all((0,T.$Kf)(this.y.map(_=>Array.from(j.entries()).map(Q=>{const V=Q[1],ee=z.get(V[0]);return _.providePortAttributes(V,ee?.pid,ee?.detail,new s.$rc().token)})))),H=new Map;if(K.forEach(_=>_.forEach(Q=>{Q&&H.set(Q.port,Q)})),!F&&!H)return;const $e=new Map;return N.forEach(_=>{const Q=F.get(_.port),V=H.get(_.port);$e.set(_.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??w.providedActionToAction(V?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),$e}addAttributesProvider(N){this.y.push(N)}};e.$iJ=L,Ke([(0,f.$5g)(1e3)],L.prototype,"U",null),e.$iJ=L=Ke([Be(0,D.$Sz),Be(1,k.$So),Be(2,$.$6h),Be(3,r.$0I),Be(4,p.$Hk),Be(5,y.$Ih),Be(6,I.$3i),Be(7,P.$kA),Be(8,i.$IF),Be(9,g.$1i)],L)}),define(De[93],Ce([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$H=e.$0H=void 0;class C{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new C(0,0)}with(A){return new C(0,0)}}e.$0H=C;class T{constructor(A,m,S,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,m),this.end=new C(S,$)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$$H=T;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(De[36],Ce([1,0,19,35,23,32,15,5,16,8,93,11]),function(be,e,C,T,f,R,A,m,S,$,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.SearchErrorCode=e.$nI=e.$mI=e.SearchSortOrder=e.ViewMode=e.$lI=e.$kI=e.$jI=e.$iI=e.SearchCompletionExitCode=e.$hI=e.$gI=e.$fI=e.QueryType=e.SearchProviderType=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$_H="workbench.view.search",e.$aI="workbench.panel.search",e.$bI="workbench.view.search",e.$cI="search-result",e.$dI="search.exclude";const p="\u27EA ",k=" characters skipped \u27EB",D=(p.length+k.length+5)*2;e.$eI=(0,m.$zh)("searchService");var y;(function(V){V[V.file=0]="file",V[V.text=1]="text"})(y||(e.SearchProviderType=y={}));var r;(function(V){V[V.File=1]="File",V[V.Text=2]="Text"})(r||(e.QueryType=r={}));function i(V){return!!V.preview}e.$fI=i;function s(V){return!!V.resource}e.$gI=s;function d(V){return!!V.message}e.$hI=d;var b;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(b||(e.SearchCompletionExitCode=b={}));class g{constructor(ee){this.resource=ee,this.results=[]}}e.$iI=g;class t{constructor(ee,me,ae,te){this.ranges=me,this.webviewIndex=te;const X=Array.isArray(me)?me:[me];if(ae&&ae.matchLines===1&&o(X)){ee=(0,A.$ee)(ee,ae.matchLines);let U="",q=0,G=0;const ce=Math.floor(ae.charsPerLine/5),re=[];for(const de of X){const Ee=Math.max(de.startColumn-ce,0),he=de.startColumn+ae.charsPerLine;if(Ee>G+ce+D){const ge=p+(Ee-G)+k;U+=ge+ee.slice(Ee,he),q+=Ee-(G+ge.length)}else U+=ee.slice(G,he);re.push(new n(0,de.startColumn-q,de.endColumn-q)),G=he}this.preview={text:U,matches:Array.isArray(this.ranges)?re:re[0]}}else{const U=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:ee,matches:(0,C.$Uf)(me,q=>new c(q.startLineNumber-U,q.startColumn,q.endLineNumber-U,q.endColumn))}}}}e.$jI=t;function o(V){const ee=V[0].startLineNumber;for(const me of V)if(me.startLineNumber!==ee||me.endLineNumber!==ee)return!1;return!0}class c{constructor(ee,me,ae,te){this.startLineNumber=ee,this.startColumn=me,this.endLineNumber=ae,this.endColumn=te}}e.$kI=c;class n extends c{constructor(ee,me,ae){super(ee,me,ee,ae)}}e.$lI=n;var a;(function(V){V.List="list",V.Tree="tree"})(a||(e.ViewMode=a={}));var l;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function v(V,ee=!0){const me=V&&V.files&&V.files.exclude,ae=ee&&V&&V.search&&V.search.exclude;if(!me&&!ae)return;if(!me||!ae)return me||ae;let te=Object.create(null);return te=f.$Wm(te,f.$Tm(me)),te=f.$Wm(te,f.$Tm(ae),!0),te}e.$mI=v;function E(V,ee){return V.excludePattern&&T.$oj(V.excludePattern,ee)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&T.$oj(V.includePattern,ee)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(me=>{const ae=me.folder.fsPath;if(R.$Ke(ee,ae)){const te=S.$ad(ae,ee);return!me.includePattern||!!T.$oj(me.includePattern,te)}else return!1}):!1:!0}e.$nI=E;var u;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class h extends Error{constructor(ee,me){super(ee),this.code=me}}e.$oI=h;function w(V){const ee=V.message;if((0,$.$2)(V))return new h(ee,u.canceled);try{const me=JSON.parse(ee);return new h(me.message,me.code)}catch{return new h(ee,u.other)}}e.$pI=w;function L(V){const ee={message:V.message,code:V.code};return new Error(JSON.stringify(ee))}e.$qI=L;function O(V){return V.type==="error"?!0:V.type==="success"}e.$rI=O;function N(V){return V.type==="success"}e.$sI=N;function M(V){return!!V.path}e.$tI=M;function z(V,ee){const me=V.searchPath?V.searchPath:V.relativePath;return(0,A.$be)(me,ee)}e.$uI=z;class j{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vI=j;function F(V,ee){const me={...V||{},...ee||{}};return Object.keys(me).filter(ae=>{const te=me[ae];return typeof te=="boolean"&&te})}e.$wI=F;class K{constructor(ee,me){this.c=null,this.a={...ee.excludePattern||{},...me.excludePattern||{}},this.b=T.$pj(this.a);let ae=ee.includePattern;me.includePattern&&(ae?ae={...ae,...me.includePattern}:ae=me.includePattern),ae&&(this.c=T.$pj(ae))}matchesExcludesSync(ee,me,ae){return!!(this.b&&this.b(ee,me,ae))}includedInQuerySync(ee,me,ae){return!(this.b&&this.b(ee,me,ae)||this.c&&!this.c(ee,me,ae))}includedInQuery(ee,me,ae){const te=this.b(ee,me,ae),X=()=>this.c?!!this.c(ee,me,ae):!0;return(0,I.$rg)(te)?te.then(U=>U?!1:X()):X()}hasSiblingExcludeClauses(){return H(this.a)}}e.$xI=K;function H(V){for(const ee in V)if(typeof V[ee]!="boolean")return!0;return!1}function $e(V){if(!V)return;let ee;return me=>(ee||(ee=(V()||Promise.resolve([])).then(ae=>ae?Q(ae):{})),ee.then(ae=>!!ae[me]))}e.$yI=$e;function _(V){if(!V)return;let ee;return me=>{if(!ee){const ae=V();ee=ae?Q(ae):{}}return!!ee[me]}}e.$zI=_;function Q(V){const ee={};for(const me of V)ee[me]=!0;return ee}}),define(De[39],Ce([1,0,19,11,21,4,3,77,17,120,24,15,2,214,5,14,243,43,54,26,20,13,7,66,36,6]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0;function a(O,N,M){return new P.$8f(z=>u(z,M)).isEqual(O,N)}function l(O,N,M){return a(O.uri,N.uri,M)?0:(0,I.$Hd)(O.uri.toString(),N.uri.toString())}function v(O,N,M){return O.index!==N.index?O.index<N.index?-1:1:a(O.uri,N.uri,M)?(0,I.$Hd)(O.name,N.name):(0,I.$Hd)(O.uri.toString(),N.uri.toString())}function E(O,N,M,z){const j=O.slice(0).sort((K,H)=>M(K,H,z)),F=N.slice(0).sort((K,H)=>M(K,H,z));return(0,C.$xf)(j,F,(K,H)=>M(K,H,z))}function u(O,N){const M=N.getCapabilities(O.scheme);return!(M&&M&1024)}class h extends i.$Sh{static toExtHostWorkspace(N,M,z,j){if(!N)return{workspace:null,added:[],removed:[]};const{id:F,name:K,folders:H,configuration:$e,transient:_,isUntitled:Q}=N,V=[],ee=M;M?H.forEach((X,U)=>{const q=p.URI.revive(X.uri),G=h.o(z||M,q,j);G?(G.name=X.name,G.index=X.index,V.push(G)):V.push({uri:q,name:X.name,index:U})}):V.push(...H.map(({uri:X,name:U,index:q})=>({uri:p.URI.revive(X),name:U,index:q}))),V.sort((X,U)=>X.index<U.index?-1:1);const me=new h(F,K,V,!!_,$e?p.URI.revive($e):null,!!Q,X=>u(X,j)),{added:ae,removed:te}=E(ee?ee.workspaceFolders:[],me.workspaceFolders,l,j);return{workspace:me,added:ae,removed:te}}static o(N,M,z){for(let j=0;j<N.folders.length;j++){const F=N.workspaceFolders[j];if(a(F.uri,M,z))return F}}constructor(N,M,z,j,F,K,H){super(N,z.map($e=>new i.$Th($e)),j,F,H),this.t=M,this.u=K,this.q=[],this.s=m.$Fh.forUris(H),z.forEach($e=>{this.q.push($e),this.s.set($e.uri,$e)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,M){return M&&this.s.get(N)&&(N=(0,P.$fg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let w=class{constructor(N,M,z,j,F){this.c=new R.$hc,this.onDidChangeWorkspace=this.c.event,this.g=new R.$hc,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$jc,this.B=new Map,this.h=j,this.s=z,this.t=F,this.j=new $.$Hl,this.k=new T.$Dg,this.o=N.getProxy(n.$SJ.MainThreadWorkspace),this.q=N.getProxy(n.$SJ.MainThreadMessageService);const K=M.workspace;this.l=K?new h(K.id,K.name,[],!!K.transient,K.configuration?p.URI.revive(K.configuration):null,!!K.isUntitled,H=>u(H,z)):void 0}$initializeWorkspace(N,M){this.v=M,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:S.Schemas.untitled,path:(0,P.$dg)((0,P.$fg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,M,z,...j){const F=[];if(Array.isArray(j)&&j.forEach(Q=>{p.URI.isUri(Q.uri)&&!F.some(V=>a(V.uri,Q.uri,this.s))&&F.push({uri:Q.uri,name:Q.name||(0,P.$cg)(Q.uri)})}),this.n||[M,z].some(Q=>typeof Q!="number"||Q<0)||z===0&&F.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(M+z>K.length)return!1;const H=K.slice(0);H.splice(M,z,...F.map(Q=>({uri:Q.uri,name:Q.name||(0,P.$cg)(Q.uri),index:void 0})));for(let Q=0;Q<H.length;Q++){const V=H[Q];if(H.some((ee,me)=>me!==Q&&a(V.uri,ee.uri,this.s)))return!1}H.forEach((Q,V)=>Q.index=V);const{added:$e,removed:_}=E(K,H,v,this.s);if($e.length===0&&_.length===0)return!1;if(this.o){const Q=N.displayName||N.name;this.o.$updateWorkspaceFolders(Q,M,z,F).then(void 0,V=>{this.n=void 0;const ee={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(r.Severity.Error,(0,k.localize)(0,null,Q,V.toString()),ee,[])})}return this.y(H),!0}getWorkspaceFolder(N,M){if(this.x)return this.x.getWorkspaceFolder(N,M)}async getWorkspaceFolder2(N,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,M)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,M){let z,j="";if(typeof N=="string"?(z=p.URI.file(N),j=N):typeof N<"u"&&(z=N,j=N.fsPath),!z)return j;const F=this.getWorkspaceFolder(z,!0);if(!F)return j;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let K=(0,P.$ig)(F.uri,z);return M&&F.name&&(K=`${F.name}/${K}`),K}y(N){this.x&&(this.n=h.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:M,added:z,removed:j}=h.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:j}))}findFiles(N,M,z,j,F=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let K;if(M===null?K=!1:M&&(typeof M=="string"?K=M:K=M.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:$e}=L(g.GlobPattern.from(N));return this.o.$startFileSearch(H??null,$e??null,K??null,z??null,F).then(_=>Array.isArray(_)?_.map(Q=>p.URI.revive(Q)):[])}async findTextInFiles(N,M,z,j,F=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),H=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:$e,folder:_}=L(g.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,V={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:H,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:$e,excludePattern:Q},ee=!1;if(this.u[K]=me=>{if(ee)return;const ae=p.URI.revive(me.resource);me.results.forEach(te=>{(0,c.$fI)(te)?z({uri:ae,preview:{text:te.preview.text,matches:(0,C.$Uf)(te.preview.matches,X=>new t.$WJ(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))},ranges:(0,C.$Uf)(te.ranges,X=>new t.$WJ(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))}):z({uri:ae,text:te.text,lineNumber:te.lineNumber})})},F.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(N,_??null,V,K,F);return delete this.u[K],me||{}}catch(me){throw delete this.u[K],me}}$handleTextSearchResult(N,M){this.u[M]?.(N)}async save(N){const M=await this.o.$save(N,{saveAs:!1});return p.URI.revive(M)}async saveAs(N){const M=await this.o.$save(N,{saveAs:!0});return p.URI.revive(M)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,M){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,M);const z=this.t.transformOutgoingScheme(N),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,z),(0,A.$kb)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(N,M){this.h.info("Getting edit session identifier for workspaceFolder",N);const z=await this.resolveWorkspaceFolder(p.URI.revive(N));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const F=await j.provideEditSessionIdentity(z,M);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(N,M,z,j){this.h.info("Getting edit session identifier for workspaceFolder",N);const F=await this.resolveWorkspaceFolder(p.URI.revive(N));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const H=await K.provideEditSessionIdentityMatch?.(M,z,j);if(this.h.info("Provider returned edit session identifier match result: ",H),!!H)return H}getOnWillCreateEditSessionIdentityEvent(N){return(M,z,j)=>{const F=function(H){M.call(z,H)};return F.extension=N,this.A.event(F,void 0,j)}}async $onWillCreateEditSessionIdentity(N,M,z){const j=await this.resolveWorkspaceFolder(p.URI.revive(N));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},M,async(F,K)=>{const H=Date.now();await Promise.resolve(F),Date.now()-H>z&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(N,M){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,M);const z=this.t.transformOutgoingScheme(N),j=this.z++;return this.o.$registerCanonicalUriProvider(j,z),(0,A.$kb)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(N,M,z){const j=this.B.get(N.scheme);if(!j)return;const F=await j.provideCanonicalUri?.(p.URI.revive(N),M,z);if(F)return F}async $provideCanonicalUri(N,M,z){return this.provideCanonicalUri(p.URI.revive(N),{targetScheme:M},z)}};e.$Vac=w,e.$Vac=w=Ke([Be(0,b.$UL),Be(1,d.$$L),Be(2,s.$Jac),Be(3,y.$3i),Be(4,o.$Tac)],w),e.$Wac=(0,D.$zh)("IExtHostWorkspace");function L(O){let N,M;return O&&(typeof O=="string"?N=O:(N=O.pattern,M=p.URI.revive(O.baseUri))),{includePattern:N,folder:M}}}),define(De[40],Ce([1,0,23,4,39,6,7,245,136,18,11,5,20,14,2]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=e.$Xac=void 0;function y(o,c){if(c){const n=c.split(".");let a=o;for(let l=0;a&&l<n.length;l++)a=a[n[l]];return a}}function r(o){return o instanceof D.URI}function i(o){return o&&o.uri instanceof D.URI&&o.languageId&&typeof o.languageId=="string"}function s(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function d(o){return o&&o.uri instanceof D.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function b(o){if(r(o))return{resource:o};if(i(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(s(o))return{overrideIdentifier:o.languageId};if(d(o))return{resource:o.uri};if(o===null)return{resource:null}}let g=class{constructor(c,n,a){this.a=c.getProxy(R.$SJ.MainThreadConfiguration),this.c=n,this.b=a,this.d=new P.$Dg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(c,n))}};e.$Xac=g,e.$Xac=g=Ke([Be(0,p.$UL),Be(1,f.$Wac),Be(2,k.$3i)],g);class t{constructor(c,n,a,l){this.a=new T.$hc,this.b=c,this.f=l,this.c=n,this.e=m.$rn.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,n){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$rn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(n,a))}getConfiguration(c,n,a){const l=b(n)||{},v=this.g(c?y(this.e.getValue(void 0,l,this.c.workspace),c):this.e.getValue(void 0,l,this.c.workspace));c&&this.h(c,l,a?.identifier);function E(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(h){return typeof y(v,h)<"u"},get:(h,w)=>{this.h(c?`${c}.${h}`:h,l,a?.identifier);let L=y(v,h);if(typeof L>"u")L=w;else{let O;const N=(M,z)=>{if((0,$.$ne)(M)){let j;const F=()=>{O=O||(0,C.$Tm)(v),j=j||y(O,z)};return new Proxy(M,{get:(K,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return F(),()=>j;if(O)return j=j||y(O,z),j[H];const $e=K[H];return typeof H=="string"?N($e,`${z}.${H}`):$e},set:(K,H,$e)=>(F(),j&&(j[H]=$e),!0),deleteProperty:(K,H)=>(F(),j&&delete j[H],!0),defineProperty:(K,H,$e)=>(F(),j&&Object.defineProperty(j,H,$e),!0)})}return Array.isArray(M)?(0,C.$Tm)(M):M};L=N(L,h)}return L},update:(h,w,L,O)=>{h=c?`${c}.${h}`:h;const N=E(L);return w!==void 0?this.b.$updateConfigurationOption(N,h,w,l,O):this.b.$removeConfigurationOption(N,h,l,O)},inspect:h=>{h=c?`${c}.${h}`:h;const w=this.e.inspect(h,l,this.c.workspace);if(w)return{key:h,defaultValue:(0,C.$Tm)(w.policy?.value??w.default?.value),globalValue:(0,C.$Tm)(w.user?.value??w.application?.value),workspaceValue:(0,C.$Tm)(w.workspace?.value),workspaceFolderValue:(0,C.$Tm)(w.workspaceFolder?.value),defaultLanguageValue:(0,C.$Tm)(w.default?.override),globalLanguageValue:(0,C.$Tm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,C.$Tm)(w.workspace?.override),workspaceFolderLanguageValue:(0,C.$Tm)(w.workspaceFolder?.override),languageIds:(0,C.$Tm)(w.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$Wm)(u,v,!1),Object.freeze(u)}g(c){const n=a=>(0,$.$ne)(a)?new Proxy(a,{get:(l,v)=>n(l[v]),set:(l,v,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(l,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(l,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(c)}h(c,n,a){const l=S.$in.test(c)?4:this.d.get(c),v=a?`[${a.value}] `:"";if(l===4){typeof n?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){n?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,n){const a=new m.$tn(c,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,v)=>a.affectsConfiguration(l,b(v))})}k(c){return c.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.$Yac=t,e.$Zac=(0,I.$zh)("IExtHostConfiguration")}),define(De[94],Ce([1,0,2,11,4,6,7,39,69,40,21,44,20,26,5,17,12,14,90,291,8]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=e.$Vbc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var g;(function(N){function M(j){if(j!=null)return j}N.from=M;function z(j){if(j!=null)return j}N.to=z})(g||(g={}));var t;(function(N){function M(j){if(j!=null)return j}N.from=M;function z(j){if(j!=null)return j}N.to=z})(t||(t={}));var o;(function(N){function M(j){if(j!=null)return j}N.from=M;function z(j){if(j!=null)return j}N.to=z})(o||(o={}));var c;(function(N){function M(F){if(F){const K=F;return K&&!!K.process}else return!1}N.is=M;function z(F){if(F==null)return;const K={process:F.process,args:F.args};return F.options&&(K.options=o.from(F.options)),K}N.from=z;function j(F){if(F!=null)return new A.$DK(F.process,F.args,F.options)}N.to=j})(c||(c={}));var n;(function(N){function M(j){if(j!=null)return j}N.from=M;function z(j){if(j!=null)return j}N.to=z})(n||(n={}));var a;(function(N){function M(F){if(F){const K=F;return K&&(!!K.commandLine||!!K.command)}else return!1}N.is=M;function z(F){if(F==null)return;const K={};return F.commandLine!==void 0?K.commandLine=F.commandLine:(K.command=F.command,K.args=F.args),F.options&&(K.options=n.from(F.options)),K}N.from=z;function j(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$EK(F.commandLine,F.options):new A.$EK(F.command,F.args?F.args:[],F.options)}N.to=j})(a||(a={}));var l;(function(N){function M(F){if(F){const K=F;return K&&K.customExecution==="customExecution"}else return!1}N.is=M;function z(F){return{customExecution:"customExecution"}}N.from=z;function j(F,K){return K.get(F)}N.to=j})(l||(e.CustomExecutionDTO=l={}));var v;(function(N){function M(z,j){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?F=j.workspaceFile:F=d.$8F),{id:z._id,workspaceFolder:F}}N.from=M})(v||(e.TaskHandleDTO=v={}));var E;(function(N){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}N.from=M})(E||(E={}));var u;(function(N){function M(F,K){if(F==null)return[];const H=[];for(const $e of F){const _=z($e,K);_&&H.push(_)}return H}N.fromMany=M;function z(F,K){if(F==null)return;let H;F.execution instanceof A.$DK?H=c.from(F.execution):F.execution instanceof A.$EK?H=a.from(F.execution):F.execution&&F.execution instanceof A.$FK&&(H=l.from(F.execution));const $e=g.from(F.definition);let _;return F.scope?typeof F.scope=="number"?_=F.scope:_=F.scope.uri:_=A.TaskScope.Workspace,!$e||!_?void 0:{_id:F._id,definition:$e,name:F.name,source:{extensionId:K.identifier.value,label:F.source,scope:_},execution:H,isBackground:F.isBackground,group:E.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}N.from=z;async function j(F,K,H){if(F==null)return;let $e;c.is(F.execution)?$e=c.to(F.execution):a.is(F.execution)?$e=a.to(F.execution):l.is(F.execution)&&($e=l.to(F._id,H));const _=g.to(F.definition);let Q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Q=F.source.scope:Q=await K.resolveWorkspaceFolder(C.URI.revive(F.source.scope)):Q=A.TaskScope.Workspace),!_||!Q)return;const V=new A.$GK(_,Q,F.name,F.source.label,$e,F.problemMatchers);return F.isBackground!==void 0&&(V.isBackground=F.isBackground),F.group!==void 0&&(V.group=A.$CK.from(F.group._id),V.group&&F.group.isDefault&&(V.group=new A.$CK(V.group.id,V.group.label),F.group.isDefault===!0&&(V.group.isDefault=F.group.isDefault))),F.presentationOptions&&(V.presentationOptions=t.to(F.presentationOptions)),F._id&&(V._id=F._id),F.detail&&(V.detail=F.detail),V}N.to=j})(u||(e.TaskDTO=u={}));var h;(function(N){function M(j){return j}N.from=M;function z(j){if(j)return Object.assign(Object.create(null),j)}N.to=z})(h||(h={}));class w{#e;constructor(M,z,j){this._id=z,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let L=class{constructor(M,z,j,F,K,H,$e,_){this.q=new f.$hc,this.r=new f.$hc,this.s=new f.$hc,this.t=new f.$hc,this.a=M.getProxy(R.$SJ.MainThreadTask),this.b=j,this.c=F,this.d=K,this.e=H,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,j){if(!j)return new A.$UJ(()=>{});const F=this.w();return this.j.set(F,{type:z,provider:j,extension:M}),this.a.$registerTaskProvider(F,z),new A.$UJ(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,z){this.a.$registerTaskSystem(M,z)}fetchTasks(M){return this.a.$fetchTasks(h.from(M)).then(async z=>{const j=[];for(const F of z){const K=await u.to(F,this.b,this.m);K&&j.push(K)}return j})}get taskExecutions(){const M=[];return this.k.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,z,j){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(z,await F.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const z=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const z=await this.y(M.id);this.s.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const z=await this.y(M.id);this.t.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const F=[],K=(0,T.$xg)(()=>j.provider.provideTasks(P.CancellationToken.None)).then(H=>this.u(z,F,j,H));return new Promise(H=>{K.then($e=>{Promise.all(F).then(()=>{H($e)})})})}async $resolveTask(M,z){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(z.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${j.type}].`);const F=await u.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const K=await j.provider.resolveTask(F,P.CancellationToken.None);if(!K)return;this.z(K,j);const H=u.from(K,j.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(H.execution)&&await this.x(H,K,!0),await this.v(H)}w(){return this.h++}async x(M,z,j){const F=await this.a.$createTaskId(M);!j&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async y(M,z){if(typeof M=="string"){const K=this.l.get(M);if(!K)throw new b.$_("Unexpected: The specified task is missing an execution");return K}const j=this.l.get(M.id);if(j)return j;const F=new Promise((K,H)=>{function $e(_,Q,V){V?K(new w(_,Q.id,V)):H("Unexpected: Task does not exist.")}z?$e(this,M,z):u.to(M.task,this.b,this.m).then(_=>$e(this,M,_))});return this.l.set(M.id,F),F.then(K=>(this.k.set(M.id,K),K),K=>Promise.reject(K))}z(M,z){M._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let F=j.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=j.next()}};e.$Vbc=L,e.$Vbc=L=Ke([Be(0,p.$UL),Be(1,k.$$L),Be(2,m.$Wac),Be(3,S.$6L),Be(4,$.$Zac),Be(5,I.$fbc),Be(6,i.$3i),Be(7,s.$Mac)],L);let O=class extends L{constructor(M,z,j,F,K,H,$e,_){super(M,z,j,F,K,H,$e,_),this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const j=u.from(z,M);if(j===void 0)throw new Error("Task is not valid");if(l.is(j.execution))await this.x(j,z,!1);else throw new b.$0;const F=await this.y(await this.a.$getTaskExecution(j),z);return this.a.$executeTask(j).catch(K=>{throw new Error(K)}),F}u(M,z,j,F){const K=[];if(F)for(const H of F){this.z(H,j),(!H.definition||!M[H.definition.type])&&this.f.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const $e=u.from(H,j.extension);$e&&l.is($e.execution)?(K.push($e),z.push(this.x($e,H,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:j.extension}}async v(M){if(l.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,j){}};e.$Wbc=O,e.$Wbc=O=Ke([Be(0,p.$UL),Be(1,k.$$L),Be(2,m.$Wac),Be(3,S.$6L),Be(4,$.$Zac),Be(5,I.$fbc),Be(6,i.$3i),Be(7,s.$Mac)],O),e.$Xbc=(0,D.$zh)("IExtHostTask")}),define(De[346],Ce([1,0,16,21,46,35,24,37,36]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;class ${constructor(p,k,D){this.k=p,this.l=k,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&R.$pj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&R.$pj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const k=this.k.folderQueries||[];return new Promise((D,y)=>{const r=i=>{this.f++,p(i)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const s=i.toString(),d=C.$cd(s);this.j&&this.j(s,d)||this.v(r,{base:i,basename:d})}),Promise.all(k.map(i=>this.p(i,r))).then(i=>{D({limitHit:this.e,stats:i[0]||void 0})},i=>{y(new Error((0,f.$ki)(i)))})})}async p(p,k){const D=new T.$rc,y=this.q(p),r=this.r(),i=new S.$xI(this.k,p),s=!i.hasSiblingExcludeClauses();let d;try{this.h.add(D),d=m.$dc.create();const b=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},y,D.token),g=d.elapsed(),t=m.$dc.create();return this.g&&!this.e||(b&&b.forEach(o=>{const c=C.$8c.relative(p.folder.path,o.path);if(s){const n=C.$cd(o.path);this.v(k,{base:p.folder,relativePath:c,basename:n});return}this.s(r,p.folder,c,k)}),this.g&&!this.e)?null:(this.u(r,i,k),{providerTime:g,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(p){const k=(0,S.$wI)(this.k.includePattern,p.includePattern),D=(0,S.$wI)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:k,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},k,D,y){if(D===this.a){const i=C.$cd(this.a);this.v(y,{base:k,relativePath:this.a,basename:i})}function r(i){const s=C.$cd(i),d=C.$bd(i);let b=p[d];b||(b=p[d]=[],r(d)),b.push({base:k,relativePath:i,basename:s})}r(D)}u({rootEntries:p,pathToEntries:k},D,y){const r=this,i=this.a;function s(d){const b=(0,S.$zI)(()=>d.map(g=>g.basename));for(let g=0,t=d.length;g<t;g++){const o=d[g],{relativePath:c,basename:n}=o;if(D.matchesExcludesSync(c,n,i!==n?b:void 0))continue;const a=k[c];if(a)s(a);else{if(c===i)continue;r.v(y,o)}if(r.e)break}}s(p)}v(p,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(k))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,k,D,y){const r=this.c(p.cacheKey),i=new $(p,k,r&&r.token);let s=0;const d=b=>{s+=b.length,D(b.map(g=>this.d(g)))};return this.e(i,P.a,d,y).then(b=>({limitHit:b.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:s,detailStats:b.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new T.$rc),this.b.get(p)}d(p){return p.relativePath?{resource:A.$gg(p.base,p.relativePath)}:{resource:p.base}}e(p,k,D,y){const r=y.onCancellationRequested(()=>{p.cancel()}),i=d=>{d&&(s.push(d),k>0&&s.length>=k&&(D(s),s=[]))};let s=[];return p.search(i).then(d=>(s.length&&D(s),r.dispose(),d),d=>(s.length&&D(s),r.dispose(),Promise.reject(d)))}}e.$8bc=P}),define(De[347],Ce([1,0,19,73,35,100,28,17,16,24,15,18,2,172,226,49,14,43,143,344,36]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.$qJ=void 0;let g=class{constructor(h,w,L,O,N){this.a=h,this.b=w,this.c=L,this.d=O,this.e=N}text(h,w,L={}){h=this.f(h,L);const O=this.a.getValue(),N=w&&w.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(w?.map(i.$Uh),L),type:2,contentPattern:h,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:O.search.usePCRE2||N||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(h,w){const L=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const O={...h,wordSeparators:L.editor.wordSeparators};return this.j(h,w)&&(O.isCaseSensitive=!0),this.k(h)&&(O.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),O}file(h,w={}){return{...this.h(h,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(h,w){return h?(h=Array.isArray(h)?h.map(a):a(h),w?this.parseSearchPaths(h):{pattern:o(...Array.isArray(h)?h:[h])}):{}}h(h=[],w={}){const L=this.g(w.includePattern,w.expandPatterns),O=this.g(w.excludePattern,w.expandPatterns),N=h.length>1,M=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,w,O)):h.map(F=>this.r(F,w,O,N))).filter(F=>!!F),z={_reason:w._reason,folderQueries:M,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:O.pattern,includePattern:L.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const F=C.$Af(C.$Kf(this.c.groups.map($e=>$e.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const K=F.filter($e=>(0,b.$nI)(z,$e.fsPath)),H=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...z,...H}}const j=w.extraFileResources&&w.extraFileResources.filter(F=>(0,b.$nI)(z,F.fsPath));return z.extraFileResources=j&&j.length?j:void 0,z}i(h){const w=[],L=new A.$xi,O={};let N=!1;return h.forEach(M=>{if(M.scheme===m.Schemas.walkThrough)return;if((0,$.$kg)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:S.$bd(M.fsPath)});let F=L.get(j);F||(N=!0,F={folder:j,includePattern:{}},w.push(F),L.set(j,F));const K=S.$ad(j.fsPath,M.fsPath);(0,I.$we)(F.includePattern)[K.replace(/\\/g,"/")]=!0}else M.fsPath&&(N=!0,O[M.fsPath]=!0)}),{folderQueries:w,includePattern:O,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(h,w){if(w.isSmartCase){if(h.isRegExp){if(P.$ce(h.pattern,!0))return!0}else if(P.$ce(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,k.$eC)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const w=H=>S.$0c(H)||/^\.\.?([\/\\]|$)/.test(H),O=(Array.isArray(h)?h:c(h)).map(H=>{const $e=this.e.resolvedUserHome;return $e?(0,R.$dA)(H,$e.scheme===m.Schemas.file?$e.fsPath:$e.path):H}),N=T.$I(O,H=>w(H)?"searchPaths":"exprSegments"),M=(N.exprSegments||[]).map(H=>P.$xd(H,"/")).map(H=>P.$xd(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),n(H))),z={},j=this.m(N.searchPaths||[]);j&&j.length&&(z.searchPaths=j);const F=C.$Kf(M),K=o(...F);return K&&(z.pattern=K),z}l(h,w){return w.disregardExcludeSettings?void 0:(0,b.$mI)(h,!w.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const w=h.flatMap(O=>{let{pathPortion:N,globPortion:M}=t(O);return M&&(M=l(M)),this.n(N).flatMap(j=>this.o(j,M))}),L=new Map;return w.forEach(O=>{const N=O.searchPath.toString(),M=L.get(N);M?O.pattern&&(M.pattern=M.pattern||{},M.pattern[O.pattern]=!0):L.set(N,{searchPath:O.searchPath,pattern:O.pattern?o(O.pattern):void 0})}),Array.from(L.values())}n(h){if(S.$0c(h)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:h})}]:[{searchPath:p.URI.file(S.$9c(h))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(h=a(h),h.startsWith("../")||h===".."){const O=S.$8c.resolve(w.path,h);return[{searchPath:w.with({path:O})}]}const L=l(h);return[{searchPath:w,pattern:L}]}else{if(h==="./"||h===".\\")return[];{const w=h.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(N=>{const M=w.match(new RegExp(`^${P.$sd(N.name)}(?:/(.*)|$)`));return M?{match:M,folder:N}:null}).filter(I.$te);if(O.length)return O.map(N=>{const M=N.match[1];return{searchPath:N.folder.uri,pattern:M&&l(M)}});{const N=h.match(/\.[\/\\](.+)[\/\\]?/),M=N?N[1]:h,z=D.localize(0,null,M);throw new Error(z)}}}}o(h,w){const L=h.pattern&&w?`${h.pattern}/${w}`:h.pattern||w,O=[{searchPath:h.searchPath,pattern:L}];return L&&!L.endsWith("**")&&O.push({searchPath:h.searchPath,pattern:L+"/**"}),O}q(h,w,L){const O=this.r((0,i.$Uh)(h.searchPath),w,L,!1);return O?{...O,includePattern:h.pattern}:null}r(h,w,L,O){let N;const M=p.URI.isUri(h)?h:h.uri;if(L.searchPaths){const H=L.searchPaths.filter($e=>(0,$.$_f)($e.searchPath,M))[0];if(H&&!H.pattern)return null;H&&(N=H.pattern)}const z=this.a.getValue({resource:M}),F={...this.l(z,w)||{},...N||{}},K=p.URI.isUri(h)?(0,$.$dg)(h):h.name;return{folder:M,folderName:O?K:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!z.search.followSymlinks}}};e.$qJ=g,e.$qJ=g=Ke([Be(0,y.$6h),Be(1,i.$Ih),Be(2,s.$1C),Be(3,r.$3i),Be(4,d.$oJ)],g);function t(u){const h=u.match(/[\*\{\}\(\)\[\]\?]/);if(h){const w=h.index,L=u.substr(0,w).match(/[/|\\][^/\\]*$/);if(L){let O=u.substr(0,L.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:u.substr((L.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((h,w)=>(h[w]=!0,h),Object.create(null)):void 0}function c(u){return f.$nj(u,",").map(h=>h.trim()).filter(h=>!!h.length)}function n(u){return[`**/${u}/**`,`**/${u}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function a(u){return u.replace(/\\/g,"/")}function l(u){return a(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(u){return u.replace(/([?*[\]])/g,"[$1]")}function E(u,h){u=C.$Ff(u,O=>O.toString());const w=[],L=h.getWorkspace();return u&&u.forEach(O=>{let N;if(h.getWorkbenchState()===2)N=(0,$.$ig)(L.folders[0].uri,O),N&&N!=="."&&(N="./"+N);else{const M=h.getWorkspaceFolder(O);if(M){const z=M.name;if(L.folders.filter(F=>F.name===z).length===1){const F=(0,$.$ig)(M.uri,O);F===""?N=`./${M.name}`:N=`./${M.name}/${F}`}else N=O.fsPath}}N&&w.push(v(N))}),w}e.$rJ=E}),define(De[348],Ce([1,0,24,2,21,8,5,347,36,43]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klb=e.$jlb=void 0;const P=7e3;function I(y,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const s=[],d=[];for(const n of i)if(/^workspaceContains:/.test(n)){const a=n.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||y.forceUsingSearch?d.push(a):s.push(a)}if(s.length===0&&d.length===0)return Promise.resolve(void 0);let b;const g=new Promise((n,a)=>{b=n}),t=n=>b({activationEvent:n}),o=Promise.all(s.map(n=>p(y,n,t))).then(()=>{}),c=k(y,r.identifier,d,t);return Promise.all([o,c]).then(()=>{b(void 0)}),g}e.$jlb=I;async function p(y,r,i){for(const s of y.folders)if(await y.exists(C.$gg(T.URI.revive(s),r))){i(`workspaceContains:${r}`);return}}async function k(y,r,i,s){if(i.length===0)return Promise.resolve(void 0);const d=new f.$rc,b=y.checkExists(y.folders,i,d.token),g=setTimeout(async()=>{d.cancel(),y.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let t=!1;try{t=await b}catch(o){R.$2(o)||R.$Y(o)}d.dispose(),clearTimeout(g),t&&s(`workspaceContains:${i.join(",")}`)}function D(y,r,i,s){const d=y.get(A.$yh),b=y.get(S.$eI),t=d.createInstance(m.$qJ).file(r.map(o=>(0,$.$Uh)(T.URI.revive(o))),{_reason:"checkExists",includePattern:i,exists:!0});return b.fileSearch(t,s).then(o=>!!o.limitHit,o=>R.$2(o)?!1:Promise.reject(o))}e.$klb=D}),define(De[45],Ce([1,0,204,16,53,24,11,3,77,2,14,6,40,286,115,39,27,148,8,25,22,262,7,64,5,26,91,20,105,72,44,4,348,114,264,17,112,37,12,113]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o,c,n,a,l,v,E,u,h,w,L,O,N,M,z,j,F){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=e.$tbc=e.$sbc=e.$rbc=e.$qbc=void 0,e.$qbc=(0,c.$zh)("IHostUtils");let H=K=class extends m.$mb{constructor(te,X,U,q,G,ce,re,de,Ee,he,ge,ne){super(),this.R=ne,this.a=this.B(new h.$hc),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=X,this.g=U,this.f=re,this.j=q,this.k=G,this.l=ce,this.m=Ee,this.p=he,this.s=ge,this.t=this.g.getProxy(I.$SJ.MainThreadWorkspace),this.u=this.g.getProxy(I.$SJ.MainThreadTelemetry),this.v=this.g.getProxy(I.$SJ.MainThreadExtensionService),this.w=new A.$Dg,this.y=new A.$Dg,this.z=new A.$Dg,this.C=new A.$Dg,this.D=new me(this.f.activationEvents),this.G=new i.$b3b(this.D,this.f.allExtensions);const ue=new d.$Ul(this.f.myExtensions);this.F=new i.$b3b(this.D,V(this.G,ue)),this.H=new D.$0ac(this.g,this.l),this.I=new L.$jbc(this.g),this.J=de,this.h=te.createChild(new v.$xh([D.$$ac,this.H],[L.$kbc,this.I])),this.L=this.B(new k.$9ac(this.F,this.G,{onExtensionActivationError:(we,Pe,B)=>{this.v.$onExtensionActivationError(we,s.$1(Pe),B)},actualActivateExtension:async(we,Pe)=>{if(i.$b3b.isHostExtension(we,this.F,this.G))return await this.v.$activateExtension(we,Pe),new k.$8ac;const B=this.F.getExtensionDescription(we);return this.$(B,Pe)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(te){s.$Y(te)}}async S(){this.J.onWillDeactivateAll();let te=[];try{te=this.F.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this.Z(G))}catch{}await Promise.all(te)}terminate(te,X=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.L.dispose(),s.setUnexpectedErrorHandler(q=>{this.l.error(q)}),this.g.dispose();const U=this.S();Promise.race([(0,A.$Fg)(5e3),U]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(te){return this.z.isOpen()?this.L.isActivated(te):!1}async getExtension(te){const X=await this.v.$getExtension(te);return X&&{...X,identifier:new d.$Tl(X.identifier.value),extensionLocation:$.URI.revive(X.extensionLocation)}}U(te,X){return this.L.activateByEvent(te,X)}W(te,X){return this.L.activateById(te,X)}activateByIdWithErrors(te,X){return this.W(te,X).then(()=>{const U=this.L.getActivatedExtension(te);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.F)}getExtensionExports(te){if(this.z.isOpen())return this.L.getActivatedExtension(te).exports;try{return this.L.getActivatedExtension(te).exports}catch{return null}}async X(te){if(te.scheme===N.Schemas.file&&this.c.fsRealpath){const X=await this.c.fsRealpath(te.fsPath);return $.URI.file(X)}return te}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(te=>new ee(te))),this.M}async Y(te){const X=S.$Fh.forUris(U=>R.$0f.ignorePathCasing(U));return await Promise.all(te.map(async U=>{if(this.qb(U)){const q=await this.X(U.extensionLocation);X.set(q,U)}})),X}Z(te){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(te))return X;const U=this.L.getActivatedExtension(te);if(!U)return X;try{typeof U.module.deactivate=="function"&&(X=Promise.resolve(U.module.deactivate()).then(void 0,q=>(this.l.error(q),Promise.resolve(void 0))))}catch(q){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(q)}try{(0,m.$hb)(U.subscriptions)}catch(q){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(q)}return X}async $(te,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.bb(te,X).then(U=>{const q=U.activationTimes;return this.v.$onDidActivateExtension(te.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,X),this.ab(te,X,"success",q),U},U=>{throw this.ab(te,X,"failure"),U})}ab(te,X,U,q){const G=_(te,X);this.u.$publicLog2("extensionActivationTimes",{...G,...q||{},outcome:U})}bb(te,X){const U=_(te,X);this.u.$publicLog2("activatePlugin",U);const q=this.qb(te);if(!q)return Promise.resolve(new k.$7ac(k.$4ac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${te.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const G=new k.$5ac(X.startup);return Promise.all([this.rb(te,(0,R.$gg)(te.extensionLocation,q),G),this.cb(te)]).then(ce=>(f.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),K.db(this.l,te.identifier,ce[0],ce[1],G))).then(ce=>(f.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ce))}cb(te){const X=new g.$abc(te,this.H),U=new g.$_ac(te.identifier.value,!1,this.H),q=new O.$lbc(te,this.I),G=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ce=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([X.whenReady,U.whenReady,this.J.whenReady]).then(()=>{const re=this;let de,Ee;const he=(0,r.$LF)(te,"ipc")?this.f.messagePorts?.get(d.$Tl.toKey(te.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:U,secrets:q,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(ge){return T.$$c(te.extensionLocation.fsPath,ge)},get storagePath(){return re.J.workspaceValue(te)?.fsPath},get globalStoragePath(){return re.J.globalValue(te).fsPath},get logPath(){return T.$$c(re.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return $.URI.joinPath(re.f.logsLocation,te.identifier.value)},get storageUri(){return re.J.workspaceValue(te)},get globalStorageUri(){return re.J.globalValue(te)},get extensionMode(){return G},get extension(){return de===void 0&&(de=new Q(re,te.identifier,te,ce,!1)),de},get extensionRuntime(){return(0,r.$MF)(te,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Ee){if(!he)return;const ge=h.Event.buffer(h.Event.fromDOMEventEmitter(he,"message",ne=>ne.data));he.start(),Ee={onDidReceiveMessage:ge,postMessage:he.postMessage.bind(he)}}return Ee}})})}static db(te,X,U,q,G){return U=U||{activate:void 0,deactivate:void 0},this.eb(te,X,U,q,G).then(ce=>new k.$6ac(!1,null,G.build(),U,ce,q.subscriptions))}static eb(te,X,U,q,G){if(typeof U.activate=="function")try{G.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${X.value}`);const ce=typeof global=="object"?global:self,re=U.activate.apply(ce,[q]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(re).then(de=>(G.activateResolveStop(),de))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(U)}fb(te,X){this.W(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:X}).then(void 0,U=>{this.l.error(U)})}gb(te,X=0){const q=Date.now();(0,j.$A)(()=>{for(let G=X;G<te.length;G+=1){const ce=te[G];for(const re of ce.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-q>50){this.gb(te,G);break}else this.fb(ce,re)}})}hb(){this.v.$setPerformanceMarks(f.getMarks()),this.k.getConfigProvider().then(te=>{const X=te.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),U=this.F.getAllExtensionDescriptions();if(X)this.gb(U);else for(const q of U)if(q.activationEvents)for(const G of q.activationEvents)G==="onStartupFinished"&&this.fb(q,G)})}ib(){const te=this.U("*",!0).then(void 0,ce=>{this.l.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.jb(ce.added)));const X=this.j.workspace?this.j.workspace.folders:[],U=this.jb(X),q=this.lb(),G=Promise.all([q,te,U]).then(()=>{});return Promise.race([G,(0,A.$Fg)(1e4)]).then(()=>{this.hb()}),G}jb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(X=>this.kb(te,X))).then(()=>{})}async kb(te,X){if(this.isActivated(X.identifier))return;const U=!this.f.remote.isRemote&&!!this.f.remote.authority,q={logService:this.l,folders:te.map(ce=>ce.uri),forceUsingSearch:U||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,re,de)=>this.t.$checkExists(ce,re,de)},G=await(0,w.$jlb)(q,X);if(G)return this.W(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:G.activationEvent}).then(void 0,ce=>this.l.error(ce))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(te){throw console.error(te),te}}async mb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:X}=this.f.environment;if(!te||!X)throw new Error(C.localize(0,null));const U=await this.rb(null,X,new k.$5ac(!1));if(!U||typeof U.run!="function")throw new Error(C.localize(1,null,X.toString()));return new Promise((q,G)=>{const ce=(Ee,he)=>{Ee?G(Ee):q(typeof he=="number"&&he>0?1:0)},re=(0,R.$7f)(X),de=U.run(re,ce);de&&de.then&&de.then(()=>{q(0)}).catch(Ee=>{G(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$Fg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,X){return this.N[te]=X,(0,m.$kb)(()=>{delete this.N[te]})}async getRemoteExecServer(te){const{resolver:X}=await this.ob(te);return X?.resolveExecServer?.(te,{resolveAttempt:0})}async ob(te){const X=te.indexOf("+");if(X===-1)throw new t.$1J("Not an authority that can be resolved!",o.RemoteAuthorityResolverErrorCode.InvalidAuthority);const U=te.substr(0,X);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this.N[U]}}async $resolveAuthority(te,X){const U=z.$dc.create(!1),q=()=>`[resolveAuthority(${(0,o.$Lk)(te)},${X})][${U.elapsed()}ms] `,G=x=>this.l.info(`${q()}${x}`),ce=x=>this.l.warn(`${q()}${x}`),re=(x,se=void 0)=>this.l.error(`${q()}${x}`,se),de=x=>{if(x instanceof t.$1J)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},Ee=async x=>{G(`activating resolver for ${x}...`);const{resolver:se,authorityPrefix:Y}=await this.ob(x);if(!se)throw re(`no resolver for ${Y}`),new t.$1J(`No remote extension installed to resolve ${Y}.`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:se,authorityPrefix:Y,remoteAuthority:x}},he=te.split(/@|%40/g).reverse();G(`activating remote resolvers ${he.join(" -> ")}`);let ge;try{ge=await Promise.all(he.map(Ee)).catch(async x=>{if(!(x instanceof t.$1J)||x._code!==o.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return ce(`resolving nested authorities failed: ${x.message}`),[await Ee(te)]})}catch(x){return de(x)}const ne=new A.$Pg;ne.cancelAndSet(()=>G("waiting..."),1e3);let ue,we;for(const[x,{authorityPrefix:se,resolver:Y,remoteAuthority:fe}]of ge.entries())try{if(x===ge.length-1)G("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${se}`),ue=await Y.resolve(fe,{resolveAttempt:X,execServer:we}),f.mark(`code/extHost/didResolveAuthorityOK/${se}`),G("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Y,t.$ZJ.isManagedResolvedAuthority(ue)?ue:void 0));else{if(G(`invoking resolveExecServer() for ${fe}`),f.mark(`code/extHost/willResolveExecServer/${se}`),we=await Y.resolveExecServer?.(fe,{resolveAttempt:X,execServer:we}),!we)throw new t.$1J(`Exec server was not available for ${fe}`,o.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${se}`)}}catch(ye){return f.mark(`code/extHost/didResolveAuthorityError/${se}`),re("returned an error",ye),ne.dispose(),de(ye)}ne.dispose();const Pe={environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures},B={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};G(`returned ${t.$ZJ.isManagedResolvedAuthority(ue)?"managed authority":`${ue.host}:${ue.port}`}`);let Z;if(t.$ZJ.isManagedResolvedAuthority(ue)){const x=X;this.R.setFactory(x,ue.makeConnection),Z={authority:te,connectTo:new o.$Ik(x),connectionToken:ue.connectionToken}}else Z={authority:te,connectTo:new o.$Jk(ue.host,ue.port),connectionToken:ue.connectionToken};return{type:"ok",value:{authority:Z,options:B,tunnelInformation:Pe}}}async $getCanonicalURI(te,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.$Lk)(te)})`);const{resolver:U}=await this.ob(te);if(!U)return null;const q=$.URI.revive(X);if(typeof U.getCanonicalURI>"u")return q;const G=await(0,A.$xg)(()=>U.getCanonicalURI(q));return G||q}$startExtensionHost(te){te.toAdd.forEach(q=>q.extensionLocation=$.URI.revive(q.extensionLocation));const{globalRegistry:X,myExtensions:U}=$e(this.D,this.G,this.F,te);return this.G.set(X.getAllExtensionDescriptions()),this.F.set(U),this.nb()}$activateByEvent(te,X){return X===1?this.w.wait().then(U=>this.U(te,!1)):this.z.wait().then(U=>this.U(te,!1))}async $activate(te,X){return await this.z.wait(),this.F.getExtensionDescription(te)?(await this.W(te,X),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ce=>ce.extensionLocation=$.URI.revive(ce.extensionLocation));const{globalRegistry:X,myExtensions:U}=$e(this.D,this.G,this.F,te),q=await this.Y(U);return(await this.getExtensionPathIndex()).setSearchTree(q),this.G.set(X.getAllExtensionDescriptions()),this.F.set(U),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const X=b.$Hc.alloc(te),U=Math.random()%256;for(let q=0;q<te;q++)X.writeUInt8(U,q);return X}async $updateRemoteConnectionData(te){this.Q=te,this.a.fire()}};e.$rbc=H,e.$rbc=H=K=Ke([Be(0,c.$yh),Be(1,e.$qbc),Be(2,l.$UL),Be(3,y.$Wac),Be(4,p.$Zac),Be(5,P.$3i),Be(6,n.$$L),Be(7,a.$dbc),Be(8,E.$csb),Be(9,u.$fbc),Be(10,M.$nbc),Be(11,F.$obc)],H);function $e(ae,te,X,U){ae.addActivationEvents(U.addActivationEvents);const q=new i.$b3b(ae,te.getAllExtensionDescriptions());q.deltaExtensions(U.toAdd,U.toRemove);const G=new d.$Ul(X.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of U.myToRemove)G.delete(re);for(const re of U.myToAdd)G.add(re);const ce=V(q,G);return{globalRegistry:q,myExtensions:ce}}function _(ae,te){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.$sbc=(0,c.$zh)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(te,X,U,q,G){this.#e=te,this.#t=X,this.#i=U.identifier,this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=T.$9c((0,R.$7f)(U.extensionLocation)),this.packageJSON=U,this.extensionKind=q,this.isFromDifferentExtensionHost=G}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$tbc=Q;function V(ae,te){return ae.getAllExtensionDescriptions().filter(X=>te.has(X.identifier))}class ee{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.$ubc=ee;class me{constructor(te){this.a=new d.$Vl,this.addActivationEvents(te)}readActivationEvents(te){return this.a.get(te.identifier)}addActivationEvents(te){for(const X of Object.keys(te))this.a.set(X,te[X])}}}),define(De[349],Ce([1,0,53,2,6,40,27,25,20,26,5,45,14,15]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;let y=class{constructor(b,g,t,o,c,n,a){this.c=b,this.d=g,this.e=t,this.f=o,this.g=c,this.h=n,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const b=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const g=await this.g.getExtensionPathIndex();this.register(new i(this.c,g,this.d,b,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(s,g,this.h.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const g of b.nodeModuleName)this.a.set(g,b);else this.a.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this.b.push(g=>b.alternativeModuleName(g))}};e.$Qcc=y,e.$Qcc=y=Ke([Be(2,P.$yh),Be(3,R.$Zac),Be(4,I.$sbc),Be(5,$.$$L),Be(6,p.$3i)],y);let r=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(b){if(b.environment.appRoot&&D.a.size){const g=(0,k.$sd)(this.c(b.environment.appRoot.fsPath)),t="[a-z0-9_.-]",o=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${g}/${c}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(b){if(!this.b)return;const g=this.b.exec(this.c(b));if(!g)return;const[,t,o,c]=g,n=D.a.get(o);if(n!==void 0)return console.warn(`${o} as been renamed to ${n}, please update your imports`),t+n+c}c(b){return b.replace(/\\/g,"/")}};r=D=Ke([Be(0,$.$$L)],r);class i{constructor(b,g,t,o,c){this.c=b,this.d=g,this.e=t,this.f=o,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Vl}load(b,g){const t=this.d.findSubstr(g);if(t){let o=this.a.get(t.identifier);return o||(o=this.c(t,this.e,this.f),this.a.set(t.identifier,o)),o}if(!this.b){let o="";this.d.forEach((c,n)=>o+=`	${n} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${g}. These are the extension path mappings: 
${o}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let s=class{constructor(b,g,t){this.e=b,this.f=g,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$SJ.MainThreadTelemetry);const o=t.getProxy(f.$SJ.MainThreadWindow);this.c=(c,n)=>{const a=T.URI.parse(c);return n?this.g(c,n):a.scheme==="http"||a.scheme==="https"?o.$openUri(a,c,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?o.$openUri(a,c,{}):this.g(c,n)}}load(b,g,t){const o=this.e.findSubstr(g);return o&&(this.a=o.identifier.value,this.h()),this.b=t(b),this.c}g(b,g){return this.i(),this.b(b,g)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};s=Ke([Be(2,S.$UL)],s)}),define(De[55],Ce([1,0,58,3,16,47,5,69,70,45,7,39,278,40]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=e.$1bc=void 0,e.$1bc=(0,A.$zh)("IExtHostVariableResolverProvider");class D extends p.$VM{constructor(i,s,d,b,g,t,o){function c(){if(d){const n=d.activeEditor();if(n)return n.document.uri;const a=b.tabGroups.all.find(l=>l.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof P.$BL||a.input instanceof P.$GL)return a.input.modified;if(a.input instanceof P.$AL||a.input instanceof P.$FL||a.input instanceof P.$DL)return a.input.uri}}}super({getFolderUri:n=>{const a=t.folders.filter(l=>l.name===n);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,a)=>g.getConfiguration(void 0,n).get(a),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=c();if(n)return f.$9c(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(s){const n=c();if(n){const a=s.getWorkspaceFolder(n);if(a)return f.$9c(a.uri.fsPath)}}},getSelectedText:()=>{if(d){const n=d.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(d){const n=d.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>i.getExtension(n)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let y=class extends T.$mb{constructor(i,s,d,b,g){super(),this.b=i,this.c=s,this.g=d,this.h=b,this.i=g,this.a=new C.$T(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.i,t,c,this.j())})}getResolver(){return this.a.value}j(){}};e.$2bc=y,e.$2bc=y=Ke([Be(0,$.$sbc),Be(1,I.$Wac),Be(2,m.$6L),Be(3,k.$Zac),Be(4,S.$Ybc)],y)}),define(De[95],Ce([1,0,11,4,2,5,6,70,45,20,7,39,140,271,40,55]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=e.$5bc=e.$4bc=e.$3bc=void 0,e.$3bc=(0,R.$zh)("IExtHostDebugService");let r=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,c,n,a,l,v){this.E=c,this.F=n,this.G=a,this.H=l,this.I=v,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$hc,this.n=new T.$hc,this.o=new T.$hc,this.u=new T.$hc,this.k=o.getProxy(A.$SJ.MainThreadDebugService),this.y=new T.$hc,this.A=new T.$hc,this.v=new s(this.k),this.w=new Map,this.F.getExtensionRegistry().then(E=>{E.onDidChange(u=>{this.J(E)}),this.J(E)})}asDebugSourceUri(o,c){const n=o;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let a=`debug:${encodeURIComponent(n.path||"")}`,l="?";return c&&(a+=`${l}session=${encodeURIComponent(c.id)}`,l="&"),a+=`${l}ref=${n.sourceReference}`,f.URI.parse(a)}else{if(n.path)return f.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(o){const c=[];for(const n of o.getAllExtensionDescriptions())if(n.contributes){const a=n.contributes.debuggers;if(a&&a.length>0)for(const l of a)(0,k.$iF)(l)&&c.push(l.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const o=[];return this.w.forEach(c=>o.push(c)),o}addBreakpoints(o){const c=o.filter(l=>{const v=l.id;return this.w.has(v)?!1:(this.w.set(v,l),!0)});this.U(c,[],[]);const n=[],a=new Map;for(const l of c)if(l instanceof P.$UK){let v=a.get(l.location.uri.toString());v||(v={type:"sourceMulti",uri:l.location.uri,lines:[]},a.set(l.location.uri.toString(),v),n.push(v)),v.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof P.$VK&&n.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(o){const c=o.filter(v=>this.w.delete(v.id));this.U([],c,[]);const n=c.filter(v=>v instanceof P.$UK).map(v=>v.id),a=c.filter(v=>v instanceof P.$VK).map(v=>v.id),l=c.filter(v=>v instanceof P.$WK).map(v=>v.id);return this.k.$unregisterBreakpoints(n,a,l)}startDebugging(o,c,n){return this.k.$startDebugging(o?o.uri:void 0,c,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,c,n){if(!c)return new P.$UJ(()=>{});const a=this.d++;return this.f.push({type:o,handle:a,provider:c}),this.k.$registerDebugConfigurationProvider(o,n,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,a),new P.$UJ(()=>{this.f=this.f.filter(l=>l.provider!==c),this.k.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(o,c,n){if(!n)return new P.$UJ(()=>{});if(!this.Q(o,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this.g++;return this.h.push({type:c,handle:a,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(c,a),new P.$UJ(()=>{this.h=this.h.filter(l=>l.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(o,c){if(!c)return new P.$UJ(()=>{});const n=this.i++;return this.j.push({type:o,handle:n,factory:c}),new P.$UJ(()=>{this.j=this.j.filter(a=>a.factory!==c)})}async $runInTerminal(o,c){return Promise.resolve(void 0)}async $substituteVariables(o,c){let n;const a=await this.W(o);return a&&(n={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,c)}K(o,c){if(o.type==="implementation")return new b(o.implementation)}L(){}async $startDASession(o,c){const n=this,a=await this.V(c);return this.S(this.N(a.type),a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const v=this.M(l),E=this.K(v,a);if(!E)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const u=E;return this.B.set(o,u),this.R(a).then(h=>(h&&this.C.set(o,h),u.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const L=w,O={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const N=await this.D.sign(L.arguments.value);O.body={signature:N},u.sendResponse(O)}else throw new Error("no signer")}catch(N){O.success=!1,O.message=N.message,u.sendResponse(O)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(w),w=(0,k.$nF)(w,!0),n.k.$acceptDAMessage(o,w)}),u.onError(w=>{h&&h.onError&&h.onError(w),this.k.$acceptDAError(o,w.name,w.message,w.stack)}),u.onExit(w=>{h&&h.onExit&&h.onExit(w??void 0,void 0),this.k.$acceptDAExit(o,w??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),u.startSession()))})}$sendDAMessage(o,c){c=(0,k.$mF)(c,!1);const n=this.C.get(o);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(c),this.B.get(o)?.sendMessage(c)}$stopDASession(o){const c=this.C.get(o);this.C.delete(o),c&&c.onWillStopSession&&c.onWillStopSession();const n=this.B.get(o);return this.B.delete(o),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const c=[],n=[],a=[];if(o.added)for(const l of o.added){const v=l.id;if(v&&!this.w.has(v)){let E;if(l.type==="function")E=new P.$VK(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")E=new P.$WK(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const u=f.URI.revive(l.uri);E=new P.$UK(new P.$7J(u,new P.$VJ(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,P.$SK)(E,v),this.w.set(v,E),c.push(E)}}if(o.removed)for(const l of o.removed){const v=this.w.get(l);v&&(this.w.delete(l),n.push(v))}if(o.changed){for(const l of o.changed)if(l.id){const v=this.w.get(l.id);if(v){if(v instanceof P.$VK&&l.type==="function"){const E=v;E.enabled=l.enabled,E.condition=l.condition,E.hitCondition=l.hitCondition,E.logMessage=l.logMessage,E.functionName=l.functionName}else if(v instanceof P.$UK&&l.type==="source"){const E=v;E.enabled=l.enabled,E.condition=l.condition,E.hitCondition=l.hitCondition,E.logMessage=l.logMessage,E.location=new P.$7J(f.URI.revive(l.uri),new P.$VJ(l.line,l.character))}a.push(v)}}}this.U(c,n,a)}async $acceptStackFrameFocus(o){let c;const n=o.sessionId?await this.V(o.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");o.kind==="thread"?c=new P.$3K(n,o.threadId):c=new P.$2K(n,o.threadId,o.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(o,c,n){return(0,C.$xg)(async()=>{const a=this.P(o);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(c);return a.provideDebugConfigurations(l,n)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(o,c,n,a){return(0,C.$xg)(async()=>{const l=this.P(o);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.W(c);return l.resolveDebugConfiguration(v,n,a)})}$resolveDebugConfigurationWithSubstitutedVariables(o,c,n,a){return(0,C.$xg)(async()=>{const l=this.P(o);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.W(c);return l.resolveDebugConfigurationWithSubstitutedVariables(v,n,a)})}async $provideDebugAdapter(o,c){const n=this.O(o);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.V(c);return this.S(n,a).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(o){const c=await this.V(o);this.m.fire(c)}async $acceptDebugSessionTerminated(o){const c=await this.V(o);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,c){(await this.V(o))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(o,c){const a={session:await this.V(o),event:c.event,body:c.body};this.u.fire(a)}M(o){if(o instanceof P.$XK)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof P.$YK)return{type:"server",port:o.port,host:o.host};if(o instanceof P.$ZK)return{type:"pipeServer",path:o.path};if(o instanceof P.$1K)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}N(o){const c=this.h.filter(n=>n.type===o);if(c.length>0)return c[0].factory}O(o){const c=this.h.filter(n=>n.handle===o);if(c.length>0)return c[0].factory}P(o){const c=this.f.filter(n=>n.handle===o);if(c.length>0)return c[0].provider}Q(o,c){if(o.contributes){const n=o.contributes.debuggers;if(n&&n.length>0){for(const a of n)if(a.label&&a.type&&a.type===c)return!0}}return!1}R(o){const n=o.configuration.type,a=this.j.filter(l=>l.type===n||l.type==="*").map(l=>(0,C.$xg)(()=>l.factory.createDebugAdapterTracker(o)).then(v=>v,v=>null));return Promise.race([Promise.all(a).then(l=>{const v=l.filter(E=>!!E);if(v.length>0)return new d(v)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(o,c){const n=c.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new P.$YK(n));if(o){const l=await this.F.getExtensionRegistry();return(0,C.$xg)(()=>o.createDebugAdapterDescriptor(c,this.T(c,l))).then(v=>{if(v)return v})}const a=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,a))}T(o,c){}U(o,c,n){(o.length>0||c.length>0||n.length>0)&&this.y.fire(Object.freeze({added:o,removed:c,changed:n}))}async V(o){if(o)if(typeof o=="string"){const c=this.l.get(o);if(c)return c}else{let c=this.l.get(o.id);if(!c){const n=await this.W(o.folderUri),a=o.parent?this.l.get(o.parent):void 0;c=new i(this.k,o.id,o.type,o.name,n,o.configuration,a),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(o){if(o){const c=f.URI.revive(o);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$4bc=r,e.$4bc=r=Ke([Be(0,$.$UL),Be(1,I.$Wac),Be(2,S.$sbc),Be(3,D.$Zac),Be(4,m.$Ybc),Be(5,y.$1bc)],r);class i{constructor(o,c,n,a,l,v,E){this.d=o,this.f=c,this.g=n,this.h=a,this.i=l,this.j=v,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,c){return this.d.$customDebugAdapterRequest(this.f,o,c)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.$5bc=i;class s{constructor(o){this.value=Object.freeze({append(c){o.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$6bc=s;class d{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(c=>c.onError?c.onError(o):void 0)}onExit(o,c){this.d.forEach(n=>n.onExit?n.onExit(o,c):void 0)}}class b extends p.$rcb{constructor(o){super(),this.h=o,o.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends r{constructor(o,c,n,a,l,v){super(o,c,n,a,l,v)}};e.$7bc=g,e.$7bc=g=Ke([Be(0,$.$UL),Be(1,I.$Wac),Be(2,S.$sbc),Be(3,D.$Zac),Be(4,m.$Ybc),Be(5,y.$1bc)],g)}),define(De[350],Ce([1,0,8,53,2,6,341,14,104,105,26,238,20,66,45,89]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0;class r{static async installEarlyHandler(d){Error.stackTraceLimit=100;const b=d.get(m.$3i),t=d.get(p.$UL).getProxy(R.$SJ.MainThreadErrors);C.setUnexpectedErrorHandler(o=>{b.error(o);const c=C.$1(o);t.$onUnexpectedError(c)})}static async installFullHandler(d){const b=d.get(m.$3i),g=d.get(p.$UL),t=d.get(D.$sbc),o=d.get(y.$cM),c=g.getProxy(R.$SJ.MainThreadExtensionService),n=g.getProxy(R.$SJ.MainThreadErrors),a=await t.getExtensionPathIndex(),l=new WeakMap;function v(h,w){if(l.has(h))return l.get(h).stack;let L="",O,N;for(const z of w)L+=`
	at ${z.toString()}`,N=z.getFileName(),!O&&N&&(O=a.findSubstr(f.URI.file(N)));const M=`${h.name||"Error"}: ${h.message||""}${L}`;return l.set(h,{extensionIdentifier:O?.identifier,stack:M}),M}const E=Symbol("prepareStackTrace wrapped");let u=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(h){if(h===v||!h||h[E]){u=h||v;return}u=function(w,L){return v(w,L),h.call(Error,w,L)},Object.assign(u,{[E]:!0})}}),C.setUnexpectedErrorHandler(h=>{b.error(h);const w=C.$1(h),L=l.get(h);if(!L?.extensionIdentifier){n.$onUnexpectedError(w);return}c.$onExtensionRuntimeError(L.extensionIdentifier,w);const O=o.onExtensionError(L.extensionIdentifier,h);b.trace("forwarded error to extension?",O,L)})}}e.$Rcc=r;class i{constructor(d,b,g,t,o){this.a=g,this.b=new A.$j3b(d,null,t),b=i.e(b,this.b);const c=new $.$xh(...(0,S.$kr)());c.set(P.$$L,{_serviceBrand:void 0,...b,messagePorts:o}),c.set(p.$UL,new p.$VL(this.b)),c.set(k.$Tac,new k.$Uac(t)),c.set(D.$qbc,g);const n=new I.$3p(c,!0);n.invokeFunction(r.installEarlyHandler),this.d=n.invokeFunction(a=>a.get(m.$3i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",b),this.c=n.invokeFunction(a=>a.get(D.$sbc)),this.c.initialize(),n.invokeFunction(r.installFullHandler)}async asBrowserUri(d){const b=this.b.getProxy(R.$SJ.MainThreadExtensionService);return f.URI.revive(await b.$asBrowserUri(d))}terminate(d){this.c.terminate(d)}static e(d,b){d.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(b.transformIncomingURIs(t.extensionLocation))}),d.environment.appRoot=f.URI.revive(b.transformIncomingURIs(d.environment.appRoot));const g=d.environment.extensionDevelopmentLocationURI;return g&&(d.environment.extensionDevelopmentLocationURI=g.map(t=>f.URI.revive(b.transformIncomingURIs(t)))),d.environment.extensionTestsLocationURI=f.URI.revive(b.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=f.URI.revive(b.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=f.URI.revive(b.transformIncomingURIs(d.environment.workspaceStorageHome)),d.environment.extensionTelemetryLogResource=f.URI.revive(b.transformIncomingURIs(d.environment.extensionTelemetryLogResource)),d.nlsBaseUrl=f.URI.revive(b.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=f.URI.revive(b.transformIncomingURIs(d.logsLocation)),d.workspace=b.transformIncomingURIs(d.workspace),d}}e.$Scc=i}),define(De[351],Ce([1,0,11,12,215,232,138,95,70,45,20,44,7,55,39,272,273,40]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;let s=class extends m.$4bc{constructor(o,c,n,a,l,v,E){super(o,c,n,a,v,E),this.Z=l,this.X=new g}K(o,c){switch(o.type){case"server":return new y.$Xcc(o);case"pipeServer":return new y.$Ycc(o);case"executable":return new y.$Zcc(o,c.type)}return super.K(o,c)}T(o,c){const n=y.$Zcc.platformAdapterExecutable(c.getAllExtensionDescriptions(),o.type);if(n)return new p.$XK(n.command,n.args,n.options)}L(){return new A.$X6b}async $runInTerminal(o,c){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const n=await this.G.getConfigProvider(),a=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),v=o.title||f.localize(0,null),E=JSON.stringify({shell:a,shellArgs:l});let u=await this.X.checkout(E,v),h,w=!1;if(u)h=o.cwd;else{const M={shellPath:a,shellArgs:l,cwd:o.cwd,name:v,iconPath:new p.$PK("debug")};w=!0,u=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,E)}u.show(!0);const L=await u.processId;w?await new Promise(M=>setTimeout(M,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?u.sendText("cls"):a.indexOf("bash")>=0?u.sendText("clear"):T.$i?u.sendText("cls"):u.sendText("clear"));const O=(0,r.$2cc)(a,o.args,!!o.argsCanBeInterpretedByShell,h,o.env);u.sendText(O);const N=this.onDidTerminateDebugSession(M=>{M.id===c&&(this.X.free(u),N.dispose())});return L}else if(o.kind==="external")return b(o,await this.G.getConfigProvider());return super.$runInTerminal(o,c)}};e.$3cc=s,e.$3cc=s=Ke([Be(0,P.$UL),Be(1,D.$Wac),Be(2,$.$sbc),Be(3,i.$Zac),Be(4,I.$fbc),Be(5,S.$Ybc),Be(6,k.$1bc)],s);let d;function b(t,o){if(!d)if(T.$i)d=new R.$G5b;else if(T.$j)d=new R.$H5b;else if(T.$k)d=new R.$I5b;else throw new Error("external terminals not supported on this platform");const c=o.getConfiguration("terminal");return d.runInTerminal(t.title,t.cwd,t.args,t.env||{},c.external||{})}class g{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,c){const a=[...this.b.entries()].map(([l,v])=>(0,C.$sg)(async E=>{if(l.name!==c||v.lastUsedAt!==-1&&await(0,r.$1cc)(await l.processId))return null;const u=Date.now();return v.lastUsedAt+g.a>u||E.isCancellationRequested||v.config!==o?null:(v.lastUsedAt=u,l)}));return await(0,C.$Jg)(a,l=>!!l)}insert(o,c){this.b.set(o,{lastUsedAt:Date.now(),config:c})}free(o){const c=this.b.get(o);c&&(c.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(De[352],Ce([1,0,16,2,102,39,69,40,43,44,20,26,94,17,14,90,24,63,55]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let d=class extends p.$Vbc{constructor(g,t,o,c,n,a,l,v,E){super(g,t,o,c,n,a,l,v),this.B=o,this.C=E,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,t){const o=t;if(!t.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const c=p.TaskHandleDTO.from(o,this.B),n=await this.a.$getTaskExecution(c);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.y(n,t);return this.a.$executeTask(c).catch(()=>{}),a}else{const c=p.TaskDTO.from(t,g);if(c===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(c.execution)&&await this.x(c,t,!1);const n=await this.y(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),n}}u(g,t,o,c){const n=[];if(c)for(const a of c){this.z(a,o),(!a.definition||!g[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const l=p.TaskDTO.from(a,o.extension);l&&(n.push(l),p.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,a,!0)))}return{tasks:n,extension:o.extension}}async v(g){return g}async F(g){let t=g&&g.length>0?g[0]:void 0;if(!t){const o=T.URI.file((0,i.homedir)());t=new S.$Th({uri:o,name:r.$dg(o),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,t){const o=T.URI.revive(g),c={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(o),a=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),v=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(a);for(const E of t.variables)c.variables[E]=await l.resolveAsync(v,E);if(t.process!==void 0){let E;if(t.process.path!==void 0){E=t.process.path.split(C.$id);for(let u=0;u<E.length;u++)E[u]=await l.resolveAsync(v,E[u])}c.process=await f.win32.findExecutable(await l.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(v,t.process.cwd):void 0,E)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(g,t,o){return f.win32.findExecutable(g,t,o)}};e.$Ucc=d,e.$Ucc=d=Ke([Be(0,P.$UL),Be(1,I.$$L),Be(2,R.$Wac),Be(3,A.$6L),Be(4,m.$Zac),Be(5,$.$fbc),Be(6,D.$3i),Be(7,y.$Mac),Be(8,s.$1bc)],d)}),define(De[353],Ce([1,0,63,55]),function(be,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class f extends T.$2bc{j(){return(0,C.homedir)()}}e.$Adc=f}),define(De[153],Ce([1,0,19,11,21,46,17,16,24,2,36]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=void 0;class I{constructor(s,d,b,g){this.d=s,this.e=d,this.f=b,this.g=g,this.a=null,this.b=!1,this.c=0}search(s,d){const b=this.d.folderQueries||[],g=new f.$rc(d);return new Promise((t,o)=>{this.a=new k(s);let c=!1;const n=(a,l)=>{if(!c&&!this.b){const v=this.h(a);y(a)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,c=!0,g.cancel(),a=this.j(a,this.d.maxResults-this.c));const E=this.h(a);this.c+=E,(E>0||!y(a))&&this.a.add(a,l)}};Promise.all(b.map((a,l)=>this.k(a,v=>n(v,l),g.token))).then(a=>{g.dispose(),this.a.flush();const l=a.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||l,messages:(0,C.$Kf)(a.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},a=>{g.dispose();const l=(0,R.$ki)(a);o(new Error(l))})})}h(s){return y(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}j(s,d){const b=Array.isArray(s.ranges)?s.ranges:[s.ranges],g=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:b.slice(0,d),preview:{matches:g.slice(0,d),text:s.preview.text},uri:s.uri}}async k(s,d,b){const g=new P.$xI(this.d,s),t=[],o={report:a=>{if(!this.l(a))return;const l=s.folder.scheme===A.Schemas.file?(0,P.$yI)(()=>this.f.readdir(S.$fg(a.uri))):void 0,v=S.$ig(s.folder,a.uri);if(v){const E=g.includedInQuery(v,m.$cd(v),l);(0,T.$rg)(E)?t.push(E.then(u=>{u&&d(a)})):E&&d(a)}}},c=this.n(s),n=await this.e.provideTextSearchResults(p(this.d.contentPattern),c,o,b);return t.length&&await Promise.all(t),n}l(s){if(y(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(s){const d=(0,P.$wI)(this.d.includePattern,s.includePattern),b=(0,P.$wI)(this.d.excludePattern,s.excludePattern),g={folder:$.URI.from(s.folder),excludes:b,includes:d,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.f.toCanonicalName(s.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.$9bc=I;function p(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class k{constructor(s){this.e=s,this.b=-1,this.d=null,this.a=new r(512,d=>this.g(d))}add(s,d){this.d&&(this.b!==d||!S.$_f(this.c,s.uri))&&(this.f(),this.d=null),this.d||(this.b=d,this.d={resource:s.uri,results:[]}),this.d.results.push(D(s))}f(){const s=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,s)}flush(){this.f(),this.a.flush()}g(s){this.e(s)}}e.$0bc=k;function D(i){return y(i)?{preview:{matches:(0,C.$Uf)(i.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:i.preview.text},ranges:(0,C.$Uf)(i.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function y(i){return!!i.preview}e.$$bc=y;class r{static{this.a=4e3}static{this.b=50}constructor(s,d){this.g=s,this.h=d,this.c=0,this.d=[],this.e=0}addItem(s,d){s&&this.j(s,d)}addItems(s,d){s&&this.k(s,d)}j(s,d){this.d.push(s),this.e+=d,this.l()}k(s,d){this.d=this.d.concat(s),this.e+=d,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$_bc=r}),define(De[96],Ce([1,0,3,6,5,346,20,66,14,2,153]),function(be,e,C,T,f,R,A,m,S,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=void 0,e.$acc=(0,f.$zh)("IExtHostSearch");let I=class{constructor(y,r,i){this.k=y,this.l=r,this.n=i,this.c=this.k.getProxy(T.$SJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$8bc}o(y){return this.l.transformOutgoingScheme(y)}registerTextSearchProvider(y,r){if(this.g.has(y))throw new Error(`a text search provider for the scheme '${y}' is already registered`);this.g.add(y);const i=this.d++;return this.e.set(i,r),this.c.$registerTextSearchProvider(i,this.o(y)),(0,C.$kb)(()=>{this.g.delete(y),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(y,r){if(this.i.has(y))throw new Error(`a file search provider for the scheme '${y}' is already registered`);this.i.add(y);const i=this.d++;return this.h.set(i,r),this.c.$registerFileSearchProvider(i,this.o(y)),(0,C.$kb)(()=>{this.i.delete(y),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(y,r,i,s){const d=p(i),b=this.h.get(y);if(b)return this.j.fileSearch(d,b,g=>{this.c.$handleFileMatch(y,r,g.map(t=>t.resource))},s);throw new Error("unknown provider: "+y)}$clearCache(y){return this.j.clearCache(y),Promise.resolve(void 0)}$provideTextSearchResults(y,r,i,s){const d=this.e.get(y);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${y}`);const b=p(i);return this.q(b,d).search(t=>this.c.$handleTextMatch(y,r,t),s)}$enableExtensionHostSearch(){}q(y,r){return new P.$9bc(y,r,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$bcc=I,e.$bcc=I=Ke([Be(0,A.$UL),Be(1,m.$Tac),Be(2,S.$3i)],I);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(k),extraFileResources:D.extraFileResources&&D.extraFileResources.map(y=>$.URI.revive(y))}}e.$ccc=p;function k(D){return{...D,folder:$.URI.revive(D.folder)}}}),define(De[354],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,301,300,33,302,40,304,305,306,280,307,69,45,309,310,315,316,317,152,284,323,324,326,115,44,328,287,13,7,85,331,92,151,39,25,276,314,65,149,94,95,96,14,66,20,26,318,274,72,90,294,329,91,71,334,332,333,295,54,327,330,114,70,89,319,93,320,17,134,283,263,312,3,27,270,112,257,321,322,296,311,282,313,113,325,297,298,299,293,308]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o,c,n,a,l,v,E,u,h,w,L,O,N,M,z,j,F,K,H,$e,_,Q,V,ee,me,ae,te,X,U,q,G,ce,re,de,Ee,he,ge,ne,ue,we,Pe,B,Z,x,se,Y,fe,ye,ze,We,xe,Ye,it,et,Ae,Ne,Ve,Le,Qe,le,oe,Ie,qe,je,Xe,nt,ot,bt,Dt,Qt,Vt,vt,Tt,Nt,Kt,At,Rt,Ot,Ut,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;function Bt(ct){const lt=ct.get(he.$$L),Jt=ct.get(ze.$Jac),Pt=ct.get(x.$cbc),kt=ct.get(n.$sbc),dt=ct.get(ee.$Wac),Ct=ct.get(et.$cM),Ft=ct.get(s.$Zac),Et=ct.get(de.$Tac),Ge=ct.get(Ee.$UL),zt=ct.get(M.$$ac),Me=ct.get(Z.$dbc),Te=ct.get(re.$4i),Se=ct.get(re.$3i),ie=ct.get(ue.$csb),Fe=ct.get(we.$Mac),He=ct.get(V.$Qbc),_e=ct.get(Ye.$kbc),Je=ct.get(it.$Ybc),rt=ct.get(Nt.$obc);Ge.set(p.$TJ.ExtHostFileSystemInfo,Jt),Ge.set(p.$TJ.ExtHostLogLevelServiceShape,Te),Ge.set(p.$TJ.ExtHostWorkspace,dt),Ge.set(p.$TJ.ExtHostConfiguration,Ft),Ge.set(p.$TJ.ExtHostExtensionService,kt),Ge.set(p.$TJ.ExtHostStorage,zt),Ge.set(p.$TJ.ExtHostTunnelService,ie),Ge.set(p.$TJ.ExtHostWindow,He),Ge.set(p.$TJ.ExtHostSecretState,_e),Ge.set(p.$TJ.ExtHostTelemetry,Ct),Ge.set(p.$TJ.ExtHostEditorTabs,Je),Ge.set(p.$TJ.ExtHostManagedSockets,rt);const pt=Ge.set(p.$TJ.ExtHostDecorations,ct.get(U.$Ubc)),wt=Ge.set(p.$TJ.ExtHostDocumentsAndEditors,ct.get(c.$6L)),ft=Ge.set(p.$TJ.ExtHostCommands,ct.get(r.$eM)),gt=Ge.set(p.$TJ.ExtHostTerminalService,ct.get(z.$fbc)),mt=Ge.set(p.$TJ.ExtHostDebugService,ct.get(G.$3bc)),gi=Ge.set(p.$TJ.ExtHostSearch,ct.get(ce.$acc)),Ht=Ge.set(p.$TJ.ExtHostTask,ct.get(q.$Xbc)),Ei=Ge.set(p.$TJ.ExtHostOutputService,ct.get(h.$Abc)),Wt=Ge.set(p.$TJ.ExtHostLocalization,ct.get(nt.$nbc)),mi=Ge.set(p.$TJ.ExtHostUrls,new _.$Jbc(Ge)),It=Ge.set(p.$TJ.ExtHostDocuments,new o.$Hac(Ge,wt)),ki=Ge.set(p.$TJ.ExtHostDocumentContentProviders,new g.$2ac(Ge,wt,Se)),Vi=Ge.set(p.$TJ.ExtHostDocumentSaveParticipant,new t.$3ac(Se,It,Ge.getProxy(p.$SJ.MainThreadBulkEdits))),St=Ge.set(p.$TJ.ExtHostNotebook,new ge.$gcc(Ge,ft,wt,It,Pt)),ti=Ge.set(p.$TJ.ExtHostNotebookDocuments,new oe.$ycc(St)),$i=Ge.set(p.$TJ.ExtHostNotebookEditors,new le.$xcc(Se,St)),si=Ge.set(p.$TJ.ExtHostNotebookKernels,new Ae.$ucc(Ge,lt,St,ft,Se)),Si=Ge.set(p.$TJ.ExtHostNotebookRenderers,new Ve.$wcc(Ge,St)),Di=Ge.set(p.$TJ.ExtHostNotebookDocumentSaveParticipant,new vt.$Ecc(Se,St,Ge.getProxy(p.$SJ.MainThreadBulkEdits))),Lt=Ge.set(p.$TJ.ExtHostEditors,new j.$Hbc(Ge,wt)),bi=Ge.set(p.$TJ.ExtHostTreeViews,new F.$Ibc(Ge.getProxy(p.$SJ.MainThreadTreeViews),ft,Se)),Ci=Ge.set(p.$TJ.ExtHostEditorInsets,new ae.$Rbc(Ge.getProxy(p.$SJ.MainThreadEditorInsets),Lt,lt.remote)),oi=Ge.set(p.$TJ.ExtHostDiagnostics,new d.$Lac(Ge,Se,Jt,wt)),ai=Ge.set(p.$TJ.ExtHostLanguages,new E.$xbc(Ge,It,ft.converter,Et)),ut=Ge.set(p.$TJ.ExtHostLanguageFeatures,new v.$Pac(Ge,Et,It,ft,oi,Se,Fe,Ct)),qi=Ge.set(p.$TJ.ExtHostFileSystem,new a.$vbc(Ge,ut)),Yt=Ge.set(p.$TJ.ExtHostFileSystemEventService,new l.$wbc(Ge,Se,wt)),ii=Ge.set(p.$TJ.ExtHostQuickOpen,(0,L.$Cbc)(Ge,dt,ft)),pi=Ge.set(p.$TJ.ExtHostSCM,new O.$Ebc(Ge,ft,It,Se)),Ii=Ge.set(p.$TJ.ExtHostQuickDiff,new Dt.$Bcc(Ge,Et)),Hi=Ge.set(p.$TJ.ExtHostShare,new Kt.$Gcc(Ge,Et)),Pi=Ge.set(p.$TJ.ExtHostComments,(0,i.$Sac)(Ge,ft,It)),wi=Ge.set(p.$TJ.ExtHostProgress,new w.$Bbc(Ge.getProxy(p.$SJ.MainThreadProgress))),Ki=Ge.set(p.$TJ.ExtHosLabelService,new te.$Sbc(Ge)),Ai=Ge.set(p.$TJ.ExtHostTheming,new ne.$hcc(Ge)),ci=Ge.set(p.$TJ.ExtHostAuthentication,new Pe.$icc(Ge)),Ji=Ge.set(p.$TJ.ExtHostTimeline,new B.$kcc(Ge,ft)),vi=Ge.set(p.$TJ.ExtHostWebviews,new Q.$Mbc(Ge,lt.remote,dt,Se,Fe)),Ri=Ge.set(p.$TJ.ExtHostWebviewPanels,new fe.$mcc(Ge,vi,dt)),cn=Ge.set(p.$TJ.ExtHostCustomEditors,new Y.$ncc(Ge,It,Me,vi,Ri)),Li=Ge.set(p.$TJ.ExtHostWebviewViews,new se.$lcc(Ge,vi)),ni=Ge.set(p.$TJ.ExtHostTesting,new We.$pcc(Ge,ft,wt)),un=Ge.set(p.$TJ.ExtHostUriOpeners,new xe.$tcc(Ge)),ln=Ge.set(p.$TJ.ExtHostProfileContentHandlers,new bt.$Acc(Ge));Ge.set(p.$TJ.ExtHostInteractive,new Ie.$zcc(Ge,St,wt,ft,Se));const Gi=Ge.set(p.$TJ.ExtHostInlineChat,new Vt.$Dcc(Ge,ft,It,Se)),fi=Ge.set(p.$TJ.ExtHostChatProvider,new At.$Hcc(Ge,Se)),Zi=Ge.set(p.$TJ.ExtHostChatSlashCommands,new Rt.$Icc(Ge,fi,Se)),Qi=Ge.set(p.$TJ.ExtHostChatVariables,new Ot.$Jcc(Ge)),ui=Ge.set(p.$TJ.ExtHostChat,new Qt.$Ccc(Ge,Se)),Yi=Ge.set(p.$TJ.ExtHostAiRelatedInformation,new Ut.$Kcc(Ge)),Mi=Ge.set(p.$TJ.ExtHostAiEmbeddingVector,new qt.$Lcc(Ge)),Xi=Ge.set(p.$TJ.ExtHostIssueReporter,new Tt.$Fcc(Ge)),Xt=Ge.set(p.$TJ.ExtHostStatusBar,new N.$Gbc(Ge,ft.converter)),yi=Object.values(p.$TJ);Ge.assertRegistered(yi);const hn=new ye.$occ(Ge,wt),Gt=new y.$Rac(Ge),li=new u.$ybc(Ge,Se),Ti=new b.$1ac(Ge);return D.$Qac.register(ft),function(Ue,xt,Fi){const $t=function(){let pe=!Ue.isUnderDevelopment;function ke(){pe||(Se.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const yt=st;typeof yt.scheme>"u"&&ke(),typeof yt.exclusive=="boolean"&&(0,je.$MF)(Ue,"documentFiltersExclusive")}return st}}(),xi={getSession(pe,ke,Oe){return ci.getSession(Ue,pe,ke,Oe)},getSessions(pe,ke){return(0,je.$MF)(Ue,"authGetSessions"),ci.getSessions(Ue,pe,ke)},async hasSession(pe,ke){return(0,je.$MF)(Ue,"authSession"),!!await ci.getSession(Ue,pe,ke,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(pe,ke,Oe,st){return ci.registerAuthenticationProvider(pe,ke,Oe,st)}},_i={registerCommand(pe,ke,Oe){return ft.registerCommand(!0,pe,ke,Oe,void 0,Ue)},registerTextEditorCommand(pe,ke,Oe){return ft.registerCommand(!0,pe,(...st)=>{const yt=Lt.getActiveTextEditor();if(!yt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}return yt.edit(Mt=>{ke.apply(Oe,[yt,Mt,...st])}).then(Mt=>{Mt||Se.warn("Edits from command "+pe+" were not applied.")},Mt=>{Se.warn("An error occurred while running command "+pe,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(pe,ke,Oe)=>((0,je.$MF)(Ue,"diffCommand"),ft.registerCommand(!0,pe,async(...st)=>{const yt=wt.activeEditor(!0);if(!yt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(yt.id);ke.apply(Oe,[Mt,...st])},void 0,void 0,Ue)),executeCommand(pe,...ke){return ft.executeCommand(pe,...ke)},getCommands(pe=!1){return ft.getCommands(pe)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.$MF)(Ue,"envShellEvent"),gt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.$MF)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.$MF)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$bM)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return et.$aM.validateSender(pe),Ct.instantiateLogger(Ue,pe,ke)},openExternal(pe,ke){return He.openUri(pe,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===lt.environment.appUriScheme)return mi.createAppUri(pe);try{return await He.asExternalUri(pe,{allowTunneling:!!lt.remote.authority})}catch(ke){if((0,Qe.$DT)(pe,Le.Schemas.http)||(0,Qe.$DT)(pe,Le.Schemas.https))return pe;throw ke}},get remoteName(){return(0,X.$Nk)(lt.remote.authority)},get remoteAuthority(){return(0,je.$MF)(Ue,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,je.$MF)(Ue,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ue,pe)},get appQuality(){return(0,je.$MF)(Ue,"resolvers"),lt.quality},get appCommit(){return(0,je.$MF)(Ue,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(pe,ke,Oe){return ni.createTestController(Ue,pe,ke,Oe)},createTestObserver(){return(0,je.$MF)(Ue,"testObserver"),ni.createTestObserver()},runTests(pe){return(0,je.$MF)(Ue,"testObserver"),ni.runTests(pe)},get onDidChangeTestResults(){return(0,je.$MF)(Ue,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.$MF)(Ue,"testObserver"),ni.results}},hi=lt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,tn={getExtension(pe,ke){(0,je.$LF)(Ue,"extensionsAny")||(ke=!1);const Oe=xt.mine.getExtensionDescription(pe);if(Oe)return new n.$tbc(kt,Ue.identifier,Oe,hi,!1);if(ke){const st=xt.all.getExtensionDescription(pe);if(st)return new n.$tbc(kt,Ue.identifier,st,hi,!0)}},get all(){const pe=[];for(const ke of xt.mine.getAllExtensionDescriptions())pe.push(new n.$tbc(kt,Ue.identifier,ke,hi,!1));return pe},get allAcrossExtensionHosts(){(0,je.$MF)(Ue,"extensionsAny");const pe=new me.$Ul(xt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of xt.all.getAllExtensionDescriptions()){const st=!pe.has(Oe.identifier);ke.push(new n.$tbc(kt,Ue.identifier,Oe,hi,st))}return ke},get onDidChange(){return(0,je.$LF)(Ue,"extensionsAny")?f.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},nn={createDiagnosticCollection(pe){return oi.createDiagnosticCollection(Ue.identifier,pe)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:pe=>oi.getDiagnostics(pe),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(pe,ke){return ai.changeLanguage(pe.uri,ke)},match(pe,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,P.$$E)(K.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(pe,ke,Oe){return ut.registerCodeActionProvider(Ue,$t(pe),ke,Oe)},registerDocumentPasteEditProvider(pe,ke,Oe){return(0,je.$MF)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,$t(pe),ke,Oe)},registerCodeLensProvider(pe,ke){return ut.registerCodeLensProvider(Ue,$t(pe),ke)},registerDefinitionProvider(pe,ke){return ut.registerDefinitionProvider(Ue,$t(pe),ke)},registerDeclarationProvider(pe,ke){return ut.registerDeclarationProvider(Ue,$t(pe),ke)},registerImplementationProvider(pe,ke){return ut.registerImplementationProvider(Ue,$t(pe),ke)},registerTypeDefinitionProvider(pe,ke){return ut.registerTypeDefinitionProvider(Ue,$t(pe),ke)},registerHoverProvider(pe,ke){return ut.registerHoverProvider(Ue,$t(pe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(pe,ke){return ut.registerEvaluatableExpressionProvider(Ue,$t(pe),ke,Ue.identifier)},registerInlineValuesProvider(pe,ke){return ut.registerInlineValuesProvider(Ue,$t(pe),ke,Ue.identifier)},registerDocumentHighlightProvider(pe,ke){return ut.registerDocumentHighlightProvider(Ue,$t(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return ut.registerLinkedEditingRangeProvider(Ue,$t(pe),ke)},registerReferenceProvider(pe,ke){return ut.registerReferenceProvider(Ue,$t(pe),ke)},registerRenameProvider(pe,ke){return ut.registerRenameProvider(Ue,$t(pe),ke)},registerDocumentSymbolProvider(pe,ke,Oe){return ut.registerDocumentSymbolProvider(Ue,$t(pe),ke,Oe)},registerWorkspaceSymbolProvider(pe){return ut.registerWorkspaceSymbolProvider(Ue,pe)},registerDocumentFormattingEditProvider(pe,ke){return ut.registerDocumentFormattingEditProvider(Ue,$t(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return ut.registerDocumentRangeFormattingEditProvider(Ue,$t(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,$t(pe),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(pe,ke,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,$t(pe),ke,Oe)},registerDocumentRangeSemanticTokensProvider(pe,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,$t(pe),ke,Oe)},registerSignatureHelpProvider(pe,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,$t(pe),ke,Oe):ut.registerSignatureHelpProvider(Ue,$t(pe),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(pe,ke,...Oe){return ut.registerCompletionItemProvider(Ue,$t(pe),ke,Oe)},registerInlineCompletionItemProvider(pe,ke,Oe){return ke.handleDidShowCompletionItem&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),Oe&&(0,je.$MF)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,$t(pe),ke,Oe)},registerDocumentLinkProvider(pe,ke){return ut.registerDocumentLinkProvider(Ue,$t(pe),ke)},registerColorProvider(pe,ke){return ut.registerColorProvider(Ue,$t(pe),ke)},registerFoldingRangeProvider(pe,ke){return ut.registerFoldingRangeProvider(Ue,$t(pe),ke)},registerSelectionRangeProvider(pe,ke){return ut.registerSelectionRangeProvider(Ue,pe,ke)},registerCallHierarchyProvider(pe,ke){return ut.registerCallHierarchyProvider(Ue,pe,ke)},registerTypeHierarchyProvider(pe,ke){return ut.registerTypeHierarchyProvider(Ue,pe,ke)},setLanguageConfiguration:(pe,ke)=>ut.setLanguageConfiguration(Ue,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,je.$MF)(Ue,"tokenInformation"),ai.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return ut.registerInlayHintsProvider(Ue,pe,ke)},createLanguageStatusItem(pe,ke){return ai.createLanguageStatusItem(Ue,pe,ke)},registerDocumentDropEditProvider(pe,ke,Oe){return ut.registerDocumentOnDropEditProvider(Ue,pe,ke,(0,je.$LF)(Ue,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(pe,ke,Oe){const st=await(A.URI.isUri(pe)?Promise.resolve(sn.openTextDocument(pe)):Promise.resolve(pe));return Lt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(pe){return Lt.createTextEditorDecorationType(Ue,pe)},onDidChangeActiveTextEditor(pe,ke,Oe){return Lt.onDidChangeActiveTextEditor(pe,ke,Oe)},onDidChangeVisibleTextEditors(pe,ke,Oe){return Lt.onDidChangeVisibleTextEditors(pe,ke,Oe)},onDidChangeTextEditorSelection(pe,ke,Oe){return Lt.onDidChangeTextEditorSelection(pe,ke,Oe)},onDidChangeTextEditorOptions(pe,ke,Oe){return Lt.onDidChangeTextEditorOptions(pe,ke,Oe)},onDidChangeTextEditorVisibleRanges(pe,ke,Oe){return Lt.onDidChangeTextEditorVisibleRanges(pe,ke,Oe)},onDidChangeTextEditorViewColumn(pe,ke,Oe){return Lt.onDidChangeTextEditorViewColumn(pe,ke,Oe)},onDidCloseTerminal(pe,ke,Oe){return gt.onDidCloseTerminal(pe,ke,Oe)},onDidOpenTerminal(pe,ke,Oe){return gt.onDidOpenTerminal(pe,ke,Oe)},onDidChangeActiveTerminal(pe,ke,Oe){return gt.onDidChangeActiveTerminal(pe,ke,Oe)},onDidChangeTerminalDimensions(pe,ke,Oe){return(0,je.$MF)(Ue,"terminalDimensions"),gt.onDidChangeTerminalDimensions(pe,ke,Oe)},onDidChangeTerminalState(pe,ke,Oe){return gt.onDidChangeTerminalState(pe,ke,Oe)},onDidWriteTerminalData(pe,ke,Oe){return(0,je.$MF)(Ue,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(pe,ke,Oe)},onDidExecuteTerminalCommand(pe,ke,Oe){return(0,je.$MF)(Ue,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(pe,ke,Oe)},get state(){return He.getState(Ue)},onDidChangeWindowState(pe,ke,Oe){return He.onDidChangeWindowState(pe,ke,Oe)},showInformationMessage(pe,...ke){return li.showMessage(Ue,R.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return li.showMessage(Ue,R.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return li.showMessage(Ue,R.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,Oe){return ii.showQuickPick(Ue,pe,ke,Oe)},showWorkspaceFolderPick(pe){return ii.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ii.showInput(pe,ke)},showOpenDialog(pe){return Ti.showOpenDialog(Ue,pe)},showSaveDialog(pe){return Ti.showSaveDialog(pe)},createStatusBarItem(pe,ke,Oe){let st,yt,Mt;return typeof pe=="string"?(st=pe,yt=ke,Mt=Oe):(yt=pe,Mt=ke),Xt.createStatusBarEntry(Ue,st,yt,Mt)},setStatusBarMessage(pe,ke){return Xt.setStatusBarMessage(pe,ke)},withScmProgress(pe){return Fe.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),wi.withProgress(Ue,{location:H.ProgressLocation.SourceControl},(ke,Oe)=>pe({report(st){}}))},withProgress(pe,ke){return wi.withProgress(Ue,pe,ke)},createOutputChannel(pe,ke){return Ei.createOutputChannel(pe,ke,Ue)},createWebviewPanel(pe,ke,Oe,st){return Ri.createWebviewPanel(Ue,pe,ke,Oe,st)},createWebviewTextEditorInset(pe,ke,Oe,st){return(0,je.$MF)(Ue,"editorInsets"),Ci.createWebviewEditorInset(pe,ke,Oe,st,Ue)},createTerminal(pe,ke,Oe){return typeof pe=="object"?"pty"in pe?gt.createExtensionTerminal(pe):gt.createTerminalFromOptions(pe):gt.createTerminal(pe,ke,Oe)},registerTerminalLinkProvider(pe){return gt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return gt.registerProfileProvider(Ue,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,je.$MF)(Ue,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(pe,Ue.identifier.value,ke)},registerTreeDataProvider(pe,ke){return bi.registerTreeDataProvider(pe,ke,Ue)},createTreeView(pe,ke){return bi.createTreeView(pe,ke,Ue)},registerWebviewPanelSerializer:(pe,ke)=>Ri.registerWebviewPanelSerializer(Ue,pe,ke),registerCustomEditorProvider:(pe,ke,Oe={})=>cn.registerCustomEditorProvider(Ue,pe,ke,Oe),registerFileDecorationProvider(pe){return pt.registerFileDecorationProvider(pe,Ue)},registerUriHandler(pe){return mi.registerUriHandler(Ue,pe)},createQuickPick(){return ii.createQuickPick(Ue)},createInputBox(){return ii.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,Oe){return Ai.onDidChangeActiveColorTheme(pe,ke,Oe)},registerWebviewViewProvider(pe,ke,Oe){return Li.registerWebviewViewProvider(Ue,pe,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,Oe){return St.onDidChangeActiveNotebookEditor(pe,ke,Oe)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,Oe){return $i.onDidChangeNotebookEditorSelection(pe,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(pe,ke,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(pe,ke,Oe)},showNotebookDocument(pe,ke){return St.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,Oe){return(0,je.$MF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,pe,ke,Oe)},registerProfileContentHandler(pe,ke){return(0,je.$MF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,pe,ke)},registerQuickDiffProvider(pe,ke,Oe,st){return(0,je.$MF)(Ue,"quickDiffProvider"),Ii.registerQuickDiffProvider($t(pe),ke,Oe,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(pe,ke){return(0,je.$MF)(Ue,"shareProvider"),Hi.registerShareProvider($t(pe),ke)}},sn={get rootPath(){return Fe.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(pe){throw new T.$7("rootPath")},getWorkspaceFolder(pe){return dt.getWorkspaceFolder(pe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(pe){throw new T.$7("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(pe){throw new T.$7("workspaceFile")},updateWorkspaceFolders:(pe,ke,...Oe)=>dt.updateWorkspaceFolders(Ue,pe,ke||0,...Oe),onDidChangeWorkspaceFolders:function(pe,ke,Oe){return dt.onDidChangeWorkspace(pe,ke,Oe)},asRelativePath:(pe,ke)=>dt.getRelativePath(pe,ke),findFiles:(pe,ke,Oe,st)=>dt.findFiles(pe,ke,Oe,Ue.identifier,st),findTextInFiles:(pe,ke,Oe,st)=>{(0,je.$MF)(Ue,"findTextInFiles");let yt,Mt;return typeof ke=="object"?(yt=ke,Mt=Oe):(yt={},Mt=ke,st=Oe),dt.findTextInFiles(pe,yt||{},Mt,Ue.identifier,st)},save:pe=>((0,je.$MF)(Ue,"saveEditor"),dt.save(pe)),saveAs:pe=>((0,je.$MF)(Ue,"saveEditor"),dt.saveAs(pe)),saveAll:pe=>dt.saveAll(pe),applyEdit(pe,ke){return hn.applyWorkspaceEdit(pe,Ue,ke)},createFileSystemWatcher:(pe,ke,Oe,st)=>Yt.createFileSystemWatcher(dt,Ue,pe,ke,Oe,st),get textDocuments(){return It.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new T.$7("textDocuments")},openTextDocument(pe){let ke;const Oe=pe;if(typeof pe=="string")ke=Promise.resolve(A.URI.file(pe));else if(A.URI.isUri(pe))ke=Promise.resolve(pe);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(pe,ke,Oe)=>It.onDidAddDocument(pe,ke,Oe),onDidCloseTextDocument:(pe,ke,Oe)=>It.onDidRemoveDocument(pe,ke,Oe),onDidChangeTextDocument:(pe,ke,Oe)=>It.onDidChangeDocument(pe,ke,Oe),onDidSaveTextDocument:(pe,ke,Oe)=>It.onDidSaveDocument(pe,ke,Oe),onWillSaveTextDocument:(pe,ke,Oe)=>Vi.getOnWillSaveTextDocumentEvent(Ue)(pe,ke,Oe),get notebookDocuments(){return St.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let Oe;if(A.URI.isUri(pe))Oe=pe,await St.openNotebookDocument(pe);else if(typeof pe=="string")Oe=A.URI.revive(await St.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(pe,ke,Oe){return ti.onDidSaveNotebookDocument(pe,ke,Oe)},onDidChangeNotebookDocument(pe,ke,Oe){return ti.onDidChangeNotebookDocument(pe,ke,Oe)},onWillSaveNotebookDocument(pe,ke,Oe){return Di.getOnWillSaveNotebookDocumentEvent(Ue)(pe,ke,Oe)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,Oe,st){return St.registerNotebookSerializer(Ue,pe,ke,Oe,(0,je.$LF)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(pe,ke,Oe)=>Fi.onDidChangeConfiguration(pe,ke,Oe),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,Fi.getConfiguration(pe,ke,Ue)},registerTextDocumentContentProvider(pe,ke){return ki.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(Fe.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Ue,pe,ke)),registerFileSystemProvider(pe,ke,Oe){return(0,qe.$jb)(qi.registerFileSystemProvider(Ue,pe,ke,Oe),Pt.addFileSystemProvider(pe,ke,Oe))},get fs(){return Pt.value},registerFileSearchProvider:(pe,ke)=>((0,je.$MF)(Ue,"fileSearchProvider"),gi.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,je.$MF)(Ue,"textSearchProvider"),gi.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,je.$MF)(Ue,"resolvers"),kt.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,je.$MF)(Ue,"resolvers"),Ki.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,je.$MF)(Ue,"resolvers"),kt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,Oe)=>Yt.onDidCreateFile(pe,ke,Oe),onDidDeleteFiles:(pe,ke,Oe)=>Yt.onDidDeleteFile(pe,ke,Oe),onDidRenameFiles:(pe,ke,Oe)=>Yt.onDidRenameFile(pe,ke,Oe),onWillCreateFiles:(pe,ke,Oe)=>Yt.getOnWillCreateFileEvent(Ue)(pe,ke,Oe),onWillDeleteFiles:(pe,ke,Oe)=>Yt.getOnWillDeleteFileEvent(Ue)(pe,ke,Oe),onWillRenameFiles:(pe,ke,Oe)=>Yt.getOnWillRenameFileEvent(Ue)(pe,ke,Oe),openTunnel:pe=>((0,je.$MF)(Ue,"tunnels"),ie.openTunnel(Ue,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,je.$MF)(Ue,"tunnels"),ie.getTunnels()},onDidChangeTunnels:(pe,ke,Oe)=>((0,je.$MF)(Ue,"tunnels"),ie.onDidChangeTunnels(pe,ke,Oe)),registerPortAttributesProvider:(pe,ke)=>((0,je.$MF)(Ue,"portsAttributes"),ie.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,je.$MF)(Ue,"tunnelFactory"),ie.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,je.$MF)(Ue,"timeline"),Ji.registerTimelineProvider(pe,ke,Ue.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:pe=>((0,je.$MF)(Ue,"workspaceTrust"),dt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,Oe)=>dt.onDidGrantWorkspaceTrust(pe,ke,Oe),registerEditSessionIdentityProvider:(pe,ke)=>((0,je.$MF)(Ue,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,Oe)=>((0,je.$MF)(Ue,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ue)(pe,ke,Oe)),registerCanonicalUriProvider:(pe,ke)=>((0,je.$MF)(Ue,"canonicalUriProvider"),dt.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,Oe)=>((0,je.$MF)(Ue,"canonicalUriProvider"),dt.provideCanonicalUri(pe,ke,Oe))},fn={get inputBox(){return Fe.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Ue)},createSourceControl(pe,ke,Oe){return pi.createSourceControl(Ue,pe,ke,Oe)}},on={createCommentController(pe,ke){return Pi.createCommentController(Ue,pe,ke)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(pe,ke,Oe){return mt.onDidStartDebugSession(pe,ke,Oe)},onDidTerminateDebugSession(pe,ke,Oe){return mt.onDidTerminateDebugSession(pe,ke,Oe)},onDidChangeActiveDebugSession(pe,ke,Oe){return mt.onDidChangeActiveDebugSession(pe,ke,Oe)},onDidReceiveDebugSessionCustomEvent(pe,ke,Oe){return mt.onDidReceiveDebugSessionCustomEvent(pe,ke,Oe)},onDidChangeBreakpoints(pe,ke,Oe){return mt.onDidChangeBreakpoints(pe,ke,Oe)},onDidChangeStackFrameFocus(pe,ke,Oe){return(0,je.$MF)(Ue,"debugFocus"),mt.onDidChangeStackFrameFocus(pe,ke,Oe)},registerDebugConfigurationProvider(pe,ke,Oe){return mt.registerDebugConfigurationProvider(pe,ke,Oe||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return mt.registerDebugAdapterDescriptorFactory(Ue,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return mt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?mt.startDebugging(pe,ke,{parentSession:Oe}):mt.startDebugging(pe,ke,Oe||{})},stopDebugging(pe){return mt.stopDebugging(pe)},addBreakpoints(pe){return mt.addBreakpoints(pe)},removeBreakpoints(pe){return mt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return mt.asDebugSourceUri(pe,ke)}},Ni={registerTaskProvider:(pe,ke)=>Ht.registerTaskProvider(Ue,pe,ke),fetchTasks:pe=>Ht.fetchTasks(pe),executeTask:pe=>Ht.executeTask(Ue,pe),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(pe,ke,Oe)=>Ht.onDidStartTask(pe,ke,Oe),onDidEndTask:(pe,ke,Oe)=>Ht.onDidEndTask(pe,ke,Oe),onDidStartTaskProcess:(pe,ke,Oe)=>Ht.onDidStartTaskProcess(pe,ke,Oe),onDidEndTaskProcess:(pe,ke,Oe)=>Ht.onDidEndTaskProcess(pe,ke,Oe)},Oi={createNotebookController(pe,ke,Oe,st,yt){return si.createNotebookController(Ue,pe,ke,Oe,st,(0,je.$LF)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>St.registerNotebookCellStatusBarItemProvider(Ue,pe,ke),createRendererMessaging(pe){return Si.createRendererMessaging(Ue,pe)},createNotebookControllerDetectionTask(pe){return(0,je.$MF)(Ue,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Ue,pe)},registerKernelSourceActionProvider(pe,ke){return(0,je.$MF)(Ue,"notebookKernelSource"),si.registerKernelSourceActionProvider(Ue,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,Oe){return(0,je.$MF)(Ue,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(pe,ke,Oe)}},zi={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),Oe=!pe||typeof pe[0]!="object"?pe:pe[0];return Wt.getMessage(Ue.identifier.value,{message:ke,args:Oe})}return Wt.getMessage(Ue.identifier.value,pe[0])},get bundle(){return Wt.getBundle(Ue.identifier.value)},get uri(){return Wt.getBundleUri(Ue.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,je.$MF)(Ue,"interactive"),Gi.registerProvider(Ue,pe,ke={label:pe.label??Ue.displayName??Ue.name})},registerInteractiveSessionProvider(pe,ke){return(0,je.$MF)(Ue,"interactive"),ui.registerChatProvider(Ue,pe,ke)},addInteractiveRequest(pe){return(0,je.$MF)(Ue,"interactive"),ui.addChatRequest(pe)},sendInteractiveRequestToProvider(pe,ke){return(0,je.$MF)(Ue,"interactive"),ui.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,je.$MF)(Ue,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(pe,ke){return(0,je.$MF)(Ue,"interactive"),ui.transferChatSession(pe,ke)}},ji={getRelatedInformation(pe,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,je.$MF)(Ue,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(Ue,pe,ke)}},Ui={registerChatResponseProvider(pe,ke,Oe){return(0,je.$MF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,pe,ke,Oe)},registerSlashCommand(pe,ke,Oe){return(0,je.$MF)(Ue,"chatSlashCommands"),Zi.registerCommand(Ue.identifier,pe,ke,Oe??{description:""})},requestChatAccess(pe){return(0,je.$MF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,pe)},registerVariable(pe,ke,Oe){return(0,je.$MF)(Ue,"chatVariables"),Qi.registerVariableResolver(Ue,pe,ke,Oe)},registerMappedEditsProvider(pe,ke){return(0,je.$MF)(Ue,"mappedEditsProvider"),ut.registerMappedEditsProvider(Ue,pe,ke)}};return{version:lt.version,ai:ji,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:H.$TK,TerminalOutputAnchor:H.TerminalOutputAnchor,ChatMessage:H.$JL,ChatMessageRole:H.ChatMessageRole,ChatVariableLevel:H.ChatVariableLevel,CallHierarchyIncomingCall:H.$gK,CallHierarchyItem:H.$fK,CallHierarchyOutgoingCall:H.$hK,CancellationError:T.$3,CancellationTokenSource:C.$rc,CandidatePortSource:p.CandidatePortSource,CodeAction:H.$bK,CodeActionKind:H.$cK,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$iK,Color:H.$vK,ColorInformation:H.$wK,ColorPresentation:H.$xK,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.$pK,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$qK,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$FK,DebugAdapterExecutable:H.$XK,DebugAdapterInlineImplementation:H.$1K,DebugAdapterNamedPipeServer:H.$ZK,DebugAdapterServer:H.$YK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$9J,DiagnosticRelatedInformation:H.$8J,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$UJ,DocumentHighlight:H.$$J,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.$uK,DocumentSymbol:H.$aK,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$4K,InlineValueText:H.$5K,InlineValueVariableLookup:H.$6K,InlineValueEvaluatableExpression:H.$7K,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:f.$hc,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$eL,FileDecoration2:H.$eL,FileSystemError:H.$9K,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:H.$0K,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$VK,InlineCompletionItem:H.$rK,InlineCompletionList:H.$sK,Hover:H.$0J,IndentAction:$.IndentAction,Location:H.$7J,MarkdownString:H.$jK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.$kK,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$VJ,ProcessExecution:H.$DK,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$dL,Range:H.$WJ,RelativePattern:H.$RK,Selection:H.$XJ,SelectionRange:H.$eK,SemanticTokens:H.$aL,SemanticTokensBuilder:H.$_K,SemanticTokensEdit:H.$bL,SemanticTokensEdits:H.$cL,SemanticTokensLegend:H.$$K,ShellExecution:H.$EK,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$mK,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$lK,SnippetString:H.$6J,SourceBreakpoint:H.$UK,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$_J,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$GK,TaskGroup:H.$CK,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$yK,TerminalQuickFixExecuteTerminalCommand:H.$AK,TerminalQuickFixOpener:H.$zK,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$BK,TerminalExitReason:H.TerminalExitReason,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$2J,SnippetTextEdit:H.$4J,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$QK,ThemeIcon:H.$PK,TreeItem:H.$HK,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$zL,UIKind:k.UIKind,Uri:A.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$5J,DocumentDropEdit:H.$NK,DocumentPasteEdit:H.$OK,InlayHint:H.$oK,InlayHintLabelPart:H.$nK,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$1J,ResolvedAuthority:H.$YJ,ManagedResolvedAuthority:H.$ZJ,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$oL,NotebookRange:H.$gL,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$hL,NotebookData:H.$iL,NotebookRendererScript:H.$mL,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$kL,NotebookCellOutputItem:H.$jL,NotebookCellStatusBarItem:H.$lL,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$3J,NotebookKernelSourceAction:H.$nL,PortAttributes:H.$qL,LinkedEditingRanges:H.$pL,TestResultState:H.TestResultState,TestRunRequest:H.$rL,TestMessage:H.$sL,TestMessage2:H.$sL,TestTag:H.$tL,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:H.$MK,DataTransferItem:H.$IK,CoveredCount:H.$uL,FileCoverage:H.$vL,StatementCoverage:H.$wL,BranchCoverage:H.$xL,FunctionCoverage:H.$yL,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$AL,TabInputTextDiff:H.$BL,TabInputTextMerge:H.$CL,TabInputCustom:H.$DL,TabInputNotebook:H.$FL,TabInputNotebookDiff:H.$GL,TabInputWebview:H.$EL,TabInputTerminal:H.$HL,TabInputInteractiveWindow:H.$IL,TelemetryTrustedValue:$e.$0n,LogLevel:re.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:H.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,StackFrameFocus:H.$2K,ThreadFocus:H.$3K,NotebookCodeActionKind:H.$dK,RelatedInformationType:H.RelatedInformationType}}}e.$Mcc=Bt}),define(De[355],Ce([1,0,104,152,39,149,40,33,69,44,94,95,96,115,72,90,151,71,54,114,89,70,150,14,55,112,113]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o,c,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$jr)(n.$nbc,n.$mbc,1),(0,C.$jr)(o.$4i,t.$Ncc,1),(0,C.$jr)(y.$Mac,y.$Nac,1),(0,C.$jr)(m.$eM,m.$dM,0),(0,C.$jr)(A.$Zac,A.$Xac,0),(0,C.$jr)(i.$cbc,i.$bbc,0),(0,C.$jr)(I.$3bc,I.$7bc,0),(0,C.$jr)(R.$Ubc,R.$Tbc,0),(0,C.$jr)(S.$6L,S.$5L,0),(0,C.$jr)(a.$obc,a.$pbc,0),(0,C.$jr)(s.$Jac,s.$Iac,0),(0,C.$jr)(T.$Abc,T.$zbc,1),(0,C.$jr)(p.$acc,p.$bcc,0),(0,C.$jr)(k.$$ac,k.$0ac,0),(0,C.$jr)(P.$Xbc,P.$Wbc,0),(0,C.$jr)($.$fbc,$.$ibc,0),(0,C.$jr)(D.$csb,D.$dsb,0),(0,C.$jr)(r.$Qbc,r.$Pbc,0),(0,C.$jr)(f.$Wac,f.$Vac,0),(0,C.$jr)(d.$kbc,d.$jbc,0),(0,C.$jr)(b.$cM,b.$_L,0),(0,C.$jr)(g.$Ybc,g.$Zbc,0),(0,C.$jr)(c.$1bc,c.$2bc,0)}),define(De[116],Ce([1,0,19,14,36,93]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=e.$4cc=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$4cc=A;function m(I,p,k,D){const y=(0,C.$Uf)(k,S),r=new f.$jI(p,y,D),i=r.preview.matches;return{ranges:(0,C.$Uf)(y,$),uri:I,preview:{text:r.preview.text,matches:(0,C.$Uf)(i,$)}}}e.$5cc=m;function S(I){return new f.$kI(I.start.line,I.start.character,I.end.line,I.end.character)}function $(I){return new R.$$H(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(p,k){this.a=p,this.b=k}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$6cc=P,e.$6cc=P=Ke([Be(1,T.$3i)],P)}),define(De[356],Ce([1,0,48,16,76,32,12,15,116,357]),function(be,e,C,T,f,R,A,m,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=void 0;const P=$.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(d,b,g,t){const o=p(d,b,g,t),c=b.folder.fsPath;return{cmd:C.spawn(P,o.args,{cwd:c}),rgDiskPath:P,siblingClauses:o.siblingClauses,rgArgs:o,cwd:c}}e.$7cc=I;function p(d,b,g,t){const o=["--files","--hidden","--case-sensitive","--no-require-git"];D([b],g,!1).forEach(n=>{const a=(0,S.$4cc)(n);if(o.push("-g",a),A.$j){const l=(0,f.$gl)(a);l!==a&&o.push("-g",l)}});const c=k([b],t,void 0,!1);return c.globArgs.forEach(n=>{const a=`!${(0,S.$4cc)(n)}`;if(o.push("-g",a),A.$j){const l=(0,f.$gl)(a);l!==a&&o.push("-g",l)}}),b.disregardIgnoreFiles!==!1?o.push("--no-ignore"):b.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),b.ignoreSymlinks||o.push("--follow"),d.exists&&o.push("--quiet"),o.push("--no-config"),b.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:c.siblingClauses}}function k(d,b,g,t=!0){const o=[];let c={};return d.forEach(n=>{const a=Object.assign({},n.excludePattern||{},b||{}),l=y(a,t?n.folder.fsPath:void 0,g);o.push(...l.globArgs),l.siblingClauses&&(c=Object.assign(c,l.siblingClauses))}),{globArgs:o,siblingClauses:c}}function D(d,b,g=!0){const t=[];return d.forEach(o=>{const c=Object.assign({},b||{},o.includePattern||{}),n=y(c,g?o.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function y(d,b,g){const t=[],o={};return Object.keys(d).forEach(c=>{if(g&&g.has(c)||!c)return;const n=d[c];c=i(b?r(b,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof n=="boolean"&&n?(c.startsWith("\\\\")&&(c+="**"),t.push(s(c))):n&&n.when&&(o[c]=n)}),{globArgs:t,siblingClauses:o}}function r(d,b){return T.$0c(b)?b:T.$$c(d,b)}e.$8cc=r;function i(d){return d=m.$xd(d,"\\"),m.$xd(d,"/")}function s(d){return R.$Ge(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.$9cc=s}),define(De[358],Ce([1,0,48,52,16,359,19,46,35,76,32,12,37,15,18,29,36,356,127]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;const d=new Set;process.on("exit",()=>{d.forEach(c=>c())});class b{constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&S.$pj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,s.$lq)(this.b).normalizedLowercase),this.u=n.excludePattern&&S.$pj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(a=>{const l=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),v=a.folder.fsPath;n.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==v).forEach(E=>{(0,P.$Ke)(E,v)&&(l[f.$ad(v,E)]=!0)}),this.t.set(v,new t(l,v))})}cancel(){this.l=!0,d.forEach(n=>n())}walk(n,a,l,v,E){if(this.m=p.$dc.create(!1),this.l)return E(null,this.j);a.forEach(u=>{const h=f.$cd(u.fsPath);this.u&&this.u(u.fsPath,h)||this.J(l,{relativePath:u.fsPath,searchPath:void 0})}),this.r=p.$dc.create(!1),this.w(n,(u,h)=>{this.x(this.y,this,u,l,v,w=>{if(w){const L=(0,m.$ki)(w);console.error(L),this.q.push(L),h(w,void 0)}else h(null,void 0)})},(u,h)=>{this.m.stop();const w=u?A.$Af(u)[0]:null;E(w,this.j)})}w(n,a,l){const v=new Array(n.length),E=new Array(n.length);let u=!1,h=0;if(n.length===0)return l(null,[]);n.forEach((w,L)=>{a(w,(O,N)=>{if(O?(u=!0,v[L]=null,E[L]=O):(v[L]=N,E[L]=null),++h===n.length)return l(u?E:null,v)})})}x(n,a,...l){try{n.apply(a,l)}catch(v){l[l.length-1](v)}}y(n,a,l,v){const E=n.folder.fsPath,u=I.$j,h=()=>M&&M.kill();d.add(h);let w=K=>{d.delete(h),w=()=>{},v(K)},L="";const O=this.D(),N=(0,i.$7cc)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),M=N.cmd,z=!Object.keys(N.siblingClauses).length,j=N.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let F=`${N.rgDiskPath} ${j}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),l({message:F}),this.s=0,this.z(M,"utf8",l,(K,H,$e)=>{if(K){w(K);return}if(this.j){w();return}const Q=(L+(u?$.$fl(H||""):H)).split(`
`);if($e){const V=Q.length;Q[V-1]=Q[V-1].trim(),Q[V-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const V of Q)if(this.J(a,{base:E,relativePath:V,searchPath:this.N(n,V)}),this.j){h();break}($e||this.j)&&w();return}this.G(n,O,E,Q,a),$e&&(this.H(O,E,a),w())})}spawnFindCmd(n){const a=this.t.get(n.folder.fsPath),l=a.getBasenameTerms(),v=a.getPathTerms(),E=["-L","."];if(l.length||v.length){E.push("-not","(","(");for(const u of l)E.push("-name",u),E.push("-o");for(const u of v)E.push("-path",u),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),C.spawn("find",E,{cwd:n.folder.fsPath})}readStdout(n,a,l){let v="";this.z(n,a,()=>{},(E,u,h)=>{if(E){l(E);return}v+=u,h&&l(null,v)})}z(n,a,l,v){let E=(w,L,O)=>{(w||O)&&(E=()=>{},this.r?.stop()),v(w,L,O)},u=!1;n.stdout?(this.A(n.stdout,a,E),n.stdout.once("data",()=>u=!0)):l({message:"stdout is null"});let h;n.stderr?h=this.B(n.stderr):l({message:"stderr is null"}),n.on("error",w=>{E(w)}),n.on("close",w=>{let L;!u&&(L=this.C(h,a))&&o(L)?E(new Error(`command failed with error code ${w}: ${this.C(h,a)}`)):(this.g&&w===0&&(this.j=!0),E(null,"",!0))})}A(n,a,l){const v=new R.StringDecoder(a);return n.on("data",E=>{l(null,v.write(E))}),v}B(n){const a=[];return n.on("data",l=>{a.push(l)}),a}C(n,a){const l=new R.StringDecoder(a);return n.map(v=>l.write(v)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:a},l,v,E){v.indexOf(this.b)!==-1&&this.J(E,{base:l,relativePath:this.b,searchPath:this.N(n,this.b)});const u=h=>{const w=f.$cd(h),L=f.$bd(h);let O=a[L];O||(O=a[L]=[],u(L)),O.push({base:l,relativePath:h,basename:w,searchPath:this.N(n,h)})};v.forEach(u)}H({rootEntries:n,pathToEntries:a},l,v){const E=this,u=this.t.get(l),h=this.b;function w(L){E.o++;const O=(0,r.$zI)(()=>L.map(N=>N.basename));for(let N=0,M=L.length;N<M;N++){const z=L[N],{relativePath:j,basename:F}=z;if(u.test(j,F,h!==F?O:void 0))continue;const K=a[j];if(K)w(K);else{if(E.p++,j===h)continue;E.J(v,z)}if(E.j)break}}w(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,a,l,v,E){const u=n.folder,h=(0,r.$zI)(()=>l);this.w(l,(w,L)=>{if(this.l||this.j)return L(null);const O=a?[a,w].join(f.sep):w;if(this.t.get(n.folder.fsPath).test(O,w,this.a.filePattern!==w?h:void 0))return L(null);const N=[u.fsPath,O].join(f.sep);T.lstat(N,(M,z)=>{if(M||this.l||this.j)return L(null);this.L(N,z,(j,F)=>j||this.l||this.j?L(null):F.isDirectory()?(this.o++,this.M(N,z,(K,H)=>K||this.l||this.j||(H=H||"",this.v[H])?L(null):(this.v[H]=!0,y.Promises.readdir(N).then($e=>{if(this.l||this.j)return L(null);this.I(n,O,$e,v,_=>L(_||null))},$e=>{L(null)})))):(this.p++,O===this.b||this.h&&D.$pe(F.size)&&F.size>this.h||this.J(v,{base:u.fsPath,relativePath:O,searchPath:this.N(n,O)}),L(null,void 0)))})},w=>{const L=w&&A.$Af(w);return E(L&&L.length>0?L[0]:void 0)})}J(n,a){this.K(a)&&(!this.d||this.d(a.relativePath,f.$cd(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(a))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.$uI)(n,this.c)}return!0}L(n,a,l){return a.isSymbolicLink()?T.stat(n,l):l(null,a)}M(n,a,l){return a.isSymbolicLink()?T.realpath(n,(v,E)=>v?l(v):l(null,E)):l(null,n)}N(n,a){return n.folderName?f.$$c(n.folderName,a):a}}e.$0cc=b;class g{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new b(n)}search(n,a,l){this.c.walk(this.a,this.b,n,a,(v,E)=>{l(v,{limitHit:E,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$$cc=g;class t{constructor(n,a){this.expression=n,this.c=a,this.d(n)}d(n){let a,l;Object.keys(n).filter(v=>n[v]).forEach(v=>{f.$0c(v)?(a=a||S.$kj(),a[v]=n[v]):(l=l||S.$kj(),l[v]=n[v])}),this.a=a&&S.$pj(a,{trimForExclusions:!0}),this.b=l&&S.$pj(l,{trimForExclusions:!0})}test(n,a,l){return this.b&&this.b(n,a,l)||this.a&&this.a(f.$$c(this.c,n),a,l)}getBasenameTerms(){const n=[];return this.a&&n.push(...S.$rj(this.a)),this.b&&n.push(...S.$rj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...S.$sj(this.a)),this.b&&n.push(...S.$sj(this.b)),n}}function o(c){const n=c.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return k.$de(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(De[360],Ce([1,0,97,22,182,21]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=e.DecodeStreamErrorKind=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=void 0,e.$0C="utf8",e.$$C="utf8bom",e.$_C="utf16be",e.$aD="utf16le";function A(a){return[e.$0C,e.$$C,e.$_C,e.$aD].some(l=>l===a)}e.$bD=A,e.$cD=[254,255],e.$dD=[255,254],e.$eD=[239,187,191];const m=512,S=512,$=512*8,P=512*128;var I;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(l,v){super(l),this.decodeStreamErrorKind=v}}e.$fD=p;class k{static async create(l){let v;if(l!==e.$0C)v=(await(0,f.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(i(l));else{const E=new TextDecoder;v={write(u){return E.decode(u,{stream:!0})},end(){return E.decode()}}}return new k(v)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function D(a,l){const v=l.minBytesRequiredForDetection??l.guessEncoding?$:S;return new Promise((E,u)=>{const h=(0,C.$vc)(z=>z.join("")),w=[];let L=0,O;const N=new R.$rc,M=async()=>{try{const z=await n({buffer:T.$Hc.concat(w),bytesRead:L},l.guessEncoding);if(z.seemsBinary&&l.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await l.overwriteEncoding(z.encoding),O=await k.create(z.encoding);const j=O.write(T.$Hc.concat(w).buffer);h.write(j),w.length=0,L=0,E({stream:h,detected:z})}catch(z){N.cancel(),h.destroy(),u(z)}};(0,C.$zc)(a,{onData:async z=>{O?h.write(O.write(z.buffer)):(w.push(z),L+=z.byteLength,L>=v&&(a.pause(),await M(),setTimeout(()=>a.resume())))},onError:z=>h.error(z),onEnd:async()=>{O||await M(),h.end(O?.end())}},N.token)})}e.$gD=D;async function y(a,l,v){const u=(await(0,f.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(i(l),v);let h=!1,w=!1;return{read(){if(w)return null;const L=a.read();if(typeof L!="string"){if(w=!0,!h&&v?.addBOM)switch(l){case e.$0C:case e.$$C:return T.$Hc.wrap(Uint8Array.from(e.$eD));case e.$_C:return T.$Hc.wrap(Uint8Array.from(e.$cD));case e.$aD:return T.$Hc.wrap(Uint8Array.from(e.$dD))}const O=u.end();return O&&O.length>0?(h=!0,T.$Hc.wrap(O)):null}return h=!0,T.$Hc.wrap(u.write(L))}}}e.$hD=y;async function r(a){return(await(0,f.$9C)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(i(a))}e.$iD=r;function i(a){return a===e.$$C||a===null?e.$0C:a}e.$jD=i;function s(a,l){if(!a||l<e.$cD.length)return null;const v=a.readUInt8(0),E=a.readUInt8(1);if(v===e.$cD[0]&&E===e.$cD[1])return e.$_C;if(v===e.$dD[0]&&E===e.$dD[1])return e.$aD;if(l<e.$eD.length)return null;const u=a.readUInt8(2);return v===e.$eD[0]&&E===e.$eD[1]&&u===e.$eD[2]?e.$$C:null}e.$kD=s;const d=["ascii","utf-16","utf-32"];async function b(a){const l=await(0,f.$9C)("jschardet","dist/jschardet.min.js"),v=a.slice(0,P),E=o(v.buffer),u=l.detect(E);if(!u||!u.encoding)return null;const h=u.encoding.toLowerCase();return 0<=d.indexOf(h)?null:t(u.encoding)}const g={ibm866:"cp866",big5:"cp950"};function t(a){const l=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[l]||l}function o(a){let l="";for(let v=0;v<a.length;v++)l+=String.fromCharCode(a[v]);return l}function c(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=a.match(/windows(\d+)/);return l?"windows-"+l[1]:a}}}e.$lD=c;function n({buffer:a,bytesRead:l},v){let E=s(a,l),u=!1;if(E!==e.$_C&&E!==e.$aD&&a){let h=!0,w=!0,L=!1;for(let O=0;O<l&&O<m;O++){const N=O%2===1,M=a.readUInt8(O)===0;if(M&&(L=!0),h&&(N&&!M||!N&&M)&&(h=!1),w&&(N&&M||!N&&!M)&&(w=!1),M&&!h&&!w)break}L&&(h?E=e.$aD:w?E=e.$_C:u=!0)}return v&&!u&&!E&&a?b(a.slice(0,l)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:u,encoding:E}}e.$mD=n,e.$nD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,360,29,153]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class R extends f.$9bc{constructor(m,S,$=T,P="searchProcess"){super(m,S,{readdir:I=>$.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$lD)(I)},P)}}e.$gdc=R}),define(De[155],Ce([1,0,48,376,359,19,73,35,16,15,2,36,93,377,357,116]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=e.$cdc=e.$bdc=e.$adc=e.$_cc=void 0;const r=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class i{constructor(w){this.a=w}provideTextSearchResults(w,L,O,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...L,folder:L.folder.toString()})}`),new Promise((M,z)=>{N.onCancellationRequested(()=>V());const j=o(w,L),F=L.folder.fsPath,K=j.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${r} ${K}
 - cwd: ${F}`);let H=C.spawn(r,j,{cwd:F});H.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),z((0,I.$qI)(new I.$oI(X&&X.message,I.SearchErrorCode.rgProcessError)))});let $e=!1;const _=new b(L.maxResults,F,L.previewOptions);_.on("result",X=>{$e=!0,me="",O.report(X)});let Q=!1;const V=()=>{Q=!0,H?.kill(),_?.cancel()};let ee=!1;_.on("hitLimit",()=>{ee=!0,V()});let me="";H.stdout.on("data",X=>{_.handleData(X),$e||(me+=X)});let ae=!1;H.stdout.once("data",()=>ae=!0);let te="";H.stderr.on("data",X=>{const U=X.toString();this.a.appendLine(U),te.length+U.length<1e6&&(te+=U)}),H.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine($e?"Got result from parser":"No result from parser"),me&&this.a.appendLine(`Got data without result: ${me}`),this.a.appendLine(""),Q)M({limitHit:ee});else{_.flush(),H=null;let X;te&&!ae&&(X=s(te))?z((0,I.$qI)(new I.$oI(X.message,X.code))):M({limitHit:ee})}})})}}e.$_cc=i;function s(h){const w=h.split(`
`),L=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new I.$oI(d(w),I.SearchErrorCode.regexParseError);const O=L.match(/grep config error: unknown encoding: (.*)/);if(O)return new I.$oI(`Unknown encoding: ${O[1]}`,I.SearchErrorCode.unknownEncoding);if(L.startsWith("error parsing glob"))return new I.$oI(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.globParseError);if(L.startsWith("the literal"))return new I.$oI(L.charAt(0).toUpperCase()+L.substr(1),I.SearchErrorCode.invalidLiteral);if(L.startsWith("PCRE2: error compiling pattern"))return new I.$oI(L,I.SearchErrorCode.regexParseError)}function d(h){const w=["Regex parse error"],L=h.filter(O=>O.startsWith("PCRE2:"));if(L.length>=1){const O=L[0].replace("PCRE2:","");if(O.indexOf(":")!==-1&&O.split(":").length>=2){const N=O.split(":")[1];w.push(":"+N)}}return w.join("")}class b extends T.EventEmitter{constructor(w,L,O){super(),this.g=w,this.h=L,this.j=O,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,L){return super.on(w,L),this}handleData(w){if(this.b)return;const L=typeof w=="string"?w:this.d.write(w);this.k(L)}k(w){let L=w.indexOf(`
`);const O=this.a+w;if(L>=0)L+=this.a.length;else{this.a=O;return}let N=0;for(;L>=0;)this.m(O.substring(N,L).trim()),N=L+1,L=O.indexOf(`
`,N);this.a=O.substring(N)}m(w){if(this.b||!w)return;let L;try{L=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(L.type==="match"){const O=g(L.data.path),N=P.URI.file(S.$$c(this.h,O)),M=this.n(L.data,N);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(L.type==="context"){const O=g(L.data.path),N=P.URI.file(S.$$c(this.h,O));this.o(L.data,N).forEach(z=>this.p(z))}}n(w,L){const O=w.line_number-1,N=g(w.lines),M=Buffer.from(N);let z=0,j=0,F=O;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const K=(0,R.$Af)(w.submatches.map((H,$e)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const _=g(H.match),Q=M.slice(z,H.start).toString(),V=t(Q),ee=V.numLines>0?V.lastLineLength:V.lastLineLength+j,me=t(_),ae=V.numLines+F,te=me.numLines+ae,X=me.numLines>0?me.lastLineLength:me.lastLineLength+ee;return z=H.end,j=X,F=te,new p.$$H(ae,ee,te,X)}));return(0,y.$5cc)(L,N,K,this.j)}o(w,L){const O=g(w.lines),N=w.line_number;return O.replace(/\r?\n$/,"").split(`
`).map((M,z)=>({text:M,uri:L,lineNumber:N+z}))}p(w){this.emit("result",w)}}e.$adc=b;function g(h){return h.bytes?Buffer.from(h.bytes,"base64").toString():h.text}function t(h){const w=/\n/g;let L=0,O=-1,N;for(;N=w.exec(h);)L++,O=N.index;const M=O>=0?h.length-O-1:h.length;return{numLines:L,lastLineLength:M}}function o(h,w){const L=["--hidden","--no-require-git"];L.push(h.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:O,otherIncludes:N}=(0,A.$I)(w.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const z=new Set;N.forEach(j=>{z.add(j)}),L.push("-g","!*"),z.forEach(j=>{c(j).map(y.$4cc).forEach(F=>{L.push("-g",F)})})}O&&O.length&&O.forEach(z=>{L.push("-g",z)}),w.excludes.map(y.$4cc).forEach(z=>L.push("-g",`!${z}`)),w.maxFileSize&&L.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||L.push("--no-ignore-parent"):L.push("--no-ignore"),w.followSymlinks&&L.push("--follow"),w.encoding&&w.encoding!=="utf8"&&L.push("--encoding",w.encoding),h.pattern==="--"&&(h.isRegExp=!0,h.pattern="\\-\\-"),h.isMultiline&&!h.isRegExp&&(h.pattern=(0,$.$sd)(h.pattern),h.isRegExp=!0),w.usePCRE2&&L.push("--pcre2"),L.push("--crlf"),h.isRegExp&&(h.pattern=n(h.pattern),L.push("--engine","auto"));let M;if(h.isWordMatch){const j=(0,$.$Ad)(h.pattern,!!h.isRegExp,{wholeWord:h.isWordMatch}).source.replace(/\\\//g,"/");L.push("--regexp",j)}else if(h.isRegExp){let z=l(h.pattern);z=v(z),L.push("--regexp",z)}else M=h.pattern,L.push("--fixed-strings");return L.push("--no-config"),w.useGlobalIgnoreFiles||L.push("--no-ignore-global"),L.push("--json"),h.isMultiline&&L.push("--multiline"),w.beforeContext&&L.push("--before-context",w.beforeContext+""),w.afterContext&&L.push("--after-context",w.afterContext+""),L.push("--"),M&&L.push(M),L.push("."),L}e.$bdc=o;function c(h){return u(h).flatMap(L=>{const O=(0,m.$nj)(L,"/");return O.map((N,M)=>O.slice(0,M+1).join("/"))})}function n(h){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;h.match(w);)h=h.replace(w,"$1\\x{$2}");const L=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;h.match(L);)h=h.replace(L,"$1\\x{$2}");return h}e.$cdc=n;const a=h=>h.type==="Assertion"&&h.kind==="lookbehind";function l(h){let w;try{w=new k.RegExpParser().parsePattern(h)}catch{return h}let L="",O=0;const N=(j,F,K)=>{L+=h.slice(O,j)+K,O=F},M=[];return new k.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const F=M[0];if(!F)N(j.start,j.end,"\\r?\\n");else if(!M.some(a))if(F.type==="CharacterClass")if(F.negate){const K=h.slice(F.start+2,j.start)+h.slice(j.end,F.end-1);F.parent?.type==="Quantifier"?N(F.start,F.end,K?`[^${K}]`:"."):N(F.start,F.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=h.slice(F.start+1,j.start)+h.slice(j.end,F.end-1);N(F.start,F.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else F.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){a(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(w),L+=h.slice(O),L}e.$ddc=l;function v(h){return h.replace(/\n/g,"\\r?\\n")}e.$edc=v;function E(h){let w=!1,L=!1,O="",N="";for(let M=0;M<h.length;M++){const z=h[M];switch(z){case"\\":L?(w?N+="\\"+z:O+="\\"+z,L=!1):L=!0;break;case"{":if(L)w?N+=z:O+=z,L=!1;else{if(w)return{strInBraces:O+"{"+N+"{"+h.substring(M+1)};w=!0}break;case"}":if(L)w?N+=z:O+=z,L=!1;else{if(w)return{fixedStart:O,strInBraces:N,fixedEnd:h.substring(M+1)};O+=z}break;default:w?N+=(L?"\\":"")+z:O+=(L?"\\":"")+z,L=!1;break}}return{strInBraces:O+(w?"{"+N:"")}}function u(h){const{fixedStart:w,strInBraces:L,fixedEnd:O}=E(h);if(w===void 0||O===void 0)return[L];let N=(0,m.$nj)(L,",");N.length||(N=[""]);const M=u(O);return N.flatMap(z=>{const j=w+z;return M.map(F=>j+F)})}e.$fdc=u}),define(De[361],Ce([1,0,21,155,84,17]),function(be,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class A{constructor($){this.b=$,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults($,P,I,p){const k=new T.$_cc(this.b);if(P.folder.scheme===R.Schemas.vscodeUserData){const D={...P,folder:P.folder.with({scheme:R.Schemas.file})},y=new f.$1u(r=>I.report({...r,uri:r.uri.with({scheme:P.folder.scheme})}));return this.c(p,r=>k.provideTextSearchResults($,D,y,r))}else return this.c(p,D=>k.provideTextSearchResults($,P,I,D))}async c($,P){const I=m($);this.a.add(I);const p=await P(I.token);return this.a.delete(I),p}d(){this.a.forEach($=>$.cancel())}}e.$jdc=A;function m(S){const $=new C.$rc;return S.onCancellationRequested(()=>$.cancel()),$}}),define(De[362],Ce([1,0,29,155,154]),function(be,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class R{constructor(S){this.a=S}search(S,$,P){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(k){P({message:k})}},p=new f.$gdc(this.a,new T.$_cc(I),C);return new Promise((k,D)=>p.search(y=>{$(y.map(A))},S).then(y=>k({limitHit:y.limitHit,type:"success",stats:y.stats}),D))}}e.$hdc=R;function A(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((S,$)=>{if($.ranges){const P=$;return S+(Array.isArray(P.ranges)?P.ranges.length:1)}else return S+1},0)}}}),define(De[363],Ce([1,0,19,11,8,4,127,16,37,2,30,36,358,362]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class D{static{this.a=512}constructor(b="searchProcess"){this.d=b,this.b=Object.create(null)}fileSearch(b){let g;const t=i(b),o=new R.$hc({onDidAddFirstListener:()=>{g=(0,T.$sg)(c=>this.doFileSearchWithEngine(p.$$cc,t,n=>o.fire(n),c)),g.then(c=>o.fire(c),c=>o.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}textSearch(b){let g;const t=i(b),o=new R.$hc({onDidAddFirstListener:()=>{g=(0,T.$sg)(c=>this.f(t,n=>o.fire(n),c)),g.then(c=>o.fire(c),c=>o.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return o.event}f(b,g,t){return b.maxFileSize=this.g().maxFileSize,new k.$hdc(b).search(t,g,g)}g(){return{maxFileSize:process.arch==="ia32"?300*P.$yk.MB:16*P.$yk.GB}}doFileSearch(b,g,t){return this.doFileSearchWithEngine(p.$$cc,b,g,t)}doFileSearchWithEngine(b,g,t,o,c=D.a){let n=0;const a=v=>{Array.isArray(v)?(n+=v.length,t(v.map(E=>this.h(E)))):v.relativePath?(n++,t(this.h(v))):t(v)};if(g.sortByScore){let v=this.l(g,a,o);if(!v){const E=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new b(E);v=this.j(u,g,t,a,o)}return new Promise((E,u)=>{v.then(([h,w])=>{const L=w.map(O=>this.h(O));this.o(L,t,c),E(h)},u)})}const l=new b(g);return this.r(l,a,c,o).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h(b){return{path:b.base?(0,m.$$c)(b.base,b.relativePath):b.relativePath}}j(b,g,t,o,c){const n=new R.$hc;let a=(0,T.$sg)(v=>{let E=[];const u=h=>{Array.isArray(h)?E=h:(o(h),n.fire(h))};return this.r(b,u,-1,v).then(h=>[h,E])}),l;if(g.cacheKey){l=this.k(g.cacheKey);const v={promise:a,event:n.event,resolved:!1};l.resultsToSearchCache[g.filePattern||""]=v,a.then(()=>{v.resolved=!0},E=>{delete l.resultsToSearchCache[g.filePattern||""]}),a=this.s(a)}return a.then(([v,E])=>{const u=l?l.scorerCache:Object.create(null),h=(typeof g.maxResults!="number"||g.maxResults>0)&&S.$dc.create(!1);return this.n(g,E,u,c).then(w=>{const L=h?h.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:w.length},messages:v.messages,limitHit:v.limitHit||typeof g.maxResults=="number"&&E.length>g.maxResults},w]})})}k(b){const g=this.b[b];return g||(this.b[b]=new y)}l(b,g,t){const o=b.cacheKey&&this.b[b.cacheKey];if(!o)return;const c=this.q(o,b.filePattern||"",g,t);if(c)return c.then(([n,a,l])=>{const v=S.$dc.create(!1);return this.n(b,a,o.scorerCache,t).then(E=>{const u=v.elapsed(),h={fromCache:!0,detailStats:l,type:this.d,resultCount:a.length,sortingTime:u};return[{type:"success",limitHit:n.limitHit||typeof b.maxResults=="number"&&a.length>b.maxResults,stats:h},E]})})}n(b,g,t,o){const c=(0,A.$lq)(b.filePattern||""),n=(l,v)=>(0,A.$kq)(l,v,c,!0,r,t),a=typeof b.maxResults=="number"?b.maxResults:Number.MAX_VALUE;return C.$zf(g,n,a,1e4,o)}o(b,g,t){if(t&&t>0)for(let o=0;o<b.length;o+=t)g(b.slice(o,o+t));else g(b)}q(b,g,t,o){const c=S.$dc.create(!1),n=g.indexOf(m.sep)>=0;let a;for(const u in b.resultsToSearchCache)if(g.startsWith(u)){if(n&&u.indexOf(m.sep)<0&&u!=="")continue;const h=b.resultsToSearchCache[u];a={promise:this.s(h.promise),event:h.event,resolved:h.resolved};break}if(!a)return null;const l=c.elapsed(),v=S.$dc.create(!1),E=a.event(t);return o&&o.onCancellationRequested(()=>{E.dispose()}),a.promise.then(([u,h])=>{if(o&&o.isCancellationRequested)throw(0,f.$4)();const w=[],L=(0,A.$lq)(g).normalizedLowercase;for(const O of h)(0,I.$uI)(O,L)&&w.push(O);return[u,w,{cacheWasResolved:a.resolved,cacheLookupTime:l,cacheFilterTime:v.elapsed(),cacheEntryCount:h.length}]})}r(b,g,t,o){return new Promise((c,n)=>{let a=[];o?.onCancellationRequested(()=>b.cancel()),b.search(l=>{l&&(t?(a.push(l),t>0&&a.length>=t&&(g(a),a=[])):g(l))},l=>{g(l)},(l,v)=>{a.length&&g(a),l?n(l):c(v)})})}clearCache(b){return delete this.b[b],Promise.resolve(void 0)}s(b){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,t){return b.then(g,t)}catch(g){return this.then(void 0,g)}finally(g){return b.finally(g)}}}}e.$idc=D;class y{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(d){return(0,m.$cd)(d.relativePath)}getItemDescription(d){return(0,m.$bd)(d.relativePath)}getItemPath(d){return d.relativePath}};function i(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(s),extraFileResources:d.extraFileResources&&d.extraFileResources.map(b=>$.URI.revive(b))}}function s(d){return{...d,folder:$.URI.revive(d.folder)}}}),define(De[364],Ce([1,0,3,17,2,29,14,26,20,96,66,36,363,361,116,154]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let r=class extends $.$bcc{constructor(s,d,b,g){super(s,b,g),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new C.$lb;const t=new D.$6cc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new k.$jdc(t))),d.remote.isRemote&&d.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const s=new D.$6cc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new k.$jdc(s))),this.x.add(this.z(T.Schemas.file,new p.$idc("fileSearchProvider")))}z(s,d){const b=this.d++;return this.v=d,this.t=b,this.c.$registerFileSearchProvider(b,this.o(s)),(0,C.$kb)(()=>{this.v=null,this.c.$unregisterProvider(b)})}$provideFileSearchResults(s,d,b,g){const t=(0,$.$ccc)(b);return s===this.t?this.A(s,d,t,g):super.$provideFileSearchResults(s,d,b,g)}A(s,d,b,g){const t=o=>{if((0,I.$tI)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(s,d,o.map(c=>f.URI.file(c.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(b,t,g)}$clearCache(s){return this.v?.clearCache(s),super.$clearCache(s)}q(s,d){return new y.$gdc(s,d,void 0,"textSearchProvider")}};e.$kdc=r,e.$kdc=r=Ke([Be(0,S.$UL),Be(1,m.$$L),Be(2,P.$Tac),Be(3,A.$3i)],r)}),define(De[117],Ce([1,0,378,60,63,379,22,8,4,3,16,12,31,80,81]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;class y{traceSocketEvent(h,w){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,h,w)}constructor(h,w=""){this.f=!0,this.debugLabel=w,this.socket=h,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,m.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(h){const w=L=>{this.traceSocketEvent("read",L),h(A.$Hc.wrap(L))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(h){const w=L=>{h({type:0,hadError:L,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(h){const w=()=>{h()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(h){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",h),this.socket.write(h.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((h,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),h();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),h()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$oh=y;var r;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var i;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(i||(i={}));class s extends $.$mb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(h,w){this.socket.traceSocketEvent(h,w)}constructor(h,w,L,O){super(),this.f=this.B(new S.$hc),this.g=this.B(new S.$hc),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new d(this,w,L,O,this.f,(N,M)=>this.k(N,M))),this.B(this.a.onError(N=>{console.error(N),(0,m.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new D.$jh,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this.f.event(h)}onClose(h){return this.g.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){let w=0;for(;w<h.byteLength;)this.a.writeMessage(h.slice(w,Math.min(w+262144,h.byteLength))),w+=262144}k(h,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",h);let L=2;h.byteLength<126?L+=0:h.byteLength<2**16?L+=2:L+=8;const O=A.$Hc.alloc(L);if(w?O.writeUInt8(194,0):O.writeUInt8(130,0),h.byteLength<126)O.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(h.byteLength>>>8&255,++N),O.writeUInt8(h.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(h.byteLength>>>24&255,++N),O.writeUInt8(h.byteLength>>>16&255,++N),O.writeUInt8(h.byteLength>>>8&255,++N),O.writeUInt8(h.byteLength>>>0&255,++N)}this.socket.write(A.$Hc.concat([O,h]))}end(){this.h=!0,this.socket.end()}l(h){if(h.byteLength!==0){for(this.b.acceptChunk(h);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),L=w.readUInt8(0),O=(L&128)>>>7,N=(L&64)>>>6,M=w.readUInt8(1),z=(M&128)>>>7,j=M&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),L=w.readUInt8(1),O=(L&128)>>>7;let N=L&127,M=1;N===126?N=w.readUInt8(++M)*2**8+w.readUInt8(++M):N===127&&(N=w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*0+w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M));let z=0;O&&(z=w.readUInt8(++M)*2**24+w.readUInt8(++M)*2**16+w.readUInt8(++M)*2**8+w.readUInt8(++M)),this.j.state=3,this.j.readLen=N,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$ph=s;class d extends $.$mb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Hc.alloc(0)}constructor(h,w,L,O,N,M){super(),this.l=h,this.m=N,this.n=M,this.a=this.B(new S.$hc),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$hc),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new S.$hc),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,w?(this.b=this.B(new b(this.l,O,L,{windowBits:15})),this.f=this.B(new g(this.l,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(h){this.g.push(h),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const h=this.g.shift();if(this.f){const w=await this.s(this.f,h);this.n(w,!0)}else this.n(h,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(h,w){return new Promise((L,O)=>{h.write(w),h.flush(N=>L(N))})}acceptFrame(h,w,L){this.h.push({data:h,isCompressed:w,isLastFrameOfMessage:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const h=this.h.shift();if(this.b&&h.isCompressed){const w=await this.w(this.b,h.data,h.isLastFrameOfMessage);this.m.fire(w)}else this.m.fire(h.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(h,w,L){return new Promise((O,N)=>{h.write(w),L&&h.write(A.$Hc.fromByteArray([0,0,255,255])),h.flush(M=>O(M))})}}class b extends $.$mb{get recordedInflateBytes(){return this.j?A.$Hc.concat(this.f):A.$Hc.alloc(0)}constructor(h,w,L,O){super(),this.h=h,this.j=w,this.a=this.B(new S.$hc),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(O),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(A.$Hc.wrap(N))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(h){this.j&&this.f.push(h.clone()),this.h.traceSocketEvent("zlibInflateWrite",h),this.b.write(h.buffer)}flush(h){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=A.$Hc.concat(this.g);this.g.length=0,h(w)})}}class g extends $.$mb{constructor(h,w){super(),this.g=h,this.a=this.B(new S.$hc),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(A.$Hc.wrap(L))})}write(h){this.g.traceSocketEvent("zlibDeflateWrite",h.buffer),this.b.write(h.buffer)}flush(h){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=A.$Hc.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),h(w)})}}function t(u,h){if(h===0)return;const w=u.byteLength>>>2;for(let j=0;j<w;j++){const F=u.readUInt32BE(j*4);u.writeUInt32BE(F^h,j*4)}const L=w*4,O=u.byteLength-L,N=h>>>24&255,M=h>>>16&255,z=h>>>8&255;O>=1&&u.writeUInt8(u.readUInt8(L)^N,L),O>=2&&u.writeUInt8(u.readUInt8(L+1)^M,L+1),O>=3&&u.writeUInt8(u.readUInt8(L+2)^z,L+2)}e.$qh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const u=(0,p.$6e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;const h=process.platform!=="darwin"&&e.$qh?e.$qh:(0,f.tmpdir)(),w=(0,P.$$c)(h,`vscode-ipc-${u}.sock`);return a(w),w}e.$rh=c;function n(u,h,w){const L=(0,C.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${w}-${h}-sock`;const O=w.substr(0,4),N=h.substr(0,6),M=L.substr(0,8);let z;return process.platform!=="darwin"&&e.$qh&&!process.env.VSCODE_PORTABLE?z=(0,P.$$c)(e.$qh,`vscode-${M}-${O}-${N}.sock`):z=(0,P.$$c)(u,`${O}-${N}.sock`),a(z),z}e.$sh=n;function a(u){const h=o[I.$t];typeof h=="number"&&u.length>=h&&console.warn(`WARNING: IPC handle "${u}" is longer than ${h} chars, try a shorter --user-data-dir`)}class l extends k.$dh{static b(h){const w=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(w,L=>({protocol:new D.$kh(new y(L,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(L,"close"))}))}constructor(h){super(l.b(h)),this.d=h}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$th=l;function v(u){return new Promise((h,w)=>{const L=(0,T.createServer)();L.on("error",w),L.listen(u,()=>{L.removeListener("error",w),h(new l(L))})})}e.$uh=v;function E(u,h){return new Promise((w,L)=>{const O=(0,T.createConnection)(u,()=>{O.removeListener("error",L),w(D.$lh.fromSocket(new y(O,`ipc-client${h}`),h))});O.once("error",L)})}e.$vh=E}),define(De[365],Ce([1,0,60,63,163,117,11,3,12,49,14,135,247,248,107,86,22]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=e.$U6b=e.$T6b=e.$S6b=void 0;async function i(t,o,c,n,a){let l;for(let v=3;v&&(l?.dispose(),l=await new s(t,o,c,n,a).waitForReady(),!(a&&f.$9e[a]||!f.$9e[l.tunnelLocalPort]));v--);return l}class s extends m.$mb{constructor(o,c,n,a,l){super(),this.j=c,this.k=l,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=o,this.b=C.createServer(),this.c=new A.$Dg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.l(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(c=>{c()})}async waitForReady(){const o=this.k??this.tunnelRemotePort,c=(0,y.$Zz)(this.j)?"0.0.0.0":"127.0.0.1";let n=await(0,f.$0e)(o,2,1e3,c),a=null;return this.b.listen(n,this.j),await this.c.wait(),a=this.b.address(),a||(n=0,this.b.listen(n,this.j),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async l(o){o.pause();const c=(0,y.$Xz)(this.tunnelRemoteHost)||(0,y.$Zz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,p.$Xk)(this.a,c,this.tunnelRemotePort),a=n.getSocket(),l=n.readEntireBuffer();n.dispose(),l.byteLength>0&&o.write(l.buffer),o.on("end",()=>{o.localAddress&&this.i.delete(o.localAddress),a.end()}),o.on("close",()=>a.end()),o.on("error",()=>{o.localAddress&&this.i.delete(o.localAddress),a instanceof R.$oh?a.socket.destroy():a.end()}),a instanceof R.$oh?this.n(o,a):this.m(o,a),o.localAddress&&this.i.set(o.localAddress,()=>{o.end(),a.end()})}m(o,c){c.onClose(()=>o.destroy()),c.onEnd(()=>o.end()),c.onData(n=>o.write(n.buffer)),o.on("data",n=>c.write(r.$Hc.wrap(n))),o.resume()}n(o,c){const n=c.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$S6b=s;let d=class extends y.$3z{constructor(o,c,n,a,l){super(c,l),this.u=o,this.v=n,this.w=a}isPortPrivileged(o){return(0,y.$1z)(o,this.l,S.OS,T.release())}s(o,c,n,a,l,v,E,u){const h=this.r(c,n);if(h)return++h.refcount,h.value;if((0,y.$Uz)(o))return this.t(o,c,n,l,v,E,u);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${n} on local port ${l}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=i(w,a,c,n,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(c,n,L),L}}};e.$T6b=d,e.$T6b=d=Ke([Be(0,k.$Rk),Be(1,P.$3i),Be(2,D.$Uk),Be(3,I.$ij),Be(4,$.$6h)],d);let b=class extends d{constructor(o,c,n,a,l){super(o,c,n,a,l)}};e.$U6b=b,e.$U6b=b=Ke([Be(0,k.$Rk),Be(1,P.$3i),Be(2,D.$Uk),Be(3,I.$ij),Be(4,$.$6h)],b);let g=class extends m.$mb{constructor(o,c,n,a,l){super(),this.b=o,this.c=c,this.f=n,this.g=a,this.h=l,this.a=new Map}async openTunnel(o,c,n,a,l,v,E,u,h){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${a} on local port ${v}.`),!this.a.has(o)){const w=new b(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(o,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(c,n,a,l,v,E,u,h)}};e.$V6b=g,e.$V6b=g=Ke([Be(0,k.$Rk),Be(1,P.$3i),Be(2,I.$ij),Be(3,D.$Uk),Be(4,$.$6h)],g)}),define(De[366],Ce([1,0,117,267,52,33,2,14,43]),function(be,e,C,T,f,R,A,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=void 0;class ${constructor(p,k,D){this.b=p,this.c=k,this.f=D,this.a=T.createServer((y,r)=>this.h(y,r)),this.g().catch(y=>(k.error(y),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,k){const D=(r,i)=>{k.writeHead(r,{"content-type":"application/json"}),k.end(JSON.stringify(i||null),s=>s&&this.c.error(s))},y=[];p.setEncoding("utf8"),p.on("data",r=>y.push(r)),p.on("end",async()=>{try{const r=JSON.parse(y.join(""));let i;switch(r.type){case"open":i=await this.i(r);break;case"openExternal":i=await this.j(r);break;case"status":i=await this.l(r);break;case"extensionManagement":i=await this.k(r);break;default:D(404,`Unknown message type: ${r.type}`);break}D(200,i)}catch(r){const i=r instanceof Error?r.message:JSON.stringify(r);D(500,i),this.c.error("Error while processing pipe request",r)}})}async i(p){const{fileURIs:k,folderURIs:D,forceNewWindow:y,diffMode:r,mergeMode:i,addMode:s,forceReuseWindow:d,gotoLineMode:b,waitMarkerFilePath:g,remoteAuthority:t}=p,o=[];if(Array.isArray(D))for(const l of D)try{o.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(k))for(const l of k)try{(0,S.$5h)(l)?o.push({workspaceUri:A.URI.parse(l)}):o.push({fileUri:A.URI.parse(l)})}catch{}const c=g?A.URI.file(g):void 0,a={forceNewWindow:y,diffMode:r,mergeMode:i,addMode:s,gotoLineMode:b,forceReuseWindow:d,preferNewWindow:!d&&!c&&!s,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,a)}async j(p){for(const k of p.uris){const D=A.URI.parse(k),y=D.scheme==="file"?D:k;await this.b.executeCommand("_remoteCLI.openExternal",y)}}async k(p){const k=y=>y?.map(r=>/\.vsix$/i.test(r)?A.URI.parse(r):r),D={list:p.list,install:k(p.install),uninstall:k(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$jM=$;let P=class extends ${constructor(p,k){super(p,k,(0,C.$rh)())}};e.$kM=P,e.$kM=P=Ke([Be(0,R.$eM),Be(1,m.$3i)],P)}),define(De[367],Ce([1,0,53,354,349,266,45,337,2,17,7,366,101,335,336]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class y extends f.$Qcc{j(){const s=this,d=globalThis._VSCODE_NODE_MODULES.module,b=d._load;d._load=function(c,n,a){return c=t(c),s.a.has(c)?s.a.get(c).load(c,S.URI.file((0,p.$Up)(n.filename)),l=>b.apply(this,[l,n,a])):b.apply(this,arguments)};const g=d._resolveLookupPaths;d._resolveLookupPaths=(o,c)=>g.call(this,t(o),c);const t=o=>{for(const c of s.b){const n=c(o);if(n){o=n;break}}return o}}}class r extends A.$rbc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async pb(){this.h.createInstance(k.$ndc);const s=this.h.invokeFunction(T.$Mcc);if(this.h.createInstance(m.$mdc),this.f.remote.isRemote&&this.f.remote.authority){const g=this.h.createInstance(I.$kM);process.env.VSCODE_IPC_HOOK_CLI=g.ipcHandlePath}this.h.createInstance(D.$odc),await this.h.createInstance(y,s,{mine:this.F,all:this.G}).install(),C.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.$ldc)(this.j,b,this,this.l,this.u,this.f),C.mark("code/extHost/didInitProxyResolver")}qb(s){return s.main}async rb(s,d,b){if(d.scheme!==$.Schemas.file)throw new Error(`Cannot load URI: '${d}', must be of file-scheme`);let g=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${d.toString(!0)}`),this.l.flush();const t=s?.identifier.value;s&&await this.s.initializeLocalizedMessages(s);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),g=be.__$__nodeRequire(d.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),b.codeLoadingStop()}return g}async $setRemoteEnvironment(s){if(this.f.remote.isRemote)for(const d in s){const b=s[d];b===null?delete process.env[d]:process.env[d]=b}}}e.$pdc=r}),define(De[368],Ce([1,0,48,22,4,3,120,12,24,2,29,14,246,64,107,86,365,26,20,72,345]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=e.$vdc=e.$udc=e.$tdc=e.$sdc=e.$rdc=e.$qdc=void 0;function g(h){const w=h.trim().split(`
`),L=[];return w.forEach(N=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(N);M&&M.length>=3&&L.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),L.reduce((N,M)=>(N[M.socket]=M,N),{})}e.$qdc=g;function t(...h){const w=[].concat(...h.map(c));return[...new Map(w.filter(L=>L.st==="0A").map(L=>{const O=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:o(O[0]),port:parseInt(O[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$rdc=t;function o(h){let w="";if(h.length===8)for(let L=h.length-2;L>=0;L-=2)w+=parseInt(h.substr(L,2),16),L!==0&&(w+=".");else for(let L=0;L<h.length;L+=8){const O=h.substring(L,L+8);let N="";for(let M=8;M>=2;M-=2)N+=O.substring(M-2,M),(M===6||M===2)&&(N=parseInt(N,16).toString(16),w+=`${N}`,N="",L+M!==h.length-6&&(w+=":"))}return w}e.$sdc=o;function c(h){const w=h.trim().split(`
`),L=w.shift().trim().split(/\s+/).filter(N=>N!=="rx_queue"&&N!=="tm->when");return w.map(N=>N.trim().split(/\s+/).reduce((M,z,j)=>(M[L[j]||j]=z,M),{}))}e.$tdc=c;function n(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/server-main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function a(h){const w=h.trim().split(`
`),L=[];return w.forEach(O=>{const N=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);N&&N.length>=4&&L.push({pid:parseInt(N[1],10),ppid:parseInt(N[2]),cmd:N[3]})}),L}e.$udc=a;async function l(h,w,L){const O=L.reduce((M,z)=>(M[z.pid]=z,M),{}),N=[];return h.forEach(({socket:M,ip:z,port:j})=>{const F=w[M]?w[M].pid:void 0,K=F?O[F]?.cmd:void 0;F&&K&&!n(K)&&N.push({host:z,port:j,detail:K,pid:F})}),N}e.$vdc=l;function v(h,w,L){const O=new Map,N=a(w);for(const M of h){const z=L.get(M.port);if(z){O.set(M.port,z);continue}const j=N.find(F=>F.cmd.includes(`${M.port}`));if(j){let F=j,K;do K=N.find(H=>H.ppid===F.pid),K&&(F=K);while(K);O.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else O.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return O}e.$wdc=v;let E=class extends d.$dsb{constructor(w,L,O,N){super(w,L,O),this.w=L,this.y=N,this.s=void 0,this.u=new Map,this.v=!1,m.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.C())}async $registerCandidateFinder(w){if(w&&this.v)return;this.v=w;let L;this.s&&(L=this.s,await this.a.$onFoundNewCandidates(this.s));const O=new A.$Il;let N=0;for(;this.v;){const M=new Date().getTime(),z=(await this.D()).filter(K=>(0,y.$Xz)(K.host)||(0,y.$Zz)(K.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(K=>K.port).join(", ")}`);const j=new Date().getTime()-M;this.n.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),N++>3&&O.update(j),(!L||JSON.stringify(L)!==JSON.stringify(z))&&(L=z,await this.a.$onFoundNewCandidates(L));const F=this.z(O.value);this.n.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(K=>setTimeout(()=>K(),F))}}z(w){return Math.max(w*20,2e3)}async C(){this.s=await this.D(),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.s.map(w=>w.port).join(", ")}`)}async D(){let w="",L="";try{w=await P.Promises.readFile("/proc/net/tcp","utf8"),L=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(w,L),N=await new Promise(_=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,V,ee)=>{_(V)})}),M=g(N),z=await P.Promises.readdir("/proc"),j=[];for(const _ of z)try{const Q=Number(_),V=S.$gg($.URI.file("/proc"),_);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(Q)){const me=await P.Promises.readlink(S.$gg(V,"cwd").fsPath),ae=await P.Promises.readFile(S.$gg(V,"cmdline").fsPath,"utf8");j.push({pid:Q,cwd:me,cmd:ae})}}catch{}const F=[],K=O.filter(_=>{const Q=M[_.socket];return Q||F.push(_),Q}),H=l(K,M,j);let $e;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const _=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(V,ee,me)=>{Q(ee)})});this.u=v(F,_,this.u),$e=Array.from(this.u.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$e.map(Q=>Q.port).join(", ")}`)}return H.then(_=>$e?_.concat($e):_)}r(w){return async L=>{const O=new r.$S6b({commit:this.w.commit,quality:this.w.quality,logService:this.n,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,z,j,F){const K=await w.makeConnection();return u.connect(K,z,j,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new k.$Ik(0),connectionToken:w.connectionToken})}},signService:this.y},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await O.waitForReady();const N=new f.$hc;return{localAddress:(0,b.$aJ)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:N.event,dispose:()=>{O.dispose(),N.fire(),N.dispose()}}}}};e.$xdc=E,e.$xdc=E=Ke([Be(0,s.$UL),Be(1,i.$$L),Be(2,I.$3i),Be(3,D.$Uk)],E);class u extends p.$mkb{static connect(w,L,O,N){const M=new R.$lb,z={onClose:M.add(new f.$hc),onData:M.add(new f.$hc),onEnd:M.add(new f.$hc)};M.add(w.onDidReceiveMessage(F=>z.onData.fire(T.$Hc.wrap(F)))),M.add(w.onDidEnd(()=>z.onEnd.fire())),M.add(w.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const j=new u(w,N,z);return j.B(M),(0,p.$lkb)(j,L,O,N,z)}constructor(w,L,O){super(L,O),this.k=w}write(w){this.k.send(w.buffer)}h(){this.k.end()}async drain(){await this.k.drain?.()}}}),define(De[369],Ce([1,0,104,340,352,351,364,367,368,95,45,96,94,44,72,91,339,338,14,353,55,261,103,107,138]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i,s,d,b,g,t,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$jr)(P.$sbc,m.$pdc,0),(0,C.$jr)(s.$4i,i.$zdc,1),(0,C.$jr)(s.$3i,new t.$wh(g.$Pcc,[!1],!0)),(0,C.$jr)(o.$Uk,c.$X6b,1),(0,C.$jr)(y.$dbc,r.$ydc,0),(0,C.$jr)($.$3bc,R.$3cc,0),(0,C.$jr)(I.$acc,A.$kdc,0),(0,C.$jr)(p.$Xbc,f.$Ucc,0),(0,C.$jr)(k.$fbc,T.$Tcc,0),(0,C.$jr)(D.$csb,S.$xdc,0),(0,C.$jr)(b.$1bc,d.$Adc,0)}),define(De[380],Ce([1,0,60,381,53,8,81,117,244,111,350,22,29,101,11,130,268,285,355,369]),function(be,e,C,T,f,R,A,m,S,$,P,I,p,k,D,y,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const s=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const a=globalThis._VSCODE_NODE_MODULES.module,l=a._load;a._load=function(v){if(v==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const d=process.exit.bind(process);function b(a){process.exit=function(l){if(a)d(l);else{const v=new Error("An extension called process.exit() and this was prevented.");console.warn(v.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(a){d()};function t(){const a=(0,i.$pm)(process.env);if(a.type===3)return new Promise((l,v)=>{const E=u=>{const h=u[0],w=new A.$mh;h.on("message",L=>w.fire(I.$Hc.wrap(L.data))),h.on("close",()=>{g("renderer closed the MessagePort")}),h.start(),l({onMessage:w.event,send:L=>h.postMessage(L.buffer)})};process.parentPort.on("message",u=>E(u.ports))});if(a.type===2)return new Promise((l,v)=>{let E=null;const u=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),h=108e5,w=3e5,L=new D.$Rg(()=>g("renderer disconnected for too long (1)"),h),O=new D.$Rg(()=>g("renderer disconnected for too long (2)"),w);process.on("message",(M,z)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const j=I.$Hc.wrap(Buffer.from(M.initialDataChunk,"base64"));let F;if(M.skipWebSocketFrames)F=new m.$oh(z,"extHost-socket");else{const K=I.$Hc.wrap(Buffer.from(M.inflateBytes,"base64"));F=new m.$ph(new m.$oh(z,"extHost-socket"),M.permessageDeflate,K,!1)}E?(L.cancel(),O.cancel(),E.beginAcceptReconnection(F,j),E.endAcceptReconnection(),E.sendResume()):(clearTimeout(u),E=new A.$nh({socket:F,initialChunk:j}),E.sendResume(),E.onDidDispose(()=>g("renderer disconnected")),l(E),E.onSocketClose(()=>{L.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;L.isScheduled()&&O.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const l=a.pipeName;return new Promise((v,E)=>{const u=C.createConnection(l,()=>{u.removeListener("error",E);const h=new A.$nh({socket:new m.$oh(u,"extHost-renderer")});h.sendResume(),v(h)});u.once("error",E),u.on("close",()=>{g("renderer closed the socket")})})}}async function o(){const a=await t();return new class{constructor(){this.a=new A.$mh,this.onMessage=this.a.event,this.b=!1,a.onMessage(l=>{(0,$.$3l)(l,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||a.send(l)}async drain(){if(a.drain)return a.drain()}}}function c(a){return new Promise(l=>{const v=a.onMessage(E=>{v.dispose();const u=JSON.parse(E.toString()),h=u.commit,w=S.default.commit;if(h&&w&&h!==w&&d(55),u.parentPid){let L=0;setInterval(function(){try{process.kill(u.parentPid,0),L=0}catch(N){N&&N.code==="EPERM"?(L++,L>=3&&g(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):g(`parent process ${u.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(u.parentPid)}catch(N){(0,R.$Y)(N)}}a.send((0,$.$2l)(0)),l({protocol:a,initData:u})});a.send((0,$.$2l)(1))})}async function n(){const a=[];process.on("unhandledRejection",(L,O)=>{a.push(O),setTimeout(()=>{const N=a.indexOf(O);N>=0&&O.catch(M=>{a.splice(N,1),(0,R.$2)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),L&&(0,R.$Y)(L))})},1e3)}),process.on("rejectionHandled",L=>{const O=a.indexOf(L);O>=0&&a.splice(O,1)}),process.on("uncaughtException",function(L){(0,R.$X)(L)||(0,R.$Y)(L)}),f.mark("code/extHost/willConnectToRenderer");const l=await o();f.mark("code/extHost/didConnectToRenderer");const v=await c(l);f.mark("code/extHost/didWaitForInitData");const{initData:E}=v;b(!!E.environment.extensionTestsLocationURI),E.environment.useHostProxy=s.useHostProxy!==void 0?s.useHostProxy!=="false":void 0,E.environment.skipWorkspaceStorageLock=(0,y.boolean)(s.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(O){d(O)}fsExists(O){return p.Promises.exists(O)}fsRealpath(O){return(0,k.$Tp)(O)}};let h=null;E.remote.authority&&s.transformURIs&&(h=(0,r.$nr)(E.remote.authority));const w=new P.$Scc(v.protocol,E,u,h);g=L=>w.terminate(L)}n().catch(a=>console.log(a))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/03671d332bf6a34782d5adc64086bc8e083a1590/core/vs/workbench/api/node/extensionHostProcess.js.map
